Attribute VB_Name = "ApiIO_W"
'Quellen zu Windows Metafiles:
'-----------------------------
'http://support.microsoft.com/support/kb/articles/Q165/9/42.asp
'  Q165942 - HOWTO: Write Data to a File Using WriteFile API

'http://support.microsoft.com/support/kb/articles/Q66/9/49.asp
'  Q66949 - INFO: Windows Metafiles Functions and  Aldus Placeable Metafiles

'Dan Appleman - Visual Basic Programmers Guide to the Windows/Win32 API
'  Chapter 8 - Sample Program QUICKDRAW.VBP

'Visual Basic Programmers Journal, January 2000, Vol. 10, No. 1, Page 94-97
'  Ask The VBPro: 'Displaying Old Metafiles

DefInt A-Z

Public Const MM_ANISOTROPIC& = 8

Type RECTS
  Left As Integer
  Top As Integer
  Right As Integer
  Bottom As Integer
End Type

' Not how RECT does not change within a structure
' that is saved on disk and is Win16 compatible!
Type METAFILEHEADER     ' 22 bytes
  Key As Long
  hMF As Integer
  bbox As RECTS
  inch As Integer
  reserved As Long
  checksum As Integer
End Type

Public Const GENERIC_WRITE& = &H40000000
Public Const GENERIC_READ& = &H80000000
Public Const FILE_ATTRIBUTE_NORMAL& = &H80
Public Const CREATE_ALWAYS& = 2
Public Const OPEN_EXISTING& = 3
Public Const OPEN_ALWAYS& = 4
Public Const INVALID_HANDLE_VALUE& = -1

Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long

Declare Function lopen Lib "kernel32" Alias "_lopen" (ByVal lpPathName As String, ByVal iReadWrite As Long) As Long
Declare Function lclose Lib "kernel32" Alias "_lclose" (ByVal hFile As Long) As Long
Declare Function lcreat Lib "kernel32" Alias "_lcreat" (ByVal lpPathName As String, ByVal iAttribute As Long) As Long
Declare Function llseek Lib "kernel32" Alias "_llseek" (ByVal hFile As Long, ByVal lOffset As Long, ByVal iOrigin As Long) As Long
Declare Function lRead Lib "kernel32" Alias "_lread" (ByVal hFile As Long, lpBuffer As Any, ByVal wBytes As Long) As Long
Declare Function lwrite Lib "kernel32" Alias "_lwrite" (ByVal hFile As Long, lpBuffer As Any, ByVal wBytes As Long) As Long

Declare Function hread Lib "kernel32" Alias "_hread" (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long
Declare Function hwrite Lib "kernel32" Alias "_hwrite" (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long
'Declare Function hwrite Lib "kernel32" Alias "_hwrite" (ByVal hfile As Long, ByVal lpBuffer As String, ByVal lBytes As Long) As Long

'--- Metafile functions ---
Declare Function CreateMetaFile& Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String)
Declare Function CreateMetaFileBynum& Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As Long)
Declare Function CreateMetaFileBystring& Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String)
Declare Function CloseMetaFile& Lib "gdi32" (ByVal hMF As Long)
Declare Function DeleteMetaFile& Lib "gdi32" (ByVal hMF As Long)

Declare Function CreateEnhMetaFile& Lib "gdi32" Alias "CreateEnhMetaFileA" (ByVal hdcRef As Long, ByVal lpFileName As String, lpRect As RECT, ByVal lpDescription As String)
Declare Function DeleteEnhMetaFile& Lib "gdi32" (ByVal hemf As Long)
Declare Function CloseEnhMetaFile& Lib "gdi32" (ByVal hDC As Long)
Declare Function PlayMetaFile& Lib "gdi32" (ByVal hDC As Long, ByVal hMF As Long)
Declare Function GetMetaFileBitsEx& Lib "gdi32" (ByVal hMF As Long, ByVal nSize As Long, lpvData As Any)

Function LoadOnePage(Tbl, hFile As Variant, RecNr&, n&)

  Select Case Tbl
  Case 1
    If Len(Segm(1)) <> LenB(Segm(1)) Then Stop
    'r& = hread&(hFile, Segm(RecNr&).SegId, n&)
    r& = hread&(hFile, Segm(RecNr&).TypePtr, n&)

  Case 2
    If HV.CoLoadMode = 1 Then
      If Len(Karte1(1)) <> LenB(Karte1(1)) Then Stop
      r& = hread&(hFile, Karte1(RecNr&).x, n&)
    Else
      s1 = (RecNr& - 1) Mod HV.MapDim
      s2 = (RecNr& - 1) \ HV.MapDim
      r& = hread&(hFile, Karte2(s1, s2).x, n&)
    End If

  Case 3
    Stop
    r& = hread&(hFile, StnIdxTbl(RecNr&), n&)

  Case 4
    If Len(StnTbl(1)) <> LenB(StnTbl(1)) Then Stop
    r& = hread&(hFile, StnTbl(RecNr&).StnCall.Call, n&)

  Case 5
    If Len(LnkTbl(1)) <> LenB(LnkTbl(1)) Then Stop
    r& = hread&(hFile, LnkTbl(RecNr&).StnPtr(1), n&)
  End Select

  If r& <> n& Then Call ShowErrNrFileNr(72, FileNr)

  LoadOnePage = (r& <> n&)

End Function

Function LoadTbl(Tbl, FileNr)

  Dim lRec As Long, ArraySize As Long
  Dim FirstRec As Long, LastRec As Long
  Dim RecNr As Long, RecCnt As Long
  Dim Start As Long, ActStart As Long

  Dim RecsPerPage As Long, Recs As Long
  Dim Lo As Long, Hi As Long
  Dim hFile As Long

  LoadTbl = True

  Select Case Tbl
  Case 1
    Lo = LBound(Segm)
    Hi = UBound(Segm)
    lRec = Len(Segm(Lo))
    LastRec = MV.In.AnzSg
  Case 2
    If HV.CoLoadMode = 1 Then
      Lo = LBound(Karte1)
      Hi = UBound(Karte1)
      lRec = Len(Karte1(Lo))
    Else
      Lo1 = LBound(Karte2, 1)
      Hi1 = UBound(Karte2, 1)
      Lo2 = LBound(Karte2, 2)
      Hi2 = UBound(Karte2, 2)
      lRec = Len(Karte2(Lo1, Lo2))
    End If
    LastRec = MV.In.AnzKo
  Case 3
    Lo = LBound(StnIdxTbl)
    Hi = UBound(StnIdxTbl)
    lRec = Len(StnIdxTbl(Lo))
  Case 4
    Lo = LBound(StnTbl)
    Hi = UBound(StnTbl)
    lRec = Len(StnTbl(Lo))
    LastRec = SV.Out.StnHdr.AnzStnRec
  Case 5
    Lo = LBound(LnkTbl)
    Hi = UBound(LnkTbl)
    lRec = Len(LnkTbl(Lo))
    LastRec = SV.Out.StnHdr.AnzLnkRec
  End Select

  FirstRec = 1
  RecCnt = LastRec - FirstRec + 1       'Total Record Count
  RecsPerPage = 65536 \ lRec


  '--- Get File-Handle / Open File ---
  FileSpec$ = ReturnFileSpec$(FileNr)

  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Function

  hFile = CreateFile(FileSpec$, GENERIC_READ&, 0, 0, OPEN_EXISTING&, 0, 0)

  If hFile < 0 Then
    Call ShowErrNrFileTxt(999, FileSpec$)
    Exit Function
  End If

  RecsPerPage = RecCnt

  '--- Rewind File ---
  ActStart = llseek&(hFile, 0, 0)
  If ActStart <> 0 Then
    Call ShowErrNrFileNr(72, FileNr)
    Exit Function
  End If


  '--- Read Data ---
  RecNr = FirstRec

  Do Until RecCnt <= 0
    Recs = RecsPerPage
    If Recs > RecCnt Then Recs = RecCnt

    '--- Read One Page ---
    ErrNr = LoadOnePage(Tbl, hFile, RecNr, Recs * lRec)
    If ErrNr Then Exit Do

    RecNr = RecNr + Recs
    RecCnt = RecCnt - Recs
  Loop

  CloseOk& = CloseHandle(hFile)
  If CloseOk& = 0& Then
    Call ShowErrNrFileTxt(72, FileSpec$)
    Exit Function
  End If

  If ErrNr Then Exit Function

  '--- Reopen Files ---
  Select Case Tbl
  Case 1, 4, 5    'BMD, BSD, BLD
    ErrNr = OpenFile(FileSpec$, "RI", CInt(lRec), FileNr)
  Case 2      'BMC
    ErrNr = OpenFile(FileSpec$, "BI", 0, FileNr)
  Case 3
  End Select

  LoadTbl = ErrNr


End Function

Function WriteEnhMetaFile(FileSpec$)

  'Enhanced Metafile

  Dim r As RECT
  'Dim oldsize As SizeApi

  WriteEnhMetaFile = 19903

  HV.PrtEnbl = 34
  Call InitPhysDevices
  HV.PrtEnbl = 1

  r.Right = HMPrt.DrawRect.Right / HMPrt.DpiX * 2540       '1/100 mm
  r.Bottom = HMPrt.DrawRect.Bottom / HMPrt.DpiY * 2540     '1/100 mm

  Call GetHMCaption(St$, Ka$)
  Title$ = Parse$(St$, "(")
  Title$ = Parse$(St$, ")") & "  " & Parse$(Ka$, "(")
  Title$ = ProgName$ & Chr$(0) & Trim$(Title$) & Chr$(0) & Chr$(0)

  'Reference DC (auer 0) geht nicht
  HV.hMetaDC = CreateEnhMetaFile(0&, FileSpec$, r, Title$)

  If HV.hMetaDC = 0 Then Exit Function
  'Ok& = SetWindowExtEx(HV.hMetaDC, r.Right, r.Bottom, oldsize)
  'Ok& = SetMapMode(HV.hMetaDC, MM_ANISOTROPIC)

  HV.PrtEnbl = 34
  Call NewMap
  HV.PrtEnbl = 1

  hndMeta& = CloseEnhMetaFile(HV.hMetaDC)
  Ok& = DeleteEnhMetaFile(hndMeta&)

  WriteEnhMetaFile = 0

End Function

Function WriteMetafile(FileSpec$)

  Dim MetaFileHdr As METAFILEHEADER
  Dim oldsize As SizeApi

  WriteMetafile = 19903

  '--- Create Metafile ---
  HV.PrtEnbl = 18
  Call InitPhysDevices

  xExt = HMPrt.DrawRect.Right
  yExt = HMPrt.DrawRect.Bottom

  HV.hMetaDC = CreateMetaFileBynum(0&)
  If HV.hMetaDC = 0 Then
    HV.PrtEnbl = 1
    Exit Function
  End If

  'Ok& = SetWindowExtEx(HV.hMetaDC, xExt, yExt, oldsize)
  'Ok& = SetMapMode(HV.hMetaDC, MM_ANISOTROPIC)

  Call NewMap
  HV.PrtEnbl = 1

  hndMeta& = CloseMetaFile(HV.hMetaDC)
  If hndMeta& = 0 Then Exit Function


  '--- Create Metafile-Header ---
  With MetaFileHdr
    ' First write a placeable header file header
    .Key = &H9AC6CDD7  ' The key - required
    .hMF = 0           ' Must be 0
    .bbox.Left = 0
    .bbox.Top = 0
    .bbox.Right = xExt     'Size in metafile units of bounding area
    .bbox.Bottom = yExt
    '.inch = 1000 ' Number of metafile units per inch
    .inch = HMPrt.DpiX
    '.inch = GetDeviceCaps(MapForm.hdc, 88)

    .reserved = 0

    ' Build the checksum
    .checksum = &H9AC6 Xor &HCDD7 ' 9ac6 xor cdd7
    .checksum = .checksum Xor .bbox.Right
    .checksum = .checksum Xor .bbox.Bottom
    .checksum = .checksum Xor .inch
  End With


  ' Open the file to write
  hndFile& = CreateFile(FileSpec$, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
  If hndFile& <> INVALID_HANDLE_VALUE Then

    ' Write Header
    Ok& = WriteFile(hndFile&, MetaFileHdr, Len(MetaFileHdr), BytesWritten&, 0)

    ' Find out how bit the buffer needs to be
    If Ok& Then BytesToWrite& = GetMetaFileBitsEx(hndMeta&, 0, ByVal 0)

    If BytesToWrite& Then
      HndMem& = GlobalAlloc(GMEM_MOVEABLE, BytesToWrite&)
    End If

    If HndMem& Then

      MemAddr& = GlobalLock(HndMem&)
      If MemAddr& Then
        Ok& = GetMetaFileBitsEx(hndMeta&, BytesToWrite&, ByVal MemAddr&)
        If Ok& Then Ok& = WriteFile(hndFile&, ByVal MemAddr&, BytesToWrite&, BytesWritten&, 0)
        If Ok& Then OkWrite& = FlushFileBuffers(hndFile&)

        lErrNr& = GlobalUnlock(HndMem&)
      End If
      lErrNr& = GlobalFree(HndMem&)
    End If

    Ok& = CloseHandle(hndFile&)

    If Ok& <> 0 And OkWrite& <> 0 Then WriteMetafile = 0
  End If


  Ok& = DeleteMetaFile(hndMeta&)

End Function

Function WriteOldMetaFile(FileSpec$)

  'Normal Metafile

  WriteOldMetaFile = 19903

  HV.hMetaDC = CreateMetaFile(FileSpec$)
  If HV.hMetaDC = 0 Then Exit Function

  HV.PrtEnbl = 18
  Call NewMap
  HV.PrtEnbl = 1

  hndMeta& = CloseMetaFile(HV.hMetaDC)
  Ok = DeleteMetaFile(hndMeta&)

  WriteOldMetaFile = 0

End Function

