Attribute VB_Name = "BackupSub"
'--------------------------- BACKUP.BAS ------------------------------

'HAMMAP Backup-Programm
'von Gerhard Berg, DJ6FM


DefInt A-Z




Dim DstDrive$                       'Drive:\[Base-Path\]
Dim TmpPath$
Dim ShipList$
Dim BackupMode

Sub Main()


  Call StartBackup
  Call ExitHMTool


End Sub

Function ArchiveFiles(Must, Src$, DstFile$)

  ArchiveFiles = True

  m$ = "ARCHIVE: " + Src$
  If BackupMode = 2 Then Call ShowCmd(m$)


  '--- Files in Inhalts-File schreiben ---
  ArcSrc$ = " DIR.LST"

  Do Until Len(Src$) = 0
    '--- Naechstes File (ggf. mit Wildcard) aus Liste ---
    SrcFile$ = Parse$(Src$, " ")

    'Pruefen, ob Source vorhanden
    ErrNr = ExistFile(SrcFile$, Must, Exist)
    If ErrNr Then Exit Function
    If Exist Then
      ArcSrc$ = ArcSrc$ + " " + SrcFile$

      '--- Files aus Wildcard bestimmen ---
      Call ParseFileSpec(SrcFile$, d$, p$, n$, e$)

      ErrNr = GetDir(SrcFile$, f$)
      If ErrNr Then Exit Function

      l$ = ""
      Do Until Len(f$) = 0
        l$ = l$ + p$ + f$ + vbCrLf
        f$ = Dir$
      Loop

      FileList$ = FileList$ + l$
    End If
  Loop


  '---- Falls Files zum Archivieren da ---
  If Len(FileList$) > 0 Then

    Call ParseFileSpec(DstFile$, d2$, P2$, n2$, E2$)
    TmpFile$ = TmpPath$ + n2$ + E2$

    If BackupMode = 2 Then

      '--- Inhalts-File schreiben ---
      ErrNr = SaveTextFile("DIR.LST", FileList$)
      If ErrNr Then Exit Function

      '--- ggf. altes Archiv-File loeschen ---
      ErrNr = DeleteFile(TmpFile$, Found)
      If ErrNr Then Exit Function

      '--- Files in temporaeres Archiv aufnehmen ---
      c$ = HomeDir$ + "LHA\LHA a /x1 " + TmpFile$ + ArcSrc$
      ErrNr = DosCommand(c$)
      If ErrNr Then Exit Function

    End If


    '--- Temporaeres Archiv kopieren ---
    ErrNr = CheckCopyFile(TmpFile$, DstFile$, "")

    'Evtl. altes Temp-File wird bei Mode = 1 hier schon geloescht
    void = DeleteFile(TmpFile$, Found)
    If ErrNr Then Exit Function
  End If

  ArchiveFiles = False

End Function

Function CancelBackup()

  CancelBackup = Val(CancelForm.Tag)

End Function

Function CheckCopyFile(Src$, DstFile$, Vers$)

  'DstFile$ = Relativer Pfad + Datei

  CheckCopyFile = True

  If BackupMode = 1 Then

    Call ParseFileSpec(DstFile$, d$, p$, n$, e$)
    ShipList$ = ShipList$ + n$ + e$ + Vers$ + vbCrLf

  Else

    'DstSpec$ is Full Destination Spec

    DstSpec$ = DstDrive$ + DstFile$


    '--- Pruefen, ob Quell-Datei vorhanden ---
    ErrNr = OpenFile(Src$, "I", 0, FileNr)
    If ErrNr Then Exit Function


    '--- Pruefen, ob genug Paltz zum kopieren ---
    Needed& = LOF(FileNr)
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function

    ErrNr = GetDiskSpaceFree(DstDrive$, Free@)
    If ErrNr Then Exit Function

    If Needed& > Free@ Then
      Cancel = NewDisk()
      If Cancel Then Exit Function
    End If


    '--- ggf. Pfad anlegen ---
    On Error Resume Next
    'Bei Windows XP liefert Dir$ keinen Fehler, wenn Verzeichnis nicht existiert
    'd$ = Dir$(DstSpec$)
    l& = FileLen(DstSpec$)
    ErrNr = Err
    On Error GoTo 0

    If ErrNr = 76 Then
      ErrNr = MakePath(DstSpec$)
      If ErrNr Then Exit Function
    End If


    '--- Datei kopieren ---
    Call ShowCmd("COPY: " + Src$ + " -> " + DstSpec$)

    ErrNr = CopyFile(Src$, DstSpec$)
    If ErrNr Then Exit Function

    'Pruefen, ob Datei kopiert ist
    ErrNr = ExistFile(DstSpec$, True, Exist)
    If ErrNr Then Exit Function

  End If

  CheckCopyFile = False

End Function

Function CompressFile(Src$, Dst$, TmpPath$, BackupMode)

  CompressFile = True

  m$ = "COMPRESS: " + Src$
  If BackupMode = 2 Then Call ShowCmd(m$)

  Call ParseFileSpec(Src$, d1$, P1$, n1$, e1$)
  Call ParseFileSpec(Dst$, d2$, P2$, n2$, E2$)


  If BackupMode = 1 Then
    v$ = ""
  Else
    '--- Komprimieren in Temp-Datei ---
    f$ = Src$ + " " + StripBackSlash$(TmpPath$)
    Cmd$ = HomeDir$ + "WIN\COMPRESS -r " + f$
    ErrNr = DosCommand(Cmd$)
    If ErrNr Then Exit Function
  End If

  '--- Temp-Datei kopieren ---
  E2$ = Left$(e1$, 3) + "_"
  TmpFile$ = TmpPath$ + n1$ + E2$
  DstFile$ = P2$ + n1$ + E2$
  ErrNr = CheckCopyFile(TmpFile$, DstFile$, v$)
  void = DeleteFile(TmpFile$, Found)
  If ErrNr Then Exit Function

  CompressFile = False

End Function

Function DiskEmpty(Dst$, Free@)

  DiskEmpty = True

  Drive$ = Left$(Dst$, 2)

  Do

    '--- Pruefen, ob Laufwerk betriebsbereit ---
    Do
      ErrNr = GetDiskSpaceFree(Dst$, Free@)
      If ErrNr = -9999 Then Exit Function
      If ErrNr Then
        Answer = TxtMsgBox(Msg$(ErrNr) + ": " + Drive$, 5, ProgName$)
        If Answer = 2 Then Exit Function
      End If
    Loop Until ErrNr = 0


    '--- Pruefen, ob Diskette leer ---
    'If Len(Drive$) < 4 Then

      'Pruefen, ob Dateien vorhanden
      ErrNr = GetDir(Dst$ + "*.*", d$)
      If Len(d$) > 0 Then ErrNr = 17000

      'Pruefen, ob Verzeichnisse vorhanden
      If ErrNr = 0 Then
        BackupForm.DirBox.Path = Dst$
        BackupForm.DirBox.Refresh
        If BackupForm.DirBox.ListCount > 0 Then ErrNr = 17000
      End If

      If ErrNr Then
        If ErrNr = 17000 And Len(Dst$) > 3 Then ErrNr = 17005
        m$ = Replace$(Msg$(ErrNr), "%", Dst$)
        Answer = TxtMsgBox(m$, 5, ProgName$)
        If Answer = 2 Then Exit Function
      End If

    'End If
  Loop Until ErrNr = 0

  DiskEmpty = False

End Function

Sub InitBackupForm()

  BackupForm.WindowState = 0
  Call CenterForm(BackupForm)

  BackupForm.Caption = ProgName$
  BackupForm.MenuFile.Caption = Msg$(17010)
  BackupForm.MenuEnd.Caption = Msg$(17011)
  BackupForm.MenuInfo.Caption = Msg$(17012)

  BackupForm.OkCmd.Caption = Msg$(25050)
  BackupForm.CancelCmd.Caption = Msg$(25053)

  On Error Resume Next
  ChDrive "A:"
  BackupForm.DriveBox.Drive = "A:"
  If Err Then MsgBox Msg$(17006)
  On Error GoTo 0

End Sub

Sub InteractiveBackup()

  Call InitBackupForm

  '--- Laufwerk auswaehlen ---
  void = ShowDiskSpaceFree()
  BackupForm.Show 1

  If BackupForm.Tag = "1" Then
    '--- Backup durchfuehren ---
    DstDrive$ = BackupForm.DriveBox.Drive
    Call PerformBackup
    Call ShowCancelForm(False)
  End If

End Sub

Function NewDisk()

  Static DiskNr

  NewDisk = True

  If DiskNr = 0 Then DiskNr = 1            'mit 2 anfangen
  DiskNr = DiskNr + 1
  Beep

  m$ = Replace$(Msg$(17001), "%", Format$(DiskNr))
  Do
    Answer = TxtMsgBox(m$, 1, ProgName$)
    If Answer = 2 Then Exit Function
    ErrNr = DiskEmpty(DstDrive$, Free@)
  Loop Until ErrNr = 0

  NewDisk = False

End Function

Sub PerformBackup()

  void = DoEvents()

  TmpPath$ = HomeDir$
  p$ = Environ$("TEMP")
  If Len(p$) > 0 Then TmpPath$ = p$
  p$ = Environ$("TMP")
  If Len(p$) > 0 Then TmpPath$ = p$
  'Avoid DOS-Command Overflow
  If Len(TmpPath$) > 10 Then TmpPath$ = "C:\TMP"
  TmpPath$ = UCase$(AddBackSlash$(TmpPath$))


  'Auf Hard-Disk ggf. Pfad anlegen
  DstDrive$ = UCase$(AddBackSlash$(DstDrive$))
  If Len(DstDrive$) > 3 Then
    ErrNr = MakePath(DstDrive$)
    If ErrNr Then Exit Sub
  End If


  'Pruefen ob Drive Ready und Diskette leer
  ErrNr = DiskEmpty(DstDrive$, Free@)
  If ErrNr Then Exit Sub

  Call ShowCancelForm(True)


  '--- HomeDir$ als aktuelles Verzeichnis setzen ---
  ' 1. Dateien ohne Source-Pfad werden von hier gelesen
  ' 2. Damit LHA nur relative Pfade speichert, muss SrcFile$ relativ
  '      und deshalb HomeDir$ aktuelles Verzeichnis sein
  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Sub

  'Directory for storing SHIPING.LST
  ShipListDir$ = UCase$(AddBackSlash$(DstDrive$))

  '--- INI-Datei oeffnen ---
  ErrNr = OpenFile(InParFile$, "I", 0, FileNr)
  If ErrNr Then Exit Sub

  If FindCmdOpt("/DOS", DosPath$) Then
    s$ = "DOS"
    If Len(DosPath$) > 0 Then
      ErrNr = ChangePath(AddBackSlash$(DosPath$))
      If ErrNr Then Exit Sub
    End If
  Else
    MsgBox "Cannot Backup HAMMAP for Windows"
    Exit Sub
  End If

  s$ = "[BACKUP-" + s$ + "]"
  ErrNr = FindSection(FileNr, s$, InpLine$, True, Found)
  If ErrNr Or Not Found Then Exit Sub

  '--- Befehle einlesen ---
  Do Until EOF(FileNr)
    ErrNr = ReadDataLine(FileNr, InpLine$, EndOfFile)
    If ErrNr Then Exit Sub
    If EndOfFile Then Exit Do
    If Left$(InpLine$, 1) = "[" Then Exit Do     'Bereichs-Ende

    InpLine$ = UCase$(InpLine$)
    InCmdBuf$ = InCmdBuf$ + InpLine$ + vbCrLf
  Loop

  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Sub


  '--- Befehle ausfuehren ---
  Call ShowCmd("GENERATE: SHIPING.LST")
  ShipList$ = "SHIPING.LST" + vbCrLf

  For BackupMode = 1 To 2
    CmdBuf$ = InCmdBuf$

    Do Until Len(CmdBuf$) = 0
      void = DoEvents()

      ErrNr = CancelBackup()
      If ErrNr Then Exit Do

      InpLine$ = Parse$(CmdBuf$, vbCrLf)

      Cmd$ = Parse$(InpLine$, ":")
      Must = Parse$(InpLine$, ",") = "1"
      Src$ = Parse$(InpLine$, ",")
      Dst$ = InpLine$

      Select Case UCase$(Cmd$)
      Case "PAUSE"
        MsgBox "Weiter mit 'Ok'"

      Case "SHIPLISTDIR"
        'Directory for storing SHIPING.LST
        ShipListDir$ = UCase$(AddBackSlash$(AddBackSlash$(DstDrive$) + Src$))

      Case "COPY", "VCOPY"
        ErrNr = ExistFile(Src$, Must, Exist)
        If ErrNr = 0 And Exist Then
          GetVer = (Cmd$ = "VCOPY")
          ErrNr = WildCopyBackupFiles(Src$, Dst$, GetVer)
        End If

      Case "LHA"
        ErrNr = ArchiveFiles(Must, Src$, Dst$)

      Case "COMPRESS"
        ErrNr = ExistFile(Src$, Must, Exist)
        If ErrNr = 0 And Exist Then
          ErrNr = CompressFile(Src$, Dst$, TmpPath$, BackupMode)
        End If

      Case "DISK"               'Force New Disk
        If BackupMode = 2 Then ErrNr = NewDisk()

      Case "SHELL"
        If BackupMode = 2 Then ErrNr = DosCommand(Src$)

      Case Else
        void = TxtMsgBox(Msg$(25031) + ": '" + Cmd$ + "'", 0, ProgName$)
        ErrNr = True
      End Select

      If ErrNr Then Exit Do

    Loop

    If ErrNr Then Exit For

    '--- Dateiliste speichern ---
    If BackupMode = 1 Then
      ErrNr = MakePath(ShipListDir$)
      If ErrNr Then Exit For
      ErrNr = SaveTextFile(ShipListDir$ + "SHIPING.LST", ShipList$)
      If ErrNr Then Exit For
    End If

  Next BackupMode

  Call ShowCancelForm(False)
  If ErrNr Then MsgNr = 17003 Else MsgNr = 17002
  void = TxtMsgBox(Msg$(MsgNr), 0, ProgName$)

End Sub

Sub ShowCancelForm(Mode)

  Static Init

  If Not Init Then
    Init = True
    Load CancelForm
    Call CenterForm(CancelForm)
    CancelForm.Caption = ProgName$
    CancelForm.CancelCmd.Caption = Msg$(25053)
  End If

  If Mode Then
    CancelForm.Show
  Else
    CancelForm.Hide
  End If

End Sub

Sub ShowCmd(Cmd$)

  CancelForm.LabelField.Caption = Cmd$
  CancelForm.LabelField.Refresh

End Sub

Function ShowDiskSpaceFree()

  d$ = UCase$(Left$(BackupForm.DriveBox.Drive, 2))
  ErrNr = GetDiskSpaceFree(d$, n@)

  Select Case ErrNr
  Case 0
    m$ = d$ & " " & Format$(CLng(n@ / 1024), "#,##0") + " " + Msg$(17004)
    BackupForm.InfoField.Caption = m$
  Case 71           'Not Ready
    BackupForm.InfoField.Caption = Msg$(ErrNr)
  Case Else
    Call ShowErrNr(ErrNr)
  End Select

  ShowDiskSpaceFree = ErrNr

End Function

Sub ShowInfo()

  If VBDOS Then
    m$ = Msg$(25027)
  Else
    m$ = Msg$(25025) + "  " + sWinBits
  End If

  m$ = ProgName$ + " " + m$ + vbCrLf
  m$ = m$ + Msg$(25024) + " " + Version$
  m$ = m$ + vbCrLf + Msg$(25023) + " Gerhard Berg, DJ6FM"

  void = TxtMsgBox(m$, 8, ProgName$ + "  -  " + Msg$(25026))

End Sub

Sub StartBackup()

  ErrNr = InitHmTool("HAMMAP - Backup", "DOS,BACKUP,HMSUB")
  If ErrNr Then Exit Sub

  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Sub

  If GV.AnzCmdFiles > 0 Then
    DstDrive$ = CmdFiles$(1)
    Call PerformBackup
    Call ShowCancelForm(False)
  Else
    ShowOk = True
    Call InteractiveBackup
  End If

End Sub

Function WildCopyBackupFiles(Src$, Dst$, GetVer)

  Dim f$, ErrNr
  Dim d$, p$, n$, e$
  Dim d1$, P1$, n1$, e1$
  Dim d2$, P2$, n2$, E2$

  WildCopyBackupFiles = True

  Call ParseFileSpec(Src$, d1$, P1$, n1$, e1$)
  Call ParseFileSpec(Dst$, d2$, P2$, n2$, E2$)


  '--- Ermittlung der Dateien ---
  'Separate Schleife, da spaeter in ExistFile auch Dir$ gebraucht wird
  ErrNr = GetDir(Src$, f$)
  If ErrNr Then Exit Function

  Do Until Len(f$) = 0
    FileList$ = FileList$ + f$ + ","
    f$ = Dir$
  Loop


  '--- Dateien kopieren ---
  Do Until Len(FileList$) = 0
    f$ = Parse$(FileList$, ",")

    Call ParseFileSpec(f$, d$, p$, n$, e$)
    If n2$ <> "*" Then n$ = n2$
    If E2$ <> ".*" Then e$ = E2$

    Src$ = d1$ + P1$ + f$
    Dst$ = P2$ + n$ + e$

    v$ = ""

    ErrNr = CheckCopyFile(Src$, Dst$, v$)
    If ErrNr Then Exit Function
  Loop

  WildCopyBackupFiles = False

End Function

