Attribute VB_Name = "BmpSub"
DefInt A-Z

'Quelle: mc August 1993, S.88
Type BmpHeader
  bfType As Integer   'File ID ('BM')
  bfSize As Long      'Filelnge in Byte
  reserved As Long    'reserviert (mu 0 sein)
  bfOffs As Long      'Offset Datenbereich
End Type

Type BmpInfoHeader
  biSize As Long      'Lnge BmpInfoHeader
  biWidth As Long     'Breite der Bitmap in Pixeln
  biHeight As Long    'Hhe der Bitmap in Pixeln
  biPlanes As Integer 'Zahl der Farbebenen (mu 1 sein)
  biBitCnt As Integer 'Zahl der Bit pro Pixel
  biCompr As Long     'Typ der Komprimierung (0=unkomprimiert, 1=RLE8, 2=RLE4)
  biSizeIm As Long    'Bildgre in Byte
  biXPelsm As Long    'horizontale Auflsung
  biYPelsm As Long    'vertikale Auflsung
  biClrUsed As Long   'Zahl der benutzen Farben
  biClrImp As Long    'Zahl der wichtigen Farben
End Type

Function CalibrateBitmap(MapFile$, Def$, Cancel)

  CalibrateBitmap = True

  DefFile$ = GetDefFile$(MapFile$)
  ErrNr = ExistFile(DefFile$, False, Exist)
  If ErrNr Then Exit Function

  With frmCalibMap

    'This triggers the Form_Load Event
    .Caption = ProgName$ & " - " & Msg$(19800) & " (" & MapFile$ & ")"

    For i = 0 To 4
      If i > 0 Then Load .Cmd(i)
      .Cmd(i).Visible = True
      .Cmd(i).TabIndex = i + 5
    Next i

    .Cmd(0).Tag = MapFile$      'Pass to frmCalibMap
    .Cmd(3).Visible = (UCase$(GetExt$(MapFile$)) = ".BMP")    'Rand lschen

    .Cmd(0).Default = True
    .Cmd(1).Cancel = True

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)
    .Cmd(2).Caption = Msg$(19801)
    .Cmd(3).Caption = Msg$(19802)
    .Cmd(4).Caption = Msg$(25056)

    .lstScale.TabIndex = 9
    .lstCoord.TabIndex = 10
    .lstDatum.TabIndex = 11
    .VScrollMap.TabIndex = 12
    .HScrollMap.TabIndex = 13


    For i = 0 To 5
      If i < 2 Then
        .lstScale.AddItem "X " & Format$(2 ^ (i - 2), "0.##")
      Else
        .lstScale.AddItem "X" & Str$(2 ^ (i - 2))
      End If
    Next i

    .lstScale.ListIndex = 2

    If Exist Then
      'Default Werte von Datei laden
      ErrNr = LoadTextFile(DefFile$, 32767, m$)
      If ErrNr Then Exit Function

      m0$ = Parse$(m$, vbCrLf)
      V$ = Parse$(m0$, ",")       'Version
      DefCoord = Val(Parse$(m0$, ","))
      DefDatum = Val(Parse$(m0$, ","))

      m1$ = Parse$(m$, vbCrLf)
      m2$ = Parse$(m$, vbCrLf)
      m3$ = Parse$(m$, vbCrLf)

      Sep$ = Mid$(Format$(0, "0.0"), 2, 1)

      For i = 0 To 3
        .fldPixel(i).Caption = Parse$(m1$, ",")        'Ref-Pixel
        .fldBorder(i).Caption = Parse$(m2$, ",")       'Rand
        m$ = Parse$(m3$, ",")                          'Ref-Koord
        If Sep$ = "," Then m$ = Replace$(m$, ".", ",")
        .fldCoord(i).text = m$
      Next i

    Else
      DefCoord = 0
      DefDatum = 0
    End If

    Call AddMsgItems(.lstCoord, 40050, DefCoord)
    Call AddMsgItems(.lstDatum, 40060, DefDatum)


    '-------- Eingabe --------
    .Show 1

    Cancel = Val(.Tag) > 0       'Cancel

    If Not Cancel Then
      '--- not Cancel -> Werte in Datei speichern ---
      MapFile$ = .Cmd(0).Tag     'evtl. gendert
      ErrNr = GetCalibInput(Def$)
      DefFile$ = GetDefFile$(MapFile$)
      If ErrNr = 0 Then ErrNr = SaveTextFile(DefFile$, Def$)
    End If

  End With

  Unload frmCalibMap
  Set frmCalibMap = Nothing

  CalibrateBitmap = ErrNr

End Function

Sub DrawPixelMap(Dev As HMDevice)

  Call GetSrcRect(MV.degFileMapArea, MV.Border, MV.BmpDisp)

  ErrNr = PrepareMapDevices(0)

  void& = CopyBitMap&(Dev.hDev, Dev.MapRect, MapForm.BitMap.hDC, MV.BmpDisp)

  ErrNr = TerminateAllDevices()

End Sub

Function GetBmpFileSpec(FileSpec$)

  Title$ = ProgName$ & " - " & Msg$(19808)

  IniDir$ = HomeDir$ + "MAP"

  Filt$ = Msg$(24052) + " (*.BMP)|*.BMP"

  GetBmpFileSpec = GetFileSpec(Title$, 2, &H2, IniDir$, "BMP", Filt$, FileSpec$)

End Function

Function GetBmpInfo$()

  Dim BmpHdr As BmpHeader
  Dim BmpInfoHdr As BmpInfoHeader

  ErrNr = OpenFile(StrPar(3, 6), "B", 0, FileNr)
  If ErrNr Then Exit Function

  On Error Resume Next
  Get #FileNr, , BmpHdr
  If Err = 0 Then Get #FileNr, , BmpInfoHdr
  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then
    Call FileError(Msg$(ErrNr), StrPar(3, 6))
    Exit Function
  End If

  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Function

  m$ = Msg$(24050 + HV.MapType) & ": " & vbCrLf & Ucase16$(StrPar(3, 6))

  With BmpInfoHdr
    If .biCompr = 0 Then
      MsgNr = 19806
    Else
      MsgNr = 19807
    End If
    m$ = m$ & vbCrLf & Format(BmpHdr.bfSize / 1024, "#,##0") & " kB (" & Msg$(MsgNr) & ")"
    m$ = m$ & vbCrLf & CStr(.biWidth) & " * " & CStr(.biHeight) & " Pixel, " & CStr(.biBitCnt) & " Bit/Pixel"
  End With

  GetBmpInfo$ = m$

End Function

Function GetCalibInput(m$)

  Static RefPixel(0 To 3)
  Static Border(0 To 3)
  Dim degArea As degAreaType
  Dim Co1 As dGeoPoint
  Dim Co2 As dGeoPoint

  GetCalibInput = True

  With frmCalibMap

    'Eingabewerte
    For i = 0 To 3
      RefPixel(i) = Val(.fldPixel(i).Caption)                      'Ref-Pixel
      m1$ = m1$ & "," & Str$(RefPixel(i))

      Border(i) = Val(.fldBorder(i).Caption)                       'Border
      m2$ = m2$ & "," & Str$(Border(i))

      mc$ = .fldCoord(i).text
      m3$ = m3$ & ", " & Replace$(mc$, ",", ".")                   'Ref-Koord
    Next i

    MapDatum = .lstDatum.ListIndex
    MapCoSys = .lstCoord.ListIndex

    mb$ = .fldCoord(0).text
    ml$ = .fldCoord(2).text

    ErrNr = PosStr2dCoord(MapDatum, MapCoSys, mb$, ml$, Co1)
    If ErrNr Then Exit Function

    mb$ = .fldCoord(1).text
    ml$ = .fldCoord(3).text

    ErrNr = PosStr2dCoord(InMapDatum, MapCoSys, mb$, ml$, Co2)
    If ErrNr Then Exit Function

  End With

  'Area
  yRatio# = (Co2.b - Co1.b) / (RefPixel(1) - RefPixel(0))
  xRatio# = (Co2.l - Co1.l) / (RefPixel(3) - RefPixel(2))

  With degArea
    .bmax = (Co1.b + yRatio# * (Border(0) - RefPixel(0)))
    .bmin = (Co1.b + yRatio# * (Border(1) - RefPixel(0)))
    .lMin = (Co1.l + xRatio# * (Border(2) - RefPixel(2)))
    .lMax = (Co1.l + xRatio# * (Border(3) - RefPixel(2)))
  End With

  m$ = "V2," & Str$(MapCoSys) & "," & Str$(MapDatum)
  m$ = m$ & vbCrLf & Mid$(m1$, 3) & vbCrLf & Mid$(m2$, 3)
  m$ = m$ & vbCrLf & Mid$(m3$, 3) & vbCrLf & degArea2Str$(degArea)

  GetCalibInput = False

End Function

Function GetDefFile$(MapFile$)

  File$ = StripExt$(MapFile$)

  Select Case UCase$(GetExt$(MapFile$))
  Case ".BMP"
    GetDefFile$ = File$ & ".bmi"
  Case ".RLE"
    GetDefFile$ = File$ & ".rli"
  Case Else
    Stop
  End Select

End Function

Sub GetSrcRect(degArea As degAreaType, rBorder As RECT, rSrc As RECT)

  Dim SelArea As degAreaType

  Call secArea2degArea(MV.ActMapArea, SelArea)

  With rBorder
    fx# = (.Right - .Left) / (degArea.lMax - degArea.lMin)
    rSrc.Left = .Left + fx# * (SelArea.lMin - degArea.lMin)
    rSrc.Right = .Left + fx# * (SelArea.lMax - degArea.lMin)
    'rSrc.Right = lmin(rSrc.Right, .Right)

    fy# = (.Bottom - .Top) / (degArea.bmax - degArea.bmin)
    rSrc.Top = .Top + fy# * (degArea.bmax - SelArea.bmax)
    rSrc.Bottom = .Top + fy# * (degArea.bmax - SelArea.bmin)
    'rSrc.Bottom = lmin(rSrc.Bottom, .Bottom)
  End With

End Sub

Function InsertBitmap(Title$, MapFile$, Change&)

  InsertBitmap = True

  Cancel = GetBmpFileSpec(MapFile$)
  If Cancel Then Exit Function

  Change& = True

  Call InitMapData
  Call EraseWaterPoints

  'Karte aus Zwischenablage einfgen
  MapForm.BitMap.Picture = Clipboard.GetData(2)

  'Karte speichern
  ErrNr = SaveBitmap(MapForm.BitMap, MapFile$)
  If ErrNr Then Exit Function             'Cancel or Error

  'Karte kalibrieren
  ErrNr = CalibrateBitmap(MapFile$, Def$, Cancel) 'MapFile$ may change !
  If ErrNr Or Cancel Then Exit Function

  ErrNr = SetBitmapDef(Def$, MV.Border, MV.FileMapArea, MV.degFileMapArea)
  If ErrNr Then Exit Function

  HV.MapType = 2
  NumPar(46).Actual = NumPar(46).Actual Or MF_BitMap

  InsertBitmap = False

End Function

Function LoadBitmap(FileSpec$, Obj As PictureBox)

  On Local Error Resume Next
  Obj.Picture = LoadPicture(FileSpec$)
  ErrNr = Err
  On Local Error GoTo 0

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, FileSpec$)

  LoadBitmap = ErrNr

End Function

Function RegisterBitMapFile(i, Cancel)

  Dim degArea As degAreaType

  RegisterBitMapFile = True

  MapFile$ = BitmapFileName(i)

  DefFile$ = GetDefFile$(MapFile$)

  ErrNr = ExistFile(DefFile$, False, Exist)
  If ErrNr Then Exit Function

  If Exist Then
    'Kartendefinition laden
    ErrNr = LoadTextFile(DefFile$, 32767, Def$)
    If ErrNr Then Exit Function
   Else
    'Karte kalibrieren
    ErrNr = LoadBitmap(MapFile$, MapForm.BitMap)
    If ErrNr Then Exit Function
    ErrNr = CalibrateBitmap(MapFile$, Def$, Cancel)  'MapFile$ may change !
    If ErrNr Then Exit Function
    If Cancel Then
      RegisterBitMapFile = False
      Exit Function
    End If

    BitmapFileName(i) = MapFile$
  End If

  With BitmapFileInfo(i)
    ErrNr = SetBitmapDef(Def$, .Border, .Area, .degArea)
    If ErrNr Then Exit Function
    .Size = FileLen(MapFile$)

    'Maximalen Bereich finden
    If Not AreaInArea(0, .Area, MV.MaxBmpArea) Then
      'aktueller Bereich ist grer als MaxArea -> neu setzen
      MV.MaxBmpArea = .Area
    End If
  End With

  RegisterBitMapFile = False

End Function

Function SaveBitmap(Obj As PictureBox, FileSpec$)

  On Local Error Resume Next
  SavePicture Obj.Image, FileSpec$
  ErrNr = Err
  On Local Error GoTo 0

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, FileSpec$)

  SaveBitmap = ErrNr

End Function

Function SelectBitmapFile$()

  '------- Bitmap-Map -------
  'Order of precedence:
  '1. Area
  '2. Vergrerung (optimal = 1)
  '3. File size

  Dim SrcRect As RECT
  Dim DstRect As RECT

  If HV.PrtEnbl And 2 Then
    'Wenn Drucker + Bildschirm -> Druckerauflsung verwenden
    DstRect = HMPrt.MapRect
  Else
    DstRect = HMCrt.MapRect
  End If


  For i = 1 To HV.AnzBitmapFiles

    With BitmapFileInfo(i)

      'prfen, ob gewnschter Ausschnitt komplett enthalten ist
      ShowOk = AreaInArea(0, MV.ActMapArea, .Area)

     If ShowOk Then

        ActSize& = .Size

        'Mastab berechnen -> mglichst nahe an 1:1
        Call GetSrcRect(.degArea, .Border, SrcRect)
        Call GetRectSize(SrcRect, wSrc&, hSrc&)
        Call GetRectSize(DstRect, wDst&, hDst&)

        ShowOk = wSrc& > 0 And hSrc& > 0 'Avoid Division by Zero

      End If

      If ShowOk Then

        ActHScale! = wDst& / wSrc&
        ActVScale! = hDst& / hSrc&

        If ActHScale! < 1! Then ActHScale! = 1! / ActHScale!
        If ActVScale! < 1! Then ActVScale! = 1! / ActVScale!
        ActScale! = (ActHScale! + ActVScale!) / 2!

        ScaleLimit = 16
        ShowOk = ActHScale! <= ScaleLimit And ActVScale! <= ScaleLimit

      End If

      If ShowOk Then

        If SelMapNr = 0 Then

          'erster passender Ausschnitt
          SelMapNr = i

        Else

          If ActScale! = SelScale! Then
            'Gleiche Vergrerung
            If ActSize& < SelSize& Then
              'gleiche Vergrerung, aber kleinere Datei
              SelMapNr = i
            End If
          ElseIf ActScale! < SelScale! Then
            'aktuelle Vergrerung ist besser
            SelMapNr = i
          End If
        End If

        If SelMapNr = i Then
          SelScale! = ActScale!
          SelSize& = ActSize&
        End If

      End If
    End With
  Next i

  If SelMapNr > 0 Then
    SelectBitmapFile$ = BitmapFileName(SelMapNr)
  End If

End Function

Function SetBitmapDef(ByVal m$, r As RECT, secArea As lAreaType, degArea As degAreaType)

  SetBitmapDef = True

  Vers$ = Parse$(m$, vbCrLf)
  RefPixel$ = Parse$(m$, vbCrLf)
  Border$ = Parse$(m$, vbCrLf)
  RefCoord$ = Parse$(m$, vbCrLf)
  AreaCoord$ = Parse$(m$, vbCrLf)

  ErrNr = Str2Rect(Border$, r)
  If ErrNr Then Exit Function

  ErrNr = Str2degArea(AreaCoord$, degArea)
  If ErrNr Then Exit Function

  'secArea so setzen, da sie komplett innerhalb degArea
  Call DegArea2SecArea(degArea, secArea, 1)

  SetBitmapDef = False

End Function

