Attribute VB_Name = "CBDCVT"
'--------------------------- CBDCVT.BAS ------------------------------

'Unterprogramme zum HAMMAP Karten-Konvertierungs-Programm
'Konvertierung der CBD-Files
'von Gerhard Berg, DJ6FM


DefInt A-Z



  Dim SegBuf() As Byte


Dim MapHeader As CbdHead
Dim SegDict As SegmentDict
Dim Segm As CbdSegment

Function ConvertCbdFile(FileNr, FileExt$)

  Dim SegNr As Long
  Dim dx As Long, dy As Long
  Dim CbdX As Long, CbdY As Long

  Dim Indata As Segment

  ConvertCbdFile = True

  RankMask& = NumPar(5).Actual

  Select Case FileExt$
  Case ".BDY", ".PBY"
    FileType = 1
  Case ".CIL"
    FileType = 2
  Case ".RIV"
    FileType = 3
  Case Else: Stop
  End Select

  ErrNr = 0
  MV.OutSegmFlag = False


  '--- Header lesen und pruefen ---
  ErrNr = GetCbdHeader(FileNr)
  If ErrNr Then Exit Function

  'Format pruefen
  If Hex$(MapHeader.MagicNum) <> "20770002" Then
    Call ShowErrNrFileNr(25003, FileNr)
    Exit Function
  End If

  ShowStep& = MapHeader.SegCount \ 50
  If ShowStep& = 0& Then ShowStep& = 1&
  void = ShowComplete(0&, ShowStep& * 50, FileNr, 29104)

  For SegNr = 1 To MapHeader.SegCount

    '--- Segment Directory Eintrag einlesen ---
    Offset& = MapHeader.DictAddr + (SegNr - 1) * Len(SegDict)

    ErrNr = GetCbdDict(FileNr, Offset&)
    If ErrNr Then Exit For


    'Pruefen, ob Segment im gewuenschten Ausschnitt
    SegEnbl = True
    If SegDict.lymax < MV.ActMapArea.lymin Then
      SegEnbl = False
    ElseIf SegDict.lymin > MV.ActMapArea.lymax Then
      SegEnbl = False
    Else
      If SegDict.lxmin < -clMaxDegX / 2& And SegDict.lxmax > clMaxDegX / 2& Then
        c1 = SegDict.lxmin < MV.ActMapArea.lxmin
        c2 = SegDict.lxmax > MV.ActMapArea.lxmax
        If c1 And c2 Then SegEnbl = False
      Else
        If SegDict.lxmax < MV.ActMapArea.lxmin Then
          SegEnbl = False
        ElseIf SegDict.lxmin > MV.ActMapArea.lxmax Then
          SegEnbl = False
        End If
      End If
    End If


    '--- Pruefen, ob Rank des Segments ausgewaehlt ---
    If SegEnbl Then

      '--- Rank umwandeln ---
      CbdRank = SegDict.Rank

      Select Case FileType
      Case 1              'BDY, PBY
        Select Case CbdRank
        Case 1            'Grenzen
          HmRank = 17 + CbdRank       '1 -> 18
        Case 2 To 3
          HmRank = 0
        Case Else
          HmRank = -1
        End Select

      Case 2              'CIL
        Select Case CbdRank
        Case 1 To 4               'Kuesten, Inseln, Seen
          HmRank = CbdRank
        Case 6 To 10              'Zeitweilige Seen, Riffe, Salzpfannen
          HmRank = 0
        Case 13 To 15             'Schelfeis, Gletscher
          HmRank = 0
        Case Else
          HmRank = -1
        End Select

      Case 3              'RIV
        Select Case CbdRank
        Case 1 To 4               'Fluesse
          HmRank = CbdRank + 7       '1 -> 8
        Case 5                    'Double lined river -> handle as Coast
          HmRank = 1
        Case 6 To 8               'zeitweilige Fluesse
          HmRank = 0
        Case 10, 11               'Kanaele
          HmRank = CbdRank + 5       '10 -> 15
        Case 13                   'Bewaesserungs-Kanaele
          HmRank = 0
        Case Else
          HmRank = -1
        End Select
      End Select

      Select Case HmRank
      Case -1
        m$ = "        Segment" + Str$(SegNr) + " - ID:"
        m$ = m$ + Str$(SegDict.SegId) + ": CBD-Rank ="
        m$ = m$ + Str$(SegDict.Rank)
        void = WriteLog(m$, 3)
        ErrNr = 25003
        Call ShowErrNrFileNr(ErrNr, FileNr)
        Exit For
      Case 0
        SegEnbl = False
      Case Else
        SegEnbl = (2& ^ (HmRank - 1) And RankMask&) <> 0
      End Select

    End If


    '--- Ehem. DDR-Grenze unterdruecken ---
    If SegEnbl Then
      Select Case SegDict.SegId
      Case 3097860 To 3097864
        SegEnbl = False
      End Select
    End If


    'Anzahl Koordinaten (incl. Anfangswert) < Min. Segment Length ?
    If SegEnbl Then
      ErrNr = GetCbdSegm(FileNr, SegDict, Segm)
      If ErrNr Then Exit For

      If Segm.AnzKoord + 1 < NumPar(3).Actual Then
        SegEnbl = False
      End If
    End If


    '--- Segment einlesen ---
    If SegEnbl Then

      SegMsg$ = Format$(Segm.Id) + "-" + Format$(SegDict.Rank)
      'Comment$ = SegMsg$
      Comment$ = ""

      '--- Format pruefen ---
      SegMsg$ = "        Segment" + Str$(SegNr) + "/" + SegMsg$

      If Segm.Id <> SegDict.SegId Then
        m$ = SegMsg$ + ": ID =" + Str$(SegDict.SegId)
        void = WriteLog(m$, 3)
        Call ShowErrNrFileNr(25003, FileNr)
        ErrNr = 25003
        Exit For
      End If

      '--- Segment oeffnen ---
      'Indata.SegId = Segm.Id
      Indata.SegType = HmRank
      CbdX = Segm.OrgX
      CbdY = Segm.OrgY
      Indata.x = CbdX
      Indata.y = CbdY

      ErrNr = OpenSegment(Indata, False, Comment$)
      If ErrNr Then Exit For


      '--- Koordinaten verarbeiten ---
      MV.In.AnzKo = MV.In.AnzKo + Segm.AnzKoord
      Ptr = 1

      For KoNr = 1 To Segm.AnzKoord
        dx = GetShort(Ptr + 1)
        If dx And &H40& Then
          '--- Short Format ---
          If dx And &H80& Then
            dx = dx Or &HFFFFFF40
          Else
            dx = dx And &H3F&
          End If

          dy = GetShort(Ptr)
          If dy And &H80& Then dy = dy Or &HFFFFFF00

          Ptr = Ptr + 2
        Else
          '--- Long Format ---
          dx = GetLong&(Ptr)
          dy = GetLong&(Ptr + 4)
          Ptr = Ptr + 8
        End If

        '--- Koordinaten ausgeben ---
        CbdX = CbdX + dx
        CbdY = CbdY + dy
        Indata.x = CbdX
        Indata.y = CbdY
        ErrNr = ProcessLineCoord(Indata)
        If ErrNr Then Exit For
      Next KoNr
      If ErrNr Then Exit For


      '--- Format pruefen ---
      If Ptr - 1 <> SegDict.nbytes Then
        m$ = SegMsg$ + ": Bytes ="
        m$ = m$ + Str$(Ptr - 1) + " /" + Str$(SegDict.nbytes)
        void = WriteLog(m$, 3)
        Call ShowErrNrFileNr(25003, FileNr)
        ErrNr = 25003
        Exit For
      End If

      c1 = MV.lSgArea.lxmin < -clMaxDegX Or MV.lSgArea.lxmax > clMaxDegX
      c2 = MV.lSgArea.lymin < -clMaxDegY Or MV.lSgArea.lymax > clMaxDegY
      If c1 Or c2 Then
        m$ = SegMsg$ + ": x="
        m$ = m$ + Format$(MV.lSgArea.lxmin) + "..." + Format$(MV.lSgArea.lxmax)
        m$ = m$ + "; y="
        m$ = m$ + Format$(MV.lSgArea.lymin) + "..." + Format$(MV.lSgArea.lymax)
        void = WriteLog(m$, 3)
        ErrNr = 25003
        Call ShowErrNrFileNr(ErrNr, FileNr)
        Exit For
      End If
    End If

    '--- % fertig ausgeben ---
    If SegNr Mod ShowStep& = 0 Then
      ErrNr = ShowComplete(SegNr, 0&, 0, 0)
      If ErrNr Then Exit For
    End If
  Next SegNr

  On Error Resume Next
  Erase SegBuf
  On Error GoTo 0


  MV.In.AnzSg = MV.In.AnzSg + MapHeader.SegCount


  '----- Letztes Segment auf Binaerdatei ausgeben ------
  If ErrNr = 0 Then
    ErrNr = SaveSegment(Comment$)
  End If

  void = ShowComplete(-1&, 0&, 0, 0)

  ConvertCbdFile = ErrNr

End Function

Function GetCbdDict(FileNr, ByteNr As Long)

  On Local Error Resume Next

  Get #FileNr, ByteNr + 1&, SegDict

  GetCbdDict = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function GetCbdHeader(FileNr)

  On Local Error Resume Next

  Get #FileNr, 1, MapHeader

  GetCbdHeader = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function GetCbdSegm(FileNr, SegDict As SegmentDict, Segm As CbdSegment)

  On Local Error Resume Next

  Get #FileNr, SegDict.AbsAdr + 1&, Segm

  If Segm.AnzKoord > 0 Then
    If Err = 0 Then ReDim SegBuf(1 To SegDict.nbytes)
    If Err = 0 Then Get #FileNr, , SegBuf
  End If

  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then Call ShowErrNrFileNr(ErrNr, FileNr)

  GetCbdSegm = ErrNr

End Function

Function GetLong&(Ptr)

  b0 = SegBuf(Ptr)
  b1 = SegBuf(Ptr + 1)
  b2 = SegBuf(Ptr + 2)
  b3 = SegBuf(Ptr + 3)

  Neg = b1 And &H80
  If Neg Then
    b1 = b1 And &H7F
    b1 = b1 Or &H40
  End If

  LV& = ((b1 * 256& + b0) * 256& + b3) * 256& + b2

  If Neg Then LV& = LV& Or &H80000000
  GetLong& = LV&

End Function

Function GetShort(Ptr)

  GetShort = SegBuf(Ptr)

End Function

