Attribute VB_Name = "CmdApi"
DefInt A-Z

Function DDEDrawMap(Cmd$)

  Dim lNewArea As lAreaType

  If Len(Cmd$) = 0 Then

    Call NewMap

  Else

    ErrNr = DDEGetArea(Cmd$, lNewArea)
    If ErrNr = 0 Then ErrNr = CheckAreaLimits(lNewArea, ErrField)
    If ErrNr = 0 Then

      If HV.MapType < 2 Then
        'Vector-Map
        SavePar9& = NumPar(9).Actual
        SavePar46& = NumPar(46).Actual

        NumPar(46).Actual = NumPar(46).Actual Or MF_AutoMap

        If Len(Cmd$) > 0 Then
          NumPar(9).Actual = NumPar(9).Actual And Not _
            (ME_Towns Or ME_TownNames Or ME_Grid Or ME_GridNames _
            Or ME_Stn Or ME_StnCalls Or ME_Links)

          Select Case Val(Cmd$)
          Case 0        'ohne Stdte
          Case 1
            NumPar(9).Actual = NumPar(9).Actual Or ME_Towns
          Case 2
            NumPar(9).Actual = NumPar(9).Actual Or ME_Towns Or ME_TownNames
          End Select
        End If

        Call SelectMapArea(lNewArea, "")

        NumPar(9).Actual = SavePar9&
        NumPar(46).Actual = SavePar46&

      Else
        'Bitmap-Map
        SavePar9& = NumPar(9).Actual
        'SavePar46& = NumPar(46).Actual

        'NumPar(46).Actual = NumPar(46).Actual Or MF_AutoMap

        If Len(Cmd$) > 0 Then
          NumPar(9).Actual = NumPar(9).Actual And Not _
            (ME_Grid Or ME_GridNames Or ME_Stn Or ME_StnCalls Or ME_Links)
        End If

        Call SelectMapArea(lNewArea, "")

        NumPar(9).Actual = SavePar9&
        'NumPar(46).Actual = SavePar46&
      End If

    End If

  End If

  If ErrNr Then
    DDEDrawMap = -3
  Else
    DDEDrawMap = 0
  End If

End Function

Function DDEGetAnzStn(Cmd$, m$)

  DDEGetAnzStn = -2

  AnzFound = 0
  NoFilter = Val(Cmd$) = 0

  '1=Header, 2=erste Station
  For StnNr = 2 To SV.Out.StnHdr.AnzStnRec

    RecNr = GetStnIdx(StnNr)
    If (StnFlags(RecNr) And &HF0) = &HF0 Then
      'Gltige Station, QTH bekannt und im Ausschnitt
      ErrNr = GetStationQth(RecNr, x, y)
      If ErrNr Then Exit Function
      If x < 32767 Then
        If NoFilter Then
          AnzFound = AnzFound + 1
        Else
          If (StnFlags(RecNr) And &H7F00) = &H7F00 Then
            AnzFound = AnzFound + 1
          End If
        End If
      End If
    End If
  Next StnNr

  m$ = LTrim$(Str$(AnzFound))
  DDEGetAnzStn = 0

End Function

Function DDEGetLinkInfo(Cmd$, m$)

  'Aufruf: GetLinkInfo: Call1,Call2[,Mode]

  SrcCall$ = Parse$(Cmd$, ",")
  DstCall$ = Parse$(Cmd$, ",")
  Mode = Val(Cmd$)

  ErrNr = DDEFindLink(SrcCall$, DstCall$, SrcRec, DstRec, LnkRec)
  If ErrNr Then         'Ungueltiges Call / nicht gefunden
    DDEGetLinkInfo = ErrNr
    Exit Function
  End If

  Select Case Mode
  Case 0
    ErrNr = DecodeLink(ActLnkData, 0)
  Case 1
    ErrNr = DecodeLink(ActLnkData, 3)
  Case Else
    DDEGetLinkInfo = -3
    Exit Function
  End Select
  If ErrNr Then
    DDEGetLinkInfo = -2
    Exit Function
  End If

  m$ = ""

  For i = 3 To AnzLnkFields
    m$ = m$ + ", " + LF$(i)
  Next i

  m$ = Mid$(m$, 3)

  DDEGetLinkInfo = 0

End Function

Function DDEGetLinks(Cmd$, m$)

  'Aufruf: GetLinks: Call

  DDEGetLinks = -2

  CallSign$ = Parse$(Cmd$, ",")

  ErrNr = DDEFindStn(CallSign$, "0", SrcRec)
  If ErrNr > 2 Then         'Ungueltiges Call / nicht gefunden
    DDEGetLinks = ErrNr
    Exit Function
  End If

  ErrNr = GetAllLinkCalls(SrcRec, Val(Cmd$), m$)
  If ErrNr Then Exit Function

  DDEGetLinks = 0

End Function

Function DDEGetPar(CmdLine$, m$)

  DDEGetPar = 0

  Cmd$ = UCase$(Parse$(CmdLine$, ","))


  Select Case Cmd$
  Case "COLOR"
    ColNr = Val(CmdLine$)             'Farb-Nr.
    If ColNr < 0 Or ColNr > 15 Then
      DDEGetPar = -3
    Else
      Col& = HV.ColVal(ColNr)
      For i = 1 To 3
        Attr = Col& Mod 256
        Col& = Col& \ 256
        m$ = m$ + "," + Str$(Attr)
      Next i
      m$ = Mid$(m$, 3)
    End If

    Exit Function

  'Case "SYMBOL"

  'Case "MYAREA"

  Case Else

    '--- numerische Parameter ---
    For i = 1 To UBound(NumPar)
      If Cmd$ = UCase$(RTrim$(NumPar(i).Label)) Then
        m$ = Format$(NumPar(i).Actual, "0")
        Exit Function
      End If
    Next i

    '--- String Parameter ---
    For i = 1 To UBound(StrPar, 2)
      If Cmd$ = UCase$(StrPar(1, i)) Then
        m$ = StrPar(3, i)
        Exit Function
      End If
    Next i

  End Select

  DDEGetPar = -3

End Function

Function DDEGetRoute(Cmd$, m$)

  'Aufruf: GetRoute:Call1,Call2

  Dim Flags
  Static StnCall As StationCall

  DDEGetRoute = -2

  SrcCall$ = Parse$(Cmd$, ",")
  DstCall$ = UCase$(Parse$(Cmd$, ","))
  Flags = Val(Parse$(Cmd$, ","))
  NotViaStn$ = Cmd$

  'Source
  ErrNr = DDEFindStn(SrcCall$, "0", StartRec)
  'Ungueltiges Call / nicht gefunden
  DDEGetRoute = ErrNr
  If ErrNr > 2 Then Exit Function

  '--- Destination ---
  'Mailbox "MB" etc. oder normales Call
  EndRec = -FindStnAbv(2, DstCall$)
  If EndRec >= 0 Then
    ErrNr = DDEFindStn(DstCall$, "0", EndRec)
    'Ungueltiges Call / nicht gefunden
    DDEGetRoute = ErrNr
    If ErrNr > 2 Then Exit Function
  End If

  'Not via
  ErrNr = CheckNotVia(NotViaStn$, NotViaRec$)
  DDEGetRoute = 3
  If ErrNr Then Exit Function


  '--- Route suchen ---
  If Flags And 2 Then Call ShowFound(0)

  Fastest = Flags And 1
  ErrNr = FindRoute(Fastest, StartRec, EndRec, NotViaRec$, RouteFound)
  If ErrNr = 0 And RouteFound Then
    '--- Route gefunden ---
    If Flags And 2 Then
      ErrNr = ShowRoute(Fastest, EndRec)
      If ErrNr = 0 Then
        Call ShowFound(2)
        If Flags And 4 Then Call DrawFound(2)
      End If
    End If

    '--- Route-Calls speichern ---
    m$ = GetRouteCalls$(EndRec)

    DDEGetRoute = 0
  Else
    DDEGetRoute = 6
  End If

  '--- Speicher freigeben ---
  Call EraseRoutes

End Function

Sub DDEGetSize(m$)

  'Return in cm:
  '  MapWidth, MapHeight, FormWidth, FormHeight, PrintWidth, PrintHeight

  f$ = "0.00"

  'Kartengroesse (incl. Rahmen)
  w! = HMCrt.FrameWidth / HMCrt.DpiX * 2.54
  h! = HMCrt.FrameHeight / HMCrt.DpiY * 2.54

  m$ = Unformat$(Format$(w!, f$)) + ", "
  m$ = m$ & Unformat$(Format$(h!, f$)) + ", "


  'Windowgroesse
  With MapForm
    .ScaleMode = 7    'cm
    w! = .ScaleWidth
    h! = .ScaleHeight
    .ScaleMode = 3    'Pixel
  End With

  m$ = m$ & Unformat$(Format$(w!, f$)) + ", "
  m$ = m$ & Unformat$(Format$(h!, f$)) + ", "


  'Drucker
  m$ = m$ & Unformat$(Format$(NumPar(16).Actual / 1000!, f$)) + ", "
  m$ = m$ & Unformat$(Format$(NumPar(15).Actual / 1000!, f$))

End Sub

Function DDEGetStn(Cmd$, m$)

  Static StnNr
  Static SearchNr
  Static FoundNr
  Dim Stn As StationData

  DDEGetStn = -2

  Search$ = Parse$(Cmd$, ",")
  NoFilter = Val(Cmd$) = 0

  If Len(Search$) = 0 Then
    SearchNr = SearchNr + 1
  Else
    NewNr = Val(Search$)
    If NewNr <> SearchNr + 1 Then
      FoundNr = 0
      StnNr = 0
    End If
    SearchNr = NewNr
  End If

  m$ = ""

  Do Until StnNr = SV.Out.StnHdr.AnzStnRec - 1
    StnNr = StnNr + 1
    '1=Header, 2=erste Station
    RecNr = GetStnIdx(StnNr + 1)

    If (StnFlags(RecNr) And &HF0) = &HF0 Then
      'Gltige Hauptzeile, QTH bekannt und im Ausschnitt
      ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)

      If NoFilter Then
        Ok = True
      Else
        Ok = (StnFlags(RecNr) And &H7F00) = &H7F00
      End If

      If Ok Then
        FoundNr = FoundNr + 1
        If FoundNr = SearchNr Then
          Call DecodeCall(Stn.StnCall, m$, LineNr$)
          Exit Do
        End If
      End If
    End If
  Loop

  DDEGetStn = 0

End Function

Function DDEGetStnInfo(Cmd$, m$)

  'Aufruf: GetStnInfo: Call,[[LineNr],Mode]

  DDEGetStnInfo = -2

  StnCall$ = Parse$(Cmd$, ",")
  LineNr$ = Parse$(Cmd$, ",")
  If Len(LineNr$) = 0 Then LineNr$ = "0"
  Mode = Val(Cmd$)

  ErrNr = DDEFindStn(StnCall$, LineNr$, RecNr)
  If ErrNr > 2 Then         'Ungueltiges Call / nicht gefunden
    DDEGetStnInfo = ErrNr
    Exit Function
  End If

  ErrNr = GetStationData(SV.Out.BsdFile, RecNr, ActStnData)
  If ErrNr Then Exit Function

  ErrNr = GetStationInfo(SV.Out.BstFile, ActStnData, ActQTH, ActInfo)
  If ErrNr Then Exit Function

  Select Case Mode
  Case 0
    Call DecodeStation(ActStnData, ActQTH, ActInfo, 0)
  Case 1
    Call DecodeStation(ActStnData, ActQTH, ActInfo, 3)
  Case Else
    DDEGetStnInfo = -3
    Exit Function
  End Select

  m$ = ""

  For i = 1 To AnzStnFields
    m$ = m$ + ", " + SF$(i)
  Next i

  m$ = Pc8toAnsi$(Mid$(m$, 3))

  DDEGetStnInfo = 0

End Function

Function DDEGetStnLines(Cmd$, m$)

  'Aufruf: GetStnLines: Call

  DDEGetStnLines = -2

  ErrNr = DDEFindStn(Cmd$, "0", RecNr)
  If ErrNr > 2 Then         'Ungueltiges Call / nicht gefunden
    DDEGetStnLines = ErrNr
    Exit Function
  End If

  ErrNr = GetStnLineNrs(RecNr, m$)
  If ErrNr Then Exit Function

  DDEGetStnLines = 0

End Function

Function DDEPrintMap(Cmd$)

  Dim lNewArea As lAreaType

  DDEPrintMap = -3

  If Len(Cmd$) = 0 Then
    ErrNr = InitPrint(2)
    If ErrNr = 0 Then
      Call NewMap
      Call TerminatePrint
    End If
  Else
    ErrNr = DDEGetArea(Cmd$, lNewArea)
    If ErrNr Then Exit Function
    ErrNr = CheckAreaLimits(lNewArea, ErrField)
    If ErrNr Then Exit Function
    ErrNr = InitPrint(2)
    If ErrNr = 0 Then
      Call SelectMapArea(lNewArea, "")
      Call TerminatePrint
    End If
  End If

  If ErrNr = 0 Then
    DDEPrintMap = 0
  Else
    DDEPrintMap = -2      'I/O-Error
  End If

End Function

Function NonOvlCommand(Fkt$, Cmd$, m$)

  'Functions that are not allowed in Overlays

  Select Case Fkt$
  Case "DRAWMAP"
    ErrNr = DDEDrawMap(Cmd$)

  Case "COPYMAP"
    Call CopyMapToClipboard(1)

  Case "PRINTMAP"
    ErrNr = DDEPrintMap(Cmd$)

  Case "STARTPRINT"
    Mode = 3    'Default
    If Len(Cmd$) > 0 Then Mode = Val(Cmd$)
    Mode = Mode Or 2       'Make sure 2 is set
    ErrNr = InitPrint(Mode)
    If ErrNr Then ErrNr = -2    'I/O-Error

  Case "STOPPRINT"
    Call TerminatePrint

  Case "GETANZSTN"
    ErrNr = DDEGetAnzStn(Cmd$, m$)

  Case "GETSTN"
    ErrNr = DDEGetStn(Cmd$, m$)

  Case "GETSTNINFO"
    ErrNr = DDEGetStnInfo(Cmd$, m$)

  Case "GETSTNLINES"
    ErrNr = DDEGetStnLines(Cmd$, m$)

  Case "GETLINKS"
    ErrNr = DDEGetLinks(Cmd$, m$)

  Case "GETROUTE"
    ErrNr = DDEGetRoute(Cmd$, m$)

  Case "GETLINKINFO"
    ErrNr = DDEGetLinkInfo(Cmd$, m$)

  Case "GETSTNABV"
    n = Val(Cmd$)
    If n >= 1 And n <= UBound(StnAbv) Then
      m$ = StnAbv(n)
    Else
      ErrNr = -3
    End If

  Case "GETSIZE"
    Call DDEGetSize(m$)

  Case "GETCOORD"
    m$ = lArea2Str$(MV.ActMapArea)

  Case "GETPAR"
    ErrNr = DDEGetPar(Cmd$, m$)

  Case "GETMSG"
    m$ = Msg$(Val(Cmd$))

  Case "GETMSGFILE"
    m$ = MsgFile$

  Case "GETHLPFILE"
    m$ = HlpFile$

  Case "GETPARFILE"
    m$ = InParFile$

  Case "GETVER"
    m$ = ApiVer$

  Case "TEST"
    m$ = Cmd$

  '--- Neu ab Version 8.0 ---
  Case "KILLPRINT"
    If Overlay Then Exit Function
    Call AbortPrint

  '--- Neu ab Version 8.0 ---
  Case "GETHAMMAPDIR"
    m$ = HomeDir$

  Case "GETMAPFILE"
    m$ = StrPar(3, 6)

  Case "LOADMAPFILE"
    Call ParseFileSpec(Cmd$, mapd$, mapp$, mapn$, mape$)
    StrPar(3, 6) = HomeDir$ & "MAP\" & mapn$ & ".BMD"
    NumPar(46).Actual = NumPar(46).Actual And Not MF_AutoMap
    ErrNr = LoadMapFile()
    If ErrNr = 0 Then
      Call NewMap
    Else
      ErrNr = -3
    End If

  Case "GETMAXCOORD"
    m$ = lArea2Str$(MV.MaxMapArea)

  '--- Neu ab Version 10.2 ---
  Case "GETMAPTYPE"
    '0=none, 1=Vector, 2=BMP, 3=RLE
    m$ = CStr(HV.MapType)

  Case Else
    ErrNr = -4
  End Select

  NonOvlCommand = ErrNr

End Function

