Attribute VB_Name = "CmdOvl"
'--------------------------- CMDOVL_W.BAS ------------------------------
'Unterprogramme zu HAMMAP
'DDE-Interface Routinen
'von Gerhard Berg, DJ6FM

DefInt A-Z

'

Function ApiCommand(Overlay, CmdStr$, Result$)

  m$ = ""
  ErrNr = 0

  Cmd$ = CmdStr$
  Fkt$ = UCase$(Parse$(Cmd$, ":"))
  If Left$(Fkt$, 1) = ";" Then Fkt$ = "NOOP"

  Select Case Fkt$
  Case "DRAWFIGURE"
    ErrNr = DDEDrawFigure(Cmd$)

  Case "DRAWSHAPE"
    ErrNr = DDEDrawShape(Cmd$)

  Case "DRAWLINE"
    ErrNr = DDEDrawLine(Cmd$)

  Case "DRAWSYMBOL"
    ErrNr = DDEDrawSymbol(Cmd$)

  Case "DRAWTEXT"
    ErrNr = DDEDrawText(Cmd$)

  Case "DRAWSTN"
    ErrNr = DDEDrawStn(Cmd$, 1)

  Case "MARKSTN"
    ErrNr = DDEDrawStn(Cmd$, 2)

  Case "DRAWSTNS"
    Mode = Val(Cmd$)
    ErrNr = DrawAllStations(1, AnzStn)
    If ErrNr = 0 And Mode = 1 Then
      ErrNr = DrawAllStations(2, AnzStn)
    End If
    If ErrNr Then ErrNr = -5

  Case "DRAWLINK"
    ErrNr = DDEDrawLink(Cmd$)

  Case "DRAWLINKS"
    ErrNr = DrawAllLinks(AnzLnk)
    If ErrNr Then ErrNr = -5

  Case "DRAWGRID"
    Size = Val(Parse$(Cmd$, ","))
    If Len(Cmd$) = 0 Then
      If NumPar(9).Actual And ME_GridNames Then
        MarkMode = 2
      Else
        MarkMode = 0
      End If
    Else
      MarkMode = Val(Cmd$)
    End If
    ErrNr = ShowGrid(Size, MarkMode, False)

  Case "SETPAR"
    ErrNr = ProcessParameter(UCase$(Cmd$))

  Case "SELSTN"         'Select Station
    ErrNr = DDESelStn(Cmd$)

  Case "NOOP"

  Case "STOREMAP"
    void = StoreMap(0&)

  Case "RESTOREMAP"
    void = RestoreMap(0, 0)

  Case Else
    If Overlay Then
      ErrNr = -4
    Else
      ErrNr = NonOvlCommand(Fkt$, Cmd$, m$)
    End If
  End Select

  If (NumPar(35).Actual And 128) = 0 Then void = DoEvents()

  If ErrNr Then
    If Overlay And ErrNr < 0 And Not HV.OvlErrFlag Then
      HV.OvlErrFlag = True      'Fehler nur einmal anzeigen
      m$ = Msg$(24024) & " - " & Msg$(25110 + ErrNr) & ": '" & CmdStr$ & "'"
      GV.NoShowError = False
      Call FileError(m$, "")
      GV.NoShowError = True
    End If

    m$ = Format$(ErrNr)
  End If

  Result$ = m$
  ApiCommand = ErrNr

End Function

Function ApiCommandList(Overlay, ByVal CmdStr$, Result$)

  GV.NoShowError = True

  ErrNr = 0
  Result$ = ""
  ApiCommandList = 0

  Cmd$ = Extract$(1, CmdStr$, vbCrLf, EOS)    'Set and extract

  Do
    If Len(Cmd$) = 0 Then
      ErrNr = 0
      Res$ = ""
    Else
      ErrNr = ApiCommand(Overlay, Cmd$, Res$)
      If ErrNr Then Res$ = CStr(ErrNr)
      If ErrNr < 0 Then ApiCommandList = ErrNr
    End If

    On Error Resume Next
    Result$ = Result$ & vbCrLf & Res$
    PrgErr = Err
    On Error GoTo 0

    If PrgErr Then
      ErrNr = -5
      Result$ = vbCrLf & "-5"
    End If

    Cmd$ = Extract$(0, "", vbCrLf, EOS)
  Loop Until ErrNr < 0 Or EOS

  GV.NoShowError = False

  Result$ = Mid$(Result$, 3)

End Function

Function DDEDrawFigure(Cmd$)

  Dim a As lAreaType
  Dim NewPen As HMPen

  DDEDrawFigure = -3

  '--- Koordinaten ---
  ErrNr = DDEGetArea(Cmd$, a)
  If ErrNr Then Exit Function


  '--- Figure ---
  FigNr = Val(Parse$(Cmd$, ","))

  Select Case FigNr
  Case 0 To 5, 10 To 16
  Case Else
    Exit Function
  End Select


  '--- ForeGround-Color ---
  Col$ = Parse$(Cmd$, ",")
  If Len(Col$) = 0 Then
    NewPen.Color = 0&
  Else
    NewPen.Color = DDEGetCol&(Col$)
    If NewPen.Color = -1 Then Exit Function
  End If


  '--- Fill-Color ---
  Col$ = Parse$(Cmd$, ",")
  If Len(Col$) = 0 Then
    FillCol& = 0
    FillStyle = 1
  Else
    FillCol& = DDEGetCol&(Col$)
    If NewPen.Color = -1 Then Exit Function
    FillStyle = 0
  End If


  '--- Width ---
  Wid$ = Parse$(Cmd$, ",")
  If Len(Wid$) = 0 Then
    NewPen.Width = 1
  Else
    NewPen.Width = Val(Wid$)
    If NewPen.Width < 1 Then Exit Function
  End If


  '--- Draw-Style ---
  Style$ = Parse$(Cmd$, ",")
  If Len(Style$) = 0 Then
    NewPen.Style = 0
  Else
    NewPen.Style = Val(Style$)
    If NewPen.Style < 0 Or NewPen.Style > 6 Then Exit Function
  End If


  '--- Fill-Style ---
  If Len(Cmd$) > 0 Then
    FillStyle = Val(Cmd$)
    If FillStyle < 0 Or FillStyle > 1 Then Exit Function
  End If


  '--- Draw Figure ---
  If AreaInArea(1, a, MV.ActMapArea) Then
    ErrNr = DrawSingleFigure(a, FigNr, NewPen, FillCol&, FillStyle, 0)
    DDEDrawFigure = 0
  Else
    DDEDrawFigure = 1    'Object not in Area
  End If

End Function

Function DDEDrawLine(Cmd$)

  Dim a As lAreaType
  Dim NewPen As HMPen

  DDEDrawLine = -3

  '--- Koordinaten ---
  ErrNr = DDEGetArea(Cmd$, a)
  If ErrNr Then Exit Function

  ErrNr = DDEGetPen(Cmd$, NewPen)
  If ErrNr Then Exit Function

  ErrNr = DrawSingleFigure(a, 2, NewPen, 0&, 0, 0)

  DDEDrawLine = 0

End Function

Function DDEDrawLink(Cmd$)

  'Aufruf: DrawLink: Call1,Call2[,Color,Pattern]

  Dim NewPen As HMPen

  SrcCall$ = Parse$(Cmd$, ",")
  DstCall$ = Parse$(Cmd$, ",")


  ErrNr = DDEFindLink(SrcCall$, DstCall$, SrcRec, DstRec, LnkRec)
  If ErrNr Then         'Ungueltiges Call / nicht gefunden
    DDEDrawLink = ErrNr
    Exit Function
  End If

  If Len(Cmd$) = 0 Then

    ErrNr = PrepareMapDevices(1)
    If ErrNr = 0 Then
      ErrNr = DrawOneLink()
    End If
    void = TerminateAllDevices()

    If ErrNr Then
      DDEDrawLink = -2
      Exit Function
    End If

  Else

    ErrNr = DDEGetPen(Cmd$, NewPen)
    If ErrNr Then
      DDEDrawLink = -3
      Exit Function
    End If

    ErrNr = PrepareMapDevices(1)
    If ErrNr = 0 Then
      ErrNr = DrawLinkLine(SrcRec, DstRec, NewPen, NewPen)
    End If
    void = TerminateAllDevices()

    If ErrNr Then
      DDEDrawLink = -2
      Exit Function
    End If

  End If

  DDEDrawLink = 0

End Function

Function DDEDrawShape(Cmd$)

  Dim a As lAreaType
  Dim NewPen As HMPen

  DDEDrawShape = -3

  '--- Koordinaten ---
  ErrNr = DDEGetArea(Cmd$, a)
  If ErrNr Then Exit Function

  '--- Color ---
  NewPen.Color = DDEGetCol&(Parse$(Cmd$, ","))
  If NewPen.Color = -1 Then Exit Function

  '--- Shape ---
  Shape = Val(Parse$(Cmd$, ","))

  '--- Width ---
  If Len(Cmd$) = 0 Then
    NewPen.Width = 1
  Else
    NewPen.Width = Val(Cmd$)
    If NewPen.Width < 1 Then Exit Function
  End If


  '--- Draw Figure ---
  If AreaInArea(1, a, MV.ActMapArea) Then
    Select Case Shape
    Case 0      'Linie
      ErrNr = DrawSingleFigure(a, 2, NewPen, 0&, 0, 0)


    Case 1      'schrges Kreuz
      ErrNr = DrawSingleFigure(a, 4, NewPen, 0&, 0, 0)


    Case 3      'leeres Rechteck
      ErrNr = DrawSingleFigure(a, 11, NewPen, 0&, 1, 0)


    Case 4      'ausgeflltes Rechteck
      ErrNr = DrawSingleFigure(a, 11, NewPen, NewPen.Color, 0, 0)


    Case 10      'leerer Kreis
      ErrNr = DrawSingleFigure(a, 10, NewPen, 0&, 1, 0)

    Case 11      'ausgefllter Kreis
      ErrNr = DrawSingleFigure(a, 10, NewPen, NewPen.Color, 0, 0)

    Case Else
      Exit Function
    End Select

    DDEDrawShape = 0
  Else
    DDEDrawShape = 1    'Object not in Area
  End If

End Function

Function DDEDrawStn(Cmd$, Mode)

  Dim Stn As StationData

  DDEDrawStn = -2

  StnCall$ = Parse$(Cmd$, ",")

  ErrNr = DDEFindStn(StnCall$, "0", StnRec)
  If ErrNr Then
    DDEDrawStn = ErrNr
    Exit Function
  End If

  ErrNr = GetStationData(SV.Out.BsdFile, StnRec, Stn)
  If ErrNr Then Exit Function

  Col$ = Parse$(Cmd$, ",")
  If Len(Col$) = 0 Then
    ForeCol& = HV.ColVal(StnColor(Stn.Software))
  Else
    ForeCol& = DDEGetCol&(Col$)
    If ForeCol& = -1 Then Exit Function
  End If

  xgeo& = CLng(Stn.xloc) * clQth2Sec
  ygeo& = CLng(Stn.yloc) * clQth2Sec

  ErrNr = PrepareMapDevices(9)

  If Mode And 1 Then
    ActSym = StnSym(Stn.StnTyp).Actual
    If HV.PrtEnbl And 1 Then
      ErrNr = DrawSymbolGeo(HMCrt, xgeo&, ygeo&, ActSym, ForeCol&)
    End If
    If HV.PrtEnbl And 2 Then
      ErrNr = DrawSymbolGeo(HMPrt, xgeo&, ygeo&, ActSym, ForeCol&)
    End If
  End If

  If Mode And 2 Then
    sc$ = Parse$(Cmd$, ",")
    If Len(sc$) = 0 Then sc$ = MarkStnCall$(Stn)
    If HV.PrtEnbl And 1 Then
      Call DrawNameGeo(HMCrt, xgeo&, ygeo&, sc$, StnRec, ForeCol&)
    End If
    If HV.PrtEnbl And 2 Then
      Call DrawNameGeo(HMPrt, xgeo&, ygeo&, sc$, StnRec, ForeCol&)
    End If
  End If

  ErrNr = TerminateAllDevices()

  DDEDrawStn = 0

End Function

Function DDEDrawSymbol(Cmd$)

  DDEDrawSymbol = -3

  '--- Position ---
  Qth$ = Parse$(Cmd$, ",")
  ErrNr = Qth2lMsecCoord(Qth$, xm&, ym&)
  If ErrNr = 0 Then
    xgeo& = xm& / 1000
    ygeo& = ym& / 1000
  Else
    'it was not a valid QTH-Locator - try Longitude and Latitude
    xgeo& = Val(Qth$) * cfDeg2Sec
    ygeo& = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
  End If

  '--- Color ---
  Col$ = Parse$(Cmd$, ",")
  ForeCol& = DDEGetCol&(Col$)
  If ForeCol& = -1 Then Exit Function


  '--- Symbol ---
  Symbol = Val(Parse$(Cmd$, ","))
  If Symbol < 0 Or Symbol > 13 Then Exit Function


  ErrNr = PrepareMapDevices(9)

  '--- Symbol ausgeben ---
  If HV.PrtEnbl And 1 Then
    ErrNr = DrawSymbolGeo(HMCrt, xgeo&, ygeo&, Symbol, ForeCol&)
  End If
  If HV.PrtEnbl And 2 Then
    ErrNr = DrawSymbolGeo(HMPrt, xgeo&, ygeo&, Symbol, ForeCol&)
  End If

  '--- Text ---
  If Len(Cmd$) > 0 Then
    If HV.PrtEnbl And 1 Then
      Call DrawNameGeo(HMCrt, xgeo&, ygeo&, Cmd$, 0, ForeCol&)
    End If
    If HV.PrtEnbl And 2 Then
      Call DrawNameGeo(HMPrt, xgeo&, ygeo&, Cmd$, 0, ForeCol&)
    End If
  End If

  ErrNr = TerminateAllDevices()

  DDEDrawSymbol = 0

End Function

Function DDEDrawText(Cmd$)

  Dim a As lAreaType
  Dim NewFont As HMFont

  DDEDrawText = -3

  '--- Position ---
  a.lxmin = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
  a.lymin = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
  a.lxmax = a.lxmin
  a.lymax = a.lymin


  '--- Color ---
  ForeCol& = DDEGetCol&(Parse$(Cmd$, ","))
  If ForeCol& = -1 Then Exit Function


  '--- Schriftgroesse ---
  NewFontSize$ = Parse$(Cmd$, ",")
  Txt$ = Cmd$

  NewFont.Angle = 0
  NewFont.Attr = 0


  '--- Text ausgeben ---
  ErrNr = PrepareMapDevices(1)

  If HV.PrtEnbl And 1 Then
    '--- Bildschirm-Ausgabe ---
    If Len(NewFontSize$) = 0 Then
      NewFont.Size = NumPar(36).Actual / 1000
      NewFont.Name = StrPar(3, 8)
    Else
      NewFont.Size = Val(NewFontSize$)
      If NewFont.Size < 8 Then
        NewFont.Name = "Small Fonts"
      Else
        NewFont.Name = "Arial"
      End If
    End If

    ErrNr = DrawTextGeo(HMCrt, a, Txt$, 0, NewFont, ForeCol&)
  End If


  If HV.PrtEnbl And 2 Then
    '--- Drucker-Ausgabe ---
    If Len(NewFontSize$) = 0 Then
      NewFont.Size = NumPar(38).Actual
      NewFont.Name = StrPar(3, 9)
    Else
      NewFont.Size = Val(NewFontSize$)
      If NewFont.Size < 8 Then
        NewFont.Name = "Small Fonts"
      Else
        NewFont.Name = "Arial"
      End If
    End If

    ErrNr = DrawTextGeo(HMPrt, a, Txt$, 0, NewFont, ForeCol&)
  End If

  ErrNr = TerminateAllDevices()


  DDEDrawText = 0

End Function

Function DDEFindLink(SrcCall$, DstCall$, SrcRec, DstRec, LnkRec)

  DDEFindLink = -2

  ErrNr = DDEFindStn(SrcCall$, "0", SrcRec)
  If ErrNr > 2 Then         'Ungueltiges Call / nicht gefunden
    DDEFindLink = ErrNr
    Exit Function
  End If

  ErrNr = GetStationData(SV.Out.BsdFile, SrcRec, ActStnData)
  If ErrNr Then Exit Function

  LnkRec = ActStnData.LnkPtr

  Do Until LnkRec = 0

    '--- Link-Partner und naechsten Link bestimmen ---
    ErrNr = GetNextLink(LnkRec, NextLink, SrcRec, DstRec, ActLnkData)
    If ErrNr Then Exit Function

    '--- Pruefen, dass aktueller Link nicht geloescht ---
    If ActLnkData.LnkDate < 32767 Then
      ErrNr = GetStationData(SV.Out.BsdFile, DstRec, ActStnData)
      If ErrNr Then Exit Function
      Call DecodeCall(ActStnData.StnCall, OutCall$, LineNr$)
      If OutCall$ = UCase$(DstCall$) Then
        'Destination gefunden
        DDEFindLink = 0
        Exit Function
      End If
    End If
    LnkRec = NextLink
  Loop

  DDEFindLink = 5     'Link not found

End Function

Function DDEFindStn(StnCall$, LineNr$, RecNr)

  Dim FindCall As StationCall

  DDEFindStn = -2

  ErrNr = EncodeCall(1, StnCall$, LineNr$, FindCall)
  If ErrNr Then
    DDEFindStn = 4                 'Ungueltiges Call
    Exit Function
  End If

  ErrNr = FindStation(FindCall, StnNr, RecNr, Found, Deleted)
  If ErrNr Then Exit Function

  If Not Found Or Deleted Then
    DDEFindStn = 3                 'Nicht gefunden
    Exit Function
  End If

  ErrNr = GetStationData(SV.Out.BsdFile, RecNr, ActStnData)
  If ErrNr Then Exit Function


  If (NumPar(41).Actual And 1) = 0 Then
    If (StnFlags(RecNr) And &H40) = 0 Then
      DDEFindStn = 2             'QTH unbekannt
      Exit Function
    ElseIf (StnFlags(RecNr) And &H80) = 0 Then
      DDEFindStn = 1             'QTH nicht im Ausschnitt
      Exit Function
    End If
  End If

  DDEFindStn = 0

End Function

Function DDEGetArea(Cmd$, a As lAreaType)

  'Cmd$ wird verndert!

  With a
    Qth$ = Parse$(Cmd$, ",")
    ErrNr = Qth2lSecArea(Qth$, .lxmin, .lymin, .lxmax, .lymax)

    If ErrNr Then
      'it was not a valid QTH-Locator - try Longitude and Latitude
      On Error Resume Next
      .lxmin = Val(Qth$) * cfDeg2Sec
      .lymin = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
      .lxmax = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
      .lymax = Val(Parse$(Cmd$, ",")) * cfDeg2Sec
      ErrNr = Err
      On Error GoTo 0
    End If
  End With

  DDEGetArea = ErrNr

End Function

Function DDEGetCol&(Col$)

  If Len(Col$) = 0 Then
    DDEGetCol& = HV.ForeCol
  ElseIf Len(Col$) <= 2 Then
    Farbe = Val(Col$)
    If Farbe < 0 Or Farbe > 15 Then
      DDEGetCol& = -1
    Else
      DDEGetCol& = HV.ColVal(Farbe)
    End If
  Else
    DDEGetCol& = Val("&H" & Col$ & "&")
  End If

End Function

Function DDEGetPen(Cmd$, NewPen As HMPen)

  DDEGetPen = -3

  '--- Color ---
  NewPen.Color = DDEGetCol&(Parse$(Cmd$, ","))
  If NewPen.Color = -1 Then Exit Function

  '--- Pattern ---
  NewPen.Style = Val(Parse$(Cmd$, ","))
  If NewPen.Style < 0 Or NewPen.Style > 6 Then Exit Function

  '--- Width ---
  If Len(Cmd$) = 0 Then
    NewPen.Width = 1
  Else
    NewPen.Width = Val(Cmd$)
    If NewPen.Width < 1 Then Exit Function
  End If

  DDEGetPen = 0

End Function

Function DDESelStn(Cmd$)

  If Len(Cmd$) = 0 Then
    '--- keine Station ---
    Call DeselectStation
    ErrNr = 0

  Else
    '--- Station selektieren ---
    ErrNr = DDEFindStn(Cmd$, "0", RecNr)
    If ErrNr = 0 Then
      ErrNr = SelectStation(RecNr, False)
      If ErrNr Then ErrNr = -2
    End If
  End If

  DDESelStn = ErrNr

End Function

Sub ExecOverlay(OvlType)

  Select Case OvlType
  Case 1
    If Len(ForeOverlay$) > 0 Then
      ErrNr = PrepareMapDevices(9)
      HV.ExecOverlay = True
      void = ApiCommandList(True, ForeOverlay$, Res$)
      HV.ExecOverlay = False
      ErrNr = TerminateAllDevices()
    End If
  Case 2
    If Len(BackOverlay$) > 0 Then
      ErrNr = PrepareMapDevices(9)
      HV.ExecOverlay = True
      void = ApiCommandList(True, BackOverlay$, Res$)
      HV.ExecOverlay = False
      ErrNr = TerminateAllDevices()
    End If
  End Select

End Sub

Sub LoadOverlay(Title$)

  Static IniDir$

  If Len(IniDir$) = 0 Then IniDir$ = HomeDir$ & "MAP"
  Filt$ = "HAMMAP Overlay (*.HMO)|*.HMO"

  'Flags: Shareware(?) + FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
  Cancel = GetFileSpec(Title$, 1, &H580C&, IniDir$, Ucase16$("hmo"), Filt$, FileSpec$)
  If Cancel Then Exit Sub                  'Abbruch

  ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
  If ErrNr Then Exit Sub

  Do Until EOF(FileNr)
    ErrNr = ReadLine(FileNr, Cmd$)
    If ErrNr Then Exit Do
    ErrNr = ServerCommand(False, Cmd$, "File", Res$)
    'If ErrNr Then Stop
  Loop

  void = CloseFile(FileNr)

End Sub

Sub SaveOverlay(Title$)

  Static IniDir$

  If Len(IniDir$) = 0 Then IniDir$ = HomeDir$ & "MAP"
  Filt$ = "HAMMAP Overlay (*.HMO)|*.HMO"

  'Flags: PathMustExist + NoChangeDir + HideReadOnly + OverwritePrompt
  Cancel = GetFileSpec(Title$, 2, &H80E&, IniDir$, Ucase16$("hmo"), Filt$, FileSpec$)
  If Cancel Then Exit Sub                  'Abbruch

  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr Then Exit Sub

  ErrNr = WriteLine(FileNr, "Overlay: -1")
  If Len(ForeOverlay$) > 0 Then
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "Overlay: 1," & OverlayInfo$)
    If ErrNr = 0 Then ErrNr = WriteString(FileNr, ForeOverlay$)
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "Overlay: 0")
  End If
  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "")

  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "Overlay: -2")
  If Len(BackOverlay$) > 0 Then
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "Overlay: 2," & OverlayInfo$)
    If ErrNr = 0 Then ErrNr = WriteString(FileNr, BackOverlay$)
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "Overlay: 0")
  End If
  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "DrawMap: " & lArea2Str(MV.ActMapArea))

  void = CloseFile(FileNr)

End Sub

