Attribute VB_Name = "CODECVT"
'---------------------------- CODECVT.BAS ----------------------------

'Code-Konvertierungs-Unterprogramme (fuer Windows)
'von Gerhard Berg, DJ6FM

DefInt A-Z
Option Explicit

Function Ansi8ToAscii7dl$(ByVal Ansi$, BadChar)

  Dim i As Long
  Dim lot As Long
  Dim Ascii$, r$

  BadChar = False
  Ascii$ = Ansi$

  For i = 1 To Len(Ascii$)

    r$ = ""

    Select Case Asc(Mid$(Ascii$, i, 1))
    Case 0 To 90, 94 To 122, 127
    Case 196: r$ = "["            '
    Case 214: r$ = "\"            '
    Case 220: r$ = "]"            '
    Case 228: r$ = "{"            '
    Case 246: r$ = "|"            '
    Case 252: r$ = "}"            '
    Case 223: r$ = "~"            '
    Case Else                     'ungueltiges Zeichen
      r$ = "."
      BadChar = True
    End Select

    If Len(r$) Then Mid$(Ascii$, i) = r$

  Next i

  Ansi8ToAscii7dl$ = Ascii$

End Function

Function Ansi8ToAscii7us$(ByVal Ansi$, BadChar)

  Dim i As Long
  Dim lot As Long
  Dim Ascii$, r$

  Ascii$ = Ansi$

  lot = Len(Ascii$)
  i = 1

  Do
    r$ = ""

    Select Case Asc(Mid$(Ascii$, i, 1))
    Case 0 To 90, 94 To 122, 127
    Case 196: r$ = "Ae"           '
    Case 214: r$ = "Oe"           '
    Case 220: r$ = "Ue"           '
    Case 228: r$ = "ae"           '
    Case 246: r$ = "oe"           '
    Case 252: r$ = "ue"           '
    Case 223: r$ = "ss"           '
    Case Else                     'ungltiges Zeichen
      BadChar = True
      Mid$(Ascii$, i) = "."
    End Select

    If Len(r$) Then
      Ascii$ = Left$(Ascii$, i - 1) + r$ + Mid$(Ascii$, i + 1)
      i = i + 1
      lot = lot + 1
    End If

    i = i + 1
  Loop Until i > lot

  Ansi8ToAscii7us$ = Ascii$

End Function

Function Ansi8ToHTML$(ByVal Ansi$)

  Dim i As Long
  Dim lot As Long, lr As Long
  Dim Html$, r$

  Html$ = Ansi$

  lot = Len(Html$)
  i = 1

  Do
    r$ = ""

    Select Case Asc(Mid$(Html$, i, 1))
    Case 196: r$ = "&Auml;"           '
    Case 214: r$ = "&Ouml;"           '
    Case 220: r$ = "&Uuml;"           '
    Case 228: r$ = "&auml;"           '
    Case 246: r$ = "&ouml;"           '
    Case 252: r$ = "&uuml;"           '
    Case 223: r$ = "&szlig;"           '
    End Select

    lr = Len(r$)
    If lr Then
      Html$ = Left$(Html$, i - 1) + r$ + Mid$(Html$, i + 1)
      i = i + lr
      lot = lot + lr - 1
    Else
      i = i + 1
    End If

  Loop Until i > lot

  Ansi8ToHTML$ = Html$

End Function

Function Ascii7DLToAnsi8$(Ascii$, BadChar)

  Dim i As Long
  Dim lot As Long
  Dim Ansi$, r

  Ansi$ = Ascii$
  BadChar = False

  For i = 1 To Len(Ansi$)

    Select Case Asc(Mid$(Ansi$, i, 1))
    Case 91: r = 196             '
    Case 92: r = 214             '
    Case 93: r = 220             '
    Case 123: r = 228            '
    Case 124: r = 246            '
    Case 125: r = 252            '
    Case 126: r = 223            '
    Case 128 To 255
      r = Asc(".")
      BadChar = True
    Case Else: r = 0
    End Select

    If r Then Mid$(Ansi$, i, 1) = Chr$(r)

  Next i

  Ascii7DLToAnsi8$ = Ansi$

End Function

Function Ascii7USToAnsi8$(Ascii$, BadChar)

  Dim i As Long
  Dim lot As Long
  Dim Ansi$, r

  Ansi$ = Ascii$
  BadChar = False

  For i = 1 To Len(Ansi$)

    Select Case Asc(Mid$(Ansi$, i, 1))
    Case 0 To 127: r = 0
    Case Else
      r = Asc(".")
      BadChar = True
    End Select

    If r Then Mid$(Ansi$, i, 1) = Chr$(r)

  Next i

  Ascii7USToAnsi8$ = Ansi$

End Function

Function HTMLToAnsi8$(Html$)

  Dim Ansi$

  Ansi$ = Html$

  Ansi$ = Replace$(Ansi$, "&Auml;", "")
  Ansi$ = Replace$(Ansi$, "&Ouml;", "")
  Ansi$ = Replace$(Ansi$, "&Uuml;", "")
  Ansi$ = Replace$(Ansi$, "&auml;", "")
  Ansi$ = Replace$(Ansi$, "&ouml;", "")
  Ansi$ = Replace$(Ansi$, "&uuml;", "")
  Ansi$ = Replace$(Ansi$, "&szlig;", "")

  HTMLToAnsi8$ = Ansi$

End Function

