Attribute VB_Name = "CONVERT"
'--------------------------- CONVERT.BAS ------------------------------

'HAMMAP Konvertierungs-Programm
'Gemeinsame Routinen fuer MAPCVT und STNCVT
'von Gerhard Berg, DJ6FM


DefInt A-Z


Const MaxAnzFiles = 50                        'Max.Anzahl Files

Dim ShowOk
Dim AnzFiles
Dim InputFile$(1 To MaxAnzFiles)

'FileType: 1 = Binaer, 2 = Text, 3 = Log
Dim OutputFile$(1 To 3)
Dim LogFile

Dim ProgInfo$

Sub AddTextLine(text$)

  If Len(TextForm.TextField.text) > 30000 Then
    TextForm.TextField.text = Right$(TextForm.TextField.text, 20000)
  End If
  TextForm.TextField.SelStart = 32767
  TextForm.TextField.SelText = text$ & vbCrLf
  TextForm.TextField.SelStart = 32767

  void = DoEvents()

End Sub

Function BatchConvert(CmdLine$)

  BatchConvert = False

  '--------------- Dateien aus Kommandozeile --------------
  InputFileList$ = Parse$(CmdLine$, ",")
  OutputFileList$ = CmdLine$
  AnzFiles = 0

  'Ausgabedateien loeschen
  For i = 1 To 3
    OutputFile$(i) = ""
  Next i


  Do While Len(InputFileList$) > 0

    InputItem$ = Parse$(InputFileList$, "+")

    'Input-File mit Wildcard
    If InStr(InputItem$, "*") Or InStr(InputItem$, "?") Then

      Call ParseFileSpec(InputItem$, d$, p$, n$, e$)

      ErrNr = GetDir(InputItem$, f$)
      If ErrNr Then Exit Function
      Do Until Len(f$) = 0

        Call ParseFileSpec(f$, d1$, P1$, n1$, e1$)
        If CheckInExt(e1$) Then
          If AnzFiles = MaxAnzFiles Then
            Call ShowErrNr(29030)
            Exit Function
          End If
          AnzFiles = AnzFiles + 1
          InputFile$(AnzFiles) = d$ + p$ + f$
        End If
        f$ = Dir$
      Loop

    Else
      '--- kein Wildcard ---
      If AnzFiles = MaxAnzFiles Then
        Call ShowErrNr(29030)
        Exit Function
      End If
      AnzFiles = AnzFiles + 1
      InputFile$(AnzFiles) = InputItem$
    End If

  Loop


  '--- Keine Eingabedateien ---
  If AnzFiles = 0 Then Exit Function


  '--- Ausgabedateien definieren ---
  Do While Len(OutputFileList$) > 0

    OutFile$ = Parse$(OutputFileList$, ",")

    '--- Nach Zieldatei Konvertierung unterscheiden ---
    Call ParseFileSpec(OutFile$, d$, p$, n$, e$)
    FileType = CheckOutExt(e$)

    If FileType > 0 Then
      OutputFile$(FileType) = OutFile$
    Else
      Call ShowErrNrFileTxt(25018, OutFile$)
      Exit Function
    End If

  Loop

  '--- Angegebene Datei(en) konvertieren ---
  ShowOk = False
  Call InitTextForm(ProgName$, "", False)
  Call ShowTextForm(True, 0)
  ErrNr = PerformConvert()
  Call ShowTextForm(False, 0)

  BatchConvert = ErrNr

End Function

Function CheckFiles()

  CheckFiles = True

  '--- Pruefen, ob Eingabe-Datei(en) definiert ---
  If AnzFiles = 0 Then
    Call ShowErrNr(25020)
    Exit Function
  End If


  '--- Eingabe-Dateien pruefen ---
  For IsFile = 1 To AnzFiles
    InputFile$(IsFile) = UCase$(InputFile$(IsFile))
    Call ParseFileSpec(InputFile$(IsFile), d$, p$, n$, e$)

    FileType = CheckInExt(e$)
    If FileType = 0 Then
      Call ShowErrNrFileTxt(25018, InputFile$(IsFile))
      Exit Function
    End If

  Next IsFile


  '--- Ausgabe-Dateien pruefen ---
  For FileType = 1 To 3

    If Len(OutputFile$(FileType)) > 0 Then

      OutputFile$(FileType) = UCase$(OutputFile$(FileType))
      Call ParseFileSpec(OutputFile$(FileType), d$, p$, n$, e$)

      '--- auf richtige Erweiterung pruefen ---
      IsType = CheckOutExt(e$)
      If IsType <> FileType Then
        Call ShowErrNrFileTxt(25018, OutputFile$(FileType))
        Exit Function
      End If

      '--- Pruefen, ob Ausgabedatei = Eingabedatei ---
      If ProgName$ = "MAPCVT" Then
        FirstFile = 1
        MsgNr = 29036
      Else
        FirstFile = 2
        MsgNr = 29034
      End If

      For IsFile = FirstFile To AnzFiles
        If InputFile$(IsFile) = OutputFile$(FileType) Then
          Call ShowErrNrFileTxt(MsgNr, InputFile$(IsFile))
          Exit Function
        End If
      Next IsFile

      If InputFile$(1) = OutputFile$(FileType) Then
        If Len(OutputFile$(1)) > 0 And Len(OutputFile$(2)) > 0 Then
          Call ShowErrNrFileTxt(29035, InputFile$(1))
          Exit Function
        End If
      Else
        'Wenn Batch-Mode, dann ggf. altes Logfile loeschen
        If FileType = 3 And Not ShowOk Then
          ErrNr = DeleteFile(OutputFile$(3), Found)
          If ErrNr Then Exit Function
        Else
          'Wenn Ausgabedatei <> Eingabedatei, dann pruefen, ob Ausgabe-Datei
          '  vorhanden  -  ggf. ueberschreiben bestaetigen
          Cancel = ConfirmOverwrite(OutputFile$(FileType), ProgName$)
          If Cancel Then Exit Function
        End If
      End If
    End If

  Next FileType

  CheckFiles = False

End Function

Sub ClearFiles()

  For i = 0 To 3
    CvtForm.FileField(i).text = ""
  Next i

  For i = 1 To CvtForm.FileList.ListCount
    CvtForm.FileList.RemoveItem 0
  Next i

End Sub

Function ConfirmOverwrite(File$, Title$)

  ConfirmOverwrite = True

  ErrNr = ExistFile(File$, False, Exist)
  If ErrNr Then Exit Function

  If Exist Then
    m1$ = Msg$(25004) + ": " + File$
    m2$ = Msg$(25005) + " ? "

    Answer = TxtMsgBox(m1$ + vbCrLf + m2$, 4 + 32 + 256, Title$)
    If Answer <> 6 Then Exit Function           'Not Yes

  End If

  ConfirmOverwrite = False

End Function

Sub ConvertCommand()

  '--- Konvertierung durchfuehren ---
  Call InitTextForm(ProgName$, "", True)
  Call ShowTextForm(True, 0)

  ErrNr = SetFiles()
  If ErrNr = 0 Then void = PerformConvert()

End Sub

Sub CvtFileCommand(Index)

  Static IniFile$
  Static IniDir$

  If Len(IniFile$) = 0 Then IniFile$ = HomeDir$ + "HAMMAP.INI"
  If Len(IniDir$) = 0 Then IniDir$ = HomeDir$

  Title$ = ProgName$ & "  -  " & StdMsg$(29000 + Index)

  Select Case Index
  Case 1                    'Neu
    Call ClearFiles
    Call EnableFunctions

  Case 2                    'Log-Datei anzeigen
    Call ShowLogFile

  Case 4                    'Einstellungen laden
    Call ClearFiles

    DefExt$ = "INI"
    f$ = Msg$(25022) + " (*.INI)|*.INI"
    NewFile$ = InParFile$
    'Flags: FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
    Flg& = &H180C&

    Cancel = GetFileSpec(Title$, 1, Flg&, IniDir$, DefExt$, f$, NewFile$)
    If Cancel Then Exit Sub

    InParFile$ = NewFile$

    void = LoadCvtParameter()
    Call SetFileParameter


  Case 5                    'Einstellungen speichern
    Screen.MousePointer = 11
    '--- Dateien uebernehmen ---
    Call GetFileParameter
    '--- Parameter ausgeben ---
    m$ = Params2Str$(False)
    void = WriteParameter(InParFile$, "[" + ProgName$ + "]", m$)
    Screen.MousePointer = 0


  Case 6                    'Einstellungen speichern als...
    DefExt$ = "INI"
    f$ = Msg$(25022) + " (*.INI)|*.INI"
    NewFile$ = InParFile$
    'Flags: CreatePrompt + PathMustExist + NoChangeDir + HideReadOnly
    'CreatePrompt-Flag geht nicht !?
    Flg& = &H280C&

    Cancel = GetFileSpec(Title$, 2, Flg&, IniDir$, DefExt$, f$, NewFile$)
    If Cancel Then Exit Sub
    InParFile$ = NewFile$

    '--- Dateien uebernehmen ---
    Call GetFileParameter

    '--- Parameter ausgeben ---
    m$ = Params2Str$(False)
    ErrNr = WriteParameter(InParFile$, "[" + ProgName$ + "]", m$)
    If ErrNr = 0 Then
      Call ParseFileSpec(InParFile$, d$, p$, n$, e$)
      CvtForm.Caption = ProgName$ + " - " + n$ + e$
    End If

  Case 8                    'Beenden
    Call ExitHMTool

  End Select

End Sub

Sub EnableFunctions()

  Cond1 = Len(CvtForm.FileField(0).text) > 0
  Cond2 = CvtForm.FileList.ListCount > 0

  CvtForm.MenuConvert.Enabled = Cond1 Or Cond2
  CvtForm.FileInsert.Enabled = Cond1
  CvtForm.FileDelete.Enabled = CvtForm.FileList.ListIndex >= 0
  CvtForm.PullDownFile(2).Enabled = Len(CvtForm.FileField(3).text) > 0

End Sub

Function FilterMsg$(MsgNr)

  FilterMsg$ = ""

End Function

Sub GetCvtFiles(Index)

  Static IniDir$

  Title$ = ProgName$ + "  -  " + CvtForm.FileLabel(Index).Caption
  If Len(IniDir$) = 0 Then IniDir$ = HomeDir$ + Left$(ProgName$, 3)

  f$ = GetFileFilter$(Index)
  Ext$ = GetDefExt$(Index)
  Files$ = CvtForm.FileField(Index).text

  If Index = 0 Then                         'Eingabedatei
    Cmd = 1
    'Flags: FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
    Flg& = &H180C&
  Else                                      'Ausgabedatei
    Cmd = 2
    'Flags: PathMustExist + NoChangeDir + HideReadOnly
    Flg& = &H80C&
  End If

  Cancel = GetFileSpec(Title$, Cmd, Flg&, IniDir$, Ext$, f$, Files$)
  If Cancel Then Exit Sub

  CvtForm.FileField(Index).text = Files$

End Sub

Sub GetFileParameter()

  For i = 0 To 3
    StrPar(3, i + 1) = CvtForm.FileField(i).text
  Next i

  If CvtForm.FileList.ListCount > 0 Then
    If Len(StrPar(3, 1)) = 0 Then Flag = True

    For i = 0 To CvtForm.FileList.ListCount - 1
      StrPar(3, 1) = StrPar(3, 1) + "," + CvtForm.FileList.List(i)
    Next i

    'Remove ","
    If Flag Then StrPar(3, 1) = Mid$(StrPar(3, 1), 2)

  End If

End Sub

Sub InitCvtForm()

  Load CvtForm

  CvtForm.WindowState = 0
  'In Win95/VB5 this corrupts the form size
  'Call CenterForm(CvtForm)

  '--- Hauptmenue ---
  CvtForm.MenuUpdate.Visible = (ProgName$ = "STNCVT")
  CvtForm.MenuFile.Caption = Msg$(29051)
  CvtForm.MenuConvert.Caption = Msg$(29052)
  CvtForm.MenuUpdate.Caption = Msg$(29053)
  CvtForm.MenuOptions.Caption = Msg$(29054)
  CvtForm.MenuInfo.Caption = Msg$(29055)
  CvtForm.MenuHelp.Caption = Msg$(29056)

  CvtForm.FileLabel(0).Caption = Msg$(29010)
  CvtForm.FileLabel(1).Caption = Msg$(29011)
  CvtForm.FileLabel(2).Caption = Msg$(29013)
  CvtForm.FileLabel(3).Caption = Msg$(29015)
  CvtForm.FileListLabel.Caption = Msg$(29020)
  CvtForm.FileInsert.Caption = Msg$(29021)
  CvtForm.FileDelete.Caption = Msg$(29022)

  m$ = Msg$(29023)
  For i = 0 To 3
    CvtForm.FileCommand(i).Caption = m$
  Next i


  Call SetMsgMode(1)


  If ProgName$ = "STNCVT" Then
    '--- Menue Aktualisieren ---
    For i = 1 To 3
      If i > 1 Then Load CvtForm.PullDownUpdate(i)
      CvtForm.PullDownUpdate(i).Caption = Msg$(29040 + i)
    Next i

    FileBase = 29000      'Datei
    OptBase = 27200       'Einstellungen
    HlpBase = 27300       'Hilfe
  Else
    FileBase = 29000      'Datei
    OptBase = 26200       'Einstellungen
    HlpBase = 26300       'Hilfe
  End If


  '--- Datei ---
  i = 0
  Do
    i = i + 1
    m$ = Msg$(FileBase + i)
    If Len(m$) = 0 Then Exit Do
    If i > 1 Then Load CvtForm.PullDownFile(i)
    Call SetMenuItem(CvtForm.PullDownFile(i), m$)
  Loop


  '--- Einstellungen ---
  i = 0
  Do
    i = i + 1
    m$ = Msg$(OptBase + i)
    If Len(m$) = 0 Then Exit Do
    If i > 1 Then Load CvtForm.PullDownOptions(i)
    Call SetMenuItem(CvtForm.PullDownOptions(i), m$)
  Loop


  '--- Hilfe ---
  i = 0
  Do
    i = i + 1
    m$ = Msg$(HlpBase + i)
    If Len(m$) = 0 Then Exit Do
    If i > 1 Then Load CvtForm.PullDownHelp(i)
    Call SetMenuItem(CvtForm.PullDownHelp(i), m$)
  Loop

  Call SetMsgMode(1)

  Call SetFileParameter

End Sub

Sub InsertFiles()

  InFile$ = CvtForm.FileField(0).text

  Do Until Len(InFile$) = 0
    s$ = Parse$(InFile$, ",")

    If InStr(s$, "*") Or InStr(s$, "?") Then
      Call ParseFileSpec(s$, d$, p$, n$, e$)
      ErrNr = GetDir(s$, f$)
      If ErrNr Then f$ = ""
      Do Until Len(f$) = 0
        Call ParseFileSpec(f$, d1$, P1$, n1$, e1$)
        If CheckInExt(e1$) Then
          CvtForm.FileList.AddItem d$ + p$ + f$
        End If
        f$ = Dir$
      Loop
    Else
      CvtForm.FileList.AddItem s$
    End If
  Loop

  If CvtForm.FileList.ListCount > 0 Then
    CvtForm.FileField(0).text = ""
  End If

  Call EnableFunctions

End Sub

Sub InteractiveConvert()

End Sub

Function LoadCvtParameter()

  ErrNr = LoadParameter(InParFile$, "[" + ProgName$ + "]", True, Found)

  If ErrNr = 0 Then
    Call ParseFileSpec(InParFile$, d$, p$, n$, e$)
    CvtForm.Caption = ProgName$ + " - " + n$ + e$
  Else
    CvtForm.Caption = ProgName$
  End If

  LoadCvtParameter = ErrNr

End Function

Function PerformConvert()

  PerformConvert = True

  '--- Daten loeschen ---
  ErrNr = ClearData()
  If ErrNr Then Exit Function


  '--- Dateien pruefen ---
  ErrNr = CheckFiles()
  If ErrNr Then Exit Function

  '--- Dateien konvertieren ---
  ErrNr = PerformConvertFiles()

  '--- Ausgabedateien schliessen (auch bei Abbruch) ---
  If Len(OutputFile$(1)) > 0 Then
    ErrCl = CloseOutBinFiles()
    ErrNr = ErrNr Or ErrCl
  End If

  If Len(OutputFile$(2)) > 0 Then
    ErrCl = CloseOutTextFiles()
    ErrNr = ErrNr Or ErrCl
  End If


  '--- Nachricht 'Konvertierung beendet / abgebrochen' ausgeben
  If ErrNr = 0 Then
    MsgNr = 29031
  Else
    MsgNr = 29032
  End If

  void = WriteLog(vbCrLf + Msg$(MsgNr) + vbCrLf, 3)

  'Im Batch-Mode (mit Log-Datei) nicht anhalten, wenn kein Fehler
  If ErrNr Then
    void = TxtMsgBox(Msg$(MsgNr), 0, ProgName$)
  End If


  '--- LogFile schliessen ---
  If LogFile Then ErrCl = CloseFile(LogFile)

  PerformConvert = ErrNr Or ErrCl

End Function

Function PerformConvertFiles()

  PerformConvertFiles = True

  '--- Logfile oeffnen ---
  If Len(OutputFile$(3)) > 0 Then
    'Datei oeffnen
    ErrNr = OpenFile(OutputFile$(3), "O", 0, LogFile)
    If ErrNr Then Exit Function
  Else
    'Wenn Batch-File, aber kein Log-File, dann am Ende halten
    If Not ShowOk Then ShowOk = True
    LogFile = 0
  End If


  '--- Titel und Autor ausgeben ---
  ErrNr = WriteLog(ProgInfo$, 3)
  If ErrNr Then Exit Function


  '--- Alle Parameter ausgeben ---
  ErrNr = WriteLog(vbCrLf + Msg$(25029) + ":" + vbCrLf, 3)
  If ErrNr Then Exit Function

  Call GetFileParameter

  ErrNr = WriteLog(Params2Str$(True), 3)
  If ErrNr Then Exit Function


  '--- Dateien konvertieren ---
  StartTime# = Now

  ErrNr = ConvertAllFiles(AnzFiles, InputFile$(), OutputFile$())
  If ErrNr Then Exit Function

  EndTime# = Now


  '--- Statistik ausgeben ---
  ErrNr = WriteStatistics(OutputFile$(3))
  If ErrNr Then Exit Function

  t$ = Mid$(Format$(EndTime# - StartTime#, "hh:m:ss"), 4)
  ErrNr = WriteLog(vbCrLf + Msg$(29033) + " " + t$, 3)
  If ErrNr Then Exit Function

  PerformConvertFiles = False

End Function

Sub PrintFound(FontMode, ByVal Title$, ByVal Txt$)

  MsgBox "Print function not supported"

End Sub

Sub SetFileParameter()

  '--- Dateien setzen ---
  For i = 0 To 3
    CvtForm.FileField(i).text = StrPar(3, i + 1)
  Next i

  s$ = CvtForm.FileField(0).text

  If InStr(s$, "*") Or InStr(s$, "?") Or InStr(s$, ",") Then
    Call InsertFiles
  End If

  Call EnableFunctions

End Sub

Function SetFiles()

  SetFiles = True

  '--- Output Files ---
  For FileType = 1 To 3
    File$ = CvtForm.FileField(FileType).text

    'Default Extension setzen
    If Len(File$) > 0 Then
      Call ParseFileSpec(File$, d$, p$, n$, e$)
      If e$ = "." Then
        e$ = "." + GetDefExt$(FileType)
        File$ = d$ + p$ + n$ + e$
        CvtForm.FileField(FileType).text = File$
      End If
    End If

    OutputFile$(FileType) = File$
  Next FileType


  '--- Input Files ---
  If Len(CvtForm.FileField(0).text) > 0 Then FirstFile = 1

  AnzFiles = CvtForm.FileList.ListCount

  If AnzFiles + FirstFile > MaxAnzFiles Then
    Call ShowErrNr(29030)
    Exit Function
  End If

  For IsFile = 1 To AnzFiles
    InputFile$(IsFile) = UCase$(CvtForm.FileList.List(IsFile - 1))
  Next IsFile

  If FirstFile Then
    AnzFiles = AnzFiles + 1
    InputFile$(AnzFiles) = UCase$(CvtForm.FileField(0).text)
  End If

  SetFiles = False

End Function

Function ShowComplete(Actual&, TotalCount&, FileNr, MsgNr)

  Static m1$, m2$
  Static Total&
  Static Incr&
  Static NextShow&


  If Actual& > 0& Then

    'Andere Aufgabe zulassen
    void = DoEvents()

    If Actual& >= NextShow& Then

      NextShow& = NextShow& + Incr&

      Complete! = Actual& / Total&
      If Complete! > 1! Then Complete! = 1!

      If CompleteForm.WindowState = 1 Then

        '----------------- Icon -------------------
        FormW = CompleteForm.ScaleWidth
        FormH = CompleteForm.ScaleHeight

        m$ = Format$(CInt(Complete! * 100)) + " %"
        w! = CompleteForm.TextWidth(m$)
        h! = CompleteForm.TextHeight(m$)

        CompleteForm.Cls
        CompleteForm.CurrentY = (FormH - h!) / 2!
        CompleteForm.CurrentX = (FormW - w!) / 2!
        CompleteForm.Print m$

      Else

        'Text ausgeben
        s$ = m1$ + Str$(CInt(Complete! * 100!)) + m2$
        CompleteForm.CompleteLabel.Caption = s$

        'Balken ausgeben


        x = CompleteForm.CompleteBox.Width * Complete!
        y = CompleteForm.CompleteBox.Height
        CompleteForm.CompleteBox.Line (0, 0)-(x, y), , B

        CompleteForm.Refresh

        'Auf Abbruch testen
        Cancel = Val(CompleteForm.Tag)
        If Cancel Then
          CompleteForm.Hide

          Unload CompleteForm
          Set CompleteForm = Nothing

          void = DoEvents()
        End If

        ShowComplete = Cancel

      End If

    End If

  ElseIf Actual& = 0& Then

    Total& = TotalCount&
    Incr& = Total& \ 100&
    NextShow& = Incr&

    m1$ = Msg$(MsgNr)
    m2$ = " % " + Msg$(29100)

    Load CompleteForm
    CompleteForm.Tag = "0"
    CompleteForm.Caption = GetFileName$(FileNr)
    Call CenterForm(CompleteForm)
    CompleteForm.CompleteLabel.Caption = m1$ + " 0" + m2$

    CompleteForm.CompleteBox.FillStyle = 0  'solid
    CompleteForm.CompleteBox.ForeColor = &H8000000D
    CompleteForm.CompleteBox.FillColor = &H8000000D
    CompleteForm.CompleteBox.Cls

    CompleteForm.CancelButton.Caption = StdMsg$(25053)
    CompleteForm.Show

    void = DoEvents()

  Else                           'Actual& < 0&

    CompleteForm.Hide

    Unload CompleteForm
    Set CompleteForm = Nothing

    void = DoEvents()

  End If

End Function

Sub ShowInfo()

  void = TxtMsgBox(ProgInfo$, 8, ProgName$ + "  -  " + Msg$(25026))

End Sub

Sub ShowLogFile()

  '--- Logfile anzeigen ---
  File$ = CvtForm.FileField(3).text
  ErrNr = LoadTextFile(File$, 32767&, text$)
  If ErrNr = 0 Then
    Call InitTextForm(File$, text$, True)
    Call ShowTextForm(True, 1)
  End If

End Sub

Function StartConvert()

  'Command-Line-Syntax:
  '  [*.MSG] /?                                         Hilfe
  '  [*.MSG] [*.INI]                                    Filespec in Maske
  '  [*.MSG] [*.INI] source[{+source}...]  [dest...]    Filespec explizit

StartConvert = True


  'Programm-spezifische Initialisierung
  ErrNr = InitConvert(InfoNr)
  If ErrNr Then Exit Function

  ProgInfo$ = GetAbout$(Msg$(InfoNr))

  '--- Parameter initialisieren und laden ---
  ErrNr = LoadCvtParameter()

  If GV.AnzCmdFiles > 0 Then

    '--- Batch Konvertierung ---
    For i = 1 To GV.AnzCmdFiles
      CmdLineOpt$ = CmdLineOpt$ & "," & CmdFiles$(i)
    Next i
    void = BatchConvert(Mid$(CmdLineOpt$, 2))
    Call ExitHMTool

  Else
    '--- Interaktive Konvertierung ---
    ShowOk = True
    Call InitCvtForm
    'Alle evtl. offenen Dateien schliessen
    void = CloseFile(-1)

    CvtForm.Show
  End If

  StartConvert = False

End Function

Function WriteLog(OutLine$, Mode)

  WriteLog = True

  If LogFile Then
    'Mode: 1 = nur auf Schirm; 2 = nur auf File; 3 = auf File und Schirm

    If Mode And 1 Then
      Call AddTextLine(OutLine$)
    End If

    If Mode And 2 Then
      ErrNr = WriteLine(LogFile, OutLine$)
      If ErrNr Then Exit Function
    End If

  Else

    Call AddTextLine(OutLine$)

  End If

  WriteLog = False

End Function

