Attribute VB_Name = "dbDesign"
DefInt A-Z

Type Mountain
  Name As String
  l As Double       'Lnge
  b As Double       'Breite
  h As Long         'Hhe
  Dist As Integer
  Rank As Integer
End Type

Dim Mtn() As Mountain

Sub AnalyseMountains()

  Dim RecNr As Long
  Dim degP1 As dGeoPoint, degP2 As dGeoPoint

  NameFldNr = GetDsFieldNr("Name")
  HeightFldNr = GetDsFieldNr("Hhe")
  LongFldNr = GetDsFieldNr("Lnge")
  LatiFldNr = GetDsFieldNr("Breite")
  DistFldNr = GetDsFieldNr("Abstand")
  RankFldNr = GetDsFieldNr("Rang")

  ReDim Mtn(1 To dbAnzDsRec) As Mountain

  Call ShowMsg("Datenstze einlesen", False, 11)

  'Datenstze einlesen
  For RecNr = 1 To dbAnzDsRec
    Call RetrieveRecord(RecNr)
    With Mtn(RecNr)
      .Name = dbDsFieldData(NameFldNr)
      .h = Val(dbDsFieldData(HeightFldNr))
      .Dist = 32767
      ErrNr1 = Str2dDegCoord(dbDsFieldData(LongFldNr), .l, 2) 'Lnge
      ErrNr2 = Str2dDegCoord(dbDsFieldData(LatiFldNr), .b, 1)  'Breite
      If ErrNr1 Or ErrNr2 Then
        .l = 0
        .b = 0
        MsgBox "Ungltige Koordinaten: " & .Name & " = " _
          & dbDsFieldData(LongFldNr) & ", " & dbDsFieldData(LatiFldNr)
      End If
    End With
  Next RecNr


  'Abstand zum nchsthheren Berg berechnen
  For Src = 1 To dbAnzDsRec
    For Dst = 1 To dbAnzDsRec
      If Src <> Dst And Mtn(Dst).h > Mtn(Src).h Then
        degP1.l = Mtn(Src).l
        degP1.b = Mtn(Src).b
        degP2.l = Mtn(Dst).l
        degP2.b = Mtn(Dst).b
        If degP1.l = 0# And degP1.b = 0# Then
          Mtn(Src).Dist = 0
        Else
          If degP2.l <> 0# Or degP2.b <> 0# Then
            iDist = QthDist(degP1, degP2)
            If iDist < Mtn(Src).Dist Then
              Mtn(Src).Dist = iDist
            End If
          End If
        End If
      End If
    Next Dst

    If Src Mod 20 = 0 Then Call ShowMsg("Record:" & Str$(Src), False, 11)
  Next Src


  '--- Datenstze speichern ---
  Call ShowMsg("Datenstze speichern", False, 0)

  With ds
    .MoveFirst
    For RecNr = 1 To dbAnzDsRec
      If ds(NameFldNr).Value <> Mtn(RecNr).Name Then
        Stop
      Else
        .Edit
        ds(DistFldNr).Value = Mtn(RecNr).Dist
        If Mtn(RecNr).Dist >= 50 Then
          ds(RankFldNr).Value = 1
        ElseIf Mtn(RecNr).Dist >= 20 Then
          ds(RankFldNr).Value = 2
        ElseIf Mtn(RecNr).Dist >= 7 Then
          ds(RankFldNr).Value = 3
        Else
          ds(RankFldNr).Value = Null
        End If
        .Update
      End If
      .MoveNext
    Next RecNr
  End With

  Erase Mtn

  ErrNr = SelectData(SelectClause & FromClause)

  Call ShowSelection

  Call ShowMsg("Berg-Analyse beendet", False, 0)

End Sub

Sub DesignFunctions(Index)

  Title$ = ProgName$ & " - " & StdMsg$(32230 + Index)

  Select Case Index
  Case 2 To 4       'Export
    ExportMode = True

    Select Case Index
    Case 2
      Ext$ = "MAP"
      Filt$ = "Karten-Datei"

    Case 3
      Ext$ = "DAT"
      Filt$ = "HMTOWN-Datei"

    Case 4    'ATV-AGAF
      MsgBox "Funktion noch nicht implementiert"
      Stop

    End Select

    Filt$ = Filt$ & " (*." & Ext$ & ")|*." & Ext$

   'Flags: PathMustExist + NoChangeDir + HideReadOnly + Overwrite-Prompt
    Flags& = &H80E

    Cancel = GetFileSpec(Title$, 2, Flags&, ".", Ext$, Filt$, DstFile$)
    If Cancel Then Exit Sub

    ErrNr = DeleteFile(DstFile$, Found)
    If ErrNr Then Exit Sub

    Call ShowMsg(Msg$(32258) & Msg$(32259), False, 11)

  Case 5    'HAMMAP-Datenbank
    Screen.MousePointer = 11
    ErrNr = ImportHammapDB()
    Screen.MousePointer = 0
    Call ShowSelection
    Exit Sub
  End Select


  Select Case Index
  Case 0       'Max. FeldLnge
    GetMaxLength = Not frmMain.pdmnuDesign(Index).Checked
    frmMain.pdmnuDesign(Index).Checked = GetMaxLength

  Case 1        'Berge analysieren
    Call AnalyseMountains

  Case 2  'HAMMAP Karten-Datei
    ErrNr = WriteMapFile(Title$, DstFile$)

  Case 3  'HMTOWN-Datei
    ErrNr = WriteHmTownFile(DstFile$)

  Case 4  'ATV-AGAF

  End Select


  If ExportMode Then
    If ErrNr Then
      Call ShowMsg(Msg$(32280), False, 0)
    Else
      Call ShowMsg("Export erfolgreich beendet", False, 0)
    End If
  End If

End Sub

Function ImportHammapDB()

  ImportHammapDB = True

  If dbAnzTables > 0 Then
    MsgBox "Datenbank mu leer sein"
    Exit Function
  End If

  MsgNr = 4
  t$ = ProgName$ & " - " & Msg$(32257)
  Ext$ = Msg$(32520 + MsgNr)
  Filt$ = Msg$(32510 + MsgNr) & " (*." & Ext$ & ")|*." & Ext$
  'Flags: FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
  Flags& = &H180C
  DefDir$ = HomeDir$ & "STN"

  Cancel = GetFileSpec(t$, 1, Flags&, DefDir$, Ext$, Filt$, SrcFile$)
  If Cancel Then Exit Function

  Call ParseFileSpec(SrcFile$, d$, p$, n$, e$)
  h$ = d$ & p$

  ErrNr = ImportStnTable(h$ & "ATV.STN", "ATV")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "BEACON.STN", "Baken")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "DIGI.LNK", "Digi-Links")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "DIGI.STN", "Digi-Stationen")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "EME.STN", "EME")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "FONE.LNK", "Fone-Links")
  If ErrNr Then Exit Function
  ErrNr = ImportStnTable(h$ & "FONE.STN", "Fone-Stationen")
  If ErrNr Then Exit Function

  ImportHammapDB = False

End Function

Function ImportStnTable(SrcFile$, DstTbl$)

  Call ParseFileSpec(SrcFile$, d$, p$, n$, e$)

  If UCase$(e$) = ".STN" Then
    MsgBase = 32320
  Else
    MsgBase = 32340
  End If

  Call ShowMsg("Import: " & SrcFile$, False, 11)
  ImportStnTable = ImportHMTable(SrcFile$, MsgBase, ",", 0, DstTbl$)

End Function

Function WriteHmTownFile(FileSpec$)

  WriteHmTownFile = True

  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)

  NameFldNr = GetDsFieldNr("Name")
  LongFldNr = GetDsFieldNr("Lnge")
  If LongFldNr < 0 Then LongFldNr = GetDsFieldNr("Longitude")
  LatiFldNr = GetDsFieldNr("Breite")
  If LatiFldNr < 0 Then LatiFldNr = GetDsFieldNr("Latitude")

  If NameFldNr < 0 Or LongFldNr < 0 Or LatiFldNr < 0 Then
    MsgBox "Ntige Felder nicht gefunden."
    Exit Function
  End If

  On Error Resume Next

  For i& = 1 To dbAnzDsRec
    Call MoveDS(i&)

    s$ = ds(NameFldNr).Value & ":"
    'Grad als Dezimalbruch
    ErrNr = Str2dDegCoord(ds(LongFldNr).Value, x#, 2)
    If ErrNr = 0 Then ErrNr = Str2dDegCoord(ds(LatiFldNr).Value, y#, 1)
    If ErrNr = 0 Then
      s$ = s$ & Unformat$(Format$(x#, "0.000")) & ","
      s$ = s$ & Unformat$(Format$(y#, "0.000"))
    Else
      s$ = ";Ungltiges Format: " & s$
      s$ = s$ & ds(LongFldNr).Value & "," & ds(LatiFldNr).Value
    End If
    ErrNr = Err
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, s$)
    If ErrNr Then Exit For
  Next i&

  LastErrNr = ErrNr
  LastError = LTrim$(Str$(ErrNr)) & ": " & Error$
  On Error GoTo 0

  ErrNr = ErrNr Or CloseFile(FileNr)

  WriteHmTownFile = ErrNr

End Function

Function WriteMapFile(Title$, FileSpec$)

  WriteMapFile = True

  NameFldNr = GetDsFieldNr("Name")
  LongFldNr = GetDsFieldNr("Lnge")
  LatiFldNr = GetDsFieldNr("Breite")
  HighFldNr = GetDsFieldNr("Hhe")
  RankFldNr = GetDsFieldNr("Rang")

  ObjFldNr = GetDsFieldNr("Objekt")
  If ObjFldNr < 0 Then
    Screen.MousePointer = 0
    Cancel = GetInput(Title$, "Objekt:", "Mountain", ObjName$)
    If Cancel Then Exit Function
    Screen.MousePointer = 11
  End If

  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "; HAMMAP Map-File")
  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "FormatVersion = 4")
  If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "")
  If ErrNr Then Exit Function


  For RecNr& = 1 To dbAnzDsRec

    Call RetrieveRecord(RecNr&)

    If Not IsNull(ds(RankFldNr).Value) Then
      s$ = ds(LatiFldNr).Value & ", " & ds(LongFldNr).Value & ", "

      If ObjFldNr < 0 Then
        s$ = s$ & ObjName$
      Else
        s$ = s$ & ds(ObjFldNr).Value
      End If

      n$ = AnsiToPc8$(dbDsFieldData(NameFldNr))
      If HighFldNr >= 0 Then
        n$ = n$ & " (" & ds(HighFldNr).Value & " m)"
      End If
      s$ = s$ & ", " & ds(RankFldNr).Value & "   ; " & n$

      ErrNr = WriteLine(FileNr, s$)
      If ErrNr Then Exit For

    End If

  Next RecNr&

  ErrNr = ErrNr Or CloseFile(FileNr)

  WriteMapFile = ErrNr

End Function

