Attribute VB_Name = "dbEdit_W"
DefInt A-Z

Sub CopyAllCommand()

  'Alle gefundenen Records auf Zwischenablage ausgeben

  Dim RecNr As Long
  Dim t$, m$

  Call ShowMsg(Msg$(32250), False, 11)

  On Local Error GoTo CopyErrHnd

  For RecNr = 0 To dbAnzDsRec
    Call RetrieveRecord(RecNr)
    t$ = t$ + CombineFields(dbDsFieldData())
  Next RecNr

  Clipboard.Clear
  Clipboard.SetText t$

ExitCopy:
  Call ShowMsg("", True, 0)
  Exit Sub

CopyErrHnd:

  m$ = "Zu viele Datenstze." + Chr$(13) + Chr$(10)
  m$ = m$ + "Benutzen Sie bitte die Funktion 'Speichern'."
  MsgBox m$
  Resume ExitCopy

End Sub

Sub CopyTableAll(Tbl As Grid)

  'Gesamte Tabelle auf Zwischenablage kopieren
  'Ausgenommen feste Zeilen und Spalten

  Tbl.SelStartCol = Tbl.FixedCols
  Tbl.SelEndCol = Tbl.Cols - 1
  Tbl.SelStartRow = Tbl.FixedRows
  Tbl.SelEndRow = Tbl.Rows - 1

  Call CopyTableSel(Tbl)

End Sub

Sub CopyTableSel(Tbl As Grid)

  'Selektierten Bereich der definierten Tabelle auf
  '   Zwischenablage kopieren
  'Felder mit TAB trennen und CR/LF abschliessen

  Dim r As Integer              'Zeile (row)
  Dim c As Integer              'Spalte (column)
  Dim t As String               'Text
  Dim tb As String              'TAB = Tabulator
  Dim CR As String              'Carriage Return / Line Feed

  tb = Chr$(9)
  CR = Chr$(13) + Chr$(10)

  For r = Tbl.SelStartRow To Tbl.SelEndRow
    Tbl.row = r
    For c = Tbl.SelStartCol To Tbl.SelEndCol
       Tbl.Col = c
       If c > Tbl.SelStartCol Then t = t + tb
       t = t + Tbl.text
    Next c

    t = t + CR

  Next r

  Tbl.row = Tbl.SelStartRow
  Tbl.Col = Tbl.SelStartCol

  Clipboard.Clear
  Clipboard.SetText t

End Sub

Sub EditCommand()

  Dim f$, ErrNr, SaveCol, d
  Dim RecNr As Long

  DsAllowEdit = MnuAllowEdit And dbDsIsTable

  If Not DsAllowEdit And dbAnzDsRec = 0 Then Exit Sub

  'Record bestimmen
  RecNr = GetDsRecNr()
  frmMain.Tbl.HighLight = False

  'Maske initialisieren
  With frmDataMask

    Call InitMask(frmDataMask, 1, Not DsAllowEdit)

    Call ScrollBarInit(frmDataMask, 1)
    Call ScrollBarSet(frmDataMask, RecNr, 1)

    .Caption = frmMain.Caption

    d = TopDist + (dbAnzDsFields + 0#) * FldDist - .ScrollBar.Top
    If d > 0 Then
      .Height = .Height + d
    End If

    If DsAllowEdit And Not AutoSave Then
      .Cmd(0).Caption = "Abbrechen"
    Else
      .Cmd(0).Caption = "Schlieen"
    End If

    .Cmd(1).Visible = DsAllowEdit     'Neu
    .Cmd(2).Visible = DsAllowEdit     'Lschen
    .Cmd(3).Visible = DsAllowEdit     'Rckgngig
    .Cmd(4).Visible = DsAllowEdit And Not AutoSave      'Speichern

    If dbDsIsTable Then
      If dbOpenTable = "tblLocator" Then
        .Txt(1).MaxLength = 6
        .Txt(4).ToolTipText = appGetDataTip$()
      End If
    End If

    TblHasChanged = False
    InsertMode = dbAnzDsRec = 0   'False, auer wenn Tabelle leer

    Call FillMask

    Call CenterForm(frmDataMask)

    .Show 1

    If TblHasChanged Then
      ErrNr = SelectData(LastSQLQuery)
    Else
      RecNr = ScrollBarGet(frmDataMask)
      If RecNr < FirstRec Or RecNr >= FirstRec + MaxRows Then
        Call ScrollBarSet(frmMain, RecNr, MaxRows)
      End If
      Call FillTable
    End If

  End With

  Unload frmDataMask
  Set frmDataMask = Nothing

  frmMain.Tbl.HighLight = True

End Sub

Sub EditFunctions(Index)

  With frmMain

    Select Case Index
    Case 0  'Bearbeiten
      Call EditCommand

    Case 1  'Bearbeiten erlaubt
      MnuAllowEdit = Not .pdmnuEdit(Index).Checked
      .pdmnuEdit(Index).Checked = MnuAllowEdit

    Case 2  'Automatisch speichern
      AutoSave = Not .pdmnuEdit(Index).Checked
      .pdmnuEdit(Index).Checked = AutoSave

    Case 3  '---
    Case 4  'Kopieren
      Call CopyTableSel(.Tbl)

    Case 5  'Tabelle kopieren
      Call CopyTableAll(.Tbl)

    Case 6  'alles kopieren
      Call CopyAllCommand

    Case 7  '-

    Case 8  'Datenstze bertragen
      Call StoreResultset

    Case 9        '-

    Case 10        'SQL-Befehl
      Cancel = GetInput(ProgName$, "SQL-Befehl:", LastSQLCommand, InpLine$)
      If Cancel Then Exit Sub

      If Len(InpLine$) > 0 Then
        ErrNr = SQLCommand(InpLine$, 0)
        If ErrNr Then MsgBox LastError
      End If

    End Select

  End With

End Sub

Sub FillMask()

  Dim f$, r$, i
  Dim RecNr As Long

  'Datensatz in Maske ausgeben
  Screen.MousePointer = 11

  With frmDataMask

    RecNr = ScrollBarGet(frmDataMask)

    'Record-Nummer anzeigen
    f$ = "#,##0"
    If InsertMode Then
      r$ = "Neuer Satz"
    Else
      r$ = "Satz " & Format$(RecNr, f$)
    End If
    r$ = r$ & " von " & Format$(dbAnzDsRec, f$)
    .Msg.Caption = r$

    If dbAnzDsRec > 0 Then
      Call ScrollBarSet(frmDataMask, RecNr, 1)

      'Datensatz holen
      Call RetrieveRecord(RecNr)

      'Datensatz ausgeben
      ProgChange = True
      For i = 1 To dbAnzDsFields
        .Txt(i).text = dbDsFieldData(i - 1)
        .Txt(i).Tag = .Txt(i).text         'Undo-Buffer
      Next i
      DoEvents
      ProgChange = False
    End If

 End With

 Call SetChangeState(False)

 Screen.MousePointer = 0

End Sub

Sub StoreResultset()

  Cancel = GetInsertOptions(DstTbl$, ImportMode)
  If Cancel Then Exit Sub

  If DstTbl$ = dbOpenTable Then
    MsgBox Msg$(32298)
    Exit Sub
  End If

  If ImportMode = 2 Then
    ErrNr = DeleteTable(DstTbl$, 32272)
    If ErrNr Then Exit Sub
  End If

  Call ShowMsg(Msg$(32040 + Index) & "...", False, 11)
  ErrNr = CopyRecordset(DstTbl$, ImportMode)
  Call ShowMsg("", True, 0)
  If ErrNr Then Exit Sub

  ErrNr = OpenTbl(DstTbl$)
  If ErrNr = 0 Then
    ErrNr = SelectData(SelectClause & FromClause)
  End If
  Call ShowSelection

End Sub

