Attribute VB_Name = "DbLib"
'Universelle Routinen fr Datenbank-Anwendungen
'Benutzen keine globalen Variablen auer den hier definierten

DefInt A-Z

Option Explicit


'Global SQL$                   'SQL-Befehl

Public LogFileNr
Public LogFileSpec As String

Public LastDBCommand As String
Public LastSQLCommand As String
Public LastSQLQuery As String
Public LastDAOCommand As String
Public LastErrCmd As String
Public LastErrNr As Long
Public LastError As String

'Database variables
Public DB As Database
Public dbDatabaseIsOpen
Public dbOpenDatabase As String
Public dbAnzTables                       'Anzahl Tabellen
Public dbTableNames() As String

'External Database variables
Public ExtDB As Database
Public dbExtAnzTables                       'Anzahl Tabellen
Public dbExtTableNames() As String

'Table variables
Public dbTblDef As TableDef
Public dbTableIsOpen
Public dbOpenTable As String
Public dbAnzTblFields
Public dbTblFieldNames() As String
Public dbTblFieldTypes() As String

'Dynaset/recordset variables
Public ds As Recordset                 'Recordset
Public dbDynasetIsOpen As Integer
Public dbDsIsTable
Public dbAnzDsFields
Public dbDsFieldNames() As String
Public dbDsFieldTypes() As String
Public dbDsFieldWidth()
Public dbTblColWidth()
Public dbAnzDsRec As Long             'Anzahl Records
Public dbDsFieldData() As String      'evtl. spaeter als Variant

'--- Query variables ---
Public SelectMask As Long
Public SelectClause As String     '"SELECT * "        (ending space)
Public FromClause As String       '"FROM name"        (no space)
Public WhereClause As String      '" WHERE condition" (leading space)
Public WhereInfo As String        'Selektierung Liste
'Sortierung
Public OrderNr As Long
Public OrderClause As String      '" ORDER BY name [DESC]"  (leading space)
Public OrderAttrib As String      'Sortierung fr Objekte
Public OrderInfo As String        'Sortierung fr Liste

Function CloseDB()

  Dim ErrNr

  CloseDB = True

  If dbDatabaseIsOpen Then

    ErrNr = CloseTable()
    If ErrNr Then Exit Function

    ErrNr = DAOCommand("CloseDB", "", "", 32289)
    If ErrNr Then Exit Function

    dbOpenDatabase = ""
    dbDatabaseIsOpen = False

    Call RegisterTables

  End If

  CloseDB = False

End Function

Function CloseDynaset()

  Dim ErrNr

  CloseDynaset = True

  If dbDynasetIsOpen Then

    ErrNr = DAOCommand("CloseDynaset", "", "", 32291)
    If ErrNr Then Exit Function

    dbDynasetIsOpen = False
    HammapPossible = 0
    dbAnzDsRec = 0
    Call RegisterDsFields

  End If

  CloseDynaset = False

End Function

Function CloseTable()

  Dim ErrNr

  CloseTable = True

  If dbTableIsOpen Then

    ErrNr = CloseDynaset()
    If ErrNr Then Exit Function

    ErrNr = DAOCommand("CloseTable", "", "", 32290)
    If ErrNr Then Exit Function

    dbOpenTable = ""
    dbTableIsOpen = False

    Call RegisterTblFields

  End If

  CloseTable = False

End Function

Function CombineFields(s() As String) As String

  'Felder zu einer Zeile zusammenfassen
  'Felder mit TAB trennen und CR/LF abschliessen

  Dim i As Integer              'Schleifenzhler
  Dim t As String               'Text
  Dim tb As String              'TAB = Tabulator
  Dim CR As String              'Carriage Return / Line Feed

  tb = Chr$(9)
  CR = Chr$(13) + Chr$(10)

  For i = -1 To UBound(s)
    t = t + tb + s(i)
  Next i

  CombineFields = Mid$(t, 2) + CR

End Function

Function CopyRecordset(DstTbl$, ImportMode)

  'ImportMode: 0=Neue Tabelle, 1=Einfgen, 2 = berschreiben

  CopyRecordset = True

  Dim ErrNr, SQL$, IntoClause$

  IntoClause$ = "INTO " & dbName$(DstTbl$) & " "

  If ImportMode = 1 Then
    'Datenstze in vorhandene Tabelle einfgen (append query)
    SQL$ = "INSERT " & IntoClause$ & LastSQLQuery
  Else
    'Neue Tabelle (make-table query)
    SQL$ = SelectClause & IntoClause$ & FromClause & WhereClause & OrderClause
  End If
  ErrNr = SQLCommand(SQL$, 32293)
  If ErrNr Then Exit Function

  Call RegisterTables

  CopyRecordset = False

End Function

Function CreateDB(FileSpec$, VersionIndex)

  'VersionIndex: 0 = 1.0, 1 = 1.1, 2 = 2.0, 3 = 3.0

  Dim ErrNr

  ErrNr = DAOCommand("CreateDB", FileSpec$, Trim$(Str$(VersionIndex)), 32283)
  If ErrNr Then
    dbOpenDatabase = ""
  Else
    dbOpenDatabase = FileSpec$
  End If

  dbDatabaseIsOpen = (ErrNr = 0)

  Call RegisterTables

  CreateDB = ErrNr

End Function

Sub CreateIndex(PrimaryIdxMask, UniqueIdxMask, CreateIdxMask)

  '----- Create Index -----
  'Global variables:
  '  Tbl = TableDef

  Dim FldNr, Mask, Unique, Primary, ErrNr
  Dim TblName$, FldName$, SQL$

  TblName$ = dbTblDef.Name

  For FldNr = 0 To dbTblDef.Fields.Count - 1
    Mask = 2 ^ FldNr
    Unique = (UniqueIdxMask And Mask) <> 0
    Primary = (PrimaryIdxMask And Mask) <> 0

    If CreateIdxMask And Mask Then
      FldName$ = dbTblDef.Fields(FldNr).Name

        '--- SQL-Version ---
        SQL$ = "CREATE "
        If Unique Then SQL$ = SQL$ & "UNIQUE "
        SQL$ = SQL$ & "INDEX idx" & dbName$(FldName$) & " ON " _
          & dbName$(TblName$) & "(" & dbName$(FldName$) & ")"
        If Primary Then SQL$ = SQL$ & " WITH PRIMARY"
        ErrNr = SQLCommand(SQL$, 32282)


    End If
  Next FldNr

End Sub

Function CreateTable(DstTbl$, ByVal NameList$, ByVal TypeList$)

  Dim i, ErrNr, n$, t$

  CreateTable = True

  ErrNr = CloseTable()
  'ErrNr = DAOCommand("CloseTable", "", "", 32290)
  If ErrNr Then Exit Function

  ErrNr = DAOCommand("CreateTable", DstTbl$, "", 32296)
  If ErrNr Then Exit Function

  Do Until Len(NameList$) = 0
    n$ = Parse$(NameList$, "|")
    t$ = Parse$(TypeList$, "|")

    ErrNr = DAOCommand("CreateField", n$, t$, 32297)
    If ErrNr Then Exit Function
  Loop

  ErrNr = DAOCommand("AppendTable", "", "", 32296)
  If ErrNr Then Exit Function

  ErrNr = CloseTable()

  Call RegisterTables

  CreateTable = False

End Function

Function DAOCommand(Cmd$, Par1$, Par2$, ErrMsgNr)

  Dim m$, ErrNr, ErrDesc$, Exist
  Dim Fld As Field, FldType, FldSize
  Dim dbIsUpdatable

  LastDAOCommand = RTrim$(Cmd$ & " " & Par1$ & " " & Par2$)
  LastDBCommand = "DAO: " & LastDAOCommand

  On Error Resume Next

  Select Case Cmd$
  Case "OpenDB"
    ErrNr = ExistFile(Par1$, True, Exist)
    If ErrNr Then
      Error 53
    Else
      'Wenn Datenbank nicht existiert, strzt System ab !!!
      'Not exclusive, not Read-Only
      Set DB = OpenDatabase(Par1$, False, False)
    End If

  Case "OpenExtDB"
    ErrNr = ExistFile(Par1$, True, Exist)
    If ErrNr Then
      Error 53
    Else
      Set ExtDB = OpenDatabase(Par1$, False, False)
    End If


  Case "CreateDB"
    Set DB = DBEngine.CreateDatabase(Par1$, dbLangGeneral, GetDBVersion(Par2$))

  Case "CompactDB"
    DBEngine.CompactDatabase Par1$, Par2$, dbLangGeneral, dbVersion30

  Case "RepairDB"
    DBEngine.RepairDatabase Par1$

  Case "CloseDB"
    DB.Close
    Set DB = Nothing

  Case "CreateExtDB"
    Set ExtDB = DBEngine.CreateDatabase(Par1$, dbLangGeneral)

  Case "CloseExtDB"
    ExtDB.Close
    Set ExtDB = Nothing

  Case "OpenTable"
    Set dbTblDef = DB.TableDefs(Par1$)

  Case "CreateTable"
    Set dbTblDef = New TableDef
    dbTblDef.Name = Par1$

  Case "AppendTable"
    DB.TableDefs.Append dbTblDef

  Case "RenameTable"
    DB.TableDefs(Par1$).Name = Par2$

  Case "CloseTable"
    Set dbTblDef = Nothing

  Case "DeleteTable"
    DB.TableDefs.Delete Par1$

  Case "DeleteExtTable"
    ExtDB.TableDefs.Delete Par1$

  Case "CreateDynaset"
    Set ds = DB.OpenRecordset(Par1$, dbOpenDynaset)
    LastDBCommand = "SQL: " & Par1$

  Case "CloseDynaset"
    ds.Close
    Set ds = Nothing

  Case "CreateField"
    ErrNr = GetFieldType(Par2$, FldType, FldSize)
    If ErrNr Then
      m$ = Msg$(32300) & ": " & Par2$
      Call LogCommand(32300, m$, 32300)
    Else
      Set Fld = New Field
      Fld.Name = Par1$
      Fld.Type = FldType
      If FldType = dbText Then Fld.Size = FldSize
      dbTblDef.Fields.Append Fld
      Set Fld = Nothing
    End If

  Case "RenameField"
    dbTblDef.Fields(Par1$).Name = Par2$

  Case "DeleteField"
    dbTblDef.Fields.Delete Par1$

  Case Else
    MsgBox "Ungltiger DAO-Befehl"
  End Select

  If ErrNr = 0 Then
    ErrNr = Err
    ErrDesc$ = Error
  End If
  On Error GoTo 0

  Call LogCommand(ErrNr, ErrDesc$, ErrMsgNr)

  DAOCommand = ErrNr

End Function

Function dbName$(n$)

  Dim i, SpChr

  'Punkt '.' ntig fr Tabellenname '*.CSV'
  Const ChrList = " -$."

  For i = 1 To Len(ChrList)
    If InStr(n$, Mid$(ChrList, i, 1)) Then
      SpChr = True
      Exit For
    End If
  Next i

  If SpChr Then
    dbName$ = "[" & n$ & "]"
  Else
    dbName$ = n$
  End If

End Function

Function DeleteField(ByVal FldName$, ConfirmMsg)

  Dim m$, SQL$, Answer, ErrNr

  DeleteField = True

  If ConfirmMsg > 0 Then
    m$ = Replace$(Msg$(ConfirmMsg), "%", FldName$)
    Answer = MsgBox(m$, 4)
    If Answer = 7 Then Exit Function   'No
  End If

  ErrNr = CloseDynaset()

  If ErrNr = 0 Then
    ErrNr = DAOCommand("DeleteField", FldName$, "", 32295)
  End If

  dbTblDef.Fields.Refresh
  Call RegisterTblFields

  DeleteField = ErrNr

End Function

Function DeleteTable(ByVal TblName$, ConfirmMsg)

  Dim m$, Answer, ErrNr

  DeleteTable = True

  If ConfirmMsg > 0 Then
    m$ = Replace$(Msg$(ConfirmMsg), "%", TblName$)
    Answer = MsgBox(m$, 4)
    If Answer = 7 Then Exit Function   'No
  End If

  ErrNr = CloseTable()
  If ErrNr Then Exit Function

  'SQL-Version
  ErrNr = SQLCommand("DROP TABLE " & dbName$(TblName$), 32287)

  If ErrNr Then Exit Function

  Call RegisterTables

  DeleteTable = False

End Function

Function ExistTable(n$, ExtDB)

  Dim i

  ExistTable = True

  If ExtDB = 0 Then
    For i = 1 To dbAnzTables
      If UCase$(n$) = UCase$(dbTableNames(i)) Then
        Exit Function
      End If
    Next i
  Else
    For i = 1 To dbExtAnzTables
      If UCase$(n$) = UCase$(dbExtTableNames(i)) Then
        Exit Function
      End If
    Next i
  End If

  ExistTable = False

End Function

Function ExistTblField(n$)

  Dim i

  ExistTblField = True

  For i = 0 To dbAnzTblFields - 1
    If UCase$(n$) = UCase$(dbTblFieldNames(i)) Then
      Exit Function
    End If
  Next i

  ExistTblField = False

End Function

Function ExportDB(DstDB$, DstTbl$, DstType$)

  Dim INClause$, SQL$, SrcTbl$

  If UCase$(SrcTbl$) = UCase$(DstTbl$) Then
    MsgBox "Ursprungs- und Zieltabelle drfen nicht den gleichen Namen haben!"
    Exit Function
  End If

  INClause$ = GetINClause(DstDB$, DstTbl$, DstType$)

  'SQL$ = "SELECT * INTO [" & DstTbl$ & "]" & INClause$
  'SQL$ = SQL$ & " FROM " & SrcTbl$ & WhereClause & OrderClause

  SQL$ = SelectClause & "INTO " & dbName$(DstTbl$) _
       & INClause$ & " " & FromClause & WhereClause & OrderClause

  ExportDB = SQLCommand(SQL$, 32280)

End Function

Function GetDBVersion(s$)

  'Version-Index: 0 = 1.0, 1 = 1.1, 2 = 2.0, 3 = 3.0, 4 = 4.0


  Select Case Val(s$)
  Case (0): GetDBVersion = dbVersion10
  Case (1): GetDBVersion = dbVersion11
  Case (2): GetDBVersion = dbVersion20
  Case (3): GetDBVersion = dbVersion30
  'Case (4): GetDBVersion = dbVersion40
  Case Else: Stop
  End Select


End Function

Function GetDsFieldNr(n$)

  Dim i

  For i = 0 To dbAnzDsFields - 1
    If UCase$(n$) = UCase$(dbDsFieldNames(i)) Then
      GetDsFieldNr = i
      Exit Function
    End If
  Next i

  GetDsFieldNr = -1

End Function

Function GetFieldType(HMType$, FldType, FldSize)

  GetFieldType = True

  FldSize = Val(Mid$(HMType$, 2))

  Select Case Left$(HMType$, 1)
  Case "T"
    FldType = dbText

  Case "I"
    Select Case FldSize
    Case 1
      FldType = dbByte
    Case 2
      FldType = dbInteger
    Case 4
      FldType = dbLong
    Case Else
      Exit Function
    End Select

  Case "F"
    Select Case FldSize
    Case 4
      FldType = dbSingle
    Case 8
      FldType = dbDouble
    Case Else
      Exit Function
    End Select

  Case "C": FldType = dbCurrency
  Case "D": FldType = dbDate
  Case "M": FldType = dbMemo
  Case Else: Exit Function
  End Select

  GetFieldType = False

End Function

Function GetHMFieldSize(HmFieldType$)

  Dim AnzBytes, n

  AnzBytes = Val(Mid$(HmFieldType$, 2))

  Select Case Left$(HmFieldType$, 1)
  Case "T": n = AnzBytes
  Case "C": n = 20
  Case "D": n = 8
  Case "M": n = 50

  Case "I"
    Select Case AnzBytes
    Case 1: n = 3   '0...255
    Case 2: n = 7   '-32.768...32.767
    Case 4: n = 14
    Case Else: Stop
    End Select

  Case "F"
    Select Case AnzBytes
    Case 4: n = 12
    Case 8: n = 22
    Case Else: Stop
    End Select

  Case Else: Stop
  End Select

  GetHMFieldSize = n

End Function

Function GetHMFieldType(ByVal dbFldType, ByVal dbFldSize) As String

  Dim s$, t$

  s$ = CStr(dbFldSize)
  Select Case dbFldType
  Case dbBoolean: t$ = "B"
  Case dbByte To dbLong: t$ = "I" & s$
  Case dbSingle To dbDouble: t$ = "F" & s$
  Case dbDate: t$ = "D"
  Case dbMemo: t$ = "M"
  Case dbText: t$ = "T" & s$
  Case Else: t$ = "?"
  End Select

  GetHMFieldType = t$

End Function

Function GetINClause$(ExtDB$, ExtTbl$, ExtType$)

  'Input:  ExtFile$, ExtType$
  'Output: INClause$, ExtTbl$

  Dim ErrNr

  'einfache Quotes (') gehen nicht bei EXCEL 5.0 ... 8.0 !!!

  If ExtType$ = "Access" Then
    'GetINClause$ = " IN '" & ExtDB$ & "'"
    GetINClause$ = " IN """ & ExtDB$ & """"
  Else
    'geht nur in VB5
    'GetINClause$ = " IN '' [" & ExtType$ & "; DATABASE=" & ExtDB$ & ";]"
    GetINClause$ = " IN """" [" & ExtType$ & "; DATABASE=" & ExtDB$ & ";]"
  End If

End Function

Function ImportDB(SrcDB$, SrcTbl$, SrcType$, ImportMode, DstTbl$)

  'ImportMode: 0=Neue Tabelle, 1=Einfgen, 2 = berschreiben

'!!! Testen, welche Version schneller ist !!!

  Dim ErrNr, INClause$, SQL$

  ImportDB = True

  '--- Import using external database ---
  If UCase$(SrcTbl$) = UCase$(DstTbl$) Then
    MsgBox "Ursprungs- und Zieltabelle drfen nicht den gleichen Namen haben!"
    Exit Function
  End If

  INClause$ = GetINClause(SrcDB$, SrcTbl$, SrcType$)

  If ImportMode = 1 Then
    'Datenstze in vorhandene Tabelle einfgen (append query)
    SQL$ = "INSERT INTO " & dbName$(DstTbl$) _
        & " SELECT * FROM " & dbName$(SrcTbl$) & INClause$
  Else
    'Neue Tabelle (make-table query)
    SQL$ = "SELECT * INTO " & dbName$(DstTbl$) _
        & " FROM " & dbName$(SrcTbl$) & INClause$
  End If

  ErrNr = SQLCommand(SQL$, 32281)
  If ErrNr Then Exit Function


  Call RegisterTables

  ImportDB = False

End Function

Sub LogCommand(ErrNr, ErrDesc$, ErrMsgNr)

  Dim m$, void

  If ErrNr Then
    LastErrCmd = LastDBCommand
    LastErrNr = ErrNr
    LastError = Trim$(Str$(ErrNr)) & ": " & ErrDesc$

    Select Case ErrMsgNr
    Case -1
      MsgBox LastError
    Case 0
    Case Else
      m$ = Msg$(ErrMsgNr)
      MsgBox m$
    End Select
  End If

  If LogFileNr Then
    void = WriteLine(LogFileNr, LastDBCommand)
    If ErrNr = 0 Then
      void = WriteLine(LogFileNr, "  ;Ok")
    Else
      If ErrMsgNr > 0 Then
        void = WriteLine(LogFileNr, "  ;" & Msg$(ErrMsgNr))
      End If
      void = WriteLine(LogFileNr, "  ;" & LastError)
    End If
  End If

End Sub

Sub MoveDS(NewRec As Long)

  'Dynaset positionieren
  'NewRec = 0: Anzahl Datenstze bestimmen
  'NewRec > 0: Auf Datensatz NewRec positionieren
  'NewRec < 0: -NewRec als aktuellen Satz setzen
  'Achtung: ds.RecordCont mu gltig sein (s.Handbuch)

  Dim i As Long             'Laufvariable
  Dim Diff As Long          'Differenz
  Static CurRec As Long     'aktueller Datensatz

  If NewRec = 0 Then
    'Anzahl Stze bestimmen
    With ds
      dbAnzDsRec = .RecordCount
      If dbAnzDsRec > 0 Then
        .MoveLast
        .MoveFirst
        dbAnzDsRec = .RecordCount
        CurRec = 1
      End If
    End With
    Exit Sub
  End If

  'prfen, ob neuer = aktuellem Datensatz
  Diff = NewRec - CurRec
  If Diff = 0 Then Exit Sub

  With ds
    If NewRec = 1 Then
      .MoveFirst
    ElseIf NewRec = dbAnzDsRec Then
      .MoveLast
    Else
      .Move Diff
    End If

    CurRec = NewRec

  End With

End Sub

Function OpenDB(FileSpec$)

  Dim Attr, m$, ErrNr

  ErrNr = GetFileAttr(FileSpec$, Attr)
  If ErrNr = 0 Then
    If Attr And 1 Then
      'Database is Read-only
      ErrNr = 32303
      Call FileError(Msg$(ErrNr), FileSpec$)
    Else
      '--- Open Database (non Exclusive, Read/Write) ---
      ErrNr = DAOCommand("OpenDB", FileSpec$, "", 32284)
    End If
  End If

  If ErrNr Then
    dbOpenDatabase = ""
  Else
    dbOpenDatabase = FileSpec$
  End If

  dbDatabaseIsOpen = (ErrNr = 0)

  Call RegisterTables

  OpenDB = ErrNr

End Function

Function OpenTbl(ByVal n$)

  'OpenTable is a keyword in VB3

  Dim ErrNr

  OpenTbl = True

  ErrNr = CloseTable()
  If ErrNr Then Exit Function

  ErrNr = DAOCommand("OpenTable", n$, "", 32285)
  If ErrNr Then
    'Tabelle kann nicht geffnet werden
    dbTableIsOpen = False
    dbOpenTable = ""
  Else
    dbTableIsOpen = True
    dbOpenTable = n$
    SelectMask = -1&
    SelectClause = "SELECT * "
    FromClause = "FROM " & dbName$(dbOpenTable)
    OrderNr = 0
    OrderClause = ""
    OrderAttrib = ""
    OrderInfo = "unsortiert"
  End If

  Call RegisterTblFields

  OpenTbl = ErrNr

End Function

Sub RegisterDsFields()

  Dim i, t$

  If dbDynasetIsOpen = 0 Then

    dbAnzDsFields = 0

    On Error Resume Next
    Erase dbDsFieldNames
    Erase dbDsFieldTypes
    Erase dbDsFieldWidth
    Erase dbTblColWidth
    Erase dbDsFieldData
    On Error GoTo 0

  Else

    '--- Felder von DS holen (Feld 0 = Lfd.Nr.) ---
    dbAnzDsFields = ds.Fields.Count

    ReDim dbDsFieldNames(-1 To dbAnzDsFields - 1)
    dbDsFieldNames(-1) = "Nr."

    ReDim dbDsFieldTypes(-1 To dbAnzDsFields - 1)
    dbDsFieldTypes(-1) = "I2"

    ReDim dbDsFieldWidth(-1 To dbAnzDsFields - 1)
    dbDsFieldWidth(-1) = GetHMFieldSize(dbDsFieldTypes(-1))                  'Nr.

    ReDim dbTblColWidth(-1 To dbAnzDsFields - 1)
    dbTblColWidth(-1) = dbDsFieldWidth(-1)

    ReDim dbDsFieldData(-1 To dbAnzDsFields - 1)

    For i = 0 To dbAnzDsFields - 1
      With ds.Fields(i)
        dbDsFieldNames(i) = .Name
        t$ = GetHMFieldType(.Type, .Size)
        dbDsFieldTypes(i) = t$
        dbDsFieldWidth(i) = GetHMFieldSize(t$)
        dbTblColWidth(i) = dbDsFieldWidth(i)
      End With

      If dbTblColWidth(i) < Len(dbDsFieldNames(i)) Then
        dbTblColWidth(i) = Len(dbDsFieldNames(i))
      End If
    Next i

    'Prfen, ob Ds = Tbl
    If dbAnzTblFields = dbAnzDsFields Then
      dbDsIsTable = True
      For i = 0 To dbAnzDsFields - 1
        If dbDsFieldNames$(i) <> dbTblFieldNames$(i) Then
          dbDsIsTable = False
          Exit For
        End If
      Next i
    Else
      dbDsIsTable = False
    End If

  End If

End Sub

Function RegisterExtDBTables(FileSpec$)

  Dim i, ErrNr, n$, a&

  dbExtAnzTables = 0

  RegisterExtDBTables = True

  'Non-exclusive, Read-only
  ErrNr = DAOCommand("OpenExtDB", FileSpec$, "", 32284)
  If ErrNr Then Exit Function

  ReDim dbExtTableNames(1 To ExtDB.TableDefs.Count) As String

  On Error Resume Next

  For i = 0 To ExtDB.TableDefs.Count - 1
    If Err Then Exit For
    n$ = ExtDB.TableDefs(i).Name
    If Err Then Exit For
      'Debug.Print n$
    If Left$(n$, 4) <> "MSys" Then
      'No SystemTable
      dbExtAnzTables = dbExtAnzTables + 1
      dbExtTableNames(dbExtAnzTables) = n$
    End If
  Next i

  ErrNr = Err
  On Error GoTo 0

  RegisterExtDBTables = ErrNr

End Function

Sub RegisterTables()

  Dim i, n$, a&

  dbAnzTables = 0

  If dbDatabaseIsOpen Then

    DB.TableDefs.Refresh

    ReDim dbTableNames(1 To DB.TableDefs.Count) As String

    For i = 0 To DB.TableDefs.Count - 1
      n$ = DB.TableDefs(i).Name
        'a& = DB.TableDefs(i).Attributes
        'Debug.Print n$, Hex$(a&)
      If Left$(n$, 4) <> "MSys" Then
        'No SystemTable
        dbAnzTables = dbAnzTables + 1
        dbTableNames(dbAnzTables) = n$
      End If
    Next i

  End If

  If dbAnzTables = 0 Then
    dbOpenTable = ""
    dbTableIsOpen = False

    On Error Resume Next
    Erase dbTableNames
    On Error GoTo 0

    Call RegisterTblFields
  End If

End Sub

Sub RegisterTblFields()

  Dim i

  If dbTableIsOpen = 0 Then

    dbAnzTblFields = 0

    On Error Resume Next
    Erase dbTblFieldNames
    Erase dbTblFieldTypes
    On Error GoTo 0

  Else

    dbAnzTblFields = dbTblDef.Fields.Count
    ReDim dbTblFieldNames(0 To dbAnzTblFields - 1)
    ReDim dbTblFieldTypes(0 To dbAnzTblFields - 1)

    For i = 0 To dbAnzTblFields - 1
      With dbTblDef.Fields(i)
        dbTblFieldNames(i) = .Name
        dbTblFieldTypes(i) = GetHMFieldType(.Type, .Size)
      End With
    Next i

  End If

End Sub

Function RenameField(ByVal OldName$, NewName$)

  Dim ErrNr

  RenameField = True

  ErrNr = CloseDynaset()
  If ErrNr Then Exit Function

  ErrNr = DAOCommand("RenameField", OldName$, NewName$, 32294)
  If ErrNr Then Exit Function

  dbTblDef.Fields.Refresh
  Call RegisterTblFields

  RenameField = False

End Function

Function RenameTable(ByVal OldName$, NewName$)

  Dim ErrNr

  RenameTable = True

  ErrNr = CloseTable()
  If ErrNr Then Exit Function

  ErrNr = DAOCommand("RenameTable", OldName$, NewName$, 32286)
  If ErrNr Then Exit Function

  Call RegisterTables

  RenameTable = False

End Function

Function SQLCommand(ByVal SQLCmd$, ErrMsgNr)

  Dim ErrNr, ErrDesc$, m$

  LastSQLCommand = SQLCmd$
  LastDBCommand = "SQL: " & LastSQLCommand

  On Error Resume Next
  DB.Execute LastSQLCommand
  ErrNr = Err
  ErrDesc$ = Error
  On Error GoTo 0

  Call LogCommand(ErrNr, ErrDesc$, ErrMsgNr)

  SQLCommand = ErrNr

End Function

Function SQLQuery(ByVal SQLCmd$)

  Dim i, ErrNr

  SQLQuery = True

  'Dynaset schlieen, falls offen
  ErrNr = CloseDynaset()
  If ErrNr Then Exit Function

  LastSQLQuery = SQLCmd$

  i = InStr(SQLCmd$, " FROM ")
  If i = 0 Then Exit Function

  ErrNr = DAOCommand("CreateDynaset", SQLCmd$, "", 0)
  If ErrNr Then
    dbDynasetIsOpen = False
    HammapPossible = 0
    dbAnzDsRec = 0
    Exit Function
  Else
    dbDynasetIsOpen = True
    Call RegisterDsFields
    Call CheckHammapPossible
  End If

  SQLQuery = ErrNr

End Function

Function tblCase$(n$)

  Dim i

  tblCase$ = n$

  For i = 1 To dbAnzTables
    If UCase$(n$) = UCase$(dbTableNames(i)) Then
      tblCase$ = dbTableNames(i)
      Exit Function
    End If
  Next i

End Function

Function WriteDS(FileSpec$, Header$, Sep$, Trailer$, Options)

  Dim RecNr&, ErrNr, FileNr, lsep
  Dim i, s$

  WriteDS = True

  lsep = Len(Sep$)

  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr Then Exit Function

  'Write Field Names
  If Options And 1 Then
    s$ = ""
    For i = 0 To dbAnzDsFields - 1
      s$ = s$ & Sep$ & ds(i).Name
    Next i
    ErrNr = WriteLine(FileNr, Header$ & Mid$(s$, lsep + 1) & Trailer$)
  End If

  If ErrNr = 0 Then
    For RecNr& = 1 To dbAnzDsRec
      Call MoveDS(RecNr&)

      s$ = ""

      For i = 0 To dbAnzDsFields - 1
        s$ = s$ & Sep$ & ds(i).Value
      Next i

      ErrNr = WriteLine(FileNr, Header$ & Mid$(s$, lsep + 1) & Trailer$)
      If ErrNr Then Exit For
    Next RecNr&
  End If

  ErrNr = ErrNr Or CloseFile(FileNr)

  WriteDS = ErrNr

End Function

