Attribute VB_Name = "dbSearch"
DefInt A-Z

Sub GetSelect()

  Dim Change&, AllFields&, f$, i, SaveSelect&

  SaveSelect& = SelectMask&
  FilterMsgSrc = 3

  Do
    Cancel = CheckBoxMask("Felder", 0, 0, SelectMask&, 0&, Change&)
    If Change& = 0 Then
      SelectMask = SaveSelect&
    Else
      AllFields& = 2& ^ dbAnzTblFields - 1
      If (SelectMask& And AllFields&) = AllFields& Then
        SelectClause = "SELECT * "
      Else
        f$ = ""
        For i = 0 To dbAnzTblFields - 1
          If SelectMask& And 2& ^ i Then
            f$ = f$ & "," & dbName$(dbTblFieldNames(i))
          End If
        Next i
        If Len(f$) = 0 Then
          MsgBox "Kein Feld ausgewhlt"
        Else
          SelectClause = "SELECT " & Mid$(f$, 2) & " "
        End If
      End If
    End If
  Loop Until SelectMask <> 0

End Sub

Sub GetSort()

  Dim t$, Cancel, Mask&

  Mask& = OrderNr
  If Mask& > dbAnzTblFields Then Mask& = 0

  t$ = "HAMINFO - Sortierung"
  FilterMsgSrc = 2
  Cancel = RadioBtnMask(t$, 0, 1, Mask&, 0&, Change&)
  If Cancel Then Exit Sub

  OrderNr = Mask& - 1

  If OrderNr < 0 Then
    OrderClause = ""
    OrderAttrib = ""
    OrderInfo = "unsortiert"
  Else
    OrderClause = " ORDER BY " & dbName$(dbTblFieldNames(OrderNr))
    OrderAttrib = dbTblFieldNames(OrderNr)
    OrderInfo = "Sortierung nach: '" & dbTblFieldNames(OrderNr) & "'"
  End If

End Sub

Function GetWhereClause()

  Dim i, Exact
  Dim t$, s$, ls$, m$
  Dim SeqSearch

  GetWhereClause = False

  With frmSeek

    Exact = .Exact.Value

    For i = 1 To dbAnzTblFields

      t$ = .Txt(i).text
      If Right$(t$, 1) <> "*" And Exact = 0 Then
        t$ = t$ & "*"
      End If

      Select Case t$
      Case "*", "?", "*?", "?*"
        t$ = ""
      End Select

      If Len(t$) > 0 Then
        s$ = s$ & " AND " & dbName$(dbTblFieldNames(i - 1))
        ls$ = ls$ & ", " & dbName$(dbTblFieldNames(i - 1))

        'Prfung ob sequentielle Suche
        If Len(t$) > 1 Then
          If Left$(t$, 1) = "*" Or Left$(t$, 1) = "?" Then
            SeqSearch = True
          End If
        End If

        'Prfung ob '=' or 'LIKE'
        If InStr(t$, "*") Or InStr(t$, "?") Then
          s$ = s$ & " LIKE "
        Else
          s$ = s$ & "="
        End If

        s$ = s$ & "'" & t$ & "'"
        ls$ = ls$ & "='" & t$ & "'"

      End If

    Next i

    If Len(s$) > 0 Then

      s$ = Mid$(s$, 6)
      WhereClause = " WHERE " & s$
      ls$ = Mid$(ls$, 3)

      If SeqSearch Then
        m$ = "Suche mit '*' oder '?' am Anfang dauert etwas lnger."
        m$ = m$ + Chr$(13) + Chr$(10) + "Wollen Sie trotzdem suchen?"
        If MsgBox(m$, 256 + 4) = 7 Then Exit Function
      End If

    Else
      WhereClause = ""
      ls$ = "*"
    End If

    WhereInfo = "Suche nach: " & ls$

  End With

  GetWhereClause = True

End Function

Sub SearchCommand()

  Dim i, h, SeekOk, SQL$
  Static OldTableName$, OldDBName$, Save$()
  Static Saved, SaveExact, ErrNr, Cmd

  If OldTableName$ <> dbOpenTable Or OldDBName$ <> DB.Name Then
    Saved = False
    OldDBName$ = DB.Name
    OldTableName$ = dbOpenTable
  End If

  If Not Saved Then ReDim Save$(1 To dbAnzTblFields)

  Call InitMask(frmSeek, 0, False)

  With frmSeek
    If dbOpenTable = "tblLocator" Then
      .Txt(4).ToolTipText = appGetDataTip$()
    End If

    .Exact.Top = TopDist + (dbAnzTblFields + 0.5) * FldDist

    h = .Exact.Top + FldDist + 2 * TopDist
    If h > .Height Then .Height = h

    .Exact.Value = SaveExact

    If Saved Then
      For i = 1 To dbAnzTblFields
        .Txt(i).text = Save$(i)
      Next i
    End If

    Call CenterForm(frmSeek)

    Do
      '--- Show Form and wait for Input ---
      'Call SetTop(frmSeek.hWnd, True)
      .Show 1
      'Call SetTop(frmSeek.hWnd, False)
      Cmd = Val(frmSeek.Tag)
      Select Case Cmd
      Case 2
        Call GetSort
      Case 3
        Call GetSelect
      End Select
    Loop Until Cmd < 2

    If Cmd = 0 Then
      'Ok Button -> start seek
      Saved = True
      SaveExact = .Exact.Value
      For i = 1 To dbAnzTblFields
        Save$(i) = .Txt(i).text
      Next i

      SeekOk = GetWhereClause()

      If SeekOk Then
        SQL$ = SelectClause & FromClause & WhereClause & OrderClause
        ErrNr = SelectData(SQL$)
      End If
    End If

  End With

  Unload frmSeek
  Set frmSeek = Nothing

End Sub

Sub SearchFunctions(Index)

  Title$ = ProgName$ & " - " & StdMsg$(32170 + Index)

  Select Case Index
  Case 0
    Call SearchCommand

  Case 1
    t$ = dbName$(dbOpenTable)
    f$ = dbName$(Tbv.ActFieldName)
    SQL$ = "SELECT DISTINCT " & f$ & ", COUNT(*) as Anzahl FROM "
    SQL$ = SQL$ & t$ & " GROUP BY " & f$ & " ORDER BY COUNT(*)"
    ErrNr = SelectData(SQL$)
    If ErrNr Then MsgBox LastError

  Case 2
    Cancel = GetInput(ProgName$, Title$ & ":", LastSQLQuery, InpLine$)
    If Cancel Then Exit Sub

    If Len(InpLine$) > 0 Then
      ErrNr = SelectData(InpLine$)
    End If
  End Select

End Sub

