Attribute VB_Name = "DrawWater"
'--------------------------- GDISUB.BAS ------------------------

'GDI-Unterprogramme (Graphics Device Interface)
'von Gerhard Berg, DJ6FM

DefInt A-Z



'----- Variables -----
Dim WaterPoints() As lPoint
Dim AnzWaterPoints As Integer

Sub AddWaterPoint(xgeo As Long, ygeo As Long)

  AnzWaterPoints = AnzWaterPoints + 1

  ReDim Preserve WaterPoints(1 To AnzWaterPoints) As lPoint

  WaterPoints(AnzWaterPoints).x = xgeo
  WaterPoints(AnzWaterPoints).y = ygeo

  Call NewMap

  Answer = GrMsgBox(Msg$(24110), 4)
  If Answer = 7 Then
    AnzWaterPoints = AnzWaterPoints - 1
    Call NewMap
  End If

End Sub

Function DrawExtraWaterPoints()

  If AnzWaterPoints = 0 Then Exit Function

  '--- Wasser anmalen ---
  ErrNr = PrepareMapDevices(7)

  If HV.PrtEnbl And 1 Then
    For i = 1 To AnzWaterPoints
      Call DrawWaterGeo(HMCrt, WaterPoints(i).x, WaterPoints(i).y)
    Next i
  End If

  If HV.PrtEnbl And 2 Then
    For i = 1 To AnzWaterPoints
      Call DrawWaterGeo(HMPrt, WaterPoints(i).x, WaterPoints(i).y)
    Next i
  End If

  ErrNr = TerminateAllDevices()

End Function

Sub DrawSingleWaterPoint(xgeo As Long, ygeo As Long)

  '--- Wasser anmalen ---
  ErrNr = PrepareMapDevices(7)

  If HV.PrtEnbl And 1 Then
    Call DrawWaterGeo(HMCrt, xgeo, ygeo)
  End If

  If HV.PrtEnbl And 2 Then
    Call DrawWaterGeo(HMPrt, xgeo, ygeo)
  End If

  ErrNr = TerminateAllDevices()

End Sub

Sub DrawWaterGeo(Dev As HMDevice, xgeo As Long, ygeo As Long)

  Dim p As PointApi

  'FloodFill geht nicht
  If Dev.FloodFillErr Then Exit Sub

  If Dev.hDev = 0 Then Stop

  p.x = SecGeo2AbsX(Dev, xgeo)
  p.y = SecGeo2AbsY(Dev, ygeo)

  If Not PointInRect(p, Dev.MapRect) Then Exit Sub

  'Complete all drawing operations
  Ok& = GdiFlush&()

  'Farbe am Fllpunkt ermitteln
  ActCol& = GetPixel&(Dev.hDev, p.x, p.y)

  If NumPar(35).Actual And 4 Then       'Debug
    MapForm.Refresh
    AnzFields = NumPar(59).Actual + 1
    m$ = lSecCoord2StrEx$(xgeo, AnzFields) & " / "
    m$ = m$ & lSecCoord2StrEx$(ygeo, AnzFields) & " / "
    m$ = m$ & Hex$(ActCol&) & " / " & Hex$(Dev.WinWaterCol) & " / " & Hex$(Dev.WinBorderCol)
    Answer = MsgBox(m$, 3)
    If Answer = 2 Then
      NumPar(35).Actual = NumPar(35).Actual And Not 4&
    End If
    If Answer <> 6 Then Exit Sub
  End If

  'Pruefen, ob schon ausgefuellt oder Rand
  If ActCol& <> Dev.WinWaterCol And ActCol& <> Dev.WinBorderCol Then

    '----- Wasser ausfllen -----
    FillOk = FloodFill(Dev.hDev, p.x, p.y, Dev.WinBorderCol)
    'FillOk = ExtFloodFill(Dev.hDev, p.X, p.Y, Dev.WinBorderCol, FLOODFILLBORDER)
    If FillOk = 0 Then
      If Dev.Id = 1 Then
        Call ShowErrNr(19901)
        Dev.FloodFillErr = True
      End If
    End If
  End If


  'Wasserpunkt markieren
  If NumPar(35).Actual And 2 Then       'Debug
    ErrNr = DrawSymbolGeo(Dev, xgeo, ygeo, 0, &HFF)
  End If

End Sub

Function DrawWaterSegment(Dev As HMDevice)

  Dim CoCl As CoordCluster
  Dim x As Long, y As Long

  If (Dev.Options And 3) <> 3 Then Exit Function
  'Wasser einfrben geht nicht in Windows Metafile
  If Dev.Id = 1 And (HV.PrtEnbl And &H30) <> 0 Then Exit Function

  DrawWaterSegment = True

  If Dev.hDev = 0 Then Stop

  x = MV.Sg.x
  y = MV.Sg.y


  '--- Ersten Wasserpunkt ausgeben ---
  Call DrawWaterGeo(Dev, x, y)


  'Ende, wenn keine weiteren Koordinaten
  If MV.Sg.KoCnt = 0 Then
    DrawWaterSegment = False
    Exit Function
  End If


  '--- Weitere Punkte ausgeben ---
  Select Case HV.CoLoadMode
  Case 0
    ErrNr = SeekFile(MV.In.BmcFile, (MV.Sg.KoBeg - 1) * CoRecLen + 1)
    If ErrNr Then Exit Function

    ResetCache = True
  Case 2
    s1 = (MV.Sg.KoBeg - 1) Mod HV.MapDim
    s2 = (MV.Sg.KoBeg - 1) \ HV.MapDim
  End Select


  For i& = MV.Sg.KoBeg To MV.Sg.KoBeg + MV.Sg.KoCnt - 1

    Select Case HV.CoLoadMode
    Case 0
      '--- Linie von Datei ausgeben ---
      ErrNr = GetCoordCache(MV.In.BmcFile, MV.co, ResetCache)
      If ErrNr Then Exit Function
      x = x + MV.co.x
      y = y + MV.co.y

    Case 1
      '--- Linie aus RAM ausgeben ---
      x = x + Karte1(i&).x
      y = y + Karte1(i&).y

    Case 2
      x = x + Karte2(s1, s2).x
      y = y + Karte2(s1, s2).y

      s1 = s1 + 1
      If s1 = HV.MapDim Then
        s1 = 0
        s2 = s2 + 1
      End If
    End Select

    '--- Wasserpunkt ausgeben ---
    Call DrawWaterGeo(Dev, x, y)

  Next i&

  DrawWaterSegment = False

End Function

Sub EraseWaterPoints()

  AnzWaterPoints = 0
  Erase WaterPoints

End Sub

