Attribute VB_Name = "DrawGrid"
'-------------------------- DRAWGRID.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function DrawTextGeo(Dev As HMDevice, a As lAreaType, Txt$, Center, NewFont As HMFont, ForeCol&)

  'Center: 0 = left top corner, 1 = center

  Dim r As RECT
  Dim rtxt As RECT
  Dim NewPen As HMPen

  If Dev.hDev = 0 Then Stop

  DrawTextGeo = True

  'Farbe whlen
  If ForeCol& <> Dev.TextColor Then
    Call ChangeTextColor(Dev, ForeCol&)
  End If

  'Font whlen
  ErrNr = SetFont(Dev, NewFont)

  'Position umrechnen
  Call larea2Rect(Dev, a, 0, r)

  h = DrawText(Dev.hDev, Txt$, -1&, rtxt, DT_CALCRECT + DT_SINGLELINE)
  w = rtxt.Right - rtxt.Left

  If Center > 0 Then
    r.Left = (r.Left + r.Right - w) / 2
    r.Top = (r.Top + r.Bottom - h) / 2
  End If

  r.Right = r.Left + w
  r.Bottom = r.Top + h

  If RectInRect(0, r, Dev.MapRect) Then
    'Text mu komplett in Karte passen

    If Dev.Options And 8 Then
      'Text hinterlegen
      r.Right = r.Right + 1     '1 Pixel Rand rechts
      NewPen.Color = HV.BackCol
      NewPen.Width = 1
      NewPen.Style = 0
      ErrNr = DrawFigureAbs(Dev, r, 11, NewPen, NewPen.Color, 0)
    End If

    th = DrawText(Dev.hDev, Txt$, -1&, r, DT_SINGLELINE + DT_NOCLIP)

  End If

  DrawTextGeo = ErrNr

End Function

Function ShowGrid(Size, MarkMode, ErrEnbl)

  ShowGrid = -3                 'Fehler-Nr fuer DDE

  Short = 1     'automatic

  CrtLineWidth = GetLineWidth(0, 7)
  PrtLineWidth = GetLineWidth(1, 7)

  If HV.PrtEnbl And 1 Then
    ErrNr = ShowGrid1(HMCrt, Size, MarkMode, Short, CrtLineWidth, ErrEnbl)
    If ErrNr Then Exit Function
  End If

  If HV.PrtEnbl And 2 Then
    ErrNr = ShowGrid1(HMPrt, Size, MarkMode, Short, PrtLineWidth, ErrEnbl)
    If ErrNr Then Exit Function
  End If

  If Size > 1 Then
    If MarkMode Then MarkMode = Short
    Short = False
    If HV.PrtEnbl And 1 Then
      ErrNr = ShowGrid1(HMCrt, Size - 1, MarkMode, Short, CrtLineWidth + 1, ErrEnbl)
    End If

    If HV.PrtEnbl And 2 Then
      ErrNr = ShowGrid1(HMPrt, Size - 1, MarkMode, Short, PrtLineWidth + 1, ErrEnbl)
    End If
    If ErrNr Then Exit Function
  End If

  ShowGrid = 0

End Function

Function ShowGrid1(Dev As HMDevice, Size, MarkMode, Short, DrawWidth, ErrEnbl)

  'MarkMode: 0=none, 1=only in corners, 2=all fields

  'Short: 0=off(full QTH), 1=automatic, 2=on(last 2 characters)
  'DrawWidth: line width in Pixels

  Dim x&, y&
  Dim a As lAreaType
  Dim secP1 As lPoint
  Dim secP2 As lPoint
  Dim dCoord As dGeoPoint
  Dim NewPen As HMPen
  Dim NewFont As HMFont

  ShowGrid1 = True

  Select Case Size
  Case 1                      'Groesstfelder
    xstep& = 20& * clDeg2Sec
  Case 2                      'Grossfelder
    xstep& = 2& * clDeg2Sec
  Case 3                      'Kleinfelder
    xstep& = (5& * clDeg2Sec) / 60&
  Case 4                      'Mikrofelder
    xstep& = 30
  Case Else
    Exit Function
  End Select

  ystep& = xstep& / 2&

  'Avoid Int() error - see VBPJ Nov.96, Page 56
  dx! = MV.ActMapArea.lxmin / xstep&
  xmin& = Int(dx!) * xstep&

  dy! = MV.ActMapArea.lymin / ystep&
  ymin& = (Int(dy!) + 1) * ystep&

  dx! = MV.ActMapArea.lxmax / xstep&
  xmax& = Int(dx!) * xstep&

  dy! = MV.ActMapArea.lymax / ystep&
  ymax& = Int(dy!) * ystep&

  anzx& = (xmax& - xmin&) / xstep& + 1
  anzy& = (ymax& - ymin&) / ystep& + 1

  If DrawWidth = 1 Then
    If (anzx& < 1 Or anzy& < 1) Then
      ErrNr = 30011                   'Keine Gitterlinie im Ausschnitt
    ElseIf Dev.MapWidth / anzx& < 3 Or Dev.MapHeight / anzy& < 3 Then
      ErrNr = 24208                   'Gitterlinien zu dicht (< 3 Pixel)
    End If
  End If

  If ErrNr Then
    If ErrEnbl Then Call ShowErrNr(ErrNr)
    Exit Function
  End If


  Screen.MousePointer = 11

  NewPen.Color = HV.ColVal(12)
  NewPen.Width = DrawWidth
  NewPen.Style = 0


  '--- Gitter ausgeben ---
  If MarkMode = 0 Then
    ErrNr = PrepareMapDevices(1)
  Else
    ErrNr = PrepareMapDevices(9)
  End If

  'senkrechte Linien
  secP1.y = MV.ActMapArea.lymin
  secP2.y = MV.ActMapArea.lymax

  For x& = xmin& To xmax& Step xstep&
    secP1.x = x&
    secP2.x = x&
    ErrNr = DrawLineGeo(Dev, secP1, secP2, NewPen)
  Next x&

  'waagrechte Linien
  secP1.x = MV.ActMapArea.lxmin
  secP2.x = MV.ActMapArea.lxmax

  For y& = ymax& To ymin& Step -ystep&
    secP1.y = y&
    secP2.y = y&
    ErrNr = DrawLineGeo(Dev, secP1, secP2, NewPen)
  Next y&


  '------ Felder beschriften ------
  If MarkMode Then

    NewFont = Dev.NameFont

    If DrawWidth = 1 Then
      TextCol& = HV.ColVal(11)
    Else
      NewFont.Size = 4 * NewFont.Size
      If NewFont.Size >= 8 And RTrim$(NewFont.Name) = "Small Fonts" Then
        NewFont.Name = "Arial"
      End If
      TextCol& = HV.ColVal(13)
    End If

    ErrNr = SetFont(Dev, NewFont)
    ChrWidth& = Dev.PhysFont.MaxCharWidth * Dev.SecPerPixelX
    ChrHeight& = Dev.PhysFont.CellHeight * Dev.SecPerPixelY

    AnzChr = 2 * Size     'Anzahl Text-Zeichen

    If Short = 1 Then
      'Text-Lnge automatisch bestimmen
      If AnzChr * ChrWidth& < xstep& Then
        Short = 0
      Else
        Short = 2
      End If
    End If

    If Short = 0 Then
      FirstChr = 1           'Text begin
    Else
      FirstChr = AnzChr - 1
      AnzChr = 2
    End If

    If AnzChr * ChrWidth& < xstep& And ChrHeight& < ystep& Then

      For y& = ymax& + ystep& To ymin& Step -ystep&

        For x& = xmin& To xmax& Step xstep&
          dCoord.l = (x& + xstep& / 2) * cfSec2Deg
          dCoord.b = (y& - ystep& / 2) * cfSec2Deg
          void = dDegCoord2Qth(dCoord, Qth$)

          If MarkMode = 1 Then
            Select Case Size
            Case 2
              ch1$ = Mid$(Qth$, 3, 1)
              ch2$ = Mid$(Qth$, 4, 1)
              c1 = (ch1$ = "0") Or (ch1$ = "9")
              c2 = (ch2$ = "0") Or (ch2$ = "9")
              OutOk = c1 And c2
            Case 3
              ch1$ = Mid$(Qth$, 5, 1)
              ch2$ = Mid$(Qth$, 6, 1)
              c1 = (ch1$ = "A") Or (ch1$ = "X")
              c2 = (ch2$ = "A") Or (ch2$ = "X")
              OutOk = c1 And c2
            End Select

          Else
            OutOk = True
          End If

          If OutOk Then
            a.lxmin = x&
            a.lymin = y&
            a.lxmax = x& + xstep&
            a.lymax = y& - ystep&
            m$ = Mid$(Qth$, FirstChr, AnzChr)
            ErrNr = DrawTextGeo(Dev, a, m$, 1, NewFont, TextCol&)
          End If

        Next x&
      Next y&

    End If
  End If

  ErrNr = ErrNr Or TerminateAllDevices()

  Screen.MousePointer = 0

  ShowGrid1 = 0

End Function

