Attribute VB_Name = "DrawInit"
'-------------------------- DRAWINIT.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z



Dim IncStnList$()
Dim ExcStnList$()
Dim AnzIncStn
Dim AnzExcStn

Sub AdjustFrameRect(Dev As HMDevice, a As lAreaType, r As RECT, Mode)

  '         hgeo             habs*TwipsPerPixelY   habs
  ' ---------------------- = ------------------- = ---- * PixelAspect
  ' wgeo*cos(ym*cfSec2Rad)   wabs*TwipsPerPixelX   wabs

  Call GetAreaSize(a, wgeo&, hgeo&)
  Call GetAreaCenter(a, xm&, ym&)
  f! = wgeo& * Cos(ym& * cfSec2Rad) / hgeo&    'f!=w/h

  If Mode And 3 Then        'horizontal

    habs! = Dev.DrawRect.Bottom - Dev.DrawRect.Top - 2
    wabs! = habs! * f! * Dev.PixelAspect
    xmabs! = (Dev.DrawRect.Right - 1 + Dev.DrawRect.Left) / 2
    r.Left = xmabs! - wabs! / 2 - 1
    r.Right = xmabs! + wabs! / 2 + 2

  ElseIf Mode And 12 Then    'vertical

    wabs! = Dev.DrawRect.Right - Dev.DrawRect.Left - 2
    habs! = wabs! / (f! * Dev.PixelAspect)
    ymabs! = (Dev.DrawRect.Bottom - 1 + Dev.DrawRect.Top) / 2
    r.Top = ymabs! - habs! / 2 - 1
    r.Bottom = ymabs! + habs! / 2 + 2

  End If

  Call ForceRectIntoRect(r, Dev.DrawRect)

End Sub

Function CheckDetails() As Long

  Mask& = SegMask("Coast", -1) Or SegMask("Border", -1)  'always

  MinPixel = 40           'Mindestabstand in Pixel
  If HV.PrtEnbl And 2 Then
    'Sekunden je minimalem Rasterfeld
    MinSize& = lMax(HMPrt.SecPerPixelX, HMPrt.SecPerPixelY) * MinPixel
    MeterPerPixel& = HMPrt.mPerPixel
  Else
    MinSize& = lMax(HMCrt.SecPerPixelX, HMCrt.SecPerPixelY) * MinPixel
    MeterPerPixel& = HMCrt.mPerPixel
  End If


  '--- QTH-Locator Grid ---
  If MinSize& > 7200 Then
    Rank = 1
  ElseIf MinSize& > 300 Then
    Rank = 2
  ElseIf MinSize& > 50 Then
    Rank = 3
  Else
    Rank = 4
  End If

  Call SetSegMask(Mask&, "Grid", Rank)


  '--- 4 Ranks - Rivers ---
  Limit = 500
  If MeterPerPixel& > Limit * 4 Then
    Rank = 1
  ElseIf MeterPerPixel& > Limit * 2 Then
    Rank = 2
  ElseIf MeterPerPixel& > Limit Then
    Rank = 3
  Else
    Rank = 4
  End If

  Call SetSegMask(Mask&, "River", Rank)


  '--- 2 Ranks - Canals ---
  If MeterPerPixel& > 1000 Then
    Rank = 1
  Else
    Rank = 2
  End If

  Call SetSegMask(Mask&, "Canal", Rank)


  '--- 3 Ranks Seen/Straen ---
  Limit = 800
  If MeterPerPixel& > Limit * 2 Then
    Rank = 1
  ElseIf MeterPerPixel& > Limit Then
    Rank = 2
  Else
    Rank = 3
  End If

  Call SetSegMask(Mask&, "Lake", Rank)
  Call SetSegMask(Mask&, "Road", Rank)


  '--- 3 Ranks - Berge ---
  If MeterPerPixel& > 800 Then
    Rank = 1
  ElseIf MeterPerPixel& > 100 Then
    Rank = 2
  Else
    Rank = 3
  End If

  Call SetSegMask(Mask&, "Mountain", Rank)


  '--- 3 Ranks abhngig von Karte - Stdte ---
  FileMapWidth& = MV.FileMapArea.lxmax - MV.FileMapArea.lxmin
  If FileMapWidth& > 500000 Then
    Limit = 1600        'World
  ElseIf FileMapWidth& > 100000 Then
    Limit = 800         'Europe
  Else
    Limit = 400         'Deutschland
  End If

  If MeterPerPixel& > Limit * 2 Then
    Rank = 1
  ElseIf MeterPerPixel& > Limit Then
    Rank = 2
  Else
    Rank = 3
  End If

  Call SetSegMask(Mask&, "Town", Rank)


  CheckDetails = Mask&

End Function

Function CheckIncStn(Ca$)

  CheckIncStn = False

  '--- Include-Liste pruefen ---
  If AnzIncStn > 0 Then
    Ok = False
    For i = 1 To AnzIncStn
      ic$ = IncStnList$(i)
      If Left$(Ca$, Len(ic$)) = ic$ Then
        Ok = True
        Exit For
      End If
    Next i
    If Not Ok Then Exit Function
  End If

  '--- Exclude-Liste pruefen ---
  If AnzExcStn > 0 Then
    For i = 1 To AnzExcStn
      ec$ = ExcStnList$(i)
      If Left$(Ca$, Len(ec$)) = ec$ Then Exit Function
    Next i
  End If

  CheckIncStn = True

End Function

Function FitAreaIntoArea(a1 As lAreaType, a2 As lAreaType)

  Call GetAreaCenter(a1, xm&, ym&)

  '--- x prfen ---
  w1& = a1.lxmax - a1.lxmin
  w2& = a2.lxmax - a2.lxmin

  If w1& < 10 Then
    a1.lxmax = xm& + 5
    a1.lxmin = xm& - 5
  End If

  If w1& > w2& Then

    a1.lxmax = a2.lxmax
    a1.lxmin = a2.lxmin
    Change = 3  'links und rechts

  ElseIf a1.lxmin < a2.lxmin Then

    'linke Kante von a1 auerhalb von a2
    a1.lxmax = a2.lxmin + w1&
    a1.lxmin = a2.lxmin
    Change = 1    'links

  ElseIf a1.lxmax > a2.lxmax Then

    'rechte Kante von a1 auerhalb von a2
    a1.lxmax = a2.lxmax
    a1.lxmin = a2.lxmax - w1&
    Change = 2    'rechts

  End If


  '------ y prfen ------
  h1& = a1.lymax - a1.lymin
  h2& = a2.lymax - a2.lymin

  If h1& < 10 Then
    a1.lymax = ym& + 5
    a1.lymin = ym& - 5
  End If

  If h1& > h2& Then

    a1.lymax = a2.lymax
    a1.lymin = a2.lymin
    Change = Change Or 12   'oben und unten

  ElseIf a1.lymin < a2.lymin Then

    'untere Kante von a1 auerhalb von a2
    a1.lymax = a2.lymin + h1&
    a1.lymin = a2.lymin
    Change = Change Or 4    'unten

  ElseIf a1.lymax > a2.lymax Then

    'obere Kante von a1 auerhalb von a2
    a1.lymax = a2.lymax
    a1.lymin = a2.lymax - h1&
    Change = Change Or 8    'oben begrent

  End If

  FitAreaIntoArea = Change

End Function

Sub InitFilterPrefix()

  AnzIncStn = AnzItems(StrPar(3, 11))
  If AnzIncStn Then
    On Error Resume Next
    ReDim IncStnList$(1 To AnzIncStn)
    If Err Then
      Call ShowErrNr(25037)
      AnzIncStn = 0
      AnzExcStn = 0
      Exit Sub
    End If
    On Error GoTo 0
    Call SplitList(UCase$(StrPar(3, 11)), IncStnList$())
  End If

  AnzExcStn = AnzItems(StrPar(3, 12))
  If AnzExcStn Then
    On Error Resume Next
    ReDim ExcStnList$(1 To AnzExcStn)
    If Err Then
      Call ShowErrNr(25037)
      AnzIncStn = 0
      AnzExcStn = 0
      Exit Sub
    End If
    On Error GoTo 0
    Call SplitList(UCase$(StrPar(3, 12)), ExcStnList$())
  End If

End Sub

Function InitializeMap()

  InitializeMap = True

  Call InitPhysDevices

  'Kartenausschnitt anpassen
  Call SetMapArea

  Call InitMapDevices


  'Set HV.MapElem as Mask for Details
  HV.MapElem = 0&
  For i = 0 To AnzDetails - 1
    If NumPar(9).Actual And (Details(i).ElemMask Or Details(i).NameMask) Then
      HV.MapElem = HV.MapElem Or Details(i).SegIdMask
    End If
  Next i

  'Kartendatei auswhlen (bentigt HV.MapElem)
  If NumPar(46).Actual And MF_AutoMap Then
    ErrNr = SelectMapFile()
    If ErrNr Then
      StrPar(3, 6) = ""
      HV.MapType = 0
    End If
  End If

  'Details bestimmen
  If NumPar(46).Actual And MF_AutoDetail Then
    NumPar(44).Actual = CheckDetails()
  End If

  'Details festlegen (von manueller Eingabe oder CheckDetails() )
  HV.MapElem = HV.MapElem And NumPar(44).Actual


  'Titel ausgeben (nach SetMapArea und SelectMapFile)
  Call ShowHMCaption


  If HV.PrtEnbl And 1 Then

    If Not HV.Scrolling Then
      HV.ScrollUserChange = False
      Call InitScroll

      Call ShowSelectedStn
      Call ShowText("", 13, 0)
      Call ShowFound(0)
    End If

    'Hintergrund und Vordergrund lschen
    With MapForm
      If Not HV.Scrolling Then
        .Picture = LoadPicture("")
        .Cls
      End If
      .ZoomFrame.Visible = False
    End With

  End If


  '----- Karte vorbereiten -----
  ErrNr = PrepareMapDevices(2)

  If HV.PrtEnbl And 1 Then
    'Rahmen um Karte ausgeben und Land einfrben
    Call PrepareMap(HMCrt)
  End If

  If HV.PrtEnbl And 2 Then
    Call PrepareMap(HMPrt)
  End If

  ErrNr = TerminateAllDevices()

  InitializeMap = False

End Function

Function SegMask(SegType$, RankMask&) As Long

  i = FindDetail(SegType$)
  With Details(i)
    RankVal& = (2& ^ (.MaxSegId - .MinSegId + 1) - 1) And RankMask&
    SegMask& = RankVal& * (2& ^ (.MinSegId - 1))
  End With

End Function

Function SelectMapFile()

  SelectMapFile = True

  If (NumPar(46).Actual And MF_BitMap) = 0 Then

    '------- Vector-Map -------
    'Order of precedence:
    '1. Area
    '2. Details
    '3. Resolution
    '4. File size

    If HV.PrtEnbl And 2 Then
      'Wenn Drucker + Bildschirm -> Druckerauflsung verwenden
      DrawRes& = HMPrt.mPerPixel
    Else
      DrawRes& = HMCrt.mPerPixel
    End If

    If (NumPar(46).Actual And MF_HiRes) = 0 Then
      'Niedrige Genauigkeit
      DrawRes& = DrawRes& * 10
    End If


    For i = 1 To HV.AnzVectorFiles

      With VectorFileInfo(i)
        If AreaInArea(0, MV.ActMapArea, .Area) Then

          ActRes& = .Res
          ActSize& = .Size

          'Verfgbare Karten-Elemente (Sement-Typen)
          ActTypes = 0
          GridNr = FindDetail("Grid")

          For n = 0 To AnzDetails - 1
            If n <> GridNr Then   'don't count Grid
              If Details(n).SegIdMask And .SegMask And HV.MapElem Then
                ActTypes = ActTypes + 1
              End If
            End If
          Next n

          'gewnschter Ausschnitt ist komplett enthalten
          If SelMapNr = 0 Then

            'erster passender Ausschnitt
            SelMapNr = i

          Else
            If ActTypes > SelTypes Then
              'mehr Karten-Elemente (Segment-Typen)
              SelMapNr = i

            ElseIf ActTypes = SelTypes Then
              'gleiche Zahl Karten-Elemente (Segment-Typen)
              If ActRes& = SelRes& Then
                'Gleiche Auflsung
                If ActSize& < SelSize& Then
                  'gleiche Auflsung, aber kleinere Datei
                  SelMapNr = i
                End If
              Else
                If SelRes& > DrawRes& Then
                  'noch keine ausreichende Auflsung
                  If ActRes& < SelRes& Then
                    'aktuelle Auflsung ist besser
                    SelMapNr = i
                  End If
                Else
                  'schon ausreichende Auflsung
                  If ActRes& < DrawRes& And ActSize& < SelSize& Then
                    'ausreichende Auflsung, aber kleinere Datei
                    SelMapNr = i
                  End If
                End If
              End If
            End If
          End If

          If SelMapNr = i Then
            SelTypes = ActTypes
            SelRes& = ActRes&
            SelSize& = ActSize&
          End If

        End If
      End With
    Next i

    If SelMapNr = 0 Then Exit Function

    SelMapFile$ = VectorFileName(SelMapNr)

  Else
    '----- BitMap Karte -----
    SelMapFile$ = SelectBitmapFile$()
    If Len(SelMapFile$) = 0 Then Exit Function
  End If

  If SelMapFile$ <> StrPar$(3, 6) Then
    'Neue Datei laden
    StrPar$(3, 6) = SelMapFile$
    void = LoadMapFile()
  End If

  SelectMapFile = False

End Function

Function SetMainStnFlags(RecNr, Stn As StationData)

  SetMainStnFlags = True

  'Prfen, ob QTH im Ausschnitt
  If (HV.ValidStnFlags And &H80) = 0 Then
    If (StnFlags(RecNr) And &H70) = &H70 Then
      'Nur Hauptzeilen mit bekanntem QTH
      If PointInIArea(Stn.xloc, Stn.yloc, MV.iStnArea) Then
        StnFlags(RecNr) = StnFlags(RecNr) Or &H80        'QTH im Ausschnitt
      Else
        StnFlags(RecNr) = StnFlags(RecNr) And Not &H80   'QTH ausserhalb
      End If
    End If
  End If


  If (HV.ValidStnFlags And &H700) <> &H700 Then
    'Filter nur mit Hauptzeile
    StnFlags(RecNr) = StnFlags(RecNr) And Not &H700

    'Status
    If (2& ^ Stn.StnStat And NumPar(1).Actual) <> 0 Then
      StnFlags(RecNr) = StnFlags(RecNr) Or &H100
    End If

    'Software
    If (2& ^ Stn.Software And NumPar(3).Actual) <> 0 Then
      StnFlags(RecNr) = StnFlags(RecNr) Or &H200
    End If

    'Hardware
    If (2& ^ Stn.Hardware And NumPar(4).Actual) <> 0 Then
      StnFlags(RecNr) = StnFlags(RecNr) Or &H400
    End If
  End If


  If (HV.ValidStnFlags And &H800) = 0 Then
    '--- Stations-Prefix ---
    If AnzIncStn Or AnzExcStn Then
      Call DecodeCall(Stn.StnCall, sc$, LineNr$)
      ShowOk = CheckIncStn(sc$)
    Else
      ShowOk = True
    End If

    If ShowOk Then
      StnFlags(RecNr) = StnFlags(RecNr) Or &H800
    Else
      StnFlags(RecNr) = StnFlags(RecNr) And Not &H800
    End If

  End If


  If (HV.ValidStnFlags And &H7000) <> &H7000 Then
    'Filter mit Zusatzzeilen
    StnFlags(RecNr) = StnFlags(RecNr) And Not &H7000

    ErrNr = GetStationLineData(SV.Out.BsdFile, RecNr)
    If ErrNr Then Exit Function

    'Typ
    TyMask& = NumPar(2).Actual
    If TyMask& = -1& Then
      Ok = True   'alles
    Else
      Ok = False
      For i = 0 To 9
        If StnLineData(i).xloc < 32767 Then
          If (2& ^ StnLineData(i).StnTyp) And TyMask& Then
            Ok = True
            Exit For
          End If
        End If
      Next i
    End If

    If Ok Then StnFlags(RecNr) = StnFlags(RecNr) Or &H1000


    '--- QRG (mit Zusatzzeilen) ---
    QrgMax& = NumPar(26).Actual
    If QrgMax& = 0& Then
      Ok = True   'alles
    Else
      QrgMin& = NumPar(22).Actual
      Ok = False
      For i = 0 To 9
        If StnLineData(i).xloc < 32767 Then
          Act& = StnLineData(i).QRG
          If Act& > QrgMin& And Act& <= QrgMax& Then
            Ok = True
            Exit For
          ElseIf Act& = QrgMin& And Act& > 0& Then
            'QRG = untere Grenze  -  ausser QRG = 0 (QRG unbekannt)
            Ok = True
            Exit For
          End If
        End If
      Next i
    End If

    If Ok Then StnFlags(RecNr) = StnFlags(RecNr) Or &H2000


    '--- Baud (mit Zusatzzeilen) ---
    BaudMax& = NumPar(27).Actual
    If BaudMax& = 0& Then
      Ok = True     'alles
    Else
      BaudMin& = NumPar(23).Actual
      Ok = False
      For i = 0 To 9
        If StnLineData(i).xloc < 32767 Then
          Act& = StnLineData(i).Baud
          If Act& > BaudMin& And Act& <= BaudMax& Then
            Ok = True
            Exit For
          ElseIf Act& = BaudMin& And Act& > 0& Then
            'Baud = untere Grenze  -  ausser Baud = 0 (Baud unbekannt)
            Ok = True
            Exit For
          End If
        End If
      Next i
    End If

    If Ok Then StnFlags(RecNr) = StnFlags(RecNr) Or &H4000

  End If

  SetMainStnFlags = False

End Function

Sub SetMapArea()

  MV.ActMapArea = MV.SelMapArea

  'wenn Kanten ber Maximum hinausgehen, Kanten begrenzen
  Change = FitAreaIntoArea(MV.ActMapArea, MV.MaxMapArea)

  If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
    '--- Karte unverzerrt ---
    Call GetAreaSize(MV.ActMapArea, wgeosel&, hgeosel&)
    Call GetAreaCenter(MV.ActMapArea, xm&, ym&)
    f! = HV.ScreenAspect * Cos(ym& * cfSec2Rad)      'f!=dygeo/dxgeo
    dxgeonew& = hgeosel& / f!
    dygeonew& = wgeosel& * f!

    If dxgeonew& > wgeosel& Then
      'neue Breite grer als angefordert -> Breite vergrern
      void = AdjustArea(MV.ActMapArea, 3)
    ElseIf dygeonew& > hgeosel& Then
      'neue Hhe grer als angefordert -> Hhe vergrern
      void = AdjustArea(MV.ActMapArea, 12)
    End If

    'wenn Kanten ber Maximum hinausgehen, Kanten begrenzen
    Change = FitAreaIntoArea(MV.ActMapArea, MV.MaxMapArea)
    Select Case Change
    Case 3, 12
      If HV.PrtEnbl And 1 Then
        'Breite oder Hhe wurde begrenzt -> Rahmen verkleinern
        Call AdjustFrameRect(HMCrt, MV.ActMapArea, HMCrt.FrameRect, Change)

        HMCrt.FrameHeight = HMCrt.FrameRect.Bottom - HMCrt.FrameRect.Top
        HMCrt.FrameWidth = HMCrt.FrameRect.Right - HMCrt.FrameRect.Left
      End If

      If HV.PrtEnbl And 2 Then
        If NumPar(46).Actual And MF_PrtProp Then
          'Breite oder Hhe wurde begrenzt -> Rahmen verkleinern
          Call AdjustFrameRect(HMPrt, MV.ActMapArea, HMPrt.FrameRect, Change)

          HMPrt.FrameHeight = HMPrt.FrameRect.Bottom - HMPrt.FrameRect.Top
          HMPrt.FrameWidth = HMPrt.FrameRect.Right - HMPrt.FrameRect.Left
        End If
      End If
    End Select

  End If

  StrPar(3, 15) = lArea2Str$(MV.ActMapArea)   'Koordinaten

  Call lArea2iArea(MV.ActMapArea, MV.iMapArea, 2)

End Sub

Sub SetSegMask(Mask&, SegType$, Rank)

  i = FindDetail(SegType$)
  MaskVal& = (2 ^ Rank - 1) * 2 ^ (Details(i).MinSegId - 1)
  Mask& = Mask& Or MaskVal&

End Sub

Function SetStnFlags()

  'Flags:
  '------
  '01,02,04: 0=nicht beschriftet, 1...4=Richtung, 7=kein Platz
  '0008: <frei>

  '0010: Station nicht gelscht
  '0020: Hauptzeile
  '0040: QTH bekannt
  '0080: QTH im Ausschnitt

  'Filter:
  '-------
  '0100: Status
  '0200: Software
  '0300: Hardware
  '0800: Prefix include/exclude
  '1000: Typ
  '2000: QRG
  '4000: Baud
  '8000: <frei>

  Dim Stn As StationData
  Static OldArea As lAreaType

  'Textausgabeflags lschen = unbeschriftet
  For i = 2 To SV.Out.StnHdr.AnzStnRec
    StnFlags(i) = StnFlags(i) And Not 7
  Next i

  'Prfen, ob sich Ausschnitt gendert hat
  If Not AreaInArea(2, OldArea, MV.ActMapArea) Then
    HV.ValidStnFlags = HV.ValidStnFlags And Not &H80
    OldArea = MV.ActMapArea
  End If

  'Alle Flags gltig -> kein Test
  If HV.ValidStnFlags = &HFFFF Then Exit Function


  SetStnFlags = True


  For i = 2 To SV.Out.StnHdr.AnzStnRec

    ErrNr = GetStationData(SV.Out.BsdFile, i, Stn)
    If ErrNr Then Exit Function

    If (HV.ValidStnFlags And &H70) <> &H70 Then
      StnFlags(i) = StnFlags(i) And Not &H70
      'Station nicht gelscht
      If Stn.xloc < 32767 Then StnFlags(i) = StnFlags(i) Or &H10
      'Hauptzeile
      If (Stn.StnCall.SSID And 255) = 0 Then
        StnFlags(i) = StnFlags(i) Or &H20
      End If
      'QTH bekannt
      If Stn.yloc < 32767 Then StnFlags(i) = StnFlags(i) Or &H40
    End If


    If (StnFlags(i) And &H30) = &H30 Then
      'Nur gltige Hauptzeilen
      ErrNr = SetMainStnFlags(i, Stn)
      If ErrNr Then Exit Function
    End If
  Next i

  HV.ValidStnFlags = &HFFFF

  SetStnFlags = False

End Function

