Attribute VB_Name = "DrawLinks"
'-------------------------- DRAWLNK.BAS ------------------------

'HAMMAP Link-Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function DrawAllLinks(AnzLnk)

  'Links fuer alle Digis zeichnen

  Dim SrcX As Long, SrcY As Long
  Dim DstX As Long, DstY As Long
  Dim StnCall As StationCall

  DrawAllLinks = True

  ErrNr = PrepareMapDevices(1)

  ShowStep = InitPercent&(Msg$(24102), CLng(SV.Out.StnHdr.AnzLnkRec), 10)

  AnzLnk = 0
  ErrNr = 0

  For LnkRec = 2 To SV.Out.StnHdr.AnzLnkRec

    If LnkRec Mod ShowStep = 0 Then
      ErrNr = ShowPercent(CLng(LnkRec), "")
      If ErrNr Then Exit For
    End If

    ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
    If ErrNr Then Exit For

    '--- Pruefen, dass Link nicht geloescht ---
    If ActLnkData.LnkDate < 32767 Then

      SrcRec = ActLnkData.StnPtr(1)
      DstRec = ActLnkData.StnPtr(2)

      If NumPar(42).Actual And 2 Then
        'Alle Links (wegen Tapete)
        ShowOk = True
      Else
        'QTH's bekannt und im Ausschnitt
        c1 = (StnFlags(SrcRec) And &HF0) = &HF0
        c2 = (StnFlags(DstRec) And &HF0) = &HF0

        If NumPar(42).Actual And 1 Then
          'mindestens 1 QTH muss im Ausschnitt sein
          ShowOk = c1 Or c2
        Else
          'beide QTH's muessen im Ausschnitt sein
          ShowOk = c1 And c2
        End If
      End If

      If ShowOk Then
        '--- Auf Prefix/Filter(?) pruefen---
        Mask& = &H7F00&
        c1 = (StnFlags(SrcRec) And Mask&) = Mask&
        c2 = (StnFlags(DstRec) And Mask&) = Mask&
        If c1 And c2 Then
          If CheckLinkFilter(ActLnkData, 0) Then
            AnzLnk = AnzLnk + 1
            ErrNr = DrawOneLink()
            If ErrNr Then Exit For
          End If
        End If
      End If
    End If

  Next LnkRec

  ErrNr = TerminateAllDevices()

  If ErrNr = 0 Then
    m$ = Format$(AnzLnk, "#,##0") + " " + Msg$(24474)
    Call ShowText(m$, 7, 0)
  End If

  DrawAllLinks = ErrNr

End Function

Function DrawLineGeo(Dev As HMDevice, secP1 As lPoint, secP2 As lPoint, NewPen As HMPen)

  Dim devP1 As PointApi
  Dim devP2 As PointApi

  If Dev.hDev = 0 Then Stop

  DrawLineGeo = True

  ErrNr = secPoint2devPoint(Dev, secP1, devP1)
  If ErrNr Then Exit Function
  ErrNr = secPoint2devPoint(Dev, secP2, devP2)
  If ErrNr Then Exit Function

  ErrNr = SetPen(Dev, NewPen)
  If ErrNr Then Exit Function

  Ok = DrawLineDev(Dev, devP1, devP2, Dev.ActPen.Color)

  DrawLineGeo = (Ok = False)

End Function

Function DrawLinkLine(SrcRec, DstRec, CrtPen As HMPen, PrtPen As HMPen)

  Dim geoP1 As lPoint
  Dim geoP2 As lPoint

  DrawLinkLine = True

  'QTH von Start und Ziel muss bekannt sein
  If (StnFlags(SrcRec) And &H70) = &H70 And _
     (StnFlags(DstRec) And &H70) = &H70 Then

    ErrNr = GetStationQth(SrcRec, SrcX, SrcY)
    If ErrNr Then Exit Function
    ErrNr = GetStationQth(DstRec, DstX, DstY)
    If ErrNr Then Exit Function

    DrawLinkLine = False

    '--- Prfung auf gleiches QTH ---
    If SrcX = DstX And SrcY = DstY Then Exit Function

    geoP1.x = CLng(SrcX) * clQth2Sec
    geoP1.y = CLng(SrcY) * clQth2Sec
    geoP2.x = CLng(DstX) * clQth2Sec
    geoP2.y = CLng(DstY) * clQth2Sec

    If HV.PrtEnbl And 1 Then
      ErrNr = DrawLineGeo(HMCrt, geoP1, geoP2, CrtPen)
    End If

    If HV.PrtEnbl And 2 Then
      ErrNr = DrawLineGeo(HMPrt, geoP1, geoP2, PrtPen)
    End If
  End If

  DrawLinkLine = False

End Function

Function DrawOneLink()

  Dim CrtPen As HMPen
  Dim PrtPen As HMPen

  SrcRec = ActLnkData.StnPtr(1)
  DstRec = ActLnkData.StnPtr(2)

  Baud& = ActLnkData.Baud
  If Baud& >= 19200 Then
    CrtPen.Width = GetLineWidth(0, 8)
    PrtPen.Width = GetLineWidth(1, 8)
  Else
    CrtPen.Width = GetLineWidth(0, 9)
    PrtPen.Width = GetLineWidth(1, 9)
  End If

  '----- Link-Farbe ---
  If NumPar(42).Actual And 4 Then

    '--- Links farbig ---
    If Baud& = 0& Then
      LinkColor = 7
    ElseIf Baud& <= 1200& Then
      LinkColor = 1
    ElseIf Baud& <= 2400& Then
      LinkColor = 2
    ElseIf Baud& <= 4800& Then
      LinkColor = 3
    ElseIf Baud& <= 9600& Then
      LinkColor = 4
    ElseIf Baud& <= 19200& Then
      LinkColor = 5
    Else
      LinkColor = 6
    End If
  Else
    '--- Links nicht farbig ---
    LinkColor = 7
  End If

  CrtPen.Color = HV.ColVal(LinkColor)
  PrtPen.Color = CrtPen.Color


  '----- Link-Muster -----
  'siehe auch Funktion ShowCall$
  If (ActLnkData.StatTyp And 255) <= 3 Then
    'Link unbekannt, ok, instabil, Test
    CrtPen.Style = 0
  Else
    'Link defekt, geplant
    CrtPen.Style = 2
  End If

  PrtPen.Style = CrtPen.Style

  DrawOneLink = DrawLinkLine(SrcRec, DstRec, CrtPen, PrtPen)

End Function

Sub DrawSelStnLinks(DrawMode)

  'Links fuer selektierten Digi zeichnen

  If HV.SelStnRec = 0 Then Exit Sub         'kein Digi selektiert

  ErrNr = FindSelStnLinks()
  If ErrNr Then Exit Sub

  If DrawMode Then

    If NumPar(46).Actual And MF_AutoArea Then
      '--- Ausschnitt anpassen ---
      Call AutoArea(1, 0&, 0&)              'Init

      Call AutoAreaStn(HV.SelStnRec)        'Selected Station

      For i = 1 To HV.AnzFound
        LnkRec = StnFnd(i).LnkRec
        ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
        If ErrNr Then Exit For

        '--- Filter pruefen ---
        If CheckLinkFilter(ActLnkData, 0) Then
          DstRec = ActLnkData.StnPtr(1)
          If DstRec = HV.SelStnRec Then DstRec = ActLnkData.StnPtr(2)

          If (StnFlags(DstRec) And &H70) = &H70 Then
            Call AutoAreaStn(DstRec)
          End If
        End If
      Next i

      Call AutoArea(4, 0&, 0&)              'Ausgeben
    End If


    '----- Links ausgeben -----
    ErrNr = PrepareMapDevices(1)

    For i = 1 To HV.AnzFound
      LnkRec = StnFnd(i).LnkRec
      ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
      If ErrNr Then Exit For

      '--- Filter pruefen ---
      If CheckLinkFilter(ActLnkData, 0) Then
        ErrNr = DrawOneLink()
        If ErrNr Then Exit For

        '--- Station ausgeben ---
        DstRec = ActLnkData.StnPtr(1)
        If DstRec = HV.SelStnRec Then DstRec = ActLnkData.StnPtr(2)

        If (StnFlags(DstRec) And &HF0) = &HF0 Then
          'QTH bekannt und im Ausschnitt
          ErrNr = GetStationData(SV.Out.BsdFile, DstRec, ActStnData)
          If ErrNr Then Exit Sub
          Colo& = HV.ColVal(StnColor(ActStnData.Software))
          ActSym = StnSym(ActStnData.StnTyp).Actual
          x0& = CLng(ActStnData.xloc) * clQth2Sec
          y0& = CLng(ActStnData.yloc) * clQth2Sec

          void = DrawSymbolGeo(HMCrt, x0&, y0&, ActSym, Colo&)
          'void = DrawSingleSymbol(x0&, y0&, ActSym, Colo)
        End If
      End If
    Next i

    ErrNr = TerminateAllDevices()

  End If

End Sub

