Attribute VB_Name = "DrawMap"
'----------------------- DRAWMAP.BAS -----------------------
DefInt A-Z
'

Sub ClearMap()

  ForeOverlay$ = ""
  BackOverlay$ = ""
  OverlayInfo$ = ""

  Call NewMap

End Sub

Function DrawAllSegments(SegType, Mode)

  '--- Draw all segments of specified type ---

  DrawAllSegments = True

  ErrNr = 0


  '------ Segment-Schleife -----
  SegNr = MV.FirstRec(SegType)

  Do Until SegNr = 0

    If MV.LoadMode And 1 Then
      '--- Segment aus Speicher ---
      MV.Sg = Segm(SegNr)
    Else
      '--- Segment von Datei einlesen ---
      ErrNr = GetSegment(MV.In.BmdFile, SegNr, MV.Sg)
      If ErrNr Then Exit Function
    End If

    If Not HV.Scrolling Then
      HV.ShowCnt = HV.ShowCnt + 1
      If HV.ShowCnt Mod HV.ShowStep = 0 Then
        ErrNr = ShowPercent(CLng(HV.ShowCnt), "")
        If ErrNr Then Exit Function
      End If
    End If

    'Pruefen, ob Segment im Ausschnitt liegt
    If MV.Sg.iArea.ixmax < MV.iMapArea.ixmin Then
      SegEnbl = False
    ElseIf MV.Sg.iArea.iymax < MV.iMapArea.iymin Then
      SegEnbl = False
    ElseIf MV.Sg.iArea.ixmin > MV.iMapArea.ixmax Then
      SegEnbl = False
    ElseIf MV.Sg.iArea.iymin > MV.iMapArea.iymax Then
      SegEnbl = False
    Else
      SegEnbl = True
    End If


    '--- Segment ausgeben ---
    If SegEnbl Then

      Select Case Mode
      Case 0
        'Linien
        '  No error handling in DrawLineSegment
        On Error Resume Next
          If HV.PrtEnbl And 1 Then
            ErrNr = DrawLineSegment(HMCrt)
            If Err Or ErrNr Then Exit Function
          End If
          If HV.PrtEnbl And 2 Then
            ErrNr = DrawLineSegment(HMPrt)
            If Err Or ErrNr Then Exit Function
          End If
        On Error GoTo 0

      Case 1
        'Wasser
        If HV.PrtEnbl And 1 Then
          ErrNr = DrawWaterSegment(HMCrt)
          If ErrNr Then Exit Function
        End If

        If HV.PrtEnbl And 2 Then
          ErrNr = DrawWaterSegment(HMPrt)
          If ErrNr Then Exit Function
        End If


      Case 2
        'Staedte + Berge
        ForeCol& = HV.ColVal(11)

        Select Case SegType
        Case 21         'Big Towns
          SymNr = 4
        Case 22 To 23   'Small Towns
          SymNr = 11
        Case 24 To 26   'Mountains
          SymNr = 6
        End Select

        If HV.PrtEnbl And 1 Then
          ErrNr = DrawSymbolGeo(HMCrt, MV.Sg.x, MV.Sg.y, SymNr, ForeCol&)
        End If

        If HV.PrtEnbl And 2 Then
          ErrNr = DrawSymbolGeo(HMPrt, MV.Sg.x, MV.Sg.y, SymNr, ForeCol&)
        End If


      Case 3
        'Staedte/Berge beschriften
        ErrNr = GetLenText(MV.In.BmtFile, MV.Sg.Comment, sc$)
        sc$ = Pc8toAnsi$(sc$)
        If ErrNr Then Exit Function

        ForeCol& = HV.ColVal(11)

        If HV.PrtEnbl And 1 Then
          Call DrawNameGeo(HMCrt, MV.Sg.x, MV.Sg.y, sc$, 0, ForeCol&)
        End If

        If HV.PrtEnbl And 2 Then
          Call DrawNameGeo(HMPrt, MV.Sg.x, MV.Sg.y, sc$, 0, ForeCol&)
        End If
      End Select
    End If

    SegNr = MV.Sg.TypePtr
  Loop

  DrawAllSegments = False

End Function

Function DrawLineSegment(Dev As HMDevice)

  'For speed reasons in VB5:
  '  Error Handling in calling routine !!!

  Dim x As Long, y As Long
  Dim xlabs As Long, ylabs As Long
  Dim xold As Long, yold As Long
  Dim OldPos As PointApi

  DrawLineSegment = True

  If Dev.hDev = 0 Then Stop

  PenCol& = Dev.ActPen.Color

  '--- Anfangspunkt ---
  If NumPar(35).Actual And 1 Then
    ErrNr = DrawSymbolGeo(Dev, MV.Sg.x, MV.Sg.y, 1, PenCol&)
  End If

  x = MV.Sg.x - MV.ActMapArea.lxmin
  y = MV.Sg.y - MV.ActMapArea.lymin



  '--- Ausgabe mit Polyline ---
  xlabs = x * Dev.PixelPerSecX
  ylabs = y * Dev.PixelPerSecY

  If MV.Sg.KoCnt > 0 Then

    xold = xlabs
    yold = ylabs

    If MV.Sg.KoCnt > UBound(SegPnts) Then
      ReDim SegPnts(0 To MV.Sg.KoCnt) As PointApi
    End If

    PolyCnt& = 0
    SegPnts(0).x = Dev.MapRect.Left + xlabs
    SegPnts(0).y = Dev.MapRect.Bottom - 1 - ylabs


    Select Case HV.CoLoadMode
    Case 0
      ErrNr = SeekFile(MV.In.BmcFile, (MV.Sg.KoBeg - 1) * CoRecLen + 1)
      If ErrNr Then Exit Function

      ResetCache = True

    Case 2
      s1 = (MV.Sg.KoBeg - 1) Mod HV.MapDim
      s2 = (MV.Sg.KoBeg - 1) \ HV.MapDim
    End Select

    On Error Resume Next

    '---------- Koordinaten-Schleife ----------
    For i& = MV.Sg.KoBeg To MV.Sg.KoBeg + MV.Sg.KoCnt - 1

      Select Case HV.CoLoadMode
      Case 0
        '--- Linie von Datei ausgeben ---
        ErrNr = GetCoordCache(MV.In.BmcFile, MV.co, ResetCache)
        If ErrNr Then Exit Function
        x = x + MV.co.x
        y = y + MV.co.y

      Case 1
        '--- Linie aus RAM ausgeben ---
        x = x + Karte1(i&).x
        y = y + Karte1(i&).y

      Case 2
        x = x + Karte2(s1, s2).x
        y = y + Karte2(s1, s2).y

        s1 = s1 + 1
        If s1 = HV.MapDim Then
          s1 = 0
          s2 = s2 + 1
        End If
      End Select

      xlabs = x * Dev.PixelPerSecX
      ylabs = y * Dev.PixelPerSecY

      If xlabs <> xold Or ylabs <> yold Then
        PolyCnt& = PolyCnt& + 1
        SegPnts(PolyCnt&).x = Dev.MapRect.Left + xlabs
        SegPnts(PolyCnt&).y = Dev.MapRect.Bottom - 1 - ylabs
        xold = xlabs
        yold = ylabs
      End If

    Next i&

    On Error GoTo 0


    '--- Segment ausgeben ---
    Ok = Polyline(Dev.hDev, SegPnts(0), PolyCnt& + 1)

  End If

  ActCol& = SetPixel&(Dev.hDev, Dev.MapRect.Left + xlabs, Dev.MapRect.Bottom - 1 - ylabs, PenCol&)

  If NumPar(35).Actual And 1 Then        'Debug
    ErrNr = DrawSymbolGeo(Dev, x + MV.ActMapArea.lxmin, y + MV.ActMapArea.lymin, 0, PenCol&)
  End If

  DrawLineSegment = False

End Function

Function DrawSegTypes(Mask&, Mode)

  'Mode: 0=Linen; 1=Wasser; 2=Staedte+Berge, 3=Staedte+Berge beschriften

  'Check if Segments of actual type selected (and existing)
  DrawMask& = Mask& And HV.MapElem
  If DrawMask& = 0 Then Exit Function

  DrawSegTypes = True

  If Mode = 1 Then

    '--- Wasser ---
    ErrNr = PrepareMapDevices(6)

    For SegType = -4 To -1
      If 2 ^ (-SegType - 1) And DrawMask& Then
        ErrNr = DrawAllSegments(SegType, Mode)
        If ErrNr Then Exit For
      End If
    Next SegType

    ErrNr = ErrNr Or TerminateAllDevices()


  Else

    Select Case Mode
    Case 0          'Linien
      ErrNr = PrepareMapDevices(0)

    Case 2, 3         'Stdte, Berge
      ErrNr = PrepareMapDevices(8)

    End Select


    '--- alles andere ---
    For SegType = 1 To MaxSegType
      If 2 ^ (SegType - 1) And DrawMask& Then

        If Mode = 0 Then
          'Linien - Breite je nach SegType
          If HV.PrtEnbl And 1 Then
            ErrNr = SetLinePen(HMCrt, SegType)
          End If
          If HV.PrtEnbl And 2 Then
            ErrNr = SetLinePen(HMPrt, SegType)
          End If
        End If

        ErrNr = DrawAllSegments(SegType, Mode)
        If ErrNr Then Exit For
      End If
    Next SegType

    ErrNr = ErrNr Or TerminateAllDevices()

  End If

  DrawSegTypes = ErrNr

End Function

Function DrawVectorMap(Part)

  DrawVectorMap = True

  If MV.In.AnzSg - SgHdrLen > 0 Then

    '------ Vektor-Karte Zeichnen ------
    Select Case Part
    Case 1
      '------- Part 1 -------
      '----- Segmentanzahl bestimmen -----
      SegCnt& = GetSegCnt(1, MaxSegType)
      'Wasser anmalen
      SegCnt& = SegCnt& + GetSegCnt(-4, -1)
      If Len(BackOverlay$) > 0 Then
        SegCnt& = SegCnt& + GetSegCnt(1, 4) + GetSegCnt(18, 18)
      End If

      '----- Karte ausgeben -----
      HV.ShowStep = InitPercent&(Msg$(24105), SegCnt&, 20)
      HV.ShowCnt = 0

      RiverMask& = SegMask("River", -1) Or SegMask("Canal", -1)
      CoastMask& = SegMask("Coast", -1) Or SegMask("Lake", -1)
      BorderMask& = SegMask("Border", -1) Or CoastMask&

      'Coasts, Islands, Lakes, Double lined Rivers, Borders
      ErrNr = DrawSegTypes(BorderMask&, 0)
      If ErrNr Then Exit Function

      'Wasser anmalen
      ErrNr = DrawSegTypes(CoastMask&, 1)
      If ErrNr Then Exit Function
      ErrNr = DrawExtraWaterPoints()
      If ErrNr Then Exit Function

      '--- Background Overlay ---
      Call ExecOverlay(2)
      If Len(BackOverlay$) > 0 Then
        'Coasts, Islands, Lakes, Double lined Rivers, Borders
        ErrNr = DrawSegTypes(BorderMask&, 0)
        If ErrNr Then Exit Function
      End If

      'Fluesse (ausser double lined), Kanaele
      ErrNr = DrawSegTypes(RiverMask&, 0)
      If ErrNr Then Exit Function

      'Roads
      Mask& = SegMask("Road", -1)
      ErrNr = DrawSegTypes(Mask&, 0)
      If ErrNr Then Exit Function


    Case 2
      '------- Part 2 -------
      'Gross-Staedte
      ErrNr = DrawSegTypes(SegMask("Town", 1), 2)
      If ErrNr Then Exit Function

      'Mittel- und Klein-Staedte
      ErrNr = DrawSegTypes(SegMask("Town", 6), 2)
      If ErrNr Then Exit Function

      'Berge
      ErrNr = DrawSegTypes(SegMask("Mountain", -1), 2)


    Case 3
      '------- Part 3 -------
      '--- Stdte beschriften ---
      If NumPar(9).Actual And ME_TownNames Then
        SegCnt& = GetSegCnt(21, 23)
        HV.ShowStep = InitPercent&(Msg$(24106), SegCnt&, 20)
        HV.ShowCnt = 0
        ErrNr = DrawSegTypes(SegMask("Town", -1), 3)
        If ErrNr Then Exit Function
      End If

      '--- Berge beschriften ---
      If NumPar(9).Actual And ME_MtnNames Then
        SegCnt& = GetSegCnt(24, 26)
        HV.ShowStep = InitPercent&(Msg$(24112), SegCnt&, 20)
        HV.ShowCnt = 0
        ErrNr = DrawSegTypes(SegMask("Mountain", -1), 3)
        If ErrNr Then Exit Function
      End If
    End Select

  End If

  DrawVectorMap = False

End Function

Function GetSegCnt(Min, Max) As Long

  For SegType = Min To Max
    If 2 ^ (Abs(SegType) - 1) And HV.MapElem Then
      SegCnt& = SegCnt& + MV.SgTypCnt(SegType)
    End If
  Next SegType

  GetSegCnt = SegCnt&

End Function

Sub NewMap()

  Static LastStnFile$

  If HV.PrtEnbl And 1 Then
    Call MapTipEnbl(False, False)

    'Zoom-Mode ausschalten
    If HV.ZoomMode > 0 Then Call StopZoom
  End If

  If LastStnFile$ = StrPar(3, 7) Then
    SaveSelStn = HV.SelStnRec
  Else
    SaveSelStn = 0
    LastStnFile$ = StrPar(3, 7)
  End If

  HV.SelStnRec = 0                       'kein Digi Selektiert
  HV.AnzFound = 0                        'kein Digi/Link gefunden

  Cancel = GetAsyncKeyState(27)          'Clear pending Keystrokes
  void = DoEvents()

  '--- Karte initialisieren ---
  ErrNr = InitializeMap()

  '------- Karte ausgeben -------

  HV.NewMapFlag = True    'For API-Notify

  'Bildschirm
  If HV.PrtEnbl And 1 Then
    If ErrNr = 0 Then Call AllocateHitArray(HMCrt)
  End If

  'Drucker
  If HV.PrtEnbl And 2 Then
    If ErrNr = 0 Then Call AllocateHitArray(HMPrt)
  End If

  Select Case HV.MapType
  Case 1      'Vector
    If ErrNr = 0 Then ErrNr = DrawVectorMap(1)    'wegen DOS unterteilt

    'Stdte und Berge ausgeben
    If ErrNr = 0 Then ErrNr = DrawVectorMap(2)

  Case 2, 3    'Pixel
    If HV.PrtEnbl And 1 Then
      If ErrNr = 0 Then Call DrawPixelMap(HMCrt)
    End If

    If HV.PrtEnbl And 2 Then
      If ErrNr = 0 Then Call DrawPixelMap(HMPrt)
    End If

    Call ExecOverlay(2)
  End Select

  Call ShowText("", 13, 0)


  '----- Gitter ausgeben -----
  If ErrNr = 0 And (NumPar(9).Actual And (ME_Grid Or ME_GridNames)) <> 0 Then

    DtlNr = FindDetail("GRID")
    Size = GetMaskVal(NumPar(44).Actual, DtlNr)

    If NumPar(9).Actual And ME_GridNames Then
      MarkMode = 2
    Else
      MarkMode = 0
    End If
    void = ShowGrid(Size, MarkMode, False)
  End If


  '--- Flags setzen (Filter usw.) ---
  If ErrNr = 0 Then
    Call ShowText(Msg$(24117), 13, 11)
    ErrNr = SetStnFlags()
    Call ShowText("", 13, 0)
  End If


  '----- Links ausgeben ---
  If ErrNr = 0 And SV.Out.StnHdr.AnzLnkRec > 1 Then
    If NumPar(9).Actual And ME_Links Then
      ErrNr = DrawAllLinks(AnzLnk)
    End If
  End If


  '----- Stationen ausgeben / beschriften ---
  'Pruefen, ob Stationen vorhanden
  If ErrNr = 0 And SV.Out.StnHdr.AnzStnRec > 1 Then
    If NumPar(9).Actual And (ME_Stn Or ME_StnCalls) Then
      'Stationen ausgeben
      ErrNr = DrawAllStations(1, AnzStn)
    End If

    If ErrNr = 0 And (NumPar(9).Actual And ME_StnCalls) <> 0 Then
      'Stationen beschriften
      ErrNr = DrawAllStations(2, AnzStn)
    End If
  End If


  If ErrNr = 0 And HV.MapType = 1 Then
    'Stdte und Berge beschriften
    ErrNr = DrawVectorMap(3)
  End If


  '--- Foreground Overlay ---
  Call ExecOverlay(1)


  If SaveSelStn Then void = SelectStation(SaveSelStn, False)


  '--- Status-Information---
  m$ = OverlayInfo$

  If Len(m$) = 0 Then


    If NumPar(9).Actual And (ME_Stn Or ME_StnCalls) Then
      If Len(m$) > 0 Then m$ = m$ & " - "
      m$ = m$ & Format$(AnzStn, "#,##0") + " " + Msg$(24473)
    End If

    If NumPar(9).Actual And ME_Links Then
      If Len(m$) > 0 Then m$ = m$ & " - "
      m$ = m$ & Format$(AnzLnk, "#,##0") + " " + Msg$(24474)
    End If

  End If

  Call ShowText(m$, 7, 0)


  If HV.PrtEnbl And 1 Then

    void = StoreMap(0&)
    Call MapTipEnbl(True, False)

    If ErrNr Then
      StrPar(3, 10) = ""
      Call ShowHMCaption
    End If

  End If

End Sub

Sub NewScrollingMap()

  'Zoom-Mode ausschalten
  If HV.ZoomMode > 0 Then Call StopZoom
  'Fadenkreuzcursor lschen
  MapForm.Line1.Visible = False
  MapForm.Line2.Visible = False


  '--- Karte initialisieren ---
  ErrNr = InitializeMap()

  '------- Karte ausgeben -------
  'If ErrNr = 0 Then ErrNr = DrawVectorMap(1)

  '----- Karte ausgeben -----
  RiverMask& = SegMask("River", -1) Or SegMask("Canal", -1)
  CoastMask& = SegMask("Coast", -1) Or SegMask("Lake", -1)
  BorderMask& = SegMask("Border", -1) Or CoastMask&

  'Coasts, Islands, Lakes, Double lined Rivers, Borders
  ErrNr = DrawSegTypes(BorderMask&, 0)
  If ErrNr Then Exit Sub

  'Wasser anmalen
  ErrNr = DrawSegTypes(CoastMask&, 1)
  If ErrNr Then Exit Sub

  'Fluesse (ausser double lined), Kanaele
  ErrNr = DrawSegTypes(RiverMask&, 0)
  If ErrNr Then Exit Sub

  'Roads
  Mask& = SegMask("Road", -1)
  ErrNr = DrawSegTypes(Mask&, 0)
  If ErrNr Then Exit Sub

  Call AllocateHitArray(HMCrt)

  'Stdte und Berge ausgeben
  ErrNr = DrawVectorMap(2)

  'Stdte und Berge beschriften
  ErrNr = DrawVectorMap(3)

End Sub

Function SetLinePen(Dev As HMDevice, SegType)

  Dim NewPen As HMPen

  Select Case SegType
  Case 1 To 2         'Major Coasts, Islands, Lakes
    NewPen.Width = GetLineWidth(Dev.Id, 0)
    ColNr = 7
  Case 3 To 4         'Minor Coasts, Islands, Lakes
    NewPen.Width = GetLineWidth(Dev.Id, 1)
    ColNr = 7
  Case 8 To 9, 15     'Major rivers and canals
    NewPen.Width = GetLineWidth(Dev.Id, 3)
    ColNr = 10
  Case 10 To 11, 16   'Minor rivers and canals
    NewPen.Width = GetLineWidth(Dev.Id, 4)
    ColNr = 10
  Case 12             'Major roads
    NewPen.Width = GetLineWidth(Dev.Id, 5)
    ColNr = 5
  Case 13 To 14       'Minor roads
    NewPen.Width = GetLineWidth(Dev.Id, 6)
    ColNr = 5
  Case 18             'Borders
    NewPen.Width = GetLineWidth(Dev.Id, 2)
    ColNr = 7
  End Select

  NewPen.Color = HV.ColVal(ColNr)
  NewPen.Style = 0

  ErrNr = SetPen(Dev, NewPen)

End Function

