Attribute VB_Name = "DrawStations"
'-------------------------- DRAWSTN.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z


Dim MarkStnList$()
Dim AnzMarkStn

Sub AllocateHitArray(Dev As HMDevice)

  xmin = Dev.MapRect.Left \ 31
  xmax = (Dev.MapRect.Right - 1 + 30) \ 31      ' =  18 for VGA
  ymin = Dev.MapRect.Top
  ymax = Dev.MapRect.Bottom - 1                 ' = 461 for VGA

  If Dev.Id = 0 Then
    ReDim CrtHits(xmin To xmax, ymin To ymax) As Long
    ReDim SaveCrtHits(xmin To xmax, ymin To ymax) As Long
  Else
    ReDim PrtHits(xmin To xmax, ymin To ymax)
  End If

End Sub

Function DrawAllStations(DrawCmd, AnzStn)

  Dim Stn As StationData

  '---Alle Digis, im Ausschnitt anzeigen / beschriften

  DrawAllStations = True

  If DrawCmd = 1 Then
    'Stationen ausgeben
    m$ = Msg$(24103)
  Else
    'Stationen beschriften
    m$ = Msg$(24109)
  End If

  ShowStep = InitPercent&(m$, CLng(SV.Out.StnHdr.AnzStnRec), 20)

  ErrNr = PrepareMapDevices(9)

  ErrNr = 0
  NewFlag = True
  TranspSym = (NumPar(41).Actual And 16) <> 0     'Symbole transparent

  AnzStn = 0

  For StnRec = 2 To SV.Out.StnHdr.AnzStnRec

    '--- alle oder selektierte Station auswaehlen ---
    If HV.SelStnRec = 0 Or StnRec = HV.SelStnRec Then

      If StnRec Mod ShowStep = 0 Then
        ErrNr = ShowPercent(CLng(StnRec), "")
        If ErrNr Then Exit For
      End If

      If (StnFlags(StnRec) And &HF0) = &HF0 Then
        'Gltige Station, QTH bekannt und im Ausschnitt -> Daten laden
        If StnRec = HV.SelStnRec Then
          ShowStn = True
        Else
          ShowStn = (StnFlags(StnRec) And &H7F00) = &H7F00
        End If

        If ShowStn Then
          ErrNr = GetStationData(SV.Out.BsdFile, StnRec, Stn)
          If ErrNr Then Exit Function

          AnzStn = AnzStn + 1

          ColNr = StnColor(Stn.Software)
          ForeCol& = HV.ColVal(ColNr)

          '--- Anzeigen ---
          If DrawCmd And 1 Then
            ActSym = StnSym(Stn.StnTyp).Actual
            x0& = CLng(Stn.xloc) * clQth2Sec
            y0& = CLng(Stn.yloc) * clQth2Sec

            'If x0& <> xold& Or y0& <> yold& Or TranspSym Then
              If HV.PrtEnbl And 1 Then
                ErrNr = DrawSymbolGeo(HMCrt, x0&, y0&, ActSym, ForeCol&)
              End If

              If HV.PrtEnbl And 2 Then
                ErrNr = DrawSymbolGeo(HMPrt, x0&, y0&, ActSym, ForeCol&)
              End If
            '  xold& = x0&
            '  yold& = y0&
            'End If

          End If

          '--- Beschriften ---
          If DrawCmd And 2 Then
            Call MarkNewStation(StnRec, Stn, ForeCol&, NewFlag)
          End If

        End If
      End If
    End If

  Next StnRec

  ErrNr = TerminateAllDevices()

  If ErrNr = 0 Then
    m$ = Format$(AnzStn, "#,##0") + " " + Msg$(24473)
    Call ShowText(m$, 7, 0)
  End If

  DrawAllStations = ErrNr

End Function

Sub DrawFound(DrawMode)

  'DrawMode: 1 = nur Stationen, 2 = Stationen + Beschriftung

  Dim Stn As StationData

  If HV.FoundMode = 2 Then
    '--- Route ---
    Start = 1
  Else
    '--- Links ---
    Start = 0
    StnFnd(0).StnRec = HV.SelStnRec
  End If

  NewFlag = True

  ErrNr = PrepareMapDevices(9)

  For Pass = 1 To DrawMode

    For i = Start To HV.AnzFound
      StnRec = StnFnd(i).StnRec
      If (StnFlags(StnRec) And &HF0) = &HF0 Then    'QTH im Ausschnitt

        ErrNr = GetStationData(SV.Out.BsdFile, StnRec, Stn)
        If ErrNr Then Exit For

        ColNr = StnColor(Stn.Software)
        ForeCol& = HV.ColVal(ColNr)

        If Pass = 1 Then
          '--- Anzeigen ---
          ActSym = StnSym(Stn.StnTyp).Actual
          xgeo& = CLng(Stn.xloc) * clQth2Sec
          ygeo& = CLng(Stn.yloc) * clQth2Sec

          If HV.PrtEnbl And 1 Then
            ErrNr = DrawSymbolGeo(HMCrt, xgeo&, ygeo&, ActSym, ForeCol&)
          End If

          If HV.PrtEnbl And 2 Then
            ErrNr = DrawSymbolGeo(HMPrt, xgeo&, ygeo&, ActSym, ForeCol&)
          End If
        Else
          '--- Beschriften ---
          Call MarkNewStation(StnRec, Stn, ForeCol&, NewFlag)
        End If
      End If
    Next i

  Next Pass

  ErrNr = TerminateAllDevices()

End Sub

Sub DrawNameGeo(Dev As HMDevice, xgeo As Long, ygeo As Long, sc$, StnRec, ForeCol&)

  'Funktion: Call an Station bzw. Namen an Stadt/Berg schreiben

  Dim a As lAreaType
  Dim p As PointApi
  Dim r As RECT
  Dim NewPen As HMPen
  Dim NewFont As HMFont

  If Dev.VbFont = 0 Then Stop

  If Dev.Id = 0 Then
    'Screen
    If StnRec = 0 Then
      'Stdte -> unbeschriftet
      rotate = 0
    Else
      rotate = StnFlags(StnRec) And 7
      If rotate = 7 Then Exit Sub     'Kein Platz
    End If
  Else
    'Printer
    rotate = 0
  End If

  p.x = SecGeo2AbsX(Dev, xgeo)
  p.y = SecGeo2AbsY(Dev, ygeo)

  If ForeCol& <> Dev.TextColor Then
    Call ChangeTextColor(Dev, ForeCol&)
  End If

  'Determine Width of text
  chh = DrawText(Dev.hDev, sc$, -1&, r, DT_CALCRECT + DT_SINGLELINE)
  tw = r.Right - r.Left + 1         '1 Pixel Rand rechts
  'offs = Dev.SymbolSize * 1.4
  offs = Dev.SymbolSize + 2         '1 Pixel frei

  'Text kann nur bei True-Type Fonts gedreht werden
  If Dev.RotateText Then
    NewFont = Dev.NameFont
  End If


  '------ Beschriftung wiederholen ------
  Select Case rotate
  Case 0
    'Pruefen, ob Mittelpunkt der Station im Ausschnitt
    '  damit Beschriftung nicht zweimal
    '  in benachbarten Tapeten-Ausschnitten erfolgt
    If PointInRect(p, Dev.MapRect) = 0 Then Exit Sub

  Case 1      'Beschriftung nach rechts
    r.Top = p.y - chh \ 2
    r.Bottom = r.Top + chh
    r.Left = p.x + offs
    r.Right = r.Left + tw

  Case 2      'Beschriftung nach links
    r.Top = p.y - chh \ 2
    r.Bottom = r.Top + chh
    r.Right = p.x - offs                 'linker Rand
    r.Left = r.Right - tw                 'rechter Rand

  Case 3, 4     'Beschriftung nach oben/unten
    If Dev.RotateText Then
      'Text Drehen
      r.Left = p.x - chh \ 2
      r.Right = r.Left + chh
      If rotate = 3 Then
        r.Bottom = p.y - offs
        r.Top = r.Bottom - tw
      Else
        r.Top = p.y + offs
        r.Bottom = r.Top + tw
      End If
      NewFont.Angle = 90
    Else
      'Text nicht drehen
      chh = Dev.PhysFont.CellHeight
      chw = Dev.PhysFont.MaxCharWidth
      dy = NumPar(40).Actual                 'vertikaler Zeichenabstand
      th = (chh + dy) * Len(sc$)             'text height (vertical)

      r.Left = p.x - chw \ 2
      r.Right = r.Left + chw

      If rotate = 3 Then
        r.Bottom = p.y - offs
        r.Top = r.Bottom - th
      Else
        r.Top = p.y + offs
        r.Bottom = r.Top + th
      End If
    End If
  End Select


  '------ Platz und Richtung der Beschriftung bestimmen ------

  '--- Pruefen, ob Ausgabe nach rechts ---
  If rotate = 0 Then
    r.Top = p.y - chh \ 2
    r.Bottom = r.Top + chh
    r.Left = p.x + offs
    r.Right = r.Left + tw
    If TextHits(Dev, r, 3) = 0 Then rotate = 1
  End If


  '--- Pruefen, ob Ausgabe nach links ---
  If rotate = 0 Then
    r.Right = p.x - offs                 'linker Rand
    r.Left = r.Right - tw                 'rechter Rand
    If TextHits(Dev, r, 3) = 0 Then rotate = 2
  End If


  '--- Pruefen, ob Ausgabe nach oben ---
  If rotate = 0 Then
    If Dev.RotateText Then
      'Text Drehen
      r.Left = p.x - chh \ 2
      r.Right = r.Left + chh
      r.Bottom = p.y - offs
      r.Top = r.Bottom - tw
    Else
      'Text nicht drehen
      chh = Dev.PhysFont.CellHeight
      chw = Dev.PhysFont.MaxCharWidth
      dy = NumPar(40).Actual                 'vertikaler Zeichenabstand
      th = (chh + dy) * Len(sc$)             'text height (vertical)

      r.Left = p.x - chw \ 2
      r.Right = r.Left + chw

      r.Bottom = p.y - offs
      r.Top = r.Bottom - th
    End If

    If TextHits(Dev, r, 3) = 0 Then
      rotate = 3
      If Dev.RotateText Then NewFont.Angle = 90
    End If
  End If


  '--- Pruefen, ob Ausgabe nach unten ---
  If rotate = 0 Then
    r.Top = p.y + offs

    If Dev.RotateText Then
      r.Bottom = r.Top + tw
    Else
      r.Bottom = r.Top + th
    End If

    If TextHits(Dev, r, 3) = 0 Then
      rotate = 4
      If Dev.RotateText Then NewFont.Angle = 90
    End If
  End If

  If rotate = 0 Then rotate = 7      'Kein Platz - nicht ausgeben

  If StnRec > 0 Then
    'Nicht fr Stdte
    StnFlags(StnRec) = (StnFlags(StnRec) And Not 15&) Or rotate
  End If


  '--- Beschriften (falls Platz) ---
  If rotate >= 1 And rotate <= 4 Then
    'weien Hintergrund fr Schrift ausgeben
    If (Dev.Options And 8) <> 0 Then
      NewPen.Color = HV.BackCol
      NewPen.Width = 1
      NewPen.Style = 0
      ErrNr = DrawFigureAbs(Dev, r, 11, NewPen, NewPen.Color, 0)
    End If

    If Dev.RotateText Then
      ErrNr = SetFont(Dev, NewFont)
      If rotate >= 3 Then
        r.Top = r.Bottom - 1         '1 Pixel Rand
      End If
      th = DrawText(Dev.hDev, sc$, -1&, r, DT_SINGLELINE + DT_NOCLIP)
    Else
      Select Case rotate
      Case 1, 2              'rechts/links
        th = DrawText(Dev.hDev, sc$, -1&, r, DT_SINGLELINE + DT_NOCLIP)

      Case 3, 4               'oben/unten
        For i = 1 To Len(sc$)
          th = DrawText(Dev.hDev, Mid$(sc$, i, 1), 1&, r, DT_CENTER + DT_SINGLELINE + DT_NOCLIP)
          r.Top = r.Top + chh + dy
        Next i
      End Select
    End If
  End If

End Sub

Sub DrawSelectedStation(ByVal Colo&)

  If HV.SelStnRec > 0 Then      'ein Digi ist selektiert

    If (StnFlags(HV.SelStnRec) And &HF0) = &HF0 Then

      'QTH bekannt und im Ausschnitt
      If Colo& = -1& Then
        ColNr = StnColor(SelStnData.Software)
        Colo& = HV.ColVal(ColNr)
      End If
      SelSym = StnSym(ActStnData.StnTyp).Actual
      x0& = CLng(SelStnData.xloc) * clQth2Sec
      y0& = CLng(SelStnData.yloc) * clQth2Sec

      void = DrawSingleSymbol(x0&, y0&, SelSym, Colo&)

    End If

  End If

End Sub

Function DrawSingleSymbol(xgeo As Long, ygeo As Long, SymNr, ForeCol&)

  ErrNr = PrepareMapDevices(9)

  If ErrNr = 0 Then

    If HV.PrtEnbl And 1 Then
      ErrNr = DrawSymbolGeo(HMCrt, xgeo, ygeo, SymNr, ForeCol&)
    End If

    If HV.PrtEnbl And 2 Then
      ErrNr = DrawSymbolGeo(HMPrt, xgeo, ygeo, SymNr, ForeCol&)
    End If

  End If

  DrawSingleSymbol = ErrNr Or TerminateAllDevices()

End Function

Function DrawSymbolGeo(Dev As HMDevice, xgeo As Long, ygeo As Long, SymNr, ForeCol&)

  Dim r As RECT
  Dim NewPen As HMPen

  If Dev.hDev = 0 Then Stop

  DrawSymbolGeo = True

  xc = SecGeo2AbsX(Dev, xgeo)
  yc = SecGeo2AbsY(Dev, ygeo)

  r.Left = xc - Dev.SymbolSize
  r.Top = yc - Dev.SymbolSize
  r.Right = xc + Dev.SymbolSize + 1
  r.Bottom = yc + Dev.SymbolSize + 1

  void = TextHits(Dev, r, 2)

  If NumPar(41).Actual And 16 Then
    FillStyle = 1   'Symbole transparent
  Else
    FillStyle = 0   'Symbole solid
  End If

  FillCol& = Dev.BackCol

  NewPen.Color = ForeCol&
  NewPen.Width = GetLineWidth(Dev.Id, 12)
  NewPen.Style = 0


  Select Case SymNr
  Case 0 To 2             'senkrechtes Kreuz, schrges Kreuz, Stern
    ErrNr = DrawFigureAbs(Dev, r, 3 + SymNr, NewPen, 0&, 0)

  Case 3                  'leeres Rechteck
    ErrNr = DrawFigureAbs(Dev, r, 11, NewPen, FillCol&, FillStyle)

  Case 4                  'ausgeflltes Rechteck
    ErrNr = DrawFigureAbs(Dev, r, 11, NewPen, ForeCol&, 0)

  Case 5 To 9             'Raute, Dreieck mit Spitze nach: oben, unten, rechts, links
    ErrNr = DrawFigureAbs(Dev, r, 7 + SymNr, NewPen, FillCol&, FillStyle)

  Case 10                 'leerer Kreis
    ErrNr = DrawFigureAbs(Dev, r, 10, NewPen, FillCol&, FillStyle)

  Case 11                 'ausgefllter Kreis
    ErrNr = DrawFigureAbs(Dev, r, 10, NewPen, ForeCol&, 0)

  Case 12                 'Punkt
    ErrNr = DrawFigureAbs(Dev, r, 1, NewPen, 0&, 0)

  Case 13                 'Nichts

  Case Else
    Exit Function

  End Select


  DrawSymbolGeo = True

End Function

Sub InitMarkPrefix()

  AnzMarkStn = AnzItems(StrPar(3, 5))
  If AnzMarkStn Then
    On Error Resume Next
    ReDim MarkStnList$(1 To AnzMarkStn)
    If Err Then
      Call ShowErrNr(25037)
      AnzMarkStn = 0
      Exit Sub
    End If
    On Error GoTo 0
    Call SplitList(UCase$(StrPar(3, 5)), MarkStnList$())
  End If

End Sub

Sub MarkNewStation(StnRec, Stn As StationData, ForeCol&, NewFlag)

  Static LastSc$
  Static xold
  Static yold
  Static LastFlags As Long

  sc$ = MarkStnCall$(Stn)

  'nur beschriften, wenn neues Call oder neues QTH
  x = Stn.xloc
  y = Stn.yloc

  If sc$ = LastSc$ And x = xold And y = yold And Not NewFlag Then
    StnFlags(StnRec) = (StnFlags(StnRec) And Not 7&) Or LastFlags
  Else
    xgeo& = CLng(x) * clQth2Sec
    ygeo& = CLng(y) * clQth2Sec

    If HV.PrtEnbl And 1 Then
      Call DrawNameGeo(HMCrt, xgeo&, ygeo&, sc$, StnRec, ForeCol&)
    End If

    If HV.PrtEnbl And 2 Then
      Call DrawNameGeo(HMPrt, xgeo&, ygeo&, sc$, StnRec, ForeCol&)
    End If

    LastSc$ = sc$
    xold = x
    yold = y
    LastFlags = StnFlags(StnRec) And 7&
    NewFlag = False
  End If

End Sub

Function MarkStnCall$(Stn As StationData)

  Call DecodeCall(Stn.StnCall, TmpCall$, LineNr$)
  'mit / ohne SSID
  If NumPar(41).Actual And 4 Then
    sc$ = TmpCall$
  Else
    sc$ = Parse$(TmpCall$, "-")
  End If

  'Standard-Prefix(e) weglassen
  If AnzMarkStn > 0 Then
    For i = 1 To AnzMarkStn
      ic$ = MarkStnList$(i)
      lp = Len(ic$)
      If Left$(sc$, lp) = ic$ Then
        sc$ = Mid$(sc$, lp + 1)
        Exit For
      End If
    Next i
  End If

  MarkStnCall$ = sc$

End Function

Function TextHits(Dev As HMDevice, r As RECT, Mode)

  'Mode: Bit 0 = 1: Check
  '      Bit 1 = 2: Set

  TextHits = True

  If r.Left > r.Right Or r.Top > r.Bottom Then Stop

  xl = r.Left
  yo = r.Top
  xr = r.Right - 1
  yu = r.Bottom - 1

  If Mode And 1 Then
    'Prfungen: 1. Text mu komplett auf Karte passen
    '           2. Stelle darf noch nicht belegt sein
    If Not RectInRect(0, r, Dev.MapRect) Then Exit Function
  Else
    'Symbole mssen zumindest z.T. in Karte sein
    'Wenn Symbole nur z.T. in Karte, dann berstehenden Teil clippen
    If Not RectInRect(1, r, Dev.MapRect) Then Exit Function

    If xl < Dev.MapRect.Left Then xl = Dev.MapRect.Left
    If yo < Dev.MapRect.Top Then yo = Dev.MapRect.Top
    If xr >= Dev.MapRect.Right Then xr = Dev.MapRect.Right - 1
    If yu >= Dev.MapRect.Bottom Then yu = Dev.MapRect.Bottom - 1
  End If



  FirstWord = xl \ 31
  FirstBit = xl Mod 31
  LastWord = xr \ 31
  LastBit = xr Mod 31

  If FirstWord = LastWord Then
    'only word
    Mask& = 2& ^ (LastBit + 1) - 2& ^ FirstBit
  Else
    'first + last word
    Mask1& = 2& ^ 31 - 2& ^ FirstBit
    Mask2& = 2& ^ (LastBit + 1) - 1
  End If


  If Mode And 1 Then

    '------ Reservierung prfen ------

    If Dev.Id = 0 Then

      '--- Bildschirm ---
      If FirstWord = LastWord Then
        'only word
        For y = yo To yu
          If CrtHits(FirstWord, y) And Mask& Then Exit Function
        Next y
      Else
        'first + last word
        For y = yo To yu
          If CrtHits(FirstWord, y) And Mask1& Then Exit Function
          If CrtHits(LastWord, y) And Mask2& Then Exit Function
        Next y

        '2nd to n-1st word
        For Word = FirstWord + 1 To LastWord - 1
          For y = yo To yu
            If CrtHits(Word, y) Then Exit Function
          Next y
        Next Word
      End If

    Else

      '--- Drucker ---
      If FirstWord = LastWord Then
        'only word
        For y = yo To yu
          If PrtHits(FirstWord, y) And Mask& Then Exit Function
        Next y
      Else
        'first + last word
        For y = yo To yu
          If PrtHits(FirstWord, y) And Mask1& Then Exit Function
          If PrtHits(LastWord, y) And Mask2& Then Exit Function
        Next y

        '2nd to n-1st word
        For Word = FirstWord + 1 To LastWord - 1
          For y = yo To yu
            If PrtHits(Word, y) Then Exit Function
          Next y
        Next Word
      End If

    End If
  End If


  If Mode And 2 Then

    '------ Reservierung setzen ------
    If Dev.Id = 0 Then

      '--- Bildschirm ---
      If FirstWord = LastWord Then
        'only word
        For y = yo To yu
          CrtHits(FirstWord, y) = CrtHits(FirstWord, y) Or Mask&
        Next y
      Else
        'first + last word
        For y = yo To yu
          CrtHits(FirstWord, y) = CrtHits(FirstWord, y) Or Mask1&
          CrtHits(LastWord, y) = CrtHits(LastWord, y) Or Mask2&
        Next y

        '2nd to n-1st word
        For Word = FirstWord + 1 To LastWord - 1
          For y = yo To yu
            CrtHits(Word, y) = -1
          Next y
        Next Word
      End If

    Else

      '--- Drucker ---
      If FirstWord = LastWord Then
        'only word
        For y = yo To yu
          PrtHits(FirstWord, y) = PrtHits(FirstWord, y) Or Mask&
        Next y
      Else
        'first + last word
        For y = yo To yu
          PrtHits(FirstWord, y) = PrtHits(FirstWord, y) Or Mask1&
          PrtHits(LastWord, y) = PrtHits(LastWord, y) Or Mask2&
        Next y

        '2nd to n-1st word
        For Word = FirstWord + 1 To LastWord - 1
          For y = yo To yu
            PrtHits(Word, y) = -1
          Next y
        Next Word
      End If
    End If

  End If

  TextHits = False

End Function

