Attribute VB_Name = "FileMsg"
'---------------------------- FILMSG.BAS ----------------------------

'File-Message-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z



Dim MsgTxtNr()                  'Message Nummer
Dim MsgTxt$()                   'Message Text
Dim MsgPtr() As Long            'Pointer to Message
Dim ActMsgPtr As Long
Dim BinMsgFileNr
Dim BinMsgFileExist
Dim AnzMsg                      'Aktuelle Anzahl Messages
Dim LastMsgNr                   'Letzte Message Nummer
Dim MsgMode                     '1 = return empty String, if Msg not found
Dim LoadMsgComplete

Function InitMsg(OutMsgFile$)

  InitMsg = True

  '--- Speicher fuer Messages reservieren ---
  On Local Error Resume Next
  ReDim MsgTxtNr(1 To AnzMsg)              'Message Nummer

  If Len(OutMsgFile$) = 0 Then
    ReDim MsgTxt$(1 To AnzMsg)             'Message Text
  Else
    ReDim MsgPtr(1 To AnzMsg) As Long      'Message Pointer
  End If

  ErrNr = Err
  On Local Error GoTo 0

  If ErrNr Then
    Call FileError("Not enough memory for messages", "")
    Exit Function
  End If

  If Len(OutMsgFile$) > 0 Then
    Call ParseFileSpec(MsgFile$, d$, p$, n$, e$)
    f$ = d$ + p$ + OutMsgFile$ + ".BMS"

    '--- Datei loeschen ---
    On Local Error Resume Next
    Kill f$
    ErrNr = Err
    On Local Error GoTo 0

    Select Case ErrNr
    Case 0, 53  'Ok, Not Found
    Case 70, 75 'Permission denied/write protected
      BinMsgFileExist = True    'use existing message file
    Case Else
      Call ShowErrNrFileTxt(Err, File$)
      Exit Function
    End Select

    ErrNr = OpenFile(f$, "B", 0, BinMsgFileNr)
    If ErrNr <> 0 Then Exit Function
  End If

  InitMsg = False

End Function

Function IsMessageActive(m$)

  If Left$(m$, 1) = "$" Then
    d$ = UCase$(Left$(m$, 2))
    IsMessageActive = (d$ = "$W" Or d$ = "$X")
    m$ = LTrim$(Mid$(m$, 3))
  Else
    IsMessageActive = True
  End If

End Function

Function LoadMessages(SectList$, OutMsgFile$)

'Ticks& = GetTickCount()

  LoadMessages = True

  ActMsgPtr = 1&

  ErrNr = LoadMsg(1, SectList$)
  If ErrNr Then Exit Function

  ErrNr = InitMsg(OutMsgFile$)
  If ErrNr Then Exit Function

  ErrNr = LoadMsg(2, SectList$)
  If ErrNr Then Exit Function

  LoadMsgComplete = True
  LoadMessages = False

'MsgBox Str$(GetTickCount() - Ticks&)

End Function

Function LoadMsg(Pass, SectList$)

  Static LastSection$

  LoadMsg = True

  ErrNr = OpenFile(MsgFile$, "I", 0, FileNr)
  If ErrNr Then Exit Function

  AnzMsg = 0
  lst$ = SectList$

  Do Until Len(lst$) = 0

    Section$ = Parse$(lst$, ",")

    '----- Bereich suchen ------
    'If Section$ <> LastSection$ Then
      ErrNr = FindSection(FileNr, Section$, LastSection$, True, Found)
      If ErrNr Or Not Found Then Exit Function
    'End If

    '----- Datei einlesen ------
    Do Until EOF(FileNr)
      ErrNr = ReadLine(FileNr, InpLine$)
      If ErrNr Then
        void = CloseFile(FileNr)
        Exit Function
      End If

      InpLine$ = LTrim$(RTrim$(InpLine$))

      If Len(InpLine$) > 0 And Left$(InpLine$, 1) <> ";" Then
        If Left$(InpLine$, 1) = "[" Then
          LastSection$ = InpLine$
          Exit Do
        End If

        AnzMsg = AnzMsg + 1

        If Pass = 2 Then
          'Messages speichern
          ErrNr = StoreMessage(InpLine$)
          If ErrNr Then Exit Function
        End If
      End If
    Loop

  Loop

  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Function

  LoadMsg = False

End Function

Function Msg$(ByVal lMsgNr As Long)


  If LoadMsgComplete Then
    iMsgNr = CInt(lMsgNr - 32768)

    'Nachricht mit Nr. 'lMsgNr' ausgeben
    Lo = 0
    Hi = AnzMsg + 1
    Diff = Hi - Lo

    Do Until Diff = 1
      Mitte = Diff \ 2 + Lo

      On Error Resume Next
      ActMsgNr = MsgTxtNr(Mitte)
      ErrNr = Err
      On Error GoTo 0
      If ErrNr Then Exit Do

      If iMsgNr = ActMsgNr Then
        If BinMsgFileNr = 0 Then
          Msg$ = MsgTxt$(Mitte)
        Else
          ErrNr = GetLenText(BinMsgFileNr, MsgPtr(Mitte), m$)
          If ErrNr Then Exit Do
          Msg$ = m$
        End If
        Exit Function
      End If

      If iMsgNr > MsgTxtNr(Mitte) Then
        Lo = Mitte
      Else
        Hi = Mitte
      End If

      Diff = Hi - Lo
    Loop
  End If

  '--- Message nicht gefunden oder nicht geladen ---
  Select Case lMsgNr
  Case 53
    Msg$ = "Datei nicht gefunden / File not found"
  Case 70
    Msg$ = "Zugriff verweigert / Permission denied"
  Case 76
    Msg$ = "Pfad nicht gefunden / Path not found"
  Case 25000
    Msg$ = "Fehler / Error"
  Case 25001
    Msg$ = "Datei / File"
  Case 25030
    Msg$ = "Bereich nicht gefunden / Section not found"
  Case 25050
    Msg$ = "Ok"
  Case Else
    If MsgMode And 1 Then
      Msg$ = ""
    Else
      Msg$ = Msg$(25000) + Str$(lMsgNr)
    End If
  End Select

End Function

Sub SetMsgMode(n)

  MsgMode = n

End Sub

Function StdMsg$(ByVal MsgNr As Long)

  m$ = Msg$(MsgNr)

  'Remove "$x" at beginning
  If Left$(m$, 1) = "$" Then
    m$ = LTrim$(Mid$(m$, 3))
  End If

  'Remove "&"
  m$ = Replace$(m$, "&", "")

  'Remove "..." at end
  m$ = Replace$(m$, "...", "")

  StdMsg$ = m$

End Function

Function StoreMessage(InpLine$)

  Dim MsgNr As Long
  Dim LastMsgNr As Long

  StoreMessage = True

  '--- Messages speichern ---
  If AnzMsg > UBound(MsgTxtNr) Then
    Call FileError("Too many Messages", "")
    Exit Function
  End If

  OrgLine$ = InpLine$

  '--- Message Number ---
  'Funktion, um Floating-Point-Package bei VAL zu vermeiden
  MsgNr = IntVal(Parse$(InpLine$, ","))

  If MsgNr <= LastMsgNr Then
    m$ = "Invalid Message Sequence:" + Str$(MsgNr)
    m$ = m$ + Chr$(13) + Chr$(10) + OrgLine$
    Call FileError(m$, "")
    Exit Function
  End If

  LastMsgNr = MsgNr
  MsgTxtNr(AnzMsg) = CInt(MsgNr - 32768)

  '--- Mesage Text ---
  If Left$(InpLine$, 2) = "$?" Then InpLine$ = Mid$(InpLine$, 3)

  InpLine$ = Pc8toAnsi$(InpLine$)

  If BinMsgFileNr = 0 Then
    MsgTxt$(AnzMsg) = InpLine$
  Else
    If Not BinMsgFileExist Then
      ErrNr = PutLenText(BinMsgFileNr, ActMsgPtr, InpLine$)
      If ErrNr Then Exit Function
    End If
    MsgPtr(AnzMsg) = ActMsgPtr
    ActMsgPtr = ActMsgPtr + Len(InpLine$) + 2
  End If

  StoreMessage = False

End Function

