Attribute VB_Name = "FILTER"
'-------------------------- FILTER.BAS ------------------------

'Filter-Unterprogramme fuer DOS und Windows
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CheckBoxMask(Title$, iMsgBase, AnzCols, Mask&, Dsbl&, Change&)

  CheckBoxMask = RadioCheckMask(0, Title$, iMsgBase, AnzCols, Mask&, Dsbl&, Change&)

End Function

Function RadioBtnMask(Title$, iMsgBase, AnzCols, Mask&, Dsbl&, Change&)

  RadioBtnMask = RadioCheckMask(1, Title$, iMsgBase, AnzCols, Mask&, Dsbl&, Change&)

End Function

Function RadioCheckMask(Mode, Title$, iMsgBase, AnzCols, Mask&, Dsbl&, Change&)

  OldMask& = Mask&

  With FilterForm

    .Caption = Title$

    Call SetMsgMode(1)

    i = 0

    Do
      If iMsgBase > 0 Then
        m$ = Msg$(iMsgBase + i)
        mf$ = FilterMsg$(iMsgBase + i)
      Else
        m$ = FilterMsg$(i)
        mf$ = ""
      End If
      If Len(m$) = 0 Then Exit Do

      CtlVisible = IsMessageActive(m$)

      If CtlVisible Then
        m$ = m$ + mf$
        AnzVis = AnzVis + 1
      Else
        m$ = ""
      End If

      If Mode = 0 Then
        If i > 0 Then Load .Chk(i)
        .Chk(i).TabIndex = i
        .Chk(i).Caption = m$
        .Chk(i).Visible = CtlVisible
        .Chk(i).Enabled = (2 ^ i And Dsbl&) = 0
      Else
        If i > 0 Then Load .Opt(i)
        .Opt(i).TabIndex = i
        .Opt(i).Caption = m$
        .Opt(i).Visible = CtlVisible
        .Opt(i).Enabled = (2 ^ i And Dsbl&) = 0
      End If

      l = .TextWidth(m$)
      If l > MaxLen Then MaxLen = l

      i = i + 1
    Loop

    Call SetMsgMode(0)

    AnzItem = i
    .Tag = Str$(AnzItem - 1)

    If Mode = 0 Then
      y0 = .Chk(0).Height
    Else
      y0 = .Opt(0).Height
    End If
    x0 = y0

    cx = MaxLen + 1.5 * x0
    x1 = 1.5 * x0
    dy = 1.5 * y0
    y1 = y0 + 0.5 * dy
    cmddy = 720

    dx = cx + x0


    If AnzCols = 1 Or AnzVis <= 12 Then
      '1 Spalte
      FormHeight = AnzVis
    Else
      '2 Spalten
      FormHeight = (AnzVis + 1) \ 2
    End If


    '--- Position und Wert der Check-Boxen ---
    BitMask& = 1&

    For i = 0 To AnzItem - 1
      If Mode = 0 Then
        .Chk(i).Top = y0 + (ivis Mod FormHeight) * dy
        .Chk(i).Left = x0 + (ivis \ FormHeight) * dx
        .Chk(i).Width = cx
        .Chk(i).Value = (Mask& And BitMask&) / BitMask&
        BitMask& = BitMask& * 2&

        If Len(.Chk(i).Caption) > 0 Then ivis = ivis + 1

      Else
        .Opt(i).Top = y0 + (ivis Mod FormHeight) * dy
        .Opt(i).Left = x0 + (ivis \ FormHeight) * dx
        .Opt(i).Width = cx

        If Len(.Opt(i).Caption) > 0 Then ivis = ivis + 1
      End If

    Next i

    If Mode > 0 Then .Opt(Mask&).Value = True


    '--- Position der Taster ---
    cmdx = 2 * x0 + ((AnzVis - 1) \ FormHeight + 1) * dx

    cmdy = .Cmd(0).Top

    If Mode = 0 Then MaxCmd = 3 Else MaxCmd = 1

    For i = 0 To MaxCmd
      If i > 0 Then Load .Cmd(i)
      .Cmd(i).Move cmdx, cmdy
      .Cmd(i).Visible = True
      .Cmd(i).TabIndex = AnzItem + i
      cmdy = cmdy + cmddy
    Next i

    .Cmd(0).Default = True
    .Cmd(1).Cancel = True

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)
    If Mode = 0 Then
      .Cmd(2).Caption = Msg$(25054)
      .Cmd(3).Caption = Msg$(25055)
    End If


    '--- Formular Breite und Hoehe berechnen ---
    borderheight = .Height - .ScaleHeight
    .Width = cmdx + CmdWidth + x1

    FormHeight = FormHeight * dy + y1
    If FormHeight < cmdy Then FormHeight = cmdy
    .Height = FormHeight + borderheight


    '--- Maske anzeigen und auf Ende warten ---
    Call CenterForm(FilterForm)
    .Show 1


    '--- Falls nicht Abbruch -> Werte auslesen ---
    If Val(.Tag) = 0 Then
      If Mode = 0 Then
        'Check-Boxes
        BitMask& = 1&
        Mask& = 0&
        AllMask& = 0&

        For i = 0 To AnzItem - 1
          If .Chk(i).Value = 1 Then Mask& = Mask& Or BitMask&
          AllMask& = AllMask& Or BitMask&
          BitMask& = BitMask& * 2&
        Next i

        '--- pruefen, ob alle Bits gesetzt ---
        If Mask& = AllMask& Then Mask& = -1&
      Else
        'Radio-Buttons
        For i = 0 To AnzItem - 1
          If .Opt(i).Value Then
            Mask& = i
            Exit For
          End If
        Next i
      End If
    End If

    Cancel = Val(.Tag) > 0
  End With

  If Mode = 0 Then
    Change& = (Mask& Xor OldMask&) And AllMask&
  Else
    Change& = Mask& <> OldMask&
  End If

  If Cancel Then Change& = False


  '--- Maske entladen ---
  Unload FilterForm
  Set FilterForm = Nothing

  RadioCheckMask = Cancel

End Function

