Attribute VB_Name = "FncDisp"
'--------------------------- FNCDISP.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z


Sub DisplayFunctions(Fkt)

  Call PrepareFunction(True, 2)       'DOS: Text-Mode + Save Screen

  Title$ = ProgName$ + " - " + StdMsg$(20007) + " - " + StdMsg$(20140 + Fkt)

  Select Case Fkt
  Case 1                '--- Karten-Inhalt ---
    If HV.MapType >= 2 Then Dsbl& = &H3FF
    Cancel = CheckBoxMask(Title$, 24500, 0, NumPar(9).Actual, Dsbl&, MapChange&)
    If MapChange& Then Call SetMapToolbar


  Case 2                '--- Karten-Details ---
    If HV.MapType >= 2 Then Dsbl& = &HFF Else Dsbl& = 3
    Cancel = SelectDetails(Title$, Dsbl&, NumPar(44).Actual, NumPar(9).Actual, MapChange&)
    If MapChange& Then
      'Details nicht mehr automatisch
      NumPar(46).Actual = NumPar(46).Actual And Not MF_AutoDetail
      Call SetMapToolbar
    End If


  Case 3                'Symbole
    n = AnzStnAbv(2) - 1
    Cancel = GetStnSymbols(Title$, n, NumPar(2).Actual, MapChange&)
    'Karte neu ausgeben, bei Prefix-Vernderung und Stationsausgabe
    MapChange& = MapChange& And (NumPar(9).Actual And ME_Stn) <> 0


  Case 4                'Prefix
    OldPrefix$ = UCase$(StrPar(3, 5))
    Cancel = GetInput(Title$, Msg$(31015), StrPar(3, 5), InpLine$)
    StrPar(3, 5) = UCase$(InpLine$)
    MapChange& = OldPrefix$ <> StrPar(3, 5)
    If MapChange& Then Call InitMarkPrefix
    'Karte neu ausgeben, bei Prefix-Vernderung und Stationsbeschriftung
    MapChange& = MapChange& And (NumPar(9).Actual And ME_StnCalls) <> 0


  Case 5                '--- Stationen ---
    Cancel = CheckBoxMask(Title$, 21000, 0, NumPar(41).Actual, 0&, Change&)

    'Karte neu ausgeben, bei Stations-Vernderung und Stationsausgabe
    c1 = (Change& And &H12) And (NumPar(9).Actual And ME_Stn) <> 0
    'Karte neu ausgeben, bei Beschriftungs-Vernderung und Stationsbeschriftung
    c2 = (Change& And 4&) And (NumPar(9).Actual And ME_StnCalls) <> 0
    MapChange& = c1 Or c2

    If (Change& And 8&) <> 0 And HV.SelStnRec > 0 Then
      '"Blinken" wurde verndert und Station ist selektiert
      NewPar& = NumPar(41).Actual
      LastSelect = HV.SelStnRec

      'Ggf. Fadenkreuzcursor ausschalten
      NumPar(41).Actual = NewPar& Xor Change&     'alte Einstellung
      Call DeselectStation

      'Ggf. Fadenkreuzcursor einschalten
      NumPar(41).Actual = NewPar&
      void = SelectStation(LastSelect, False)
    End If


  Case 6                '--- Links ---
    Cancel = CheckBoxMask(Title$, 21020, 0, NumPar(42).Actual, 0&, Change&)
    If Change& And 1 Then
      'Links nach auerhalb gendert -> Flags neu berechnen
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H80
    End If

    'Karte neu ausgeben, bei Link-Vernderung und Linkausgabe
    MapChange& = (Change& And 7) <> 0 And (NumPar(9).Actual And ME_Links) <> 0


  Case 7                '--- Entfernung + Position ---
    ErrNr = InitMaskData(5, Title$, "")
    If ErrNr = 0 Then
      'Set Prompt and Default
      Call SetMaskData(1, Msg$(40100), "", "@40000", "", "")   'Entfernung
      Call SetMaskData(2, Msg$(40103), "", "@40030", "", "")   'Locator
      Call SetMaskData(3, Msg$(40104), "", "@40040", "", "")   'Geogr.Koordinaten
      Call SetMaskData(4, Msg$(40105), "", "@40050", "", "")   'Koordinatensystem
      Call SetMaskData(5, Msg$(40106), "", "@40060", "", "")   'Kartendatum

      For i = 1 To 5
        MaskData(i, 2) = CStr(NumPar(56 + i).Actual)    'Default fr Eingabe
      Next i

      Cancel = GetMaskInput(0, Change&)

      If Not Cancel Then
        For i = 1 To 5
          NumPar(56 + i).Actual = Val(GetMaskData(i))
        Next i
        MapChange& = Change& And 4&
      End If

      Call EraseMaskData
    End If


  Case 8                '--- Extras ---
    Dsbl& = 0&

    Cancel = CheckBoxMask(Title$, 24450, 0, NumPar(12).Actual, Dsbl&, Change&)


    If Change& And 2& Then
      '"Einstellungen beim Beenden speichern" wurde gendert
      Call HMWriteParameter
    End If
    MapChange& = False


  Case 9                'Farben
    'MapChange& kann auch bei Cancel = True gesetzt sein !
    Cancel = SelectColors(MapChange&)


  Case 10, 11            '--- Schriftgroesse ---
    Cancel = ScreenSelectFont(Title$, Change&)
    If Not Cancel Then
      'Symbol- und Font-Gre nicht automatisch
      OldPar& = NumPar(51).Actual
      NumPar(51).Actual = NumPar(51).Actual And Not 4&
      Change& = Change& Or ((OldPar& Xor NumPar(51).Actual) <> 0)
    End If

    'Schrift gendert und Symbole und/oder Beschriftung in Karte
    c1 = ME_MtnNames Or ME_TownNames Or ME_GridNames
    c1 = c1 Or ME_StnCalls Or ME_Mountains Or ME_Towns Or ME_Stn
    MapChange& = Change& <> 0& And (NumPar(9).Actual And c1) <> 0&


  Case 12               'Linienbreite
    Call SelectLineWidth(0, Title$, MapChange&)

  Case 13               'Bildschirm
    Dsbl& = 0&

    Cancel = CheckBoxMask(Title$, 24400, 0, NumPar(51).Actual, Dsbl&, Change&)

    'Names
    cn = ME_MtnNames Or ME_TownNames Or ME_StnCalls
    'Symbols
    cs = ME_Mountains Or ME_Towns Or ME_Stn Or cn

    'Farbausgabe, Wasser+Land
    c1 = Change& And 3&
    'Symbolgre automatisch
    c2 = (Change& And 4&) <> 0 And (NumPar(9).Actual And cs) <> 0
    'Text
    c3 = (Change& And &H18&) <> 0 And (NumPar(9).Actual And (cn Or ME_GridNames)) <> 0
    MapChange& = c1 Or c2 Or c3


  Case 14               'Bedienung
    OldPar& = NumPar(53).Actual
    Cancel = CheckBoxMask(Title$, 24430, 0, NumPar(53).Actual, 0&, Change&)
    If Change& Then Call GuiFunctions(OldPar&)
    MapChange& = False

  End Select

  Call TerminateFunction(1, MapChange&)

End Sub

'Function SelectDetails siehe Datei 'SelMap.bas'

Sub DrawSymbols(MaxSymbols)

  With SymbolForm

    x0 = .Temp.ScaleWidth / 2
    y0 = .Temp.ScaleHeight / 2

    SymWidth = y0 / 2

    xl = x0 - SymWidth
    xr = x0 + SymWidth
    yu = y0 - SymWidth
    yo = y0 + SymWidth


    For i = 0 To MaxSymbols

      .Temp.Cls

      Select Case i
      Case 0                                'senkrechtes Kreuz
        .Temp.Line (x0, yo)-(x0, yu)
        .Temp.PSet Step(0, 0)
        .Temp.Line (xl, y0)-(xr, y0)
        .Temp.PSet Step(0, 0)

      Case 1                                'schraeges Kreuz
        .Temp.Line (xl, yo)-(xr, yu)
        .Temp.PSet Step(0, 0)
        .Temp.Line (xr, yo)-(xl, yu)
        .Temp.PSet Step(0, 0)

      Case 2                                'Stern
        .Temp.Line (x0, yo)-(x0, yu)
        .Temp.PSet Step(0, 0)
        .Temp.Line (xl, y0)-(xr, y0)
        .Temp.PSet Step(0, 0)
        .Temp.Line (xl, yo)-(xr, yu)
        .Temp.PSet Step(0, 0)
        .Temp.Line (xr, yo)-(xl, yu)
        .Temp.PSet Step(0, 0)

      Case 3                                'leeres Rechteck
        .Temp.FillColor = .Temp.BackColor
        .Temp.Line (xl, yo)-(xr, yu), , B

      Case 4                                'ausgefuelltes Rechteck
        .Temp.FillColor = .Temp.ForeColor
        .Temp.Line (xl, yo)-(xr, yu), , B

      Case 5                                'Raute
        .Temp.Line (x0, yo)-(xr, y0)
        .Temp.Line -(x0, yu)
        .Temp.Line -(xl, y0)
        .Temp.Line -(x0, yo)

      Case 6                                'Dreieck (Spitze oben)
        .Temp.Line (x0, yo)-(xr, yu)
        .Temp.Line -(xl, yu)
        .Temp.Line -(x0, yo)

      Case 7                                'Dreieck (Spitze unten)
        .Temp.Line (x0, yu)-(xr, yo)
        .Temp.Line -(xl, yo)
        .Temp.Line -(x0, yu)

      Case 8                                'Dreieck (Spitze rechts)
        .Temp.Line (xr, y0)-(xl, yu)
        .Temp.Line -(xl, yo)
        .Temp.Line -(xr, y0)

      Case 9                                'Dreieck (Spitze links)
        .Temp.Line (xl, y0)-(xr, yu)
        .Temp.Line -(xr, yo)
        .Temp.Line -(xl, y0)

      Case 10                               'leerer Kreis
        .Temp.FillColor = .Temp.BackColor
        .Temp.Circle (x0, y0), SymWidth

      Case 11                               'ausgefuellter Kreis
        .Temp.FillColor = .Temp.ForeColor
        .Temp.Circle (x0, y0), SymWidth

      Case 12                               'Punkt
        .Temp.DrawWidth = 2
        .Temp.PSet (x0, y0)

      Case 13                               'Nichts

      End Select

      .SymbolImage(i).Picture = .Temp.Image

    Next i

  End With

End Sub

Function GetLineWidth(DevId, i)

  ParNr = 62 + DevId * 2 + i \ 8
  Offset& = 16& ^ (i Mod 8)
  GetLineWidth = (NumPar(ParNr).Actual And 7& * Offset&) \ Offset& + 1

End Function

Function GetStnSymbols(Title$, MaxItem, TypMask&, Change&)


  MaxSymbols = 13

  Screen.MousePointer = 11

  x0 = SymbolForm.Symbol(0).Height
  y0 = 140
  dy = 280


  '--- Symbole ausgeben ---
  y = y0
  For i = 0 To MaxSymbols
    If i > 0 Then
      Load SymbolForm.Symbol(i)
      Load SymbolForm.SymbolImage(i)
      SymbolForm.Symbol(i).Visible = True
      SymbolForm.SymbolImage(i).Visible = True
    End If
    SymbolForm.Symbol(i).Top = y
    SymbolForm.Symbol(i).TabIndex = i
    SymbolForm.SymbolImage(i).Top = y
    y = y + dy
  Next i

  Call DrawSymbols(MaxSymbols)

  '--- Stations-Typ ausgeben ---
  For i = 0 To MaxItem
    l = SymbolForm.TextWidth(Msg$(24310 + i))
    If l > MaxLen Then MaxLen = l
  Next i

  BitMask& = 1&
  y = y0

  For i = 0 To MaxItem
    If i > 0 Then
      Load SymbolForm.StnTyp(i)
      Load SymbolForm.StnTypImage(i)
      Load SymbolForm.TypLabel(i)
      SymbolForm.StnTyp(i).Visible = True
      SymbolForm.StnTypImage(i).Visible = True
      SymbolForm.TypLabel(i).Visible = True
    End If

    SymbolForm.StnTyp(i).Top = y
    SymbolForm.StnTypImage(i).Top = y
    SymbolForm.StnTyp(i).TabIndex = MaxSymbols + 1 + i

    SymbolForm.TypLabel(i).Top = y
    SymbolForm.TypLabel(i).Width = MaxLen
    SymbolForm.TypLabel(i).Caption = Msg$(24310 + i)


    '--- aktuelle Werte ausgeben ---
    OutEnbl = (TypMask& And BitMask&) <> 0
    SymbolForm.StnTyp(i).Enabled = OutEnbl
    SymbolForm.TypLabel(i).Enabled = OutEnbl
    BitMask& = BitMask& * 2&

    SymbolNr = StnSym(i).Actual
    SymbolForm.StnTypImage(i).Picture = SymbolForm.SymbolImage(SymbolNr).Picture
    SymbolForm.StnTyp(i).Tag = Format$(SymbolNr)

    y = y + dy
  Next i


  '--- Befehls-Tasten ---
  SymbolForm.Cmd(0).Caption = Msg$(25050)
  SymbolForm.Cmd(1).Caption = Msg$(25053)
  SymbolForm.Cmd(2).Caption = Msg$(25056)

  CmdLeft = SymbolForm.TypLabel(0).Left + MaxLen + x0

  For i = 0 To 2
    SymbolForm.Cmd(i).Left = CmdLeft
    SymbolForm.Cmd(i).Width = CmdWidth
    SymbolForm.Cmd(i).Height = CmdHeight
  Next i


  '--- Form ---
  SymbolForm.Caption = Title$
  SymbolForm.Width = CmdLeft + CmdWidth + 1.5 * x0
  SymbolForm.Height = (MaxItem + 1) * dy + 5 * y0
  SymbolForm.Line1.y2 = SymbolForm.ScaleHeight

  Screen.MousePointer = 0


  '--- Falls nicht Abbruch -> Werte auslesen ---
  If Val(SymbolForm.Tag) = 0 Then
    For i = 0 To MaxItem
      StnSym(i).Actual = Val(SymbolForm.StnTyp(i).Tag)
    Next i
  End If


  '--- Form ausgeben und Eingabe machen ---
  Call CenterForm(SymbolForm)

  SymbolForm.Show 1

  '--- Falls nicht Abbruch -> Werte auslesen ---
  Cancel = Val(SymbolForm.Tag) <> 0
  Change& = 0&

  If Not Cancel Then
    For i = 0 To MaxItem
      NewSymbol = Val(SymbolForm.StnTyp(i).Tag)
      If StnSym(i).Actual <> NewSymbol Then
        Change& = True
        StnSym(i).Actual = NewSymbol
      End If
    Next i
  End If


  '--- Maske entladen ---
  Unload SymbolForm
  Set SymbolForm = Nothing

  GetStnSymbols = Cancel

End Function

Function ScreenSelectFont(Title$, Change&)

  Change& = False


  With FileSpecForm.CmDlg
    .CancelError = True
    .Flags = &H10401

    .FontName = StrPar(3, 8)
    .FontSize = NumPar(36).Actual / 1000
    .FontBold = (NumPar(37).Actual And 1) <> 0
    .FontItalic = (NumPar(37).Actual And 2) <> 0

    On Error Resume Next
    .Action = 4
    Cancel = Err
    On Error GoTo 0

    If Cancel = 0 Then
      P37& = (.FontBold And 1) Or (.FontItalic And 2)

      If StrPar(3, 8) <> .FontName Then Change& = True
      If NumPar(36).Actual <> .FontSize * 1000! Then Change& = True
      If NumPar(37).Actual <> P37& Then Change& = True

      StrPar(3, 8) = .FontName
      NumPar(36).Actual = .FontSize * 1000!
      NumPar(37).Actual = P37&
    End If

  End With


  ScreenSelectFont = Cancel <> 0

End Function

Function SelectColors(Change&)

  Static SaveCol(0 To 15) As Long

  With ColorForm
    .Caption = ProgName$ & " - " & Msg$(19220)
    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)
    .DefaultCmd.Caption = Msg$(19221)
    .ColorCmd.Caption = Msg$(19223)
    .MapCmd.Caption = Msg$(19222)
    .HelpCmd.Caption = Msg$(25056)

    Call CenterForm(ColorForm)

    'Save Colors
    For i = 0 To 15
      SaveCol(i) = HV.ColVal(i)
    Next i

    'Farben whlen
    .Show 1

    Cancel = Val(.Tag) <> 0
    Change& = False

    For i = 0 To 15
      If SaveCol(i) <> HV.ColVal(i) Then Change& = True
    Next i

    If Cancel Then
      'Abbruch
      If Change& Then
        'Farben wieder herstellen
        For i = 0 To 15
          HV.ColVal(i) = SaveCol(i)
        Next i
      End If

      'Vorschau -> Karte wiederherstellen
      Change& = Val(.ColorCmd.Tag) = 2
    End If

  End With

  '--- Maske entladen ---
  Unload ColorForm
  Set ColorForm = Nothing

  SelectColors = Cancel

End Function

Sub SelectLineWidth(DevId, Title$, Change&)

  Const AnzFields = 13

  ErrNr = InitMaskData(AnzFields, Title$, Msg$(19904))

  'm$ = "1|2|3|4|5|6|7|8"
  m$ = ""

  For i = 0 To AnzFields - 1
    Call SetMaskData(i + 1, Msg$(19240 + i), CStr(GetLineWidth(DevId, i)), m$, "1", "8")
  Next i

  If DevId = 0 Then
    Dsbl = 0&
  Else
    Dsbl = &H800
  End If

  Cancel = GetMaskInput(Dsbl, Change&)
  If Cancel Then Exit Sub

  For i = 62 To 63
    NumPar(i + DevId * 2).Actual = 0
    NumPar(i + DevId * 2).Actual = 0
  Next i

  For i = 0 To AnzFields - 1
    ParNr = 62 + DevId * 2 + i \ 8
    NewWidth& = 16& ^ (i Mod 8) * (Val(GetMaskData(i + 1)) - 1)
    NumPar(ParNr).Actual = NumPar(ParNr).Actual Or NewWidth&
  Next i

End Sub

