Attribute VB_Name = "FncInfo"
'-------------------------- FNCINFO.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z


  Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
  End Type

  Declare Sub GlobalMemoryStatus Lib "kernel32.dll" (lpBuffer As MEMORYSTATUS)

Sub AutoAreaLocator(a As lAreaType)

  If (NumPar(46).Actual And MF_AutoArea) = 0 Then Exit Sub

  Call AutoArea(2, a.lxmin, a.lymin)   'links unten
  Call AutoArea(2, a.lxmin, a.lymax)
  Call AutoArea(2, a.lxmax, a.lymin)
  Call AutoArea(2, a.lxmax, a.lymax)   'rechts oben

End Sub

Sub FindCoordinate(Title$)

  Dim a As lAreaType
  Dim NewPen As HMPen


  Static Default1$, Default2$

  ErrNr = InitMaskData(2, Title$, Msg$(24133))
  If ErrNr Then Exit Sub

  'Set Prompt and Default
  Call SetMaskData(1, Msg$(24134), Default1$, "", "", "")
  Call SetMaskData(2, Msg$(24135), Default2$, "", "", "")

  Cancel = GetMaskInput(0, Change&)

  ycoord$ = GetMaskData(1)
  xcoord$ = GetMaskData(2)

  Call EraseMaskData

  If Cancel Then Exit Sub

  Default1$ = ycoord$
  Default2$ = xcoord$

  ErrNr = Str2dDegCoord(xcoord$, grd#, 2)
  x& = grd# * cfDeg2Sec

  ErrNr = Str2dDegCoord(ycoord$, grd#, 1)
  y& = grd# * cfDeg2Sec

  If Not PointInWorld(x&, y&) Then
    Call ShowErrNr(24136)
    Exit Sub
  End If

  Call AutoArea(7, x&, y&)

  If Not PointInLArea(x&, y&, MV.ActMapArea) Then
    Call ShowErrNr(24137)
    Exit Sub
  End If

  dx& = HMCrt.SecPerPixelX * 3
  dy& = HMCrt.SecPerPixelY * 3

  a.lxmin = x& - dx&
  a.lxmax = x& + dx&
  a.lymin = y& - dy&
  a.lymax = y& + dy&

  NewPen.Color = HV.ColVal(13)
  NewPen.Width = 2
  NewPen.Style = 0

  void = DrawSingleFigure(a, 4, NewPen, 0&, 0, 1)
  If Len(OverlayInfo$) = 0 Then OverlayInfo$ = "HAMMAP Overlay"
  Call NewMap

End Sub

Sub FindLocator()

  Dim a As lAreaType
  Dim NewPen As HMPen
  Static OldQth$

  Cancel = GetInput(ProgName$, Msg$(24130), OldQth$, Qth$)
  If Cancel Then Exit Sub
  OldQth$ = Qth$

  ErrNr = Qth2lSecArea(Qth$, a.lxmin, a.lymin, a.lxmax, a.lymax)
  If ErrNr Then
    Call ShowErrNr(24131)
    Exit Sub
  End If

  If NumPar(46).Actual And MF_AutoArea Then
    'Ausschnitt anpassen (alle 4 Ecken)
    Call AutoArea(1, 0&, 0&)              'Init
    Call AutoAreaLocator(a)
    Call AutoArea(4, 0&, 0&)              'Ausgabe
  End If

  NewPen.Color = HV.ColVal(13)
  NewPen.Width = 2
  NewPen.Style = 0

  If AreaInArea(1, a, MV.ActMapArea) Then
    void = DrawSingleFigure(a, 11, NewPen, 0&, 1, 1)
    If Len(OverlayInfo$) = 0 Then OverlayInfo$ = "HAMMAP Overlay"
    Call NewMap
  Else
    Call ShowErrNr(24132)
  End If

End Sub

Sub FindTown(Title$)

  Dim a As lAreaType
  Static lastf$
  Dim NewPen As HMPen

  Cancel = GetInput(Title$, Msg$(19668), lastf$, f$)
  If Cancel Then Exit Sub

  Screen.MousePointer = 11

  lastf$ = f$

  ErrNr = OpenDB()
  If ErrNr Then Exit Sub

  SQL$ = "Select Distinct Locator from tblLocator"

  If InStr(f$, "*") > 0 Or InStr(f$, "?") > 0 Then
    'Suche mit Wildcard
    SQL$ = SQL$ & " Where Stadt like '" & f$ & "'"
  Else
    'Suche ohne Wildcard
    SQL$ = SQL$ & " Where Stadt = '" & f$ & "'"
    SQL$ = SQL$ & " Or Stadt like '" & f$ & " *'"
    SQL$ = SQL$ & " Or Stadt like '" & f$ & "-*'"
  End If

  'SQL$ = SQL$ & " Order by Locator"

  s$ = GetDBInfo$(SQL$, Result)

  If Result < 0 Then
    'Fehler
    Screen.MousePointer = 0
    Call FileError(s$, "")
    Exit Sub
  ElseIf Result = 0 Then
    'keine Info
    Screen.MousePointer = 0
    Call ShowErrNr(19669)
    Exit Sub
  End If

  If NumPar(46).Actual And MF_AutoArea Then
    'Ausschnitt anpassen (alle 4 Ecken)
    Call AutoArea(1, 0&, 0&)              'Init

    s1$ = s$
    Do Until Len(s1$) = 0
      Qth$ = Parse$(s1$, vbCrLf)
      If Qth$ <> LastQth$ Then
        LastQth$ = Qth$
        ErrNr = Qth2lSecArea(Qth$, a.lxmin, a.lymin, a.lxmax, a.lymax)
        If ErrNr = 0 Then
          Call AutoAreaLocator(a)
        End If
      End If
    Loop

    Call AutoArea(4, 0&, 0&)              'Ausgabe
  End If

  NewPen.Color = HV.ColVal(13)
  NewPen.Width = 1
  NewPen.Style = 0

  LastQth$ = ""
  Do Until Len(s$) = 0
    Qth$ = Parse$(s$, vbCrLf)
    If Qth$ <> LastQth$ Then
      LastQth$ = Qth$

      ErrNr = Qth2lSecArea(Qth$, a.lxmin, a.lymin, a.lxmax, a.lymax)
      If ErrNr = 0 Then
        If AreaInArea(1, a, MV.ActMapArea) Then
          void = DrawSingleFigure(a, 11, NewPen, NewPen.Color, 0, 1)
          Ok = Ok + 1
        Else
          NotOk = NotOk + 1
        End If

      End If
    End If
  Loop

  If Ok = 0 Then
    Select Case NotOk
    Case 0
      ErrNr = 19669
    Case 1
      ErrNr = 19670
    Case Else
      ErrNr = 19671
    End Select
  Else
    If Len(OverlayInfo$) = 0 Then OverlayInfo$ = "HAMMAP Overlay"
    If NotOk > 0 Then ErrNr = 19672
  End If

  Call NewMap

  Screen.MousePointer = 0
  If ErrNr Then Call ShowErrNr(ErrNr)

End Sub

Function GetInfo$(Fkt)

  f$ = "#,##0"

  Select Case Fkt
  Case 1                                        'Ueber
    m$ = GetAbout$("")

  Case 2                                        'Karte
    Select Case HV.MapType
    Case 0    'keine Datei
      m$ = Msg$(24214)
    Case 1    'Vektor-Datei
      m$ = Msg$(24051) + ": " + Ucase16$(StrPar(3, 6)) + vbCrLf
      m$ = m$ + Format$(MV.In.AnzSg - SgHdrLen, f$) + " " + Msg$(24002) + ",  "
      m$ = m$ + Format$(MV.In.AnzKo - CoHdrLen, f$) + " " + Msg$(24009)
    Case 2, 3   'BitMap/RLE-Datei
      m$ = GetBmpInfo$()
    End Select

    AnzFields = NumPar(59).Actual + 1
    m$ = m$ & vbCrLf & lArea2Msg$(MV.ActMapArea, AnzFields)

    Call GetAreaSize(MV.ActMapArea, wSec&, hSec&)
    Call GetAreaCenter(MV.ActMapArea, xm&, ym&)
    wkm! = EarthRad * wSec& * cfSec2Rad * Cos(ym& * cfSec2Rad)
    w$ = DistToMsg$(wkm!, NumPar(57).Actual)
    DistMode = NumPar(57).Actual
    h$ = DistToMsg$(EarthRad * hSec& * cfSec2Rad, DistMode)
    m$ = m$ & vbCrLf & w$ & " * " & h$ & " " & Msg$(40005 + DistMode)



  Case 3                                        'Station
    If SV.Out.BsdFile = 0 Then
      m$ = Msg$(24215)
    Else
      m$ = Msg$(25001) + ": " + UCase$(StrPar(3, 7)) + vbCrLf

      '--- Stationsversion lesen ---
      V = GetStnVer()
      If V > 0 Then StnVer$ = Msg$(24113) + Str$(V)
      If SV.Out.StnHdr.Modified Then
        If Len(StnVer$) > 0 Then StnVer$ = StnVer$ + " - "
        StnVer$ = StnVer$ + Msg$(24114)
      End If
      If Len(StnVer$) > 0 Then m$ = m$ + StnVer$ + vbCrLf

      m$ = m$ + LTrim$(Format$(SV.Out.StnHdr.AnzStn, f$)) + " " + Msg$(31035) + vbCrLf
      m$ = m$ + LTrim$(Format$(SV.Out.StnHdr.AnzLnk, f$)) + " " + Msg$(31036)
    End If

  Case 4                                    'System
    m$ = GetSystemInfo$(StrPar(3, 4), NumPar(7).Actual)

  End Select

  GetInfo$ = m$

End Function

Function GetSystemInfo$(ScreenType$, BufferSize&)


  'See VBPJ June 1996, Page 138
  Dim MemInfo As MEMORYSTATUS

  MemInfo.dwLength = Len(MemInfo)
  Call GlobalMemoryStatus(MemInfo)

  m$ = Format$(MemInfo.dwAvailPhys \ 1024, "#,##0") + " " + Msg$(31050)
  'm1$ = Format$(GetFreeSystemResources(0)) + " % " + Msg$(24022)
  'If m1$ > "" Then m$ = m$ + vbCrLf + m1$


  GetSystemInfo$ = m$

End Function

Sub InfoFunctions(Index)

  If Index = 10 Then
    Call PrepareFunction(True, 2)     'DOS: Text-Mode + Save Map
  Else
    Call PrepareFunction(True, 0)
  End If

  Title$ = StdMsg$(20200 + Index)

  Select Case Index
  Case 1 To 4
    m$ = GetInfo$(Index)
      void = TxtMsgBox(m$, 8, ProgName$ + " - " + Msg$(25026))

  Case 6
    Call FindLocator

  Case 7
    Call FindCoordinate(Title$)

  Case 8      'Stadt usw. suchen
    Call FindTown(Title$)

  Case 10      'Maus-Info Auswahl
    Call MapTipSelection(Title$)

  Case 11     'Maus-Info Optionen
    Call MapTipOptions(Title$)

  End Select

  Call TerminateFunction(0, 0&)

End Sub

Sub MapTipEnbl(Enbl, Must)

  With MapForm

    If (NumPar(47).Actual > 0 And HV.MouseFunctionMode = 0) Or Must Then
      .TipTimer.Enabled = Enbl

      If Enbl Then
        Select Case NumPar(47).Actual
        Case 5, 6     'ok v11
          void = OpenDB()
        End Select
      Else
        .Tip.Visible = False
      End If
    End If

  End With

End Sub

Sub MapTipOptions(Title$)

  Dim i, Cancel
  Dim InpLine$

  Call MapTipEnbl(False, True)

  'Nur Schriftgre
  Cancel = GetInput(Title$, "", Format$(NumPar(50).Actual), InpLine$)
  If Not Cancel Then
    NumPar(50).Actual = Val(Unformat$(InpLine$))
  End If

  Call InitTip

  Call MapTipEnbl(True, False)

End Sub

Sub MapTipSelection(Title$)

  Dim OldDB, NewDB, Change&, void, Dsbl&

  Call MapTipEnbl(False, True)
  OldDB = NumPar(47).Actual = 5 Or NumPar(47).Actual = 6    'Ok v11

  If HasDBModule Then
    Dsbl& = 0&
  Else
    'ohne Distrikt + Geogr.Info
    Dsbl& = &H60&
  End If

  Cancel = RadioBtnMask(Title$, 24700, 1, NumPar(47).Actual, Dsbl&, Change&)
  If Not Cancel Then
    Call SetMouseToolbar
  End If

  Call MapTipEnbl(True, False)

End Sub

