Attribute VB_Name = "FncLink"
'--------------------------- FNCLNK.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CheckLnkMem()

  'Don't put into ModLnk.bas

  SV.MaxAnzLnk = SV.MaxAnzLnk + NumPar(11).Actual

  On Local Error Resume Next

  'Link-Index
  If SV.LnkIdxLoaded Then
    ReDim Preserve LnkIdxTbl(1 To SV.MaxAnzLnk) As Integer
  End If

  '--- Link-Tabelle ---
  If Err = 0 And SV.LnkDataLoaded Then
    ReDim Preserve LnkTbl(1 To SV.MaxAnzLnk) As LinkData
  End If

  If Err Then SV.MaxAnzLnk = SV.MaxAnzLnk - NumPar(11).Actual
  CheckLnkMem = Err

  On Local Error GoTo 0

End Function

Function EditLinkData(Title$, AnzFields, Dsbl, Change&)

  EditLinkData = True

  ErrNr = InitMaskData(AnzFields, Title$, "")
  If ErrNr Then Exit Function

  For i = 1 To AnzFields
    MaskData(i, 1) = StdMsg$(22140 + i)        'Prompt
    MaskData(i, 2) = LF$(i)                    'Default
  Next i

  '--- Auswahl ---
  If InStr(LF$(2), ",") Then
    MaskData(2, 4) = LF$(2)                     'Links
    MaskData(2, 2) = ""
  End If

  If AnzFields > 2 Then
    MaskData(3, 4) = AbvAusw$(5, 24280)         'Link-Status
    MaskData(5, 4) = BaudList$                  'Baud
    MaskData(6, 4) = AbvAusw$(6, 24260)         'Lnk-Typ
  End If

  '--- Eingabe ---
  Cancel = GetMaskInput(Dsbl, Change&)

  If Not Cancel Then
    For i = 1 To AnzFields
      LF$(i) = UCase$(GetMaskData(i))
    Next i
  End If

  Call EraseMaskData

  EditLinkData = Cancel

End Function

Function EditLinkFunctions(Index, iMsgBase, Change&)

  Static StnCall As StationCall
  Static Stn As StationData
  Static Lnk As LinkData

  EditLinkFunctions = True    'Cancel

  EditMsg$ = StdMsg$(iMsgBase + Index)

  LF$(1) = SelStnCall$

  If Index = 1 Then
    LF$(2) = ""
  Else
    If HV.SelStnRec > 0 Then
      ErrNr = GetAllLinkCalls(HV.SelStnRec, 0, LF$(2))
      If ErrNr Then Exit Function
    Else
      LF$(2) = ""
    End If
  End If


  Select Case Index
  Case 1
    '------ Link anlegen ------
    LF$(3) = "OK"
    LF$(4) = Format$(Now, "YYMM")
    LF$(5) = ""
    LF$(6) = ""

    Do
      '--- Daten eingeben ---
      Cancel = EditLinkData(EditMsg$, 6, 0, Change&)
      If Cancel Then Exit Function

      '--- Daten verarbeiten und speichern ---
      Screen.MousePointer = 11
      ErrNr = ProcessLink("AL")
      Screen.MousePointer = 0
    Loop While ErrNr

    void = WriteUpdLog("AL")


  Case 2
    '------ Link aendern ------
    Do
      Cancel = EditLinkData(EditMsg$, 2, 0, Change&)
      If Cancel Then Exit Function

      'Pruefen, ob gleiche Calls
      If LF$(1) = LF$(2) Then
        ErrNr = 31046
        Call ShowErrNr(ErrNr)
      End If

      'Ggf. Link-Calls vertauschen, damit Call1 < Call2
      If LF$(1) > LF$(2) Then
        Tmp$ = LF$(1)
        LF$(1) = LF$(2)
        LF$(2) = Tmp$
      End If


      '--- Rufzeichen codieren und Link suchen ---
      For i = 1 To 2
        If ErrNr = 0 Then
          ErrNr = EncodeCall(2, LF$(i), "0", ActLnkCall(i))
        End If
      Next i

      If ErrNr = 0 Then
        Screen.MousePointer = 11
        ErrNr = FindLink(ActLnkCall(), LnkNr, RecNr, Found, Deleted)
        Screen.MousePointer = 0
      End If

      If ErrNr = 0 Then
        If (Found And Deleted) Or Not Found Then
          ErrNr = 31044            'nicht gefunden
          Call ShowErrNr(ErrNr)
        End If
      End If

    Loop While ErrNr


    '--- Alte Linkdaten laden ---
    ErrNr = GetLinkData(SV.Out.BldFile, RecNr, Lnk)
    If ErrNr Then Exit Function

    ErrNr = DecodeLink(Lnk, 0)
    If ErrNr Then Exit Function

    'Fr UPD-File - Old-Value
    For i = 1 To 6
      OF$(i) = LF$(i)
    Next i

    OldDate$ = LF$(4)
    LF$(4) = Format$(Now, "YYMM")

    Do
      LF$(4) = LF$(4) + " (" + OldDate$ + ")"

      '--- Daten eingeben ---
      Cancel = EditLinkData(EditMsg$, 6, 3, Change&)

      LF$(4) = Parse$(LF$(4), "(")
      Change& = Change& And Not 8
      If LF$(4) <> OldDate$ Then Change& = Change& Or 8&
      If Cancel <> 0 Or Change& = 0 Then Exit Function

      '--- Daten verarbeiten und speichern ---
      Screen.MousePointer = 11
      ErrNr = ProcessLink("UL")
      Screen.MousePointer = 0
    Loop While ErrNr

    void = WriteUpdLog("UL")


  Case 3
    '------ Link loeschen ------
    Cancel = EditLinkData(EditMsg$, 2, 0, Change&)
    If Cancel Then Exit Function

    '--- Link loeschen ---
    Screen.MousePointer = 11
    ErrNr = ProcessLink("DL")
    Screen.MousePointer = 0
    If ErrNr Then Exit Function

    void = WriteUpdLog("DL")

  End Select

  HV.ForceRecalcRoutes = True

  EditLinkFunctions = False    'Not Cancel

End Function

Function GetLinkInfo(SrcRec, LnkRec, m$)

  Dim StnCall As StationCall

  GetLinkInfo = True

  '--- Link - volle Info ---
  ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
  If ErrNr Then Exit Function

  ErrNr = DecodeLink(ActLnkData, 3)
  If ErrNr Then Exit Function


  '--- Calls ---
  ErrNr = GetStationCall(SrcRec, StnCall)
  If ErrNr Then Exit Function
  Call DecodeCall(StnCall, Source$, l$)

  DstRec = ActLnkData.StnPtr(1)
  If DstRec = SrcRec Then DstRec = ActLnkData.StnPtr(2)

  ErrNr = GetStationCall(DstRec, StnCall)
  If ErrNr Then Exit Function
  Call DecodeCall(StnCall, dest$, l$)
  m$ = Source$ + " -> " + dest$


  '--- Typ + Baud ---
  LnkTyp = ActLnkData.StatTyp \ 256
  If ActLnkData.Baud > 0 Or LnkTyp > 0 Then
    m$ = m$ + vbCrLf
    If LnkTyp > 0 Then m$ = m$ + LF$(6)
    If ActLnkData.Baud > 0 And LnkTyp > 0 Then m$ = m$ + " - "
    If ActLnkData.Baud > 0 Then
      m$ = m$ + Format$(Val(LF$(5)), "#,##0") + " Baud"
    End If
  End If


  '--- Datum ---
  m$ = m$ + vbCrLf

  If ActLnkData.LnkDate > 0 Then
    m$ = m$ + LF$(4) + "; "
  End If


  '--- Status ---
  m$ = m$ + LF$(3)

  GetLinkInfo = False

End Function

Sub LinkFunctions(Fkt)

  'Shortcut-Keys are not disabled
  If HV.HMDisabled Then Exit Sub

  'Pruefen, ob Links vorhanden
  If SV.Out.StnHdr.AnzLnkRec < 2 Then
    Call ShowErrNr(24216)
    Exit Sub
  End If

  Select Case Fkt
  Case 2, 6 To 8
    Call PrepareFunction(True, 2)       'DOS: Text-Mode + Save Map
  Case Else
    Call PrepareFunction(True, 0)
  End Select


  Title$ = StdMsg$(20100 + Fkt)

  Select Case Fkt
  Case 1                          'Links Zeichnen
    ErrNr = SetStnFlags()
    If ErrNr Then Exit Sub
    If HV.SelStnRec = 0 Then
      ErrNr = DrawAllLinks(AnzLnk)
    Else
      Call DrawSelStnLinks(True)
    End If


  Case 2                          'Route
    ErrNr = SetStnFlags()
    If ErrNr = 0 Then
      Cancel = SelectRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)
    End If


    If Not Cancel Then
      Call MakeRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)
    End If




  Case 4                          'Route/Links Drucken
    If HV.FoundMode >= 2 Then
      For i = 1 To HV.AnzFound
        m$ = m$ + vbCrLf + ShowCall$(i)
      Next i

      Call PrintText(Msg$(24600 + HV.FoundMode), Mid$(m$, 3))
    End If


  Case 6 To 8                     'Link anlegen,aendern,loeschen
    Cancel = EditLinkFunctions(Fkt - 5, 20105, Change&)   '1...3
    If Fkt = 7 Then
      MapChange& = Not Cancel And Change& <> 0    'ndern
    Else
      MapChange& = Not Cancel
    End If
  End Select


  Call TerminateFunction(1, MapChange&)

End Sub

Function SelectRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)

SelectRoute = True

'#If DOS Then

  Static OldDst$, OldMark
  Static RouterMsg$(0 To 3)

  'Form laden und initialisieren
  RouterForm.Caption = Msg$(24001)

  RouterForm.Lbl(0).Caption = Msg$(24025) & ":"
  RouterForm.Lbl(1).Caption = Msg$(24026) & ":"
  RouterForm.Lbl(2).Caption = Msg$(24028)

  RouterMsg$(0) = Msg$(24021) & " (*)"     'All Routes
  RouterMsg$(1) = Msg$(24310 + FindStnAbv(2, "MB")) & " (MB)"
  RouterMsg$(2) = Msg$(24310 + FindStnAbv(2, "DX")) & " (DX)"
  RouterMsg$(3) = Msg$(24310 + FindStnAbv(2, "WX")) & " (WX)"

  For i = 0 To UBound(RouterMsg$)
    RouterForm.DstBox.AddItem RouterMsg$(i)
  Next i


  RouterForm.Cmd(0).Caption = Msg$(25050)
  RouterForm.Cmd(1).Caption = Msg$(25053)
  RouterForm.cmdHelp.Caption = Msg$(25056)

  RouterForm.Opt(0).Caption = Msg$(24018)
  RouterForm.Opt(1).Caption = Msg$(24019)

  RouterForm.ChkMark.Caption = Msg$(24029)


  '--- Vorbelegungen ---
  Index = 1 + ((NumPar(42).Actual And 16) <> 0)
  RouterForm.Opt(Index).Value = True
  RouterForm.ChkMark.Value = OldMark

  'ein Digi ist selektiert
  If HV.SelStnRec > 0 Then OldDst$ = SelStnCall$

  RouterForm.SrcBox.text = StrPar(3, 14)          'Router-Start
  RouterForm.DstBox.text = OldDst$
  RouterForm.NotViaBox.text = StrPar(3, 1)        'NotVia


  '--- Eingabe ---
  Call CenterForm(RouterForm)

  RouterForm.Show 1

  Cancel = Val(RouterForm.Tag) <> 0

  '--- Falls nicht Abbruch -> Werte auslesen ---
  If Cancel = 0 Then
    StrPar(3, 14) = RouterForm.SrcBox.text
    OldDst$ = RouterForm.DstBox.text
    StrPar(3, 1) = RouterForm.NotViaBox.text
    OldMark = RouterForm.ChkMark.Value

    StartRec = Val(RouterForm.SrcBox.Tag)
    EndRec = Val(RouterForm.DstBox.Tag)
    NotViaList$ = RouterForm.NotViaBox.Tag
    Fastest = RouterForm.Opt(0).Value
    Mark = RouterForm.ChkMark.Value = 1
  End If

  Unload RouterForm
  Set RouterForm = Nothing


  SelectRoute = Cancel

End Function

Sub ShowLinkInfo(ByVal FoundNr)

  '--- Link - volle Info ---
  LnkRec = StnFnd(FoundNr).LnkRec
  ErrNr = GetLinkInfo(HV.SelStnRec, LnkRec, m$)
  If ErrNr = 0 Then void = GrMsgBox(m$, 8)

End Sub

