Attribute VB_Name = "FncMap"
'--------------------------- FNCMAP.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Sub EditAreaList(Mode, MsgNr)

  'Mode: 0 = Rename, 1 = Add, 2 = Delete

  If Mode = 1 And HV.AnzArea = UBound(Area) Then
    Call ShowErrNr(24012)       'Zu viele Bereiche
    Exit Sub
  End If

  EditAreaForm.Caption = "HAMMAP  -  " + StdMsg$(MsgNr)
  EditAreaForm.Tag = Format$(Mode)

  EditAreaForm.Cmd(0).Caption = StdMsg$(25050)
  EditAreaForm.Cmd(1).Caption = StdMsg$(25053)
  EditAreaForm.Cmd(0).Enabled = False

  EditAreaForm.AreaNameLabel.Caption = Msg$(24033)
  EditAreaForm.AreaNameLabel.Visible = Mode < 2
  EditAreaForm.AreaNameField.Visible = Mode < 2
  EditAreaForm.AreaNameField.text = ""

  EditAreaForm.AreaListLabel.Caption = Msg$(24030 + Mode)

  '--- Ggf. alte Liste loeschen ---
  For i = EditAreaForm.AreaList.ListCount - 1 To 0 Step -1
    EditAreaForm.AreaList.RemoveItem i
  Next i

  '--- Neue Liste ausgeben ---
  For i = 1 To HV.AnzArea
    'm$ = Pc8ToAnsi$(Replace$(Area(i).Label, "&", ""))
    m$ = Pc8toAnsi$(Area(i).Label)
    EditAreaForm.AreaList.AddItem m$
  Next i

  If Mode = 1 Then
    EditAreaForm.AreaList.AddItem "----------"
  End If

  Call CenterForm(EditAreaForm)

  EditAreaForm.Show 1


  '--- Falls nicht Abbruch -> Werte auslesen ---
  If Val(EditAreaForm.Tag) = 0 Then

    HV.AreaListModified = True

    n = EditAreaForm.AreaList.ListIndex + 1
    a$ = AnsiToPc8$(RTrim$(EditAreaForm.AreaNameField.text))
    OldAnz = HV.AnzArea

    Select Case Mode
    Case 0                'Rename
      Area(n).Label = a$

    Case 1                'Add
      HV.AnzArea = HV.AnzArea + 1
      For i = HV.AnzArea To n + 1 Step -1
        Area(i) = Area(i - 1)
      Next i
      Area(n).lArea = MV.ActMapArea
      Area(n).Label = a$

    Case 2                'Delete
      HV.AnzArea = HV.AnzArea - 1
      For i = n To HV.AnzArea
        Area(i) = Area(i + 1)
      Next i
    End Select

    Call InitAreaMenu(OldAnz)

  End If

  Unload EditAreaForm
  Set EditAreaForm = Nothing

End Sub

Sub MapFunctions(Fkt)

  Dim lNewArea As lAreaType

  'Shortcut-Keys are not disabled
  If HV.HMDisabled Then Exit Sub

  Title$ = ProgName$ + " - " + StdMsg$(20060 + Fkt)

  Select Case Fkt
  Case 6 To 13
    Call PrepareFunction(True, 2)     'DOS: Text-Mode + Save Map
  Case Else
    Call PrepareFunction(True, 0)
  End Select


  Select Case Fkt
  Case 1                          'Karte Neu ausgeben
    Call ClearMap

  Case 2                          'Karte vergroessern
    Call CmdZoomInOut(0.5)

  Case 3                          'Karte verkleinern
    Call CmdZoomInOut(2)

  Case 5                          'Vergroesserung waehlen
    Call InitializeZoom

  Case 6                          'Gebiet
    lNewArea = MV.ActMapArea
    AnzFields = NumPar(59).Actual + 1
    Cancel = GetAreaLimits(Title$, lNewArea, StrPar(3, 10), AnzFields, Change&)
    If Change& Then
      Call SelectMapArea(lNewArea, StrPar(3, 10))
      MapChange& = False      'Karte schon ausgegeben
    End If


  Case 8 To 10                     'Ausschnitt aendern
    Call EditAreaList(Fkt - 8, 20050 + Fkt)


  Case 12                          'Karten-Funtionen
    Cancel = CheckBoxMask(Title$, 24740, 1, NumPar(46).Actual, 0&, Change&)
    If Not Cancel Then

      If Left$(Msg$(24742), 2) = "$$" Then
        If (NumPar(46).Actual And MF_AutoMap) <> 0 Then
          'Wenn Automap gesetzt wird, dann auf Vektor-Map schalten
          NumPar(46).Actual = NumPar(46).Actual And Not MF_BitMap
        End If
      End If


      'MF_Automap wurde gelscht
      If Change& And Not NumPar(46).Actual And MF_AutoMap Then
        MV.MaxMapArea = MV.FileMapArea
        HV.ScrollUserChange = False
        Call InitScroll

      End If

      Const c1 = MF_AutoMap Or MF_HiRes Or MF_AutoDetail  'nur wenn Bit gesetzt wurde
      Const c2 = MF_CrtProp Or MF_PrtProp                 'bei nderung
      'MF_Automap ist gesetzt und MF_Bitmap wurde gendert
      c3 = (NumPar(46).Actual And MF_AutoMap) <> 0 And (Change& And MF_BitMap)
      If Change& And ((c1 And NumPar(46).Actual) Or c2) Or c2 Then
        MapChange& = True
      End If

      Call SetMaxMapArea
    End If

  Case 13                          'Mausklick-Funktionen
    Call MapTipEnbl(False, True)
    Cancel = RadioBtnMask(Title$, 24720, 1, HV.MouseFunctionMode, 0&, Change&)
    If Not Cancel Then
      Call SetMainToolBar
      Call SetMouseIcon
    End If
    Call MapTipEnbl(True, False)
  End Select

  Call TerminateFunction(1, MapChange&)

End Sub

