Attribute VB_Name = "FncPrint_W"
'-------------------------- LPTSUB_W.BAS ------------------------
'HAMMAP Drucker-Unterprogramme fuer Windows
'von Gerhard Berg, DJ6FM

DefInt A-Z

Sub AbortPrint()

  HV.PrtEnbl = 1

  Call KillPrint

End Sub

Sub CopyMapToClipboard(Mode)

  '----- Copy Map (FrameRect) onto Clipboard ---
  'Alternative Version mit Windows-API siehe HAMMAP Version 9
  '        See VBPJ 101 Tech Tips, 7th edition Page 4
  '        "Copy Drawn Picture to Clipboard"


  '"Clipboard.SetData MapForm.Image" would copy entire Form
  ErrNr = CopyMapToPictureBox(Mode, HMPrt.DrawRect)
  If ErrNr Then Exit Sub

  Clipboard.Clear
  Clipboard.SetData PrtOptForm.Pict.Image, 2          'BMP-Format

  Unload PrtOptForm
  Set PrtOptForm = Nothing

End Sub

Function CopyMapToPictureBox(Mode, rDst As RECT)

  '--- Copy Bitmap to PrtOptForm.Pict ---
  'Mode: 0=Alles(HmForm), 1=Karte(FrameRect)

  Dim rSrc As RECT

  CopyMapToPictureBox = True

  Call SetTop(HmForm.hWnd, True)

  Select Case Mode
  Case 0      'Alles (HmForm)
    hSrcDC& = GetWindowDC(HmForm.hWnd)
    Call GetWindowRect(HmForm.hWnd, rSrc)    'Screen-Coordinates

    'Prfen ob Fenster links oder rechts auerhalb Bildschirm
    '  (in Maximized State ist rSrc.Left=-4)
    If rSrc.Left < 0 Then
      rSrc.Left = Abs(rSrc.Left)
    Else
      MaxRight = Screen.Width / Screen.TwipsPerPixelX
      rSrc.Right = lMin(MaxRight, rSrc.Right) - rSrc.Left     'Breite
      rSrc.Left = 0
    End If

    If rSrc.Top < 0 Then
      rSrc.Top = Abs(rSrc.Top)
    Else
      MaxBottom = Screen.Height / Screen.TwipsPerPixelY
      rSrc.Bottom = lMin(MaxBottom, rSrc.Bottom) - rSrc.Top   'Hhe
      rSrc.Top = 0
    End If

  Case 1      'nur Karte (FrameRect)
    hSrcDC& = MapForm.hDC
    rSrc = HMCrt.FrameRect

  Case 2      'nur Karte (DrawRect)
    hSrcDC& = MapForm.hDC
    rSrc = HMCrt.DrawRect
  End Select

  Call GetRectSize(rSrc, w&, h&)

  rDst.Left = 0
  rDst.Top = 0
  rDst.Right = w&
  rDst.Bottom = h&

  hTmpDC& = InitTempPictureBox(w&, h&)

  If hTmpDC& <> 0 Then
    Ok& = CopyBitMap&(hTmpDC&, rDst, hSrcDC&, rSrc)
  End If

  If Mode = 0 Then
    Ok& = ReleaseDC(HmForm.hWnd, hSrcDC&)
  End If

  Call SetTop(HmForm.hWnd, False)

  If hTmpDC& <> 0 Then CopyMapToPictureBox = False

End Function

Sub InitPageSetup()

  Load PageSetupForm

  Call CenterForm(PageSetupForm)

  With PageSetupForm
    .Caption = Msg$(19300)

    .OrientOption(1).Caption = Msg$(19306)
    .OrientOption(2).Caption = Msg$(19307)
    .ColorOpt.Caption = Msg$(19305)


    y = .InputLabel(1).Top

    For i = 1 To 4

      If i > 1 Then
        Load .InputLabel(i)
        Load .Txt(i)
        Load .Spn(i)
      End If

      .InputLabel(i).Top = y
      .Txt(i).Top = y
      .Spn(i).Top = y
      .Spn(i).Height = 375
      .Spn(i).Width = 255

      y = y + 1.5 * .Txt(1).Height

      .InputLabel(i).Caption = Msg$(19300 + i)

      .InputLabel(i).Visible = True
      .Txt(i).Visible = True
      .Spn(i).Visible = True

      .Txt(i).TabIndex = i

    Next i

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)

  End With

End Sub

Function InitPrint(ByVal Mode)

  'Ausgabe eines Dokuments initialisieren
  'Waehrend des Drucks duerfen keine relevanten Einstellungen veraendert werden

  'Mode: 1 = CRT
       ' 2 = Printer
       ' 4 = Printer-Simulation   (Output = frmPrtSim)
       ' 8 = Printer gepuffert    (Temp = PrtOptForm)
       '16 = Windows Metafile
       '32 = Windows Enhanced Metafile

  InitPrint = True

  HV.PrtEnbl = Mode

  Call InitPhysDevices

  'Zum Einfrben des Wassers ggf. auf gepufferte Ausgabe umschalten
  '   (nicht bei Metafile oder Screendump)
  If (HV.PrtEnbl And &H130) = 0 Then
    'Kein Erweitertes Men (automatisch whlen)
    c1 = Not HmForm.pdmnuPrint(2).Visible
    'Farbausgabe und Wasser einfrben
    c2 = (NumPar(52).Actual And 3) = 3
    'Drucker kann Wasser nicht einfrben
    c3 = (GetDeviceCaps(Printer.hDC, RasterCaps) And RC_FLOODFILL) = 0

    If c1 And c2 And c3 Then
      HV.PrtEnbl = HV.PrtEnbl Or 8      'gepuffert drucken
    End If
  End If


  If HV.PrtEnbl And 8 Then
    '--- Gepufferte Ausgabe ---
    If NumPar(35).Actual And 1024 Then

      'Use PictureBox
      Dib.BitsPerPixel = GetDeviceCaps(MapForm.hDC, BITSPIXEL)
      Ok& = InitTempPictureBox(HMPrt.DrawWidth, HMPrt.DrawHeight)

    Else

      Dib.Type = 1          'Use Device-Independant Bitmap

      If Dib.Type = 0 Then
        Dib.BitsPerPixel = GetDeviceCaps(MapForm.hDC, BITSPIXEL)
      Else
        'Use DIBSection  (geht nur mit 24 Bit)
        Dib.BitsPerPixel = 24
      End If
      Ok& = CreateMemoryDevice(HMPrt.DrawWidth, HMPrt.DrawHeight)
    End If

    If Ok& = 0 Then
      Call ShowErrNr(7)
      HV.PrtEnbl = 1
      Exit Function
    End If
  End If

  InitPrint = StartPrint()

End Function

Function IsPrinterInstalled()

  '--- Pruefen ob Drucker installiert ---
  On Error Resume Next
  i = Printer.ScaleMode
  IsPrinterInstalled = Err = 0
  If Err Then Call ShowErrNr(19902)
  On Error GoTo 0

End Function

Sub KillPrint()

  'Druck abbrechen

  If HV.PrtEnbl And 4 Then

    'Simulation
    frmPrtSim.Cls

  Else

    Printer.KillDoc

  End If

End Sub

Sub PrintCmd(Mode)

  'Ausgabe auf Drucker, Memory oder Bildschirm
  ErrNr = InitPrint(Mode)
  If ErrNr Then Exit Sub

  Call NewMap
  Call TerminatePrint

End Sub

Sub PrinterSetup()

  'Druckereinrichtung aufrufen

  'Release hDC for printer (see Language Reference p. 455)
  Printer.EndDoc

  With FileSpecForm.CmDlg
    .CancelError = True
    .PrinterDefault = True
    .Flags = &H40&

    On Error Resume Next
    .Action = 5
    ErrNr = Err                'Abbruch
    On Error GoTo 0
  End With

  If ErrNr = 0 Then
    'Force new default printer to be used
    Printer.TrackDefault = False
    Printer.TrackDefault = True
  End If

End Sub

Sub PrintFunctions(Index)

  Title$ = ProgName$ + " - " + StdMsg$(20009) + " - " + StdMsg$(19040 + Index)

  '--- Pruefen ob Drucker installiert ---
  If IsPrinterInstalled() = 0 Then Exit Sub

  Call PrepareFunction(True, 0)

  Select Case Index
  Case 1                    'Karte Drucken
    Call PrintCmd(2)        'direkt drucken

  Case 2                    'Karte Drucken (gepuffert)
    Call PrintCmd(10)

  Case 3                    'Vorschau
    Call PrintCmd(6)

  Case 5                    'Druck Anfang
    void = InitPrint(3)

  Case 6                    'Druck Ende
    Call TerminatePrint

  Case 7                    'Druck Abbruch
    Call AbortPrint


  Case 9                    'Bildschirmausdruck HAMMAP
    Call ScreenDump(0)

  Case 10                    'Bildschirmausdruck Karte
    If NumPar(46).Actual And MF_PrtProp Then
      'fr Drucker unverzerrt
      Call ScreenDump(2)
    Else
      Call ScreenDump(1)
    End If

  Case 11                   'Bildschirmausdruck VB
    Call ScreenDumpVB

  Case 13                   'Seite einrichten
    Call PrtPageSetup

  Case 14                   'Drucker-Einstellungen
    Cancel = CheckBoxMask(Title$, 24400, 0, NumPar(52).Actual, 0&, Change&)

  Case 15                   'Drucker-Schriftart
    Call PrtSelectFont

  Case 16                   'Linienbreite
    Call SelectLineWidth(1, Title$, Change&)

  Case 17                   'Druckereinrichtung
    Call PrinterSetup

  End Select

  Call TerminateFunction(0, 0&)

End Sub

Sub PrtPageSetup()

  Screen.MousePointer = 11

  HV.PrtSetupProgChange = True

  'Form Laden und initialisieren
  Call InitPageSetup

  With PageSetupForm
    Mode = (NumPar(43).Actual And 1) + 1
    .OrientOption(1).Value = (Mode = 1)
    .OrientOption(2).Value = (Mode = 2)
    .ColorOpt.Value = NumPar(52).Actual And 1

    '--- Anfangswerte ---
    For i = 1 To 4
      m$ = Format$(NumPar(i + 12).Actual / 1000!, "0.0")
      .Txt(i).text = m$
      .Txt(i).SelStart = 0
      .Txt(i).SelLength = Len(m$)
    Next i

  End With

  HV.PrtSetupProgChange = False

  Screen.MousePointer = 0


  '--- Eingabe ---
  PageSetupForm.Show 1

  '--- Falls nicht Abbruch -> Werte auslesen ---
  With PageSetupForm
    If Val(.Tag) = 0 Then
      For i = 1 To 4
        NumPar(i + 12).Actual = sCtlVal(.Txt(i)) * 1000!
        If NumPar(i + 12).Actual < NumPar(i + 12).Min Then
           NumPar(i + 12).Actual = NumPar(i + 12).Min
        End If
        If NumPar(i + 12).Actual > NumPar(i + 12).Max Then
           NumPar(i + 12).Actual = NumPar(i + 12).Max
        End If
      Next i

      If .OrientOption(1).Value Then
        NumPar(43).Actual = 0
      Else
        NumPar(43).Actual = 1
      End If
    End If

    If .ColorOpt.Value Then
      NumPar(52).Actual = NumPar(52).Actual Or 1
    Else
      NumPar(52).Actual = NumPar(52).Actual And Not 1&
    End If
  End With

  Unload PageSetupForm
  Set PageSetupForm = Nothing

End Sub

Sub PrtSelectFont()

  'Drucker-Schriftart auswaehlen

  With FileSpecForm.CmDlg
    .CancelError = True
    .Flags = &H10402

    .FontName = StrPar(3, 9)
    .FontSize = NumPar(38).Actual / 1000
    .FontBold = (NumPar(39).Actual And 1) <> 0
    .FontItalic = (NumPar(39).Actual And 2) <> 0

    On Error Resume Next
    .Action = 4
    ErrNr = Err
    On Error GoTo 0

    If ErrNr = 0 Then
      'keinAbbruch
      StrPar(3, 9) = .FontName
      NumPar(38).Actual = .FontSize * 1000!
      NumPar(39).Actual = (.FontBold And 1) Or (.FontItalic And 2)

      'Symbol- und Font-Gre nicht automatisch
      NumPar(52).Actual = NumPar(52).Actual And Not 4&
    End If

  End With

End Sub

Sub SaveMapToFile(Mode, Title$)

  'Mode: 0=HAMMAP speichern, 1=Karte speichern
  Static IniDir$

  If Len(IniDir$) = 0 Then IniDir$ = HomeDir$ & "."
  Filt$ = "Bitmap (*.BMP)|*.BMP"
  If Mode = 1 Then
    Filt$ = Filt$ & "|Windows Metafile (*.WMF)|*.WMF"
    Filt$ = Filt$ & "|Windows Enhanced Metafile (*.EMF)|*.EMF"
  End If
  FilNam$ = "HAMMAP"

  'Flags: PathMustExist + NoChangeDir + HideReadOnly + OverwritePrompt
  Cancel = GetFileSpec(Title$, 2, &H80E&, IniDir$, "BMP", Filt$, FilNam$)
  If Cancel Then Exit Sub                  'Abbruch

  File$ = FilNam$

  Select Case UCase$(Right$(File$, 4))
  Case ".WMF"
    '----- Ausgabe als Windows Metafile -----
    If NumPar(46).Actual And MF_OldMeta Then
      ErrNr = WriteOldMetaFile(File$)
    Else
      ErrNr = WriteMetafile(File$)
    End If
    If ErrNr Then Call FileError(Msg$(ErrNr), File$)

  Case ".EMF"
    '----- Ausgabe als Windows Enhanced Metafile -----
    ErrNr = WriteEnhMetaFile(File$)
    If ErrNr Then Call FileError(Msg$(ErrNr), File$)


  Case Else
    '----- Ausgabe als Bitmap File -----
    ErrNr = CopyMapToPictureBox(Mode, HMPrt.DrawRect)
    If ErrNr Then Exit Sub

    'Karte speichern...
    Call ShowText(Msg$(24007), 13, 11)

    ErrNr = SaveBitmap(PrtOptForm.Pict, File$)

    Unload PrtOptForm
    Set PrtOptForm = Nothing

    Call ShowText("", 13, 0)

  End Select

End Sub

Sub ScreenDump(Mode)

  Dim wPixel As Long, hPixel As Long

  HV.PrtEnbl = 266         '256+8+2
  Call InitPhysDevices

  With HMPrt

    'Bild kopieren nach TempDevice (setzt DrawRect = Source)
    ErrNr = CopyMapToPictureBox(Mode, .DrawRect)
    If ErrNr Then
      HV.PrtEnbl = 1
      Exit Sub
    End If

    Call ShowText(Msg$(24104), 13, 11)

    '------- Mastab bestimmen -------
    Call GetRectSize(.DrawRect, wSrc&, hSrc&)
    Call GetRectSize(.PrintRect, wDst&, hDst&)


    '--- Unterschiedliche Auflsung in X- und Y-Richtung bercksichtigen ---

    'Ganzzahligen Vergrerungsfaktor so bestimmen, da Bild in Rahmen pat
    Found = False
    For wPixel = 1 To 10
      For hPixel = 1 To 10
        If .DpiX * wPixel = .DpiY * hPixel Then
          Found = True
          Exit For
        End If
      Next hPixel
      If Found Then Exit For
    Next wPixel

    If Not Found Then
      wPixel = 1
      hPixel = 1
    End If

    DevScale = lMin(Int(wDst& / (wSrc& * hPixel)), Int(hDst& / (hSrc& * wPixel)))
    If DevScale = 0 Then DevScale = 1

    .PrintRect.Right = .PrintRect.Left + wSrc& * DevScale * hPixel
    .PrintRect.Bottom = .PrintRect.Top + hSrc& * DevScale * wPixel


  End With

  '--- Ausdrucken ---
  ErrNr = StartPrint()
  If ErrNr Then Exit Sub

  Dib.BitsPerPixel = GetDeviceCaps(PrtOptForm.Pict.hDC, BITSPIXEL)

  Call TerminatePrint

  Call ShowText("", 13, 0)

  If ErrNr Then Call ShowErrNr(ErrNr)

End Sub

Sub ScreenDumpVB()

  Call ShowText(Msg$(24104), 13, 11)

  Orient = (NumPar(43).Actual And 1) + 1
  ErrNr = SetOrientation(Orient)

  If ErrNr = 0 Then
    On Error Resume Next
    MapForm.PrintForm
    PrtErrNr = Err
    On Error GoTo 0
  End If

  Call ShowText("", 13, 0)
  If PrtErrNr Then Call ShowErrNr(ErrNr)

End Sub

Function StartPrint()

  'Simulation
  If (NumPar(35).Actual And 512) <> 0 Then
    HV.PrtEnbl = HV.PrtEnbl Or 4
  End If

  If HV.PrtEnbl And 4 Then
    'Drucker-Simulation
    With frmPrtSim
      .Enabled = False
      .AutoRedraw = True
      .Cls
      .Caption = ProgName$ & " - " & Msg$(19100)
      .mnuClose.Caption = Msg$(19101)
      .Show
    End With

  Else

    'Orientation cannot be set within a page (after opening printer)
    Orient = (NumPar(43).Actual And 1) + 1
    ErrNr = SetOrientation(Orient)

    '--- Drucker initialisieren und testen, ob Drucker Ready ---
    ' (doesn't work with spooling)
    If ErrNr = 0 Then
      On Error Resume Next
      Printer.Print " "
      ErrNr = Err
      On Error GoTo 0

      If ErrNr Then Call ShowErrNr(ErrNr)
    End If
  End If

  If ErrNr Then HV.PrtEnbl = 1

  StartPrint = ErrNr

End Function

Sub TerminatePrint()

  Screen.MousePointer = 11

  If HV.PrtEnbl And 8 Then
    '------- gepuffert -------
    If HV.PrtEnbl And 4 Then
      hDstDC& = frmPrtSim.hDC      'Simulation
    Else
      hDstDC& = Printer.hDC        'Drucker
    End If

    If (HV.PrtEnbl And 256) = 0 And (NumPar(35).Actual And 1024) = 0 Then

      'Nicht Screen-Dump und Nicht PictureBox
      Ok& = PrintBitmap&(hDstDC&, HMPrt.PrintRect, HMPrt.DrawRect)

      Call DeleteMemoryDevice

    Else

      'Use PictureBox
      ErrNr = PrintPictureBox(PrtOptForm.Pict, HMPrt.DrawRect, _
              hDstDC&, HMPrt.PrintRect)

      If NumPar(35).Actual And 2048 Then
        'Temp Device zeigen
        With PrtOptForm
          .Show
          .Pict.Refresh
          .Refresh
        End With
      Else
        Unload PrtOptForm
        Set PrtOptForm = Nothing
      End If
    End If
  End If


  If HV.PrtEnbl And 4 Then
    '--- Simulation ---
    With frmPrtSim
      .Refresh
      .Enabled = True
    End With
    GV.TopForm = 2
  Else
    '--- Drucker ---
    If CheckCancel() Or ErrNr Then
      Call KillPrint
    Else
      Printer.EndDoc
    End If
  End If

  Screen.MousePointer = 0

  HV.PrtEnbl = 1      'only CRT

End Sub

