Attribute VB_Name = "FncSel"
'--------------------------- FNCSEL.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function GetQrgBaud()

  Static OldPar&(0 To 1, 0 To 3)

  With MinMaxForm

    '--- Texte ausgeben ---
    .Caption = ProgName$

    For i = 0 To 3
      .RowLabel(i).Caption = Msg$(24520 + i)
    Next i

    For i = 0 To 2
      .ColLabel(i).Caption = Msg$(24524 + i)
    Next i

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)
    .HelpCmd.Caption = Msg$(25056)


    '--- aktuelle Werte ausgeben ---
    For i = 0 To 3
      OldPar&(0, i) = NumPar(22 + i).Actual
      OldPar&(1, i) = NumPar(26 + i).Actual

      If i = 0 Then
        '--- Qrg ---
        .MinField(0).text = Format$(NumPar(22).Actual / 1000!, "0.000")
        .MaxField(0).text = Format$(NumPar(26).Actual / 1000!, "0.000")
      Else
        '--- Baud ---
        .MinField(i).text = Format$(NumPar(22 + i).Actual)
        .MaxField(i).text = Format$(NumPar(26 + i).Actual)
      End If

      .AllField(i).Value = -1 * (NumPar(26 + i).Actual = 0&)

      If .AllField(i).Value <> 0 Then
        .MinField(i).text = ""
        .MaxField(i).text = ""
      End If
    Next i

  End With

  '--- Form ausgeben und Eingabe machen ---
  Call CenterForm(MinMaxForm)
  MinMaxForm.Show 1


  '--- Falls nicht Abbruch -> Werte auslesen ---
  With MinMaxForm
    If Val(.Tag) = 0 Then
      For i = 0 To 3
        If .AllField(i).Value Then
          NumPar(22 + i).Actual = 0&
          NumPar(26 + i).Actual = 0&
        Else
          If i = 0 Then
            '--- Qrg ---
            NumPar(22 + i).Actual = sCtlVal(.MinField(i)) * 1000!
            NumPar(26 + i).Actual = sCtlVal(.MaxField(i)) * 1000!
          Else
            '--- Baud ---
            NumPar(22 + i).Actual = Val(.MinField(i).text)
            NumPar(26 + i).Actual = Val(.MaxField(i).text)
          End If
        End If

        If OldPar&(0, i) <> NumPar(22 + i).Actual Or _
           OldPar&(1, i) <> NumPar(26 + i).Actual Then
          'Change flags
          Flags = Flags Or 2 ^ i
        End If
      Next i
    End If
  End With

  '--- Maske entladen ---
  Unload MinMaxForm
  Set MinMaxForm = Nothing

  GetQrgBaud = Flags

End Function

Sub SelectFunctions(Fkt)

  Const cStnLnk = ME_Stn Or ME_StnCalls Or ME_Links

  Call PrepareFunction(True, 2)

  'Stationen und/oder Links anzeigen
  DrawStnLnk = (cStnLnk And NumPar(9).Actual) <> 0
  'Links anzeigen
  DrawLnk = (ME_Links And NumPar(9).Actual) <> 0

  Title$ = StdMsg$(20006) + " - " + StdMsg$(20120 + Fkt)


  Select Case Fkt
  Case 1                'Standard-Werte
    For i = 1 To 5
      If NumPar(i).Actual <> NumPar(i).Default Then c1 = True
      NumPar(i).Actual = NumPar(i).Default
    Next i

    '--- Alle QRG's und Bauds (22 bis 29) ---
    '--- Standard-Werte fuer Router + Link-Typ (30 bis 34) ---
    For i = 22 To 34
      If NumPar(i).Actual <> NumPar(i).Default Then c2 = True
      NumPar(i).Actual = NumPar(i).Default
    Next i

    '--- Stations-Prefix ---
    If Len(StrPar(3, 11)) > 0 Or Len(StrPar(3, 12)) > 0 Then c3 = True
    StrPar(3, 11) = ""
    StrPar(3, 12) = ""
    Call InitFilterPrefix

    If c1 Then HV.ValidStnFlags = HV.ValidStnFlags And Not &H1700&
    If c2 Then HV.ValidStnFlags = HV.ValidStnFlags And Not &H6000&
    If c3 Then HV.ValidStnFlags = HV.ValidStnFlags And Not &H800&
    MapChange& = c1 Or c2 Or c3


  Case 3                                'Stations-Prefix
    ErrNr = InitMaskData(2, Title$, Msg$(31015))
    If ErrNr Then Exit Sub

    'Set Prompt and Default
    Call SetMaskData(1, Msg$(31016), StrPar(3, 11), "", "", "")
    Call SetMaskData(2, Msg$(31017), StrPar(3, 12), "", "", "")

    Cancel = GetMaskInput(0, Change&)
    If Change& Then
      'nderung eines Prefix und Ausgabe von Stationen/Links
      MapChange& = DrawStnLnk
      StrPar(3, 11) = UCase$(GetMaskData(1))
      StrPar(3, 12) = UCase$(GetMaskData(2))
      Call InitFilterPrefix
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H800
    End If

    Call EraseMaskData


  Case 4                'Stations-Status
    Cancel = CheckBoxMask(Title$, 24300, 0, NumPar(1).Actual, 0&, Change&)
    If Change& Then
      MapChange& = DrawStnLnk
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H100
    End If


  Case 5                'Stations-Typ
    Cancel = CheckBoxMask(Title$, 24310, 0, NumPar(2).Actual, 0&, Change&)
    If Change& Then
      MapChange& = DrawStnLnk
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H1000
    End If


  Case 6                'Software
    Cancel = CheckBoxMask(Title$, 24340, 0, NumPar(3).Actual, 0&, Change&)
    If Change& Then
      MapChange& = DrawStnLnk
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H200
    End If


  Case 7                'Hardware
    Cancel = CheckBoxMask(Title$, 24370, 0, NumPar(4).Actual, 0&, Change&)
    If Change& Then
      MapChange& = DrawStnLnk
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H400
    End If


  Case 8                                        'Link-Status
    Cancel = CheckBoxMask(Title$, 24280, 0, NumPar(5).Actual, 0&, Change&)
    MapChange& = Change& <> 0 And DrawLnk


  Case 9                                        'Link-Typ
    Cancel = CheckBoxMask(Title$, 24260, 0, NumPar(33).Actual, 0&, Change&)
    MapChange& = Change& <> 0 And DrawLnk


  Case 10                                       'QRG/Baud
    Change& = GetQrgBaud()

    If Change& And 1 Then    'QRG
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H2000
    End If
    If Change& And 2 Then    'Stn-Baud
      HV.ValidStnFlags = HV.ValidStnFlags And Not &H4000
    End If
    If Change& And 8 Then    'Route-Baud
      HV.ForceRecalcRoutes = True
    End If

    c1 = (Change& And 3) <> 0 And DrawStnLnk      'Stn.-QRG/Baud
    c2 = (Change& And 4) <> 0 And DrawLnk         'Link-Baud
    MapChange& = c1 Or c2


  Case 11                                       'Route-Status
    Cancel = CheckBoxMask(Title$, 24280, 0, NumPar(30).Actual, 0&, Change&)
    If Change& Then HV.ForceRecalcRoutes = True


  Case 12                                       'Route-Typ
    Cancel = CheckBoxMask(Title$, 24310, 0, NumPar(31).Actual, 0&, Change&)
    If Change& Then HV.ForceRecalcRoutes = True


  Case 13                                       'Route-Software
    Cancel = CheckBoxMask(Title$, 24340, 0, NumPar(32).Actual, 0&, Change&)
    If Change& Then HV.ForceRecalcRoutes = True


  Case 14                                       'Route-Link-Typ
    Cancel = CheckBoxMask(Title$, 24260, 0, NumPar(34).Actual, 0&, Change&)
    If Change& Then HV.ForceRecalcRoutes = True

  End Select

  Call TerminateFunction(1, MapChange&)

End Sub

