Attribute VB_Name = "FncStn"
'--------------------------- FNCSTN.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CheckStnMem()

  'Don't put into ModStn.bas

  SV.MaxAnzStn = SV.MaxAnzStn + NumPar(10).Actual

  '--- Index-Arrays muessen im Speicher sein (wegen Verschiebung) ---
  On Local Error Resume Next

  'Stations-Index
  If SV.StnIdxLoaded Then
    ReDim Preserve StnIdxTbl(1 To SV.MaxAnzStn) As Integer
  End If

  'Stations-Status
  If Err = 0 Then
    ReDim Preserve StnFlags(1 To SV.MaxAnzStn) As Integer
  End If
  If Err = 0 Then
    ReDim Preserve SaveStnFlags(1 To SV.MaxAnzStn) As Integer
  End If

  'Stations-Tabelle
  If Err = 0 And SV.StnDataLoaded Then
    ReDim Preserve StnTbl(1 To SV.MaxAnzStn) As StationData
  End If


  '--- Wenn Stationsdaten nicht geladen wurden -> Calls bzw. Qth laden ---
  'Stations-Calls
  If Err = 0 And SV.StnCallsLoaded Then
    ReDim Preserve StnCallTbl(1 To SV.MaxAnzStn) As StationCall
  End If

  'Stations-Qth
  If Err = 0 And SV.StnQthLoaded Then
    ReDim Preserve StnQthTbl(1 To SV.MaxAnzStn) As Koordinate
  End If

  If Err Then SV.MaxAnzStn = SV.MaxAnzStn - NumPar(10).Actual

  CheckStnMem = Err
  On Local Error GoTo 0

End Function

Function DecodeStationLines(InfoMode)

  DecodeStationLines = True

  For i = 0 To 9
    If StnLineData(i).xloc < 32767 Then

      ActStnData = StnLineData(i)

      ErrNr = GetStationInfo(SV.Out.BstFile, ActStnData, Qth$, Info$)
      If ErrNr Then Exit Function

      Call DecodeStation(ActStnData, Qth$, Info$, InfoMode)

      For j = 1 To AnzStnFields
        SLF$(i, j) = SF$(j)
      Next j
    End If
  Next i

  DecodeStationLines = False

End Function

Function EditStationData(Title$, AnzFields, Change&)

  EditStationData = True

  ErrNr = InitMaskData(AnzFields, Title$, "")
  If ErrNr Then Exit Function

  If AnzFields = 2 Then

    '--- Station auswhlen ---
    For i = 1 To AnzFields
      MaskData(i, 1) = StdMsg$(22120 + i)      'Prompt
      MaskData(i, 2) = SF$(i)                  'Default
    Next i

    If InStr(SF$(2), ",") Then
      MaskData(2, 4) = SF$(2)                     'Zeilen
      MaskData(2, 2) = ""
    End If

    Dsbl = 0

  Else

    '--- Stationsdaten eingeben ---
    For i = 1 To AnzFields
      MaskData(i, 1) = StdMsg$(22120 + i)        'Prompt
      Select Case i
      Case 8
        QRG& = Val(SF$(8)) * 1000&
        If QRG& < 0& Then
          MaskData(i, 2) = "-1"
        ElseIf QRG& = 0 Then
          MaskData(i, 2) = "?"
        Else
          Call Qrg2Str(QRG&, MaskData(i, 2), sRxQrg$, sChannel$)
        End If
      Case 12 To 13
        MaskData(i, 2) = Pc8toAnsi$(SF$(i))      'Default QTH + Info
      Case Else
        MaskData(i, 2) = SF$(i)                  'Default
      End Select
    Next i

    If SF$(2) = "0" Then
      Dsbl = 3
    Else
      'Dsbl = &HE03
      Dsbl = &H403
    End If

    MaskData(3, 4) = AbvAusw$(1, 24300)         'Status
    MaskData(5, 4) = AbvAusw$(2, 24310)         'Typ
    MaskData(6, 4) = AbvAusw$(3, 24340)         'Software
    MaskData(7, 4) = AbvAusw$(4, 24370)         'Hardware
    MaskData(9, 4) = BaudList$                  'Baud
  End If


  '---------- Eingabe ----------
  Cancel = GetMaskInput(Dsbl, Change&)
  If Not Cancel Then

    If AnzFields = 2 Then

      '--- Station auswhlen ---
      For i = 1 To AnzFields
        SF$(i) = UCase$(GetMaskData(i))
      Next i

      If Len(SF$(2)) = 0 Then SF$(2) = "0"

    Else

      For i = 1 To AnzFields
        Select Case i
        Case 8    'QRG
          sngQRG! = Val(Unformat$(GetMaskData(i)))
          SF$(i) = Unformat$(Format$(sngQRG!, "0.000;-0.000;0"))

        Case 12 To AnzFields      'QTH, Info
          SF$(i) = Trim$(Replace$(AnsiToPc8$(GetMaskData(i)), ",", ";"))

        Case Else
          SF$(i) = UCase$(GetMaskData(i))
        End Select
      Next i
    End If

  End If

  Call EraseMaskData

  EditStationData = Cancel

End Function

Function EditStationFunctions(Index, iMsgBase, Change&)

  Static StnCall As StationCall
  Static Stn As StationData
  Static Lnk As LinkData

  EditStationFunctions = True   'Cancel

  EditMsg$ = StdMsg$(iMsgBase + Index)

  'Station auswaehlen
  ErrNr = SelectEditStation(EditMsg$)
  If ErrNr Then Exit Function

  'Prfen, ob Station vorhanden
  ErrNr = EncodeCall(1, SF$(1), SF$(2), StnCall)
  If ErrNr Then Exit Function

  Screen.MousePointer = 11
  ErrNr = FindStation(StnCall, StnNr, RecNr, Found, Deleted)
  Screen.MousePointer = 0
  If ErrNr Then Exit Function

  Exist = Found And Not Deleted


  If Index = 1 Then
    '------ Station anlegen ------
    If Exist Then
      Call ShowErrNr(31039)
      Exit Function
    End If
  Else
    '------ Station aendern/loeschen ------
    If Not Exist Then
      Call ShowErrNr(24202)
      Exit Function
    End If
  End If


  Select Case Index
  Case 1
    '------ Station anlegen ------
    'Default-Werte
    SF$(3) = "OK"
    SF$(4) = Format$(Now, "YYMM")
    For i = 5 To 13
      SF$(i) = ""
    Next i

    Do
      '--- Daten eingeben ---
      Cancel = EditStationData(EditMsg$, 13, Change&)
      If Cancel Then Exit Function

      '--- Daten verarbeiten und speichern ---
      Screen.MousePointer = 11
      ErrNr = ProcessStation("AS", RecNr)
      Screen.MousePointer = 0
    Loop While ErrNr

    void = WriteUpdLog("AS")


  Case 2
    '------ Station ndern ------

    '--- Alte Stationsdaten laden ---
    ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
    If ErrNr Then Exit Function

    ErrNr = GetStationInfo(SV.Out.BstFile, Stn, Qth$, Info$)
    If ErrNr Then Exit Function

    If SF$(2) = "0" Then Mode = 1 Else Mode = 0
    Call DecodeStation(Stn, Qth$, Info$, Mode)

    'Fr UPD-File - Old-Value
    For i = 1 To 13
      OF$(i) = SF$(i)
    Next i

    OldDate$ = SF$(4)
    SF$(4) = Format$(Now, "YYMM")

    Do
      SF$(4) = SF$(4) + " (" + OldDate$ + ")"

      '--- Daten eingeben ---
      Cancel = EditStationData(EditMsg$, 13, Change&)

      SF$(4) = Parse$(SF$(4), "(")
      Change& = Change& And Not 8
      If SF$(4) <> OldDate$ Then Change& = Change& Or 8&

      If Cancel <> 0 Or Change& = 0 Then Exit Function


      '--- Daten verarbeiten und speichern ---
      Screen.MousePointer = 11
      ErrNr = ProcessStation("US", RecNr)
      Screen.MousePointer = 0
    Loop While ErrNr

    void = WriteUpdLog("US")


  Case 3
    '------ Station loeschen ------
    '--- Warnung bei Hauptzeile ---
    If SF$(2) = "0" Then
      Cancel = TxtMsgBox(Msg$(24115), 1 + 48 + 256, EditMsg$)
      If Cancel = 2 Then Exit Function
    End If

    '--- Beim Lschen Station deselektieren ---
    If HV.SelStnRec > 0 Then
      'Auf Grafik-Modus umschalten (muss vor 'SelectStation' stehen)
      Call TerminateFunction(0, 0&)
      Call DeselectStation
    End If

    '--- Station loeschen ---
    ErrNr = ProcessStation("DS", RecNr)
    If ErrNr Then Exit Function

    void = WriteUpdLog("DS")

  End Select


  HV.ForceRecalcRoutes = True

  'Achtung: Beim Lschen auch Zusatzzeilen prfen
  HV.ValidStnFlags = 0

  EditStationFunctions = False     'Not Cancel

End Function

Function GetLongStationInfo(RecNr, m$)

  GetLongStationInfo = True

  ReDim SLF$(0 To 9, 1 To AnzStnFields)

  '--- Station - volle Info ---
  'call,0,[status],[datum],[typ],[software],[hardware],
  '  [qrg],[baud],[sysop],[locator],[qth],[info]

  If RecNr = 0 Then
    Call ShowErrNr(24211)
    Exit Function
  End If

  '--- Daten laden und decodieren ---
  ErrNr = GetStationLineData(SV.Out.BsdFile, RecNr)
  If ErrNr Then Exit Function

  ErrNr = DecodeStationLines(6)
  If ErrNr Then Exit Function


  '--- Daten zusammenstellen ---
  '--- Call ---
  m$ = SLF$(0, 1)


  '--- QTH, Locator ---
  If Len(SLF$(0, 12)) > 0 Then
    m$ = m$ + " - " + Pc8toAnsi$(SLF$(0, 12))
    If Len(SLF$(0, 11)) > 0 Then m$ = m$ + " (" + SLF$(0, 11) + ")"
  Else
    If Len(SLF$(0, 11)) > 0 Then m$ = m$ + " - QTH: " + SLF$(0, 11)
  End If


  '--- Sysop ---
  If Len(SLF$(0, 10)) > 0 Then
    If Len(m$) < 35 Then
      m$ = m$ + " - "
    Else
      m$ = m$ + vbCrLf
    End If
    m$ = m$ + "Sysop: " + SLF$(0, 10)
  End If


  '--- Stationstyp ---
  StnTyp = StnLineData(0).StnTyp


  '--- Haupt + Zusatzzeilen ---
  For i = 1 To 9
    If StnLineData(i).xloc < 32767 Then AddLine = True
  Next i

  For i = 0 To 9
    If StnLineData(i).xloc < 32767 Then

      If AddLine Then
        Z$ = "#" + Format$(i) + ": "
      Else
        Z$ = ""
      End If

      '--- Info ---
      If Len(SLF$(i, 13)) > 0 Then
        m$ = m$ + vbCrLf + Z$ + Pc8toAnsi$(SLF$(i, 13))
      End If


      '--- Typ, Software, Hardware ---
      Typ = StnLineData(i).StnTyp
      SW = StnLineData(i).Software
      HW = StnLineData(i).Hardware

      If i = 0 Or Typ Or SW Or HW Then

        '--- Typ ---
        m$ = m$ + vbCrLf + Z$ + SLF$(i, 5)

        '--- Software, Hardware ---
        If SW Or HW Then m$ = m$ + ": "
        If SW Then m$ = m$ + SLF$(i, 6)
        If SW > 0 And HW > 0 Then m$ = m$ + " / "
        If HW Then m$ = m$ + SLF$(i, 7)
      End If


      '--- QRG ---
      QRG& = StnLineData(i).QRG           'QRG in kHz

      If QRG& > 0& Then

        q$ = GetQrgInfo$(QRG&)

        If Len(q$) > 15 Then
          m$ = m$ + vbCrLf + Z$ + q$ + vbCrLf + Z$
        Else
          m$ = m$ + vbCrLf + Z$ + q$ + "; "
        End If

      ElseIf QRG& = 0& Then
        'QRG unbekannt
        m$ = m$ + vbCrLf + Z$ + Msg$(24218) + "; "
      Else
        'kein Benutzerzugang
        m$ = m$ + vbCrLf + Z$ + Msg$(24217) + "; "
      End If

      If QRG& >= 0 Then

        '--- Baud ---
        If StnLineData(i).Baud > 0 Then
          m$ = m$ + Format$(Val(SLF$(i, 9)), "#,##0") + " Baud; "
        ElseIf StnTyp < 13 Then
          '"Baud unbekannt" nicht bei Fonie, ATV usw.
          m$ = m$ + Msg$(24219) + "; "
        End If

      End If


      '--- Datum ---
      If Len(SLF$(i, 4)) > 0 Then
        m$ = m$ + SLF$(i, 4) + "; "
      End If


      '--- Status ---
      m$ = m$ + SLF$(i, 3)

    End If
  Next i

  Erase SLF$

  GetLongStationInfo = False

End Function

Function GetShortStationInfo(m$)

  GetShortStationInfo = True

  '--- Station - Kurzinfo (unterste Zeile) ---
  If HV.SelStnRec = 0 Then Exit Function

  ActStnData = SelStnData

  Call DecodeStation(ActStnData, ActQTH, ActInfo, 1)

  m$ = SF$(1)

  'Status, Datum, Typ, Software, Hardware
  If SF$(3) <> "?" Then m$ = m$ + " " + SF$(3)
  If Len(SF$(4)) > 0 Then m$ = m$ + " " + SF$(4)
  If SF$(5) <> "?" Then m$ = m$ + " " + SF$(5)

  If SF$(6) <> "?" Or SF$(7) <> "?" Then
    m$ = m$ + " " + SF$(6) + "/" + SF$(7)
  End If

  'Sysop
  If Len(SF$(10)) > 0 Then m$ = m$ + " " + SF$(10) + ";"

  'QRG, Baud
  QRG& = SelStnData.QRG
  If QRG& >= 0 Then
    'Hat Benutzerzugang
    If QRG& = 0 Then
      m$ = m$ & " ? MHz;"
    Else
      Call Qrg2Str(QRG&, sTxQrg$, sRxQrg$, sChannel$)
      m$ = m$ & " " & sTxQrg$ & " MHz;"
    End If
    If SelStnData.Baud > 0 Then
      m$ = m$ + " " + Format$(SelStnData.Baud) + " Baud;"
    End If
  End If

  'Locator, QTH, Info
  If Len(SF$(11)) = 0 Then
    m$ = m$ + " QTH=? "
  Else
    m$ = m$ + " " + SF$(11) + " "
  End If

  m$ = m$ + Pc8toAnsi$(SelQTH)
  If Len(SelInfo$) > 0 Then m$ = m$ + "; " + Pc8toAnsi$(SelInfo)

  GetShortStationInfo = False

End Function

Function SelectEditStation(EditMsg$)

  SelectEditStation = True

  '--- Default fuer selektierte Station ---
  If HV.SelStnRec > 0 Then
    SF$(1) = SelStnCall$
    ErrNr = GetStnLineNrs(HV.SelStnRec, SF$(2))
    If ErrNr Then Exit Function
  Else
    SF$(1) = ""
    SF$(2) = "0"
  End If

  '--- Call und Zeile eingeben ---
  SelectEditStation = EditStationData(EditMsg$, 2, Change&)

End Function

Sub SelectStnByCall()

  Static LastCall$

  'GetInput (Title$, Prompt$, Default$, InpLine$)
  m$ = "HAMMAP - " + StdMsg$(24116)
  Cancel = GetInput(m$, Prompt$, LastCall$, Eingabe$)
  If Not Cancel Then LastCall$ = Eingabe$
  If Cancel Then Exit Sub

  Call DeselectStation

  If Len(Eingabe$) > 0 Then
    Call ShowText(Msg$(24116), 13, 11)
    ErrNr = FindAllStations(UCase$(Eingabe$))
    Call ShowText("", 13, 0)
    If ErrNr Then Exit Sub

    If HV.AnzFound = 0 Then
      Call ShowErrNr(24202)
    Else
      Call ShowFoundStn(True)
    End If
  End If

End Sub

Sub ShowStationInfo(Mode, ByVal FoundNr)

  Select Case Mode
  Case 1
    '--- Station - Kurzinfo (unterste Zeile) ---
    ErrNr = GetShortStationInfo(m$)
    If ErrNr = 0 Then Call ShowText(m$, 7, 0)

  Case 2
    '--- Station - volle Info ---
    If FoundNr = 0 Then
      RecNr = HV.SelStnRec
    Else
      RecNr = StnFnd(FoundNr).StnRec
    End If

    ErrNr = GetLongStationInfo(RecNr, m$)
    If ErrNr = 0 Then void = GrMsgBox(m$, 0)

  End Select

End Sub

Sub StnFunctions(Fkt)

  'Shortcut-Keys are not disabled
  If HV.HMDisabled Then Exit Sub

  'Pruefen, ob Stationen vorhanden
  If SV.Out.StnHdr.AnzStnRec < 2 Then
    Call ShowErrNr(24215)
    Exit Sub
  End If

  Select Case Fkt
  Case 8 To 10
    Call PrepareFunction(True, 2)         'Text-Mode + Save Map
  Case Else
    Call PrepareFunction(True, 0)
  End Select


  Title$ = StdMsg$(20080 + Fkt)

  Select Case Fkt
  Case 1, 2                                     'Anzeigen, Beschriften
    ErrNr = SetStnFlags()
    If ErrNr Then Exit Sub

    If Fkt = 1 Then
      Call DeselectStation
      HV.AnzFound = 0
      Call ShowFound(0)
    End If

    ErrNr = DrawAllStations(Fkt, AnzStn)


  Case 4                                     'Alle
    Call DeselectStation

  Case 5                                     'Suchen
    Call SelectStnByCall

  Case 6                                     'Info
    Call ShowStationInfo(2, 0)

  Case 8 To 10                    'Station anlegen,ndern,lschen
    Cancel = EditStationFunctions(Fkt - 7, 20087, Change&)   '1...3
    If Fkt = 9 Then
      MapChange& = Not Cancel And Change& <> 0    'ndern
    Else
      MapChange& = Not Cancel
    End If

  End Select

  Call TerminateFunction(1, MapChange&)

End Sub

