Attribute VB_Name = "FncSub"
'--------------------------- FNCSUB.BAS ------------------------
'von Gerhard Berg, DJ6FM

DefInt A-Z

Sub AreaFunctions(Fkt)

  Dim lNewArea As lAreaType

  'If MV.In.AnzSg = 0 Then Call ShowErrNr(24214)

  Call PrepareFunction(True, 0)

  lNewArea = Area(Fkt).lArea

  If IsNullArea(lNewArea) Then
    lNewArea = MV.MaxMapArea
  Else
    ErrNr = CheckAreaLimits(lNewArea, ErrField)
    If ErrNr Then Exit Sub
  End If

  m$ = Replace$(RTrim$(Area(Fkt).Label), "&", "")
  Call SelectMapArea(lNewArea, m$)

  Call TerminateFunction(0, 0&)

End Sub

Sub DesignFunctions(Fkt)

  Title$ = ProgName$ + " - " + StdMsg$(20160 + Fkt)

  Select Case Fkt
  Case 1                   'Debug
    Cancel = CheckBoxMask(Title$, 19500, 0, NumPar(35).Actual, 0&, Change&)

  Call InitShowOle

  Case 2
    Chk = HmForm.DesignPullDown(Fkt).Checked

    If Chk Then
      Call MapRecStop
    Else
      ErrNr = MapRecStart(Title$)
      If ErrNr Then Exit Sub
    End If

    HmForm.DesignPullDown(Fkt).Checked = Not Chk

  Case 3        'Reload Messages

  Case 4
    Call ShowOleClients

  Case 5      'Kanal-Liste ausgeben
    IniDir$ = HomeDir$
    Filt$ = "Text-File (*.TXT)|*.TXT"
    'Flags: PathMustExist + NoChangeDir + HideReadOnly
    Cancel = GetFileSpec(Title$, 2, &H80C&, IniDir$, "TXT", Filt$, FilNam$)
    If Not Cancel Then
      ErrNr = WriteChannelList(FilNam$)
    End If

  Case 6, 7     'GetDeviceCaps
    Cancel = GetInput(Title$, "Parameter #:", "", InpLine$)
    If Not Cancel Then
      If Fkt = 6 Then
        Value& = GetDeviceCaps(Printer.hDC, Val(InpLine$))
      Else
        Value& = GetDeviceCaps(MapForm.hDC, Val(InpLine$))
      End If
      MsgBox "Parameter " & InpLine$ & ": =" & Str$(Value&) & " = &H" & Hex$(Value&)
    End If

  Case 8        'HmForm-Size
    MsgBox CStr(HmForm.Width / Screen.TwipsPerPixelX) & " * " _
      & CStr(HmForm.Height / Screen.TwipsPerPixelY), , "HMForm Size [Pixels]"
  Case Else
    Stop

  End Select

End Sub

Sub FileFunctions(Fkt)

  'Shortcut-Keys are not disabled
  If HV.HMDisabled Then Exit Sub

  Title$ = ProgName$ + " - " + StdMsg$(20020 + Fkt)

  Select Case Fkt
  Case 1, 2, 8, 19
    Call PrepareFunction(True, 2)       'DOS: Text-Mode + Save Screen
  Case 21
    'Shell: Um Speicherplatz zu sparen, wird Bildschirm nicht gespeichert
    Call ShowErrNr(24212)
    Call PrepareFunction(True, 1)       'DOS: Text-Mode
  Case Else
    Call PrepareFunction(True, 0)
  End Select


  Select Case Fkt
  Case 1                          'Stationsdatei
    Cancel = LoadNewStations(Title$, MapChange&)
    'Karte mit neuen Stationen neu ausgeben


  Case 2                          'Kartendatei
    Cancel = LoadNewMap(Title$, 0, MapChange&)
    Call SetMaxMapArea

  Case 3                          'Karte einfgen
    ErrNr = InsertBitmap(Title$, MapFile$, MapChange&)
    If ErrNr = 0 Then
      StrPar(3, 6) = MapFile$
    ElseIf MapChange& Then
      'restore original File (evtl. wurde Rand abgeschnitten)
      void = LoadMapFile()
    End If

    Call SetMaxMapArea


  Case 4                          'Karte kalibrieren
    MapFile$ = StrPar(3, 6)
    ErrNr = CalibrateBitmap(MapFile$, Def$, Cancel)   'MapFile$ may change!
    If ErrNr = 0 And Cancel = 0 Then
      ErrNr = SetBitmapDef(Def$, MV.Border, MV.FileMapArea, MV.degFileMapArea)
      StrPar(3, 6) = MapFile$
      MapChange& = True
    Else
      'restore original File
      void = LoadMapFile()
    End If

    Call SetMaxMapArea


  Case 10                         'HAMMAP Speichern
    Call SaveMapToFile(0, Title$)

  Case 11                         'Karte Speichern
    Call SaveMapToFile(1, Title$)

  Case 13                         'HAMMAP Kopieren
    Call CopyMapToClipboard(0)

  Case 14                         'Karte Kopieren
    Call CopyMapToClipboard(1)

  Case 16                         'Overlay laden
    Call LoadOverlay(Title$)

  Case 17                         'Overlay speichern
    Call SaveOverlay(Title$)

  Case 19                         'Speicherverwendung
    Cancel = CheckBoxMask(Title$, 24470, 0, NumPar(8).Actual, 0&, Change&)


  Case 20                         'Einstellungen speichern
    Call HMWriteParameter




  Case 22                          'Beenden
    Call HMQuit
    Exit Sub      'Don't Call TerminateFunction
  End Select

  Call TerminateFunction(1, MapChange&)

End Sub

Sub HelpFunctions(Fkt)

  Call PrepareFunction(False, 2)      'DOS: Text-Mode + Save Map

  Select Case Fkt
  Case 1: h$ = "Introduction"
  Case 2: h$ = "Help"
  Case 3: h$ = "Toolbars"
  Case 4: h$ = "PopUpMap"
  Case 5  '---
  Case 6: h$ = "File"
  Case 7: h$ = "Map"
  Case 8: h$ = "Area"
  Case 9: h$ = "Stations"
  Case 10: h$ = "Links"
  Case 11: h$ = "Selection"
  Case 12: h$ = "Display"
  Case 13: h$ = "Print-Windows"
  Case 14: h$ = "Info"
  End Select

  void = ShowHelp("HAMMAP-" + h$)

  Call TerminateFunction(0, 0&)

End Sub

Sub MapFormDblClick()

  Call PrepareFunction(True, 0)

  '--- Info fuer selektierte Station ---
  If HV.ZoomPointer > 0 And HV.ZoomMode = 3 Then

    'Karte vergrern
    Call TerminateZoom(HV.ZoomStartPoint)

  ElseIf HV.SelStnRec > 0 Then

    Call ShowStationInfo(2, 0)

  End If

  Call TerminateFunction(0, 0&)

End Sub

Sub MapFormKeyDown(KeyCode, Shift)

  Static Busy

  Select Case KeyCode
  Case 33, 34, 37 To 40
    If Busy Then Exit Sub
    Busy = True

    Call PrepareFunction(True, 0)

    Select Case KeyCode
    Case 38   'Up
      Call CmdZoomMove("U", 0.25)
    Case 40   'Down
      Call CmdZoomMove("D", 0.25)
    Case 37   'Left
      Call CmdZoomMove("L", 0.25)
    Case 39   'Right
      Call CmdZoomMove("R", 0.25)

    Case 33   'Pg Up
      Select Case Shift
      Case 0
        Call CmdZoomMove("U", 1)
      Case 1
        Call CmdZoomMove("L", 1)
      End Select

    Case 34   'Pg Down
      Select Case Shift
      Case 0
        Call CmdZoomMove("D", 1)
      Case 1
        Call CmdZoomMove("R", 1)
      End Select

    End Select

    Call TerminateFunction(0, 0)

    Busy = False
  End Select

End Sub

Sub MapFormKeyPress(KeyAscii)

  'letztes Blinken ggf. aufheben
  Call DrawSelectedStation(-1)

  Select Case KeyAscii
  Case 27     'ESC
    If HV.ZoomMode Then
      Call StopZoom
    End If

  Case Else
    'Call ShowText(Str$(KeyAscii), 7, 0)

  End Select

End Sub

Sub MapFormMouseDown(Button, Shift, pabs As PointApi)

  Dim pgeo As lPoint

  If Not PointInRect(pabs, HMCrt.MapRect) Then
    Beep
    Exit Sub
  End If

  If HV.ZoomMode = 0 Then Call PrepareFunction(True, 0)

  If HV.ZoomMode > 0 And Button = 1 Then

    Call StartZoomMove(pabs)

  Else

    Call devPoint2secPoint(HMCrt, pabs, pgeo)

    '--- Maus in Karten-Bereich ---
    Select Case Button
    '------- Linke Taste -------
    Case 1
      Select Case HV.MouseFunctionMode
      Case 0        'Standardmodus
        If gblMapRecFile = 0 Then
          Call MouseClickStation(pgeo)                 'Station anklicken
        Else
          Call MapRecSave(pgeo.x, pgeo.y)
        End If
      Case 1
        Call CmdZoomCenter(pgeo.x, pgeo.y, 0.5)
      Case 2
        Call CmdZoomCenter(pgeo.x, pgeo.y, 2)
      Case 3
        Call AddWaterPoint(pgeo.x, pgeo.y)
      End Select

    '------- rechte Taste -------
    Case 2
      Select Case Shift
      Case 0
        Select Case HV.MouseFunctionMode
        Case 0
          If HV.ZoomMode Then
            Call StopZoom
          Else
            HmForm.PopupMenu HmForm.mnuMap, 2
          End If
        Case 1
          Call CmdZoomCenter(pgeo.x, pgeo.y, 2)
        Case 2
          Call CmdZoomCenter(pgeo.x, pgeo.y, 0.5)
        End Select

      Case 2      'Ctrl - Info ausgeben
        m$ = Replace$(MapTipInfo$(1, pabs), vbCrLf, " ")
        Call ShowText(m$, 7, 0)
        void = DrawSingleSymbol(pgeo.x, pgeo.y, 12, HV.ColVal(13))

      Case 4      'Alt - einfaerben
        'Call DrawSingleWaterPoint(pgeo.x, pgeo.y)
        Call AddWaterPoint(pgeo.x, pgeo.y)
      End Select

    'Case 3                              '--- beide Tasten
    'Case 4                              '--- mittlere Taste
    End Select

  End If

  'Nach InitializeZoom (Popup-Menu) ist TerminateFunction ntig !
  If HV.ZoomMode <= 1 Then Call TerminateFunction(0, 0&)

End Sub

Sub MapFormMouseMove(Button, Shift, pabs As PointApi)

  If HV.ZoomMode Then Call ZoomMouseMove(pabs)

End Sub

Sub MapFormMouseUp(Button, Shift, pabs As PointApi)

  If HV.ZoomMode > 0 Then Call TerminateZoom(pabs)

End Sub

Sub WinPopupFunctions(Index)

  'Fehler in V11.0 (Stop bei Kontextmen) - gelscht in V11.0a
  'Call PrepareFunction(True, 0)

  Title$ = StdMsg$(19180 + Index)

  Select Case Index
  Case 1      'Maus-Info Auswahl
    Call MapTipSelection(Title$)

  Case 2      'Maus-Info Optionen
    Call MapTipOptions(Title$)

  Case 3      '---

  Case 4      'Locator suchen
    Call FindLocator

  Case 5      'Koordinaten suchen
    Call FindCoordinate(Title$)

  Case 6      'Stadt usw. suchen
    Call FindTown(Title$)

  Case 7      '---

  Case 8      'Karte speichern
    void = StoreMap(0&)

  Case 9      'Karte wiederherstellen
    void = RestoreMap(1, 0)

  Case 10     '---

  Case 11     'Ausschnitt whlen
    Call InitializeZoom

  Case 12     'Ausschnitt/Karte vergrern
    Call CmdZoomInOut(0.5)

  Case 13     'Karte verkleinern
    Call CmdZoomInOut(2)

  Case 14     '---

  Case 15     'Hilfe
    void = ShowHelp("HAMMAP-PopUpMap")
    GV.TopForm = 1

  End Select

  'Fehler in V11.0 (Stop bei Kontextmen) - gelscht in V11.0a
  'Call TerminateFunction(0, 0&)

End Sub

