Attribute VB_Name = "GdiSub"
'--------------------------- GDISUB.BAS ------------------------

'GDI-Unterprogramme (Graphics Device Interface)
'von Gerhard Berg, DJ6FM

DefInt A-Z



'----- Variables -----
Dim FigPnts(0 To 4) As PointApi

Dim Ok As Long


'----- Functions -----

Public Declare Function SaveDC& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function RestoreDC& Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long)
Public Declare Function CreateRectRgnIndirect& Lib "gdi32" (lpRect As RECT)
Public Declare Function SelectClipRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function GetClipRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function GetDeviceCaps& Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long)

Public Declare Function CreatePen& Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long)
Public Declare Function CreateBrushIndirect& Lib "gdi32" (lpLogBrush As LOGBRUSH)
Public Declare Function CreateFontIndirect& Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT)
Public Declare Function GetTextMetrics& Lib "gdi32" Alias "GetTextMetricsA" (ByVal hDC As Long, lpMetrics As TEXTMETRIC)
Public Declare Function SelectObject& Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long)
Public Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)

Public Declare Function SetPixel& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long)
Public Declare Function GetPixel& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long)
Public Declare Function GetNearestColor& Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long)

Public Declare Function MoveToEx& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As PointApi)
Public Declare Function LineTo& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long)
Public Declare Function Polyline& Lib "gdi32" (ByVal hDC As Long, lpPoint As PointApi, ByVal nCount As Long)
Public Declare Function Polygon& Lib "gdi32" (ByVal hDC As Long, lpPoint As PointApi, ByVal nCount As Long)
Public Declare Function Rectangle& Lib "gdi32" (ByVal hDC As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function Ellipse& Lib "gdi32" (ByVal hDC As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function FloodFill& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long)
Public Declare Function ExtFloodFill& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long)

Public Declare Function GdiFlush& Lib "gdi32" ()

Public Declare Function SetTextColor& Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long)
Public Declare Function DrawText& Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long)
'

Sub ChangeTextColor(Dev As HMDevice, ByVal Col As Long)

  If Dev.hDev = 0 Then Stop

  If Dev.MonoChrome Then
    If Col <> HV.BackCol Then Col = HV.ForeCol
  End If

  void& = SetTextColor&(Dev.hDev, Col)

  Dev.TextColor = NewCol&

End Sub

Function DrawFigureAbs(Dev As HMDevice, r As RECT, ByVal FigNr, NewPen As HMPen, FillCol&, FillStyle)

  'FillStyle: 0=solid(ausgefllt), 1=transparent

  Dim ActCol As Long
  Dim pDev As PointApi

  If Dev.hDev = 0 Then Stop

  ErrNr = SetPen(Dev, NewPen)
  PenCol& = Dev.ActPen.Color

  If FigNr >= 10 Then
    ErrNr = SetBrush(Dev, FillCol&, FillStyle)

    xl = r.Left
    yo = r.Top
    xr = r.Right - 1
    yu = r.Bottom - 1

    xc = (xl + xr) \ 2
    yc = (yo + yu) \ 2

    If xl = xr And yo = yu Then
      FigNr = 1      'Punkt
    End If

  End If

  Select Case FigNr
  Case 0                                'nichts

  Case 1                                'Punkt
    Call GetRectCenter(r, pDev)
    ActCol = SetPixel&(Dev.hDev, pDev.x, pDev.y, PenCol&)

  Case 2                                'Linie
    'links unten nach rechts oben
    ErrNr = DrawRectLine(Dev, r, PenCol&, 2)

  Case 3                                'senkrechtes Kreuz
    ErrNr = DrawRectLine(Dev, r, PenCol&, 0)
    ErrNr = DrawRectLine(Dev, r, PenCol&, 1)

  Case 4                                'schraeges Kreuz
    ErrNr = DrawRectLine(Dev, r, PenCol&, 2)
    ErrNr = DrawRectLine(Dev, r, PenCol&, 3)

  Case 5                                'Stern
    ErrNr = DrawRectLine(Dev, r, PenCol&, 0)
    ErrNr = DrawRectLine(Dev, r, PenCol&, 1)
    ErrNr = DrawRectLine(Dev, r, PenCol&, 2)
    ErrNr = DrawRectLine(Dev, r, PenCol&, 3)


  Case 10                               'Kreis / Ellipse
    Ok = Ellipse(Dev.hDev, xl, yo, r.Right, r.Bottom)

  Case 11                                'Rechteck
    Ok = Rectangle(Dev.hDev, xl, yo, r.Right, r.Bottom)

  Case 12                                'Raute
    FigPnts(0).x = xc: FigPnts(0).y = yo
    FigPnts(1).x = xr: FigPnts(1).y = yc
    FigPnts(2).x = xc: FigPnts(2).y = yu
    FigPnts(3).x = xl: FigPnts(3).y = yc
    FigPnts(4).x = xc: FigPnts(4).y = yo
    nCount& = 5

  Case 13                                'Dreieck (Spitze oben)
    FigPnts(0).x = xc: FigPnts(0).y = yo
    FigPnts(1).x = xr: FigPnts(1).y = yu
    FigPnts(2).x = xl: FigPnts(2).y = yu
    FigPnts(3).x = xc: FigPnts(3).y = yo
    nCount& = 4

  Case 14                                'Dreieck (Spitze unten)
    FigPnts(0).x = xc: FigPnts(0).y = yu
    FigPnts(1).x = xr: FigPnts(1).y = yo
    FigPnts(2).x = xl: FigPnts(2).y = yo
    FigPnts(3).x = xc: FigPnts(3).y = yu
    nCount& = 4

  Case 15                               'Dreieck (Spitze rechts)
    FigPnts(0).x = xr: FigPnts(0).y = yc
    FigPnts(1).x = xl: FigPnts(1).y = yu
    FigPnts(2).x = xl: FigPnts(2).y = yo
    FigPnts(3).x = xr: FigPnts(3).y = yc
    nCount& = 4

  Case 16                               'Dreieck (Spitze links)
    FigPnts(0).x = xl: FigPnts(0).y = yc
    FigPnts(1).x = xr: FigPnts(1).y = yu
    FigPnts(2).x = xr: FigPnts(2).y = yo
    FigPnts(3).x = xl: FigPnts(3).y = yc
    nCount& = 4

  End Select

  If nCount& > 0 Then
  Ok = Polygon(Dev.hDev, FigPnts(0), nCount&)
  End If

End Function

Function DrawLineDev(Dev As HMDevice, devP1 As PointApi, devP2 As PointApi, crColor&)

  Dim OldPos As PointApi


  If devP1.x <> devP2.x Or devP1.y <> devP2.y Then
    Ok = MoveToEx(Dev.hDev, devP1.x, devP1.y, OldPos)
    Ok = LineTo(Dev.hDev, devP2.x, devP2.y)
  End If

  'LineTo gibt Endpunkt unter Windows nicht aus
  ActCol& = SetPixel&(Dev.hDev, devP2.x, devP2.y, crColor&)


  DrawLineDev = Ok

End Function

Function DrawRectLine(Dev As HMDevice, r As RECT, PenCol&, Mode)

  Dim P1 As PointApi
  Dim P2 As PointApi

  Select Case Mode
  Case 0      'waagrecht
    P1.x = r.Left
    P1.y = (r.Top + r.Bottom - 1) \ 2
    P2.x = r.Right - 1
    P2.y = P1.y

  Case 1      'senkrecht
    P1.x = (r.Left + r.Right - 1) \ 2     'Mitte
    P1.y = r.Top
    P2.x = P1.x
    P2.y = r.Bottom - 1

  Case 2      'links unten nach rechts oben
    P1.x = r.Left
    P1.y = r.Bottom - 1
    P2.x = r.Right - 1
    P2.y = r.Top

  Case 3      'links oben nach rechts unten
    P1.x = r.Left
    P1.y = r.Top
    P2.x = r.Right - 1
    P2.y = r.Bottom - 1

  Case Else
    Stop
  End Select

  Ok = DrawLineDev(Dev, P1, P2, PenCol&)

  DrawRectLine = (Ok = 0)

End Function

Function DrawSingleFigure(a As lAreaType, FigNr, NewPen As HMPen, FillCol&, FillStyle, OvlMode)

  Dim r As RECT

  DrawSingleFigure = True

  If OvlMode = 0 Then

    '--- Non-Overlay ---
    ErrNr = PrepareMapDevices(1)

    If HV.PrtEnbl And 1 Then
      Call larea2Rect(HMCrt, a, 0, r)
      ErrNr = DrawFigureAbs(HMCrt, r, FigNr, NewPen, FillCol&, FillStyle)
    End If

    If HV.PrtEnbl And 2 Then
      Call larea2Rect(HMPrt, a, 0, r)
      ErrNr = DrawFigureAbs(HMPrt, r, FigNr, NewPen, FillCol&, FillStyle)
    End If

    ErrNr = ErrNr Or TerminateAllDevices()

  Else

    '--- Overlay ---
    Cmd$ = "DrawFigure: " & lArea2Str$(a) & "," & Str$(FigNr)
    Cmd$ = Cmd$ & ", 00" & Hex$(NewPen.Color) & ", 00" & Hex$(FillCol&)
    Cmd$ = Cmd$ & "," & Str$(NewPen.Width) & "," & Str$(NewPen.Style)
    Cmd$ = Cmd$ & "," & Str$(FillStyle)

    If OvlMode = 1 Then
      'Foreground-Overlay
      ForeOverlay$ = ForeOverlay$ & Cmd$ & vbCrLf
    Else
      'Background-Overlay
      BackOverlay$ = BackOverlay$ & Cmd$ & vbCrLf
    End If

  End If

  DrawSingleFigure = False

End Function

Sub EnblMapControls(State)

  Static CrossHairState, TipState

  If State = 0 Then

    CrossHairState = MapForm.Line1.Visible
    If CrossHairState Then
      MapForm.Line1.Visible = False
      MapForm.Line2.Visible = False
    End If

    'Tip nicht mitkopieren
    TipState = MapForm.Tip.Visible
    If TipState Then MapForm.Tip.Visible = False

    'Warten bis Controls invisible (Windows messages abgearbeitet)
    void = DoEvents()

  Else

    If CrossHairState Then
      MapForm.Line1.Visible = True
      MapForm.Line2.Visible = True
    End If

    'Tip wiederherstellen
    If TipState Then MapForm.Tip.Visible = True

  End If

End Sub

Function GetAutoFontSize(Dev As HMDevice) As Single

  'Koordinaten in Grad = xy / 3600 = xy * cfSec2Deg
  'Koordinaten im Bogenmass = Grad * deg2rad / 3600

  x2! = MV.ActMapArea.lxmax * cfSec2Rad
  x1! = MV.ActMapArea.lxmin * cfSec2Rad
  y2! = MV.ActMapArea.lymax * cfSec2Rad
  y1! = MV.ActMapArea.lymin * cfSec2Rad

  'Bogen = Winkel im Bogenmass * Radius

  'Ausschnitthoehe in km
  dy! = (y2! - y1!) * EarthRad

  'y-Mittelwert im Bogenmass
  ym! = (y2! + y1!) / 2

  'Ausschnittbreite in km
  dx! = (x2! - x1!) * EarthRad * Cos(ym!)

  '--- Kartenaufloesung in km je Pixel ---
  kppx! = dx! / Dev.MapWidth
  kppy! = dy! / Dev.MapHeight

  If kppx! > kppy! Then
    MapRes! = kppx!
  Else
    MapRes! = kppy!
  End If

  'Min.Size = 2; Max.Size = 6 bzw. 12
  'Achtung: Ergebnis soll gerundet sein
  MaxSize = 12
  GetAutoFontSize = 2 + (MaxSize - 2) * Exp(-0.8 * MapRes!)

End Function

Sub GetDpi(ByVal hDC&, DpiX, DpiY)

  Const LOGPIXELSX = 88    '  Logical pixels/inch in X
  Const LOGPIXELSY = 90    '  Logical pixels/inch in Y

  DpiX = GetDeviceCaps(hDC&, LOGPIXELSX)
  DpiY = GetDeviceCaps(hDC&, LOGPIXELSY)

End Sub

Function GetFontSize(Dev As HMDevice)

  '--- Schriftgroesse bestimmen ---

  If Dev.Options And 4 Then
    'Automatisch nach Ausschnitt-Groesse
    Dev.NameFont.Size = GetAutoFontSize(Dev)
    If Int(Dev.NameFont.Size * Dev.DpiY / PointsPerInch) < 10 Then
    'If Int(Dev.NameFont.Size * Dev.PixelPerCmY * CmPerPoint) < 10 Then
    'If Dev.NameFont.Size < 8! Then
      Dev.NameFont.Name = "Small Fonts"
    Else
      Dev.NameFont.Name = "Arial"
    End If
    Dev.NameFont.Attr = 0
    Dev.NameFont.Angle = 0
  Else
    'Aus Parametern
    Dev.NameFont = Dev.ParamFont
  End If

  'siehe auch APISIM_D/CreateFontIndirect
  Dev.SymbolSize = (Dev.NameFont.Size * Dev.DpiY / PointsPerInch - 1) / 2
  If Dev.SymbolSize < 1 Then Dev.SymbolSize = 1

End Function

Sub GetScreenAspect()

  'Screen Aspect (dots)
  'Don't use MapHeight and MapWidth - it's not defined at InitPhysDevices
  HV.ScreenAspect = ((HMCrt.FrameHeight - 2) / (HMCrt.FrameWidth - 2))
  HV.ScreenAspect = HV.ScreenAspect * HMCrt.PixelAspect

  If NumPar(46).Actual And MF_PrtProp Then
    'Breite und Hhe der Drucker-Karte in cm
    HV.ScreenAspect = NumPar(15).Actual / NumPar(16).Actual
  End If

End Sub

Sub HMFont2LogFont(Dev As HMDevice, HMFnt As HMFont, LogFnt As LOGFONT)

  Dim TempByteArray() As Byte

  '------ Font definieren ------

  '--- Drehung ---
  LogFnt.lfEscapement = HMFnt.Angle * 10          'Degrees * 10
  LogFnt.lfOrientation = LogFnt.lfEscapement      'fr Windows NT


  '--- Gre ---
  h = Int(HMFnt.Size * Dev.DpiY / PointsPerInch)

  'If RTrim$(HMFnt.Name) = "Small Fonts" Then
  '  If h > 9 Then h = 9
  'Else
  '  If h < 7 Then h = 7
  'End If

  'negativ -> Glyph Size
  LogFnt.lfHeight = -h


  '--- Name ---
  n$ = RTrim$(HMFnt.Name) & Chr$(0)
  TempByteArray = StrConv(n$, vbFromUnicode)
  Call CopyMemory(LogFnt.lfFaceName(0), TempByteArray(0), Len(n$))


  '--- Italic ---
  If HMFnt.Attr And 2 Then LogFnt.lfItalic = 1


  '--- Bold ---
  If HMFnt.Attr And 1 Then
    LogFnt.lfWeight = 800        'Bold
  Else
    LogFnt.lfWeight = 400
  End If

End Sub

Sub InitMapDevice(Dev As HMDevice)

  Dev.MapRect.Left = Dev.FrameRect.Left + 1
  Dev.MapRect.Top = Dev.FrameRect.Top + 1
  Dev.MapRect.Right = Dev.FrameRect.Right - 1
  Dev.MapRect.Bottom = Dev.FrameRect.Bottom - 1

  Dev.MapWidth = Dev.FrameWidth - 2
  Dev.MapHeight = Dev.FrameHeight - 2

  'Umrechnung Sekunden <--> Pixel
  Dev.SecPerPixelX = HV.MapWidthGeo / Dev.MapWidth
  Dev.SecPerPixelY = HV.MapHeightGeo / Dev.MapHeight
  Dev.PixelPerSecX = Dev.MapWidth / HV.MapWidthGeo
  Dev.PixelPerSecY = Dev.MapHeight / HV.MapHeightGeo

  'Auflsung in Meter pro Pixel
  ym& = (MV.ActMapArea.lymax + MV.ActMapArea.lymin) / 2
  dx! = HV.MapWidthGeo * cfSec2Rad * EarthRad * Cos(ym& * cfSec2Rad)
  dy! = HV.MapHeightGeo * cfSec2Rad * EarthRad

  HorRes& = dx! * 1000 / Dev.MapWidth
  VerRes& = dy! * 1000 / Dev.MapHeight
  Dev.mPerPixel = lMin(HorRes&, VerRes&)    'Auflsung in m/Pixel

  ErrNr = GetFontSize(Dev)

End Sub

Sub InitMapDevices()

  '--- Set device dependent parameter ---

  If HV.PrtEnbl And 1 Then

    Call GetAreaSize(MV.ActMapArea, HV.MapWidthGeo, HV.MapHeightGeo)

    Call InitMapDevice(HMCrt)

    '----- Screen -----
    Call GetScreenAspect

    'Bereich fr Stationsausgabe bestimmen
    If HMCrt.SymbolSize = 0 Then Stop
    If HMCrt.SecPerPixelX = 0 Then Stop

    dw! = (HMCrt.SymbolSize + 1) * HMCrt.SecPerPixelX
    dh! = (HMCrt.SymbolSize + 1) * HMCrt.SecPerPixelY
    'zum Aufrunden bei Verwendung von Int
    dr! = cfQth2Sec - 1

    'Avoid Int() error - see VBPJ Nov.96, Page 56
    If (NumPar(42).Actual And 3) = 0 Then
      'Links nicht nach auerhalb -> Stationen am Rand nicht zeichnen
      fxmax! = MV.ActMapArea.lxmax - dw!
      fxmin! = MV.ActMapArea.lxmin + dw! + dr!
      fymax! = MV.ActMapArea.lymax - dh!
      fymin! = MV.ActMapArea.lymin + dh! + dr!
    Else
      'Links nach ausserhalb -> Stationen am Rand zeichnen
      fxmax! = MV.ActMapArea.lxmax + dw! + dr!
      fxmin! = MV.ActMapArea.lxmin - dw!
      fymax! = MV.ActMapArea.lymax + dh! + dr!
      fymin! = MV.ActMapArea.lymin - dh!
    End If

    MV.iStnArea.ixmax = Int(fxmax! / cfQth2Sec)
    MV.iStnArea.ixmin = Int(fxmin! / cfQth2Sec)
    MV.iStnArea.iymax = Int(fymax! / cfQth2Sec)
    MV.iStnArea.iymin = Int(fymin! / cfQth2Sec)

  End If

  If HV.PrtEnbl And 2 Then
    Call InitMapDevice(HMPrt)
  End If

End Sub

Sub InitPhysDevice(Dev As HMDevice)

  With Dev

    'Set derived parameter
    .MonoChrome = (.Options And 1) = 0

    If (.Options And 3) = 3 Then
      'Farbausgabe und Land einfrben
      .BackCol = HV.ColVal(9)   'Landfarbe
    Else
      .BackCol = HV.BackCol   'Hintergrundfarbe
    End If

    .DrawRect.Right = .DrawRect.Left + .DrawWidth
    .DrawRect.Bottom = .DrawRect.Top + .DrawHeight

    .PrintRect.Right = .PrintRect.Left + .DrawWidth
    .PrintRect.Bottom = .PrintRect.Top + .DrawHeight

    .PixelAspect = .DpiX / .DpiY

    'Initial values
    .FrameRect = .DrawRect
    .FrameWidth = .DrawWidth
    .FrameHeight = .DrawHeight

  End With

End Sub

Sub InitPhysDevices()

  If HV.PrtEnbl And 1 Then
    '------- Screen -------
    With HMCrt
      .Id = 0
      Call GetDpi(MapForm.hDC, .DpiX, .DpiY)
      .Options = NumPar(51).Actual         'Bildschirm

      .DrawRect.Left = 0
      .DrawRect.Top = 0
    End With


    With MapForm
      .ScaleMode = 3              'Pixel
      If .MapHScroll.Visible Then
        dx = .MapVScroll.Width
        dy = .MapHScroll.Height
      Else
        dx = 0
        dy = 0
      End If
      HMCrt.DrawWidth = lMax(4, .ScaleWidth - dx)
      HMCrt.DrawHeight = lMax(4, .ScaleHeight - dy)
    End With


    With HMCrt
      If NumPar(46).Actual And MF_PrtProp Then
        'Seitenverhltnis (Hhe/Breite) wie bei Drucker machen
        PrtAsp! = NumPar(15).Actual / NumPar(16).Actual
        ScrAsp! = HMCrt.DrawHeight / HMCrt.DrawWidth
        If ScrAsp! < PrtAsp! Then
          'Bildschirm zu hoch -> Breite anpassen
          NewWidth = HMCrt.DrawHeight / PrtAsp!
          HMCrt.DrawRect.Left = (HMCrt.DrawWidth - NewWidth) \ 2
          HMCrt.DrawWidth = NewWidth
        ElseIf ScrAsp! > PrtAsp! Then
          'Bildschirm zu breit -> Hhe anpassen
          NewHeight = HMCrt.DrawWidth * PrtAsp!
          HMCrt.DrawRect.Top = (HMCrt.DrawHeight - NewHeight) \ 2
          HMCrt.DrawHeight = NewHeight
        End If
      End If

      HMCrt.ParamFont.Name = StrPar(3, 8)
      HMCrt.ParamFont.Size = NumPar(36).Actual / 1000!
      HMCrt.ParamFont.Attr = NumPar(37).Actual         '1 = Bold, 2 = Italic
      HMCrt.ParamFont.Angle = 0

      Call InitPhysDevice(HMCrt)
      Call GetScreenAspect
    End With

  End If


  If HV.PrtEnbl And 2 Then
    '------- Printer -------
    With HMPrt
      HMPrt.Id = 1

      If (NumPar(35).Actual And 512) <> 0 And (HV.PrtEnbl And &H30) = 0 Then
        HV.PrtEnbl = HV.PrtEnbl Or 4        'Simulation
      End If

      Select Case HV.PrtEnbl And &H34
      Case 4, 16, 32    'Simulation, WMF, EMF
        Call GetDpi(MapForm.hDC, .DpiX, .DpiY)
      Case Else         'Printer
        Call GetDpi(Printer.hDC, .DpiX, .DpiY)
      End Select

      .Options = NumPar(52).Actual

      .ParamFont.Name = StrPar(3, 9)
      .ParamFont.Size = NumPar(38).Actual / 1000!
      .ParamFont.Attr = NumPar(39).Actual         '1 = Bold, 2 = Italic
      .ParamFont.Angle = 0

      .DrawRect.Left = NumPar(14).Actual * .DpiX / 2540
      .DrawRect.Top = NumPar(13).Actual * .DpiY / 2540
      .DrawWidth = NumPar(16).Actual * .DpiX / 2540
      .DrawHeight = NumPar(15).Actual * .DpiY / 2540

      .PrintRect = .DrawRect

      If HV.PrtEnbl And &H38 Then
        '--- Buffered Printing / Windows Metafile ---
        .DrawRect.Left = 0
        .DrawRect.Top = 0
      End If

      If HV.PrtEnbl And &H30 Then
        '--- Windows Metafile ---
        .DrawWidth = HMCrt.DrawWidth
        .DrawHeight = HMCrt.DrawHeight
      End If

      Call InitPhysDevice(HMPrt)
    End With
  End If

End Sub

Function InitTempPictureBox(w&, h&) As Long

  With PrtOptForm
    .ScaleMode = 3            'Pixel
    With .Pict
      'BorderStyle must be 0 = none
      .ScaleMode = 3          'Pixel
      .AutoRedraw = True
      .Cls
      On Error Resume Next
      .Move 0, 0, w&, h&
      ErrNr = Err
      On Error GoTo 0
      InitTempPictureBox = .hDC
    End With
  End With

  If ErrNr Then
    Unload PrtOptForm
    Set PrtOptForm = Nothing
    InitTempPictureBox = 0
    Call ShowErrNr(7)     'Nicht genug Speicher
  End If

End Function

Function PrepareDevice(Dev As HMDevice, Mode)

  If Dev.hDev = 0 Then Stop

  Dim NewObj As Long

  'save Device Context state
  Dev.VbDev = SaveDC(Dev.hDev)
  'ErrNr = (Dev.VbDev = 0)


  'set clipping region
  If Mode And 4 Then
    'Wasser
    NewObj = CreateRectRgnIndirect(Dev.FrameRect)
  ElseIf Mode And 2 Then
    NewObj = CreateRectRgnIndirect(Dev.DrawRect)
  Else
    NewObj = CreateRectRgnIndirect(Dev.MapRect)
  End If
  Ok = SelectClipRgn(Dev.hDev, NewObj)
  Ok = DeleteObject(NewObj)

  ReDim SegPnts(0 To 500) As PointApi

  'Prepare Water
  If (Mode And 4) <> 0 And (Dev.Options And 3) = 3 Then
    Call PrepareWater(Dev)
  End If

  'Determine Symbol- and Font-Size
  If Mode And 8 Then
    'ErrNr = GetFontSize(Dev)
    ErrNr = SetFont(Dev, Dev.NameFont)
  End If

  Dev.TextColor = -1        'Force setting of color

  'Must be after call to SetFont !!!
  Dev.RotateText = (Dev.Options And 16) <> 0 And Dev.PhysFont.TrueType
    'RTrim$ (Dev.NameFont.Name) <> "Small Fonts"

End Function

Sub PrepareMap(Dev As HMDevice)

  '--- Rahmen um Karte ausgeben und Land einfrben ---

  Dim NewPen As HMPen

  NewPen.Width = 1
  NewPen.Style = 0
  NewPen.Color = HV.ForeCol

  If Not RectInRect(2, Dev.DrawRect, Dev.FrameRect) Then
    If Dev.Id = 0 Or (HV.PrtEnbl And 28) <> 0 Then
      'Bildschirm, Simulation, gepuffert oder Metafile
      '-> Papier-Seite mit weiem Hintergrund und schwarzem Rahmen
      ErrNr = DrawFigureAbs(Dev, Dev.DrawRect, 11, NewPen, HV.BackCol, 0)
    Else
      'Drucker -> nur Rahmen (transparent)
      ErrNr = DrawFigureAbs(Dev, Dev.DrawRect, 11, NewPen, HV.BackCol, 1)
    End If
  End If

  ErrNr = DrawFigureAbs(Dev, Dev.FrameRect, 11, NewPen, Dev.BackCol, 0)

End Sub

Function PrepareMapDevices(Mode)

  'Mode: 1 = Call InitMapDevices
       ' 2 = Clipping includes Frame
       ' 4 = Water Output
       ' 8 = Get Symbol- and Font-Size

  If HV.ExecOverlay Then Exit Function

  If HMCrt.hDev <> 0 Or HMPrt.hDev <> 0 Then Stop

  If Mode And 1 Then
    Call InitMapDevices
  End If


  '--- Screen ---
  If HV.PrtEnbl And 1 Then
    If HV.MouseFunctionMode > 0 Then MapForm.MousePointer = 0

    'Disable Blink- und Tip-Timer
    '  (API-Ausgabe darf nicht unterbrochen werden)
    HMCrt.BlinkEnbl = MapForm.BlinkTimer.Enabled
    If HMCrt.BlinkEnbl Then MapForm.BlinkTimer.Enabled = False

    HMCrt.TipEnbl = MapForm.TipTimer.Enabled
    If HMCrt.TipEnbl Then MapForm.TipTimer.Enabled = False

    'noch anstehende Timer-Events abarbeiten
    DoEvents

    If (NumPar(46).Actual And MF_BackGnd) = 0 Then
      'Vorbereitung der Ausgabe in Window statt persistant BitMap
      Call PrepareWindowOutput
    End If

    HMCrt.hDev = MapForm.hDC
    ErrNr = PrepareDevice(HMCrt, Mode)
  End If



  '--- Printer ---
  If HV.PrtEnbl And 2 Then
    If HV.PrtEnbl And &H30 Then
      'Windows (Enhanced) Metafile
      HMPrt.hDev = HV.hMetaDC
    ElseIf HV.PrtEnbl And 8 Then
      'buffered Printing
      If NumPar(35).Actual And 1024 Then
        'use PictureBox
        HMPrt.hDev = PrtOptForm.Pict.hDC
      Else
        'use DIBSection
        HMPrt.hDev = Dib.hCompDC
      End If
    ElseIf HV.PrtEnbl And 4 Then
      'Simulation
      HMPrt.hDev = frmPrtSim.hDC
    Else
      'Printer
      HMPrt.hDev = Printer.hDC
    End If
    ErrNr = PrepareDevice(HMPrt, Mode)
  End If


End Function

Sub PrepareWater(Dev As HMDevice)

  Dim NewPen As HMPen

  If Dev.hDev = 0 Then Stop

  'Rahmen in Randfarbe zeichnen, um Auslaufen zu verhindern
  NewPen.Color = HV.ForeCol
  NewPen.Width = 1
  NewPen.Style = 0
  ErrNr = DrawFigureAbs(Dev, Dev.FrameRect, 11, NewPen, 0&, 1)

  'Tatschliche Windows-Farben ermitteln
  Dev.WinBorderCol = GetNearestColor&(Dev.hDev, HV.ForeCol)
  Dev.WinWaterCol = GetNearestColor&(Dev.hDev, HV.ColVal(8))

  'Brush setzen
  ErrNr = SetBrush(Dev, HV.ColVal(8), 0)

End Sub

Sub PrepareWindowOutput()

  If HMCrt.hDev <> 0 Then Stop

  'Put Window on top (ausser beim Blinken)
  '  beim Blinken: 1. nicht ntig, 2. strt andere Anwendungen
  If Not HV.BlinkFlag Then
    Call SetTop(HmForm.hWnd, True)
  End If

  'Karte aktualisieren
  'MapForm.Refresh

  'Output to Window
  MapForm.AutoRedraw = False

End Sub

Function SetBrush(Dev As HMDevice, ByVal Col As Long, FillStyle)

  Dim lBrush As LOGBRUSH

  Dim NewObj As Long
  Dim OldObj As Long

  If Dev.hDev = 0 Then Stop

  If Dev.MonoChrome Then
    If Col <> HV.BackCol Then Col = HV.ForeCol
  End If

  If Dev.BrushColor <> Col Or Dev.BrushStyle <> FillStyle _
    Or Dev.VbBrush = 0 Then

    lBrush.lbColor = Col
    lBrush.lbStyle = FillStyle
    NewObj = CreateBrushIndirect(lBrush)

    'select new Brush into Device Context
    OldObj = SelectObject(Dev.hDev, NewObj)
    'ErrNr = (OldObj = 0)

    'delete old Brush object
    If Dev.VbBrush = 0 Then
      Dev.VbBrush = OldObj
    Else
      Ok = DeleteObject(OldObj)
    End If

    Dev.BrushColor = Col
    Dev.BrushStyle = FillStyle

  End If

End Function

Function SetFont(Dev As HMDevice, NewFont As HMFont)

  Dim NewObj As Long
  Dim OldObj As Long

  Dim ApiFont As LOGFONT
  Dim PhysFont As TEXTMETRIC
  Dim r As RECT

  If Dev.hDev = 0 Then Stop

  'Prfen ob erster Font oder Font gendert wird
  c1 = NewFont.Name <> Dev.ActFont.Name
  c2 = NewFont.Size <> Dev.ActFont.Size
  c3 = NewFont.Attr <> Dev.ActFont.Attr
  C4 = NewFont.Angle <> Dev.ActFont.Angle

  If c1 Or c2 Or c3 Or C4 Or Dev.VbFont = 0 Then

    'create new Font object
    Call HMFont2LogFont(Dev, NewFont, ApiFont)

    NewObj = CreateFontIndirect(ApiFont)
    'ErrNr = (NewObj = 0)

    'select new Font into Device Context
    OldObj = SelectObject(Dev.hDev, NewObj)
    'ErrNr = (OldObj = 0)

    'Save old VB-Font / delete old Font object
    If Dev.VbFont = 0 Then
      Dev.VbFont = OldObj
    Else
      Ok = DeleteObject(OldObj)
    End If

    Ok = GetTextMetrics(Dev.hDev, PhysFont)

    Dev.PhysFont.TrueType = (PhysFont.tmPitchAndFamily And TMPF_TRUETYPE) <> 0

    Dev.PhysFont.CellHeight = DrawText(Dev.hDev, "M", 1&, r, DT_CALCRECT + DT_SINGLELINE)
    Dev.PhysFont.MaxCharWidth = r.Right

    Dev.ActFont = NewFont

  End If

End Function

Function SetPen(Dev As HMDevice, NewPen As HMPen)

  Dim NewObj As Long
  Dim OldObj As Long

  If Dev.hDev = 0 Then Stop

  ForeCol& = NewPen.Color

  If Dev.MonoChrome Then
    If ForeCol& <> HV.BackCol Then ForeCol& = HV.ForeCol
  End If

  If Dev.ActPen.Color <> ForeCol& Or Dev.ActPen.Width <> NewPen.Width _
    Or Dev.ActPen.Style <> NewPen.Style Or Dev.VbPen = 0 Then

    'create new Pen object
    NewObj = CreatePen(NewPen.Style, NewPen.Width, ForeCol&)
    'ErrNr = (NewObj = 0)

    'select new Pen into Device Context
    OldObj = SelectObject(Dev.hDev, NewObj)
    'ErrNr = (OldObj = 0)

    'delete old Pen object
    If Dev.VbPen = 0 Then
      Dev.VbPen = OldObj
    Else
      Ok = DeleteObject(OldObj)
    End If

    Dev.ActPen = NewPen

  End If

End Function

Function TerminateAllDevices()

  If HV.ExecOverlay Then Exit Function

  If HV.PrtEnbl And 2 Then
    '--- Printer ---
    ErrNr = TerminateDevice(HMPrt)
    If HV.PrtEnbl And 4 Then
      frmPrtSim.Refresh
    End If
  End If


  If HV.PrtEnbl And 1 Then
    '--- Screen ---
    ErrNr = TerminateDevice(HMCrt)

    If NumPar(46).Actual And MF_BackGnd Then
      'Ausgabe im Hintergrund
      If Not HV.Scrolling Then
        'For scrolling update only when map is completed
        MapForm.Refresh
      End If
    Else
      'Ausgabe im Window (Vordergrund)
      ErrNr = TerminateWindowOutput()
    End If

    'Enable Map- und TipTimer
    If HMCrt.BlinkEnbl Then MapForm.BlinkTimer.Enabled = True
    If HMCrt.TipEnbl Then MapForm.TipTimer.Enabled = True

    If HV.MouseFunctionMode > 0 Then
      MapForm.MousePointer = 99
      MapForm.Refresh
      DoEvents
    End If

  End If

End Function

Function TerminateDevice(Dev As HMDevice)

  If Dev.hDev = 0 Then Stop
  If Dev.VbDev = 0 Then Stop

  Dim OldObj As Long


  Ok& = GdiFlush&()       'Complete all drawing operations

  Erase SegPnts

  If Dev.VbFont <> 0 Then
    'restore VB Font into Device Context
    OldObj = SelectObject(Dev.hDev, Dev.VbFont)
    'ErrNr = (OldObj = 0)

    'delete old Font object
    Ok = DeleteObject(OldObj)
    Dev.VbFont = 0
  End If


  If Dev.VbBrush <> 0 Then
    'restore VB Brush into Device Context
    OldObj = SelectObject(Dev.hDev, Dev.VbBrush)
    'ErrNr = (OldObj = 0)

    'delete old Brush object
    Ok = DeleteObject(OldObj)
    Dev.VbBrush = 0
  End If


  If Dev.VbPen <> 0 Then
    'restore VB Pen into Device Context
    OldObj = SelectObject(Dev.hDev, Dev.VbPen)
    'ErrNr = (OldObj = 0)

    'delete old Pen object
    Ok = DeleteObject(OldObj)
    Dev.VbPen = 0
  End If


  'restore Device Context state
  Ok = RestoreDC(Dev.hDev, Dev.VbDev)

  Dev.hDev = 0
  Dev.VbDev = 0

End Function

Function TerminateWindowOutput()

  Dim FrmDC As Long

  If HMCrt.hDev <> 0 Then Stop

  'Tip und Fadenkreuzcursor nicht mitkopieren
  Call EnblMapControls(False)

  '------- Copy Window to persistent bitmap (auer beim Blinken)
  'beim Blinken: 1. nicht ntig, 2. Drop-Down Mens wrden mitkopiert
  If HV.BlinkFlag Then
    MapForm.AutoRedraw = True
  Else
    FrmDC = MapForm.hDC
    MapForm.AutoRedraw = True
    x1 = HMCrt.DrawRect.Left
    y1 = HMCrt.DrawRect.Top
    w = HMCrt.DrawWidth
    h = HMCrt.DrawHeight
    Ok = BitBlt(MapForm.hDC, x1, y1, w, h, FrmDC, x1, y1, SRCCOPY)
    If Ok = 0 Then MsgBox "BitBlt Error"

    Call SetTop(HmForm.hWnd, False)
  End If

  'Tip und Fadenkreuzcursor wiederherstellen
  Call EnblMapControls(True)

  TerminateWindowOutput = (Ok = 0)

End Function

