Attribute VB_Name = "GeoLib"
'--------------------------- GEOLIB.BAS ------------------------

DefInt A-Z



'QTH-Locator
' 18 Groesstfelder (Field)         A...R: E-W je 20   - N-S je 10
' 10 Grossfelder (Squares)         0...9: E-W je 2    - N-S je 1
' 24 Kleinfelder (Sub-squares)     A...X: E-W je 5'    - N/S je 2,5'
' 10 Mikrofelder (Sub-sub-squares) 0...9: E-W je 30"   - N/S je 15"
' 25 ...felder                     A...Y: E-W je 1,2"  - N/S je 0,6"
' 10 ...felder                     0...9: E-W je 0,12" - N/S je 0,06"

Function dDegCoord2DegStr$(ByVal c As Double, ByVal AnzFields, ByVal AnzNull, ByVal Fmt)

  'Input:  c Koordinate in Grad
  '        AnzFields = Anzahl Felder (1=Grad, 2=Grad:Min, 3=Grad:Min:Sec)
  '        AnzNull   = Anzahl Nachkommastellen
  '        Fmt       = Format (0=use sign, 1=append N/S, 2=append O/W)

  Dim cabs As Long
  Dim f As Long

  If c < 0 Then vz$ = "-" Else vz$ = ""

  If AnzNull = 0 Then
    NullStr$ = ""
  Else
    NullStr$ = "." & String$(AnzNull, "0")
  End If

  f = 10 ^ AnzNull
  cabs = Abs(c) * (60 ^ (AnzFields - 1)) * f

  Select Case AnzFields
  Case 1
    s$ = Format$(cabs / f, "0" & NullStr$)
  Case 2
    Mins& = cabs Mod (60 * f)
    Grds& = cabs \ (60 * f)
    s$ = Format$(Grds&, "0") & ":" & Format$(Mins& / f, "00" & NullStr$)
  Case 3
    Secs& = cabs Mod (60 * f)
    cabs = cabs \ (60 * f)
    Mins& = cabs Mod 60
    Grds& = cabs \ 60
    s$ = Format$(Grds&, "0") & ":" & Format$(Mins&, "00") & ":" _
       & Format$(Secs& / f, "00" & NullStr$)
  End Select

  If Fmt = 0 Then
    dDegCoord2DegStr$ = vz$ & s$
  Else
    NOSW$ = Msg$(40200)
    If c > 0 Then
      dDegCoord2DegStr$ = s$ & " " & Mid$(NOSW$, Fmt, 1)
    ElseIf c = 0 Then
      dDegCoord2DegStr$ = s$
    Else
      dDegCoord2DegStr$ = s$ & " " & Mid$(NOSW$, Fmt + 2, 1)
    End If
  End If

End Function

Function dDegCoord2Qth(dP As dGeoPoint, Qth$)

  'Input: Lnge und Breite in Grad
  'Output: Locator 12-stellig

  Const deg1 = 60& * 60 * 50    'Rechnung in 1/50 sec

  dCoord2Qth = True

  Qth$ = ""

  If dP.l < -180 Or dP.l > 180 Then Exit Function
  If dP.b < -90 Or dP.b > 90 Then Exit Function

  dx& = 360& * deg1                           '360
  x1& = Int((dP.l + 180) * deg1)              '"A" = -180 (West)
  If x1& >= dx& Then x1& = dx& - 1            '180
  y1& = Int((dP.b + 90) * deg1)               '"A" =  -90 (Sd)
  If y1& >= dx& \ 2 Then y1& = dx& \ 2 - 1    '90

  For i = 1 To 6
    MinCh = Asc(Mid$(QthMinChr$, i, 1))
    MaxCh = Asc(Mid$(QthMaxChr$, i, 1))

    dx& = dx& \ (MaxCh - MinCh + 1)              'Feldbreite
    dy& = dx& \ 2                                'Feldhhe

    Qth$ = Qth$ + Chr$(x1& \ dx& + MinCh)
    Qth$ = Qth$ + Chr$(y1& \ dy& + MinCh)

    x1& = x1& Mod dx&
    y1& = y1& Mod dy&
  Next i

  dCoord2Qth = False

End Function

Function DistToMsg$(ByVal Dist As Single, ByVal Mode)

  Select Case Mode
  Case 0    'km
    f! = 1!
  Case 1    'Meilen
    f! = 1.609
  Case 2    'Seemeilen
    f! = 1.85228
  Case Else
    Stop
  End Select

  If Dist >= 10 Then
    Fmt$ = "#,##0"
  Else
    Fmt$ = "#,##0.0"
  End If

  DistToMsg$ = Format$(Dist / f!, Fmt$)

End Function

Function km2miles(ByVal km As Double, ByVal units) As Double

  Select Case units
  Case 0    'km
    km2miles = km
  Case 1    'Landmeilen = statute miles
    km2miles = km / 1.60934
  Case 2    'Seemeilen = nautical miles
    km2miles = km / 1.852
  Case Else
    Stop
  End Select

End Function

Function lCoord2Str$(c&, Fmt)

  'Input:  c& in Sekunden
  'Output: [-][g]gg:mm:ss

  If Fmt = 0 Then

    If c& < 0 Then Sg$ = "-" Else Sg$ = ""
    cabs& = Abs(c&)

    For i = 1 To 2
      s$ = ":" + Format$(cabs& Mod 60, "00") + s$
      cabs& = cabs& \ 60
    Next i

    lCoord2Str$ = Sg$ + Format$(cabs&, "00") + s$

  Else

    lCoord2Str$ = Format$(c& / 3600, "0." & String$(Fmt, "0"))

  End If

End Function

Function lSecCoord2Msg$(c As Long, AnzFields, Direct)

  'Direct: 0=none, 1=N-S, 2=O-W

  AnzNulls = 2 * (3 - AnzFields)

  lSecCoord2Msg$ = dDegCoord2DegStr$(CDbl(c * cfSec2Deg), AnzFields, AnzNulls, Direct)

End Function

Function lSecCoord2StrEx$(c As Long, AnzFields)

  AnzNulls = 2 * (3 - AnzFields)

  lSecCoord2StrEx$ = dDegCoord2DegStr$(CDbl(c * cfSec2Deg), AnzFields, AnzNulls, 0)

End Function

Function Qth2dDegArea(Qth$, dP1 As dGeoPoint, dP2 As dGeoPoint)

  Qth2dDegArea = Qth2lMsecArea(Qth$, x1&, y1&, x2&, y2&)

  dP1.l = x1& * cdMsec2Deg
  dP1.b = y1& * cdMsec2Deg

  dP2.l = x2& * cdMsec2Deg
  dP2.b = y2& * cdMsec2Deg

End Function

Function Qth2dDegCoord(Qth$, dP As dGeoPoint)

  'Output in Grad

  Qth2dDegCoord = Qth2lMsecCoord(Qth$, xm&, ym&)

  dP.l = xm& * cdMsec2Deg
  dP.b = ym& * cdMsec2Deg

End Function

Function Qth2lMsecArea(Qth$, x1&, y1&, x2&, y2&)

  'Output in 1/1000 sec (milli-seconds = ms)

  Const deg1 = 60& * 60 * 1000      'Rechnung in 1/1000 sec

  Qth2lMsecArea = True     'Format error for Exit Function

  Qth$ = UCase$(Trim$(Qth$))
  l = Len(Qth$)

  If l < 2 Or l > 12 Or l Mod 2 = 1 Then Exit Function

  dx& = 360& * deg1          'Anfangs-Feldbreite = 360
  x1& = -180& * deg1         '"A" = -180 (West)
  y1& = -90& * deg1          '"A" =  -90 (Sd)

  For i = 1 To l \ 2
    xCh = Asc(Mid$(Qth$, 2 * i - 1, 1))
    yCh = Asc(Mid$(Qth$, 2 * i, 1))

    MinCh = Asc(Mid$(QthMinChr$, i, 1))
    MaxCh = Asc(Mid$(QthMaxChr$, i, 1))

    If xCh < MinCh Or xCh > MaxCh Then Exit Function
    If yCh < MinCh Or yCh > MaxCh Then Exit Function

    dx& = dx& \ (MaxCh - MinCh + 1)               'Feldbreite
    dy& = dx& \ 2                                 'Feldhhe

    x1& = x1& + dx& * (xCh - MinCh)
    y1& = y1& + dy& * (yCh - MinCh)
  Next i

  x2& = x1& + dx&
  y2& = y1& + dy&

  Qth2lMsecArea = False    'ok

End Function

Function Qth2lMsecCoord(Qth$, xm&, ym&)

  'Output in 1/1000 sec (milli-seconds = ms)

  Qth2lMsecCoord = Qth2lMsecArea(Qth$, x1&, y1&, x2&, y2&)

  xm& = (x1& + x2&) \ 2
  ym& = (y1& + y2&) \ 2

End Function

Function Qth2lSecArea(Qth$, x1&, y1&, x2&, y2&)

  Qth2lSecArea = Qth2lMsecArea(Qth$, x1&, y1&, x2&, y2&)

  x1& = x1& / 1000
  y1& = y1& / 1000
  x2& = x2& / 1000
  y2& = y2& / 1000

End Function

Function Qth2lSecCoord(Qth$, xm&, ym&)

  'Output in seconds

  Qth2lSecCoord = Qth2lMsecArea(Qth$, x1&, y1&, x2&, y2&)

  xm& = (x1& + x2&) \ 2000
  ym& = (y1& + y2&) \ 2000

End Function

Function QthAngle(degP1 As dGeoPoint, degP2 As dGeoPoint) As Double

  'Antennenrichtung fr Verbindung zwischen P1 und P2 am Ort P1 berechnen
  Dim radP1 As dGeoPoint, radP2 As dGeoPoint
  Dim degdl As Double, raddl As Double
  Dim degdb As Double
  Dim ctgAngle As Double, Angle As Double

  radP1.b = degP1.b * deg2rad
  radP2.b = degP2.b * deg2rad
  degdl = degP2.l - degP1.l
  raddl = degdl * deg2rad
  degdb = degP2.b - degP1.b

  If degP1.b <= -90# Or degP2.b >= 90# Then

    'Station 1 am Sdpol oder Station 2 am Nordpol -> immer nach Norden
    Angle = 0#

  ElseIf degP1.b >= 90# Or degP2.b <= -90# Then

    'Station 1 am Nordpol oder Station 2 am Sdpol -> immer nach Sden
    Angle = 180#

  Else

    Select Case Abs(degdl)
    Case 0#     'gleiche Lnge
      If degdb = 0# Then
        'gleiche Breite -> gleicher Standort
        Angle = 0#
      Else
        'Richtung nach Norden oder Sden
        If degdb > 0# Then Angle# = 0# Else Angle# = 180#
      End If

    Case 180#   'auf Erdkugel entgegengesetzt
      If degP1.b + degP2.b > 0 Then Angle# = 0# Else Angle# = 180#

    Case Else
      On Error Resume Next
      'Lsung nach Bronstein - Taschenbuch der Mathematik, 7. Auflage - 1967, S. 164 - Formel (4)
      'N=Nordpol, L=Lnge, B=Breite
      'a=Strecke(N:P1)=Pi/2-B1; b=Strecke(N:P2)=Pi/2-B2; C=Winkel(N:P1,N:P2)=L2-L1
      'gesucht: B=Winkel(P1:N,P1:P2)=Angle
      'Sin(a) * Ctg(b) = Ctg(B) * Sin(C) + Cos(a) * Cos(C)
      'Ctg(B) = (Sin(a) * Ctg(b) - Cos(a) * Cos(C)) / Sin(C)
      'mit ctg(x)=tan(Pi/2-x); ctg(x)=1/tan(x); cos(HalfPi-x)=sin(x); sin(HalfPi-x)=cos(x)
      'Ctg(Angle) = (Sin(Pi/2-B1) * Ctg(Pi/2-B2) - Cos(Pi/2-B1) * Cos(L2-L1)) / Sin(L2-L1)
      ctgAngle = (Cos(radP1.b) * Tan(radP2.b) - Sin(radP1.b) * Cos(raddl)) / Sin(raddl)
      If Err = 0 Then Angle = (HalfPi - Atn(ctgAngle)) * rad2deg
      If degdl < 0# Xor Abs(degdl) > 180# Then Angle = 180# + Angle
      If Err Then Angle = 0#
      On Error GoTo 0
    End Select
  End If

  QthAngle = Angle

End Function

Function QthDist(degP1 As dGeoPoint, degP2 As dGeoPoint) As Double

  'Entfernung fr Verbindung zwischen P1 und P2
  Dim radP1 As dGeoPoint, raddl As Double
  Dim degAngle1 As Double, radAngle1 As Double
  Dim degDist As Double, ctgDist As Double

  raddl = (degP2.l - degP1.l) * deg2rad
  radP1.b = degP1.b * deg2rad

  If degP1.l = degP2.l Or Abs(degP1.b) = 90# Or Abs(degP2.b) = 90# Then

    'gleiche Lnge oder 1 Station an einem Pol
    QthDist = Abs(degP1.b - degP2.b) * deg2rad * EarthRad

  ElseIf Abs(degP1.l - degP2.l) = 180# Then

    'Stationen auf Erdkugel entgegengesetzt
    degDist = Abs(degP1.b + degP2.b - 180#)
    If degDist > 180# Then degDist = 360# - degDist
    QthDist = degDist * deg2rad * EarthRad

  Else

    degAngle1 = QthAngle(degP1, degP2)
    If degAngle1 = 0# Then
      'Winkel = 0 -> gleicher Punkt -> Entfernung = 0
      QthDist = 0#
    Else
      radAngle1 = degAngle1 * deg2rad
      On Error Resume Next
      'Lsung nach Bronstein - Taschenbuch der Mathematik, 7. Auflage - 1967, S. 164 (5)
      'N=Nordpol, L=Lnge, B=Breite
      'c=Strecke(N:P1)=Pi/2-B1; B=Winkel(N:P1,N:P2)=L2-L1; A=Winkel(P1:N,P1:P2)=Angle1
      'gesucht: b=Strecke(P1:P2)=Dist
      'Sin(A) * Ctg(B) = Ctg(b) * Sin(c) - Cos(A) * Cos(c)
      'Ctg(b) = (Sin(A) * Ctg(B) + Cos(A) * Cos(c)) / Sin(c)
      'Ctg(Dist) = (Sin(Angle1) * Ctg(L2 - L1) + Cos(Angle1) * Cos(Pi/2 - B1)) / Sin(Pi/2 - B1)
      ctgDist = (Sin(radAngle1) / Tan(raddl) + Cos(radAngle1) * Sin(radP1.b)) / Cos(radP1.b)
      If Err = 0 Then QthDist = (HalfPi - Atn(ctgDist)) * EarthRad
      If Err Then QthDist = 0#
      On Error GoTo 0
    End If

  End If

End Function

Function Str2Dbl(ByVal s$, d#)

  s$ = Unformat$(s$)

  On Error Resume Next
  d# = CDbl(Val(s$))
  ErrNr = Err
  On Error GoTo 0

  Str2Dbl = ErrNr <> 0

End Function

Function Str2dDegCoord(ByVal s$, c#, Direct)

  'String DMS$ in Grad, Minuten und Sekunden zerlegen
  'DMS$-Format: dd{| } [mm{'| } [ss["] ] ]
  '  dd=degree(Grad); mm=Minutes;  ss=Seconds

  'Direct: 1=N/S, 2=O/W

  Str2dDegCoord = True

  s$ = UCase$(Trim$(Replace$(s$, ",", ".")))
  c# = 1

  Select Case Right$(s$, 1)
  Case ".", ":"
    s$ = Trim$(Left$(s$, Len(s$) - 1))
  End Select

  If Direct < 1 Or Direct > 2 Then Stop
  NOSW$ = Msg$(40200)
  NO$ = Mid$(NOSW$, Direct, 1)
  SW$ = Mid$(NOSW$, Direct + 2, 1)

  Select Case Right$(s$, 1)
  Case NO$
    s$ = Trim$(Left$(s$, Len(s$) - 1))
  Case SW$
    c# = -1
    s$ = Trim$(Left$(s$, Len(s$) - 1))
  Case "0" To "9"
    'Vorangestellt
    Select Case Left$(s$, 1)
    Case NO$
      s$ = Trim$(Mid$(s$, 2))
    Case "-", SW$
      c# = -1
      s$ = Trim$(Mid$(s$, 2))
    Case "0" To "9"
    Case Else
      Exit Function       'Error
    End Select
  Case Else
    Exit Function       'Error
  End Select

  'Delimiter auf " " normieren
  s$ = Replace$(s$, Chr$(248), "")    'DOS-Grd -> Win-Grd
  c1 = InStr(s$, "")
  c2 = InStr(s$, "'")
  If c1 > 0 Or c2 > 0 Then
    'Wenn  oder ' vorkommt, mssen beide vorhanden sein
    If c1 = 0 Or c2 = 0 Then Exit Function
    s$ = Replace$(s$, "", ":")
    s$ = Replace$(s$, "'", ":")
    s$ = Replace$(s$, """", ":")
  End If

  s$ = Replace$(s$, ":", " ")

  'String in Grad, Miniten, Sekunden zerlegen
  grd$ = Parse$(s$, " ")
  Min$ = Parse$(s$, " ")
  sec$ = Parse$(s$, " ")
  If Len(s$) > 0 Then Exit Function
  If Val(Min$) >= 60 Or Val(sec$) >= 60 Then Exit Function

  If Len(Min$) = 0 And Len(sec$) = 0 Then
    'Nur Grad angegeben
    g2$ = grd$
    g1$ = Parse$(g2$, ".")
    l = Len(g1$)
    If l >= 5 Then
      '[[g]g]gmmss[.s...]
      sec$ = Right$(g1$, 2) + "." + g2$
      Min$ = Mid$(g1$, l - 3, 2)
      grd$ = Left$(g1$, l - 4)
    End If
  ElseIf Len(sec$) = 0 Then
    'Nur Grad und Minuten angegeben
    m2$ = Min$
    m1$ = Parse$(m2$, ".")
    l = Len(m1$)
    If l >= 3 Then
      '[[g]g]g:[m]mss[.s...]
      sec$ = Right$(m1$, 2) + "." + m2$
      Min$ = Left$(m1$, l - 2)
    End If
  End If

  If Val(grd$) > 180 Or Val(Min$) > 60 Or Val(sec$) > 60 Then Exit Function
  c# = c# * (Val(grd$) + (Val(Min$) + Val(sec$) / 60#) / 60#)

  Str2dDegCoord = False

End Function

