Attribute VB_Name = "GPMAPSUB"
'---------------------------- GPMAPSUB.BAS ----------------------------

'von Gerhard Berg, DJ6FM

DefInt A-Z
'

Sub devPoint2degPoint(Dev As HMDevice, DevPoint As PointApi, degPoint As dGeoPoint)

  'Umrechnung von absoluten Bildschirmkoordinaten (Pixel)
  '   in geographische Koordinaten (Grad)

  'xgeo - xgeomin      xgeomax - xgeomin
  '----------------- = -----------------
  'xdev - xdevmin      xdevmax - xdevmin

  'ygeo - ygeomin    ygeomax - ygeomin
  '--------------- = ------------------
  'ydevmin - ydev    ydevmax - ydevmin

  degPoint.l = (MV.ActMapArea.lxmin + (DevPoint.x - Dev.MapRect.Left) * Dev.SecPerPixelX) * cfSec2Deg
  degPoint.b = (MV.ActMapArea.lymin + (Dev.MapRect.Bottom - 1 - DevPoint.y) * Dev.SecPerPixelY) * cfSec2Deg

End Sub

Sub devPoint2secPoint(Dev As HMDevice, DevPoint As PointApi, secPoint As lPoint)

  'Umrechnung von absoluten Bildschirmkoordinaten (Pixel)
  '   in geographische Koordinaten (Sekunden)

  'xgeo - xgeomin      xgeomax - xgeomin
  '----------------- = -----------------
  'xdev - xdevmin      xdevmax - xdevmin

  'ygeo - ygeomin    ygeomax - ygeomin
  '--------------- = ------------------
  'ydevmin - ydev    ydevmax - ydevmin

  secPoint.x = MV.ActMapArea.lxmin + (DevPoint.x - Dev.MapRect.Left) * Dev.SecPerPixelX
  secPoint.y = MV.ActMapArea.lymin + (Dev.MapRect.Bottom - 1 - DevPoint.y) * Dev.SecPerPixelY

End Sub

Sub larea2Rect(Dev As HMDevice, a As lAreaType, Offset, r As RECT)

  r.Left = SecGeo2AbsX(Dev, a.lxmin) - Offset
  r.Top = SecGeo2AbsY(Dev, a.lymax) - Offset
  r.Right = SecGeo2AbsX(Dev, a.lxmax) + 1 + Offset
  r.Bottom = SecGeo2AbsY(Dev, a.lymin) + 1 + Offset

End Sub

Function PropWidth(ByVal ymax&, ByVal ymin&) As Long

  If ymax& = ymin& Then
    PropWidth = 0
  Else
    ym! = (ymax& + ymin&) / 2
    f! = HV.ScreenAspect * Cos(ym! * cfSec2Rad) 'f! = h / w
    PropWidth = (ymax& - ymin&) / f!            'Breite w = h / f
  End If

End Function

Sub Rect2lArea(Dev As HMDevice, r As RECT, Offset, a As lAreaType)

  Dim pabs As PointApi
  Dim pgeo As lPoint

  'links oben
  pabs.x = r.Left + Offset
  pabs.y = r.Top + Offset
  Call devPoint2secPoint(Dev, pabs, pgeo)
  a.lxmin = pgeo.x
  a.lymax = pgeo.y

  'rechts unten
  pabs.x = r.Right - 1 - Offset
  pabs.y = r.Bottom - 1 - Offset
  Call devPoint2secPoint(Dev, pabs, pgeo)
  a.lxmax = pgeo.x
  a.lymin = pgeo.y

End Sub

Function SecGeo2AbsX(Dev As HMDevice, xgeo As Long) As Long

  'Umrechnung von geographischen Koordinaten (Sekunden)
  '   in absolute Bildschirmkoordinaten (Pixel)

  'xgeo - xgeomin      xgeomax - xgeomin
  '----------------- = -----------------
  'xabs - xabsmin      xabsmax - xabsmin

  On Error Resume Next
  SecGeo2AbsX = Dev.MapRect.Left + (xgeo - MV.ActMapArea.lxmin) * Dev.PixelPerSecX
  If Err Then SecGeo2AbsX = -9999
  On Error GoTo 0

End Function

Function SecGeo2AbsY(Dev As HMDevice, ygeo As Long) As Long

  'ygeo - ygeomin    ygeomax - ygeomin
  '--------------- = ------------------
  'yabsmin - yabs    yabsmax - yabsmin

  On Error Resume Next
  SecGeo2AbsY = Dev.MapRect.Bottom - 1 - (ygeo - MV.ActMapArea.lymin) * Dev.PixelPerSecY
  If Err Then SecGeo2AbsY = -9999
  On Error GoTo 0

End Function

Function secPoint2devPoint(Dev As HMDevice, secPoint As lPoint, DevPoint As PointApi)

  'Umrechnung von geographischen Koordinaten (Sekunden)
  '   in absolute Bildschirmkoordinaten (Pixel)

  'xgeo - xgeomin      xgeomax - xgeomin
  '----------------- = -----------------
  'xdev - xdevmin      xdevmax - xdevmin

  'ygeo - ygeomin    ygeomax - ygeomin
  '--------------- = ------------------
  'ydevmin - ydev    ydevmax - ydevmin

  On Error Resume Next
  DevPoint.x = Dev.MapRect.Left + (secPoint.x - MV.ActMapArea.lxmin) * Dev.PixelPerSecX
  If Err = 0 Then
    DevPoint.y = Dev.MapRect.Bottom - 1 - (secPoint.y - MV.ActMapArea.lymin) * Dev.PixelPerSecY
  End If
  secPoint2devPoint = Err
  On Error GoTo 0

End Function

