Attribute VB_Name = "GpsFnc"
DefInt A-Z

Sub FileFunctions(Index)

  Select Case Index
  Case 0
    Call appQuit
  Case Else
    Stop
  End Select

End Sub

Sub GarminFunctions(Index)

  Select Case Index
  Case 0
    Call GetProductData
  Case 1
    Call XmitCommand(ACK)
  Case 2
    Call XmitCommand(NAK)
  End Select

End Sub

Function GetComSettings(Title$)

  Call CenterForm(frmComOpt)

  With frmComOpt
    .Caption = Title$

    'Garmin Speed
    .Lbl(6).Visible = GV.DesignMode
    .cboGarmin.Visible = GV.DesignMode


    '--- COM-Port ---
    With .cboPort
      ' Load Port Settings
      .AddItem "OffLine"
      For i = 1 To 16
        .AddItem "Com" & CStr(i)
      Next i
    End With
    .cboPort.ListIndex = NumPar(1).Actual


    '--- Default Settings ---
    Settings$ = StrPar$(3, 7)
    Baud$ = Parse$(Settings$, ",")
    Parity$ = UCase$(Parse$(Settings$, ","))
    DataBits$ = Parse$(Settings$, ",")
    StopBits$ = Settings$

    'Baud-Rate
    'Call AddStrItems(.cboSpeed, "110|300|600", "")
    Call AddStrItems(.cboSpeed, "1200|2400|4800|9600|14400|19200", "")
    'Call AddStrItems(.cboSpeed, "28800|38400|56000|57600|115200|128000|256000", "")
    Call SetComboText(.cboSpeed, Baud$)

    'Parity
    Call AddStrItems(.cboParity, "None|Even|Odd|Mark|Space", "")
    .cboParity.ListIndex = InStr("NEOMS", Parity$) - 1

    'Data Bits
    Call AddStrItems(.cboDataBits, "4|5|6|7|8", DataBits$)

    'Stop Bits
    Call AddStrItems(.cboStopBits, "1|1.5|2", StopBits$)

    'Handshake
    Call AddMsgItems(.Handshake, 47000, NumPar(19).Actual)


    .DTREnable.Value = NumPar(9).Actual
    .RtsEnable.Value = NumPar(10).Actual
    .txtTimeOut.text = Format$(NumPar(11).Actual / 1000, "0")


    '--- Settings eingeben ---
    .Show 1

    Cancel = Val(.Tag)

    If Not Cancel Then
      NumPar(1).Actual = .cboPort.ListIndex

      Parity$ = Mid$("NEOMS", .cboParity.ListIndex + 1, 1)
      StrPar(3, 7) = Trim$(.cboSpeed.text) & "," & Parity$ & "," _
        & Trim$(.cboDataBits.text) & "," & Trim$(.cboStopBits.text)

      NumPar(19).Actual = .Handshake.ListIndex
      NumPar(9).Actual = .DTREnable.Value
      NumPar(10).Actual = .RtsEnable.Value
      NumPar(11).Actual = Val(.txtTimeOut.text * 1000)
    End If

  End With

  Unload frmComOpt
  Set frmComOpt = Nothing

  GetComSettings = Cancel

End Function

Sub GetDisplayOptions(Title$)

  ErrNr = InitMaskData(3, Title$, "")
  If ErrNr Then Exit Sub

  If NumPar(16).Actual = 9999 Then
    DefPar& = 0&
  Else
    DefPar& = NumPar(16).Actual
  End If

  Call SetMaskData(1, Msg$(46120), CStr(DefPar& / 2), "", "-24", "24")
  Call SetMaskData(2, Msg$(46121), CStr(NumPar(17).Actual), "@46100", "", "")
  Call SetMaskData(3, Msg$(46122), CStr(NumPar(18).Actual), "@40032", "", "")

  Cancel = GetMaskInput(0&, Change&)
  If Not Cancel Then
    NumPar(16).Actual = Val(Unformat$(GetMaskData(1))) * 2
    NumPar(17).Actual = Val(GetMaskData(2))
    NumPar(18).Actual = Val(GetMaskData(3))
  End If

End Sub

Sub GetHmOptions(Title$)

  Const AnzFields = 4
  Const Offset = 3

  ErrNr = InitMaskData(AnzFields, Title$, "")

  For i = 1 To AnzFields
    npar = i + Offset
    If i = 1 Then f = 1000 Else f = 1
    MaskData(i, 1) = Msg$(46130 + i)       'Prompt
    MaskData(i, 2) = CStr(NumPar(npar).Actual / f)    'Default
    If NumPar(npar).Max > 0& Then
      MaskData(i, 5) = CStr(NumPar(npar).Min / f)     'Min
      MaskData(i, 6) = CStr(NumPar(npar).Max / f)     'Max
    End If
  Next i

  Cancel = GetMaskInput(0, Change&)

  If Change& Then
    NumPar(1 + Offset).Actual = Val(Unformat$(GetMaskData(1))) * 1000
    For i = 2 To AnzFields
      NumPar(i + Offset).Actual = Val(Unformat$(GetMaskData(i)))
    Next i
  End If

  Call EraseMaskData

  HMFirstTime = 0

End Sub

Sub GetSimData(Title$, Change&)

  Const AnzFields = 6

  ErrNr = InitMaskData(AnzFields, Title$, Msg$(46200))
  If Err Then Exit Sub

  For i = 1 To AnzFields
    Call SetMaskData(i, Msg$(46110 + i), StrPar(3, i), "", "", "")
  Next i

  Do
    Cancel = GetMaskInput(0, Change&)
    If Cancel Then
      Erase MaskData
      Exit Sub
    End If

    For i = 1 To 2
      m$ = GetMaskData(i)
      ErrNr = Str2dDegCoord(m$, bl#, i)
      If ErrNr Then
        MsgBox "Ungltiges Format " & Parse$(Msg$(46110 + i), "[") & ": '" & m$ & "'"
      End If
    Next i
  Loop Until ErrNr = 0

  If Change& Then
    For i = 1 To AnzFields
      StrPar(3, i) = GetMaskData(i)
    Next i
  End If

  Call EraseMaskData

End Sub

Sub GpsFunctions(Index)

  Title$ = ProgName$ & "  -  " & StdMsg$(46040 + Index)

  If Index >= 7 Then
    OldPause = gblPause
    Call SetPause(True)
  End If

  Select Case Index
  Case 0 To 3       'GPS-Anzeige
    Call InitTable(Index + 1)

  Case 5            'Systemzeit setzen
    Call SetSystemTime

  Case 7            'Einstellungen COM-Port
    void = GetComSettings(Title$)

  Case 8            'Einstellungen Anzeige
    Call GetDisplayOptions(Title$)

  Case 10           'Simulation beginnen / Beenden
    Call EnblSim(Not gblSimulation)
    If gblSimulation Then OldPause = False    'Start Simulation

  Case 11           'Simulationsdaten
    Call GetSimData(Title$, Change&)
    If Change& Then
      Call SetParameter     'Set SimTimer

      If gblSimulation Then
        'Force new start of simulation with new data
        Call EnblSim(False)
        Call EnblSim(True)
      End If

    End If
  Case Else
    Stop
  End Select

  If Index >= 7 Then
    Call SetPause(OldPause)
  End If

End Sub

Sub GpsShowAbout()

  OldPause = gblPause
  Call SetPause(True)

  MsgBox GetAbout$("GPS-Interface fr HAMMAP")

  Call SetPause(OldPause)

End Sub

Sub HammapFunctions(Index)

  Title$ = ProgName$ & "  -  " & StdMsg$(46080 + Index)

  OldPause = gblPause
  Call SetPause(True)

  Select Case Index
  Case 0          'Mit HAMMAP verbinden
    If GV.HammapConnected Then
      Call HMDisconnect
    Else
      void = appHMConnect()
    End If

    Call CheckHmMenu     'Set Checked in Menu


  Case 2          'Kartenausschnitt zentrieren
    ErrNr = GoUpdateHAMMAP()

  Case 3, 4       'Kartenausschnitt fortlaufend zentrieren / Weg einzeichnen
    If HMFunction = 0 Then
      HMFirstTime = 0
      HMFunction = Index - 2    '1 oder 2
    Else
      HMFunction = 0
    End If

    Call CheckHmMenu     'Set Checked in Menu


  Case 6          'Einstellungen
    Call GetHmOptions(Title$)

  Case Else
    Stop
  End Select

  Call SetPause(OldPause)

End Sub

Sub MainMenuFunctions(Index)

  '.Checked kann hier nicht gesetzt werden,
  '   sonst wird Haken erst gesetzt, wenn Maus auf dem Befehl steht

  With frmMain

    Select Case Index
    Case 0    'Datei

    Case 1    'GPS
      'Systemzeit setzen
      .pdmnuGPS(5).Enabled = GpsRcvd >= 2 And Not gblSimulation

    Case 2    'Garmin

    Case 3    'HAMMAP
      'Karte einmal zentrieren
      .pdmnuHAMMAP(2).Enabled = GV.HammapConnected _
          And (HMFunction = 0) And (GpsRcvd = 3 Or gblSimulation)

      'Fortlaufend Karte zentrieren/Weg einzeichnen
      For i = 3 To 4
        .pdmnuHAMMAP(i).Enabled = GV.HammapConnected
      Next i


    Case 4    'Pause
      Call SetPause(Not gblPause)

    Case 5    'Info
      Call GpsShowAbout

    End Select

  End With

End Sub

