Attribute VB_Name = "GpsSub"
DefInt A-Z

Function CheckDist(wgs As dGeoPoint, OldPoint As dGeoPoint, ParNr)

  Dist! = QthDist(wgs, OldPoint)
  If Int(Dist!) = Dist! Then f$ = "0" Else f$ = "0.###"
  FixMsg$ = FixMsg$ & " (" & Format$(Dist!, f$) & " km Abstand)"
  Call ShowStatus(FixMsg$)
  void = DoEvents()
  CheckDist = Dist! > 0! And Dist! * 1000! >= NumPar(ParNr).Actual

End Function

Sub ComPortEvent()

  Dim InCom() As Byte

  With frmMain.MSComm1

    EventNr = .CommEvent

    ' Branch according to the CommEvent property.
    ' Event messages.
    If EventNr = 1 Then    'Send

      InCom = .Input
      Debug.Print "Send"
      Exit Sub

    ElseIf EventNr = 2 Then    'Receive

      '--- Daten empfangen ---
      If GarminData Then
        InCom = .Input

        For i = LBound(InCom) To UBound(InCom)
          Debug.Print InCom(i), Chr$(InCom(i))
        Next i
        Debug.Print "-----"
        Exit Sub

      Else
        'NMEA Data
        InBuffer$ = InBuffer$ & .Input
        If Len(InBuffer$) > 10000 Then
          InBuffer$ = "***" & Mid$(InBuffer$, 5000)
        End If

        GpsState = 1
        StartComm = 0

        If GpsRcvd = 0 Then
          Call ShowStatus("Kein gltiger GPRMC-Satz empfangen")
          GpsRcvd = 1
        End If
      End If

    Else

      void$ = .Input
      InBuffer$ = InBuffer$ & "***"

      Select Case EventNr
      Case 1004
        ERMsg$ = "Framing Error"
      Case 1006
        ERMsg$ = "Overrun Error"
      Case 1008
        ERMsg$ = "Receive Buffer Overflow"
      Case 1009
        ERMsg$ = "Parity Error"
      Case Else
        ERMsg$ = "Unknown error or event:" & Str$(EventNr)
      End Select

      ' Display event messages in the status bar, if not Start
      If StartComm Then
        StartComm = StartComm - 1
      Else
        Call ShowStatus(ERMsg$)
      End If

      ' Display error messages in an alert message box.
      'Beep
      'Ret = MsgBox(ERMsg$, 1, "Click Cancel to quit, OK to ignore.")

      ' If the user clicks Cancel (2)...
      'If Ret = 2 Then
      '    .PortOpen = False    ' Close the port and quit.
      'End If

      ' Enable timer so that the message in the status bar
      ' is cleared after 2 seconds
      'Timer2.Enabled = True
    End If

    Do
      Ptr = InStr(InBuffer$, Chr$(13))
      If Ptr = 0 Then Exit Do

      'Complete line
      InpLine$ = Trim$(Left$(InBuffer$, Ptr - 1))
      InBuffer$ = Mid$(InBuffer$, Ptr + 1)

      If Left$(InpLine$, 1) = Chr$(10) Then
        'Strip LF
        InpLine$ = LTrim$(Mid$(InpLine$, 2))
      End If

      If InStr(InpLine$, "***") = 0 And Len(InpLine$) > 0 Then
        'valid line
        Call ProcessLine(InpLine$)
      End If
    Loop

  End With

End Sub

Function GoUpdateHAMMAP()

  Static Busy

  If Not Busy Then

    Busy = True

    If Not gblPause Then Call EnblRun(False)

    GoUpdateHAMMAP = UpdateHAMMAP(gWGS)

    If Not gblPause Then Call EnblRun(True)

    Busy = False

  Else

    GoUpdateHAMMAP = True

  End If

End Function

Sub ProcessGPGGA()

  Dim Min As Double
  Static HMGrd(0 To 1) As Double

  If Len(GpsField(2)) = 0 Or Len(GpsField(4)) = 0 Then
    Call ShowPos(gWGS, 0, -1, 0)
    Exit Sub
  End If


  For i = 0 To 1
    r$ = GpsField$(2 + i * 2)
    If InStr(r$, ".") = 0 Or Len(r$) < 5 Then
      Call ShowStatus("Format-Fehler")
      Exit Sub
    End If
    l$ = Parse$(r$, ".")
    If Len(l$) < 2 Then Exit Sub
    grd = Val(Left$(l$, Len(l$) - 2))
    Min = Val(Right$(l$, 2) & "." & r$)

    HMGrd(i) = grd + Min / 60#
  Next i

  gWGS.l = HMGrd(1)              'Lnge
  If UCase$(GpsField$(5)) <> "E" Then gWGS.l = -gWGS.l

  gWGS.b = HMGrd(0)              'Breite
  If UCase$(GpsField$(3)) <> "N" Then gWGS.b = -gWGS.b

  gWGS.hNN = Val(GpsField$(9)) 'Hhe ber NN
  gWGS.h = Val(GpsField$(9)) + Val(GpsField$(11)) 'Hhe ber Ellipsoid
  If UCase$(GpsField$(10)) <> "M" Then gWGS.h = gWGS.h * 0.3048

  Sats = Val(GpsField$(7))      'Number of Sattelites in use
  Quality = Val(GpsField$(6))
  HeightOk = Len(Trim(GpsField$(9))) > 0

  Call ShowPos(gWGS, Sats, Quality, HeightOk)

End Sub

Sub ProcessGPRMC()

  Dim GPSDateTime As Double

  MyYear = Val(Mid$(GpsField$(9), 5))
  If MyYear < 100 Then
    MyYear = MyYear + 1900
    If MyYear < 98 Then MyYear = MyYear + 100
  End If
  MyMonth = Val(Mid$(GpsField$(9), 3, 2))
  MyDay = Val(Mid$(GpsField$(9), 1, 2))

  MyHour = Val(Mid$(GpsField$(1), 1, 2))
  MyMinute = Val(Mid$(GpsField$(1), 3, 2))
  MySecond = Val(Mid$(GpsField$(1), 5, 2))

  GPSDateTime = DateSerial(MyYear, MyMonth, MyDay)
  GPSDateTime = GPSDateTime + TimeSerial(MyHour, MyMinute, MySecond)

  If Not TimeDiffSet Then
    TimeDiffSet = True

    d# = Now - GPSDateTime
    Diff& = CLng((d# - Int(d#)) * 48)

    If NumPar(16).Actual = 9999 Then
      NumPar(16).Actual = Diff&
    ElseIf NumPar(16).Actual <> Diff& Then
      Answer = MsgBox("Ortszeit an Systemzeit anpassen ?", 32 + 4)
      If Answer = 6 Then
        NumPar(16).Actual = Diff&      'Yes
      End If
    End If

  End If

  If SetTimeMode Then

    Call ShowSetTime(GPSDateTime)

  Else

    Call ShowDateTime(GPSDateTime)

    Quality = (GpsField$(2) = "A")
    Speed# = Val(GpsField$(7)) / 1.852
    Direction# = Val(GpsField$(8))
    Call ShowSpeed(Speed#, Direction#, Quality)

  End If

End Sub

Sub ProcessGPRMM()

  Static MsgFlag

  If GpsField$(1) <> "WGS 84" Then
    If Not MsgFlag Then
      MsgFlag = True
      MsgBox "Schalten Sie bitte den GPS-Empfnger von '" _
        & GpsField$(1) & "' auf 'WGS 84' um!"
    End If
  Else
    MsgFlag = False
  End If

End Sub

Sub ProcessLine(ByVal InpLine$)

  Static LastCol&

  InpLine$ = Replace$(InpLine$, "*", ",*")
  GpsCmd$ = Parse$(InpLine$, ",")

  For i = 1 To UBound(GpsField)
    GpsField$(i) = Parse$(InpLine$, ",")
  Next i

  If GpsCmd$ = "$GPGSV" Then
    GpsCmd$ = GpsCmd$ & "-" & GpsField$(2)
  End If


  'Show GPS Data
  Select Case ShowGpsDataMode
  Case 2        'Empfangsdaten anzeigen  (alle Stze)
    Call ShowGpsRxData

  Case 3, 4      'Satelliten anzeigen  (GPGSV)
    If Left$(GpsCmd$, 6) = "$GPGSV" Then
      For BaseNr = 4 To 16 Step 4
        If Len(GpsField$(BaseNr)) > 0 Then
          If ShowGpsDataMode = 3 Then
            Call ShowSatellitesInView(BaseNr)
          Else
            PRN$ = GpsField$(BaseNr)
            Elev = Val(GpsField$(BaseNr + 1))
            Azim = Val(GpsField$(BaseNr + 2))
            SN = Val(GpsField$(BaseNr + 3))
            Call ShowSatelliteGraphics(PRN$, Elev, Azim, SN)
          End If
        End If
      Next BaseNr

    ElseIf GpsCmd$ = "$GPGSA" Then
      If ShowGpsDataMode = 3 Then
        Call ShowSatellitesUsed(0)
        For BaseNr = 3 To 14
          If Len(GpsField$(BaseNr)) > 0 Then
            Call ShowSatellitesUsed(BaseNr)
          End If
        Next BaseNr
      End If
    End If

  End Select


  Select Case GpsCmd$
  Case "$GPRMC"             'Zeit, Geschw. und Richtung
    If GpsRcvd = 1 Then
      Call ShowStatus("Kein gltiger GPGGA-Satz empfangen")
      GpsRcvd = 2
    End If
    Call ProcessGPRMC

  Case "$GPGGA"             'Position, QTH-Locator
    If GpsRcvd = 2 Then
      Call ShowStatus("")
      GpsRcvd = 3
    End If
    Call ProcessGPGGA

  Case "$PGRMM"
    Call ProcessGPRMM

  End Select

End Sub

Sub ShowDateTime(GPSDateTime As Double)

  Dim LocalDateTime As Double

  FmtTime$ = "hh:mm:ss"
  FmtDate$ = "dd.mm.yy"

  With frmMain
    .UtcDate = Format$(GPSDateTime, FmtDate$)
    UTC$ = Format$(GPSDateTime, FmtTime$)     'used also elsewhere
    .UtcTime = UTC$
    LocalDateTime = GPSDateTime + NumPar(16).Actual / 48
    .LocalDate = Format$(LocalDateTime, FmtDate$)
    .LocalTime = Format$(LocalDateTime, FmtTime$)
  End With

End Sub

Sub ShowPos(wgs As dGeoPoint, Sats, Quality, HeightOk)

  Dim Tmp As dGeoPoint
  Dim Geo As dGeoPoint
  Dim Konf As KonfCoord

  Static OldCoordCol&


  With frmMain

    If Quality = -1 Then

      For i = 0 To 1
        .GeoCoord(i).Caption = "?"
        .KonfCoord(i).Caption = "?"
      Next i

      .fldQth.Caption = "?"

    Else

      'Geographische Koordinaten
      GeoMapDatum = .DatumList(0).ListIndex
      DegMinSec = .FmtList(0).ListIndex
      ErrNr = dCoord2PosStr(GeoMapDatum, 0, DegMinSec, 2, wgs, mb$, ml$)
      .GeoCoord(0).Caption = mb$
      .GeoCoord(1).Caption = ml$

      'Konforme Koordinaten
      KonfMapDatum = .DatumList(1).ListIndex
      MapCoSys = .FmtList(1).ListIndex + 1
      ErrNr = dCoord2PosStr(KonfMapDatum, MapCoSys, 0, 0, wgs, mb$, ml$)
      .KonfCoord(0).Caption = ml$
      .KonfCoord(1).Caption = mb$
    End If

    'Farben
    If Quality > 0 Then
      CoordCol& = &H0
    Else
      CoordCol& = &HFF
    End If

    If CoordCol& <> OldCoordCol Then
      OldCoordCol& = CoordCol&

      .fldQth.ForeColor = CoordCol&

      For i = 0 To 1
        .GeoCoord(i).ForeColor = CoordCol&
        .KonfCoord(i).ForeColor = CoordCol&
      Next i
    End If


    '--- Hhe ---
    For i = 0 To 1
      MapDatum = .DatumList(i).ListIndex

      ErrNr = CoordTransf(0, wgs, MapDatum, Geo)

      If MapDatum = 0 Then
        h# = Geo.hNN      'Hhe ber NN
      Else
        h# = Geo.h        'Hhe ber Ellipsoid
      End If

      If ErrNr = 0 Then
        If HeightOk Then
          If NumPar(17).Actual = 0 Then
            m$ = Format$(h#, "#,##0.0 m")
          Else
            'Umrechnung in Fu
            m$ = Format$(h# / 0.3048, "#,##0 ft")
          End If
        Else
          m$ = "?"
        End If
      Else
        m$ = ""
      End If

      .HeightVal(i).Caption = m$

      'Farbe
      If MapDatum = 0 And Quality > 0 And Sats >= 4 Then
        .HeightVal(i).ForeColor = &H0
      Else
        .HeightVal(i).ForeColor = &HFF
      End If
    Next i


    '--- Status ---
    If gblSimulation Then
      FixMsg$ = "Simulation"
    Else
      If HMFunction > 0 Then
        s$ = ""
      Else
        s$ = " (" & Format$(Sats) & " Satelliten)"
      End If

      If Sats >= 4 Then
        If GeoType = 0 And KonfType = 0 Then
          FixMsg$ = " Lnge + Breite + Hhe o.k." & s$
        Else
          FixMsg$ = " Lnge + Breite + Hhe ungenau" & s$
        End If
      ElseIf Quality > 0 Then
        If HeightOk Then
          FixMsg$ = " Lnge + Breite o.k., Hhe ungenau" & s$
        Else
          FixMsg$ = " Lnge + Breite o.k., Hhe unbekannt" & s$
        End If
      ElseIf Quality = 0 Then
        If HeightOk Then
          FixMsg$ = " Lnge, Breite, Hhe ungenau"
        Else
          FixMsg$ = " Lnge + Breite ungenau, Hhe unbekannt"
        End If
      Else
        FixMsg$ = " Lnge, Breite, Hhe unbekannt"
      End If
    End If

    If Quality < 0 Then
      'keine Position verfgbar
      Call ShowStatus(FixMsg$)
      Exit Sub
    End If


    '----- QTH-Locator -----
    ErrNr = dDegCoord2Qth(wgs, Qth$)
    If ErrNr = 0 Then
      .fldQth.Caption = Left$(Qth$, NumPar(18).Actual * 2 + 6)

      If ShowGpsDataMode = 1 Then
        'Ortschaften anzeigen
        Qth6$ = Left$(Qth$, 6)
        If Qth6$ <> OldQth$ Then
          OldQth$ = Qth6$
          SQL$ = "Select Stadt from tblLocator "
          SQL$ = SQL$ & "Where Locator = '" & Qth6$ & "'"
          GeoInfo$ = GetDBInfo$(SQL$, Result)
          frmGpsData.Caption = "Ortschaften im QTH-Locator " & Qth6$

          If Result <= 0 Then
            frmGpsData.InfoBox.text = ""
          Else
            frmGpsData.InfoBox.text = GeoInfo$
          End If
        End If
      End If

    End If

  End With

  '--- HAMMAP-Anzeige ---
  If GV.HammapConnected And HMFunction > 0 Then
    Call ShowPosHammap(wgs, FixMsg$)
  Else
    Call ShowStatus(FixMsg$)
  End If

End Sub

Sub ShowPosHammap(wgs As dGeoPoint, FixMsg$)

  '--- HAMMAP-Anzeige ---
  Static OldPoint As dGeoPoint
  Dim MaxCoord As lAreaType


  Select Case HMFunction
  Case 1                'Kartenausschnitt zentrieren
    If HMFirstTime = 0 Then
      ErrNr = GoUpdateHAMMAP()
      If ErrNr Then
        HMFirstTime = -1
      Else
        HMFirstTime = 1
        OldPoint = wgs
      End If
    ElseIf HMFirstTime = 1 Then
      If CheckDist(wgs, OldPoint, 5) Then
        ErrNr = GoUpdateHAMMAP()
        OldPoint = wgs
      End If
    End If

    If ErrNr Then
      Call ShowStatus("Anzeige in HAMMAP nicht mglich")
    End If


  Case 2                'Weg anzeigen
    If HMFirstTime = 0 Then
      'Erster Aufruf
      HMFirstTime = 1
      OldPoint = wgs
      ShowOk = True

      'Clear Overlays
      ErrNr = HMCommand("Overlay:-1", Res$)
      ErrNr = HMCommand("Overlay:-2", Res$)
      ErrNr = HMCommand("DrawMap", Res$)

    Else
      If Not CheckDist(wgs, OldPoint, 6) Then Exit Sub

      'Immer ausgeben
      ShowOk = True

      If ShowOk Then
        'Weg ausgeben
        sWid$ = CStr(NumPar(7).Actual)   'Linienbreite
        Cmd$ = "DrawLine:" & Str$(OldPoint.l) & "," & Str$(OldPoint.b) _
           & "," & Str$(wgs.l) & "," & Str$(wgs.b) & ",0000FF,0," & sWid$

        'Store Overlay
        ErrNr = HMCommand("Overlay:1", Res$)    'Start Foreground Overlay
        If ErrNr = 0 Then ErrNr = HMCommand(Cmd$, Res$)
        ErrNr = HMCommand("Overlay:0", Res$)    'Terminate Overlay

        'Draw Line-Segment immediately
        ErrNr = HMCommand(Cmd$, Res$)
        'Prevent that Restores from TipSub erase lines
        ErrNr = HMCommand("StoreMap", Res$)

        'If ErrNr Then Exit Sub
      End If

      OldPoint = wgs

    End If

    If ShowOk Then
      Call ShowStatus(FixMsg$)
    Else
      Call ShowStatus("Weg auerhalb des aktuellen Kartenausschnitts")
    End If

  Case Else
    Stop
  End Select

End Sub

Sub ShowSetTime(GPSDateTime As Double)

  Dim SystemTime As Double
  Dim TimeDiff As Double

  SystemTime = Now
  TimeFmt$ = "hh:mm:ss"

  With frmTime
    If StartSetTime Then
      TimeDiff = SystemTime - GPSDateTime
      TimeDiff = CInt((TimeDiff - Int(TimeDiff)) * 48)
      .txtDiff.text = Format$(TimeDiff / 2, "+0")
      StartSetTime = False
    End If

    .txtUTC.text = Format$(GPSDateTime, TimeFmt$)
    TimeDiff = Val(Unformat$(.txtDiff.text)) * 2
    LocalTime = GPSDateTime + TimeDiff / 48
    .txtLocal.text = Format$(LocalTime, TimeFmt$)
    .txtSystem.text = Format$(SystemTime, TimeFmt$)
  End With

End Sub

Sub ShowSpeed(Speed#, Direction#, Quality)

  With frmMain

    'Geschwindigkeit (Knoten -> km/h)
    Select Case NumPar(17).Actual
    Case 0
      m$ = "km/h"
      f! = 1
    Case 1
      m$ = "Meilen/h"
      f! = 1.609
    Case 2
      m$ = "Knoten"
      f! = 1.852
    End Select

    If Quality Then
      Fldcol& = &H0
      .fldSpeed.Caption = Format$(Speed# / f!, "#,##0.0 ") & m$
      .fldDirection.Caption = Format(Direction#, "0.0 ")
    Else
      Fldcol& = &HFF
      .fldSpeed.Caption = "?"
      .fldDirection.Caption = "?"
    End If

    .fldSpeed.ForeColor = Fldcol&
    .fldDirection.ForeColor = Fldcol&

  End With

End Sub

Sub SimTimerEvent()

  Static Busy

  If Busy Then Exit Sub

  Busy = True

  Call ShowDateTime(CDbl(Now - NumPar(16).Actual / 48))

  'Richtung und Geschwindigkeit
  Quality = Len(StrPar(3, 4)) > 0
  ErrNr = Str2Dbl(StrPar(3, 4), Speed#)
  If ErrNr = 0 Then ErrNr = Str2Dbl(StrPar(3, 5), Direction#)
  If ErrNr = 0 Then Call ShowSpeed(Speed#, Direction#, Quality)

  'Position
  HeightOk = Len(StrPar(3, 3)) > 0
  If HeightOk Then Sats = 4 Else Sats = 3
  If Len(StrPar(3, 1)) > 0 And Len(StrPar(3, 2)) > 0 Then
    Quality = 1
  Else
    Quality = 0
  End If
  If Quality = 0 Then Sats = 0

  If Speed# > 0 Then
    d# = Speed# / (3600# * 6372#) * rad2deg
    a# = Direction# * deg2rad

    gWGS.l = gWGS.l + d# * Sin(a#) / Cos(deg2rad * gWGS.b)
    gWGS.b = gWGS.b + d# * Cos(a#)
  End If

  Call ShowPos(gWGS, Sats, Quality, HeightOk)

  Busy = False

End Sub

Function UpdateHAMMAP(Coord As dGeoPoint)

  Dim lArea As lAreaType
  Dim CircArea As lAreaType       'Circle
  Dim SymArea As lAreaType
  Dim MaxArea As lAreaType

  Dim deg2rad!

  UpdateHAMMAP = True

  ErrNr = HMCommand("GetSize", m$)
  If ErrNr Then Exit Function

  'Kartengre in cm
  wcm! = Val(Parse$(m$, ","))
  hcm! = Val(Parse$(m$, ","))

  'Fenstergre in cm
  wcm! = Val(Parse$(m$, ","))
  hcm! = Val(Parse$(m$, ","))


  'Kartenausschnitt berechnen
  deg2rad! = Atn(1) / 45!
  xm& = Coord.l * cfDeg2Sec
  ym& = Coord.b * cfDeg2Sec
  dy0& = NumPar(4).Actual / 1000 * cfDeg2Sec / (6370 * deg2rad!)
  dx0& = dy0& / Cos(Coord.b * deg2rad!)

  If wcm! > hcm! Then
    'Breite > Hhe
    dx& = dx0& * wcm! / hcm! * 1.1
    dy& = dy0& * 1.1
  Else
    'Breite < Hhe
    dx& = dx0& * 1.1
    dy& = dy0& * hcm! / wcm! * 1.1
  End If

  lArea.lxmin = xm& - dx&
  lArea.lxmax = xm& + dx&
  lArea.lymin = ym& - dy&
  lArea.lymax = ym& + dy&

  ErrNr = HMCommand("GetMaxCoord", Res$)
  If ErrNr Then Exit Function
  ErrNr = Str2lArea(Res$, MaxArea)
  If ErrNr Then Exit Function
  If Not AreaInArea(1, lArea, MaxArea) Then Exit Function

  'Karte ausgeben
  CmdMap$ = "DrawMap:" & lArea2Str$(lArea)

  'Kreis ausgeben
  CircArea.lxmin = xm& - dx0&
  CircArea.lxmax = xm& + dx0&
  CircArea.lymin = ym& - dy0&
  CircArea.lymax = ym& + dy0&
  sWid$ = CStr(NumPar(7).Actual)   'Linienbreite
  CmdCircle$ = "DrawShape:" & lArea2Str$(CircArea) & ",0000FF,10," & sWid$

  'Symbolgre berechnen
  ErrNr = HMCommand("GetCoord", m$)
  If ErrNr Then Exit Function

  'Tatschliche Kartengre holen
  ErrNr = Str2lArea(m$, lArea)

  symw& = (lArea.lxmax - lArea.lxmin) * 0.1 / wcm!
  symh& = (lArea.lymax - lArea.lymin) * 0.1 / hcm!
  If symw& = 0 Then symw& = 1
  If symh& = 0 Then symh& = 1

  SymArea.lxmin = Coord.l * cfDeg2Sec - symw&
  SymArea.lxmax = Coord.l * cfDeg2Sec + symw&
  SymArea.lymin = Coord.b * cfDeg2Sec - symh&
  SymArea.lymax = Coord.b * cfDeg2Sec + symh&

  'Symbol ausgeben
  CmdSymbol$ = "DrawShape:" & lArea2Str$(SymArea) & ",0000FF,1,2"

  'Clear Overlays
  ErrNr = HMCommand("Overlay:-1", Res$)
  ErrNr = HMCommand("Overlay:-2", Res$)

  'Overlay
  ErrNr = HMCommand("Overlay:1", Res$)    'Start Foreground Overlay
  ErrNr = HMCommand(CmdCircle$, Res$)
  ErrNr = HMCommand(CmdSymbol$, Res$)
  ErrNr = HMCommand("Overlay:0", Res$)    'Terminate Overlay
  ErrNr = HMCommand(CmdMap$, Res$)        'Draw Map

  UpdateHAMMAP = False

End Function

