Attribute VB_Name = "GpsTbl"
DefInt A-Z

Const yoffset = 300

Const xangle = 120
Const yangle = 60

Dim sinxangle!
Dim cosxangle!
Dim sinyangle!
Dim cosyangle!

Sub CloseTable()

  Static Busy

  If Busy Then Exit Sub

  Busy = True

  ShowGpsDataMode = 0
  Erase GpsSentenceName$
  Erase GpsSatelliteNr$

  Unload frmGpsData
  Set frmGpsData = Nothing

  Busy = False

End Sub

Sub Draw2DLine(x1!, y1!, x2!, y2!, colo&)

  Const f! = 2000
  Const x0! = 1.25 * f!
  Const y0! = x0! + yoffset

  frmGpsData.ForeColor = colo&
  frmGpsData.Line (x0! + x1! * f!, y0! - y1! * f!)-(x0! + x2! * f, y0! - y2 * f!)

End Sub

Sub Draw2DText(x1!, y1!, text$, colo&)

  Const f! = 2000
  x0! = 1.25 * f! - frmGpsData.TextWidth("0")
  y0! = x0! + yoffset - 1.1 * frmGpsData.TextHeight("0")

  frmGpsData.CurrentX = x0! + x1! * f!
  frmGpsData.CurrentY = y0! - y1! * f!
  frmGpsData.ForeColor = colo&
  frmGpsData.Print text$

End Sub

Sub Draw3DLine(x1!, y1!, z1!, x2!, y2!, z2!, colo&)

  x2D1! = x1! * sinxangle! + y1! * sinyangle!
  y2D1! = y1! * cosyangle! + x1! * cosxangle! + z1!
  x2D2! = x2! * sinxangle! + y2! * sinyangle!
  y2D2! = y2! * cosyangle! + x2! * cosxangle! + z2!

  Call Draw2DLine(x2D1!, y2D1!, x2D2!, y2D2!, colo&)

End Sub

Sub Draw3DText(x1!, y1!, z1!, text$, colo&)

  x2D1! = x1! * sinxangle! + y1! * sinyangle!
  y2D1! = y1! * cosyangle! + x1! * cosxangle! + z1!

  Call Draw2DText(x2D1!, y2D1!, text$, colo&)

End Sub

Sub HelpTable()

  OldPause = gblPause
  Call SetPause(True)

  Select Case ShowGpsDataMode
  Case 1                   'Ortschaften
    m$ = "Anzeige der Ortschaften, Berge, Seen usw. aus der Locator-Datenbank"
    m$ = m$ & Chr$(13) & Chr$(10) & "fr den aktuellen QTH-Locator"

  Case 2, 3                'Tabelle
    m$ = "Durch Ziehen der Spaltentrennlinien in der obersten Zeile "
    m$ = m$ & Chr$(13) & Chr$(10) & "knnen Sie die Spaltenbreiten verndern."

  Case 4
    m$ = "3D-Anzeige der Satelliten:"
    m$ = m$ & Chr$(13) & Chr$(10) & "rot = Hhe (not tracking)"
    m$ = m$ & Chr$(13) & Chr$(10) & "grn = Hhe (tracking - S/N > 0)"
  End Select

  MsgBox m$

  Call SetPause(OldPause)

End Sub

Sub InitTable(Mode)

  ShowGpsDataMode = Mode

  Load frmGpsData

  Erase GpsSatelliteNr$
  Erase GpsSentenceName$

  With frmGpsData
    .WindowState = 0

    Select Case ShowGpsDataMode
    Case 1                   'TextBox (Ortschaften)
      .Width = 5000
      .Height = 4380
      .AutoRedraw = False
      .GpsTbl.Visible = False
      .MenuSep.Visible = False
      .InfoBox.Visible = True

    Case 2, 3                'Tabelle (NMEA, Satelliten)
      .Width = 9000
      .Height = 3500
      .AutoRedraw = False
      .GpsTbl.Visible = True
      .MenuSep.Visible = False
      .InfoBox.Visible = False

    Case 4                    'Grafik (Satelliten)

      .Width = 5125 + 100
      .Height = 5695 + yoffset
      .AutoRedraw = True
      .GpsTbl.Visible = False
      .InfoBox.Visible = False
      .MenuSep.Visible = True

    End Select


    Select Case ShowGpsDataMode
    Case 1                  'Ortschaften

      .Caption = "Ortschaften"
      .InfoBox.text = ""
      OldQth$ = ""

    Case 2                  'GPS-Empfangsdaten

      .Caption = "GPS Empfangs-Daten"

      With .GpsTbl

        .Cols = 22
        .Rows = 2

        ReDim GpsSentenceName$(1 To 1)

        GpsSentenceName$(1) = "$GPRMC"
        .Col = 0
        .row = 1
        .text = GpsSentenceName$(1)


        'Spaltenberschriften
        .row = 0
        .FixedAlignment(0) = 0
        .Col = 0
        .text = ""

        .FixedAlignment(1) = 2
        .ColAlignment(1) = 0
        .Col = 1
        .text = "UTC"

        For i = 2 To .Cols - 1
          .FixedAlignment(i) = 2
          .ColAlignment(i) = 0
          .Col = i
          .text = Format$(i - 1)
        Next i

      End With

    Case 3                  'GPS Satelliten

      With .GpsTbl

        frmGpsData.Caption = "GPS Satelliten"

        .Cols = 7
        .Rows = 2

        'Spaltenberschriften
        .row = 0
        .Col = 0
        .text = "Lfd.Nr."
        .Col = 1
        .text = "UTC"
        .Col = 2
        .text = "Sat. PRN Nr."
        .Col = 3
        .text = "Elevation []"
        .Col = 4
        .text = "Azimuth []"
        .Col = 5
        .text = "S/N [db]"
        .Col = 6
        .text = "benutzt"

        For i = 0 To .Cols - 1
          .FixedAlignment(i) = 2
          If i > 0 Then .ColAlignment(i) = 2
        Next i
      End With

    Case 4
      .Caption = "GPS Satelliten"

      sinxangle! = Sin(xangle * deg2rad)
      cosxangle! = Cos(xangle * deg2rad)
      sinyangle! = Sin(yangle * deg2rad)
      cosyangle! = Cos(yangle * deg2rad)

      .Show
      .Cls
      'x-Achse
      Call Draw3DLine(-1.2, 0, 0, 1.2, 0, 0, 0)
      Call Draw3DLine(1.1, 0.05, 0, 1.2, 0, 0, 0)
      Call Draw3DLine(1.1, -0.05, 0, 1.2, 0, 0, 0)
      Call Draw3DText(1.2, 0, 0, "O", 0)

      'y-Achse
      Call Draw3DLine(0, -1.2, 0, 0, 1.2, 0, 0)
      Call Draw3DLine(0.05, 1.1, 0, 0, 1.2, 0, 0)
      Call Draw3DLine(-0.05, 1.1, 0, 0, 1.2, 0, 0)
      Call Draw3DText(0, 1.2, 0, "N", 0)

      'z-Achse
      Call Draw3DLine(0, 0, -1.2, 0, 0, 1.2, 0)
      Call Draw3DLine(0.05, 0, 1.1, 0, 0, 1.2, 0)
      Call Draw3DLine(-0.05, 0, 1.1, 0, 0, 1.2, 0)
      Call Draw3DText(0, 0, 1.15, "h", 0)

      .Refresh

    End Select


    Call ResizeTable
    .Show
    Call CenterForm(frmGpsData)

  End With

End Sub

Sub ResizeTable()

    Select Case ShowGpsDataMode
    Case 1        'Ortschaften anzeigen

      With frmGpsData
        .InfoBox.Move 0, 0, .ScaleWidth, .ScaleHeight
      End With

    Case 2        'Empfangsdaten anzeigen

      With frmGpsData.GpsTbl

        .Move 0, 0, frmGpsData.ScaleWidth, frmGpsData.ScaleHeight
        c! = .GridLineWidth * Screen.TwipsPerPixelX

        w0! = frmGpsData.TextWidth("$GPGSV-2 ")
        w1! = frmGpsData.TextWidth("00:00:00 ")
        w! = (.Width - w0! - w1! - c! * (.Cols + 3) - 10) / (.Cols - 2)

        .ColWidth(0) = w0!
        .ColWidth(1) = w1!

        For i = 2 To .Cols - 1
          .ColWidth(i) = w!
        Next i

      End With

    Case 3        'Satelliten anzeigen
      With frmGpsData
        .GpsTbl.Move 0, 0, .ScaleWidth, .ScaleHeight
        With .GpsTbl
          c! = .GridLineWidth * Screen.TwipsPerPixelX
          w! = (.Width - c! * (.Cols + 3) - 10) / .Cols

          For i = 0 To .Cols - 1
            .ColWidth(i) = w!
          Next i
        End With
      End With

    Case 4        'Grafik
      With frmGpsData.MenuSep
        .x1 = 0
        .y1 = 0
        .x2 = frmGpsData.ScaleWidth
        .y2 = 0
      End With

    End Select

End Sub

Sub ShowGpsRxData()

  AnzRows = UBound(GpsSentenceName$)

  For i = 1 To AnzRows
    If GpsCmd$ = GpsSentenceName$(i) Then
      RowNr = i
      Exit For
    End If
  Next i

  'Neue Zeile einrichten
  If RowNr = 0 Then
    RowNr = AnzRows + 1
    ReDim Preserve GpsSentenceName$(1 To RowNr)
    GpsSentenceName$(RowNr) = GpsCmd$

    With frmGpsData.GpsTbl
      .Rows = RowNr + 1
      .row = RowNr
      .Col = 0
      .text = GpsCmd$
    End With
  End If

  'Daten anzeigen
  With frmGpsData.GpsTbl

    .row = RowNr
    .Col = 1
    .text = UTC$

    For ColNr = 2 To .Cols - 1
      .Col = ColNr
      .text = GpsField$(ColNr - 1)
    Next ColNr
    .Col = 0
  End With

End Sub

Sub ShowSatelliteGraphics(PRN$, Elevation, Azimuth, SN)

  'If Elevation = 0 Then Exit Sub

  az! = Azimuth * deg2rad
  el! = Elevation * deg2rad
  x! = Sin(az!) * Cos(el!)
  y! = Cos(az!) * Cos(el!)
  Call Draw3DLine(0, 0, 0, x!, y!, 0, &H0)
  If SN = 0 Then colo& = &HFF Else colo& = &HC000&
  Call Draw3DLine(x!, y!, 0, x!, y!, Sin(el!), colo&)

  On Error Resume Next
  AnzRows = UBound(GpsSatelliteNr$)
  On Error GoTo 0

  For i = 1 To AnzRows
    If PRN$ = GpsSatelliteNr$(i) Then
      RowNr = i
      Exit For
    End If
  Next i

  'Satelliten-Nr. nur das erste mal ausgeben
  If RowNr = 0 Then
    RowNr = AnzRows + 1
    ReDim Preserve GpsSatelliteNr$(1 To RowNr)
    GpsSatelliteNr$(RowNr) = PRN$
    Call Draw3DText(x!, y!, Sin(el!), PRN$, &HFF)
  End If
  frmGpsData.Refresh

End Sub

Sub ShowSatellitesInView(BaseNr)

  On Error Resume Next
  AnzRows = UBound(GpsSatelliteNr$)
  On Error GoTo 0

  PRN$ = GpsField$(BaseNr)

  For i = 1 To AnzRows
    If PRN$ = GpsSatelliteNr$(i) Then
      RowNr = i
      Exit For
    End If
  Next i

  'Neue Zeile einrichten
  If RowNr = 0 Then
    RowNr = AnzRows + 1
    ReDim Preserve GpsSatelliteNr$(1 To RowNr)
    GpsSatelliteNr$(RowNr) = PRN$

    With frmGpsData.GpsTbl
      .Rows = RowNr + 1
      .row = RowNr
      .Col = 0
      .text = Format$(RowNr)
    End With
  End If

  'Daten anzeigen
  With frmGpsData.GpsTbl

    .row = RowNr

    .Col = 1
    .text = UTC$

    For ColNr = 2 To 5
      .Col = ColNr
      m$ = GpsField$(BaseNr + ColNr - 2)
      .text = m$
    Next ColNr

    .Col = 0
  End With

End Sub

Sub ShowSatellitesUsed(BaseNr)

  With frmGpsData.GpsTbl
    If BaseNr = 0 Then
      .Col = 6
      For RowNr = 1 To .Rows - 1
        .row = RowNr
        .text = "-"
      Next RowNr

    Else

      PRN$ = GpsField$(BaseNr)

      On Error Resume Next
      AnzRows = UBound(GpsSatelliteNr$)
      On Error GoTo 0

      For i = 1 To AnzRows
        If PRN$ = GpsSatelliteNr$(i) Then
          .Col = 6
          .row = i
          .text = "+"
          Exit For
        End If
      Next i

    End If

    .Col = 0

  End With

End Sub

