Attribute VB_Name = "GrdLib"
DefInt A-Z
Option Explicit

Type GrdType
  AnzCols As Integer
End Type

Public gblGrd As GrdType
Public GrdRowData() As String
Public PrtColWidth() As Single                          'Field Width

Sub ClearGrid(Grd As Grid, StartRow)

  With Grd
    .SelStartRow = StartRow
    .SelEndRow = Grd.Rows - 1
    .SelStartCol = 0
    .SelEndCol = Grd.Cols - 1
    .Clip = ""
  End With

End Sub

Sub CopyGrid(Grd As Grid, StartRow)

  Dim RowNr, ColNr
  Dim t$, m$

  For RowNr = StartRow To Grd.Rows - 1
    Grd.row = RowNr
    t$ = ""

    For ColNr = 0 To Grd.Cols - 1
      Grd.Col = ColNr
      t$ = t$ & Chr$(9) + Grd.text
    Next ColNr

    m$ = m$ & Mid$(t$, 2) & vbCrLf
  Next RowNr

  Clipboard.Clear
  Clipboard.SetText m$

  Grd.row = 0
  Grd.Col = 0

End Sub

Sub GrdFillGrid(Grd As Grid, ByVal StartRecNr As Long)

  Dim RowNr, RecNr As Long, ErrNr

  Screen.MousePointer = 11

  '--- Grid lschen ---
  If Grd.Rows > 1 Then Call ClearGrid(Grd, 1)


  '--- Stationsinfo ausgeben ---
  For RowNr = 1 To Grd.Rows - 1

    RecNr = StartRecNr + RowNr - 1

    ErrNr = RetrieveRowData(RecNr)
    If ErrNr Then Exit Sub

    'Stationsinfo ausgeben
    Call GrdSetRowData(Grd, RowNr)
  Next RowNr


  Grd.row = 0
  Grd.Col = 0
  On Error Resume Next
  Grd.SetFocus
  On Error GoTo 0

  Screen.MousePointer = 0

End Sub

Sub GrdGetRowData(Grd As Grid, RowNr)

  Dim ColNr

  With Grd

    .row = RowNr

    For ColNr = 0 To .Cols - 1
      .Col = ColNr
      GrdRowData(ColNr) = .text
    Next ColNr

  End With

End Sub

Sub GrdInitGrid(Grd As Grid)

  ReDim GrdRowData(0 To gblGrd.AnzCols - 1) As String

  With Grd
    .Cols = gblGrd.AnzCols
  End With

End Sub

Sub GrdPrintData(Grd As Grid, ByVal EndRecNr As Long, ByVal OptTitle As String)

  Dim RecNr As Long
  Dim ColNr, ErrNr, LineCount, Cancel, Border
  Dim s$
  Dim y!, dy!, h!

  If EndRecNr > 50 Then
    s$ = "Wollen Sie wirklich " & Format$(EndRecNr, "#,##0") _
      & " Datenstze drucken?"
    If MsgBox(s$, 256 + 4) = 7 Then Exit Sub
  End If


  'Drucker fr Dokument initialisieren
  ErrNr = PrtStartDoc()
  If ErrNr Then Exit Sub

  Do Until GetAsyncKeyState(27) = 0
  Loop


  Screen.MousePointer = 11

  'Spaltenbreiten aus Tabelle bernehmen
  Call PrtSetTabs(Grd, 0, Grd.Cols - 1)


  '--- Druckausgabe ---
  For RecNr = 1 To EndRecNr

    If LineCount = 0 Then

      'Druckseite initialisieren (Seitenkopf ausgeben)
      Call PrtStartPage(OptTitle)
      OptTitle = ""   'nur auf erster Seite

      'Feldberschriften ausgeben
      Printer.FontBold = True
      Grd.row = 0
      Border = 15

      For ColNr = 0 To Grd.Cols - 1
        Grd.Col = ColNr
        h! = PrintField(Grd.text, 0, Border, PrtColWidth(ColNr), 0.05)
        Border = 14   'Links nur 1. Mal
      Next ColNr

      With Printer
        .CurrentX = 0
        .CurrentY = .CurrentY + h!
      End With

      Printer.FontBold = False

    End If

    'Zeile ausgeben
    ErrNr = RetrieveRowData(RecNr)
    If ErrNr Then Exit For

    Border = 13
    For ColNr = 0 To Grd.Cols - 1
      h! = PrintField(GrdRowData(ColNr), 0, Border, PrtColWidth(ColNr), 0.05)
      Border = 12   'Links nur 1. Mal
    Next ColNr

    With Printer
      .CurrentX = 0
      .CurrentY = .CurrentY + h!
    End With

    LineCount = LineCount + 1
    If PrtEndOfPage() Then LineCount = 0

    If RecNr Mod 10 = 0 Then
      Cancel = GetAsyncKeyState(27)
      If Cancel Then Exit For
      DoEvents
    End If

  Next RecNr

  Grd.Parent.SetFocus

  If Cancel Then
    MsgBox "Funktion abgebrochen"
    Call AbortPrint
  Else
    Printer.EndDoc
  End If

  Screen.MousePointer = 0

End Sub

Function GrdSaveData(Frm As Form, Title$, ByVal EndRecNr As Long)

  Static InitDir$
  Dim FILTER$, FileSpec$, t$
  Dim ErrNr, FileNr, ColNr, Cancel
  Dim RecNr As Long

  GrdSaveData = True

  'Dateispezifikation eingeben
  If Len(InitDir$) = 0 Then InitDir$ = HomeDir$
  FILTER$ = "Textdatei (*.TXT)|*.TXT"
  ErrNr = GetFileSpec(Title$, 2, &H806, InitDir$, "TXT", FILTER$, FileSpec$)
  If ErrNr Then Exit Function

  'Datei ffnen
  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr Then Exit Function


  Do Until GetAsyncKeyState(27) = 0
  Loop

  Screen.MousePointer = 11

  For RecNr = 0 To EndRecNr

    ErrNr = RetrieveRowData(RecNr)
    If ErrNr Then Exit For

    t$ = ""
    For ColNr = 0 To UBound(GrdRowData)
      t$ = t$ & Chr$(9) + GrdRowData(ColNr)
    Next ColNr

    ErrNr = WriteLine(FileNr, Mid$(t$, 2))
    If ErrNr Then Exit For

    If RecNr Mod 10 = 0 Then
      Cancel = GetAsyncKeyState(27)
      If Cancel Then
        Frm.SetFocus
        MsgBox "Funktion abgebrochen"
        Exit For
      End If
      DoEvents
    End If

  Next RecNr

  Screen.MousePointer = 0
  Frm.SetFocus

  'Datei schlieen
  GrdSaveData = CloseFile(FileNr)

End Function

Sub GrdSetRowData(Grd As Grid, RowNr)

  Dim ColNr

  With Grd

    .row = RowNr

    For ColNr = 0 To .Cols - 1
      .Col = ColNr
      .text = GrdRowData(ColNr)
    Next ColNr

  End With

End Sub

Sub PrtSetTabs(Grd As Grid, StartCol, EndCol)

  'Feldbreiten und TAB's fr Drucker berechnen
  'Proportional zu denen in Tabelle Grd setzen

  Dim lw As Single                          'Line Width
  Dim ColNr As Integer

  ReDim PrtColWidth(StartCol To EndCol) As Single

  'Spaltenbreiten aus Tabelle bernehmen
  For ColNr = StartCol To EndCol
    PrtColWidth(ColNr) = Grd.ColWidth(ColNr)
    lw = lw + PrtColWidth(ColNr)
  Next ColNr


  'Feldbreiten fr Drucker berechnen (proportional zu Tabelle)
  For ColNr = StartCol To EndCol
    PrtColWidth(ColNr) = PrtColWidth(ColNr) * Prt.PrintWidth / lw
  Next ColNr

End Sub

