Attribute VB_Name = "GtArea"
'---------------------------- GETAREA.BAS ----------------------------

'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CheckAreaLimits(lNewArea As lAreaType, ErrFld)

  ErrFld = 0

  'Pruefen, ob Ausschnitt ausserhalb des Maximums
  If lNewArea.lxmin < -clMaxDegX Then
    ErrFld = 1
  ElseIf lNewArea.lxmax > clMaxDegX Then
    ErrFld = 2
  ElseIf lNewArea.lymin < -clMaxDegY Then
    ErrFld = 3
  ElseIf lNewArea.lymax > clMaxDegY Then
    ErrFld = 4
  End If
  If ErrFld <> 0 Then ErrNr = 30012

  'Pruefen, ob max. kleiner min.
  If ErrNr = 0 Then
    If lNewArea.lxmax < lNewArea.lxmin Then
      ErrFld = 2
    ElseIf lNewArea.lymax < lNewArea.lymin Then
      ErrFld = 4
    End If
    If ErrFld <> 0 Then ErrNr = 30012
  End If

  'Pruefen, ob Ausschnitt zu klein
  If ErrNr = 0 Then
    If lNewArea.lxmax - lNewArea.lxmin < 10& Then
      ErrFld = 2
    ElseIf lNewArea.lymax - lNewArea.lymin < 10& Then
      ErrFld = 4
    End If
    If ErrFld <> 0 Then ErrNr = 30011
  End If

  If ErrNr Then Call ShowErrNr(ErrNr)

  CheckAreaLimits = ErrNr

End Function

Function CtlTxt2lCoord&(Ctl As Control, Direct)

  co$ = Ctl.text      'Wegen DOS separate Zeile
  ErrNr = Str2dDegCoord(co$, grd#, Direct)
  CtlTxt2lCoord& = grd# * cfDeg2Sec

End Function

Sub GetAreaFields(lArea As lAreaType)

  lArea.lymin = CtlTxt2lCoord&(AreaForm.XYField(1), 1)
  lArea.lymax = CtlTxt2lCoord&(AreaForm.XYField(2), 1)
  lArea.lxmin = CtlTxt2lCoord&(AreaForm.XYField(3), 2)
  lArea.lxmax = CtlTxt2lCoord&(AreaForm.XYField(4), 2)

End Sub

Function GetAreaLimits(Title$, lArea As lAreaType, AreaName$, DegFmt, Change&)

  Dim lNewArea As lAreaType

  GetAreaLimits = True

  dy = 720
  dy1 = 240

  With AreaForm

    '--- Labels ---
    For i = 0 To 7
      If i > 0 Then Load .AreaLabel(i)
      .AreaLabel(i).Visible = True
      .AreaLabel(i).Caption = Msg$(30000 + i)
    Next i


    '--- Eingabefelder + Position der Labels ---
    y = .XYField(1).Top

    For i = 0 To 3
      If i > 0 Then Load .XYField(i + 1)
      .XYField(i + 1).Visible = True
      .XYField(i + 1).TabIndex = i
      .XYField(i + 1).Top = y
      .AreaLabel(2 * i).Top = y
      .AreaLabel(2 * i + 1).Top = y + dy1
      y = y + dy
    Next i

    '--- Kommandotasten ---
    y = .Cmd(0).Top

    For i = 0 To 4
      If i > 0 Then Load .Cmd(i)
      .Cmd(i).Visible = True
      .Cmd(i).TabIndex = i + 4
      .Cmd(i).Top = y
      If i >= 2 Then
        m$ = Msg$(30020 + i - 2)
        .Cmd(i).Caption = Parse$(m$, ",")
        .Cmd(i).Tag = m$
      End If
      y = y + dy
    Next i

    .Cmd(0).Tag = AreaName$
    .Cmd(1).Tag = Str$(DegFmt)

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)

    .Cmd(0).Default = True
    .Cmd(1).Cancel = True

    .Caption = Title$

    Call SetAreaFields(lArea, DegFmt)

    Call CenterForm(AreaForm)

    .Show 1

    Cancel = Val(.Tag) <> 0
    Change& = False

    If Not Cancel Then
      Call GetAreaFields(lNewArea)
      Change& = Not AreaInArea(2, lNewArea, lArea)
      lArea = lNewArea
      AreaName$ = .Cmd(0).Tag
    End If

  End With

  Unload AreaForm
  Set AreaForm = Nothing

  GetAreaLimits = Cancel

End Function

Sub SetAreaFields(lArea As lAreaType, AnzFields)

  AnzNulls = 2 * (3 - AnzFields)

  AreaForm.XYField(1).text = dDegCoord2DegStr$(CDbl(lArea.lymin * cfSec2Deg), AnzFields, AnzNulls, 1)
  AreaForm.XYField(2).text = dDegCoord2DegStr$(CDbl(lArea.lymax * cfSec2Deg), AnzFields, AnzNulls, 1)
  AreaForm.XYField(3).text = dDegCoord2DegStr$(CDbl(lArea.lxmin * cfSec2Deg), AnzFields, AnzNulls, 2)
  AreaForm.XYField(4).text = dDegCoord2DegStr$(CDbl(lArea.lxmax * cfSec2Deg), AnzFields, AnzNulls, 2)

End Sub

