Attribute VB_Name = "GuiSubWin"
DefInt A-Z

Sub AutoArrange(Mode)

  If HmForm.WindowState = 1 Then Exit Sub       'Icon

  'Rekursive Aufrufe verhindern
  HV.AutoArrangeBusy = True

  'MapForm.WindowState = 0
  'AuxForm.WindowState = 0

  wges! = HmForm.ScaleWidth
  hges! = HmForm.ScaleHeight

  Select Case Mode
  Case 0                'festes Verhaeltnis
    wmap! = 0.75 * wges!
    'wmap = wges * MapForm.Width / (MapForm.Width + AuxForm.Width)

  Case 1                'MapForm vergroessern
    wmap! = MapForm.Width

  Case 2                'AuxForm vergroessern
    wmap! = wges! - AuxForm.Width
    If wmap! < 0! Then wmap! = 0!
  End Select

  waux! = wges! - wmap!
  If waux! < 0! Then waux! = 0!
  AuxForm.Move wmap!, 0, waux!, hges!

  MapForm.Move 0, 0, wmap!, hges!

  HV.AutoArrangeBusy = False

End Sub

Sub AuxFormEnbl()

  HV.AuxFormProgResize = True

  'geht nicht unter VB3
  AuxForm.Visible = (NumPar(53).Actual And 256) <> 0

  HV.AuxFormProgResize = False

End Sub

Sub AuxFormResize()

  If HV.AuxFormProgResize Then Exit Sub

  'Pruefen, ob Auto Arrange
  If NumPar(53).Actual And 512 Then
    If WindowState <> 0 Then
      WindowState = 0
      Mode = 0
    Else
      Mode = 2
    End If
    If Not HV.AutoArrangeBusy Then
      Call AutoArrange(Mode)
    End If
  End If

  cl = 0.05 * AuxForm.ScaleWidth
  AuxForm.Selection.Left = cl
  AuxForm.ListLabel.Left = cl
  AuxForm.AuxList.Left = cl

  cw = 0.9 * AuxForm.ScaleWidth
  AuxForm.Selection.Width = cw
  AuxForm.ListLabel.Width = cw
  AuxForm.AuxList.Width = cw

  ch = AuxForm.ScaleHeight - AuxForm.AuxList.Top - AuxForm.Selection.Top
  If ch < 500 Then ch = 500
  AuxForm.AuxList.Height = ch

End Sub

Sub GuiFunctions(OldPar&)

  NewPar& = NumPar(53).Actual

  'If multipe Symbolbars are eplicitely selected -> allow it
  If (NewPar& And 14) <> (OldPar& And 14) Then
    Select Case (NewPar& And 14) \ 2
    Case 3, 5 To 7
      NumPar(53).Actual = NewPar& Or 32
    End Select
  End If

  Call SetToolbars

  If (NewPar& And 15) <> (OldPar& And 15) Then
    'Symbolbars were added/deleted
    ResizeHMForm = True
  End If

  If (NewPar& And 128) <> (OldPar& And 128) Then
    'Scrollbar-Anzeige wurde gendert
    ResizeMapForm = True
    Call ScrollBarEnbl
  End If

  If (NewPar& And 256) <> (OldPar& And 256) Then
    'Stations-Fenster-Anzeige wurde gendert
    ResizeHMForm = True
    Call AuxFormEnbl
  End If


  '--- Pruefen, ob Auto-Arrange eingeschaltet wurde ---
  If NewPar& And Not OldPar& And 512& Then
    Call AutoArrange(0)
  End If

  If ResizeHMForm Then
    Call HMFormResize
  ElseIf ResizeMapForm Then
    Call MapFormResize
  End If

End Sub

Sub HMFormResize()

  If HmForm.WindowState = 1 Then Exit Sub       'Minimized

  If (NumPar(53).Actual And 256) = 0 Then
    'Stationsfenster ist NICHT sichtbar
    With HmForm
      MapForm.Move 0, 0, .ScaleWidth, .ScaleHeight
    End With
  ElseIf (NumPar(53).Actual And 512) = 0 Then
    'Kein AutoArrange -> no action
  Else
    'Stationsfenster ist sichtbar
    If HV.AutoArrangeBusy Then Exit Sub

    w1 = ScaleWidth
    h1 = ScaleHeight
    Call AutoArrange(0)

    'ggf. 2. Mal anordnen (wegen Entfallen der Scrollbars)
    w2 = ScaleWidth
    h2 = ScaleHeight
    If w1 <> w2 Or h1 <> h2 Then
      Call AutoArrange(0)
    End If

  End If

  Call InitPlaceHolder

End Sub

Function InitGui()

  '----- GUI Initialization called once on program start -----

  InitGui = True

  HV.HMFormProgResize = True

  Load HmForm

  With HmForm
    .WindowState = NumPar(21).Actual

    If NumPar(21).Actual <> 1 Then .Show

    If NumPar(21).Actual <> 2 Then
      .Move NumPar(18).Actual, NumPar(17).Actual, NumPar(20).Actual, NumPar(19).Actual
    End If

    .StatusBox.Width = .StatusContainer.ScaleWidth
    End With

  HV.HMFormProgResize = False


  HV.HMFormProgResize = True    'Because of reference to MapForm.Watchdog
  Call SetToolbars
  HV.HMFormProgResize = False

  Call SetMapToolbar
  Call SetMouseToolbar

  Call AuxFormEnbl
  Call ScrollBarEnbl

  InitGui = False

End Function

Sub InitScroll()

  If Not MapForm.MapHScroll.Visible Then Exit Sub
  If HV.ScrollUserChange Then Exit Sub

  AreaOk = AreaInArea(0, MV.ActMapArea, MV.FileMapArea)

  If (NumPar(46).Actual And MF_BitMap) > 0 And AreaOk Then
    HV.ScrollMapArea = MV.FileMapArea
  Else
    HV.ScrollMapArea = MV.MaxMapArea
  End If

  Call GetAreaSize(HV.ScrollMapArea, wmax&, hmax&)
  Call GetAreaSize(MV.ActMapArea, wact&, hact&)

  HV.ScrollPrgChange = True

  With MapForm
    HV.HScrollScale = Int(wmax& / 32767) + 1

    With .MapHScroll
      .Min = 0
      .Max = Int((wmax& - wact& + HV.HScrollScale - 1) / HV.HScrollScale)
      .LargeChange = lMax(2&, wact& \ HV.HScrollScale)
      'V11.0a
      .SmallChange = lMax(1&, .LargeChange \ 4)
      .Value = (MV.ActMapArea.lxmin - HV.ScrollMapArea.lxmin) \ HV.HScrollScale
      HV.HScrollEnbl = (.Max - .Min <> 0)
      .Enabled = HV.HScrollEnbl
    End With


    HV.VScrollScale = Int(hmax& / 32767) + 1

    With .MapVScroll
      .Max = 0
      .Min = Int((hmax& - hact& + HV.VScrollScale - 1) \ HV.VScrollScale)
      .LargeChange = lMax(2&, hact& \ HV.VScrollScale)
      'V11.0a
      .SmallChange = lMax(1&, .LargeChange \ 4)
      .Value = (MV.ActMapArea.lymin - HV.ScrollMapArea.lymin) \ HV.VScrollScale
      HV.VScrollEnbl = (.Max - .Min <> 0)
      .Enabled = HV.VScrollEnbl
    End With

    DoEvents
    HV.ScrollPrgChange = False

  End With

End Sub

Sub MapFormResize()

  If HV.MapFormProgResize Then Exit Sub
  If HmForm.WindowState = 1 Then Exit Sub       'Minimized

  If MapForm.ScaleHeight = 0 Then
    MapForm.Height = MapForm.Height + 100
    Exit Sub
  End If

  With MapForm

    If (NumPar(53).Actual And &H300&) = &H300& Then
      'Auto Arrange und Stationsfenster sichtbar
      If .WindowState <> 0 Then
        .WindowState = 0
        Mode = 0
      Else
        Mode = 1
      End If
      If Not HV.AutoArrangeBusy Then
        Call AutoArrange(Mode)
      End If
    End If

    '--- Ausschnitt anpassen ---

    'Scrollbars anpassen
    If .MapHScroll.Visible Then
      .ScaleMode = 3
      dx = .MapVScroll.Width
      dy = .MapHScroll.Height
      x1 = .ScaleWidth - dx
      If x1 < 0 Then x1 = 0
      y1 = .ScaleHeight - dy
      If y1 < 0 Then y1 = 0
      .MapHScroll.Move 0, y1, x1
      .MapVScroll.Move x1, 0, dx, y1
      With .HiddenField
        'Hide field behind scrollbar
        .ZOrder 1
        .Move x1, 0, dx, dy
        'Set focus to hidden field, so that scrollbars don't blink
        '   see Prepare-/TerminateFunction (not possible if HmForm is disabled)
      End With
    End If
  End With

  If Not Busy And WindowState <> 1 And Not HV.DisableNewMap Then
    Busy = True
    Call NewMap
    Busy = False
  End If

End Sub

Sub ScrollBarEnbl()

  'Scrollbar-Anzeige

  HV.MapFormProgResize = True

  ScrollEnbl = (NumPar(53).Actual And 128) <> 0

  With MapForm
    .MapVScroll.Visible = ScrollEnbl
    .MapHScroll.Visible = ScrollEnbl
    .HiddenField.Visible = ScrollEnbl

    If .HiddenField.Visible Then
      'Catch unexpected errors (they occured)
      On Error Resume Next
      .HiddenField.SetFocus
      On Error GoTo 0
    End If
  End With

  HV.MapFormProgResize = False

End Sub

