Attribute VB_Name = "HAMCLK_W"
DefInt A-Z

Public ActClk As Form

Public TimeDiff As Single
Public ClockTitle As String

Public AlarmString As String
Public AlarmDay As Double
Public AlarmTime As Double

Public TitleHeight As Single
Public TimeSize$

Public FntName As String
Public FntSize As Single
Public FntBold As Integer
Public FntItalic As Integer

Public YTop As Integer
Public XLeft As Integer

Public Radius As Single            'Clock-Radius
Public cx As Single                'Clock-Center x
Public cy As Single                'Clock-Center y

'Global TwoPi As Single

Sub DrawMinute(m!, lz!)

  r1! = Radius * lz!             'Zeigerlnge
  r2! = Radius * 0.3 * lz!
  r3! = Radius * 0.07            'Zeigerbreite

  a! = m! / 60! * TwoPi
  sa! = Sin(a!)
  ca! = Cos(a!)

  X1! = cx + r1! * sa!
  Y1! = cy - r1! * ca!

  If Radius > 500 Then
    ActClk.PSet (X1!, Y1!)
    ActClk.Line -(cx + r3! * ca!, cy + r3! * sa!)
    ActClk.Line -(cx - r2! * sa!, cy + r2! * ca!)
    ActClk.Line -(cx - r3! * ca!, cy - r3! * sa!)
    ActClk.Line -(X1!, Y1!)
  Else
    ActClk.Line (cx, cy)-(X1!, Y1!)
    ActClk.PSet (X1!, Y1!)
  End If

End Sub

Sub DrawSecond(s)

  If frmClk1.OptionsSeconds.Checked Then
    r! = Radius * 0.8
    a! = s / 60! * TwoPi
    ActClk.Line (cx, cy)-(cx + r! * Sin(a!), cy - r! * Cos(a!))
  End If

End Sub

Sub InitClock(TopMode)

  FormW! = ActClk.ScaleWidth
  FormH! = ActClk.ScaleHeight


  '------------- Digital ---------------
  If frmClk1.OptionsDigital.Checked Then

    '--- Schriftgre anpassen ---
    If frmClk1.OptionsSeconds.Checked Then
      TimeSize$ = "00:00:00"

      If ActClk.WindowState = 1 Then
        On Error Resume Next
        ActClk.FontName = "Small Fonts"
        On Error GoTo 0
      Else
        ActClk.FontName = FntName
      End If
    Else
      TimeSize$ = "00:00"
      ActClk.FontName = FntName
    End If

    ActClk.FontBold = FntBold
    ActClk.FontItalic = FntItalic

    ActClk.FontSize = 24
    s! = ActClk.FontSize

    FontW! = s! * FormW! / ActClk.TextWidth(TimeSize$)
    FontH! = s! * FormH! / ActClk.TextHeight(TimeSize$)

    If FontW! < FontH! Then f! = FontW! Else f! = FontH!

    If f! < 3 Then f! = 3
    ActClk.FontSize = f! * 0.95


    '--- Text zentrieren ---
    w! = ActClk.TextWidth(TimeSize$)
    h! = ActClk.TextHeight(TimeSize$)
    YTop = (FormH! - h!) / 2!
    XLeft = (FormW! - w!) / 2!

  Else

    '------------ Analog ---------------
    If FormW! > FormH! Then
      Radius = FormH! / 2! * 0.95
    Else
      Radius = FormW! / 2! * 0.95
    End If

    'Mittelpunkt
    cx = FormW! / 2!
    cy = FormH! / 2!

    ActClk.Cls
    ActClk.Circle (cx, cy), Radius


    '--- Stunden- und Minutenmarkierungen ausgeben ---
    r! = Radius * 0.9
    HourMark! = Radius * 0.025
    ActClk.FillStyle = 0

    For i = 0 To 59
      a! = i / 60 * TwoPi
      PX! = cx + r! * Sin(a!)
      PY! = cy - r! * Cos(a!)

      If i Mod 5 = 0 Then
        ActClk.Circle (PX!, PY!), HourMark!, , , , 1
      Else
        If Radius > 500 Then ActClk.PSet (PX!, PY!)
      End If
    Next i

    ActClk.FillStyle = 1

    MinShown = False
    SecShown = False

  End If        'Ende Analog


  '--- 'Immer im Vordergrund' setzen ---
  If TopMode Then
    Mode = frmClk1.OptionsTopMost.Checked
  Else
    Mode = False
  End If

  Call SetTop(frmClk1.hWnd, Mode)
  Call SetTop(frmClk2.hWnd, Mode)

  Call SetClockTitle
  Call ShowTime(True)

End Sub

Sub SelectColor(Mode)

  If Mode = 0 Then
    frmClk1.CmDlg.Color = frmClk1.BackColor
  Else
    frmClk1.CmDlg.Color = frmClk1.ForeColor
  End If
  frmClk1.CmDlg.Flags = &H1&
  frmClk1.CmDlg.CancelError = True

  On Local Error Resume Next
  frmClk1.CmDlg.Action = 3
  If Err Then Exit Sub
  On Local Error GoTo 0

  If Mode = 0 Then
    frmClk1.BackColor = frmClk1.CmDlg.Color
    frmClk2.BackColor = frmClk1.CmDlg.Color
  Else
    frmClk1.ForeColor = frmClk1.CmDlg.Color
    frmClk2.ForeColor = frmClk1.CmDlg.Color
    frmClk1.FillColor = frmClk1.CmDlg.Color
    frmClk2.FillColor = frmClk1.CmDlg.Color
  End If

End Sub

Sub SelectFont()

  frmClk1.CmDlg.CancelError = True
  frmClk1.CmDlg.Flags = &H10401

  frmClk1.CmDlg.FontName = FntName
  frmClk1.CmDlg.FontSize = ActClk.FontSize
  frmClk1.CmDlg.FontBold = FntBold
  frmClk1.CmDlg.FontItalic = FntItalic

  On Error Resume Next
  frmClk1.CmDlg.Action = 4
  If Err Then Exit Sub
  On Local Error GoTo 0

  FntName = frmClk1.CmDlg.FontName
  FntSize = frmClk1.CmDlg.FontSize
  FntBold = frmClk1.CmDlg.FontBold
  FntItalic = frmClk1.CmDlg.FontItalic

  Call InitClock(True)

End Sub

Sub SetClockTitle()

  t$ = ClockTitle
  If t$ <> "HAMCLOCK" Then t$ = "HAMCLOCK - " & t$

  If TimeDiff <> 0 Then d$ = " (" & Format$(TimeDiff) + ")"

  App.Title = ClockTitle & d$
  frmClk1.Caption = t$ & d$

End Sub

Sub ShowTime(NewShow)

  Dim ActTime As Double
  Dim ActDay As Double

  Static LastHour As Integer
  Static LastMinute As Integer
  Static LastSecond As Integer


  ActTime = Now + TimeDiff / 24       'Actual Time

  If frmClk1.OptionsSeconds.Checked Then
    ts$ = Format$(ActTime, "HH:MM:SS")
  Else
    ts$ = Format$(ActTime, "HH:MM")
  End If

  If ActClk.WindowState = 1 Then
    frmClk1.Caption = ClockTitle & " - " & ts$
    Exit Sub
  End If

  If frmClk1.OptionsDigital.Checked Then

    '-------------- Digital -------------
    ActClk.Cls
    ActClk.CurrentY = YTop
    ActClk.CurrentX = XLeft
    ActClk.Print ts$

  Else

    '--------------- Analog --------------
    hr = Hour(ActTime) Mod 12
    m = Minute(ActTime)
    s = Second(ActTime)

    If Not NewShow Then

      '--- Alte Zeit lschen (Hintergrundfarbe) ---
      If ActClk.WindowState = 1 Then
        '--- Icon ---
        ActClk.Cls
      Else
        SaveCol& = ActClk.ForeColor
        ActClk.ForeColor = ActClk.BackColor

        Call DrawMinute(CSng(LastMinute), 0.8)
        DrawHour! = (LastHour + LastMinute / 60) * 5
        Call DrawMinute(DrawHour!, 0.6)
        Call DrawSecond(LastSecond)

        ActClk.ForeColor = SaveCol&
      End If
    End If


    'Neue Minuten- und Stundenzeiger ausgeben (Vordergrund)
    Call DrawMinute(CSng(m), 0.8)
    DrawHour! = (hr + m / 60!) * 5
    Call DrawMinute(DrawHour!, 0.6)

    'Sekundenzeiger ausgeben
    Call DrawSecond(s)

    LastHour = hr
    LastMinute = m
    LastSecond = s

  End If


  '---- Alarm ----
  ActDay = Int(ActTime)
  If AlarmDay = ActDay Then
    If ActTime - ActDay >= AlarmTime Then
      Beep
      MsgBox "Es ist " + Format$(ActTime, "HH:MM:SS") + " !"
      AlarmDay = AlarmDay + 1
    End If
  End If

End Sub

