Attribute VB_Name = "HamDst"
DefInt A-Z


Dim degQTH(1 To 2) As dGeoPoint

Sub AppQuit()

  StrPar(3, 1) = HamDist.QthField(1).text

  d$ = Params2Str$(False)
  ErrNr = WriteParameter(InParFile$, "[HAMDIST]", d$)

  Call ExitHMTool

End Sub

Sub Calculate()

  Dim Dist As Double, Angle As Double

  With HamDist
    .DistField.text = ""
    .AngleField(1).text = ""
    .AngleField(2).text = ""
  End With

  For Index = 1 To 2
    Qth$ = Trim$(HamDist.QthField(Index).text)
    ErrNr = Qth2dDegCoord(Qth$, degQTH(Index))
    If ErrNr Then Exit Sub
  Next Index

  Dist = QthDist(degQTH(1), degQTH(2)) / EarthRad * (NumPar(6).Actual / 1000)
  Dist = km2miles(Dist, NumPar(2).Actual)

  f$ = DecFmt$(NumPar(3).Actual)
  Unit$ = Msg$(40005 + NumPar(2).Actual)
  HamDist.DistField.text = Format$(Dist, f$) & " " & Unit$

  If Dist > 0# Then
    f$ = DecFmt$(NumPar(5).Actual)
    Deg$ = " " & Mid$(DegChr & "g", NumPar(4).Actual + 1, 1)

    For Index = 1 To 2
      Angle = QthAngle(degQTH(Index), degQTH(Index Mod 2 + 1))
      If NumPar(4).Actual = 1 Then Angle = Angle * 10 / 9   'Neugrad
      HamDist.AngleField(Index).text = Format$(Angle, f$) & Deg$
    Next Index
  End If

End Sub

Sub EnterCoord(Index)

  Dim dP As dGeoPoint

  With HamDist

    Title$ = Msg$(48070 + Index - 1)

    ErrNr = InitMaskData(2, Title$, "")
    If ErrNr = 0 Then
      'Set Prompt and Default
      Qth$ = Trim$(.QthField(Index).text)
      If Len(Qth$) > 0 Then
        ErrNr = Qth2dDegCoord(Qth$, dP)

        If ErrNr = 0 Then
          AnzFields = 3
          AnzNulls = 0

          Select Case Len(Qth$)
          Case 8, 10
            AnzNulls = 1
          Case 12
            AnzNulls = 2
          End Select

          b$ = dDegCoord2DegStr$(dP.b, AnzFields, AnzNulls, 1)
          l$ = dDegCoord2DegStr$(dP.l, AnzFields, AnzNulls, 2)
        End If
      End If

      Call SetMaskData(1, Msg$(48080), b$, "", "-90", "90")    'Breite
      Call SetMaskData(2, Msg$(48081), l$, "", "-180", "180")  'Lnge

      Cancel = GetMaskInput(0, Change&)

      If Not Cancel Then
        ErrNr = Str2dDegCoord(GetMaskData(1), dP.b, 1)
        If ErrNr = 0 Then ErrNr = Str2dDegCoord(GetMaskData(2), dP.l, 2)
        'degQTH(Index) = dP   'fr direkte Verwendung der Koordinaten

        If ErrNr = 0 Then ErrNr = dDegCoord2Qth(dP, Qth$)
        If ErrNr = 0 Then
          Qth$ = Left$(Qth$, NumPar(1).Actual * 2 + 2)
        Else
          Qth$ = ""
          MsgBox Msg$(40211)
        End If
        .QthField(Index).text = Qth$
      End If

      Call EraseMaskData

      .QthField(Index).SetFocus
    End If

  End With

End Sub

Sub ExtrasFunctions(Index)

  Const AnzFields = 6

  Title$ = StdMsg$(48020 + Index)

  Select Case Index
  Case 0
    ErrNr = InitMaskData(AnzFields, Title$, "")
    If ErrNr = 0 Then
      'Set Selection
      MaskData(1, 4) = "@40030"     'Locator mit
      MaskData(2, 4) = "@40000"     'Entfernung in
      MaskData(3, 4) = "@48130"     'Entfernung mit
      MaskData(4, 4) = "@48120"     'Richtung in
      MaskData(5, 4) = "@48130"     'Richtung mit

      For i = 1 To AnzFields
        MaskData(i, 1) = Msg$(48100 + i)            'Prompt
        If i < 6 Then
          MaskData(i, 2) = CStr(NumPar(i).Actual)     'Default fr Eingabe
        Else
          'Erdradius in m
          MaskData(i, 2) = Format$(NumPar(i).Actual / 1000, "#,##0.0##")
        End If
      Next i

      Cancel = GetMaskInput(0, Change&)

      If Not Cancel And Change& <> 0& Then
        For i = 1 To 5
          NumPar(i).Actual = Val(GetMaskData(i))
        Next i

        'Erdradius in m
        NumPar(6).Actual = Val(Unformat$(GetMaskData(6))) * 1000&

        Call Calculate
      End If

      Call EraseMaskData
    End If
  End Select

End Sub

Sub FileFunctions(Index)

  Select Case Index
  Case 0
    Call AppQuit
  End Select

End Sub

Sub InfoFunctions(Index)

  Select Case Index
  Case 0      'Hilfe
    m$ = "Geben Sie den QTH-Locator von zwei Standorten mit 2 bis 8 Stellen ein." & vbCrLf
    m$ = m$ & "Oder drcken Sie auf die Taste neben dem Eingabefeld und geben Lnge und Breite ein." & vbCrLf
    m$ = m$ & "Sobald gltige Werte eingegeben sind, werden Entfernung und Antennenrichtung automatisch berechnet."
    MsgBox m$, 0, "HAMDIST  -  Help"

  Case 1      'ber
    Call ShowAbout

  End Select

End Sub

Sub InitHamDist()

  With HamDist

    ErrNr = InitHmTool("HAMDIST", "DOS,HMSUB,GEO,HAMDIST")
    If ErrNr Then
      Call ExitHMTool
      Exit Sub
    End If

    'Parameter laden
    ErrNr = LoadParameter(InParFile$, "[HAMDIST]", False, Found)
    If ErrNr Then Exit Sub

    Call InitMenu

    .MenuSep.Move 0, 0, .ScaleWidth, 50
    .MenuSep.Visible = True

    void = SetReadOnly(.DistField, True)
    void = SetReadOnly(.AngleField(1), True)
    void = SetReadOnly(.AngleField(2), True)

    HamDist.Height = 3945

    Call CenterForm(HamDist)
    HamDist.Show

    If Len(.QthField(1).text) = 0 Then
      .QthField(1).SetFocus
    Else
      .QthField(2).SetFocus
    End If

  End With

End Sub

Sub InitMenu()

  '--- Mens ---
  Call SetMsgMode(1)

  With HamDist

    For MenuNr = 0 To MsgBase(-1)
      i = 0
      Do
        m$ = Parse$(Msg$(MsgBase(MenuNr) + i), "(")
        If Len(m$) = 0 Then Exit Do

        Select Case MenuNr
        Case 0      'Hauptmenu
          Call SetMenuItem(.mnuMain(i), m$)
        Case 1      'Datei
          If i > 1 Then Load .pdmnuFile(i)
          Call SetMenuItem(.pdmnuFile(i), m$)
        Case 2      'Extras
          If i > 1 Then Load .pdmnuExtras(i)
          Call SetMenuItem(.pdmnuExtras(i), m$)
        Case 3      'Info
          If i > 1 Then Load .pdmnuInfo(i)
          Call SetMenuItem(.pdmnuInfo(i), m$)
        End Select

        i = i + 1
      Loop
    Next MenuNr

    'Labels
    For i = 0 To 4
      .FieldLabel(i).Caption = Msg$(48050 + i)
    Next i

    .CoordCmd(1).ToolTipText = Msg$(48070)
    .CoordCmd(2).ToolTipText = Msg$(48071)

  End With

  Call SetMsgMode(0)

End Sub

Sub InitParameter()         '***$$$ADR

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (CheckBoxMask)
  '        muss NumPar.Max = 0 sein (oder nicht definiert) !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '        NumPar(...).Label = ""

  ReDim NumPar(1 To 6) As NumParType

  Call InitNumPar(1, "QthChar", 2&, 0&, 5&)
  Call InitNumPar(2, "DistUnit", 0&, 0&, 2&)
  Call InitNumPar(3, "DistFmt", 0&, 0&, 6&)
  Call InitNumPar(4, "AngleUnit", 0&, 0&, 4&)
  Call InitNumPar(5, "AngleFmt", 0&, 0&, 6&)
  Call InitNumPar(6, "EarthRad", 6368000, 5000000, 7000000)


  '--- String-Parameter setzen ---
  'Index 1: 1 = Name, 2 = Default, 3 = Actual, 4 = Multiline
  'Index 2: lfd. Nummer des Parameters
  ReDim StrPar(1 To 4, 1 To 1) As String

  Call InitStrPar(1, "QTH1", "", "")

End Sub

Function MsgBase(MenuNr) As Long

  If MenuNr < 0 Then
    MsgBase = 2
  Else
    MsgBase = 48000 + 10 * MenuNr
  End If

End Function

Sub SetParameter()

  HamDist.QthField(1).text = StrPar(3, 1)

End Sub

