Attribute VB_Name = "HAMEDIT"
DefInt A-Z

Option Explicit

Public FntName As String
Public FntSize As Single
Public FntBold
Public FntItalic

Type LineInfo
  LineNr As Integer
  LineStart As Long
  LineLength As Integer
  LineCount As Integer
End Type

Public Wrap
Public OverWriteFlag

Public Const WM_CUT = &H300
Public Const WM_COPY = &H301
Public Const WM_PASTE = &H302
Public Const WM_CLEAR = &H303
Public Const WM_UNDO = &H304

  Public Const MaxTextLength& = 65535

  Declare Function GetKeyState% Lib "user32.dll" (ByVal nVirtKey&)
  Declare Sub GetKeyboardState Lib "user32.dll" (lpKeyState As Byte)
  Declare Sub SetKeyboardState Lib "user32.dll" (lpKeyState As Byte)

  Const VK_Insert = &H2D

Function BackupFile(FileSpec$, BackExt$)

  Dim d$, p$, n$, e$
  Dim BackSpec$
  Dim Exist, Found, ErrNr

  BackupFile = True

  'wenn Ausgabedatei noch nicht existiert -> Ende
  ErrNr = ExistFile(FileSpec$, False, Exist)
  If ErrNr Or Not Exist Then
    BackupFile = ErrNr
    Exit Function
  End If

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)
  BackSpec$ = d$ + p$ + n$ + BackExt$

  'wenn Backup-Datei schon existiert -> lschen
  ErrNr = ExistFile(BackSpec$, False, Exist)
  If ErrNr Then Exit Function

  If Exist Then
    ErrNr = DeleteFile(BackSpec$, Found)
    If ErrNr Then Exit Function
  End If

  'alte Datei in *.BAK umbenennen
  On Local Error Resume Next
  Name FileSpec$ As BackSpec$
  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, FileSpec$)

  BackupFile = ErrNr

End Function

Sub DeleteEmptyLines(Txt$)

  'Im String Txt$ CR durch CR/LF ersetzen
  'Wegen langen Strings wird Txt$ nicht in andere Variable umgespeichert
  '  (spart Zeit und Speicherplatz)

  Dim Pt&

  Pt& = 1

  Do
    Pt& = InStr(Pt&, Txt$, vbCrLf & vbCrLf)
    If Pt& = 0 Then Exit Do
    Txt$ = Left$(Txt$, Pt& - 1) & Mid$(Txt$, Pt& + 2)
  Loop

End Sub

Function FixCrLf$(ByVal m$)

  Dim i As Long
  Dim CR$, LF$

  CR$ = Chr$(13)
  LF$ = Chr$(10)

  'Fix CR
  i = 0
  Do
    i = InStr(i + 1, m$, CR$)
    If i = 0 Then Exit Do
    If Mid$(m$, i + 1, 1) <> LF$ Then
      m$ = Left$(m$, i) & LF$ & Mid$(m$, i + 1)
      i = i + 1
    End If
  Loop

  'Fix LF
  i = 0
  Do
    i = InStr(i + 1, m$, LF$)
    If i = 0 Then Exit Do
    If Mid$(m$, i - 1, 1) <> CR$ Then
      m$ = Left$(m$, i - 1) & CR$ & Mid$(m$, i)
      i = i + 1
    End If
  Loop

  FixCrLf$ = m$

End Function

Function GetInsertKeyState()

  GetInsertKeyState = GetKeyState(VK_Insert)

End Function

Sub GetLineInfo(Info As LineInfo)

  Dim Wnd As Long
  Dim Ptr As Long

  Wnd = HmEdit.TheText(Wrap).hWnd

  'Get current linenr
  Ptr = HmEdit.TheText(Wrap).SelStart
  Info.LineNr = SendMessageBynum(Wnd, EM_GETLINEFROMCHAR, Ptr, 0&)

  'Get start of line
  Info.LineStart = SendMessageBynum(Wnd, EM_LINEINDEX, Info.LineNr, 0&)

  'Get length of line
  Info.LineLength = SendMessageBynum(Wnd, EM_LINELENGTH, Ptr, 0&)

  'Get line count
  Info.LineCount = SendMessageBynum(Wnd, EM_GETLINECOUNT, 0, 0&)

End Sub

Sub PrintCommand()

  '--- Text ausdrucken ---
  Dim ErrNr, EOS
  Dim s$

  ErrNr = PrtStartDoc()
  If ErrNr Then Exit Sub

  Screen.MousePointer = 11

  Call PrtStartPage("")             'Titel erste Seite

  s$ = Extract$(1, HmEdit.TheText(Wrap).text, vbCrLf, EOS)

  Do Until EOS
    ErrNr = PrintSection(s$)
    If ErrNr Then Exit Sub
    s$ = Extract$(0, "", vbCrLf, EOS)
  Loop

  Printer.EndDoc

  Screen.MousePointer = 0

End Sub

Sub SetInsertKeyState(Ins)

  Dim lpKeyState(0 To 255) As Byte

  Call GetKeyboardState(lpKeyState(0))

  If Ins Then Ins = 1
  lpKeyState(VK_Insert) = Ins

  Call SetKeyboardState(lpKeyState(0))


End Sub

Sub ShowStatus()

  Static Busy
  Dim NrLines, m$, f$, Ins
  Dim NrChar As Long

  Dim Info As LineInfo
  Dim void As Long

  If Busy Or HmEdit.StatusContainer.Visible = False Then Exit Sub

  Busy = True

  Call GetLineInfo(Info)
  f$ = "#,##0"

  m$ = "Zeile " & Format$(Info.LineNr + 1, f$)
  m$ = m$ & " / " & Format$(Info.LineCount, f$)
  m$ = m$ & " - Spalte"
  m$ = m$ & Str$(HmEdit.TheText(Wrap).SelStart - Info.LineStart)
  m$ = m$ & " /" & Str$(Info.LineLength)
  m$ = m$ & " - Zeichen" & Str$(HmEdit.TheText(Wrap).SelStart)
  m$ = m$ & " /" & Str$(Len(HmEdit.TheText(Wrap).text))

  If OverWriteFlag Then
    m$ = m$ & "  -  berschreiben"
  Else
    m$ = m$ & "  -  Einfgen"
  End If

  HmEdit.StatusBox.text = " " & m$

  Busy = False

End Sub

Function Tab2Space$(ByVal InText$)

  'Funktion: In InText$ TAB's (HT = 09H) durch Leerzeichen ersetzen.
  'InText$ kann mehrere Zeilen lang sein.

  Dim l$, tin$, tout$
  Dim i, eol

  tin$ = InText$
  tout$ = ""

  Do Until Len(tin$) = 0
    eol = InStr(tin$, vbCrLf)

    If eol = 0 Then
      l$ = tin$
      tin$ = ""
    Else
      l$ = Left$(tin$, eol - 1)
      tin$ = Mid$(tin$, eol + 2)
    End If

    Do
      i = InStr(l$, Chr$(9))
      If i = 0 Then Exit Do

      l$ = Left$(l$, i - 1) + Space$(8 - ((i - 1) Mod 8)) + Mid$(l$, i + 1)
    Loop

    tout$ = tout$ + l$ + vbCrLf
  Loop

  Tab2Space$ = tout$

End Function

