Attribute VB_Name = "HAMGPS"
DefInt A-Z

Public InBuffer$
Public gblSimulation
Public CommEnbl
Public StartComm
Public GpsState
Public GpsRcvd

Public HMFunction
Public HMFirstTime

Public OldQth$

Public GpsCmd$
Public GpsField$(20)

Public gblPause
Public ShowGpsDataMode
Public GpsSentenceName$()
Public GpsSatelliteNr$()
Public UTC$
Public TimeDiffSet
Public LocalTime As Double

Public SetTimeMode
Public StartSetTime

Public gWGS As dGeoPoint

Sub Main()

  ErrNr = appInit()
  If ErrNr Then
    Call appQuit
    Exit Sub
  End If

  'Fenster auf Bildschirm zentrieren und anzeigen
  Call CenterForm(frmMain)
  frmMain.Show

End Sub

Function appHMConnect()

  Dim ErrNr

  ErrNr = HMConnect(0)
  'If ErrNr = 0 Then ErrNr = HMSetMask(?)   'not required
  If ErrNr = 0 Then
    ErrNr = HMCheckVer("11.0")
    If ErrNr Then Call HMDisconnect
  End If

  appHMConnect = ErrNr

End Function

Function appInit()

  appInit = True

  ErrNr = InitHmTool("HAMGPS", "DOS,HMSUB,HMAPI,GEO,HAMGPS,COM")
  If ErrNr Then Exit Function


  '--- Parameter laden ---
  ErrNr = LoadParameter(InParFile$, "[HAMGPS]", False, Found)
  If ErrNr Then Exit Function

  If Not Found Or Len(StrPar(3, 7)) = 0 Then
    Cancel = GetComSettings(ProgName$ & "  -  " & StdMsg$(46040 + 7))
    If Cancel Then Exit Function
  End If


  'Mu nach LoadParameter stehen
  Call InitMenu


  'HAMMAP aktivieren
  If NumPar(2).Actual <> 0 And GV.HammapMode Then
    void = appHMConnect()
  End If


  'Set Checked in Menu
  ' (mu nach LoadParameter, InitMenu und appHMConnect stehen)
  Call CheckHmMenu


  'Datenbank ffnen
  void = OpenDB()

  'COM-Port ffnen
  Call EnblComm(True)

  appInit = False

End Function

Sub appQuit()

  'Einstellungen speichern
  NumPar(2).Actual = GV.HammapConnected And 1
  m$ = Params2Str$(0)
  void = WriteParameter(InParFile$, "[HAMGPS]", m$)

  'Terminate COM-Port
  Call EnblComm(False)

  'Close database
  void = CloseDB()

  'Disconnect HAMMAP
  Call HMDisconnect

  'Close forms and terminate
  Call ExitHMTool

End Sub

Sub CheckHmMenu()

  With frmMain
    .pdmnuHAMMAP(0).Checked = GV.HammapConnected
    .pdmnuHAMMAP(3).Checked = (HMFunction = 1)
    .pdmnuHAMMAP(4).Checked = (HMFunction = 2)
  End With

End Sub

Sub ClearDisplay()

  With frmMain
    .UtcDate.Caption = ""
    .UtcTime.Caption = ""
    .LocalDate.Caption = ""
    .LocalTime.Caption = ""

    For i = 0 To 1
      .GeoCoord(i).Caption = ""
      .KonfCoord(i).Caption = ""
      .HeightVal(i).Caption = ""
    Next i

    .fldSpeed.Caption = ""
    .fldDirection.Caption = ""
    .fldQth.Caption = ""
  End With

End Sub

Sub ClientNotify(ByVal EventNr As Integer, ByVal EventData As String)

  'No action

End Sub

Sub ClientTerminate()

  HMFunction = 0
  Call CheckHmMenu

End Sub

Sub EnblComm(ByVal NewState)

  If NewState = CommEnbl Then Exit Sub    'keine nderung

  CommEnbl = NewState

  If NewState <> 0 Then

    'Comm Einschalten
    If NumPar(1).Actual = 0 Then
      Call ShowStatus("Offline")
    Else
      StartComm = 10
      ErrNr = SetComPort()
      InBuffer$ = "***"
    End If

  Else

    'Comm ausschalten
    With frmMain
      If .MSComm1.PortOpen Then
        .MSComm1.PortOpen = False
      End If
      .GPSWatchDog.Enabled = False
      Call ShowStatus("")
      Call ClearDisplay
    End With

  End If

End Sub

Sub EnblRun(State)

  If gblSimulation Then
    frmMain.SimTimer.Enabled = State
    If State Then
      Call SimTimerEvent
    Else
      ClearDisplay
    End If
  Else
    Call EnblComm(State)
  End If

End Sub

Sub EnblSim(ByVal NewState)

  If NewState = gblSimulation Then Exit Sub

  gblSimulation = NewState

  Call EnblComm(Not NewState)

  With frmMain

    .pdmnuGPS(10).Checked = NewState
    .SimTimer.Enabled = gblSimulation

    If gblSimulation Then
      'Simulation beginnen
      ErrNr = Str2dDegCoord(StrPar(3, 1), gWGS.b, 1)
      If ErrNr Then MsgBox "Ungltiges Format: " & StrPar(3, 1)

      ErrNr = Str2dDegCoord(StrPar(3, 2), gWGS.l, 2)
      If ErrNr Then MsgBox "Ungltiges Format: " & StrPar(3, 2)

      ErrNr = Str2Dbl(StrPar(3, 3), gWGS.h)
      gWGS.hNN = gWGS.h

      HMFirstTime = 0

      Call ShowStatus("Simulation")
      Call SimTimerEvent
    End If

    Call SetPause(False)

  End With

End Sub

Sub InitMenu()

  With frmMain

    .Height = 6240

    'Dropdown-List Koordinaten-Format
    Call AddMsgItems(.FmtList(0), 40040, 0)
    Call AddMsgItems(.FmtList(1), 40051, 0)

    'Dropdown-List Karten-Datum
    For i = 0 To 1
      Call AddMsgItems(.DatumList(i), 40060, 0)
    Next i

    For i = 0 To 1
      .FmtList(i).ListIndex = NumPar(12 + i).Actual
      .DatumList(i).ListIndex = NumPar(14 + i).Actual
    Next i

    'Statuszeile
    void = SetReadOnly(.StatusBox, True)
    .StatusContainer.BackColor = &H8000000F
    .StatusBox.BackColor = &H8000000F

    'Men-Separator
    With .MenuSep
      .Visible = True
      .x1 = 0
      .y1 = 0
      .x2 = frmMain.ScaleWidth
      .y2 = 0
    End With


    '--- Men ---
    Call SetMsgMode(1)

    ReDim MsgBase(0 To 4) As Long

    MsgBase(0) = 46000         'Hauptmen
    MsgBase(1) = 46020         'File
    MsgBase(2) = 46040         'GPS
    MsgBase(3) = 46060         'Garmin
    MsgBase(4) = 46080         'HAMMAP


    For MenuNr = 0 To UBound(MsgBase)
      i = 0
      Do
        m$ = Msg$(MsgBase(MenuNr) + i)
        If Len(m$) = 0 Then Exit Do

        'On Error Resume Next

        Select Case MenuNr
        Case 0    'Hauptmen
          Call SetMenuItem(.mnuMain(i), m$)

        Case 1    'Datei
          If i > 0 Then Load .pdmnuFile(i)
          Call SetMenuItem(.pdmnuFile(i), m$)

        Case 2    'GPS
          If i > 0 Then Load .pdmnuGPS(i)
          Call SetMenuItem(.pdmnuGPS(i), m$)

        Case 3    'Garmin
          If i > 0 Then Load .pdmnuGarmin(i)
          Call SetMenuItem(.pdmnuGarmin(i), m$)

        Case 4    'HAMMAP
          If i > 0 Then Load .pdmnuHAMMAP(i)
          Call SetMenuItem(.pdmnuHAMMAP(i), m$)

        End Select

        'On Error GoTo 0

        i = i + 1
      Loop
    Next MenuNr

    Call SetMsgMode(0)

    'Mu nach Initialisierung stehen
    .mnuMain(2).Visible = GV.DesignMode     'Men Garmin
    .mnuMain(3).Visible = GV.HammapMode     'Men HAMMAP

  End With

  Erase MsgBase

End Sub

Sub InitParameter()

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (GetFilter)
  '        muss NumPar.Max = 0 sein (oder nicht definiert) !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '        NumPar(...).Label = ""

  ReDim NumPar(1 To 19) As NumParType

  Call InitNumPar(1, "COM-Port", 0&, 0&, 16&)
  Call InitNumPar(2, "HM-Enbl", 0&, 0&, 0&)     'Connect

  'Reihenfolge und Position 4...8 nicht aendern
  Call InitNumPar(4, "HM-Radius", 25000&, 1&, 20000000)
  Call InitNumPar(5, "HM-Update", 1000&, 0&, 1000000)
  Call InitNumPar(6, "HM-Resolution", 1000&, 0&, 1000000)
  Call InitNumPar(7, "HM-LineWidth", 2&, 1&, 10&)
  Call InitNumPar(8, "", 0&, 0&, 0&)        'unused

  Call InitNumPar(9, "DTREnable", 0&, 0&, 1&)
  Call InitNumPar(10, "RTSEnable", 0&, 0&, 1&)
  Call InitNumPar(11, "Timeout", 3000&, 1000&, 65000)

  'Reihenfolge und Position 12...15 nicht ndern
  Call InitNumPar(12, "GeoFmt", 2&, 0&, 2&)
  Call InitNumPar(13, "KonfFmt", 0&, 0&, 2&)
  Call InitNumPar(14, "GeoDatum", 0&, 0&, 3&)
  Call InitNumPar(15, "KonfDatum", 0&, 0&, 3&)

  'Reihenfolge und Position 16...18 nicht ndern
  Call InitNumPar(16, "TimeDiff", 9999&, -48&, 48&)    'Stunden*2
  Call InitNumPar(17, "Units", 0&, 0&, 2&)
  Call InitNumPar(18, "QTH-Locator", 0&, 0&, 3&)

  Call InitNumPar(19, "Handshake", 0&, 0&, 3&)

  '--- String-Parameter setzen ---
  ReDim StrPar(1 To 4, 1 To 7) As String

  'Reihenfolge 1...5 = Simulationsdaten !!! (nicht aendern)
  Call InitStrPar(1, "SimLatitude", "", "")
  Call InitStrPar(2, "SimLongitude", "", "")
  Call InitStrPar(3, "SimHeight", "0", "")
  Call InitStrPar(4, "SimSpeed", "0", "")
  Call InitStrPar(5, "SimDirection", "0", "")
  Call InitStrPar(6, "SimInterval", "1000", "")

  Call InitStrPar(7, "COM-Settings", "4800,N,8,1", "")

End Sub

Function SetComPort()

  SetComPort = False

  With frmMain.MSComm1

    On Error Resume Next

    .Handshaking = NumPar(19).Actual
    .DTREnable = NumPar(9).Actual <> 0
    .RtsEnable = NumPar(10).Actual <> 0
    frmMain.GPSWatchDog.Interval = NumPar(11).Actual
    .Settings = StrPar(3, 7)
    If Err = 0 Then .CommPort = NumPar(1).Actual
    If Err = 0 Then
      If .PortOpen = False Then .PortOpen = True
    End If
    If Err = 0 Then
      If .InBufferCount > 0 Then m$ = .Input
    End If
    ErrNr = Err
    ErrTxt$ = Error$
    On Error GoTo 0

    If ErrNr Then
      Select Case ErrNr
      Case 8002, 8005
        m$ = Msg$(ErrNr) & ": COM " & Format$(NumPar(1).Actual)
      Case 380, 8015
        m$ = Msg$(25001) & ": " & StrPar(3, 7)
      Case Else
        m$ = ErrTxt$
      End Select

      MsgBox m$, 48
      NumPar(1).Actual = 0      'Offline
      SetComPort = True
      Call ShowStatus(m$)
    End If

    frmMain.GPSWatchDog.Enabled = (NumPar(1).Actual > 0)
    GpsState = 0
    GpsRcvd = 0

  End With

End Function

Sub SetParameter()

  For i = 1 To 5
    If Len(StrPar(3, i)) = 0 Then StrPar(3, i) = "0"
  Next i

  frmMain.SimTimer.Interval = Val(StrPar(3, 6))

End Sub

Sub SetPause(ByVal State)

  If gblPause = State Then Exit Sub

  gblPause = State

  Call EnblRun(Not gblPause)

  With frmMain.mnuMain(4)

    If gblPause Then
      Call ShowStatus("Pause")
      .Caption = "&Weiter"
    Else
      Call ShowStatus("")
      .Caption = "&Pause"
    End If

  End With

End Sub

Sub SetSystemTime()

  SetTimeMode = True
  StartSetTime = True

  frmMain.Hide

  Call CenterForm(frmTime)

  frmTime.Show 1

  Unload frmTime
  Set frmTime = Nothing

  frmMain.Show

  SetTimeMode = False

End Sub

Sub ShowStatus(ByVal m$)

  With frmMain.StatusBox
    .text = " " & m$
    .Refresh
  End With

End Sub

Sub WatchDogEvent()

  If GpsState = 0 Then
    Call ShowStatus("GPS-Empfnger nicht aktiv")
    GpsRcvd = 0
  Else
    GpsState = 0
  End If

End Sub

