Attribute VB_Name = "HAMTBL_W"
DefInt A-Z

Public Lbl$(0 To 13)           'Field-Labels
Public w(0 To 13) As Single    'Width per Column
'Global Stn$()                  'Calls
'Global StnLines$()             'Station-Lines

Public TotWid As Integer       'Total Width
Public tppx                    'Twips per Pixel x
Public tppy                    'Twips per Pixel y
Public wGrdLin                 'Grid Line Width (in Twips)
Public hGrdLin                 'Grid Line Height (in Twips)

Public FieldMask As Integer    'Feldmaske
Public GrdCols As Integer      'Anzahl Spalten
Public AnzStn As Integer       'Anzahl Stationen
Public FirstStn As Integer     'Erste Station

Public ScrollProgChange As Integer
Public ResizeProgChange

Public UnKnown$(0 To 13)       'Unbekannt

Sub Main()

  ErrNr = InitHmTool("HMTBL", "DOS,HAMMAP,HMSUB")
  If ErrNr Then Exit Sub

  ErrNr = InitQRGTable()
  If ErrNr Then Exit Sub

  GV.ProgChange = True
  Call CenterForm(HmTbl)
  DoEvents
  GV.ProgChange = False

  With HmTbl
    void = SetReadOnly(.StatusBox, True)
    .StatusContainer.BackColor = &H8000000F
    .StatusBox.BackColor = &H8000000F
  End With

  ErrNr = HMConnect(4)
  If ErrNr = 0 Then ErrNr = HMCheckVer("11.0")
  If ErrNr = 0 Then ErrNr = HMSetMask(4)
  If ErrNr Then
    Call HMDisconnect
    Exit Sub
  End If

  w(0) = 3: Lbl$(0) = "Nr"
  w(1) = 7: Lbl$(1) = "Call"          '9
  w(2) = 1: Lbl$(2) = "Zeile"
  w(3) = 8: Lbl$(3) = "Status"
  w(4) = 4: Lbl$(4) = "Datum"
  w(5) = 7: Lbl$(5) = "Typ"
  w(6) = 8: Lbl$(6) = "Software"
  w(7) = 8: Lbl$(7) = "Hardware"
  w(8) = 6: Lbl$(8) = "QRG [MHz]"
  w(9) = 4: Lbl$(9) = "Baud"          '6
  w(10) = 6: Lbl$(10) = "Sysop"
  w(11) = 6: Lbl$(11) = "Locator"
  w(12) = 16: Lbl$(12) = "QTH"         '36
  w(13) = 20: Lbl$(13) = "Info"        '48

  FieldMask = 1 + 2 + 32 + 256 + 512 + 4096
  GrdCols = 6
  tppx = Screen.TwipsPerPixelX
  tppy = Screen.TwipsPerPixelY
  wGrdLin = tppx * HmTbl.Grd.GridLineWidth
  hGrdLin = tppy * HmTbl.Grd.GridLineWidth

  UnKnown$(3) = Msg$(24300)
  UnKnown$(5) = Msg$(24310)
  UnKnown$(6) = Msg$(24340)
  UnKnown$(7) = Msg$(24370)

  HmTbl.Grd.FontSize = 8
  Call InitGrid
  Call AdjustGrid

  ResizeProgChange = True
  HmTbl.Show
  DoEvents
  ResizeProgChange = False

  'Druckausgabe initialisieren
  With Prt
    .ListTitle = "HAMMAP"
    For i = 1 To 4
      .OptEnbl(i) = True
      .OptValue(i) = 1
    Next i
    .OptEnbl(3) = False
  End With

  Call PrtInit

End Sub

Sub AdjustGrid()

    If HmTbl.WindowState = 1 Then Exit Sub

  With HmTbl
    .Grd.Width = .ScaleWidth - .ScrollBar.Width
    grdh = .ScaleHeight - .StatusContainer.Height
    If grdh < 0 Then grdh = 0

    With .Grd
      .Height = grdh
      AnzRows = .Height \ (.RowHeight(0) + hGrdLin)
      If AnzRows > AnzStn + 1 Then AnzRows = AnzStn + 1
      'If AnzRows < 2 Then AnzRows = 2
      .Rows = AnzRows
      ReDim Stn$(1 To .Rows)
      ReDim StnLines$(1 To .Rows)

      ColNr = 0
      PlanWid& = .Width - .Cols * wGrdLin
      wfakt! = PlanWid& / TotWid

      For i = 0 To 13
        If 2 ^ i And FieldMask Then
          .ColWidth(ColNr) = wfakt! * w(i) + tppx / 2
          pw& = pw& + wfakt! * w(i)
          ActWid& = ActWid& + (.ColWidth(ColNr) \ tppx) * tppx
          ColNr = ColNr + 1
        End If
      Next i

      Diff& = PlanWid& - ActWid&
      .ColWidth(ColNr - 1) = .ColWidth(ColNr - 1) + Diff&
    End With

    ScrollProgChange = True

    With .ScrollBar
      .Top = 0
      .Left = HmTbl.ScaleWidth - .Width
      .Height = grdh
      .Max = AnzStn - HmTbl.Grd.Rows + 2
      If HmTbl.Grd.Rows = 1 Then
        .LargeChange = 1
      Else
        .LargeChange = HmTbl.Grd.Rows - 1
      End If
    End With

    DoEvents
    ScrollProgChange = False

  End With

End Sub

Sub ClientNotify(ByVal EventNr As Integer, ByVal EventData As String)

  Call FillGrid

End Sub

Sub ClientTerminate()

  GV.ProgChange = True

  Call ExitHMTool

  DoEvents
  GV.ProgChange = False

End Sub

Sub FileFunctions(Index)

  Select Case Index
  Case 0  'Speichern...
    Title$ = ProgName$ & "  -  Speichern unter"
    void = GrdSaveData(HmTbl, Title$, AnzStn)

  Case 1  '-

  Case 2  'Drucken
    Call GrdPrintData(HmTbl.Grd, AnzStn, "")

  Case 3  'Schriftart
    Call PrtSelectFont(HmTbl.CmDlg)

  Case 4  'Seite einrichten
    void = PrtPageSetup()

  Case 5  'Drucker einrichten
    Call PrinterSetup(HmTbl.CmDlg)

  Case 6  '-

  Case 7  'Beenden
    Call HMDisconnect

  End Select

End Sub

Sub FillGrid()

  Static OldArea$

  HmTbl.StatusBox.text = ""
  DoEvents

  'Prfen, ob sich Kartenbereich gendert hat
  ErrNr = HMCommand("GetCoord", NewArea$)
  If ErrNr Then Exit Sub

  If NewArea$ <> OldArea$ Then
    Call InitGrid
    Call AdjustGrid
    OldArea$ = NewArea$
  End If

  Call GrdFillGrid(HmTbl.Grd, FirstStn)

End Sub

Sub InitGrid()

  ErrNr = HMCommand("GetAnzStn:1", m$)
  If ErrNr Then
    Call HMDisconnect
    Exit Sub
  End If

  AnzStn = Val(m$)

  Call ShowMsg(Format$(AnzStn, "#,##0") & " Stationen")

  FirstStn = 1

  gblGrd.AnzCols = GrdCols
  Call GrdInitGrid(HmTbl.Grd)

  With HmTbl.Grd
    '.FontSize = 8
    .Top = 0
    .Left = 0

    .row = 0
    ColNr = 0
    TotWid = 0

    For i = 0 To 13
      If 2 ^ i And FieldMask Then
        .Col = ColNr
        .text = Lbl$(i)
        TotWid = TotWid + w(i)
        ColNr = ColNr + 1
      End If
    Next i

    '.Rows = 2
    '.Refresh
  End With

  ScrollProgChange = True

  With HmTbl.ScrollBar
    .Value = 1
    .LargeChange = 1
    .Max = 1
  End With

  DoEvents
  ScrollProgChange = False

End Sub

Sub OptionFunctions(Index)

  Select Case Index
  Case 0    'Felder...
    Call SelectFields

  Case 1    'Abkrzungen

    With HmTbl.mnuOptions(Index)
      .Checked = Not .Checked
      If .Checked Then
        w(3) = 3
        w(5) = 3
        w(6) = 3
        w(7) = 3
      Else
        w(3) = 8
        w(5) = 7
        w(6) = 8
        w(7) = 8
      End If
    End With

    Call InitGrid
    Call AdjustGrid
    Call FillGrid

  Case 2    'Schriftart...
    void& = CtlSelectFont(&H10401, HmTbl.CmDlg, HmTbl.Grd, Cancel)
    If Not Cancel Then
      Call InitGrid
      Call AdjustGrid
      Call FillGrid
    End If

  Case 3    'Immer im Vordergrund
    With HmTbl.mnuOptions(Index)
      .Checked = Not .Checked
      Call SetTop(HmTbl.hWnd, .Checked)
    End With

  End Select

End Sub

Function RetrieveRowData(StnNr As Long)

  For i = 0 To GrdCols - 1
    GrdRowData(i) = ""
  Next i

  If StnNr = 0 Then
    'berschriften
    Call GrdGetRowData(HmTbl.Grd, 0)
    Exit Function
  End If


  RetrieveRowData = True

  '--- Call holen ---
  Cmd$ = "GetStn:" & Str$(StnNr) & ",1"
  ErrNr = HMCommand(Cmd$, StnCall$)
  If ErrNr Then Exit Function


  '--- Stationszeilen holen ---
  Cmd$ = "GetStnLines:" & StnCall$

  ErrNr = HMCommand(Cmd$, ActStnLines$)
  If ErrNr Then Exit Function


  '--- Stationsinfo fr alle Zeilen holen ---
  'Abkrzungen
  If HmTbl.mnuOptions(1).Checked Then Mode$ = ",0" Else Mode$ = ",1"

  Cmd$ = ""
  Lines$ = ActStnLines$

  Do Until Len(Lines$) = 0
    Ln$ = Parse$(Lines$, ",")
    Cmd$ = Cmd$ & vbCrLf & "GetStnInfo:" & StnCall$ & "," & Ln$ & Mode$
  Loop

  ErrNr = HMCommand(Mid$(Cmd$, 3), Res$)
  If ErrNr Then Exit Function


  'Stationsinfo aufbereiten
  Lines$ = ActStnLines$

  Do Until Len(Lines$) = 0
    Ln$ = Parse$(Lines$, ",")
    STNINFO$ = Str$(StnNr) & "," & Parse$(Res$, vbCrLf)

    ColNr = 0

    For Fld = 0 To 13
      m$ = Parse$(STNINFO$, ",")

      If 2 ^ Fld And FieldMask Then
        If Fld = 8 Then
          'QRG
          QRG& = Val(m$) * 1000&
          If QRG& <= 0 Then
            m$ = ""
          Else
            Call Qrg2Str(QRG&, m$, sRxQrg$, sChannel$)
          End If
          'm$ = Format$(Val(m$), "#,##0.000; ; ")
        End If

        If Ln$ = "0" Then
          If Fld = 3 Then BaseStat$ = m$
        Else
          '--- Zusatzzeilen ---
          'Nr. und Call lschen
          If Fld <= 1 Then m$ = ""

          'Unbekannt lschen
          If m$ = UnKnown$(Fld) Then m$ = ""

          'Gleichen Status in Zusatzzeilen lschen
          If Fld = 3 And m$ = BaseStat$ Then m$ = ""
        End If

        If Len(m$) > 0 Then
          If Len(GrdRowData(ColNr)) > 0 Then m$ = GrdRowData(ColNr) & "+" & m$
          GrdRowData(ColNr) = m$
        End If
        ColNr = ColNr + 1
      End If
    Next Fld
  Loop

  RetrieveRowData = False

End Function

Sub SelectFields()

  Call CenterForm(FieldForm)

  For i = 0 To 13
    If i > 0 Then Load FieldForm.CheckField(i)
    FieldForm.CheckField(i).Top = 200 + 300 * i
    FieldForm.CheckField(i).Visible = True
    FieldForm.CheckField(i).Caption = Lbl$(i)
  Next i

  'CheckBoxes vorbelegen
  For i = 0 To 13
    If 2 ^ i And FieldMask Then
      FieldForm.CheckField(i).Value = 1
    Else
      FieldForm.CheckField(i).Value = 0
    End If
  Next i

  '----- Eingabe -----
  FieldForm.Show 1

  If FieldForm.Tag = "0" Then

    'Ergebnis auslesen
    FieldMask = 0
    GrdCols = 0

    For i = 0 To 13
      If FieldForm.CheckField(i).Value = 1 Then
        FieldMask = FieldMask + 2 ^ i
        GrdCols = GrdCols + 1
      End If
    Next i

    Call InitGrid
    Call AdjustGrid
    Call FillGrid
  End If

  Unload FieldForm
  Set FieldForm = Nothing

End Sub

Sub ShowMsg(ByVal t$)

  HmTbl.StatusBox.text = " " & t$

End Sub

