Attribute VB_Name = "HmApi"
DefInt A-Z

Public CommandList
Public ApiModeDde

Sub ClientNotify(EventNr As Integer, EventData As String)

  frmHmApi.NotifyField(EventNr).Caption = EventData
  Beep

End Sub

Sub ClientTerminate()

  Call ShowConnectState

  frmHmApi.StatusField.Caption = "Disconnected"

End Sub

Sub ConnectCommand()

  With frmHmApi
    .ResultField.text = ""

    If GV.HammapConnected Then
      '--- Disconnect ---
      Call HMDisconnect
      m$ = "Disconnected"
    Else
      '--- Connect ---
      .StatusField.Caption = "Loading HAMMAP"
      Call HMTimeout(Val(.TimeoutField.text))

      ErrNr = HMConnect((ApiModeDde And 1) Or 2)
      If ErrNr = 0 Then
        m$ = "Connected to HAMMAP"
        Call SetNotifyMask
      Else
        m$ = "OLE-Server not available"
      End If

    End If

    .StatusField.Caption = m$

    Call ShowConnectState
  End With

End Sub

Sub ExecuteCommand()

  With frmHmApi
    .StatusField.Caption = "Busy"
    .ResultField.text = ""
    Cmd$ = .CommandField.text
    DoEvents
    s$ = "Ok"

    If CommandList Then
      'Execute as Command-List
      ErrNr = HMCommand(Cmd$, r$)
      If ErrNr Then
        s$ = r$
        r$ = ""
      End If
    Else
      'Execeute as separate commands
      Do Until Len(Cmd$) = 0
        c1$ = Parse$(Cmd$, vbCrLf)
        ErrNr = HMCommand(c1$, r1$)
        If ErrNr Then s$ = "Error"
        r$ = r$ & r1$ & vbCrLf
      Loop
    End If

    .StatusField.Caption = s$
    .ResultField.text = r$
    .ResultField.SelStart = 0

    With .CommandField
      .SetFocus
      .SelStart = 0
      .SelLength = 32767
    End With
  End With

End Sub

Sub InitHmOle()

  ErrNr = InitHmTool("HMAPI", "DOS,HMSUB,HMAPI")
  If ErrNr Then
    Call ExitHMTool
    Exit Sub
  End If

  Call CenterForm(frmHmApi)
  Call ShowConnectState

  With frmHmApi
    .StatusField.Caption = "Disconnected"

    .StatusField.BackColor = &H80000005
    For i = 1 To AnzHmApiEvents
      .NotifyField(i).BackColor = &H80000005
    Next i

    void = SetReadOnly(.ResultField, True)

    .OleOpt(0).Value = True
    .ApiMode(0).Value = True
  End With

End Sub

Public Sub Quit()

  Call HMDisconnect

  Call ExitHMTool

End Sub

Sub SetNotifyMask()

  For i = 1 To AnzHmApiEvents
    Mask = Mask + frmHmApi.NotifyLabel(i).Value * 2 ^ (i - 1)
  Next i

  ErrNr = HMSetMask(Mask)

End Sub

Public Sub SetTimeout()

  Call HMTimeout(Val(frmHmApi.TimeoutField.text))

End Sub

Sub ShowConnectState()

  With frmHmApi

    .OkLight.FillStyle = 0     'Solid

    '.CommandLabel.Enabled = GV.HammapConnected
    '.CommandField.Enabled = GV.HammapConnected
    .ExecuteCmd.Enabled = GV.HammapConnected

    For i = 0 To 1
      .ApiMode(i).Enabled = Not GV.HammapConnected
    Next i

    If GV.HammapConnected Then
      '--- Connected ---
      .CommandField.SetFocus
      .ConnectCmd.Caption = "Disconnect"
      .OkLight.FillColor = RGB(0, 255, 0)
    Else
      '--- Disconnected ---
      .ConnectCmd.Caption = "Connect"
      .OkLight.FillColor = RGB(255, 0, 0)
    End If

    .ResultField.text = ""

  End With

End Sub

