VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HammapClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
DefInt A-Z
Option Explicit

Private WithEvents HM As HAMMAP
Attribute HM.VB_VarHelpID = -1

Friend Function Connect(Optional Timeout = 10)

  Dim Start As Date   'Date and Time

  Connect = True

  '--- Connect to HAMMAP ---
  Start = Now

  'Wait until HAMMAP Object is created
  Do
    On Error Resume Next
    Set HM = New HAMMAP
    On Error GoTo 0
    If Second(Now - Start) > Timeout Then Exit Function
  Loop While HM Is Nothing

  'Wait until HAMMAP is Ready
  Do
    DoEvents
    If Second(Now - Start) > Timeout Then Exit Function
  Loop Until HM.Ready

  HM.ClientName = App.Title

  Connect = False

End Function

Property Get Station() As String

  Station = HM.Station

End Property

Property Get Ready() As String

  Ready = HM.Ready

End Property

Property Let CallbackMask(Mask)

  HM.CallbackMask = Mask

End Property

Private Sub HM_Notify(EventNr As Integer, EventData As String)

  Call HmNotify(EventNr, EventData)

End Sub

Friend Function Command(Cmd$, Result$) As Long

  On Error Resume Next
  Result$ = HM.Action(Cmd$)
  If Err.Number Then
    Result$ = Err.Description
    If Err.Number < vbObjectError Then
      Command = -6      'OLE-Error
    Else
      Command = Err.Number - vbObjectError - 1004
    End If
  End If
  On Error GoTo 0

End Function

Private Sub HM_Terminate()

  'Terminate Event from HAMMAP
  Call Terminate

  Set HmClient = Nothing

  'Perform program specific Terminate
  Call ClientTerminate

  DoEvents

End Sub

Friend Sub Terminate()

  On Error Resume Next
  HM.Disconnect
  Set HM = Nothing
  On Error GoTo 0

  GV.HammapConnected = False

End Sub

