Attribute VB_Name = "HaminfoCommands"
DefInt A-Z
Option Explicit

Sub ClearMask()

  Dim i

  With frmDataMask

    ProgChange = True
    For i = 1 To dbAnzDsFields
      .Txt(i).text = ""
    Next i
    DoEvents
    ProgChange = False

  End With

End Sub

Sub PackDatabase(t$, Index)

  'Datenbank komprimieren

  Dim Filt$, SrcFile$, SrcTbl$, DstFile$, SQL$
  Dim Cancel, ErrNr, Found

  SrcFile$ = dbOpenDatabase
  SrcTbl$ = dbOpenTable

  'Ziel-Datenbank
  Filt$ = "Access-Datenbank (*.MDB)|*.MDB"
  'Flags: PathMustExist + NoChangeDir + HideReadOnly + Overwrite-Prompt
  Cancel = GetFileSpec(t$, 2, &H80E, ".", "MDB", Filt$, DstFile$)
  If Cancel Then Exit Sub

  If UCase$(SrcFile$) = UCase$(DstFile$) Then
    MsgBox Msg$(32299)
    Exit Sub
  End If

  ErrNr = CloseDB()
  If ErrNr Then Exit Sub

  ErrNr = DeleteFile(DstFile$, Found)
  If ErrNr Then Exit Sub

  Call ShowMsg(StdMsg$(32020 + Index) & Msg$(32259), False, 11)

  ErrNr = DAOCommand("CompactDB", SrcFile$, DstFile$, 32288)

  If Len(SrcFile$) = 0 Then
    Call ShowSelection
  Else
    ErrNr = OpenDB(SrcFile$)
    If ErrNr = 0 Then
      If Len(SrcTbl$) = 0 Then
        Call ShowSelection
      Else
        ErrNr = OpenTbl(SrcTbl$)
        If ErrNr = 0 Then
          ErrNr = SelectData(SelectClause & FromClause)
        End If
      End If
    End If
    If ErrNr Then ShowSelection
  End If

End Sub

Sub PrintCommand()

  Dim OptTitle$

  Call ShowMsg(Msg$(32253), 0, 11)

  OptTitle$ = WhereInfo & "  -  " & OrderInfo

  Call GrdPrintData(frmMain.Tbl, dbAnzDsRec, OptTitle$)

  Call ShowMsg("", True, 0)

End Sub

Sub SortCommand(Descending)

  Dim OldSort$, NewSort$, Direct$, DirectInfo$, SortOk, ErrFlg, SQL$, ErrNr

  'Vorhandenen Dynaset umsortieren
  OldSort$ = OrderAttrib

  OrderNr = Tbv.FirstFieldNr
  NewSort$ = dbDsFieldNames(OrderNr)
  If Descending Then
    Direct$ = " DESC"
    DirectInfo$ = " absteigend"
  End If
  OrderAttrib = NewSort$ & Direct$
  OrderClause = " ORDER BY " & dbName$(NewSort$) & Direct$
  OrderInfo = "Sortierung nach: " & "'" & NewSort$ & "'" & DirectInfo$

  If OrderAttrib = OldSort Then Exit Sub      'keine nderung

  Call ShowMsg(Msg$(32252), 0, 11)

  ds.Sort = OrderAttrib

  On Error Resume Next
  Set ds = ds.OpenRecordset()
  ErrFlg = Err
  On Error GoTo 0

  'Wenn ds nicht mehr zu sich selbst zugewiesen werden kann
  '  (max. ca. 10 mal) dann neu einlesen
  If ErrFlg Then
    ErrNr = SelectData(LastSQLQuery)
  End If

  Call ShowMsg("", False, 0)
  If ErrNr Then Exit Sub

  DsHasChanged = True

  Call MoveDS(0)
  Call ScrollBarSet(frmMain, 1, MaxRows)

  Call FillTable

End Sub

