Attribute VB_Name = "HMIF"
DefInt A-Z

'120 seconds = 2 minutes (10 seconds was not enough for 133 MHz system)
Const DefaultTimeout = 120

Dim ActualTimeout
Dim ConnectMode
Dim ApiOle
Dim EventNr
Dim EventData As String

Public HmClient As HammapClient

Function DDECommand(Cmd$, Result$)

  DDECommand = -6     'DDE-Error

  On Error Resume Next
  DdeForm.DDEResult.LinkExecute Cmd$
  ErrNr = Err
  ErrTxt$ = Error$
  On Error GoTo 0

  Select Case ErrNr
  Case 0, 285
    'Ergebnis bzw. Fehlertext abholen
    '285: Foreign application won't perform DDE method or operation
    On Error Resume Next
    DdeForm.DDEResult.LinkRequest
    ReqErrNr = Err
    Result$ = DdeForm.DDEResult.Caption
    On Error GoTo 0

    If ReqErrNr Then
      Result$ = Msg$(ReqErrNr)
    Else
      If ErrNr Then
        ErrNr = Val(Result$)
        Result$ = Msg$(25110 + ErrNr)
      End If
      DDECommand = ErrNr
    End If

  Case 286, 287
    '286: Timeout while waiting for DDE response from HAMMAP
    '287: User pressed ESC key during DDE operation
    Result$ = Msg$(ErrNr)

  Case 293
    '293: No Response from foreign application
    Result$ = Msg$(ErrNr)
    DdeForm.DDEResult.LinkMode = 0     'Off
    void = HMConnect((ConnectMode))

  Case Else
    Result$ = ErrTxt$
  End Select

  DoEvents

End Function

Function DDEConnect()

  On Error Resume Next
  DdeForm.DDEResult.LinkMode = 2                'Manual
  DDEConnect = Err
  On Error GoTo 0

End Function

Function DdePoll$(i)

  On Error Resume Next

  With DdeForm.NotifyField(i)
    SaveMode = .LinkMode
    .LinkMode = 2   'manual
    .LinkRequest
    DdePoll$ = .Caption
    .LinkMode = SaveMode
  End With

  On Error GoTo 0

End Function

Sub DdeTerminate()

  'Terminate DDE
  DoEvents
  GV.ProgChange = True
  DdeForm.DDEResult.LinkMode = 0          'None
  GV.ProgChange = False

  For i = 1 To AnzHmApiEvents
    DdeForm.NotifyField(i).LinkMode = 0   'None
  Next i

  Unload DdeForm
  Set DdeForm = Nothing

  GV.HammapConnected = False

  Call ClientTerminate

End Sub

Function HMCheckVer(v1$)

  HMCheckVer = True

  ErrNr = HMCommand("GetVer", V2$)
  If ErrNr Then Exit Function

  If Val(V2$) < Val(v1$) Then
    m$ = "Dieses Programm bentigt mindestens" & vbCrLf
    m$ = m$ & "HAMMAP Version " & v1$ & ". "
    m$ = m$ & "Ihre Version ist " & V2$ & "."
    MsgBox m$
    Exit Function
  End If

  HMCheckVer = False

End Function

Function HMCommand(ByVal Cmd$, Result$)

  Dim ErrNr As Long

  ErrNr = WaitForHmReady()
  If ErrNr Then
    Result$ = "HAMMAP Busy Timeout"
  Else
    If ApiOle Then

      ErrNr = HmClient.Command(Cmd$, Result$)

    Else

      'DDE bertrgt maximal 1024 Zeichen
      Result$ = ""
      Do
        ErrNr = DDECommand(Cmd$, r$)
        Result$ = Result$ & r$
        Cmd$ = ""
      Loop Until Len(r$) < 1024 Or ErrNr <> 0

    End If

  End If

  If (ConnectMode And 2) = 0 And ErrNr <> 0 Then
    MsgBox Result$
  End If

  HMCommand = (ErrNr <> 0)

End Function

Function HMConnect(Mode)

  'Mode: Bit 0=1: 0=default:Win32=OLE, Win16=DDE
  '               1=DDE
  '      Bit 1=2: dont't show errors
  '      Bit 2=4: delayed Notify
  '               (necessary if Notify causes other API-commands)

  ConnectMode = Mode

  ApiOle = (Mode And 1) = 0

  If ActualTimeout = 0 Then Call HMTimeout(DefaultTimeout)

  If ApiOle Then

    '----- OLE -----
    Set HmClient = New HammapClient

    ErrNr = HmClient.Connect(ActualTimeout)
    If ErrNr Then MsgBox "Verbindungs-Fehler mit HAMMAP"

  Else

    '----- DDE -----
    Load DdeForm

    ErrNr = DDEConnect()

    If ErrNr Then
      'HAMMAP starten
      f$ = HomeDir$ & "WIN32\HAMMAP32.EXE"
      On Error Resume Next
      Handle& = Shell(f$, 4)
      ErrNr = Err
      On Error GoTo 0

      If ErrNr = 0 Then ErrNr = WaitForHmReady()
      If ErrNr = 0 Then ErrNr = DDEConnect()

    End If

    If ErrNr Then
      Do
        m$ = "Starten Sie HAMMAP" & Chr$(13) & Chr$(10)
        m$ = m$ & "und bettigen Sie die 'Ok' Taste"
        iAntwort = MsgBox(m$, 1 + 48)
        If iAntwort = 2 Then Exit Do   'Cancel

        DdeForm.DDEResult.LinkMode = 0       'Disconnect
        DoEvents

        ErrNr = DDEConnect()
      Loop Until ErrNr = 0
    End If

    If ErrNr = 0 Then
      With DdeForm.ClientName
        .LinkMode = 2   'manual
        .Caption = ProgName$
        .LinkPoke
      End With
    End If

  End If

  GV.HammapConnected = (ErrNr = 0)
  HMConnect = ErrNr

End Function

Sub HMDisconnect()

  'Disconnect from Client
  'Terminate OLE from Client
  Static Busy

  'Avoid recursive calls when unloading forms
  If Busy Then Exit Sub

  Busy = True

  If GV.HammapConnected Then
    If ApiOle Then
      'OLE
      HmClient.Terminate
      Set HmClient = Nothing
    Else
      Call DdeTerminate
    End If
  End If

  'Perform program specific Terminate
  Call ClientTerminate

  DoEvents

  Busy = False

End Sub

Sub HmNotify(n, d$)

  If ConnectMode And 4 Then
    'delayed Notify
    EventNr = n
    EventData = d$
    DdeForm.NotifyTimer.Enabled = True
  Else
    Call ClientNotify(n, d$)
  End If

End Sub

Sub HmNotifyTimer()

  DdeForm.NotifyTimer.Enabled = False
  Call ClientNotify(EventNr, EventData)

End Sub

Function HMReady$()

  If ApiOle Then
    HMReady$ = HmClient.Ready
  Else
    HMReady$ = DdePoll$(2)
  End If

End Function

Function HMSetMask(Mask)

  If ApiOle Then

    On Error Resume Next
    HmClient.CallbackMask = Mask
    HMSetMask = Err
    On Error GoTo 0

  Else

    For i = 1 To AnzHmApiEvents
      If Mask And 2 ^ (i - 1) Then
        DdeForm.NotifyField(i).LinkMode = 1   'Automatic
      Else
        DdeForm.NotifyField(i).LinkMode = 0   'None
      End If
    Next i

  End If

End Function

Function HMStation$()

  If ApiOle Then
    HMStation$ = HmClient.Station
  Else
    HMStation$ = DdePoll$(1)
  End If

End Function

Sub HMTimeout(tout)

  ActualTimeout = tout

  If ApiOle Then
    App.OleRequestPendingTimeout = 1000& * tout
    App.OleRequestPendingMsgText = "HAMMAP OLE-Timeout"
    App.OleRequestPendingMsgTitle = ProgName$

    App.OleServerBusyTimeout = 1000& * tout
    App.OleServerBusyMsgText = "HAMMAP OLE-Busy-Timeout"
    App.OleServerBusyMsgTitle = ProgName$
  Else
    DdeForm.DDEResult.LinkTimeout = tout * 10
  End If

End Sub

Function WaitForHmReady()

  Const SleepTime = 500   'msec

  For i = 1 To ActualTimeout * 1000& / SleepTime
    DoEvents
    If Val(HMReady$()) Then Exit Function
    Call ApiSleep(500)
  Next i

  WaitForHmReady = True     'TimeOut

End Function

