Attribute VB_Name = "HamInfo"
'Globale Definitionen
DefInt A-Z

Option Explicit

Type TableVars
  'First Record in Table
  TableStart As Long

  'Selected Records/Fields
  FirstRecNr As Long
  LastRecNr As Long
  FirstFieldNr As Integer
  LastFieldNr As Integer

  'Actual Record/Field
  ActRecNr As Long
  ActFieldNr As Integer
  ActFieldName As String
End Type

Public Tbv As TableVars


Public FilterMsgSrc

Public MnuAllowEdit        'Menu State
Public DsAllowEdit         'Allow Edit in DataSet
Public AutoSave
Public NeedToSave
Public InsertMode

Public AddressMode

Public ProgResize

Public DataDir$                         'Data Directory

Public Fld As Field
Public Idx As Index

Public TopDist
Public Const FldDist = 500

Public NewTblColWidth

'--------------------------------------------------

Public FirstRec As Long                'First Record in Table
Public MaxRows As Integer              'Max. Anzahl Zeilen


Public ShowFlag As Integer             '0=nichts, 1=Maske, 2=Tabelle
Public DsHasChanged
Public TblHasChanged
Public ProgChange As Integer
Public FieldOverflow
Public GetMaxLength

Public MaxFieldLength()

'HAMMAP Variables
Public HammapPossible          '0=none, 1 =Locator, 2=Lnge/Breite
Public HMLocatorField
Public HMLongitudeField
Public HMLatitudeField

Sub Main()

  Dim ErrNr

  ErrNr = InitHamInfo()
  If ErrNr Then
    Call appQuit
    Exit Sub
  End If

  'Fenster auf Bildschirm zentrieren und anzeigen
  ProgResize = True
  With frmMain
    .Tbl.Visible = False
    .ScrollBar.Visible = False
    Call CenterForm(frmMain)
    .Show
    DoEvents
  End With
  ProgResize = False

  'Default Datenbank ffnen
  Screen.MousePointer = 11
  Call OpenDefaultDB
  Screen.MousePointer = 0

End Sub

Function appGetDataTip$()

  Dim m$

  m$ = "! = Berg (Hhe) - "
  m$ = m$ & "$ = Landschaft,Schlo,Burg - "
  m$ = m$ & "% = See - "
  m$ = m$ & "* = Insel - "
  m$ = m$ & "& = Lustiger Name - "
  m$ = m$ & "# = Alm,Berghtte,Gut"

  appGetDataTip$ = m$

End Function

Sub appHMConnect()

  Dim ErrNr

  ErrNr = HMConnect(0)
  If ErrNr = 0 Then
    ErrNr = HMCheckVer("11.0")
    If ErrNr Then
      Call HMDisconnect
    Else
      Call CheckHammapPossible
    End If
  End If

End Sub

Sub appKeyInput(Index, KeyAscii)

  Dim c$, tb$

  Select Case dbOpenTable
  Case "tblLocator"
    c$ = Chr$(KeyAscii)
    tb$ = Chr$(8)

    Select Case Index
    Case 1, 2, 5      'Locator, Distrikt, DXCC
      Select Case c$
      Case tb$
      Case "a" To "z"
        KeyAscii = Asc(UCase$(c$))
      Case "0" To "9", "A" To "Z"
      Case Else
        KeyAscii = 0
        Beep
      End Select

    Case 4            'Extra
      Select Case c$
      Case tb$
      Case "!", "$", "%", "*", "&", "#"
      Case Else
        KeyAscii = 0
        Beep
      End Select

    End Select
  End Select

End Sub

Sub appQuit()

  Dim void

  'Muss vor CloseDB stehen
  Call appSaveParameter

  void = CloseDB()

  If LogFileNr Then void = CloseFile(LogFileNr)

  'Disconnect HAMMAP
  Call HMDisconnect

  'Close forms and terminate
  Call ExitHMTool

End Sub

Sub appSaveParameter()

  Dim m$, ErrNr

  'Einstellungen speichern
  NumPar(1).Actual = MnuAllowEdit And 1 Or AutoSave And 2
  NumPar(2).Actual = GV.HammapConnected And 1
  NumPar(6).Actual = frmMain.Tbl.FontSize * 1000
  NumPar(7).Actual = frmMain.Tbl.FontBold And 1 Or frmMain.Tbl.FontItalic And 2

  StrPar(3, 1) = dbOpenDatabase
  StrPar(3, 2) = dbOpenTable
  StrPar(3, 3) = LogFileSpec
  StrPar(3, 8) = frmMain.Tbl.FontName

  m$ = Params2Str$(0)
  ErrNr = WriteParameter(InParFile$, "[HAMINFO]", m$)

End Sub

Function CalcColWidth(i)

  Dim n

  n = dbTblColWidth(i)
  CalcColWidth = 6 * Log(n * 2 + 5) - 10

End Function

Sub CheckHammapPossible()

  HammapPossible = 0

  If GV.HammapConnected And Not ds Is Nothing Then
    If ds.RecordCount > 0 Then
      HMLocatorField = GetDsFieldNr("Locator")
      If HMLocatorField >= 0 Then
        HammapPossible = 1
      Else
        HMLongitudeField = GetDsFieldNr("Lnge")
        If HMLongitudeField < 0 Then
          HMLongitudeField = GetDsFieldNr("Longitude")
        End If

        HMLatitudeField = GetDsFieldNr("Breite")
        If HMLatitudeField < 0 Then
          HMLatitudeField = GetDsFieldNr("Latitude")
        End If

        If HMLongitudeField >= 0 And HMLatitudeField >= 0 Then
          HammapPossible = 2
        End If
      End If
    End If
  End If

End Sub

Sub ClientNotify(EventNr As Integer, EventData As String)

  'No action

End Sub

Sub ClientTerminate()

  'Bei Beenden von HAMMAP wird HAMINFO nicht beendet

End Sub

Sub DeleteRecord()

  Dim m$, Answer
  Dim RecNr As Long

  If Not AutoSave Then
    m$ = "Wollen Sie den Datensatz wirklich lschen ?"
    Answer = MsgBox(m$, 4 + 32)
    If Answer = 7 Then Exit Sub
  End If


  '--- Delete record ---
  With ds
    .Delete

    dbAnzDsRec = dbAnzDsRec - 1
    TblHasChanged = True

    RecNr = ScrollBarGet(frmDataMask)
    If RecNr = 0 Then
      InsertMode = True
      Call ClearMask
    ElseIf RecNr > dbAnzDsRec Then
      RecNr = RecNr - 1
      .MovePrevious
    Else
      .MoveNext
    End If

    Call ScrollBarInit(frmDataMask, 1)
    Call ScrollBarSet(frmDataMask, RecNr, 1)
    Call FillMask
  End With

End Sub

Sub EnblMenus()

  Dim i, c1, c2, c3

  With frmMain

    '        0                                'Datei
    .mnuMain(1).Enabled = dbDatabaseIsOpen    'Import
    .mnuMain(2).Enabled = (dbAnzDsRec > 0)    'Export
    .mnuMain(3).Enabled = dbDatabaseIsOpen    'Tabelle
    '.mnuMain(4).Enabled = (dbAnzDsRec > 0)   'Bearbeiten
    .mnuMain(5).Enabled = dbTableIsOpen       'Suchen
    .mnuMain(6).Enabled = (dbAnzDsRec > 1)    'Sortieren
    .mnuMain(7).Visible = GV.DesignMode       'Design
    .mnuMain(8).Visible = GV.HammapMode       'HAMMAP
    .mnuMain(9).Visible = AddressMode         'Adressen
    '        10                               'Einstellungen
    '        11                               'Info


    'Men Datei
    .pdmnuFile(0).Enabled = True                  'Datenbank ffnen
    .pdmnuFile(1).Enabled = dbDatabaseIsOpen      'Datenbank schlieen
    '---      (2)
    .pdmnuFile(3).Enabled = True                  'Datenbank anlegen
    .pdmnuFile(4).Enabled = dbDatabaseIsOpen      'Datenbank komprimieren
    .pdmnuFile(5).Enabled = Not dbDatabaseIsOpen  'Datenbank reparieren
    '---      (6)
    .pdmnuFile(7).Enabled = (dbAnzDsRec > 0) And Prt.Installed   'Drucken
    .pdmnuFile(8).Enabled = Prt.Installed         'Drucker-Schriftart
    .pdmnuFile(9).Enabled = Prt.Installed         'Seite einrichten
    .pdmnuFile(10).Enabled = True                 'Drucker einrichten
    '---      (11)
    .pdmnuFile(12).Checked = (LogFileNr > 0)      'LogFile
    .pdmnuFile(12).Visible = GV.ExpertMode


    'Men Import
    For i = 4 To 8
      .pdmnuImport(i).Visible = GV.HammapMode
    Next i

    'Men Export


    'Men Tabelle
    .pdmnuTable(0).Enabled = dbAnzTables > 0      'Tabelle ffnen
    .pdmnuTable(1).Enabled = dbTableIsOpen        'Tabelle schlieen
    '---       (2)
    .pdmnuTable(3).Enabled = dbDatabaseIsOpen     'Tabelle anlegen

    .pdmnuTable(4).Enabled = dbTableIsOpen        'Tabelle umbenennen
    .pdmnuTable(5).Enabled = dbTableIsOpen        'Tabelle lschen
    '---       (6)
    c1 = dbTableIsOpen And dbDsIsTable
    .pdmnuTable(7).Enabled = c1                 'Feld anlegen
    .pdmnuTable(8).Enabled = c1                 'Feld umbenennen
    .pdmnuTable(9).Enabled = c1                 'Feld lschen


    'Men Bearbeiten
    .pdmnuEdit(0).Enabled = (dbAnzDsRec > 0)
    For i = 4 To 6
      .pdmnuEdit(i).Enabled = (dbAnzDsRec > 0)
    Next i
    .pdmnuEdit(8).Enabled = (dbAnzDsRec > 0)

    For i = 9 To 10
      .pdmnuEdit(i).Visible = GV.ExpertMode
    Next i


    'Men Suchen
    .pdmnuSearch(1).Enabled = dbTableIsOpen And dbDsIsTable
    .pdmnuSearch(2).Visible = GV.ExpertMode        'SQL-Abfrage


    'Menu Design
    If dbDsIsTable Then
      c1 = ExistTblField("Name") And ExistTblField("Hhe")
      c2 = ExistTblField("Lnge") And ExistTblField("Breite")
      c3 = ExistTblField("Abstand") And ExistTblField("Rang")
    Else
      c1 = False
    End If

    .pdmnuDesign(1).Enabled = c1 And c2 And c3    'Berge analysieren
    .pdmnuDesign(2).Enabled = c1 And c2 And c3    'Berge exportieren


    'Men HAMMAP see Sub MainMenuFunctions wg. HMDisconnect

    'Men Info
    For i = 2 To 4
      .pdmnuInfo(i).Visible = GV.HammapMode
    Next i

    For i = 5 To 10
      .pdmnuInfo(i).Visible = GV.ExpertMode
    Next i


    'Popup-Men

  End With

End Sub

Sub Extras(KeyAscii)

  Select Case KeyAscii
  Case 4           'Ctrl-D
    GV.DesignMode = Not GV.DesignMode
    Call ShowSelection
  Case 24          'Ctrl-X
    GV.ExpertMode = Not GV.ExpertMode
    Call ShowSelection
  End Select

End Sub

Sub FillTable()

  'Datenstze in Tabelle ausgeben
  ' (Anfang durch Scrollbar definiert)

  Dim m$, RowNr, i
  Dim RecNr As Long
  Dim AnzRows As Long

  Static OldFirst As Long
  Static OldRows As Long

  If frmMain.Tbl.Visible = False Then Exit Sub

  Select Case dbAnzDsRec
  Case 0
    'kein Datensatz
    m$ = Msg$(32260)
  Case 1
    m$ = Msg$(32261)
  Case Else
    m$ = Format$(dbAnzDsRec, "#,##0 ") & Msg$(32262) & " ("
    m$ = m$ & OrderInfo & ")"
  End Select

  Call ShowMsg(m$, 0, 0)

  With frmMain.Tbl
    Tbv.TableStart = ScrollBarGet(frmMain)
    Call ScrollBarSet(frmMain, Tbv.TableStart, MaxRows)
    AnzRows = dbAnzDsRec - Tbv.TableStart + 1
    If AnzRows > MaxRows Then AnzRows = MaxRows

    If OldFirst = Tbv.TableStart And OldRows = AnzRows _
      And Not DsHasChanged Then Exit Sub

    Screen.MousePointer = 11

    OldFirst = Tbv.TableStart
    OldRows = AnzRows
    DsHasChanged = False

    .Rows = AnzRows + 1
    .FixedRows = 1

    For RowNr = 1 To AnzRows
      .row = RowNr
      RecNr = Tbv.TableStart + RowNr - 1

      'Datensatz holen
      If dbAnzDsRec > 0 Then Call RetrieveRecord(RecNr)

      'Datenfelder ausgeben
      For i = 0 To dbAnzDsFields
        .Col = i
        If dbAnzDsRec > 0 Then
          .text = dbDsFieldData(i - 1)
        Else
          .text = ""
        End If
      Next i

    Next RowNr

    .row = 1
    .SelStartRow = 1
    .SelEndRow = 1

    .Col = 1
    .SelStartCol = 1
    .SelEndCol = 1

    Call SetTableVars

  End With

  Screen.MousePointer = 0

End Sub

Function FilterMsg$(MsgNr)

  Select Case FilterMsgSrc
  Case 0
    If MsgNr > dbAnzTables Then
      FilterMsg$ = ""
    Else
      FilterMsg$ = dbTableNames(MsgNr + 1)
    End If

  Case 1
    If MsgNr > dbExtAnzTables Then
      FilterMsg$ = ""
    Else
      FilterMsg$ = dbExtTableNames(MsgNr + 1)
    End If

  Case 2
    If MsgNr > dbAnzTblFields Then
      FilterMsg$ = ""
    ElseIf MsgNr = 0 Then
      FilterMsg$ = "unsortiert"
    Else
      FilterMsg$ = dbTblFieldNames(MsgNr - 1)
    End If

  Case 3
    If MsgNr >= dbAnzTblFields Then
      FilterMsg$ = ""
    Else
      FilterMsg$ = dbTblFieldNames(MsgNr)
    End If

  End Select

End Function

Function GetConnectPar(ExtFile$, ExtType$, ExtDB$, ExtTbl$)

  'Input:  ExtFile$, ExtType$
  'Output: ExtDB$, ExtTbl$

  Dim d$, p$, n$, e$

  GetConnectPar = True

  Call ParseFileSpec(ExtFile$, d$, p$, n$, e$)

  If ExtType$ = "EXCEL 7.0" Then ExtType$ = "EXCEL 5.0"

  Select Case ExtType$
  Case "Access"
    ExtDB$ = ExtFile$

  Case "dBASE III", "dBASE IV", "dBASE 5.0"
    ExtDB$ = d$ & p$
    ExtTbl$ = n$

  Case "Text"
    ExtDB$ = d$ & p$
    ExtTbl$ = n$ & e$ 'e$ ist ntig fr File-Extension

  Case "EXCEL 3.0", "EXCEL 4.0"
    ExtDB$ = d$ & p$
    ExtTbl$ = n$

  Case "EXCEL 5.0", "EXCEL 7.0", "EXCEL 8.0"
    ExtDB$ = ExtFile$
    'ExtDB$ = d$ + p$ + n$

  Case ""   'HAMMAP

  Case Else
    MsgBox "Ungltiger externer Datenbanktyp"
    Exit Function
  End Select

  GetConnectPar = False

End Function

Function GetDsRecNr() As Long


  GetDsRecNr = Tbv.TableStart + frmMain.Tbl.row - 1&


End Function

Function GetExtTable(Import, ExtType$, ExtFile$, ExtTable$)

  Dim ErrNr, Exist, Cancel, DefName$

  GetExtTable = True

  If ExtType$ = "Access" Then

    ErrNr = ExistFile(ExtFile$, False, Exist)
    If ErrNr Then Exit Function

    If Exist Then
      'Datenbank existiert (Export oder Import)
      ErrNr = RegisterExtDBTables(ExtFile$)
      If ErrNr Then Exit Function

      Cancel = SelectExtTable(Import, Exist, ExtFile$, ExtTable$)

      Erase dbExtTableNames

      ErrNr = DAOCommand("CloseExtDB", "", "", 32289)
      If Cancel Or ErrNr Then Exit Function

    Else
      'Datenbank existiert nicht (Export)
      Cancel = SelectExtTable(Import, Exist, ExtFile$, ExtTable$)
      'Cancel does not create new database
      If Cancel Then Exit Function

      ErrNr = DAOCommand("CreateExtDB", ExtFile$, "", 32283)
      If ErrNr Then Exit Function

      ErrNr = DAOCommand("CloseExtDB", "", "", 32289)
      If ErrNr Then Exit Function
    End If

  Else
    'EXCEL
    DefName$ = ExtTable$
    Cancel = GetInput(ProgName$, "EXCEL-Tabelle", DefName$, ExtTable$)
    If Cancel Then Exit Function
  End If

  GetExtTable = False

End Function

Function GetInsertOptions(DstTbl$, ImportMode)

  Dim i

  With frmImpOpt

    .ImportOpt(0).Value = True
    .frameOldTbl.BorderStyle = 0

    Select Case dbAnzTables
    Case 0
      .ImportOpt(1).Enabled = False
      .txtOldTbl.Enabled = False
      .OldTblOpt(0).Enabled = False
      .OldTblOpt(1).Enabled = False

    Case 1
      .OldTblOpt(0).Value = True
      .txtOldTbl.AddItem dbTableNames(1)
      'geht nicht in VB3
      .txtOldTbl.text = dbTableNames(1)

    Case Else
      .OldTblOpt(0).Value = True

      For i = 1 To dbAnzTables
        .txtOldTbl.AddItem dbTableNames(i)
      Next i
    End Select

    .Show 1

    DstTbl$ = .Tag

    If .ImportOpt(0).Value Then
      ImportMode = 0  'Neue Tabelle
    ElseIf .OldTblOpt(0).Value Then
      ImportMode = 1  'Einfgen
    Else
      ImportMode = 2  'berschreiben
    End If

    GetInsertOptions = (Len(DstTbl$) = 0) 'Abbruch

  End With

  Unload frmImpOpt
  Set frmImpOpt = Nothing

End Function

Sub GetRecord()

  'Liest Daten aus der Maske aus
  Dim i

  For i = 1 To dbAnzDsFields
    dbDsFieldData(i - 1) = frmDataMask.Txt(i).text
  Next i

End Sub

Sub GetTableFormat(MsgBase, NameList$, TypeList$, AnzFields, OEMChrSet)

  Dim i, m$

  NameList$ = ""
  TypeList$ = ""
  AnzFields = 0

  m$ = Msg$(MsgBase)
  AnzFields = Val(Parse$(m$, ":"))
  OEMChrSet = (m$ = "OEM")

  For i = 1 To AnzFields
    m$ = Msg$(MsgBase + i)
    NameList$ = NameList$ & "|" & Parse$(m$, ":")
    If m$ = "" Or m$ = "T0" Then m$ = "T10"
    TypeList$ = TypeList$ & "|" & m$
  Next i

  NameList$ = Mid$(NameList$, 2)
  TypeList$ = Mid$(TypeList$, 2)

End Sub

Function ImportHMTable(SrcFile$, MsgBase, Sep$, ImportMode, DstTbl$)

  Dim ErrNr, ErrField, ErrDesc$
  Dim SrcFileNr, InputLine$, c1$, i, t$
  Dim NameList$, TypeList$, AnzFields, OEMChrSet

  ImportHMTable = True

  ErrNr = OpenFile(SrcFile$, "I", 0, SrcFileNr)
  If ErrNr Then Exit Function

  Call GetTableFormat(MsgBase, NameList$, TypeList$, AnzFields, OEMChrSet)
  ReDim dbDsFieldData(0 To AnzFields - 1)

  If GetMaxLength Then
    ReDim MaxFieldLength(0 To AnzFields - 1)
  End If

  If ImportMode <> 1 Then
    ErrNr = CreateTable(DstTbl$, NameList$, TypeList$)
    If ErrNr Then Exit Function
  End If

  ErrNr = SQLQuery("SELECT * FROM " & dbName$(DstTbl$))
  If ErrNr Then Exit Function

  FieldOverflow = False

  Do Until EOF(SrcFileNr)
    ErrNr = ReadLine(SrcFileNr, InputLine$)
    If ErrNr Then Exit Do

    If OEMChrSet Then
      InputLine$ = Pc8toAnsi$(Trim$(InputLine$))
    Else
      InputLine$ = Trim$(InputLine$)
    End If

    If Len(InputLine$) > 0 Then
      c1$ = Left$(InputLine$, 1)
      If c1$ <> "#" And c1$ <> ";" Then
        For i = 0 To AnzFields - 1
          dbDsFieldData(i) = Parse$(InputLine$, Sep$)
          If GetMaxLength Then
            If Len(dbDsFieldData(i)) > MaxFieldLength(i) Then
              MaxFieldLength(i) = Len(dbDsFieldData(i))
            End If
          End If
        Next i
        ErrNr = StoreRecord(True, ErrField)
        If ErrNr Then Exit Do
      End If
    End If
  Loop
  If ErrNr Then Exit Function

  If FieldOverflow Then
    MsgBox "Ein oder mehrere Felder waren zu lang"
  End If

  ErrNr = CloseFile(SrcFileNr)
  If ErrNr Then Exit Function

  ErrNr = CloseTable()
  If ErrNr Then Exit Function

  Call RegisterTables

  If GetMaxLength Then
    t$ = ""
    For i = 0 To AnzFields - 1
      t$ = t$ & vbCrLf & Parse$(NameList$, "|") & ": " & Str$(MaxFieldLength(i))
    Next i
    MsgBox Mid$(t$, 3), , "Max.Feldlnge"
    Erase MaxFieldLength
  End If

  ImportHMTable = False

End Function

Function ImportLocator(dBaseFileSpec$)

  Dim AccessFileSpec$, AccessTableName$, SQL$
  Dim SrcDB$, SrcTbl$, SrcType$
  Dim Found, ErrNr, Exist, AnzIdx, i, f$
  Dim d$, p$, n$, e$

  ImportLocator = True

  Call ParseFileSpec(dBaseFileSpec$, d$, p$, n$, e$)
  AccessFileSpec$ = d$ & p$ & n$ & ".MDB"
  AccessTableName$ = "tblLocator"


  'Evtl. offene Datenbank schlieen
  ErrNr = CloseDB()


  'Create Access Database
  ErrNr = CreateDB(AccessFileSpec$, 3)      'Access 3.0
  SrcType$ = "dBASE 5.0"
  If ErrNr Then Exit Function


  '--- Import dBASE Database ---
  ErrNr = GetConnectPar(dBaseFileSpec$, SrcType$, SrcDB$, SrcTbl$)
  If ErrNr Then Exit Function
  ErrNr = ImportDB(SrcDB$, SrcTbl$, SrcType$, 0, AccessTableName$)

  If ErrNr Then
    'Import fehlerhaft
    ErrNr = CloseDB()
    ErrNr = DeleteFile(AccessFileSpec$, Found)
    f$ = Left$(AccessFileSpec$, Len(AccessFileSpec$) - 4) & ".LDB"
    ErrNr = DeleteFile(f$, Found)
    ErrNr = True
  Else
    'Import ok
    ErrNr = OpenTbl(AccessTableName$)
  End If

  'Feldnamen ndern: LOCATOR -> Locator usw.
    If ErrNr = 0 Then
      For i = 0 To dbTblDef.Fields.Count - 1
        n$ = dbTblDef.Fields(i).Name
        If n$ <> "DXCC" Then
          dbTblDef.Fields(i).Name = Left$(n$, 1) & LCase$(Mid$(n$, 2))
        End If
      Next i

      'Register modified field names
      DB.TableDefs.Refresh
      Call RegisterTblFields
    End If

  If ErrNr Then MsgBox Msg$(32281)
  If ErrNr Then Exit Function


  '--- Index anlegen ---
  Call ShowMsg(Msg$(32256) & Msg$(32259), 0, 11)
  Call CreateIndex(0, 0, 5)

  DB.TableDefs.Refresh

  ImportLocator = False

End Function

Function InitHamInfo()

  InitHamInfo = True

  Dim i, ErrNr, Mode, void, FileNr, Found, Par$

  ReDim dbTblColWidth(-1 To -1)

  OrderInfo = "unsortiert"

  ErrNr = InitHmTool("HAMINFO", "DOS,HMSUB,HAMINFO,HMAPI")
  If ErrNr Then Exit Function

  AddressMode = FindCmdOpt("/A", Par$)


  DataDir$ = HomeDir$ & "DB32\"
  ErrNr = ChangePath(DataDir$)
  If ErrNr Then Exit Function

  Call InitMenu

  With frmMain
    void = SetReadOnly(.StatusBox, True)
    .StatusContainer.BackColor = &H8000000F
    .StatusBox.BackColor = &H8000000F
  End With

  'Parameter laden
  ErrNr = LoadParameter(InParFile$, "[HAMINFO]", False, Found)
  If ErrNr Then Exit Function

  'HAMMAP aktivieren
  If (NumPar(2).Actual And 1) <> 0 And GV.HammapMode Then
    Call appHMConnect
  End If

  'Druckausgabe initialisieren
  With Prt
    .ListTitle = App.Title

    For i = 1 To 4
      .OptEnbl(i) = True
      .OptValue(i) = 1
    Next i

    .OptValue(3) = 0
    .OptCaption(3) = "Suche + Sortierung"
  End With

  Call PrtInit

  InitHamInfo = False

End Function

Sub InitMask(Frm As Form, DynaSrc, ReadOnly)

  Dim i, void, imax, ActTop

  With Frm

    TopDist = .Lbl(1).Top
    ActTop = TopDist

    If DynaSrc = 0 Then
      imax = dbAnzTblFields
    Else
      imax = dbAnzDsFields
    End If

    For i = 1 To imax
      If i > 1 Then
        On Error Resume Next
        Load .Lbl(i)
        Load .Txt(i)
        On Error GoTo 0
      End If

      If DynaSrc = 0 Then
        .Lbl(i).Caption = dbTblFieldNames(i - 1)
      Else
        .Lbl(i).Caption = dbDsFieldNames(i - 1)
        .Txt(i).MaxLength = dbDsFieldWidth(i - 1)
      End If

      .Lbl(i).Top = ActTop
      .Lbl(i).Visible = True
      .Txt(i).Top = ActTop
      .Txt(i).TabIndex = i - 1
      .Txt(i).Visible = True
      ActTop = ActTop + FldDist
      If ReadOnly Then
        void = SendMessageBynum(.Txt(i).hWnd, EM_SETREADONLY, True, 0&)
      End If
    Next i

  End With

End Sub

Sub InitMenu()


  Dim MenuNr, i, m$

  '--- Mens ---
  Call SetMsgMode(1)

  ReDim MsgBase(0 To 17)

  MsgBase(0) = 32000         'Hauptmen
  MsgBase(1) = 32020         'File
  MsgBase(2) = 32550         'Access-Versions
  MsgBase(3) = 32060         'Import
  MsgBase(4) = 32070         'Export
  MsgBase(5) = 32080         'dBase-Versions
  MsgBase(6) = 32090         'EXCEL-Versions
  MsgBase(7) = 32085         'Text-Versions
  MsgBase(8) = 32100         'DXCC-Versions
  MsgBase(9) = 32040         'Tabelle
  MsgBase(10) = 32110        'Bearbeiten
  MsgBase(11) = 32170        'Suchen
  MsgBase(12) = 32220        'Sortieren
  MsgBase(13) = 32180        'HAMMAP
  MsgBase(14) = 32700        'Adressen
  MsgBase(15) = 32230        'Design
  MsgBase(16) = 32200        'Info
  MsgBase(17) = 32240        'Einstellungen


  With frmMain

    For MenuNr = 0 To UBound(MsgBase)
      i = 0
      Do
        m$ = Msg$(MsgBase(MenuNr) + i)
        If Len(m$) = 0 Then Exit Do

        'On Error Resume Next

        Select Case MenuNr
        Case 0    'Haupt-Men
          Call SetMenuItem(.mnuMain(i), m$)

        Case 1    'File-Menu
          If i > 4 Then Load .pdmnuFile(i)
          Call SetMenuItem(.pdmnuFile(i), m$)

        Case 2    'Access Version
          If i > 1 Then Load .pdmnuCreateDB(i)
          Call SetMenuItem(.pdmnuCreateDB(i), m$)

        Case 3    'Import Men
          'If i > 3 Then Load .pdmnuImport(i)
          Call SetMenuItem(.pdmnuImport(i), m$)

        Case 4    'Export Men
          Call SetMenuItem(.pdmnuExport(i), m$)

        Case 5    'dBase-Versionen
          If i > 0 Then Load .pdmnuImportdBASE(i)
          Call SetMenuItem(.pdmnuImportdBASE(i), m$)
          If i > 0 Then Load .pdmnuExportdBASE(i)
          Call SetMenuItem(.pdmnuExportdBASE(i), m$)

        Case 6    'EXCEL-Versionen
          If i > 0 Then Load .pdmnuImportEXCEL(i)
          Call SetMenuItem(.pdmnuImportEXCEL(i), m$)
          If i > 0 Then Load .pdmnuExportEXCEL(i)
          Call SetMenuItem(.pdmnuExportEXCEL(i), m$)

        Case 7    'Text-Versionen
          If i > 0 Then Load .pdmnuExportText(i)
          Call SetMenuItem(.pdmnuExportText(i), m$)

        Case 8  'DXCC-Versionen
          If i > 0 Then Load .pdmnuImportDXCC(i)
          Call SetMenuItem(.pdmnuImportDXCC(i), m$)

        Case 9    'Men Tabelle
          If i > 0 Then Load .pdmnuTable(i)
          Call SetMenuItem(.pdmnuTable(i), m$)

        Case 10   'Men Bearbeiten
          If i > 4 Then Load .pdmnuEdit(i)
          Call SetMenuItem(.pdmnuEdit(i), m$)

        Case 11   'Men Suchen
          If i > 0 Then Load .pdmnuSearch(i)
          Call SetMenuItem(.pdmnuSearch(i), m$)

        Case 12   'Men Sortieren
          If i > 0 Then Load .pdmnuSort(i)
          Call SetMenuItem(.pdmnuSort(i), m$)

        Case 13   'Men HAMMAP
          If i > 0 Then Load .pdmnuHAMMAP(i)
          Call SetMenuItem(.pdmnuHAMMAP(i), m$)

        Case 14   'Men Adressen   $$$ADR
          If i > 0 Then Load .pdmnuAddr(i)
          Call SetMenuItem(.pdmnuAddr(i), m$)

        Case 15   'Men Design
          If i > 0 Then Load .pdmnuDesign(i)
          Call SetMenuItem(.pdmnuDesign(i), m$)

        Case 16   'Men Info
          If i > 1 Then Load .pdmnuInfo(i)
          Call SetMenuItem(.pdmnuInfo(i), m$)

        Case 17   'Men Einstellungen
          If i > 0 Then Load .pdmnuOptions(i)
          Call SetMenuItem(.pdmnuOptions(i), m$)

        End Select

        'On Error GoTo 0

        i = i + 1
      Loop
    Next MenuNr

  End With

  Call SetMsgMode(0)

  Erase MsgBase

End Sub

Sub InitParameter()         '***$$$ADR

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (CheckBoxMask)
  '        muss NumPar.Max = 0 sein (oder nicht definiert) !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '        NumPar(...).Label = ""

  ReDim NumPar(1 To 9) As NumParType

  Call InitNumPar(1, "EditOptions", 1&, 0&, 3&)
  NumPar(2).Label = "HammapEnable": NumPar(2).Default = 0&
  NumPar(3).Label = "HammapOptions": NumPar(3).Default = &H2A5&
  Call InitNumPar(4, "ImportMask", 0&, 0&, 0&)
  Call InitNumPar(5, "ExportMask", 0&, 0&, 0&)
  Call InitNumPar(6, "ScrFontSize", 8&, 0&, 100000)
  Call InitNumPar(7, "ScrFontStyle", 0&, 0&, 3&)
  Call InitNumPar(8, "HammapSymbol", 0&, 0&, 12&)
  Call InitNumPar(9, "HammapColor", 0&, 0&, 0&)


  '--- String-Parameter setzen ---
  'Index 1: 1 = Name, 2 = Default, 3 = Actual, 4 = Multiline
  'Index 2: lfd. Nummer des Parameters
  ReDim StrPar(1 To 4, 1 To 9) As String

  Call InitStrPar(1, "Database32", "", "")
  Call InitStrPar(2, "Table", "", "")
  Call InitStrPar(3, "LogFile", "", "")

  Call InitStrPar(4, "TelCdPrg", "", "")
  Call InitStrPar(5, "Europa30", "", "")
  Call InitStrPar(6, "KlickTel", "", "")
  Call InitStrPar(7, "Palm", "", "")

  Call InitStrPar(8, "ScrFontName", "MS Sans Serif", "")
  Call InitStrPar(9, "Database16", "", "")

End Sub

Sub InitTable()

  Dim i

  gblGrd.AnzCols = dbAnzDsFields + 1
  Call GrdInitGrid(frmMain.Tbl)

  'Tabelle initialisieren
  With frmMain.Tbl
    .Rows = 2
    .FixedAlignment(0) = 2       'Lfd.Nr - zentriert

    For i = 0 To dbAnzDsFields
      .Col = i
      .row = 0
      .text = dbDsFieldNames(i - 1)
      .row = 1
      .text = ""
    Next i
  End With

End Sub

Sub MaskFunctions(Index)

  Dim i, ErrNr, ErrField

  With frmDataMask
    Select Case Index
    Case 0      'Schlieen
      'wenn Autosave: Speichern
      'wenn nicht Autosave: Abbrechen (mit Besttigung bei nderungen)
      Call RecordCheckSave
      .Hide

    Case 1      'Neu
      Call RecordCheckSave
      Call ClearMask

      InsertMode = True
      Call SetChangeState(False)

    Case 2       'Lschen
      Call DeleteRecord

    Case 3       'Rckgngig
      ProgChange = True
      For i = 1 To dbAnzDsFields
        .Txt(i).text = .Txt(i).Tag      'Undo
      Next i
      DoEvents
      ProgChange = False

      InsertMode = dbAnzDsRec = 0
      Call SetChangeState(False)

    Case 4      'Speichern
      Call GetRecord
      ErrNr = StoreRecord(InsertMode, ErrField)
      If ErrField < 0 Then Call ShowUpdate

    End Select

    Select Case Index
    Case 1 To 3
      .Txt(1).SetFocus
    Case 4      'Speichern
      If ErrField < 0 Then
        .Txt(1).SetFocus
      Else
        .Txt(ErrField + 1).SetFocus
      End If
    End Select

  End With

End Sub

Sub OpenDefaultDB()

  Dim ErrNr, Cancel, OldMouse
  Dim NewDatabase$, NewTable$, d$, p$, n$, e$

  If GV.AnzCmdFiles = 0 Then
    NewDatabase$ = StrPar(3, 1)
    NewTable$ = StrPar(3, 2)
  Else
    NewDatabase$ = CmdFiles$(1)
    If GV.AnzCmdFiles > 1 Then
      NewTable$ = CmdFiles$(2)
    End If
  End If

  If Len(NewDatabase$) > 0 Then
    ErrNr = OpenDB(NewDatabase$)
    If ErrNr = 0 Then
      If Len(NewTable$) > 0 Then
        ErrNr = OpenTbl(tblCase$(NewTable$))
      Else
        OldMouse = Screen.MousePointer
        Screen.MousePointer = 0
        Cancel = SelectTable(True)
        ErrNr = Cancel
        Screen.MousePointer = OldMouse
      End If
    End If

    If ErrNr = 0 And dbTableIsOpen Then
      ErrNr = SelectData(SelectClause & FromClause)
    End If

  End If

  Call ShowSelection

End Sub

Sub OpenLogFile(FileSpec$)

  Dim ErrNr, m$

  ErrNr = OpenFile(FileSpec$, "A", 0, LogFileNr)
  If ErrNr = 0 Then
    LogFileSpec = FileSpec$
    ErrNr = WriteLine(LogFileNr, "")
    m$ = "--- " & Format$(Now, "dd.mm.yyyy - hh:mm:ss") & " ---"
    ErrNr = WriteLine(LogFileNr, m$)
    ErrNr = WriteLine(LogFileNr, "")
  End If

End Sub

Sub RecordCheckSave()

  Dim Answer, ErrNr, ErrField

  'Nothing to save
  If Not NeedToSave Then Exit Sub

  If Not AutoSave Then
    Answer = MsgBox("nderungen speichern ?", 4 + 32)
    If Answer = 7 Then
      Call SetChangeState(False)
      Exit Sub
    End If
  End If

  Call GetRecord
  ErrNr = StoreRecord(InsertMode, ErrField)
  Call ShowUpdate

End Sub

Sub ResizeTable()

  Dim i
  Dim TotalWidth!, c!, f!, h!

  If Not frmMain.Tbl.Visible Then Exit Sub

  With frmMain.Tbl

    c! = .GridLineWidth * Screen.TwipsPerPixelX

    If NewTblColWidth Then
      NewTblColWidth = False
    Else
      For i = 0 To dbAnzDsFields
        dbTblColWidth(i - 1) = .ColWidth(i) + c!
      Next i
    End If

    For i = -1 To dbAnzDsFields - 1
      TotalWidth! = TotalWidth! + CalcColWidth(i)
    Next i

    f! = (.Width - 4 * c!) / TotalWidth!

    For i = -1 To dbAnzDsFields - 1
      .ColWidth(i + 1) = CalcColWidth(i) * f! - c!
    Next i

    h! = .RowHeight(0) + .GridLineWidth * Screen.TwipsPerPixelY
    MaxRows = (frmMain.ScaleHeight - 50 - frmMain.StatusContainer.Height - h!) \ h!
    If MaxRows < 1 Then MaxRows = 1
  End With

  'Update ScrollBar
  Call ScrollBarInit(frmMain, MaxRows)

End Sub

Sub RetrieveRecord(RecNr As Long)

  Dim i

  If RecNr = 0 Then

    For i = -1 To dbAnzDsFields - 1
      dbDsFieldData(i) = dbDsFieldNames(i)
    Next i

  Else

    Call MoveDS(RecNr)

    dbDsFieldData(-1) = Format$(RecNr, "#,##0")

    For i = 0 To dbAnzDsFields - 1
      'Add "" to avoid NULL-Error
      dbDsFieldData(i) = "" & ds(i).Value
    Next i

  End If

End Sub

Function RetrieveRowData(RecNr As Long)

  Dim i

  If RecNr = 0 Then

    For i = -1 To dbAnzDsFields - 1
      GrdRowData(i + 1) = dbDsFieldNames(i)
    Next i

  Else

    Call MoveDS(RecNr)

    GrdRowData(0) = Format$(RecNr, "#,##0")

    For i = 0 To dbAnzDsFields - 1
      If IsNull(ds(i).Value) Then
        GrdRowData(i + 1) = ""
      Else
        GrdRowData(i + 1) = ds(i).Value
      End If
    Next i

  End If

End Function

Function ScrollBarGet(Frm As Form) As Long

  With Frm.ScrollBar
    If dbAnzDsRec <= 1 Then
      ScrollBarGet = dbAnzDsRec       '0 oder 1
    Else
      ScrollBarGet = .Value + 32768 + Val(.Tag)
    End If
  End With

End Function

Sub ScrollBarInit(Frm As Form, MaxRows)

  Dim Recs As Long

  With Frm.ScrollBar
    .Enabled = dbAnzDsRec > 1

    If dbAnzDsRec > 0 Then
      Recs = dbAnzDsRec - MaxRows + 1
      If Recs < 1 Then Recs = 1
      If Recs > 65535 Then Recs = 65535

      ProgChange = True

      .Tag = "0"
      .Max = Recs - 32768
      .LargeChange = MaxRows
      .Enabled = dbAnzDsRec > MaxRows

    End If
  End With

  DoEvents

  ProgChange = False

End Sub

Sub ScrollBarSet(Frm As Form, RecNr As Long, MaxRows)

  Dim Offset As Long

  With Frm.ScrollBar

    .Enabled = dbAnzDsRec > 1

    If dbAnzDsRec > 0 Then

      'ProgChange verhindert,
      '  da mit Change Event neue Ausgabe erfolgt
      ProgChange = True

      If dbAnzDsRec < 65535 Then
        Offset = 0
      Else
        If RecNr < dbAnzDsRec / 2 Then
          Offset = 0
        Else
          Offset = dbAnzDsRec - 65535 - MaxRows + 1
        End If
      End If

      .Value = RecNr - 32768 - Offset
      .Tag = Str$(Offset)

      ProgChange = False
    End If
  End With

  DoEvents

End Sub

Function SelectData(SQLCmd$)

  Dim ErrNr, i, m$

  SelectData = True

  If Not dbTableIsOpen Then Exit Function

  Call ShowMsg(Msg$(32251), False, 11)

  '--- Datenbankabfrage ---
  Screen.MousePointer = 11

  ErrNr = SQLQuery(SQLCmd$)
  If ErrNr Then
    Screen.MousePointer = 0
    Call ShowMsg("", True, 0)
    With frmMain
      .Tbl.Visible = False
      .ScrollBar.Visible = False
    End With

    m$ = Msg$(32304)
    If GV.ExpertMode Then m$ = m$ & ":" & vbCrLf & LastError
    MsgBox m$
    Exit Function
  End If

  NewTblColWidth = True

  'Anzahl Datenstze bestimmen
  Call MoveDS(0)

  DsHasChanged = True

  Call ShowSelection

  'Tabelle initialisieren
  Call InitTable
  Call ResizeTable

  FirstRec = 1
  Call ScrollBarSet(frmMain, 1, MaxRows)
  Call FillTable

  Screen.MousePointer = 0

  SelectData = False

End Function

Function SelectExtTable(Import, DBExist, FileSpec$, TblName$)

  Dim t$, Cancel, Change&, ErrNr, Mask&, DefName$, m$, Answer

  SelectExtTable = True

  If Import Then

    '--- Import ---
    Select Case dbExtAnzTables
    Case 0
      TblName$ = ""
      MsgBox "Datenbank '" & FileSpec$ & "' enthlt keine Tabellen"
      Exit Function
    Case 1
      TblName$ = dbExtTableNames$(1)
    Case Else
      t$ = "HAMINFO - Tabelle zum Lesen"
      FilterMsgSrc = 1
      Cancel = RadioBtnMask(t$, 0, 1, Mask&, 0&, Change&)
      If Cancel Then Exit Function

      TblName$ = dbExtTableNames(Mask& + 1)
    End Select

  Else

    '--- Export ---
    Do
      Cancel = GetInput(ProgName$, Msg$(32270), DefName$, TblName$)
      If Cancel Then Exit Function

      If DBExist Then
        If Not ExistTable(TblName$, True) Then Exit Do

        m$ = Replace$(Msg$(32277), "%", TblName$)
        m$ = m$ & vbCrLf & Replace$(Msg$(32272), "%", TblName$)
        Answer = MsgBox(m$, 3)

        Select Case Answer
        Case 2   'Cancel
          Exit Function
        Case 6   'yes - Erase Table
          ErrNr = DAOCommand("DeleteExtTable", TblName$, "", 32287)
        End Select

        DefName$ = TblName$
      Else
        Exit Do
      End If
    Loop While Answer = 7  'No - Don't overwrite

  End If

  SelectExtTable = ErrNr

End Function

Function SelectTable(AutoSelect)

  Dim t$, Cancel, Change&, ErrNr, Mask&, SQL$

  SelectTable = True

  If dbAnzTables = 0 Then
    If AutoSelect Then
      Call ShowMsg(Msg$(32263), 0, 0)
    Else
      MsgBox Msg$(32263)
    End If
  ElseIf dbAnzTables = 1 And AutoSelect Then
    ErrNr = OpenTbl(dbTableNames$(1))
  Else
    t$ = "HAMINFO - Tabelle ffnen"
    FilterMsgSrc = 0
    Cancel = RadioBtnMask(t$, 0, 1, Mask&, 0&, Change&)
    If Cancel Then
      Call ShowSelection
      Exit Function
    End If

    ErrNr = OpenTbl(dbTableNames(Mask& + 1))
    If ErrNr Then
      Call ShowSelection
      Exit Function
    End If
  End If

  ErrNr = SelectData(SelectClause & FromClause)

  Call ShowSelection

  SelectTable = False

End Function

Sub SetChangeState(State)

  NeedToSave = State

  With frmDataMask

    'Schlieen
    'wenn Autosave: Speichern
    'wenn nicht Autosave: Abbrechen (mit Besttigung bei nderungen)
    '.Cmd(0).Enabled = Not State

    'Neu
    '.Cmd(1).Enabled = Not State Or AutoSave
    .Cmd(1).Enabled = (AutoSave And State) _
      Or (Not InsertMode And Not State)

    'Lschen
    '.Cmd(2).Enabled = Not State
    '.Cmd(2).Enabled = Not (State Or InsertMode And AutoSave)
    .Cmd(2).Enabled = Not (State Or InsertMode)

    'Rckgngig
    .Cmd(3).Enabled = State
    '.Cmd(3).Enabled = State Or InsertMode

    'Speichern
    .Cmd(4).Enabled = State

    .ScrollBar.Enabled = (Not State Or AutoSave) And dbAnzDsRec > 1

  End With

End Sub

Sub SetParameter()

  Dim ErrNr

  MnuAllowEdit = (NumPar(1).Actual And 1) <> 0
  AutoSave = (NumPar(1).Actual And 2) <> 0


  frmMain.Tbl.FontName = StrPar(3, 8)
  frmMain.Tbl.FontSize = NumPar(6).Actual / 1000
  frmMain.Tbl.FontBold = (NumPar(7).Actual And 1) <> 0
  frmMain.Tbl.FontItalic = (NumPar(7).Actual And 2) <> 0

  If Len(StrPar(3, 3)) > 0 Then Call OpenLogFile(StrPar(3, 3))

End Sub

Sub SetTableVars()

  With frmMain.Tbl
    Tbv.FirstRecNr = GetDsRecNr()
    Tbv.LastRecNr = Tbv.FirstRecNr + .SelEndRow - .SelStartRow
    Tbv.FirstFieldNr = .SelStartCol - 1
    Tbv.LastFieldNr = .SelEndCol - 1
  End With

  Tbv.ActRecNr = Tbv.FirstRecNr
  Tbv.ActFieldNr = Tbv.FirstFieldNr
  If dbDsIsTable Then
    Tbv.ActFieldName = dbTblFieldNames(Tbv.ActFieldNr)
  Else
    Tbv.ActFieldName = dbDsFieldNames(Tbv.ActFieldNr)
  End If

End Sub

Sub ShowInHammap(AllRecs)

  Dim FirstRecNr, LastRecNr
  Dim ErrNr, void, AnzRec&, RecNr&, FieldNr, Fmt$, m$, c$
  Dim Qth$, l$, b$, x#, y#, x1&, x2&, y1&, y2&
  Dim xmin!, ymin!, xmax!, ymax!, cx, cy
  Dim Cmd$, CmdLst$, Res$, DrawCol$, SymNr$
  Dim Shown, Outside, Invalid
  Dim Pt As dGeoPoint

  If HammapPossible = 0 Or GV.HammapConnected = 0 Then Exit Sub

  SymNr$ = CStr(NumPar(8).Actual)
  DrawCol$ = Right$("000000" & Hex$(NumPar(9).Actual), 6)

  If AllRecs Then
    FirstRecNr = 1
    LastRecNr = dbAnzDsRec
  Else
    FirstRecNr = Tbv.FirstRecNr
    LastRecNr = Tbv.LastRecNr
  End If


  'Ausschnittskoordinaten bestimmen
  If (NumPar(3).Actual And 512) = 0 Then
    ErrNr = HMCommand("GetCoord", c$)
    If ErrNr Then Exit Sub

    xmin! = Val(Parse$(c$, ","))
    ymin! = Val(Parse$(c$, ","))
    xmax! = Val(Parse$(c$, ","))
    ymax! = Val(Parse$(c$, ","))
  End If

  Call ShowMsg("Informationen in HAMMAP anzeigen...", 0, 11)

  Fmt$ = "0.000"
  CmdLst$ = ""

  If NumPar(3).Actual And 128 Then
    'Overlay lschen
    ErrNr = HMCommand("Overlay:-1", Res$)
    If ErrNr = 0 Then ErrNr = HMCommand("Overlay:-2", Res$)
    If ErrNr Then Exit Sub
  End If

  If NumPar(3).Actual And 256 Then
    ErrNr = HMCommand("Overlay:2", Res$)
  Else
    ErrNr = HMCommand("Overlay:1", Res$)
  End If
  If ErrNr Then Exit Sub

  For RecNr& = FirstRecNr To LastRecNr
    Call MoveDS(RecNr&)
    If HammapPossible = 1 Then
      Qth$ = ds(HMLocatorField).Value & ""
      If Len(Qth$) < 6 Then
        ErrNr = True
      Else
        ErrNr = Qth2dDegCoord(Qth$, Pt)
        If ErrNr = 0 Then
          x# = Pt.l
          y# = Pt.b
        End If
      End If
    Else
      l$ = Trim$(ds(HMLongitudeField).Value & "")
      b$ = Trim$(ds(HMLatitudeField).Value & "")
      If Len(l$) = 0 Or Len(b$) = 0 Then
        ErrNr = True
      Else
        ErrNr = Str2dDegCoord(l$, x#, 2)
        If ErrNr = 0 Then ErrNr = Str2dDegCoord(b$, y#, 1)
      End If
    End If

    If ErrNr = 0 Then
      If NumPar(3).Actual And 512 Then
        cx = True
        cy = True
      Else
        cx = x# >= xmin! And x# <= xmax!
        cy = y# >= ymin! And y# <= ymax!
      End If

      If cx And cy Then
        'DrawSymbol:x,y[,[Color][,[Symbol][,Text]]]
        Cmd$ = vbCrLf & "DrawSymbol:" _
             & Unformat$(Format$(x#, Fmt$)) & "," _
             & Unformat$(Format$(y#, Fmt$)) & "," _
             & DrawCol$ & "," & SymNr$ & ","
        If Tbv.FirstFieldNr = Tbv.LastFieldNr Then
          Cmd$ = Cmd$ & ds(Tbv.FirstFieldNr).Value & ""
        Else
          m$ = ""
          For FieldNr = Tbv.FirstFieldNr To Tbv.LastFieldNr
            m$ = m$ & " - " & ds(FieldNr).Value & ""
          Next FieldNr
          Cmd$ = Cmd$ & Mid$(m$, 4)
        End If
        CmdLst$ = CmdLst$ & Cmd$
        Shown = Shown + 1
      Else
        Outside = Outside + 1
      End If

    Else
      Invalid = Invalid + 1
    End If
  Next RecNr

  If Len(CmdLst$) > 2 Then
    void = HMCommand(Mid$(CmdLst$, 3), Res$)
  End If

  m$ = "Anzeige:" & Str$(Shown)
  If Outside > 0 Then m$ = m$ & "; auerhalb:" & Str$(Outside)
  If Invalid > 0 Then m$ = m$ & "; kein oder ungltiges QTH:" & Str$(Invalid)
  Call ShowMsg(m$, 0, 0)

  'Overlay beenden
  ErrNr = HMCommand("Overlay:0", Res$)
  ErrNr = HMCommand("DrawMap", Res$)

  If NumPar(3).Actual And 1 Then
    frmMain.SetFocus
  End If

End Sub

Sub ShowMsg(Msg$, ShowSaved, Mouse)

  Static MsgSave$

  With frmMain.StatusBox
    If Len(Msg$) = 0 Then
      If ShowSaved Then
        .text = " " & MsgSave$
      Else
        .text = ""
      End If
    Else
      MsgSave$ = .text
      .text = " " & Msg$
    End If
    .Refresh
  End With

  Screen.MousePointer = Mouse

  DoEvents

End Sub

Sub ShowSelection()

  Dim m$, d$, p$, n$, e$

  With frmMain

    m$ = "HAMINFO"
    If Not dbDatabaseIsOpen Then
      .Tbl.Visible = False
      Call ShowMsg("Keine Datenbank geffnet", False, 0)
    Else
      Call ParseFileSpec(dbOpenDatabase, d$, p$, n$, e$)
      m$ = m$ & " (" & n$

      If dbAnzTables = 0 Then
        .Tbl.Visible = False
        Call ShowMsg("Datenbank enthlt keine Tabellen", False, 0)
      ElseIf dbTableIsOpen = 0 Then
        .Tbl.Visible = False
        Call ShowMsg("Keine Tabelle geffnet", False, 0)
      Else
        m$ = m$ & "." & dbOpenTable
        .Tbl.Visible = True
      End If

      m$ = m$ & ")"
    End If

    .Caption = m$

    .ScrollBar.Visible = .Tbl.Visible

  End With

  Call EnblMenus

End Sub

Sub ShowTableInfo()

  Dim m$, t$

  Const Fmt$ = "#,##0"

  With frmMain.Tbl
    Call SetTableVars

    'Row-Information (Records)
    If dbAnzDsRec = 0 Then
      'kein Datensatz
      m$ = Msg$(32260)
    Else
      m$ = "Satz " & Format$(Tbv.FirstRecNr, Fmt$)
      If Tbv.LastRecNr <> Tbv.FirstRecNr Then
        m$ = m$ & "..." & Format$(Tbv.LastRecNr, Fmt$)
      End If
      m$ = m$ & " (" & Format$(dbAnzDsRec, Fmt$) & ")"
    End If

    'Column-Information (Fields)
    If Tbv.FirstFieldNr = Tbv.LastFieldNr Then
      m$ = m$ & " - Feld '" & dbDsFieldNames(Tbv.FirstFieldNr) & "'"
      If Tbv.LastRecNr = Tbv.FirstRecNr Then
        t$ = .text
        If Len(t$) > 0 Then m$ = m$ & " = '" & .text & "'"
      End If
    End If

    .Col = Tbv.FirstFieldNr + 1
    .row = .SelStartRow
  End With

  Call ShowMsg(m$, False, 0)

End Sub

Sub ShowUpdate()

  Dim RecNr As Long

  If InsertMode Then
    InsertMode = False
    dbDsFieldData(-1) = Format$(RecNr, "#,##0")
    dbAnzDsRec = dbAnzDsRec + 1
    RecNr = dbAnzDsRec
    Call ScrollBarInit(frmDataMask, 1)
    Call ScrollBarSet(frmDataMask, RecNr, 1)
  End If

  Call FillMask

  TblHasChanged = True
  Call SetChangeState(False)

End Sub

Function StoreRecord(Insert, ErrField)

  Dim i, m$, ErrNr, ErrDesc$, OldErrNr

  ErrField = -1

  With ds

    On Error Resume Next
    If Insert Then
      If .RecordCount > 0 Then .MoveLast
      If Err = 0 Then .AddNew
      LastDBCommand = "DAO: DS.Insert"
    Else
      .Edit
      LastDBCommand = "DAO: DS.Edit"
    End If
    ErrNr = Err
    ErrDesc$ = Error
    On Error GoTo 0

  End With


  '--- Felder in Datenbank speichern ---
  If ErrNr = 0 Then
    For i = 0 To dbAnzDsFields - 1
      With ds(i)
        m$ = "DAO: DS(" & dbDsFieldNames(i) & ").Value = "
        On Error Resume Next
        If Len(dbDsFieldData(i)) = 0 Then
          If Insert Then
            .Value = Null
          ElseIf Not IsNull(.Value) Then
            .Value = Null
          End If
          LastDBCommand = m$ & "Null"
        Else
          If Insert Then
            .Value = dbDsFieldData(i)
          ElseIf IsNull(.Value) Then
            'wegen evtl. (unique) Index nur genderte Felder speichern
            .Value = dbDsFieldData(i)
          ElseIf .Value <> dbDsFieldData(i) Then
            'wegen evtl. (unique) Index nur genderte Felder speichern
            .Value = dbDsFieldData(i)
          End If
          LastDBCommand = m$ & dbDsFieldData(i)
        End If

        ErrNr = Err
        ErrDesc$ = Error
        On Error GoTo 0

        If ErrNr Then
          ErrField = i
          Exit For
        End If
      End With
    Next i
  End If


  OldErrNr = ErrNr
  On Error Resume Next
  ds.Update
  If OldErrNr = 0 Then
    LastDBCommand = "DAO: DS.Update"
    ErrNr = Err
    ErrDesc$ = Error
  End If
  On Error GoTo 0


  If ErrNr Then
    If ErrField >= 0 Then
      MsgBox Msg$(32301) & ": '" & dbDsFieldData(ErrField) & "'"
    Else
      MsgBox Msg$(32302)
    End If
  End If

  Call LogCommand(ErrNr, ErrDesc$, 0)

  StoreRecord = ErrNr

End Function

Function txtMsgBox(Txt$, Style, Title$)

  'For full function (centered Text) of txtMsgBox use TXTMSG.BAS
  txtMsgBox = MsgBox(Txt$, Style, Title$)

End Function

