Attribute VB_Name = "HMINIT"
'-------------------------- HMINIT.BAS ------------------------
'HAMMAP Unterprogramme zur Initialisierung
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function InitHammap()

  ReDim StnFnd(0 To 50) As FoundType

  InitHammap = True

  PrgNam$ = "HAMMAP"


  '--- Messages laden ---
  MsgList$ = "DOS,HMWIN,HAMMAP,HMSUB,HMWIN32,MAP,STN,HMAPI,GEO"

  ErrNr = InitHmTool(PrgNam$, MsgList$)
  If ErrNr Then Exit Function

  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Function


  '--- Detail-Maske initialisieren ---
  Call InitDetails

  '--- Parameter initialisieren ---
  Call InitParameter

  '--- Parameter einlesen ---
  ErrNr = ReadHMParameter()
  If ErrNr Then Exit Function

  Call SetParameter
  GV.ParameterLoaded = True

  ErrNr = InitQRGTable()
  If ErrNr Then Exit Function


  '--- Ggf. Titelseite ausgeben ---
  'muss nach ReadHMParameter stehen
  If NumPar(12).Actual And 1 Then
    ErrNr = ShowHelp("[HAMMAP-Title]")
    'If ErrNr Then Exit Function
    If ErrNr = 0 Then GV.TopForm = 1
  End If


  '--- Systemabhaengige Initialisierungen (DOS / WIN) ---
  ErrNr = InitHammapSys()
  If ErrNr Then Exit Function

  If StrPar(3, 13) <> Version$ Then
    StrPar(3, 13) = Version$
    Call HMWriteParameter
  End If

  '--- Stationen einlesen ---
  Call LoadStations

  '--- Karten registrieren ---
  ErrNr = RegisterMapFiles()
  If ErrNr Then Exit Function

  '--- Karte einlesen ---
  If NumPar(46).Actual And MF_AutoMap Then
    'Karte automatisch whlen
    StrPar(3, 6) = ""      'No current file
    HV.MapType = 0
  Else
    void = LoadMapFile()
  End If

  Call SetMaxMapArea

  HV.PrtEnbl = 1    'Ausgabe auf Bildschirm

  InitHammap = False

End Function

Function InitHammapSys()

  InitHammapSys = True


  HV.MaxFound = 50

  '--- GUI und Menue initialisisieren ---
  void = InitGui()

  void = SetReadOnly(HmForm.StatusBox, True)
  HmForm.StatusContainer.BackColor = &H8000000F
  HmForm.StatusBox.BackColor = &H8000000F

  Call InitMenu

  Call InitTip

  'Fenstergre einstellen (mu nach Initmenu stehen)
  HV.DisableNewMap = True     'NewMap is called later explicitely
  If NumPar(53).Actual And 256 Then
    'Stationsfenster ist sichtbar
    Call AutoArrange(0)
  Else
    With HmForm
      MapForm.Move 0, 0, .ScaleWidth, .ScaleHeight
    End With
  End If
  HV.DisableNewMap = False

  HV.CursorWidth = GetSystemMetrics(13)


  'Tip-Timer starten
  MapForm.TipTimer.Interval = NumPar(54).Actual
  Call MapTipEnbl(True, False)

  'Blink-Timer setzen
  MapForm.BlinkTimer.Interval = NumPar(55).Actual

  InitHammapSys = False

End Function

Sub InitMenu()

  '--- Map-Form ---
  HV.MapFormProgResize = True
  MapForm.Caption = Msg$(24000)
  HV.MapFormProgResize = False

  '--- Aux Form ---
  HV.AuxFormProgResize = True
  AuxForm.Caption = Msg$(24600)
  HV.AuxFormProgResize = False

  DoEvents

  DoEvents

  '--- Bereichs-Menu ---
  Call InitAreaMenu(0)


  '--- Mens ---
  Call SetMsgMode(1)

  With HmForm

    For MenuNr = 0 To MsgBase(-1)
      i = 1
      Do
        m$ = Parse$(Msg$(MsgBase(MenuNr) + i), "(")
        If Len(m$) = 0 Then Exit Do
        On Error Resume Next

        Select Case MenuNr
        Case 0      'Hauptmenu
          Call SetMenuItem(.mnuMain(i), m$)
          If i = 8 Then .mnuMain(8).Visible = False      'Design
        Case 1
          Load .FilePullDown(i)
          Call SetMenuItem(.FilePullDown(i), m$)
        Case 2
          Load .MapPullDown(i)
          Call SetMenuItem(.MapPullDown(i), m$)
        Case 3      'Gebiet
        Case 4
          Load .StnPullDown(i)
          Call SetMenuItem(.StnPullDown(i), m$)
        Case 5
          Load .LinkPullDown(i)
          Call SetMenuItem(.LinkPullDown(i), m$)
        Case 6
          Load .SelectPullDown(i)
          Call SetMenuItem(.SelectPullDown(i), m$)
        Case 7
          Load .DisplayPullDown(i)
          Call SetMenuItem(.DisplayPullDown(i), m$)
        Case 8
          Load .DesignPullDown(i)
          Call SetMenuItem(.DesignPullDown(i), m$)
        Case 9
          Load .pdmnuPrint(i)
          Call SetMenuItem(.pdmnuPrint(i), m$)
        Case 10
          Load .InfoPullDown(i)
          Call SetMenuItem(.InfoPullDown(i), m$)
        Case 11
          Load .HelpPullDown(i)
          Call SetMenuItem(.HelpPullDown(i), m$)
        Case 12
          Load .mnuPopupMap(i)
          Call SetMenuItem(.mnuPopupMap(i), m$)
        End Select

        On Error GoTo 0

        i = i + 1
      Loop
    Next MenuNr

  End With

  HV.HMFormProgResize = True
  Call ShowExpertFunctions
  HV.HMFormProgResize = False
  'Call WinFormKeys(24)    'Erweiterte Funktionen ausschalten

  Call SetMsgMode(0)

  Call InitToolbars

End Sub

Function MsgBase(FktNr)

  Select Case FktNr
  Case -1                   'last FktNr
    MsgBase = 12
  Case 2
    MsgBase = 20060         'Karte
  Case 3                    'Bereich
    MsgBase = 0
  Case 9
    MsgBase = 19040         'Drucken
  Case 10
    MsgBase = 20200         'Info
  Case 11
    MsgBase = 20220         'Help
  Case 12
    MsgBase = 19180         'Map-Popup
  Case Else
    MsgBase = 20000 + 20 * FktNr
  End Select

End Function

