Attribute VB_Name = "HMParam"
'-------------------------- HMINIT.BAS ------------------------
'HAMMAP Unterprogramme zur Initialisierung
'von Gerhard Berg, DJ6FM

DefInt A-Z

Sub InitParameter()

  ReDim Area(1 To 24) As lAreaLimits
  ReDim StnSym(0 To Len(Msg$(31100 + 2)) / 3 - 1) As StationSymbol

  ReDim StnAbv(1 To 6) As String
  ReDim AnzStnAbv(1 To 6) As Integer


  '--- Abkuerzungen ---
  For i = 1 To UBound(StnAbv)
    StnAbv(i) = UCase$(Msg$(31100 + i))
    AnzStnAbv(i) = Len(StnAbv(i)) / 3
  Next i


  '----- Parameter Initialisieren -----
  NotHerc = True

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (CheckBoxMask) muss NumPar.Max = 0 sein !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '    NumPar(...).Label = ""

  ReDim NumPar(1 To 65) As NumParType

  'NumPar(1).Label = "StnStatus": NumPar(1).Default = -1&
  Call InitNumPar(1, "StnStatus", -1&, 0&, 0&)

  NumPar(2).Label = "StnTyp": NumPar(2).Default = -1&
  NumPar(3).Label = "StnSoftware": NumPar(3).Default = -1&
  NumPar(4).Label = "StnHardware": NumPar(4).Default = -1&
  NumPar(5).Label = "LinkStatus": NumPar(5).Default = -1&

  'Drucker-Port (nur VBDOS)
  NumPar(6).Label = "LPT": NumPar(6).Default = 1&
    NumPar(6).Min = 1&: NumPar(6).Max = 3&

  'Puffer reservieren fuer PAINT, Windows, SaveScreen  (Groesse = NumPar * 8)
  NumPar(7).Label = "BufferSize": NumPar(7).Default = 60000 / 8&

  'Speicher:1=Segmente,2=Koordinaten,4=Stationen,8=Links,16=Karte
  NumPar(8).Label = "Memory"
  NumPar(8).Default = -1&

  'Kartenanzeige (Filter) (geaendert u.a. in Version 7.1 und 9.1)
  NumPar(9).Label = "Map": NumPar(9).Default = ME_Coasts Or ME_Borders

  'Reserve fuer Stations- und Link-Aenderungen
  'NumPar(10).Label = "Stations": NumPar(10).Default = 20&
  '  NumPar(10).Min = 0&: NumPar(10).Max = 32767&
  Call InitNumPar(10, "Stations", 20&, 0&, 32767&)

  NumPar(11).Label = "Links": NumPar(11).Default = 20&
    NumPar(11).Min = 0&: NumPar(11).Max = 32767&

  'Extras
  NumPar(12).Label = "Display"
  If NotHerc Then
    NumPar(12).Default = &H627&   '3D
  Else
    NumPar(12).Default = &H60F&   'Maus per Programm
  End If



  '--- Druckbildgroesse (in 1/1000 cm - nur Windows) ---
  NumPar(13).Label = "PrintTop": NumPar(13).Default = 2000
    NumPar(13).Min = 0&: NumPar(13).Max = 100000
  NumPar(14).Label = "PrintLeft": NumPar(14).Default = 2000
    NumPar(14).Min = 0&: NumPar(14).Max = 100000
  NumPar(15).Label = "PrintHeight": NumPar(15).Default = 9000
    NumPar(15).Min = 500&: NumPar(15).Max = 200000
  NumPar(16).Label = "PrintWidth": NumPar(16).Default = 12000
    NumPar(16).Min = 500&: NumPar(16).Max = 200000


  '--- Fenstergroesse (in Twips - nur Windows) ---
  NumPar(17).Label = "WindowTop"
  NumPar(18).Label = "WindowLeft"
  NumPar(19).Label = "WindowHeight"
  NumPar(20).Label = "WindowWidth"
  NumPar(21).Label = "WindowState": NumPar(21).Default = 0&
    NumPar(21).Min = 0&: NumPar(21).Max = 2&

  With Screen
    NumPar(17).Default = .Height * 0.05   'Top
    NumPar(18).Default = .Width * 0.05    'Left
    NumPar(19).Default = .Height * 0.9    'Height
    NumPar(20).Default = .Width * 0.9     'Width
  End With

  '--- QRG / Baud ---
  NumPar(22).Label = "MinQrq": NumPar(22).Default = 0&
    NumPar(22).Min = 0&: NumPar(22).Max = 999999999
  NumPar(23).Label = "MinBaud": NumPar(23).Default = 0&
    NumPar(23).Min = 0&: NumPar(23).Max = 999999
  NumPar(24).Label = "MinLinkBaud": NumPar(24).Default = 0&
    NumPar(24).Min = 0&: NumPar(24).Max = 999999
  NumPar(25).Label = "MinRouteBaud": NumPar(25).Default = 0&
    NumPar(25).Min = 0&: NumPar(25).Max = 999999

  NumPar(26).Label = "MaxQrq": NumPar(26).Default = 0&
    NumPar(26).Min = 0&: NumPar(26).Max = 999999999
  NumPar(27).Label = "MaxBaud": NumPar(27).Default = 0&
    NumPar(27).Min = 0&: NumPar(27).Max = 999999
  NumPar(28).Label = "MaxLinkBaud": NumPar(28).Default = 0&
    NumPar(28).Min = 0&: NumPar(28).Max = 999999
  NumPar(29).Label = "MaxRouteBaud": NumPar(29).Default = 0&
    NumPar(29).Min = 0&: NumPar(29).Max = 999999

  '--- Router ---
  NumPar(30).Label = "RouteStatus": NumPar(30).Default = Val("&H0F")
  NumPar(31).Label = "RouteTyp": NumPar(31).Default = Val("&H9B")
  NumPar(32).Label = "RouteSoftware": NumPar(32).Default = -1&
  NumPar(33).Label = "LinkTyp": NumPar(33).Default = Val("&H0E7")
  NumPar(34).Label = "RouteLinkTyp": NumPar(34).Default = &HE7

  NumPar(35).Label = "Debug": NumPar(35).Default = 0


  '--- Fonts (ab Version 5.2) ---
  NumPar(36).Label = "FontSize"
  NumPar(36).Default = 8000&
  NumPar(37).Label = "FontAttr": NumPar(37).Default = 0
    NumPar(37).Min = 0&: NumPar(37).Max = 3&
  NumPar(38).Label = "LptFontSize": NumPar(38).Default = 8000&
  NumPar(39).Label = "LptFontAttr": NumPar(39).Default = 0
    NumPar(39).Min = 0&: NumPar(39).Max = 3&

  '--- Zeilenabstand fuer senkrechte Stationsbeschriftung (Pixel) ---
  NumPar(40).Label = "LineDist": NumPar(40).Default = 0&
    NumPar(40).Min = 0&: NumPar(40).Max = 5&

  '--- Einstellungen (ab Version 6.0) ---
  NumPar(41).Label = "StnOpt"
  NumPar(41).Default = &H13

  NumPar(42).Label = "LinkOpt"
    NumPar(42).Default = &H35

  '--- Printer-Orientation (ab Version 6.1a) ---
  '    geaendert in Version 8.0 und 8.1
  NumPar(43).Label = "PrintOptions": NumPar(43).Default = 1&
    NumPar(43).Min = 0&: NumPar(43).Max = 3&

  '--- Kartenlemente - Segment-Typ (ab Version 7.0) ---
  'Parameter 44 gendert in Version 10 (9.1)
  NumPar(44).Label = "SegType": NumPar(44).Default = &H7FFFFFFF
  NumPar(45).Label = "FastLoad": NumPar(45).Default = 255&

  '--- Karten-Funktionen (ab Version 10 (9.1)) ---
  NumPar(46).Label = "MapFunctions"
  NumPar(46).Default = MF_AutoMap + MF_AutoAct + MF_AutoArea _
     + MF_AutoDetail + MF_CrtProp + MF_ZoomCorr
  NumPar(46).Default = NumPar(46).Default + MF_HiRes + MF_BackGnd


  '--- Data-Tips (ab Version 8.0) ---
  NumPar(47).Label = "TipSelect": NumPar(47).Default = 0&
    NumPar(47).Min = 0&: NumPar(47).Max = 15&
  NumPar(48).Label = "TipDelay": NumPar(48).Default = 0&
    NumPar(48).Min = 0&: NumPar(48).Max = 32767&
  NumPar(49).Label = "TipTime": NumPar(49).Default = 0&
    NumPar(49).Min = 0&: NumPar(49).Max = 32767&
  NumPar(50).Label = "TipSize": NumPar(50).Default = 8&
    NumPar(50).Min = 6&: NumPar(50).Max = 50&

  '--- Bildschirm-/Drucker-Einstellungen (ab Version 8.1) ---
  NumPar(51).Label = "ScreenOptions": NumPar(51).Default = 7&
  NumPar(52).Label = "PrinterOptions": NumPar(52).Default = 4&

  '--- Toolbar (ab Version 9) ---
  NumPar(53).Label = "ToolBarOptions"
    NumPar(53).Default = &H2AF&

  'Timer (ab Version 8.2)
  NumPar(54).Label = "TipTimer"
    NumPar(54).Default = 100&
    NumPar(54).Min = 1&: NumPar(54).Max = 32767&

  NumPar(55).Label = "BlinkTimer": NumPar(55).Default = 500&
    NumPar(55).Min = 1&: NumPar(55).Max = 32767&

  '--- Auto-Details only in Version 9.0 - leave for compatibility ---
  NumPar(56).Label = "AutoDetail": NumPar(56).Default = 0&

  '--- Neu ab Version 11.0 ---
  Call InitNumPar(57, "Distance", 0&, 0&, 2&)
  Call InitNumPar(58, "Locator", 2&, 0&, 3&)
  Call InitNumPar(59, "GeoCoord", 2&, 0&, 2&)
  Call InitNumPar(60, "Coordsystem", 0&, 0&, 3&)
  Call InitNumPar(61, "MapDatum", 0&, 0&, 3&)

  Call InitNumPar(62, "CrtLineWidth1", 0&, 0&, 0&)
  Call InitNumPar(63, "CrtLineWidth2", 0&, 0&, 0&)
  Call InitNumPar(64, "CrtLineWidth1", 0&, 0&, 0&)
  Call InitNumPar(65, "CrtLineWidth2", 0&, 0&, 0&)

  For i = 1 To UBound(NumPar)
    NumPar(i).Actual = NumPar(i).Default
  Next i


  '--- String-Parameter setzen ---
  'Index 1: 1 = Name, 2 = Default, 3 = Actual
  'Index 2: Parameter-Nr.
  ReDim StrPar(1 To 4, 1 To 15) As String

  '--- NotVia (ab Version 5.3) ---
  'StrPar(1, 1) = "NotVia": StrPar(2, 1) = ""
  Call InitStrPar(1, "NotVia", "", "")

  'StrPar(1, 2) = "LptTyp": StrPar(2, 2) = "Standard"
  Call InitStrPar(2, "LptTyp", "Standard", "")

  StrPar(1, 3) = "LptCtrl": StrPar(2, 3) = ""
  StrPar(1, 4) = "Screen": StrPar(2, 4) = "AUTO"
  StrPar(1, 5) = "Prefix": StrPar(2, 5) = "DB0"
  StrPar(1, 6) = "MapFile": StrPar(2, 6) = HomeDir$ + "MAP\EU-ALL.BMD"
  StrPar(1, 7) = "StationFile": StrPar(2, 7) = HomeDir$ + "STN\DIGI"

  '--- Fonts (ab Version 5.2) ---
  StrPar(1, 8) = "FontName": StrPar(2, 8) = "Arial"
  StrPar(1, 9) = "LptFontName": StrPar(2, 9) = "Arial"

  'Ab Version 5.4
  StrPar(1, 10) = "MyAreaName": StrPar(2, 10) = ""
  StrPar(1, 11) = "IncludeStn": StrPar(2, 11) = ""
  StrPar(1, 12) = "ExcludeStn": StrPar(2, 12) = ""

  'Ab Version 8.1
  StrPar(1, 13) = "Version": StrPar(2, 13) = ""

  'Ab Version 9.0
  StrPar(1, 14) = "RouteStart": StrPar(2, 14) = ""

  'Ab Version 9.0
  StrPar(1, 15) = "MyArea": StrPar(2, 15) = ""

  For i = 1 To UBound(StrPar, 2)
    StrPar(3, i) = StrPar(2, i)
  Next i


  HV.AnzArea = 1
  Area(1).Label = Msg$(24041)


  '--- Stations-Symbole ---
  StnSym(1).Default = 10            'Digi
  StnSym(2).Default = 3             'Mailbox
  StnSym(3).Default = 12            'Link-Node
  StnSym(4).Default = 8             'Gateway
  StnSym(5).Default = 6             'DX-Cluster
  StnSym(6).Default = 7             'WX-Node
  StnSym(7).Default = 5             'TCP-IP
  StnSym(8).Default = 4             'User-Node

  For i = 0 To AnzStnAbv(2) - 1
    StnSym(i).Actual = StnSym(i).Default
  Next i


  '--- Farben ---
  HV.DefCol(0) = RGB2Col(255, 255, 255)      'Hintergrund
  HV.DefCol(1) = RGB2Col(0, 0, 255)          '
  HV.DefCol(2) = RGB2Col(0, 0, 128)          '
  HV.DefCol(3) = RGB2Col(255, 0, 255)        '
  HV.DefCol(4) = RGB2Col(128, 0, 128)        '
  HV.DefCol(5) = RGB2Col(255, 0, 0)          '
  HV.DefCol(6) = RGB2Col(128, 0, 0)          '
  HV.DefCol(7) = RGB2Col(0, 0, 0)            'Grenzen
  HV.DefCol(8) = RGB2Col(0, 255, 255)        'Meere, Seen
  HV.DefCol(9) = RGB2Col(0, 255, 0)          'Land
  HV.DefCol(10) = RGB2Col(0, 0, 255)         'Fluesse
  HV.DefCol(11) = RGB2Col(0, 0, 0)           'Staedte
  HV.DefCol(12) = RGB2Col(128, 128, 128)     'grau
  HV.DefCol(13) = RGB2Col(255, 0, 0)         'Meldungen
  HV.DefCol(14) = RGB2Col(0, 0, 128)         'Stationen, Links
  HV.DefCol(15) = RGB2Col(0, 0, 0)           'Grenzen

  For i = 0 To 15
    HV.ColVal(i) = HV.DefCol(i)
  Next i

End Sub

Function ProcessParameter(OrgLine$)

  ProcessParameter = -3                 'Fehler fuer DDE

  InpLine$ = LTrim$(OrgLine$)
  CmdLine$ = Parse$(InpLine$, ";")
  Cmd$ = UCase$(Parse$(CmdLine$, "="))

  Select Case Cmd$
  Case ""          'leere Zeile oder Kommentar

  '--------- Screen --------------
  Case "COLOR"
    ColNr = Val(Parse$(CmdLine$, ","))             'Farb-Nr.
    If ColNr < 0 Or ColNr > 15 Then
      Call FileError(Msg$(24010) + Str$(ColNr), InParFile$)
      Exit Function
    Else
      Fakt& = 1
      NewCol& = 0&
      For i = 1 To 3
        Attr = Val(Parse$(CmdLine$, ","))
        If Attr < 0 Or Attr > 255 Then
          Call FileError(Msg$(24011) + Str$(Attr), InParFile$)
          Exit Function
        End If
        NewCol& = NewCol& + Fakt& * Attr
        Fakt& = Fakt& * 256&
      Next i
      HV.ColVal(ColNr) = NewCol&
    End If

  Case "SYMBOL"
    AbvTxt$ = UCase$(Parse$(CmdLine$, ","))
    AbvVal = FindStnAbv(2, AbvTxt$)
    ActSym = Val(CmdLine$)
    If AbvVal < 0 Or ActSym < 0 Or ActSym > 13 Then
      Call FileError(Msg$(25031) + Quotes$(OrgLine$), InParFile$)
      Exit Function
    End If
    StnSym(AbvVal).Actual = ActSym

  Case Else
    Call FileError(Msg$(25031) + Quotes$(OrgLine$), InParFile$)
    Exit Function
  End Select

  ProcessParameter = 0

End Function

Function ReadHMParameter()

  '------------------ INI-File einlesen -------------------

  ReadHMParameter = True

  '--- Bereich '[HAMMAP]' laden ---
  ErrNr = ReadParameter(InParFile$, "[HAMMAP]", True, Found)
  If ErrNr Then Exit Function


  '--- Bereich '[HAMMAP-SP]' laden ---
  ErrNr = GetSection(InParFile$, "[HAMMAP-SP]", True, SectData$, AnzDataLines, Found)
  If ErrNr Then Exit Function

  '--- Parameter einlesen ---
  Do Until Len(SectData$) = 0
    InpLine$ = Parse$(SectData$, vbCrLf)
    void = ProcessParameter(InpLine$)
  Loop


  '------------------- Kartenausschnitte -----------------------

  '--- Bereich '[sprache]' suchen ---
  Call ParseFileSpec(MsgFile$, d$, p$, Speak$, e$)
  Sect$ = "[" + UCase$(Speak$) + "]"

  ErrNr = GetSection(InParFile$, Sect$, True, SectData$, AnzDataLines, Found)
  If ErrNr Then Exit Function

  '--- Parameter einlesen ---
  Do Until Len(SectData$) = 0

    InpLine$ = Parse$(SectData$, vbCrLf)

    Cmd$ = Parse$(InpLine$, "=")
    CmdLine$ = Parse$(InpLine$, ";")
    OrgLine$ = Cmd$ + " = " + CmdLine$
    Cmd$ = UCase$(Cmd$)

    Select Case Cmd$
    Case ""
    Case "AREA"
      If Not FileArea Then
          FileArea = True
          HV.AnzArea = 0
      End If

      If HV.AnzArea = UBound(Area) Then
        Call ShowErrNrFileTxt(24012, InParFile$)
        Exit Function
      End If

      HV.AnzArea = HV.AnzArea + 1
      Area(HV.AnzArea).Label = Parse$(CmdLine$, ",")
      ErrNr = Str2lArea(CmdLine$, Area(HV.AnzArea).lArea)

    Case Else
      ErrNr = True
    End Select

    If ErrNr Then
      Call FileError(Msg$(25031) + Quotes$(OrgLine$), InParFile$)
      Exit Function
    End If

  Loop

  StrPar(3, 5) = UCase$(StrPar(3, 5))

  ReadHMParameter = False

End Function

Sub SetParameter()

  OldVer$ = StrPar(3, 13)
  OldMajor = Val(Parse$((OldVer$), "."))

  If OldVer$ <> Version$ Then
    If OldVer$ = "" Then
      'Wechsel von <= V8.0 nach >= V8.1
      'Nur beim ersten Start der Version >= 8.1 ausfhren
      'Symbole nicht transparent
      NumPar(41).Actual = NumPar(41).Actual And Not 16&
      'Karte nicht im Hintergrund ausgeben
      NumPar(46).Actual = NumPar(46).Actual And Not MF_BackGnd
    End If

    If OldMajor <= 8 Or Left$(OldVer$, 3) = "9.0" Then
      'Changes for Version >= 9.1
      'MsgBox "New Version: " & Version$
      NumPar(9).Actual = NumPar(9).Default      'Karten-Inhalte
      NumPar(44).Actual = NumPar(44).Default    'Karten-Details
      NumPar(56).Actual = 0&      'No longer used - force no output
    End If

    If OldMajor <= 9 Or Left$(OldVer$, 4) = "10.0" Then
      'Changes for Version >= 10.1
      NumPar(46).Actual = NumPar(46).Default    'Karten-Funktionen (wegen Bitmap)
    End If

    'Titelseite zeigen
    NumPar(12).Actual = NumPar(12).Default Or 1&

  End If


  SV.ErrorExit = True           'Bei Fehler Abbruch (interaktiver Betrieb)
  SV.DataFormat = 0
  SV.AddLines = -1              'Alle Felder in Zusatzzeilen zulassen
  SV.ErrorLevel = -1            'Alle Fehler anzeigen


  '--- Farben ---
  HV.BackCol = HV.ColVal(0)
  HV.ForeCol = HV.ColVal(15)


  'Wenn kein aktueller Ausschnitt definiert (MyArea undefiniert),
  '   dann Ausschnitt Nr.1 benutzen / bei Demo 'Alles'
  ErrNr = Str2lArea((StrPar(3, 15)), MV.SelMapArea)

  If IsNullArea(MV.SelMapArea) Then
    AreaNr = 1                'Deutschland
    MV.SelMapArea = Area(AreaNr).lArea
    m$ = RTrim$(Area(AreaNr).Label)
    StrPar(3, 10) = Replace$(m$, "&", "")
  End If


  Call ParseFileSpec(StrPar(3, 6), d$, p$, n$, e$)
  If Len(StrPar(3, 6)) = 0 Then
    'No file was loaded last time
    StrPar(3, 6) = StrPar(2, 6)
  ElseIf e$ = "." Then
    'For compatibility with older INI-Files
    StrPar(3, 6) = StrPar(3, 6) & ".BMD"
  End If

  'Dateinamen fuer 16 Bit in Upper Case
  StrPar(3, 6) = Ucase16$(StrPar(3, 6))
  StrPar(3, 7) = Ucase16$(StrPar(3, 7))



  HV.FastLoad = NumPar(45).Actual

  Call InitShowOle


  Call InitFilterPrefix
  Call InitMarkPrefix

End Sub

