Attribute VB_Name = "HMSUB"
'--------------------------- HMSUB.BAS ------------------------

'HAMMAP Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function FileLength$(FileNr)

  If FileNr = 0 Then
    l& = 0&
  Else
    l& = (LOF(FileNr) + 1023) \ 1024
  End If
  FileLength$ = " (" + Format$(l&) + " KB)"

End Function

Function FilterMsg$(MsgNr)

  '--- Dateilaenge ---
  Select Case MsgNr
  Case 24470
    FilterMsg$ = FileLength$(MV.In.BmdFile)
  Case 24471
    FilterMsg$ = FileLength$(MV.In.BmcFile)
  Case 24472                               'Stations-Index
    If SV.Out.BsdFile = 0 Then
      l& = 0&
    Else
      l& = (LOF(SV.Out.BsdFile) \ 24 + 1023) \ 1024
    End If
    FilterMsg$ = " (" + Format$(l&) + " KB)"
  Case 24473
    FilterMsg$ = FileLength$(SV.Out.BsdFile)
  Case 24474
    FilterMsg$ = FileLength$(SV.Out.BldFile)
  Case 24475
  Case 24476
    FilterMsg$ = " (0 KB)"
  End Select

End Function

Function GetMouseInfo$(degP1 As dGeoPoint, Mode)

  Dim degP2 As dGeoPoint
  Dim Dist As Single

  If Mode And 1 Then
    Stop    'not used anymore
  End If

  If Mode And 2 Then
    void = dDegCoord2Qth(degP1, Qth$)
    m$ = m$ + Left$(Qth$, NumPar(58).Actual * 2 + 2)
  End If

  If HV.SelStnRec > 0 Then

    If (Mode And 6) = 6 Then m$ = m$ + " - "

    If Mode And 4 Then
      '--- Entfernung ---
      m$ = m$ + RTrim$(SelStnCall$) + ":"
      m$ = m$ & vbCrLf

      degP2.l = SelStnData.xloc / cfDeg2Qth
      degP2.b = SelStnData.yloc / cfDeg2Qth

      Dist = QthDist(degP1, degP2)
      DistMode = NumPar(57).Actual
      m$ = m$ & DistToMsg$(Dist, DistMode) & " " & Msg$(40005 + DistMode)

      '--- Richtung ---
      If Dist > 0 Then
        f$ = "0.00 " & DegChr

        'Winkel bei P1
        m$ = m$ + " / " + Format$(QthAngle(degP1, degP2), f$)
        'Winkel bei P2 (Gegenrichtung)
        m$ = m$ + " / " + Format$(QthAngle(degP2, degP1), f$)
      End If
    End If
  End If

  GetMouseInfo$ = RTrim$(m$)

End Function

Function InitPercent&(m$, Max As Long, Stp)

  Dim ShowStep As Long

  ShowStep = (Max + Stp - 1) \ Stp
  If ShowStep = 0 Then ShowStep = 1
  HV.ShowMax = ShowStep * Stp
  InitPercent& = ShowStep

  void = ShowPercent(0&, m$)

  Call OpenCancel

End Function

Sub PrepareFunction(HMDsbl, TextMode)

  'TextMode: 0=Stay in Graphics-Mode, 1=switch to Text-Mode, 2=1+SaveMap

  'Interlock
  If HV.FunctionPrepared Then Stop
  HV.FunctionPrepared = True


  If NumPar(41).Actual And 8 Then
    'Blinken abschalten
    MapForm.BlinkTimer.Enabled = False
    'Noch ausstehende Interrupts abarbeiten
    void = DoEvents()

    'letztes Blinken ggf. aufheben
    Call DrawSelectedStation(-1)
  End If



  If HMDsbl Then
    '--- Disable HAMMAP ---
    HV.HMDisabled = True

    'OLE notification = Not Ready
    If HV.StartupComplete Then
      Call ApiNotify(2, LTrim$(Str$(0)))
    End If

    'Disable Input
    HmForm.Enabled = False
    'avoid multiple triggering
    MapForm.MapHScroll.Enabled = False
    MapForm.MapVScroll.Enabled = False
  End If

  'Zeitmessung
  HV.StartTime = GetTickCount()

End Sub

Function ShowPercent(n&, NewMsg$)

  Static OldMsg$

  If Len(NewMsg$) > 0 Then OldMsg$ = NewMsg$

  m$ = Format$((n& * 100&) \ HV.ShowMax, " (0 \%)")
  Call ShowText(OldMsg$ + m$, 7, 11)

  ShowPercent = CheckCancel()

End Function

Sub TerminateFunction(UpdateMap, MapChange&)

  'UpdateMap: 0=Never, 1=if change, 2=always

  Static LastArea$

  'Wegen Route (DOS)
  If HV.FunctionPrepared = 0 Then Exit Sub
  HV.FunctionPrepared = False


  '--- Zeitmessung ---
  msecs& = GetTickCount() - HV.StartTime


  '--- Ggf. Karte neu ausgeben ---
  Select Case UpdateMap
  Case 0
    NewMapEnbl = False
  Case 1
    'Bei nderungen Karte neu ausgeben
    NewMapEnbl = (NumPar(46).Actual And MF_AutoAct) <> 0 And MapChange& <> 0&
  Case 2
    NewMapEnbl = True
  Case Else
    Stop
  End Select



  'Ggf. Karte ausgeben
  If NewMapEnbl And HV.StartupComplete Then
    Call NewMap
  End If

  If HV.HMDisabled Then
    'Enable HAMMAP
    HV.HMDisabled = False

    With HmForm
      'Enable Input
      .Enabled = True
      'SetFocus sorgt dafuer, dass Funktionstasten wieder gehen
      .SetFocus
    End With

    With MapForm
      'avoid multiple triggering
      .MapHScroll.Enabled = HV.HScrollEnbl
      .MapVScroll.Enabled = HV.VScrollEnbl

      If .MousePointer = 99 Then
        'Restore custom Mouse-Pointer
        .MousePointer = 0
        .MousePointer = 99
      End If
      If .HiddenField.Visible Then
        .HiddenField.SetFocus
      End If
    End With


    'Set Focus
    Select Case GV.TopForm
    Case 1
      TextForm.SetFocus
    Case 2
      frmPrtSim.SetFocus
    Case Else
      MapForm.SetFocus
    End Select

    GV.TopForm = 0

    'OLE notification = Ready
    If HV.StartupComplete Then
      Call ApiNotify(2, LTrim$(Str$(-1)))
    End If

    If LastArea$ <> StrPar(3, 15) Then    'Ausschnitt gendert
      Call ApiNotify(3, StrPar(3, 15))
      LastArea$ = StrPar$(3, 15)
    End If

    If HV.NewMapFlag Then
      HV.NewMapFlag = False
      Call ApiNotify(4, StrPar(3, 15))      'Karte neu ausgegeben
    End If

  End If



  If (NumPar(41).Actual And 8) <> 0 And HV.StartupComplete And _
      HV.SelStnRec > 0 Then
    'Blinken wieder einschalten
    MapForm.BlinkTimer.Enabled = True
  End If


  '--- Zeitmessung ausgeben ---
  If NumPar(35).Actual And 16 Then
    'Benoetigte Zeit ausgeben
    Call ShowText(Format$(msecs&, "#,##0") & " msec", 13, 0)
  End If

End Sub

Sub Test(m$)

  Static Skip

  If Skip Then Exit Sub

  MsgBox m$

End Sub

