Attribute VB_Name = "HmTools"
DefInt A-Z


Dim modAnzCmdOpt                        '# of Options in Command Line
Dim modCmdOpt$()                        'Command-Line Options
Dim modCmdOptPar$()                     'Command-Line Option Parameters

Sub ExitHMTool()

  Dim Frm As Form

  'Rekursiven Aufruf beim Schliessen der Hauptform verhindern
  GV.ProgUnload = True


  For Each Frm In Forms
    Unload Frm
    Set Frm = Nothing
  Next Frm


End Sub

Function FindCmdOpt(ByVal s$, Par$)

  FindCmdOpt = False
  If Right$(s$, 1) = ":" Then s$ = Left$(s$, Len(s$) - 1)   'Drop ':'
  Par$ = ""     'Parameter of Option

  For i = 1 To modAnzCmdOpt
    If UCase$(modCmdOpt$(i)) = UCase$(s$) Then
      Par$ = modCmdOptPar$(i)
      FindCmdOpt = True
      Exit For
    End If
  Next i

End Function

Function GetAbout$(Description$)

  m$ = Msg$(25025) & "  " & sWinBits

  m$ = ProgName$ & " " & m$ & vbCrLf & Msg$(25024) & " " & Version$
  If Len(Description$) > 0 Then m$ = m$ & vbCrLf & Description$
  m$ = m$ & vbCrLf & Msg$(25023) & " Gerhard Berg, DJ6FM"

  GetAbout$ = m$

End Function

Function GetCmdFileSpecs()

  GetCmdFileSpecs = True

  '--- Message- und Help-File bestimmen ---
  HlpDir$ = "Win32\"

  If Not FindCmdOpt("/L:", Lng$) Then
    'Sprache nicht als Kommandozeilen-Option
    f$ = HomeDir$ + "HM-SPEAK.INI"
    ErrNr = ExistFile(f$, False, Exist)
    If ErrNr Then Exit Function
    If Exist Then
      'Sprache aus HM-SPEAK.INI
      ErrNr = LoadTextFile(f$, 100, fin$)
      If ErrNr Then Exit Function
      Lng$ = UCase$(Parse$(fin$, Chr$(13)))
    Else
      Lng$ = "DEUTSCH"
    End If
  End If

  MsgFile$ = HomeDir$ + Lng$ + ".MSG"
  HlpFile$ = HomeDir$ + HlpDir$ + Lng$ + ".HLP"


  '--- INI-File bestimmen ---
  If FindCmdOpt("/I:", InParFile$) Then
    'INI-Datei in Kommandozeile
    Call ParseFileSpec(InParFile$, d$, p$, n$, e$)
    If Len(d$) = 0 And Len(p$) = 0 Then
      InParFile$ = HomeDir$ + InParFile$
    End If
  Else
    'INI-Datei nicht als Kommandozeilen-Option
    InParFile$ = HomeDir$ + "HAMMAP.INI"

    ErrNr = ExistFile(InParFile$, False, Exist)
    If ErrNr Then Exit Function
    'Wenn INI-File nicht existiert, dann neu anlegen
    If Not Exist Then ErrNr = SaveTextFile(InParFile$, "")
  End If

  GetCmdFileSpecs = False

End Function

Sub GetHomeDir()

  '--- HomeDir bestimmen (z.B. C:\HM51\) ---
  '  (1 Ebene unter AppPath z.B. C:\HM51\WIN)

  '  HomeDir hat immer ein "\" am Ende !

  'Start before "\" at end and go left to find second"\" from right
  HomeDir$ = AddBackSlash$(AppPath$())

  'If MSG-File is in AppPath -> use AppPath as HomeDir
  If Len(Dir$(HomeDir$ & "*.MSG")) > 0 Then Exit Sub

  For i = Len(HomeDir$) - 1 To 1 Step -1
    If Mid$(HomeDir$, i, 1) = "\" Then
      HomeDir$ = Left$(HomeDir$, i)
      Exit For
    End If
  Next i

End Sub

Function InitHmTool(PrgNam$, MsgList$)

  InitHmTool = True


  ProgName$ = PrgNam$

  App.Title = ProgName$

  'Kommandozeile analysieren
  Call ParseCmdLine
  GV.ExpertMode = FindCmdOpt("/X", Par$)
  GV.DesignMode = FindCmdOpt("/D", Par$)
  GV.HammapMode = Not FindCmdOpt("/H", Par$)


  '--- Home-Directory (C:\HAMMAP\) bestimmen ---
  Call GetHomeDir


  '--- FileSpec fuer MSG, HLP und INI bestimmen ---
  ErrNr = GetCmdFileSpecs()
  If ErrNr Then Exit Function


  '--- Messages laden ---
  If Len(MsgList$) > 0 Then
    OutMsgFile$ = ""

    ErrNr = LoadMessages(MsgList$, OutMsgFile$)
    If ErrNr Then Exit Function

    'Version berprfen
    If Left$(MsgList$, 3) = "DOS" And Msg$(1) <> "V" & Version$ Then
      MsgBox "Versions Unvertrglichkeit" & vbCrLf & _
        "Version incompatibility"
      Exit Function
    End If

  End If


  '--- Ggf. Hilfe ausgeben ---
  If FindCmdOpt("/?", Opt$) Then
    'Must be modal
    void = ShowSection(HlpFile$, ProgName$ + "-Start", 1)
    Exit Function
  End If


  '--- Trennzeichen berprfen (fr Unformat) ---
  s1$ = Mid$(Format$(1234, "0,000"), 2, 1)
  s2$ = Mid$(Format$(0, "0.0"), 2, 1)
  If s1$ = s2$ Then
    'Must be modal
    void = ShowSection(HlpFile$, "Country-Setup", 1)
    Exit Function
  End If

  InitHmTool = False

End Function

Sub ParseCmdLine()

  Dim Pass, Cmd$, Pt

  For Pass = 1 To 2

    Cmd$ = LTrim$(Command$)
    modAnzCmdOpt = 0
    GV.AnzCmdFiles = 0

    Do Until Len(Cmd$) = 0

      'Ende des aktuellen Parameters finden
      InString = (Left$(Cmd$, 1) = """")
      Eop = Len(Cmd$)

      For i = 2 To Len(Cmd$)
        Select Case Mid$(Cmd$, i, 1)
        Case """"
          InString = Not InString
        Case " ", "/"
          If Not InString Then
            Eop = i - 1
            Exit For
          End If
        End Select
      Next i

      Par$ = Left$(Cmd$, Eop)
      Cmd$ = LTrim$(Mid$(Cmd$, Eop + 1))

      If Left$(Par$, 1) = "/" Then
        'Option
        modAnzCmdOpt = modAnzCmdOpt + 1
        If Pass = 2 Then
          modCmdOpt$(modAnzCmdOpt) = Parse$(Par$, ":")
          modCmdOptPar$(modAnzCmdOpt) = DropDblQuotes$(Par$)
        End If
      Else
        'File
        GV.AnzCmdFiles = GV.AnzCmdFiles + 1
        If Pass = 2 Then
          CmdFiles$(GV.AnzCmdFiles) = DropDblQuotes$(Par$)
        End If
      End If

    Loop

    If Pass = 1 Then
      ReDim modCmdOpt$(0 To modAnzCmdOpt)
      ReDim modCmdOptPar$(0 To modAnzCmdOpt)
      ReDim CmdFiles$(0 To GV.AnzCmdFiles)
    End If

  Next Pass

End Sub

Sub ShowAbout()

  MsgBox GetAbout(""), 0, ProgName$ & "  -  " & Msg$(25026)

End Sub

