Attribute VB_Name = "IOSUB"
'---------------------------- IOSUB.BAS ----------------------------

'I/O-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z



Const MaxFiles = 30
Dim FileName$(1 To MaxFiles)            'Datei-Namen

Function ChangePath(FileSpec$)

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  On Local Error Resume Next
  If Len(d$) > 0 Then ChDrive d$
  If Len(p$) > 0 Then ChDir StripBackSlash$(p$)
  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, p$)

  ChangePath = ErrNr

End Function

Function CloseFile(FileNr)

  On Local Error Resume Next

  Select Case FileNr
  Case -1                     'Alle Dateien schliessen
    Close
    For i = 1 To MaxFiles
      FileName$(i) = ""
    Next i

  Case 0                      'Datei ist bereits geschlossen

  Case Else                   'Datei #FileNr schliessen
    OldNr = FileNr
    OldName$ = FileName$(FileNr)
    Close #FileNr
    FileName$(FileNr) = ""
    FileNr = 0
  End Select

  ErrNr = Err
  On Error GoTo 0

  CloseFile = ErrNr

  If ErrNr Then Call FileError(Msg$(ErrNr), OldName$)

End Function

Function CountFiles(FileSpec$)

  ErrNr = GetDir(FileSpec$, f$)
  If ErrNr Then Exit Function

  Do Until Len(f$) = 0
    n = n + 1
    f$ = Dir$
  Loop

  CountFiles = n

End Function

Function DeleteFile(File$, Found)

  On Local Error Resume Next

  '--- Datei loeschen ---
  Kill File$

  DeleteFile = Err
  Found = False

  Select Case Err
  Case 0
    Found = True
  Case 53
    DeleteFile = False
  Case Else
    Call ShowErrNrFileTxt(Err, File$)
  End Select

  On Local Error GoTo 0

End Function

Function ExistFile(File$, MustExist, Exist)

  ErrNr = GetDir(File$, f$)
  Exist = Len(f$) > 0

  'Datei nicht gefunden
  If ErrNr = 0 And MustExist And Not Exist Then
    ErrNr = 53
    Call ShowErrNrFileTxt(ErrNr, File$)
  End If

  ExistFile = ErrNr

End Function

Function ExtractSection(InpData$, SectName$, BOFD&, BOSN&, BOSD&, EOSD&)

  'Pointer to first character after end of file
  l& = Len(InpData$) + 1

  'Find Begin of Section Name (Starting at Begin of File Data = BOFD)
  BOSN& = InStr(BOFD&, InpData$, SectName$)
  If Len(SectName$) = 0 Then BOSN& = 0
  ExtractSection = (BOSN& > 0&)   'Section found

  If BOSN& = 0 Then
    'Section not found
    'InpData$ = InpData$ & vbCrLf
    BOSN& = l&
    BOSD& = BOSN&
    EOSD& = BOSN&
  Else
    'Find Begin of Section Data (Begin of Line after Section Name)
    BOSD& = InStr(BOSN&, InpData$, vbCrLf) + 2
    If BOSD& = 2 Then
      'No CRLF = Section Name is at end of file
      BOSD& = l&
      EOSD& = l&
    Else
      'Find End of Section = EOS (Begin of next Section)
      EOSD& = InStr(BOSN&, InpData$, vbCrLf + "[") + 2
      If EOSD& = 2 Then
        'No next Section (actual section is last section)
        EOSD& = l&
      End If
    End If
  End If

End Function

Function FindSection(FileNr, InId$, InpLine$, MustExist, Found)

  FindSection = True
  Found = False

  Id$ = UCase$(InId$)
  If Left$(Id$, 1) <> "[" Then Id$ = "[" + Id$ + "]"

  Do Until UCase$(Trim$(InpLine$)) = Id$

    'Bereich nicht gefunden
    If EOF(FileNr) Then
      If MustExist Then
        m$ = Msg$(25030) + " '" + Id$ + "'"
        Call FileError(m$, FileName$(FileNr))
      End If
      ErrNr = CloseFile(FileNr)
      If ErrNr Then Exit Function
      FindSection = MustExist
      Exit Function
    End If

    'Zeile lesen
    ErrNr = ReadLine(FileNr, InpLine$)
    If ErrNr Then
      void = CloseFile(FileNr)
      Exit Function
    End If

  Loop

  FindSection = False
  Found = True

End Function

Function GetDir(FileSpec$, FirstDir$)

  On Error Resume Next
  FirstDir$ = Dir$(FileSpec$)
  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then FirstDir$ = ""

  'Pfad nicht gefunden
  If ErrNr = 76 Then ErrNr = 0

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, FileSpec$)

  GetDir = ErrNr

End Function

Function GetExt$(FileSpec$)

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  GetExt$ = e$

End Function

Function GetFileAttr(FileSpec$, Attr)

  On Local Error Resume Next

  'Command not available in VBDOS
  Attr = GetAttr(FileSpec$)

  GetFileAttr = Err

  If Err Then Call FileError(Msg$(Err), FileSpec$)

  On Local Error GoTo 0

End Function

Function GetFileName$(FileNr)

  If FileNr > 0 And FileNr <= MaxFiles Then
    f$ = FileName$(FileNr)
  End If

  If Len(f$) = 0 Then
    GetFileName$ = "File" + Str$(FileNr)
  Else
    Call ParseFileSpec(f$, d$, p$, n$, e$)
    GetFileName$ = n$ + e$
  End If

End Function

Function GetLenText(FileNr, Position As Long, Txt$)

  On Local Error Resume Next

  '--- Laenge einlesen ---
  If Position = 0 Then
    Get #FileNr, , l
  Else
    Get #FileNr, Position, l
  End If

  '--- Text einlesen ---
  If Err = 0 Then
    Txt$ = Input$(l, #FileNr)
  End If

  GetLenText = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

  On Local Error GoTo 0

End Function

Function GetSection(FileName$, InSectList$, MustExist, SectData$, AnzDataLines, Found)

  GetSection = True

  '---- Sequentiell einlesen ---
  ' (Einlesen und Analysieren der ganzen Datei ist zu langsam)

  '----- Datei oeffnen und Bereich suchen ------
  ErrNr = OpenFile(FileName$, "I", 0, FileNr)
  If ErrNr Then Exit Function

  SectList$ = InSectList$

  SectData$ = ""
  AnzDataLines = 0

  Do Until Len(SectList$) = 0

    SectName$ = Parse$(SectList$, ",")

    ErrNr = FindSection(FileNr, SectName$, InpLine$, MustExist, Found)

    '----- Bereich einlesen ------
    If Found Then
      m$ = ""
      Do Until EOF(FileNr)
        ErrNr = ReadLine(FileNr, InpLine$)
        If ErrNr Then Exit Do

        c1$ = Left$(InpLine$, 1)
        If c1$ = "[" Then Exit Do
        m$ = m$ + InpLine$ + vbCrLf

        If Len(InpLine$) > 0 And c1$ <> ";" Then
          AnzDataLines = AnzDataLines + 1
        End If
      Loop
      SectData$ = SectData$ + m$
    End If

    If ErrNr Then Exit Do
  Loop

  '----- Datei schliessen ------
  ErrNr = ErrNr Or CloseFile(FileNr)
  If ErrNr Then Exit Function

  GetSection = False

End Function

Function GetString(FileNr, Length&, St$)

  On Local Error Resume Next

  '--- String ausgeben ---
  St$ = Input$(Length&, #FileNr)

  GetString = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function LoadTextFile(FileSpec$, MaxLen As Long, text$)

  Dim lot As Long

  LoadTextFile = True

  '--- Datei oeffnen ---
  ErrNr = ExistFile(FileSpec$, True, Exist)
  If ErrNr Then Exit Function

  ErrNr = OpenFile(FileSpec$, "B", 0, FileNr)
  If ErrNr Then Exit Function

  lot = LOF(FileNr)
  If lot > MaxLen And MaxLen > 0 Then
    Call ShowErrNrFileTxt(25010, FileSpec$)
    lot = MaxLen
  End If

  '--- Datei einlesen ---
  On Local Error Resume Next
  text$ = Input$(lot, #FileNr)
  ErrNr = Err
  On Local Error GoTo 0

  If ErrNr Then
    Call ShowErrNrFileTxt(ErrNr, FileSpec$)
  'Else
  '  Call CRtoCRLF(Text$)               'CR -> CRLF
  End If


  '--- Datei schliessen ---
  ErrCl = CloseFile(FileNr)
  LoadTextFile = ErrNr Or ErrCl

End Function

Function MakePath(NewPath$)

  'Funktion: Pfad anlegen
  'NewPath$ muss "\" am Ende des Pfades haben

  Static LastPath$

  If NewPath$ = LastPath$ Then Exit Function

  MakePath = True

  Call ParseFileSpec(NewPath$, d$, p$, n$, e$)

  LastPath$ = ""

  'Pruefen auf Root Backslash
  If Left$(p$, 1) <> "\" Then Exit Function
  p$ = Mid$(p$, 2)

  'Pruefen auf Leerzeichen
  If InStr(p$, " ") Then Exit Function

  Do Until Len(p$) = 0
    P1$ = Parse$(p$, "\")
    'Pruefen auf leeres Feld('\\')
    If Len(P1$) = 0 Then Exit Function
    Path$ = Path$ + "\" + P1$

    On Local Error Resume Next
    MkDir d$ + Path$
    ErrNr = Err
    If ErrNr = 75 Then ErrNr = 0      'Pfad existiert schon
    If ErrNr Then
      Call FileError(Msg$(ErrNr), d$ + Path$)
      Exit Function
    End If
    On Local Error GoTo 0
  Loop

  LastPath$ = NewPath$
  MakePath = False

End Function

Function OpenFile(File$, FileTyp$, RecLen, FileNr)

  OpenFile = True

  If FileTyp$ = "RI" Or FileTyp$ = "BI" Then
    ErrNr = ExistFile(File$, True, Exist)
    If ErrNr Then Exit Function
  End If

  On Local Error Resume Next

  FileNr = FreeFile
  ErrNr = Err

  If FileNr <= MaxFiles Then
    FileName$(FileNr) = File$
  Else
    ErrNr = 25012
  End If

  If ErrNr = 0 Then
    Select Case FileTyp$
    Case "I"
      Open File$ For Input As #FileNr
    Case "O"
      Open File$ For Output As #FileNr
    Case "A"
      Open File$ For Append As #FileNr
    Case "B", "BI"
      Open File$ For Binary As #FileNr
    Case "R", "RI"
      Open File$ For Random As #FileNr Len = RecLen
    Case Else
      Stop
    End Select
    ErrNr = Err
  End If

  OpenFile = ErrNr

  If ErrNr Then Call ShowErrNrFileTxt(ErrNr, File$)

End Function

Function PutLenText(FileNr, Position As Long, Txt$)

  On Local Error Resume Next

  '--- Laenge ausgeben ---
  l = Len(Txt$)
  If Position = 0 Then
    Put #FileNr, , l
  Else
    Put #FileNr, Position, l
  End If

  '--- Text ausgeben ---
  If Err = 0 Then
    Put #FileNr, , Txt$
  End If

  PutLenText = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

  On Local Error GoTo 0

End Function

Function PutString(FileNr, St$)

  On Local Error Resume Next

  '--- String ausgeben ---
  Put #FileNr, , St$

  PutString = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function ReadDataLine(FileNr, InpLine$, EndOfFile)

  'Einlesen einer Daten-Zeile
  '   Leerzeilen und Kommentar-Zeilen werden uebersprungen

  ReadDataLine = True

  Do
    'Dateiende
    EndOfFile = EOF(FileNr)
    If EndOfFile Then Exit Do

    ErrNr = ReadLine(FileNr, InpLine$)
    If ErrNr Then Exit Function

    InpLine$ = LTrim$(RTrim$(InpLine$))

    l$ = Left$(InpLine$, 1)
    If l$ = ";" Or l$ = "#" Then InpLine$ = ""

  Loop While Len(InpLine$) = 0

  ReadDataLine = False

End Function

Function ReadLine(FileNr, InpLine$)

  On Local Error Resume Next

  Line Input #FileNr, InpLine$

  ReadLine = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

  On Local Error GoTo 0

End Function

Function RenameFile(OldFile$, NewFile$)

  On Local Error Resume Next

  Name OldFile$ As NewFile$

  RenameFile = Err

  If Err Then
    Call ShowErrNrFileTxt(Err, OldFile$ + " -> " + NewFile$)
   End If

  On Local Error GoTo 0

End Function

Function ReturnFileSpec$(FileNr)

  If FileNr > 0 And FileNr <= MaxFiles Then
    ReturnFileSpec$ = FileName$(FileNr)
  End If

End Function

Function SaveTextFile(FileSpec$, text$)

  SaveTextFile = True

  '-- Datei oeffnen ---
  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr Then Exit Function

  '--- Datei schreiben ---
  ErrNr = WriteString(FileNr, text$)

  '--- Datei schliessen ---
  ErrNr = ErrNr Or CloseFile(FileNr)

  SaveTextFile = ErrNr

End Function

Function SeekFile(FileNr, Position As Long)

  On Local Error Resume Next

  Seek #FileNr, Position

  SeekFile = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

  On Local Error GoTo 0

End Function

Sub ShowErrNr(ErrNr)

  Call FileError(Msg$(ErrNr), "")

End Sub

Sub ShowErrNrFileNr(ErrNr, FileNr)

  If FileNr > 0 And FileNr <= MaxFiles Then
    FileTxt$ = FileName$(FileNr)
  End If

  If Len(FileTxt$) = 0 Then FileTxt$ = "File" + Str$(FileNr)

  Call FileError(Msg$(ErrNr), FileTxt$)

End Sub

Sub ShowErrNrFileTxt(ErrNr, FileTxt$)

  Call FileError(Msg$(ErrNr), FileTxt$)

End Sub

Function StripExt$(FileSpec$)

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  StripExt$ = d$ + p$ + n$

End Function

Function WriteLine(FileNr, OutLine$)

  WriteLine = WriteString(FileNr, OutLine$ + Chr$(13) + Chr$(10))

End Function

Function WriteString(FileNr, OutStr$)

  On Local Error Resume Next

  Print #FileNr, OutStr$;

  WriteString = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

  On Local Error GoTo 0

End Function

