Attribute VB_Name = "LNKSUB"
'-------------------------- LNKSUB.BAS ------------------------

'HAMMAP Link-Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CheckLinkFilter(Lnk As LinkData, Mode)

  CheckLinkFilter = False

  'Pruefen, ob Link geloescht
  If Lnk.LnkDate = 32767 Then Exit Function


  If Mode = 0 Then
    '--- Link ---
    StMask& = NumPar(5).Actual
    TyMask& = NumPar(33).Actual
    BaudMin& = NumPar(24).Actual
    BaudMax& = NumPar(28).Actual
  Else
    '--- Route ---
    StMask& = NumPar(30).Actual
    TyMask& = NumPar(34).Actual
    BaudMin& = NumPar(25).Actual
    BaudMax& = NumPar(29).Actual
  End If


  '--- Pruefen, ob alles ---
  If StMask& = -1& And TyMask& = -1& And BaudMax& = 0& Then
    CheckLinkFilter = True
    Exit Function
  End If


  '--- Status ---
  LnkStat = Lnk.StatTyp And 255
  If (2& ^ LnkStat And StMask&) = 0 Then Exit Function

  '--- Typ ---
  LnkTyp = Lnk.StatTyp \ 256
  If (2& ^ LnkTyp And TyMask&) = 0 Then Exit Function


  '--- Baud ---
  Act& = Lnk.Baud

  If BaudMax& = 0& Then
    'Alle Baud
    CheckLinkFilter = True
  ElseIf Act& > BaudMin& And Act& <= BaudMax& Then
    'untere Grenze < Baud <= obere Grenze
    CheckLinkFilter = True
  ElseIf Act& = BaudMin& And Act& > 0& Then
    'Baud = untere Grenze  -  ausser Baud = 0 (Baud unbekannt)
    CheckLinkFilter = True
  End If

End Function

Function FindSelStnLinks()

  Dim StnCall As StationCall

  'Find all Links for selected Station
  SrcRec = HV.SelStnRec
  If SrcRec = 0 Then Exit Function                   'kein Digi selektiert

  HV.AnzFound = 0
  LnkRec = SelStnData.LnkPtr

  Do Until LnkRec = 0

    '--- Link-Partner und naechsten Link bestimmen ---
    ErrNr = GetNextLink(LnkRec, NextLink, SrcRec, DstRec, ActLnkData)
    If ErrNr Then Exit Do

    '--- Pruefen, dass aktueller Link nicht geloescht ---
    If ActLnkData.LnkDate < 32767 Then

      '--- Daten speichern ---
      If (StnFlags(DstRec) And &H30) = &H30 And HV.AnzFound < UBound(StnFnd) Then
        HV.AnzFound = HV.AnzFound + 1
        StnFnd(HV.AnzFound).StnRec = DstRec
        StnFnd(HV.AnzFound).Status = ActLnkData.StatTyp And 255
        StnFnd(HV.AnzFound).LnkRec = LnkRec

        ErrNr = GetStationCall(DstRec, StnCall)
        If ErrNr Then Exit Do
        StnFnd(HV.AnzFound).StnCall = StnCall
      End If

    End If
    LnkRec = NextLink
  Loop

  '--- Links im Zusatzfenster ausgeben ---
  Call ShowFound(3)

  FindSelStnLinks = ErrNr

End Function

Function GetAllLinkCalls(SrcRec, Mode, m$)

  Static FindCall As StationCall

  GetAllLinkCalls = True

  ErrNr = GetStationData(SV.Out.BsdFile, SrcRec, ActStnData)
  If ErrNr Then Exit Function

  LnkRec = ActStnData.LnkPtr

  m$ = ""

  Do Until LnkRec = 0

    '--- Link-Partner und naechsten Link bestimmen ---
    ErrNr = GetNextLink(LnkRec, NextLink, SrcRec, DstRec, ActLnkData)
    If ErrNr Then Exit Function


    '--- Pruefen, dass aktueller Link nicht geloescht ---
    If ActLnkData.LnkDate < 32767 Then

      If Mode = 0 Then
        'ungefiltert
        Ok = True
      Else
        'gefiltert
        Ok = CheckLinkFilter(ActLnkData, 0)
      End If

      If Ok Then
        ErrNr = GetStationData(SV.Out.BsdFile, DstRec, ActStnData)
        If ErrNr Then Exit Function

        Call DecodeCall(ActStnData.StnCall, OutCall$, LineNr$)
        m$ = OutCall$ + ", " + m$
      End If
    End If

    LnkRec = NextLink
  Loop

  If Len(m$) > 0 Then m$ = Left$(m$, Len(m$) - 2)

  GetAllLinkCalls = False

End Function

Function SelectLink(NewLink)

  HV.SelLnkRec = NewLink

  Call ToolbarShowSelectedLink

End Function

