Attribute VB_Name = "LOADMAP"
'----------------------- LOADMAP.BAS ----------------------------------

DefInt A-Z

Sub InitMapData()

  '--- Kartendaten initialisieren ---
  MV.BinExt(1) = ".BMD"
  MV.BinExt(2) = ".BMC"
  MV.BinExt(3) = ".BMT"

  MV.In.AnzSg = 0
  MV.In.AnzKo = 0

  'Evtl. reservierten Speicher freigeben
  On Local Error Resume Next
  Erase Segm
  Erase Karte1
  Erase Karte2
  On Local Error GoTo 0

  '--- Evtl. offene Files schliessen ---
  void = CloseMapBinFiles(MV.In)

  'Bitmap-Hintergrundspeicher lschen
  MapForm.BitMap.Picture = LoadPicture("")

End Sub

Function LoadMap1(FileSpec$)

  Dim Sg As Segment
  Dim SgPtrTbl As SgTable
  Dim SgCntTbl As SgTable

  LoadMap1 = True

  '--- Dateien oeffnen ---
  ErrNr = OpenMapInBinFiles(FileSpec$, MV.In)
  If ErrNr Then Exit Function


  '--- Pointer und Type-Count Record einlesen ---
  For RecNr = 0 To 2
    ErrNr = GetSegment(MV.In.BmdFile, RecNr + 2, Sg)
    If ErrNr Then Exit Function
    LSet SgPtrTbl = Sg

    ErrNr = GetSegment(MV.In.BmdFile, RecNr + 5, Sg)
    If ErrNr Then Exit Function
    LSet SgCntTbl = Sg


    '--- Compile First-Pointer and Type-Count Record ---
    For i = 0 To 15
      SgTyp = -16 + RecNr * 16 + i
      MV.FirstRec(SgTyp) = SgPtrTbl.Tbl(i)
      MV.SgTypCnt(SgTyp) = SgCntTbl.Tbl(i)
    Next i

  Next RecNr

  MV.In.AnzSg = MV.In.SgHead.AnzSg          'Anzahl Segmente
  MV.In.AnzKo = MV.In.SgHead.AnzKo          'Anzahl Koordinaten



  MV.LoadMode = NumPar(8).Actual And 3

  '--- Speicher fuer Segmente reservieren ---
  If MV.LoadMode And 1 Then
    On Local Error Resume Next
    ReDim Segm(1 To MV.In.AnzSg) As Segment
    ErrNr = Err
    On Local Error GoTo 0

    If ErrNr Then
      MV.LoadMode = MV.LoadMode And Not 1
      NumPar(8).Actual = NumPar(8).Actual And Not 1
      Call ShowErrNrFileNr(24017, MV.In.BmdFile)
    End If
  End If


  '--- Speicher fuer Koordinaten reservieren ---
  On Local Error Resume Next
    If (MV.LoadMode And 2) = 0 Then

      HV.CoLoadMode = 0

    ElseIf MV.In.AnzKo <= 32767 Or VBWin32 <> 0 Then

      HV.CoLoadMode = 1

      ReDim Karte1(1 To MV.In.AnzKo) As Koordinate

    Else

      HV.CoLoadMode = 2

      d1 = (MV.In.AnzKo + 32766&) \ 32767&
      HV.MapDim = (MV.In.AnzKo + (d1 - 1)) \ d1
      ReDim Karte2(0 To HV.MapDim - 1, 0 To d1 - 1) As Koordinate

    End If
    ErrNr = Err
  On Local Error GoTo 0


  If HV.CoLoadMode > 0 Then

    If ErrNr Then
      HV.CoLoadMode = 0
      NumPar(8).Actual = NumPar(8).Actual And Not 2
      Call ShowErrNrFileNr(24017, MV.In.BmcFile)
    End If
  End If


  '--- Karte laden ---
  LoadMap1 = LoadMapTables(Msg$(24008) + n$)

End Function

Function LoadMapData(FileSpec$)

  Dim NewMapArea As lAreaType

  LoadErrNr = LoadMap1(FileSpec$)

  If LoadErrNr = 0 Then
    '--- Maximalwerte fuer Ausschnitt setzen (wenn nicht automatisch) ---
    Call iArea2lArea(MV.In.SgHead.iArea, MV.FileMapArea)

    If (NumPar(46).Actual And MF_AutoMap) = 0 Then
      MV.MaxMapArea = MV.FileMapArea
    End If
  Else
    '--- Fehler beim Laden ---
    Call InitMapData
    void = CloseMapBinFiles(MV.In)
  End If

  Call ShowText("", 13, 0)

  LoadMapData = LoadErrNr

End Function

Function LoadMapFile()

  ErrNr = LoadMapFile1(StrPar(3, 6))    'StrPar(3,6) may change !
  If ErrNr Then
    StrPar(3, 6) = ""
    HV.MapType = 0
  End If

  Call SetMapToolbar

  Call SetMaxMapArea

End Function

Function LoadMapFile1(MapFile$)

  LoadMapFile1 = True

  If Len(MapFile$) = 0 Then Exit Function

  Call InitMapData
  Call EraseWaterPoints


  Ext$ = UCase$(GetExt$(MapFile$))

  If Ext$ = ".BMD" Then

    '----- Binr-Datei -----
    ErrNr = LoadMapData(MapFile$)
    If ErrNr Then Exit Function

    HV.MapType = 1
    NumPar(46).Actual = NumPar(46).Actual And Not MF_BitMap

  Else

    '----- Bitmap/RLE-Datei laden und ggf. kalibrieren -----
    ErrNr = LoadBitmap(MapFile$, MapForm.BitMap)
    If ErrNr Then Exit Function

    DefFile$ = GetDefFile$(MapFile$)

    ErrNr = ExistFile(DefFile$, False, Exist)
    If ErrNr Then Exit Function

    If Exist Then
      'Kartendefinition laden
      ErrNr = LoadTextFile(DefFile$, 32767, Def$)
      If ErrNr Then Exit Function
     Else
      'Karte kalibrieren
      ErrNr = CalibrateBitmap(MapFile$, Def$, Cancel) 'MapFile$ may change !
      If ErrNr Or Cancel Then Exit Function
    End If

    ErrNr = SetBitmapDef(Def$, MV.Border, MV.FileMapArea, MV.degFileMapArea)
    If ErrNr Then Exit Function

    Select Case Ext$
    Case ".BMP"
      HV.MapType = 2
    Case ".RLE"
      HV.MapType = 3
    Case Else
      Stop
    End Select

    NumPar(46).Actual = NumPar(46).Actual Or MF_BitMap

  End If

  LoadMapFile1 = False

End Function

Function LoadMapTables(m$)

  Dim CoCl As CoordCluster

  LoadMapTables = True

  '--- Segmente einlesen ---
  If MV.LoadMode And 1 Then

    If HV.FastLoad And 1 Then

      '--- Segment Array einlesen ---
      Call ShowText(m$ + ".BMD", 13, 11)
      ErrNr = LoadTbl(1, MV.In.BmdFile)
      Call ShowText("", 13, 0)
      If ErrNr Then Exit Function

    Else

      '--- Sequentiell einlesen ---
      ShowStep& = InitPercent&(m$ + ".BMD", CLng(MV.In.AnzSg), 10)

      For RecNr = 1 To MV.In.AnzSg
        If RecNr Mod ShowStep& = 0 Then
          ErrNr = ShowPercent(CLng(RecNr), "")
          If ErrNr Then Exit Function
        End If
        ErrNr = GetSegment(MV.In.BmdFile, RecNr, Segm(RecNr))
        If ErrNr Then Exit Function
      Next RecNr

    End If

  End If


  '----- Koordinaten einlesen -----
  If HV.CoLoadMode > 0 Then

    If HV.FastLoad And 2 Then

      '--- Koordinaten-Array einlesen ---
      Call ShowText(m$ + ".BMC", 13, 11)
      ErrNr = LoadTbl(2, MV.In.BmcFile)
      Call ShowText("", 13, 0)
      If ErrNr Then Exit Function

    Else

      '--- Sequentiell einlesen ---
      ShowStep& = InitPercent&(m$ + ".BMC", MV.In.AnzKo, 10)

      ErrNr = SeekFile(MV.In.BmcFile, 0 * CoRecLen + 1)
      If ErrNr Then Exit Function

      ResetCache = True
      s1 = 0
      s2 = 0

      For i& = 1 To MV.In.AnzKo
        If i& Mod ShowStep& = 0 Then
          ErrNr = ShowPercent(i&, "")
          If ErrNr Then Exit Function
        End If

        ErrNr = GetCoordCache(MV.In.BmcFile, MV.co, ResetCache)
        If ErrNr Then Exit Function

        If HV.CoLoadMode = 1 Then
          Karte1(i&) = MV.co
        Else
          Karte2(s1, s2) = MV.co
          s1 = s1 + 1
          If s1 = HV.MapDim Then
            s1 = 0
            s2 = s2 + 1
          End If
        End If
      Next i&

    End If

  End If

  LoadMapTables = False

End Function

Function RegisterMapFiles()

  Dim FileNr As MapFiles

  RegisterMapFiles = True


  '------- Vektor-Karten -------

  'Anzahl Files bestimmen
  HV.AnzVectorFiles = 0

  Do
    Call ParseFileSpec(StrPar(3, 6), d$, p$, n$, e$)
    dP$ = d$ + p$
    If Len(dP$) = 0 Then dP$ = HomeDir$ & "MAP\"
    AnzFiles = CountFiles(dP$ & "*.BMD")

    If AnzFiles = 0 Then
      Call FileError(Msg$(24220), dP$ & "*.BMD")

      Prepare = (HV.FunctionPrepared = 0)
      'DOS: switch to Text-Mode (if not already in Text-Mode)
      If Prepare Then Call PrepareFunction(False, 1)

      Cancel = LoadNewMap(StdMsg$(20022), 1, Change&)

      If Prepare Then Call TerminateFunction(0, 0&)
      If Cancel Then Exit Function
    End If
  Loop Until AnzFiles > 0


  '--- Arrays dimensionieren ---
  ReDim VectorFileName(1 To AnzFiles) As String
  ReDim VectorFileInfo(1 To AnzFiles) As VectorFileInfoType


  '--- Informationen einlesen ---
  ErrNr = GetDir(dP$ & "*.BMD", f$)

  If ErrNr Then Exit Function

  'Dir$ wird in OpenMapInBinFile gebraucht, deshalb getrennte Schleife
  Do Until Len(f$) = 0
    i = i + 1
    VectorFileName(i) = dP$ & f$
    f$ = Dir$
  Loop

  HV.AnzVectorFiles = 0

  For i = 1 To AnzFiles
    ErrNr = OpenMapInBinFiles(VectorFileName(i), FileNr)
    If ErrNr Then Exit Function

    'Header-Daten speichern
    With VectorFileInfo(i)
      .SegMask = FileNr.SgHead.SegMask

      Call iArea2lArea(FileNr.SgHead.iArea, .Area)
      .Res = FileNr.SgHead.LengRes * 10&
      .Size = LOF(FileNr.BmdFile) + LOF(FileNr.BmcFile)

      'Maximalen Bereich finden
      If Not AreaInArea(0, .Area, MV.MaxVectorArea) Then
        'aktueller Bereich ist grer als MaxArea -> neu setzen
        MV.MaxVectorArea = .Area
      End If
    End With

    ErrNr = CloseMapBinFiles(FileNr)
    If ErrNr Then Exit Function

    HV.AnzVectorFiles = HV.AnzVectorFiles + 1
  Next i



  '----- BitMap-Karten -----

  If Left$(Msg$(24742), 2) <> "$$" Then

    HV.AnzBitmapFiles = 0

    Do
      Call ParseFileSpec(StrPar(3, 6), d$, p$, n$, e$)
      dP$ = d$ + p$
      If Len(dP$) = 0 Then dP$ = HomeDir$ & "MAP\"
      AnzFiles = CountFiles(dP$ & "*.BMP") + CountFiles(dP$ & "*.RLE")

      If AnzFiles = 0 Then
        Call FileError(Msg$(24220), FileSpec$)

        Cancel = LoadNewMap(StdMsg$(20022), 1, Change&)
        If Cancel Then Exit Function
      End If
    Loop Until AnzFiles > 0


    '--- Arrays dimensionieren ---
    ReDim BitmapFileName(1 To AnzFiles) As String
    ReDim BitmapFileInfo(1 To AnzFiles) As BitmapFileInfoType

    'Dateinamen einlesen (getrennte Schleife wegen I/O in CalibrateBitmap)
    AnzFiles = 0

    ErrNr = GetDir(dP$ & "*.BMP", f$)
    If ErrNr Then Exit Function
    Do Until Len(f$) = 0
      AnzFiles = AnzFiles + 1
      BitmapFileName(AnzFiles) = dP$ & f$
      f$ = Dir$
    Loop

    ErrNr = GetDir(dP$ & "*.RLE", f$)
    If ErrNr Then Exit Function
    Do Until Len(f$) = 0
      AnzFiles = AnzFiles + 1
      BitmapFileName(AnzFiles) = dP$ & f$
      f$ = Dir$
    Loop


    '--- Informationen einlesen ---
    HV.AnzBitmapFiles = 0

    For i = 1 To AnzFiles
      ErrNr = RegisterBitMapFile(i, Cancel)
      If ErrNr Then Exit Function       'Cancel or Error
      If Cancel Then Exit For

      HV.AnzBitmapFiles = HV.AnzBitmapFiles + 1
    Next i

  End If

  RegisterMapFiles = False

End Function

Sub SetMaxMapArea()

  Select Case HV.MapType
  Case 0    'Keine Karte geladen
    If HV.AnzBitmapFiles = 0 Then
      If HV.AnzVectorFiles = 0 Then
        Call SetWorldArea(MV.MaxMapArea)
      Else
        MV.MaxMapArea = MV.MaxVectorArea
      End If
    Else
        MV.MaxMapArea = MV.MaxBmpArea
    End If

  Case 1    'Vektor-Karte
    If NumPar(46).Actual And MF_AutoMap Then
      MV.MaxMapArea = MV.MaxVectorArea
    Else
      MV.MaxMapArea = MV.FileMapArea
    End If

  Case 2, 3   'Bitmap-Karte
    If Left$(Msg$(24742), 2) = "$$" Then
      MV.MaxMapArea = MV.FileMapArea
    Else
      If NumPar(46).Actual And MF_AutoMap Then
        MV.MaxMapArea = MV.MaxBmpArea
      Else
        MV.MaxMapArea = MV.FileMapArea
      End If
    End If

  Case Else
    Stop
  End Select

End Sub

