Attribute VB_Name = "LOADSTN"
'-------------------------- LOADSTN.BAS ------------------------

'HAMMAP Stations-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z


Function AllocMem()

  AllocMem = True

  '--- Arrays neu dimensionieren ---
  SV.StnDataLoaded = (NumPar(8).Actual And 8) <> 0
  SV.StnIdxLoaded = (NumPar(8).Actual And 4) <> 0
  SV.StnCallsLoaded = False
  SV.StnQthLoaded = True

  SV.LnkDataLoaded = (NumPar(8).Actual And 16) <> 0
  SV.LnkIdxLoaded = False
  SV.LnkStnPtrLoaded = False

  SV.MaxAnzStn = SV.Out.StnHdr.AnzStnRec + NumPar(10).Actual
  SV.MaxAnzLnk = SV.Out.StnHdr.AnzLnkRec + NumPar(11).Actual


  '--- Index-Arrays muessen im Speicher sein (wegen Verschiebung) ---
  On Local Error Resume Next

  'Stations-Index
  If SV.StnIdxLoaded Then
    ReDim StnIdxTbl(1 To SV.MaxAnzStn) As Integer
  End If

  'Link-Index
  If SV.LnkIdxLoaded Then
    ReDim LnkIdxTbl(1 To SV.MaxAnzLnk) As Integer
  End If

  'Stations-Status
  If Err = 0 Then
    ReDim StnFlags(1 To SV.MaxAnzStn) As Integer
    If Err = 0 Then
      ReDim SaveStnFlags(1 To SV.MaxAnzStn) As Integer
    End If
    If Err Then
      Erase StnIdxTbl
      Erase LnkIdxTbl
    End If
  End If

  ErrNr = Err
  On Local Error GoTo 0


  If ErrNr Then
    Call ShowErrNr(25037)
    Exit Function
  End If


  '--- Stations-Tabelle ---
  If SV.StnDataLoaded Then
    On Local Error Resume Next
    ReDim StnTbl(1 To SV.MaxAnzStn) As StationData
    ErrNr = Err
    On Local Error GoTo 0


    If ErrNr Then
      Call ShowErrNr(31033)
      SV.StnDataLoaded = 0
      NumPar(8).Actual = NumPar(8).Actual And Not 8&
    End If
  End If


  '--- Wenn Stationsdaten nicht geladen wurden -> Calls bzw. Qth laden ---
  If SV.StnDataLoaded Then
    SV.StnCallsLoaded = 0
    SV.StnQthLoaded = 0
  Else
    On Local Error Resume Next

    'Stations-Calls
    If SV.StnCallsLoaded Then
      ReDim StnCallTbl(1 To SV.MaxAnzStn) As StationCall
    End If

    'Stations-Qth
    If SV.StnQthLoaded Then
      ReDim StnQthTbl(1 To SV.MaxAnzStn) As Koordinate
    End If

    ErrNr = Err
    On Local Error GoTo 0


    If ErrNr Then
      Call ShowErrNr(25037)
      SV.StnCallsLoaded = 0
      SV.StnQthLoaded = 0
      Exit Function
    End If
  End If


  '--- Link-Tabelle ---
  If SV.LnkDataLoaded Then
    On Local Error Resume Next
    ReDim LnkTbl(1 To SV.MaxAnzLnk) As LinkData
    ErrNr = Err
    On Local Error GoTo 0


    If ErrNr Then
      Call ShowErrNr(31034)
      SV.LnkDataLoaded = 0
      NumPar(8).Actual = NumPar(8).Actual And Not 16&
    End If
  End If

  'n = (SV.StnDataLoaded <> 0) And 1 Or (SV.StnIdxLoaded <> 0) And 2
  'n = n Or (SV.StnCallsLoaded <> 0) And 4 Or (SV.StnQthLoaded <> 0) And 8
  'n = n Or (SV.LnkDataLoaded <> 0) And 16 Or (SV.LnkIdxLoaded <> 0) And 32
  'n = n Or (SV.LnkStnPtrLoaded <> 0) And 64
  'locate 2,2:print hex$(n):Input a$

  AllocMem = False

End Function

Sub LoadStations()

  '--- Daten initialisieren ---
  Call InitStnData

  HV.ValidStnFlags = 0

  '--- Dateien pruefen und oeffnen ---
  Call ParseFileSpec(UCase$(StrPar(3, 7)), d$, p$, n$, e$)
  If Len(n$) = 0 Then ErrNr = True

  If ErrNr = 0 Then ErrNr = OpenStnInBinFiles(d$ + p$ + n$, SV.Out)

  '---Speicher reservieren ---
  If ErrNr = 0 Then ErrNr = AllocMem()

  '--- Stations-Tabellen laden ---
  If ErrNr = 0 Then ErrNr = LoadStnTables(SV.Out, Msg$(24006) + " " + n$)

  If ErrNr Then
    'Bei Fehler -> Daten initialisieren
    Call InitStnData
    StrPar(3, 7) = ""
  End If

  HmForm.mnuMain(4).Enabled = SV.Out.BsdFile <> 0
  HmForm.mnuMain(5).Enabled = SV.Out.BsdFile <> 0

  Call SetMapToolbar
  Call ShowText("", 13, 0)

End Sub

Function LoadStnTables(FileData As StationFiles, m$)

  Static Stn As StationData
  Static Lnk As LinkData
  Static ActCall As StationCall

  LoadStnTables = True

  '--- Ggf. Stationsdaten einlesen ---
  c1 = SV.StnDataLoaded
  c2 = SV.StnIdxLoaded Or SV.StnCallsLoaded Or SV.StnQthLoaded

  If SV.StnDataLoaded And (HV.FastLoad And 8) <> 0 Then

    '--- Stations-Array einlesen ---
    Call ShowText(m$ + ".BSD", 13, 11)

    AnzRecs& = FileData.StnHdr.AnzStnRec
    SV.Out.StnHdr.AnzStnRec = AnzRecs&

    ErrNr = LoadTbl(4, FileData.BsdFile)

    Call ShowText("", 13, 0)
    If ErrNr Then Exit Function


    '--- Index generieren ---
    If SV.StnIdxLoaded Then
      Call ShowText(Msg$(31051), 13, 11)

      SV.Out.StnHdr.AnzStnRec = 1

      For RecNr = 2 To AnzRecs&
        Stn = StnTbl(RecNr)     '$$$ Neu V8.2
        ActCall = Stn.StnCall   '$$$ geaendert V8.2
        ErrNr = AddStnIdx(ActCall, IdxRecNr, Found, Deleted)
        If ErrNr Then Exit For
        SV.Out.StnHdr.AnzStnRec = SV.Out.StnHdr.AnzStnRec + 1
      Next RecNr

      Call ShowText("", 13, 0)
      If ErrNr Then Exit Function

    End If

  ElseIf c1 Or c2 Then

    '--- Sequentiell einlesen ---
    Anz& = FileData.StnHdr.AnzStnRec
    ShowStep = InitPercent&(m$ + ".BSD", Anz&, 10)

    SV.Out.StnHdr.AnzStnRec = 1

    For RecNr = 2 To Anz&

      '--- Daten von Disk einlesen ---
      ErrNr = InputStationData(FileData.BsdFile, RecNr, Stn)
      If ErrNr Then Exit Function

      '--- Daten in RAM ausgeben ---
      Call StoreStationData(RecNr, Stn)

      '--- Index aktualisieren ---
      If SV.StnIdxLoaded Then
        ErrNr = AddStnIdx(Stn.StnCall, IdxRecNr, Found, Deleted)
        If ErrNr Then Exit For
      End If

      SV.Out.StnHdr.AnzStnRec = SV.Out.StnHdr.AnzStnRec + 1

      If RecNr Mod ShowStep = 0 Then
        ErrNr = ShowPercent(CLng(RecNr), "")
        If ErrNr Then Exit Function
      End If
    Next RecNr

  End If


  '--- Ggf. Linkdaten einlesen ---
  c1 = FileData.BldFile > 0
  c2 = SV.LnkDataLoaded <> 0

  If c1 And c2 And (HV.FastLoad And 16) <> 0 Then

    '--- Link-Array einlesen ---
    Call ShowText(m$ + ".BLD", 13, 11)

    AnzRecs& = FileData.StnHdr.AnzLnkRec
    SV.Out.StnHdr.AnzLnkRec = AnzRecs&

    ErrNr = LoadTbl(5, FileData.BldFile)

    Call ShowText("", 13, 0)
    If ErrNr Then Exit Function


    '--- Index generieren ---
    If SV.LnkIdxLoaded Then
      Call ShowText(Msg$(31052), 13, 11)

      SV.Out.StnHdr.AnzLnkRec = 1

      For RecNr = 2 To AnzRecs&
        ErrNr = GetLinkCalls(RecNr, ActLnkCall(1), ActLnkCall(2))
        If ErrNr Then Exit For
        ErrNr = AddLnkIdx(ActLnkCall(), IdxRecNr, Found, Deleted)
        If ErrNr Then Exit For
        SV.Out.StnHdr.AnzLnkRec = SV.Out.StnHdr.AnzLnkRec + 1
      Next RecNr

      Call ShowText("", 13, 0)
      If ErrNr Then Exit Function
    End If

  ElseIf c1 And (c2 Or SV.LnkIdxLoaded Or SV.LnkStnPtrLoaded) Then

    '--- Sequentiell einlesen ---
    Anz& = FileData.StnHdr.AnzLnkRec
    ShowStep = InitPercent&(m$ + ".BLD", Anz&, 10)

    SV.Out.StnHdr.AnzLnkRec = 1

    For RecNr = 2 To Anz&

        '--- Daten von Disk einlesen ---
      ErrNr = InputLinkData(FileData.BldFile, RecNr, Lnk)
      If ErrNr Then Exit Function

      '--- Daten in RAM ausgeben ---
      Call StoreLinkData(RecNr, Lnk)

      '--- Index aktualisieren ---
      If SV.LnkIdxLoaded Then
        ErrNr = GetLinkCalls(RecNr, ActLnkCall(1), ActLnkCall(2))
        If ErrNr Then Exit For

        ErrNr = AddLnkIdx(ActLnkCall(), IdxRecNr, Found, Deleted)
        If ErrNr Then Exit Function
      End If

      SV.Out.StnHdr.AnzLnkRec = SV.Out.StnHdr.AnzLnkRec + 1

      If RecNr Mod ShowStep = 0 Then
        ErrNr = ShowPercent(CLng(RecNr), "")
        If ErrNr Then Exit Function
      End If
    Next RecNr

  End If

  LoadStnTables = False

End Function

