Attribute VB_Name = "MAPCVT"
'--------------------------- MAPCVT.BAS ------------------------------

'Unterprogramme zum HAMMAP Karten-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM


DefInt A-Z



Dim LineNr As Long                            'Zeilen-Nr
Dim Indata As Segment                         'Eingabe-Segment / -Zeile

Dim LastInX As Long                           'letzter eingelesener x-Wert
Dim LastInY As Long                           'letzter eingelesener y-Wert
Dim LastOutX As Long                          'letzter ausgegebener x-Wert
Dim LastOutY As Long                          'letzter ausgegebener y-Wert
Dim MinAngle                                  'min. Winkel
Dim MaxAngle                                  'max. Winkel

Dim InpLine As String                         'Eingabe-Zeile
Dim Start                                     '  Feld-Anfang
Dim Lol                                       '  Zeilenlaenge
Dim InComment As String                       'Eingabe-Kommentar
Dim OutComment As String                      'Ausgabe-Kommentar

Dim FldSep As String                          'Field Separator
Dim ComSep As String                          'Comment Separator
Dim FmtVer                                    'Format Version

Dim RankSegm(-6 To 31)
Dim RankCoord(-6 To 31) As Long

Function ClearData()

  MV.BinExt(1) = ".BMD"
  MV.BinExt(2) = ".BMC"
  MV.BinExt(3) = ".BMT"

  MV.Out.BmdFile = 0                    'Binaer-Ausgabedateien
  MV.Out.BmcFile = 0
  MV.Out.BmtFile = 0
  MV.Out.TxtFile = 0                    'Text-Ausgabedatei

  MV.Out.AnzSg = 0                      'Anzahl Output-Segmente (ohne Header)
  MV.Out.AnzKo = 0                      'Anzahl Output-Koordinaten (ohne Header)
  MV.Out.SegMask = 0
  MV.Out.TxtLen = 0                     'Text-Laenge (ohne Header)
  MV.Out.FmtErr = 0                     'Anzahl Formatfehler

  MV.In.AnzSg = 0                       'Anzahl Input-Segmente (ohne Header)
  MV.In.AnzKo = 0                       'Anzahl Input-Koordinaten (ohne Header)

  LineNr = 0                            'Zeilen-Nr
  MV.CommentCount = 1                   'nicht mit Leerzeile starten

  MV.Sg.SegType = 0                     'Segment Typ

  Call ClearRecNr

  ClearData = False

End Function

Function ConvertFile(FileSpec$)

  ConvertFile = True

  Dim e$
  Dim WDType
  Dim i, Fmt$

  e$ = GetExt$(FileSpec$)

  '--- Segment-Typ fuer World Digitized aus Dateinamen ---
  If e$ = ".MP1" Then
    If Right$(n$, 1) = "3" Then
      WDType = 18         'Grenzen
    Else
      WDType = 1          'Kuesten, Inseln, Seen
    End If
  End If


  '--- Statistik-Zaehler loeschen
  For i = LBound(RankSegm) To UBound(RankSegm)
    RankSegm(i) = 0
    RankCoord(i) = 0
  Next i


  Select Case e$
  Case ".BMD"

    '-------- Binaer-Datei konvertieren --------
    '--- Dateinamen auf Logfile ausgeben ---
    ErrNr = WriteLog(vbCrLf + Msg$(26001), 3)
    If ErrNr Then Exit Function

    For i = 1 To 3
      ErrNr = WriteLog("    " + StripExt$(FileSpec$) + MV.BinExt(i), 3)
      If ErrNr Then Exit Function
    Next i

    '-- Dateien oeffnen und pruefen ---
    ErrNr = OpenMapInBinFiles(FileSpec$, MV.In)
    If ErrNr Then Exit Function

    MV.In.AnzSg = MV.In.AnzSg + MV.In.SgHead.AnzSg - SgHdrLen
    MV.In.AnzKo = MV.In.AnzKo + MV.In.SgHead.AnzKo - CoHdrLen


    '--- Datei konvertieren ---
    ErrNr = ConvertMapBinFile()
    If ErrNr Then Exit Function

    '--- Dateien schliessen ---
    ErrNr = CloseMapBinFiles(MV.In)
    If ErrNr Then Exit Function


  Case ".MAP", ".MP1", ".OLD", ".TWN", ".TXT"

    '-------- Text-Datei konvertieren --------

    '--- Dateinamen auf Logfile ausgeben ---
    ErrNr = WriteLog(vbCrLf + Msg$(26002), 3)
    If ErrNr Then Exit Function
    ErrNr = WriteLog("    " + FileSpec$, 3)
    If ErrNr Then Exit Function

    '--- Datei oeffnen ---
    ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
    If ErrNr Then Exit Function

    '----- Datei konvertieren -----
    ErrNr = ConvertMapTextFile(FileNr, FileSpec$, WDType)
    If ErrNr Then Exit Function

    '--- Datei schliessen ---
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function


  Case ".BDY", ".PBY", ".CIL", ".RIV"

    '-------- CBD-Datei konvertieren --------

    '--- Dateinamen auf Logfile ausgeben ---
    ErrNr = WriteLog(vbCrLf + Msg$(26001), 3)
    If ErrNr Then Exit Function
    ErrNr = WriteLog("    " + FileSpec$, 3)
    If ErrNr Then Exit Function

    '--- Datei oeffnen ---
    ErrNr = OpenFile(FileSpec$, "B", 0, FileNr)
    If ErrNr Then Exit Function

    '----- Datei konvertieren -----
    ErrNr = ConvertCbdFile(FileNr, e$)
    If ErrNr Then Exit Function

    '--- Datei schliessen ---
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function

  Case Else
    Stop
  End Select

  m1$ = Msg$(26300) + " "
  Fmt$ = "#,##0"

  For i = LBound(RankSegm) To UBound(RankSegm)
    If RankSegm(i) > 0 Then
      m$ = m1$ + Format$(i) + ": " + Format$(RankSegm(i), Fmt$) + " " + Msg$(26006)
      m$ = m$ + ", " + Format$(RankCoord(i), Fmt$) + " " + Msg$(26007)
      ErrNr = WriteLog("        " + m$, 3)
      If ErrNr Then Exit For

      MV.SgTypCnt(i) = MV.SgTypCnt(i) + RankSegm(i)
    End If
  Next i

  ConvertFile = False

End Function

Function ConvertMapBinFile()

  Dim ActData As Segment
  Dim BinX As Long, BinY As Long

  ConvertMapBinFile = True

  TypeMask& = NumPar(5).Actual

  '--- Pruefen, ob gleicher Ausschnitt ---
  c1 = MV.In.SgHead.iArea.ixmin = MV.iMapArea.ixmin
  c2 = MV.In.SgHead.iArea.ixmax = MV.iMapArea.ixmax
  c3 = MV.In.SgHead.iArea.iymin = MV.iMapArea.iymin
  C4 = MV.In.SgHead.iArea.iymax = MV.iMapArea.iymax
  SameArea = c1 And c2 And c3 And C4

  '--- Pruefen, ob unterschiedliche Aufloesung ---
  c1 = CInt(NumPar(1).Actual / 10) = MV.In.SgHead.LengRes
  c2 = NumPar(2).Actual = MV.In.SgHead.AnglRes
  SameRes = c1 And c2

  ErrNr = 0
  MV.OutSegmFlag = False

  ShowStep& = MV.In.SgHead.AnzSg \ 50
  If ShowStep& = 0& Then ShowStep& = 1&
  void = ShowComplete(0&, ShowStep& * 50, MV.In.BmdFile, 29104)


  '----- Segment-Schleife -----
  For SegNr = SgHdrLen + 1 To MV.In.SgHead.AnzSg

    '--- Segment einlesen ---
    ErrNr = GetSegment(MV.In.BmdFile, SegNr, Indata)
    If ErrNr Then Exit For

    'Pruefen, ob Segment im gewuenschten Ausschnitt
    If SameArea Then
      SegEnbl = True
    ElseIf IsComment(Indata) Then
      SegEnbl = True
    Else
      SegEnbl = True
      If Indata.iArea.ixmax < MV.iMapArea.ixmin Then
        SegEnbl = False
      ElseIf Indata.iArea.ixmin > MV.iMapArea.ixmax Then
        SegEnbl = False
      ElseIf Indata.iArea.iymax < MV.iMapArea.iymin Then
        SegEnbl = False
      ElseIf Indata.iArea.iymin > MV.iMapArea.iymax Then
        SegEnbl = False
      End If
    End If


    '--- Pruefen, ob Rank des Segments ausgewaehlt ---
    If SegEnbl Then
      SegEnbl = (2& ^ (Abs(Indata.SegType) - 1) And TypeMask&) <> 0
    End If


    'Anzahl Koordinaten (incl. Anfangswert) < Min. Segment Length ?
    If SegEnbl Then
      If Indata.KoCnt + 1 < NumPar(3).Actual Then
        SegEnbl = False
      End If
    End If


    If SegEnbl Then

      '--- Kommentar einlesen ---
      If Indata.Comment = 0 Then
        Comment$ = ""
      Else
        ErrNr = GetLenText(MV.In.BmtFile, Indata.Comment, Comment$)
        If ErrNr Then Exit For
      End If

      '--- Segment oeffnen ---
      ErrNr = OpenSegment(Indata, False, Comment$)
      If ErrNr Then Exit For

      BinX = Indata.x
      BinY = Indata.y


      '--- Anfang der Koordinaten in Datei suchen ---
      If Indata.KoCnt > 0 Then
        'for KoBeg = 1 -> Byte = 1
        'first Data Record: KoBeg = 3 -> Byte = 9 (Header + 1)
        ErrNr = SeekFile(MV.In.BmcFile, (Indata.KoBeg - 1) * 4 + 1)
        If ErrNr Then Exit For
        ResetCache = True


        '----- Koordinatenschleife innerhalb des Segments -----
        For KoNr = 1 To Indata.KoCnt

          '--- Koordinaten einlesen ---
          ErrNr = GetCoordCache(MV.In.BmcFile, MV.co, ResetCache)
          If ErrNr Then Exit For

          '--- Koordinaten ausgeben ---
          ActData.x = BinX + MV.co.x
          ActData.y = BinY + MV.co.y
          BinX = ActData.x
          BinY = ActData.y

          If IsLine(MV.Sg.SegType) And Not SameRes Then
            '--- Linie mit Pruefung der Aufloesung ---
            ErrNr = OutputLineCoord(ActData)
            If ErrNr Then Exit For
          Else
            '--- andere Koordinaten ---
            ErrNr = OutputCoord(ActData.x, ActData.y)
            If ErrNr Then Exit For
            LastInX = ActData.x
            LastInY = ActData.y
          End If

        Next KoNr

        If ErrNr Then Exit For
      End If
    End If

    '--- % fertig ausgeben ---
    If SegNr Mod ShowStep& = 0 Then
      ErrNr = ShowComplete(CLng(SegNr), 0&, 0, 0)
      If ErrNr Then Exit For
    End If

  Next SegNr


  '----- Letztes Segment auf Binaerdatei ausgeben ------
  If ErrNr = 0 Then
    ErrNr = SaveSegment(OutComment)
  End If

  void = ShowComplete(-1&, 0&, 0, 0)

  ConvertMapBinFile = ErrNr

End Function

Function ConvertMapTextFile(FileNr, FileSpec$, WDType)

  ConvertMapTextFile = True

  ErrNr = 0
  MV.OutSegmFlag = False
  NewSeg = True               'Neues Segment fuer GPS und World Digitized
  SkipSeg = False             'Don't skip segment


  '--- Format-Version ---
  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)
  Select Case e$
  Case ".OLD"                   'Old HAMMAP-Format
    FmtVer = 1
    FldSep = " "
    ComSep = "#"
  Case ".MAP"
    FmtVer = 2                  'default (ohne FORMATVERSION-Befehl)
    FldSep = ","
    ComSep = ";"
  Case ".MP1"
    FmtVer = -1                 'World-Digitized-Format
    FldSep = " "
  Case ".TWN"
    FmtVer = -2                 'Staedte-Format
    ComSep = ";"
  Case ".TXT"
    FmtVer = -3
    FldSep = ","
    ComSep = ";"
  Case Else
    Stop
  End Select


  ShowStep& = LOF(FileNr) \ 50
  NextShow& = ShowStep&
  void = ShowComplete(0&, ShowStep& * 50, FileNr, 29104)


  '--- Zeilenschleife ---
  Do Until EOF(FileNr)

    '--- Zeile einlesen ---
    ErrNr = ReadLine(FileNr, InpLine)
    If ErrNr Then Exit Do

    Actual& = Actual& + Len(InpLine) + 2

    InpLine = LTrim$(InpLine)
    LineNr = LineNr + 1

    If InpLine = "; HAMMAP Map-File" Then
      InpLine = ""
    End If

    If Len(InpLine) = 0 Then

      NewSeg = True             'Neues Segment fuer World Digitized

    ElseIf UCase$(Left$(InpLine, 13)) = "FORMATVERSION" Then

      t$ = Parse$(InpLine, "=")
      FmtVer = Val(InpLine)

      Select Case FmtVer
      Case 1
        FldSep = " "
        ComSep = "#"
      Case 2 To 4
        FldSep = ","
        ComSep = ";"
      Case Else
        Call FileError(Msg$(25002) + ": " + InpLine, File$)
        void = ShowComplete(-1&, 0&, 0, 0)
        Exit Function
      End Select

    Else

      '--- Zeile parsen ---
      Select Case FmtVer
      Case 1 To 4
        ErrNr = ParseHMLine(OldCmd)
        'SkipSeg gilt fr ganzes Segment
        If Indata.SegType <> 0 Then
          SkipSeg = OldCmd
          If SkipSeg Then SkipCnt = SkipCnt + 1
        End If

      Case -1                      'World-Digitized-Format
        ErrNr = ParseWDLine(WDType, NewSeg)

      Case -2
        ErrNr = ParseTwnLine()

      Case -3
        ErrNr = ParseTxtLine(NewSeg, n$ & e$)

      Case Else
        Stop
      End Select

      If ErrNr Then Exit Do

      If Not SkipSeg Then

        '----- Zeile ausgeben ------
        If Indata.SegType <> 0 Then

          '------- Befehlszeile = Segment -------
          'Input-Segmente zaehlen (incl. Kommentare)
          MV.In.AnzSg = MV.In.AnzSg + 1

          'neues Segment oeffnen
          ErrNr = OpenSegment(Indata, False, InComment)
          If ErrNr Then Exit Do

        Else

          '------- Folgezeile = Koordinaten -------
          'Input-Koordinaten zaehlen
          MV.In.AnzKo = MV.In.AnzKo + 1

          'Pruefen, ob Folgezeile am Dateianfang oder nach Kommentarzeile
          If MV.Sg.SegType = 0 Or IsComment(MV.Sg) Then
            ErrNr = 26028
            Call FileError(Msg$(26028) + Str$(LineNr), File$)
            Exit Do
          End If

          If IsLine(MV.Sg.SegType) Then

            'Koordinaten fuer Linie ausgeben
            ErrNr = ProcessLineCoord(Indata)
            If ErrNr Then Exit Do

            'ggf. Kommentar ausgeben -> neues Segment
            If Len(InComment) > 0 Then
              ErrNr = OpenSegment(Indata, True, InComment)
              If ErrNr Then Exit Do
            End If
          Else

            'Andere Koordinaten ausgeben
            ErrNr = ProcessCoord(Indata, InComment)
            If ErrNr Then Exit Do

          End If
        End If
      End If
    End If


    '--- % fertig ausgeben ---
    If Actual& >= NextShow& Then
      ErrNr = ShowComplete(NextShow&, 0&, 0, 0)
      If ErrNr Then Exit Do
      NextShow& = NextShow& + ShowStep&
    End If

  Loop


  '--- letztes Segment ausgeben ---
  If ErrNr = 0 Then
    ErrNr = SaveSegment(OutComment)
  End If

  If SkipCnt > 0 Then
    m$ = Format$(SkipCnt, "#,##0") & " " & Msg$(26015)
    If ErrNr = 0 Then ErrNr = WriteLog(m$, 3)
  End If

  void = ShowComplete(-1&, 0&, 0, 0)

  ConvertMapTextFile = ErrNr

End Function

Function CvtVer1(Col, Attrib$)

  ErrNr = 0

  '----- Farbe -----
  'Farbe uebersetzen
  Select Case Col
  Case 1 To 4
    Col = Col + 7
  Case 15
    Col = 7
  Case Else
    ErrNr = 26011
  End Select


  '----- Attribut -----
  If Abs(Indata.SegType) = 1 Then

    '--- Linienmuster ---

    Select Case Attrib$
    Case "FFFF", ""
      Attrib$ = "0"                     'durchgehende Linie

    Case "FF00", "00FF", "0FF0", "F0F0", "0F0F"
      Attrib$ = "1"                     'gestrichelte Linie

    Case "CCCC", "6666", "3333", "AAAA", "5555"
      Attrib$ = "2"                     'gepunktete Linie

    Case Else
      ErrNr = 26012                     'Fehler
    End Select

  Else

    '--- Randfarbe beim Ausfuellen ---
    If Abs(Indata.SegType) = 2 Then
      If Attrib$ = "15" Then Attrib$ = "7"
    End If
  End If

  CvtVer1 = ErrNr

End Function

Function CvtVer2(Col, Attr)

  ErrNr = 0

  Select Case Indata.SegType
  Case 1                            'Linie
    If Col = 7 Then
      If Attr = 0 Then
        Indata.SegType = 1          'Kuesten, Inseln, Seen, Grenzen
      Else
        Indata.SegType = 19         'sonstige Grenzen
      End If
    ElseIf Col = 10 Then
      Indata.SegType = 8            'Fluesse (nicht double-lined)
    Else
      ErrNr = 26011
    End If

  Case -1                           'Linie (Einzelheiten)
    If Col = 7 Then
      If Attr = 0 Then
        Indata.SegType = 2          'Kuesten, Inseln, Seen, Grenzen
      Else
        Indata.SegType = 20         'sonstige Grenzen
      End If
    ElseIf Col = 10 Then
      Indata.SegType = 9            'Fluesse (nicht double-lined)
    Else
      ErrNr = 26011
    End If

  Case 2              'Wasser
    If Col = 8 Then
      If Attr = 7 Then               'Randfarbe
        Indata.SegType = -1          'Meere, grosse Seen
      Else
        ErrNr = 26013
      End If
    Else
      ErrNr = 26011
    End If

  Case -2
    If Col = 8 Then
      If Attr = 7 Then               'Randfarbe
        Indata.SegType = -2          'Seen (Einzelheiten)
      Else
        ErrNr = 26013
      End If
    Else
      ErrNr = 26011
    End If
  Case Else
    ErrNr = 26010
  End Select

  CvtVer2 = ErrNr

End Function

Function CvtVer3(SgTyp$, Rank, OldCmd)

  ErrNr = 0
  OldCmd = False


  '--- Typ und Rang umwandeln ---
  Select Case SgTyp$
  Case "COAST", "WATER"
    Select Case Rank
    Case 1 To 4
      If SgTyp$ = "COAST" Then
        Indata.SegType = Rank
      Else
        Indata.SegType = -Rank
      End If
    Case 5 To 6
      OldCmd = True
    Case Else
      ErrNr = 26010
    End Select

  Case "RIVER"
    Select Case Rank
    Case 1                'Double Lined River -> handle as Coast
      Indata.SegType = 1
    Case 2 To 5
      Indata.SegType = Rank + 6
    Case 6 To 8
      OldCmd = True
    Case Else
      ErrNr = 26010
    End Select

  Case "CANAL"
    Select Case Rank
    Case 1 To 2
      Indata.SegType = Rank + 14
    Case 3
      OldCmd = True
    Case Else
      ErrNr = 26010
    End Select

  Case "BORDER"
    Select Case Rank
    Case 1
      Indata.SegType = Rank + 17
    Case 2 To 3
      OldCmd = True
    Case Else
      ErrNr = 26010
    End Select

  Case "TOWN"
    Select Case Rank
    Case 1 To 3
      Indata.SegType = Rank + 20
    Case Else
      ErrNr = 26010
    End Select

  Case "SALTPAN", "ICESHELVE"
    Select Case Rank
    Case 1 To 2
      OldCmd = True
    Case Else
      ErrNr = 26010
    End Select

  Case "GLACIER", "REEF"
    If Rank = 1 Then
      OldCmd = True
    Else
      ErrNr = 26010
    End If

  Case Else
    ErrNr = 26010

  End Select

  CvtVer3 = ErrNr

End Function

Function CvtVer4(SgTyp$, Rank)

  ErrNr = 0

  '--- Typ und Rang umwandeln ---
  If SgTyp$ = "WATER" Then
    If Rank < 1 Or Rank > 4 Then ErrNr = 26010
    Indata.SegType = -Rank
  Else
    SgType = FindDetail(SgTyp$)
    If SgType < 0 Then
      ErrNr = 2610
    Else
      MinSegId = Details(SgType).MinSegId - 1
      If Rank < 1 Or Rank > Details(SgType).MaxSegId - MinSegId Then
        ErrNr = 2610
      Else
        Indata.SegType = MinSegId + Rank
      End If
    End If
  End If

  CvtVer4 = ErrNr

End Function

Function FormatError(ErrNr, InLine$)

  '--- Formatfehler ausgeben ---

  FormatError = True

  MV.Out.FmtErr = MV.Out.FmtErr + 1

  m1$ = Msg$(ErrNr) + Str$(LineNr) + ": "
  m2$ = Space$(4) + InLine$
  ErrNr = WriteLog(m1$ + vbCrLf + m2$, 2)
  If ErrNr Then Exit Function

  If MV.Out.TxtFile Then
    ErrNr = WriteLine(MV.Out.TxtFile, "; " + m1$ + vbCrLf + "; " + m2$)
    If ErrNr Then Exit Function
  End If

  FormatError = False

End Function

Function GetField$()

  'Ggg. fuehrende Leerzeichen ueberspringen ---
  If FldSep = " " Then
    Do While Mid$(InpLine, Start, 1) = " " And Start <= Lol
      Start = Start + 1
    Loop
  End If

  If Start <= Lol Then
    Ende = InStr(Start, InpLine, FldSep)
    If Ende = 0 Then Ende = Lol + 1
    GetField$ = Mid$(InpLine, Start, Ende - Start)
    Start = Ende + 1
  Else
    GetField$ = ""
  End If

End Function

Function GetX()

  f$ = GetField$()

  If Len(f$) = 0 Then
    ErrNr = 26021                           'Feld leer
  Else
    ErrNr = Str2dDegCoord(f$, Coord#, 2)
    If ErrNr Then
      ErrNr = 26008
    Else
      Indata.x = Coord# * cfDeg2Sec
      If Abs(Indata.x) > CLng(1.1 * clMaxDegX) Then
        ErrNr = 26008
      ElseIf Indata.x < -clMaxDegX Then
        Indata.x = Indata.x + 2 * clMaxDegX
      ElseIf Indata.x > clMaxDegX Then
        Indata.x = Indata.x - 2 * clMaxDegX
      End If
    End If
  End If

  If ErrNr Then ErrNr = FormatError(ErrNr, InpLine)
  GetX = ErrNr

End Function

Function GetY()

  f$ = GetField$()

  If Len(f$) = 0 Then
    ErrNr = 26022                           'Feld leer
  Else
    ErrNr = Str2dDegCoord(f$, Coord#, 1)
    If ErrNr Then
      ErrNr = 26008
    Else
      Indata.y = Coord# * cfDeg2Sec
      If Indata.y < -clMaxDegY Or Indata.y > clMaxDegY Then
        ErrNr = 26009
      End If
    End If
  End If

  If ErrNr Then ErrNr = FormatError(ErrNr, InpLine)
  GetY = ErrNr

End Function

Function OpenSegment(ActData As Segment, ContSegm, Comment$)

  OpenSegment = True

  '--- voriges Segment auf Binaerdatei ausgeben ---
  '(ab 2. Mal - siehe MV.OutSegmFlag in SaveSegment)
  ErrNr = SaveSegment(OutComment)
  If ErrNr Then Exit Function

  MV.OutSegmFlag = True


  'Continuation Segment -> Segment-Id und -Typ beibehalten
  If ContSegm Then
    'ActData.SegId = MV.Sg.SegId
    ActData.SegType = MV.Sg.SegType
  End If


  '--- neues Segment auf Textdatei ausgeben ---
  If MV.Out.TxtFile Then
    ErrNr = WriteSegment(MV.Out.TxtFile, ActData, Comment$)
    If ErrNr Then Exit Function
  End If


  '----- neues Segment fuer Binaerdatei oeffnen -----
  MV.Out.AnzSg = MV.Out.AnzSg + 1
  RankSegm(ActData.SegType) = RankSegm(ActData.SegType) + 1

  If ActData.SegType >= 0 Then
    MV.Out.SegMask = MV.Out.SegMask Or 2 ^ (ActData.SegType - 1)
  End If


  'Neues Segment vorbelegen
  MV.Sg = ActData
  'Nr. der 1. Koordinate (ab 1)
  MV.Sg.KoBeg = MV.Out.AnzKo + CoHdrLen + 1
  MV.Sg.KoCnt = 0                 'Anzahl Koordinaten

  MV.lSgArea.lxmin = ActData.x
  MV.lSgArea.lxmax = ActData.x
  MV.lSgArea.lymin = ActData.y
  MV.lSgArea.lymax = ActData.y

  LastInX = ActData.x
  LastInY = ActData.y
  LastOutX = ActData.x
  LastOutY = ActData.y
  MinAngle = 32767
  MaxAngle = 32767

  OutComment = Comment$

  OpenSegment = False

End Function

Function OutCheckResolution(ActX As Long, ActY As Long)

  Dim degActPnt As dGeoPoint
  Dim degLastInPnt As dGeoPoint
  Dim degLastOutPnt As dGeoPoint

  degActPnt.l = ActX * cfSec2Deg
  degActPnt.b = ActY * cfSec2Deg
  degLastInPnt.l = LastInX * cfSec2Deg
  degLastInPnt.b = LastInY * cfSec2Deg
  degLastOutPnt.l = LastOutX * cfSec2Deg
  degLastOutPnt.b = LastOutY * cfSec2Deg


  '--- Aufloesung pruefen ---
  AngleLimit = NumPar(2).Actual
  If AngleLimit <> 0 Then
    ActAngle = QthAngle(degLastInPnt, degActPnt)
    If MinAngle = 32767 Then
      '1. Koordinate
      MinAngle = ActAngle
      MaxAngle = ActAngle
    Else
      DiffMax = ActAngle - MaxAngle
      If (DiffMax > 0 And DiffMax < 180) Or DiffMax <= -180 Then
        MaxAngle = ActAngle
      End If

      DiffMin = ActAngle - MinAngle
      If (DiffMin < 0 And DiffMin > -180) Or DiffMin >= 180 Then
        MinAngle = ActAngle
      End If
    End If
  End If

  LengthLimit& = NumPar(1).Actual

  If LengthLimit& = 0 Then
    OutEnbl = True
  Else
    ActDist& = QthDist(degLastOutPnt, degActPnt) * 1000
    OutEnbl = ActDist& >= LengthLimit&

    If Not OutEnbl And AngleLimit <> 0 Then
      DiffAngle = Abs(MaxAngle - MinAngle)
      If DiffAngle > 180 Then DiffAngle = 360 - DiffAngle
      If DiffAngle >= AngleLimit Then OutEnbl = 1
    End If
  End If

  If OutEnbl = 1 Then
    OutCheckResolution = OutputCoord(LastInX, LastInY)
    MinAngle = ActAngle
    MaxAngle = ActAngle
  ElseIf OutEnbl Then
    OutCheckResolution = OutputCoord(ActX, ActY)
    MinAngle = ActAngle
    MaxAngle = ActAngle
  Else
    OutCheckResolution = False
  End If

  LastInX = ActX
  LastInY = ActY

End Function

Function OutputCoord(ByVal ActX As Long, ByVal ActY As Long)

  '--- Unbedingte Ausgabe der Koordinaten ---
  'Parameters must be passed by value - actual parameters may be changed

  OutputCoord = True

  '--- Koordinaten auf Binaerdatei ausgeben ---
  If MV.Out.BmcFile Then
    MV.co.x = ActX - LastOutX
    MV.co.y = ActY - LastOutY
    ErrNr = PutCoordCache(MV.Out.BmcFile, MV.co, 1)
    If ErrNr Then Exit Function
  End If

  '--- Koordinaten auf Textdatei ausgeben ---
  If MV.Out.TxtFile Then
    ErrNr = WriteCoord(MV.Out.TxtFile, ActY)
    If ErrNr Then Exit Function
    ErrNr = WriteString(MV.Out.TxtFile, ", ")
    If ErrNr Then Exit Function
    ErrNr = WriteCoord(MV.Out.TxtFile, ActX)
    If ErrNr Then Exit Function
    'New Line
    ErrNr = WriteLine(MV.Out.TxtFile, "")
    If ErrNr Then Exit Function
  End If

  '--- Minimal-/Maximalwerte feststellen ---
  If ActX < MV.lSgArea.lxmin Then MV.lSgArea.lxmin = ActX
  If ActX > MV.lSgArea.lxmax Then MV.lSgArea.lxmax = ActX
  If ActY < MV.lSgArea.lymin Then MV.lSgArea.lymin = ActY
  If ActY > MV.lSgArea.lymax Then MV.lSgArea.lymax = ActY

  '--- Koordinatenzahl erhoehen ---
  MV.Sg.KoCnt = MV.Sg.KoCnt + 1             'Anzahl im aktuellen Segment
  MV.Out.AnzKo = MV.Out.AnzKo + 1           'Gesamtzahl
  RankCoord(MV.Sg.SegType) = RankCoord(MV.Sg.SegType) + 1

  LastOutX = ActX
  LastOutY = ActY

  OutputCoord = False

End Function

Function OutputLineCoord(ActData As Segment)

  '----- Koordinaten fuer Linie ausgeben ---

  Dim dx As Long, dy As Long
  Dim d As Long
  Dim NewX As Long, NewY As Long
  Dim LastData As Segment

  OutputLineCoord = True

  dx = ActData.x - LastOutX
  dy = ActData.y - LastOutY

  If Abs(dx) > Abs(dy) Then d = Abs(dx) Else d = Abs(dy)


  '--- Wenn Koordinatendifferenz > 30, dann interpolieren ---
  If d > 30000& Then

    AnzSteps = d \ 30000&
    dx = dx / (AnzSteps + 1)
    dy = dy / (AnzSteps + 1)

    For i = 1 To AnzSteps
      NewX = LastOutX + dx
      NewY = LastOutY + dy

      ErrNr = OutputCoord(NewX, NewY)
      If ErrNr Then Exit Function
    Next i

  End If


  'Wenn zuviele Koordinaten im aktuellen Segment
  '  -> neues Segment oeffnen
  If MV.Sg.KoCnt >= NumPar(4).Actual Then
    LastData.x = LastInX
    LastData.y = LastInY
    ErrNr = OpenSegment(LastData, True, "")
    If ErrNr Then Exit Function
  End If


  'Koordinaten ausgeben
  OutputLineCoord = OutCheckResolution(ActData.x, ActData.y)

End Function

Function ParseHMLine(OldCmd)

  Call StartParse
  If IsComment(Indata) Then Exit Function        'Kommentar

  ParseHMLine = True

If FmtVer >= 4 Then
  ErrNr = GetY()                                'y-Koordinate
  If ErrNr = 0 Then ErrNr = GetX()              'x-Koordinate
Else
  ErrNr = GetX()                                'x-Koordinate
  If ErrNr = 0 Then ErrNr = GetY()              'y-Koordinate
End If
  If ErrNr Then Exit Function

  If Start > Lol Then                           'Folgezeile
    ParseHMLine = False
    Exit Function
  End If


  OldCmd = False

  Select Case FmtVer
  Case 1, 2

    '--- Typ, Farbe und Attribut umsetzen ---
    Indata.SegType = Val(GetField$())

    If Indata.SegType = 0 Then
      'zu viele Felder fuer Folgezeile
      If Start <= Lol Then ErrNr = 26023
    ElseIf Indata.SegType < -6 Or Indata.SegType > 6 Then
      ErrNr = 26010
    End If

    Col = Val(GetField$())
    Attrib$ = GetField$()
    If FmtVer = 1 And ErrNr = 0 Then ErrNr = CvtVer1(Col, Attrib$)

    Attr = Val(Attrib$)
    If ErrNr = 0 Then ErrNr = CvtVer2(Col, Attr)

  Case 3

    '--- Typ und Rang umsetzen ---
    SgTyp$ = UCase$(LTrim$(RTrim$(GetField$())))
    Rank = Val(GetField$())
    ErrNr = CvtVer3(SgTyp$, Rank, OldCmd)

  Case 4

    '--- Typ und Rang umsetzen ---
    SgTyp$ = UCase$(LTrim$(RTrim$(GetField$())))
    Rank = Val(GetField$())
    ErrNr = CvtVer4(SgTyp$, Rank)

  Case Else
    Stop
  End Select


  '--- Ggf. Segment-Id lesen ---
  'If Start > Lol Then                           'kein Segment-Id
  '  Indata.SegId = 0
  'Else
  '  Indata.SegId = Val(GetField$())
  'End If


  If ErrNr Then
    Indata.SegType = 1
    'Indata.SegId = 0
    ErrNr = FormatError(ErrNr, InpLine)
    If ErrNr Then Exit Function
  End If


  '--- Pruefen, ob zu viele Felder ---
  If Start <= Lol Then
    ErrNr = FormatError(26024, InpLine)
    If ErrNr Then Exit Function
  End If

  ParseHMLine = False

End Function

Function ParseTwnLine()

  'Format: Name:x,y

  Call StartParse
  If IsComment(Indata) Then Exit Function        'Kommentar

  ParseTwnLine = True

  If Len(InComment) > 0 Or InStr(InpLine, ":") = 0 Then
    ErrNr = FormatError(26014, InpLine)
    If ErrNr Then Exit Function
  End If

  FldSep = ":"
  t$ = GetField$()

  'Staedte-Namen in Lower Case umwandeln
  Upper = True
  For i = 1 To Len(t$)
    ch$ = Mid$(t$, i, 1)
    Select Case Asc(ch$)
    Case 65 To 90, 142, 153, 154
      If Upper Then
        Upper = False
      Else
        Select Case Asc(ch$)
        Case 142    'Ae
          Mid$(t$, i, 1) = Chr$(132)
        Case 153    'Oe
          Mid$(t$, i, 1) = Chr$(148)
        Case 154    'Ue
          Mid$(t$, i, 1) = Chr$(129)
        Case Else
          Mid$(t$, i, 1) = LCase$(ch$)
        End Select
      End If
    Case Else
      Upper = True
    End Select
  Next i

  InComment = t$                   'Town-Name

  FldSep = ","
  ErrNr = GetX()                   'x-Koordinate
  If ErrNr Then Exit Function

  ErrNr = GetY()                   'y-Koordinate
  If ErrNr Then Exit Function


  '--- optional Rank (1...3) ---
  If Start <= Lol Then
    Rnk$ = GetField$()
    If Val(Rnk$) < 1 Or Val(Rnk$) > 3 Then
      ErrNr = FormatError(26013, InpLine)
      If ErrNr Then Exit Function
    End If
    Rank = Val(Rnk$)
  Else
    Rank = 3                       'Default
  End If

  Indata.SegType = Rank + 20


  '--- Pruefen, ob zu viele Felder ---
  If Start <= Lol Then
    ErrNr = FormatError(26024, InpLine)
    If ErrNr Then Exit Function
  End If

  ParseTwnLine = False

End Function

Function ParseTxtLine(NewSeg, FileName$)

  '------------ Parse Line in Text-Format --------------
  'FileFormat:  <y> ',' <x> [ ',' ....]
  'Each file is considered one segment

  ParseTxtLine = True

  Start = 1
  Lol = Len(InpLine)

  ErrNr = GetY()                                'y-Koordinate
  If ErrNr Then Exit Function

  ErrNr = GetX()                                'x-Koordinate
  If ErrNr Then Exit Function


  '--- Segment Typ ---
  If NewSeg Then

    SaveMousePointer = Screen.MousePointer
    Screen.MousePointer = 0

    m$ = Msg$(30016) & " '" & FileName$ & "'"
    Cancel = SelectSegmentType("MAPCVT", m$, "Road", SegType$, Rank, Comment$)
    If Cancel Then Exit Function

    Screen.MousePointer = SaveMousePointer

    DtlNr = FindDetail(SegType$)
    Indata.SegType = Details(DtlNr).MinSegId + Rank - 1
    InComment = Comment$
    NewSeg = False

  Else

    Indata.SegType = 0
    InComment = ""

  End If

  ParseTxtLine = False

End Function

Function ParseWDLine(WDType, NewSeg)

  '------------ Parse Line in World Digitized MP1-Format --------------
  'FileFormat:
  '<y> <blank> <x> [<blank> <comment>]
  'Segments are separated by empty lines

  ParseWDLine = True

  Start = 1
  Lol = Len(InpLine)

  ErrNr = GetY()                                'y-Koordinate
  If ErrNr Then Exit Function

  ErrNr = GetX()                                'x-Koordinate
  If ErrNr Then Exit Function


  '--- Segment Typ ---
  If NewSeg Then
    Indata.SegType = WDType
    NewSeg = False
  Else
    Indata.SegType = 0
  End If


  '--- Ggf. Kommentar ---
  If Start <= Lol Then
    InComment = LTrim$(Mid$(InpLine, Start))
    Indata.SegType = WDType
  Else
    InComment = ""
  End If

  ParseWDLine = False

End Function

Function ProcessCoord(ActData As Segment, Comment$)

  '----- Koordinaten (ausser fuer Linie) verarbeiten ---

  Dim dx As Long, dy As Long

  dx = Abs(ActData.x - LastOutX)
  dy = Abs(ActData.y - LastOutY)

  If dx > 30000 Or dy > 30000 Or Len(Comment$) > 0 Then

    'Wenn Punktabstand zu gross oder Kommentar in Zeile,
    '  dann neues Segment mit jetzigen Koordinaten oeffnen

    ProcessCoord = OpenSegment(ActData, True, Comment$)

  Else

    'Koordinaten ausgeben
    ProcessCoord = OutputCoord(ActData.x, ActData.y)

  End If

End Function

Function ProcessLineCoord(ActData As Segment)

  '----- Koordinaten fuer Linie verarbeiten ---

  Dim dx As Long, dy As Long
  Dim MidData As Segment

  ProcessLineCoord = True

  MidData = ActData
  dx = ActData.x - LastOutX
  dy = ActData.y - LastOutY

  If ActData.x < -clMaxDegX / 2& And LastOutX > clMaxDegX / 2& Then

    '--- 180 Grad nach rechts ueberschreiten ---

    'y interpolieren

    'midy-lasty   acty-lasty   dy
    '---------- = ---------- = --
    'midx-lastx   actx-lastx   dx

    dx = ActData.x + 2 * clMaxDegX - LastOutX

    MidData.x = clMaxDegX
    MidData.y = LastOutY + (MidData.x - LastOutX) * dy / dx

    ErrNr = OutputLineCoord(MidData)
    If ErrNr Then Exit Function

    MidData.x = -clMaxDegX
    ErrNr = OpenSegment(MidData, True, "")
    If ErrNr Then Exit Function


  ElseIf ActData.x > clMaxDegX / 2& And LastOutX < -clMaxDegX / 2& Then

    '--- 180 Grad nach links ueberschreiten ---

    dx = ActData.x - 2 * clMaxDegX - LastOutX

    MidData.x = -clMaxDegX
    MidData.y = LastOutY + (MidData.x - LastOutX) * dy / dx

    ErrNr = OutputLineCoord(MidData)
    If ErrNr Then Exit Function

    MidData.x = clMaxDegX
    ErrNr = OpenSegment(MidData, True, "")
    If ErrNr Then Exit Function

  End If

  ProcessLineCoord = OutputLineCoord(ActData)

End Function

Function SaveSegment(Comment$)

  SaveSegment = True

  If MV.OutSegmFlag Then

    '--- letzte Koordinate auf jeden Fall ausgeben ---
    ' auf Binaer- und Text-Datei
    ' (falls noch nicht geschehen - wegen Aufloesung)
    If IsLine(MV.Sg.SegType) Then
      If LastInX <> LastOutX Or LastInY <> LastOutY Then
        ErrNr = OutputCoord(LastInX, LastInY)
        If ErrNr Then Exit Function
      End If
    End If


    '--- Segment auf Binaerdatei ausgeben ---
    If MV.Out.BmdFile Then

      '--- Kommentar ausgeben ---
      If Len(Comment$) = 0 Then
        MV.Sg.Comment = 0
      Else
        'Start des Textes
        MV.Sg.Comment = MV.Out.TxtLen + TxtHdrLen + 1
        'Textlaenge (+2 fuer Laengenbytes)
        MV.Out.TxtLen = MV.Out.TxtLen + Len(Comment$) + 2
        ErrNr = PutLenText(MV.Out.BmtFile, 0, Comment$)
        If ErrNr Then Exit Function
      End If

      '--- Segment ausgeben ---
      'Segment-Bereich -> Integer (groesser)
      Call lArea2iArea(MV.lSgArea, MV.Sg.iArea, 2)

      ErrNr = StoreSegment(MV.Out.BmdFile, MV.Sg)
      If ErrNr Then Exit Function

    End If
  End If

  SaveSegment = False

End Function

Sub StartParse()

  Dim ClrData As Segment             'immer 0 -> zum Loeschen

  '--- Kommentar abspalten ---
  i = InStr(InpLine, ComSep)
  If i = 0 Then
    InComment = ""
    InpLine = RTrim$(InpLine)
  Else
    InComment = LTrim$(RTrim$(Mid$(InpLine, i + 1)))
    InpLine = RTrim$(Left$(InpLine, i - 1))
  End If

  Lol = Len(InpLine)

  If Lol = 0 Then
    Indata = ClrData                'Segmentdaten loeschen
    Indata.SegType = 30             'Kommentar-Segment
  Else
    Indata.SegType = 0
    Start = 1
  End If

End Sub

