Attribute VB_Name = "MapCvtUp"
'--------------------------- MAPCVTUP.BAS ------------------------------

'Unterprogramme zum HAMMAP Karten-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM


DefInt A-Z
Option Explicit

Function CheckInExt(Ext$)

  Select Case UCase$(Ext$)
  Case ".BMD"
    CheckInExt = 1
  Case ".MAP", ".MP1", ".OLD", ".TWN", ".TXT"
    CheckInExt = 2
  Case ".BDY", ".PBY", ".CIL", ".RIV"
    CheckInExt = 3
  Case Else
    CheckInExt = 0
  End Select

End Function

Function CheckOutExt(Ext$)

  Select Case UCase$(Ext$)
  Case ".BMD"
    CheckOutExt = 1
  Case ".MAP"
    CheckOutExt = 2
  Case ".LOG"
    CheckOutExt = 3
  Case Else
    CheckOutExt = 0
  End Select

End Function

Function ConvertAllFiles(AnzFiles, InputFile$(), OutputFile$())

  Dim ErrNr, IsFile

  ConvertAllFiles = True

  '--------- Binaer-Ausgabedateien oeffnen ------------
  If Len(OutputFile$(1)) > 0 Then
    ErrNr = OpenOutBinFiles(OutputFile$(1))
    If ErrNr Then Exit Function
  End If


  '--------- Text-Ausgabedatei oeffnen ------------
  If Len(OutputFile$(2)) > 0 Then
    ErrNr = OpenOutTextFiles(OutputFile$(2))
    If ErrNr Then Exit Function
  End If


  '--- Datei(en) konvertieren ---
  For IsFile = 1 To AnzFiles
    Screen.MousePointer = 11
    ErrNr = ConvertFile(InputFile$(IsFile))
    Screen.MousePointer = 0
    If ErrNr Then Exit Function
  Next IsFile


  '--- Header bzw. Daten ausgeben ---
  'Binaer-Files muessen zuerst ausgeben werden, da in STNCVT
  '  bei Ausgabe der Textfiles Daten evtl. umsortiert werden
  If Len(OutputFile$(1)) > 0 Then
    ErrNr = SaveOutBinFiles()
    If ErrNr Then Exit Function
  End If

  If Len(OutputFile$(2)) > 0 Then
    ErrNr = WriteOutTextFiles(OutputFile$(2))
    If ErrNr Then Exit Function
  End If

  ConvertAllFiles = False

End Function

Function GetDefExt$(FileTyp)

  Select Case FileTyp
  Case 0: GetDefExt$ = ""
  Case 1: GetDefExt$ = "BMD"
  Case 2: GetDefExt$ = "MAP"
  Case 3: GetDefExt$ = "LOG"
  Case Else: Stop
  End Select

End Function

Sub GetExtras(Title$)

  Dim ErrNr, i, Cancel, Change&

  Const AnzFields = 4

  ErrNr = InitMaskData(AnzFields, Title$, "")
  If ErrNr Then Exit Sub


  For i = 1 To AnzFields
    MaskData(i, 1) = Msg$(26230 + i)      'Prompt
    'Default
    If i = 1 Then
      MaskData(i, 2) = Format$(NumPar(i).Actual / 1000)
      If NumPar(i).Min <> NumPar(i).Max Then
        MaskData(i, 5) = Str$(NumPar(i).Min / 1000)
        MaskData(i, 6) = Str$(NumPar(i).Max / 1000)
      End If
    Else
      MaskData(i, 2) = Format$(NumPar(i).Actual)
      If NumPar(i).Min <> NumPar(i).Max Then
        MaskData(i, 5) = Str$(NumPar(i).Min)
        MaskData(i, 6) = Str$(NumPar(i).Max)
      End If
    End If
  Next i

  Cancel = GetMaskInput(0, Change&)

  If Change& Then
    For i = 1 To AnzFields
      If i = 1 Then
        NumPar(i).Actual = Val(Unformat$(GetMaskData(i))) * 1000!
      Else
        NumPar(i).Actual = Val(Unformat$(GetMaskData(i)))
      End If
    Next i
  End If

  Call EraseMaskData

End Sub

Function GetFileFilter$(Index)

  Dim f$, fb$, ft$

  fb$ = Msg$(29016) + " (*.BMD)|*.BMD"
  ft$ = Msg$(29017) + " (*.MAP)|*.MAP"

  Select Case Index
  Case 0                                    'Eingabedatei
    f$ = fb$ + "|" & ft$
    f$ = f$ + "|" & Msg$(30017) & " (*.TXT)|*.TXT"
    f$ = f$ + "|" & Msg$(26003) & " (*.TWN)|*.TWN"
    f$ = f$ + "|World Data Bank (CBD)|*.BDY;*.PBY;*.CIL;*.RIV"
    f$ = f$ + "|World Digitized (*.MP1)|*.MP1"
    GetFileFilter$ = f$ + "|HAMMAP 3.x (*.OLD)|*.OLD"
  Case 1                                    'Binaer-Ausgabedatei
    GetFileFilter$ = fb$
  Case 2                                    'Text-Ausgabedatei
    GetFileFilter$ = ft$
  Case 3                                    'Logdatei
    GetFileFilter$ = Msg$(29015) + " (*.LOG)|*.LOG"
  End Select

End Function

Sub HelpFunctions(Index)

  Dim s$
  Dim void

  Select Case Index
  Case 1
    s$ = "CONVERT-File"
  Case 2
    s$ = "CONVERT-Convert"
  Case 3
    s$ = "MAPCVT-Options"
  Case 4
    s$ = "HAMMAP-Help"
  End Select

  void = ShowHelp(s$)

End Sub

Function InitConvert(InfoNr)

  Dim MsgList$, ErrNr

  InfoNr = 26000

  MsgList$ = "DOS,HMSUB,MAPCVT,CONVERT,MAP,GEO"
  ErrNr = InitHmTool("MAPCVT", MsgList$)

  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Function


  'Detail-Masken initialisieren
  If ErrNr = 0 Then Call InitDetails

  InitConvert = ErrNr

End Function

Sub InitParameter()

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (CheckBoxMask) muss NumPar.Max = 0 sein !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '    NumPar(...).Label = ""

  Dim a As lAreaType

  ReDim NumPar(1 To 8) As NumParType

  'Reihenfolge 1...4 = Eingabe "Extras" !!! (nicht aendern)
  Call InitNumPar(1, "Resolution", 0&, 0&, 327670)
  Call InitNumPar(2, "Angle", 0&, 0&, 180&)
  Call InitNumPar(3, "MinSegLen", 0&, 0&, 1000&)
  Call InitNumPar(4, "MaxSegLen", 500&, 10&, 100000)

  Call InitNumPar(5, "SegType", -1&, 0&, 0&)
  Call InitNumPar(6, "DataFormat", 2&, 0&, 0&)

  Call InitNumPar(8, "GeoCoord", 2&, 0&, 2&)    'Grad:Min:Sec


  '--- String-Parameter setzen ---
  'Index 1: 1 = Name, 2 = Default, 3 = Actual, 4 = Multiline
  ReDim StrPar(1 To 4, 1 To 6) As String

  'Reihenfolge 1...4 = CvtForm.FileField() !!! (nicht aendern)
  Call InitStrPar(1, "InputFile", "", "+")
  Call InitStrPar(2, "OutBinFile", "", "")
  Call InitStrPar(3, "OutTxtFile", "", "")
  Call InitStrPar(4, "OutLogFile", "", "")

  Call InitStrPar(5, "Version", "", "")

  Call SetWorldArea(a)
  Call InitStrPar(6, "MapArea", lArea2Str$(a), "")

End Sub

Function OpenMapOutBinFiles(BinFile$, FileNr As MapFiles)

  Dim void, i, ErrNr, Found

  OpenMapOutBinFiles = True

  '--- Evtl. geoeffnete Dateien schliessen ---
  void = CloseMapBinFiles(FileNr)


  '--- Alte Dateien loeschen ---
  For i = 1 To 3
    ErrNr = DeleteFile(BinFile$ + MV.BinExt(i), Found)
    If ErrNr Then Exit Function
  Next i


  '--- Dateien oeffnen ---
  ErrNr = OpenFile(BinFile$ + ".BMD", "R", Len(FileNr.SgHead), FileNr.BmdFile)
  If ErrNr Then Exit Function

  ErrNr = OpenFile(BinFile$ + ".BMC", "B", 0, FileNr.BmcFile)
  If ErrNr Then Exit Function

  ErrNr = OpenFile(BinFile$ + ".BMT", "B", 0, FileNr.BmtFile)
  If ErrNr Then Exit Function


  OpenMapOutBinFiles = False

End Function

Function OpenOutBinFiles(OutBinFileSpec$)

  Dim CoordHdr As CoordHeader
  Dim OutBinFile$
  Dim ErrNr, void

  OpenOutBinFiles = True

  '----- Binaer-Ausgabedateien oeffnen -----
  OutBinFile$ = StripExt$(OutBinFileSpec$)


  '--- Dateien oeffnen ---
  ErrNr = OpenMapOutBinFiles(OutBinFile$, MV.Out)
  If ErrNr Then Exit Function


  '---------------- Segmentdatei -----------------
  'Vorlaeufigen Header ausgeben
  MV.Out.SgHead.FmtTyp = Str2Long("HMMD")
  MV.Out.SgHead.FmtVer = Str2Int(MapFmtVer$)
  MV.Out.SgHead.AnzKo = -1                       'Abbruch-Flag
  ErrNr = PutSegmentHeader(MV.Out.BmdFile, MV.Out.SgHead)
  If ErrNr Then Exit Function


  '------------- Koordinatendatei -------------------
  'Header ausgeben
  CoordHdr.FmtTyp = Str2Long("HMMC")
  CoordHdr.FmtVer = Str2Int(MapFmtVer$)

  ErrNr = PutCoordHeader(MV.Out.BmcFile, CoordHdr)
  If ErrNr Then Exit Function


  '------------------ Kommentardatei --------------------
  'Header ausgeben
  ErrNr = PutString(MV.Out.BmtFile, "HMMT" + MapFmtVer$)
  If ErrNr Then Exit Function


  'Output Cache zuruecksetzen
  void = PutCoordCache(MV.Out.BmcFile, MV.co, 0)

  OpenOutBinFiles = False

End Function

Function OpenOutTextFiles(OutTextFile$)

  Dim ErrNr
  Dim m$

  OpenOutTextFiles = True

  'Auf Log-Datei ausgeben
  ErrNr = WriteLog("    " + OutTextFile$, 3)
  If ErrNr Then Exit Function

  '--- Text-Ausgabedatei oeffnen ---
  ErrNr = OpenFile(OutTextFile$, "O", 0, MV.Out.TxtFile)
  If ErrNr Then Exit Function
  m$ = "; HAMMAP Map-File" + vbCrLf

  m$ = m$ + "FormatVersion = 4" + vbCrLf
  ErrNr = WriteLine(MV.Out.TxtFile, m$)
  If ErrNr Then Exit Function

  OpenOutTextFiles = False

End Function

Sub OptionsFunctions(Index)

  Dim Title$, void, dummyAreaName$
  Dim ElemPar&, Cancel, Change&, i, GrdMinSec, ErrNr
  Dim a As lAreaType

  Title$ = ProgName$ & "  -  " & StdMsg$(26200 + Index)

  Select Case Index
  Case 1                'Alles
    NumPar(1).Actual = 0                'Length-Resolution
    NumPar(2).Actual = 0                'Angle-Resolution
    NumPar(3).Actual = 0                'Min. Segment-Length
    NumPar(4).Actual = 32767            'Max. Segment-Length
    NumPar(5).Actual = -1               'Karten-Details

    Call SetWorldArea(a)
    StrPar(3, 6) = lArea2Str$(a)

    Call SetParameter


  Case 3                'Kartenbereich
    GrdMinSec = NumPar(8).Actual + 1   'Grad:Min:Sek

    Cancel = GetAreaLimits(Title$, MV.lParArea, dummyAreaName$, GrdMinSec, Change&)
    If Cancel = 0 Then
      StrPar(3, 6) = lArea2Str$(MV.lParArea)
      Call SetParameter
    End If


  Case 4                'Karten-Details
    ElemPar& = 0&

    For i = 0 To AnzDetails - 1
      If NumPar(5).Actual And Details(i).SegIdMask Then
        ElemPar& = ElemPar& Or Details(i).ElemMask
      End If
    Next i

    Cancel = SelectDetails(Title$, 256, NumPar(5).Actual, ElemPar&, Change&)


  Case 5                'Extras
    Call GetExtras(Title$)

  Case 6                'Datenformat
    Cancel = CheckBoxMask(Title$, 26240, 0, NumPar(6).Actual, 0&, Change&)


  Case 7                'Anzeige
    ErrNr = InitMaskData(2, Title$, "")
    If ErrNr Then Exit Sub

    'Grad:Min:Sek
    Call SetMaskData(1, Msg$(40104), CStr(NumPar(8).Actual), "@40040", "", "")    'Geogr.Koordinaten
    'DOS: 3D-Effekt
    Call SetMaskData(2, Msg$(29200), CStr(NumPar(7).Actual), "@29201", "", "")

    Cancel = GetMaskInput(0, Change&)

    If Not Cancel Then
      NumPar(8).Actual = Val(GetMaskData(1))
      NumPar(7).Actual = Val(GetMaskData(2))
      If Change& And 2 Then Call SetParameter
    End If

    Call EraseMaskData

  End Select

End Sub

Function SaveOutBinFiles()

  Dim ErrNr

  SaveOutBinFiles = True

  '--- Segment-Header setzen ---
  If MV.Out.FmtErr > 0 Then
    MV.Out.SgHead.AnzKo = -1                  'Fehler-Flag
  Else
    'Anzahl Koordinaten (incl. Header)
    MV.Out.SgHead.AnzKo = MV.Out.AnzKo + CoHdrLen
  End If

  'Maximale Koordinatenwerte
  MV.Out.SgHead.iArea = MV.iMapArea
  'Anzahl Segmente (incl.Header)
  MV.Out.SgHead.AnzSg = MV.Out.AnzSg + SgHdrLen
  'Anzahl Kommentarbytes (incl. Header und Laengenbytes)
  MV.Out.SgHead.AnzComment = MV.Out.TxtLen + TxtHdrLen

  MV.Out.SgHead.SegMask = MV.Out.SegMask                'Segment-Typ Maske
  MV.Out.SgHead.LengRes = NumPar(1).Actual / 10         'Laengen-Aufloesung (10 m)
  MV.Out.SgHead.AnglRes = NumPar(2).Actual              'Winkel-Aufloesung


  '--- Header-Segment ausgeben ---
  ErrNr = StoreSegmentHeader(MV.Out.BmdFile, MV.Out.SgHead)
  If ErrNr Then Exit Function


  '--- Koordinaten-Cache leermachen ---
  ErrNr = PutCoordCache(MV.Out.BmcFile, MV.co, 2)
  If ErrNr Then Exit Function

  SaveOutBinFiles = False

End Function

Sub SetParameter()

  Dim m$, void, ErrNr
  Dim a As lAreaType


  '--- Kartenbereich ---
  ErrNr = Str2lArea(StrPar(3, 6), MV.lParArea)
  If IsNullArea(MV.lParArea) Then Call SetWorldArea(MV.lParArea)
  Call lArea2iArea(MV.lParArea, MV.iMapArea, 2)
  Call iArea2lArea(MV.iMapArea, MV.ActMapArea)

  If StrPar(3, 5) <> Version$ Then
    If Len(StrPar(3, 5)) = 0 Then
      'alte Version vor V10.2
      NumPar(7).Actual = NumPar(7).Default      'DOS: 3D-Effekt
      NumPar(8).Actual = NumPar(8).Default
    End If

    StrPar(3, 5) = Version$
    m$ = Params2Str$(False)
    void = WriteParameter(InParFile$, "[" + ProgName$ + "]", m$)
  End If

End Sub

Sub UpdateFunctions(Index)

  'Dummy Subroutine for Compatibility with STNCVT

End Sub

Function WriteStatistics(OutLogFile$)

  Dim ErrNr
  Dim m$, Fmt$

  WriteStatistics = True
  Fmt$ = "#,##0"

  '--- Statistik ausgeben ---

  '--- Segmente ---
  m$ = LPad$(Format$(MV.Out.AnzSg, Fmt$), 4)
  If MV.Out.AnzSg <> MV.In.AnzSg Then
    m$ = m$ + " (" + Format$(MV.In.AnzSg, Fmt$) + ")"
  End If
  ErrNr = WriteLog(vbCrLf + m$ + " " + Msg$(26006), 3)
  If ErrNr Then Exit Function


  '--- Koordinaten ---
  m$ = LPad$(Format$(MV.Out.AnzKo, Fmt$), 4)
  If MV.Out.AnzKo <> MV.In.AnzKo Then
    m$ = m$ + " (" + Format$(MV.In.AnzKo, Fmt$) + ")"
  End If
  ErrNr = WriteLog(vbCrLf + m$ + " " + Msg$(26007), 3)
  If ErrNr Then Exit Function

  m$ = LPad$(Format$(MV.Out.FmtErr), 4)
  ErrNr = WriteLog(vbCrLf + m$ + " " + Msg$(29026), 3)
  If ErrNr Then Exit Function

  If MV.Out.FmtErr > 0 And Len(OutLogFile$) > 0 Then
    m$ = "   " + Msg$(29027) + Quotes$(OutLogFile$)
    ErrNr = WriteLog(m$, 1)
    If ErrNr Then Exit Function
  End If

  WriteStatistics = False

End Function

