Attribute VB_Name = "MapSel"
'-------------------------- SelMap.BAS ------------------------

'Filter-Unterprogramme fuer DOS und Windows
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function FindDetail(SegType$)

  Dim CmdFix  As String * 8

  CmdFix = UCase$(SegType$)

  For i = 0 To AnzDetails - 1
    If UCase$(Details(i).Cmd) = CmdFix Then
      FindDetail = i
      Exit Function
    End If
  Next i

  FindDetail = -1   'Not found

End Function

Function GetMaskVal(ByVal ParVal&, ByVal DtlNr)

  With Details(DtlNr)
    MaskedVal& = (ParVal& And .SegIdMask) \ (2 ^ (.MinSegId - 1))
    GetMaskVal = lMax(1, Log(lMax(1, MaskedVal&)) / Log(2))
  End With

End Function

Sub InitDetails()

  ReDim Details(0 To AnzDetails - 1) As DetailType

  Call SetDetails(0, "Coast", 1, 1, ME_Coasts, 0)      'Kste
  Call SetDetails(1, "Border", 18, 18, ME_Borders, 0)  'Grenze
  Call SetDetails(2, "Lake", 2, 4, ME_Lakes, 0)        'Seen, Inseln
  Call SetDetails(3, "River", 8, 11, ME_Rivers, 0)
  Call SetDetails(4, "Canal", 15, 16, ME_Canals, 0)
  Call SetDetails(5, "Road", 12, 14, ME_Roads, 0)
  Call SetDetails(6, "Mountain", 24, 26, ME_Mountains, ME_MtnNames)
  Call SetDetails(7, "Town", 21, 23, ME_Towns, ME_TownNames)
  Call SetDetails(8, "Grid", 27, 30, ME_Grid, ME_GridNames)

End Sub

Function SelectDetails(Title$, HideRow&, DtlPar&, ElemPar&, Change&)

  With frmMapSel

    .Caption = Title$
    .Tag = Str$(AnzDetails)
    .BigLabel(1).Caption = Msg$(30100)
    .BigLabel(2).Caption = Msg$(30101)
    y = .Scroll(0).Top

    dy = .Scroll(0).Height * 2
    dx = dy / 2
    y1 = dy / 6
    cmddy = 720

    For i = 0 To AnzDetails - 1

      If i > 0 Then
        Load .ActSel(i)
        Load .Scroll(i)
        Load .ActVal(i)
        Load .LabelField(i)
      End If

      .ActSel(i).Top = y
      .Scroll(i).Top = y
      .ActVal(i).Top = y
      .LabelField(i).Top = y

      m$ = Msg$(30110 + i)
      l = .TextWidth(m$)
      If l > MaxLen Then MaxLen = l
      .LabelField(i).Caption = m$

      RowVisible = Left$(m$, 2) <> "$$" And (HideRow& And 2 ^ i) = 0
      .ActSel(i).Visible = RowVisible
      .Scroll(i).Visible = RowVisible
      .ActVal(i).Visible = RowVisible
      .LabelField(i).Visible = RowVisible

      If RowVisible Then y = y + dy
    Next i


    '--- Position der Taster ---
    cmdx = .LabelField(0).Left + MaxLen + dx
    cmdy = .Cmd(0).Top

    For i = 0 To 5
      If i <> 0 Then Load .Cmd(i)
      .Cmd(i).Move cmdx, cmdy
      .Cmd(i).Visible = True
      .Cmd(i).TabIndex = AnzItem + i
      cmdy = cmdy + cmddy
    Next i

    .Cmd(0).Default = True
    .Cmd(1).Cancel = True

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)
    .Cmd(2).Caption = Msg$(25054)
    .Cmd(3).Caption = Msg$(25055)
    .Cmd(4).Caption = Msg$(25058)
    .Cmd(5).Caption = Msg$(25059)


    '--- Formular Hoehe Breite berechnen ---
    hborder = .Height - .ScaleHeight
    wborder = .Width - .ScaleWidth

    frmh = y + y1
    If cmdy > frmh Then frmh = cmdy
    .Height = frmh + hborder
    .Width = cmdx + CmdWidth + dx + wborder


    '--- Controls initialisieren ---
    Call SetDtlCtrl(DtlPar&, ElemPar&)


    '--- Maske anzeigen und auf Ende warten ---
    Call CenterForm(frmMapSel)
    .Show 1
    Cancel = Val(frmMapSel.Tag) <> 0

    '--- Falls nicht Abbruch -> Werte auslesen ---
    If Not Cancel Then

      DtlPar& = 0
      Change& = 0

      For i = 0 To AnzDetails - 1
        ActSel = .ActSel(i).Value
        If Details(i).OldSel <> ActSel Then Change& = True  'Change

        If ActSel Then
          ElemPar& = ElemPar& Or Details(i).ElemMask
        Else
          ClearMask& = Details(i).ElemMask Or Details(i).NameMask
          ElemPar& = ElemPar& And Not ClearMask&
        End If

        ActVal = .Scroll(i).Value
        If Details(i).OldVal <> ActVal Then Change& = True  'Change
        If ActSel Then
          BitVal& = (2& ^ ActVal - 1) * (2& ^ (Details(i).MinSegId - 1))
          DtlPar& = (DtlPar& And Not Details(i).SegIdMask) Or BitVal&
        End If
      Next i

    End If
  End With

  Unload frmMapSel
  Set frmMapSel = Nothing

  SelectDetails = Cancel

End Function

Function SelectSegmentType(Title$, Hint$, Default$, SegType$, Rank, Comment$)

  SelectSegmentType = True

  ErrNr = InitMaskData(3, Title$, Hint$)
  If ErrNr Then Exit Function

  For i = 0 To AnzDetails - 1
    m$ = m$ & "|" & RTrim$(Details(i).Cmd)
  Next i

  Call SetMaskData(1, Msg$(30040), Default$, Mid$(m$, 2), "", "")
  Call SetMaskData(2, Msg$(30041), "", "", "1", "4")
  Call SetMaskData(3, Msg$(30042), "", "", "", "")

  Do
    Cancel = GetMaskInput(0, Change&)
    If Cancel Then Exit Function

    ErrNr = 0
    SegType$ = GetMaskData(1)
    Rank = Val(GetMaskData(2))
    Comment$ = GetMaskData(3)

    If SegType$ = "Water" Then
      If Rank > 4 Then ErrNr = 30015
    Else
      DtlNr = FindDetail(SegType$)
      If DtlNr < 0 Then
        ErrNr = 30014
      Else
        MaxRank = Details(DtlNr).MaxSegId - Details(DtlNr).MinSegId + 1
        If Rank > MaxRank Then ErrNr = 30015
      End If
    End If

    If ErrNr Then Call ShowErrNr(ErrNr)
  Loop Until ErrNr = 0

  SelectSegmentType = False

End Function

Sub SetDetails(DtlNr, SegType$, MinSegId, MaxSegId, ElemMask&, NameMask&)

  SegIdMask& = (2& ^ (MaxSegId - MinSegId + 1) - 1) * (2& ^ (MinSegId - 1))

  With Details(DtlNr)
    .Cmd = SegType$
    .MinSegId = MinSegId
    .MaxSegId = MaxSegId
    .SegIdMask = SegIdMask&
    .ElemMask = ElemMask&
    .NameMask = NameMask&
  End With

  'Debug.Print DtlNr, Cmd$, MinSegId, MaxSegId, Hex$(SegIdMask&)

End Sub

Sub SetDtlCtrl(DtlPar&, ElemPar&)

  With frmMapSel

    For i = 0 To AnzDetails - 1

      .Scroll(i).Max = Details(i).MaxSegId - Details(i).MinSegId + 1

      ActSel = Abs((ElemPar& And (Details(i).ElemMask Or Details(i).NameMask)) <> 0)
      .ActSel(i).Value = ActSel
      .Scroll(i).Enabled = ActSel

      ActVal = GetMaskVal(DtlPar&, i)

      If ActSel Then
        .ActVal(i).Caption = LTrim$(Str$(ActVal))
        .Scroll(i).Value = ActVal
      Else
        .ActVal(i).Caption = "0"
        .Scroll(i).Value = 1
      End If

      Details(i).OldSel = ActSel
      Details(i).OldVal = ActVal
    Next i

  End With

End Sub

