Attribute VB_Name = "MAPSUB"
'----------------------- MAPSUB.BAS -----------------------
DefInt A-Z
'

Sub GetHMCaption(St$, KA$)

  'Stationsdatei
  If Len(StrPar(3, 7)) > 0 Then
    Call ParseFileSpec(StrPar(3, 7), d$, p$, n$, e$)
  Else
    n$ = Msg$(24604) + " " + Msg$(24600)
  End If
  St$ = ProgName$ + " (" + n$ + ")"

  'Kartendatei
  KA$ = Pc8toAnsi$(StrPar(3, 10))
  If Len(KA$) = 0 Then
    AnzFields = NumPar(59).Actual + 1
    KA$ = lArea2Msg$(MV.ActMapArea, AnzFields)  'Text
  End If
  If Len(StrPar(3, 6)) > 0 Then
    Call ParseFileSpec(StrPar(3, 6), d$, p$, n$, e$)
    KA$ = KA$ & " (" & n$ & ")"
  Else
    KA$ = KA$ & " (" + Msg$(24604) + " " + Msg$(24605) + ")"
  End If

End Sub

Sub MapRecSave(xgeo&, ygeo&)

  Call DrawSingleWaterPoint(xgeo&, ygeo&)

  Answer = MsgBox("Save Water?", 4)

  If Answer = 6 Then
    m$ = Unformat$(lSecCoord2StrEx$(ygeo&, 1)) & ", "
    m$ = m$ & Unformat$(lSecCoord2StrEx$(xgeo&, 1))
    m$ = m$ & ", " & gblMapRecType & gblMapRecComment
    gblMapRecComment = ""     'Write comment only once

    void = WriteLine(gblMapRecFile, m$)

    MapForm.Picture = MapForm.Image     'Store Change in Background
  End If

  MapForm.Cls

End Sub

Function MapRecStart(Title$)

  Static File$

  MapRecStart = True

  Cancel = SelectSegmentType(Title$, "", "Water", SegType$, Rank, Comment$)
  If Cancel Then Exit Function

  gblMapRecType = SegType$ & "," & Str$(Rank)
  gblMapRecComment = "    ; " & Comment$


  IniDir$ = HomeDir$ + "\MAP\SRC"
  f$ = "Map (*.MAP)|*.MAP"
  'Flags: PathMustExist + NoChangeDir + HideReadOnly
  Flg& = &H80C&

  Cancel = GetFileSpec(Title$, 2, Flg&, IniDir$, ".MAP", f$, File$)
  If Cancel Then Exit Function

  ErrNr = ExistFile(File$, False, Exist)
  If ErrNr Then Exit Function
  If Exist Then
    Answer = MsgBox("Erase existing File?", 4)
    If Answer = 6 Then m$ = "O" Else m$ = "A"
  Else
    m$ = "O"
  End If

  ErrNr = OpenFile(File$, m$, 0, gblMapRecFile)
  If ErrNr Then Exit Function

  If m$ = "O" Then
    ErrNr = WriteLine(gblMapRecFile, "FormatVersion = 4")
    If ErrNr Then Exit Function
  End If

  MapRecStart = False

End Function

Sub MapRecStop()

  void = CloseFile(gblMapRecFile)

End Sub

Function RestoreMap(KeepSel, KeepFound)

  ErrNr = 0


  'KeepSel: 0 = keep none, 1 = keep old, 2 = keep new selection

  'Restore Station-Status
  HV.ValidStnFlags = HV.ValidSaveStnFlags
  For i = 1 To SV.MaxAnzStn
    StnFlags(i) = SaveStnFlags(i)
  Next i

  'Restore Hit-Table
  For x = LBound(CrtHits, 1) To UBound(CrtHits, 1)
    For y = LBound(CrtHits, 2) To UBound(CrtHits, 2)
      CrtHits(x, y) = SaveCrtHits(x, y)
    Next y
  Next x

  NewSel = HV.SelStnRec
  OldSel = HV.SaveSelStnRec

  If KeepSel = 0 Or (KeepSel = 1 And NewSel > 0) Then
    Call DeselectStation
  End If

  'KeepFound: 0=don't keep; 1 = always keep; 2 = keep if no station selected
  If KeepFound = 0 Or KeepFound = 2 And HV.SelStnRec > 0 Then
    HV.AnzFound = 0
    Call ShowFound(0)
    Call ShowText("", 13, 0)
  End If

  'Tip und CrossHairCursor deaktivieren
  Call EnblMapControls(False)

  'Copy Background to Foreground
  MapForm.Cls
  'MapForm.Refresh
  'DoEvents

  'Tip und CrossHairCursor wieder herstellen
  Call EnblMapControls(True)

  'Selektierung wiederherstellen
  If KeepSel = 1 And OldSel > 0 Then
    void = SelectStation(OldSel, False)
  End If

  'Restore Message
  Call ShowText(LTrim$(gblStoreMessage$), 7, 0)

  RestoreMap = ErrNr

End Function

Sub SelectMapArea(lNewArea As lAreaType, ByVal NewAreaName As String)

  MV.SelMapArea = lNewArea
  StrPar(3, 10) = NewAreaName

  Call NewMap

End Sub

Sub ShowHMCaption()

  Call GetHMCaption(St$, KA$)


  HmForm.Caption = St$
  MapForm.Caption = KA$


End Sub

Function StoreMap(StoreMode&)


  'Tip und CrossHairCursor nicht mitkopieren
  Call EnblMapControls(False)

  'Put Map into BackGround - Clear ForeGround
  MapForm.Picture = MapForm.Image
  MapForm.Cls

  'Tip und CrossHairCursor wieder herstellen
  Call EnblMapControls(True)

  'Save Hit-Table
  For x = LBound(CrtHits, 1) To UBound(CrtHits, 1)
    For y = LBound(CrtHits, 2) To UBound(CrtHits, 2)
      SaveCrtHits(x, y) = CrtHits(x, y)
    Next y
  Next x

  'Save Station-Status
  HV.ValidSaveStnFlags = HV.ValidStnFlags
  For i = 1 To SV.MaxAnzStn
    SaveStnFlags(i) = StnFlags(i)
  Next i

  HV.SaveSelStnRec = HV.SelStnRec

  'Save Message
  gblStoreMessage$ = HmForm.StatusBox.text


  StoreMap = ErrNr

End Function

