Attribute VB_Name = "MCVTIO"
'--------------------------- MCVTIO.BAS ------------------------------

'Unterprogramme zum HAMMAP Karten-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM


DefInt A-Z



Dim SegmBuf(-6 To 31) As Segment
Dim LastRec(-16 To 31) As Integer

Sub ClearRecNr()

  For i = LBound(MV.FirstRec) To UBound(MV.FirstRec)
    MV.SgTypCnt(i) = 0
    MV.FirstRec(i) = 0
    LastRec(i) = 0
  Next i

End Sub

Function CloseOutBinFiles()

  '--- Dateien schliessen ---
  CloseOutBinFiles = CloseMapBinFiles(MV.Out)

End Function

Function CloseOutTextFiles()

  '--- Textdatei schliessen ---
  CloseOutTextFiles = CloseFile(MV.Out.TxtFile)

End Function

Function PutCoordCache(FileNr, Coord As Koordinate, Mode)

  Static Ptr
  Static CoCl As CoordCluster

  ErrNr = 0
  PutCoordCache = True

  Select Case Mode
  Case 0
    '--- Pointer zuruecksetzen (Start) ---
    Ptr = 0

  Case 1
    '--- normale Ausgabe ---
    Ptr = Ptr + 1
    CoCl.xy(Ptr).x = Coord.x
    CoCl.xy(Ptr).y = Coord.y

    If Ptr = 8 Then
      '--- Koordinaten-Cluster ausgeben ---
      On Local Error Resume Next
      Put #FileNr, , CoCl
      ErrNr = Err
      On Local Error GoTo 0

      Ptr = 0
    End If

  Case 2
    '--- Rest noch ausgeben (Ende) ---
    For i = 1 To Ptr
      On Local Error Resume Next
      Put #FileNr, , CoCl.xy(i)
      ErrNr = Err
      On Local Error GoTo 0

      If ErrNr Then Exit For
    Next i

    '--- Trailer an Koordinaten-Datei anhaengen (fuer GetCoordCache) ---
    If ErrNr = 0 Then
      For i = 1 To 8
        CoCl.xy(i).x = 0
        CoCl.xy(i).y = 0
      Next i

      On Local Error Resume Next
      Put #FileNr, , CoCl
      ErrNr = Err
      On Local Error GoTo 0
    End If

    Ptr = 0

  End Select

  PutCoordCache = ErrNr
  If ErrNr Then Call ShowErrNrFileNr(ErrNr, FileNr)

End Function

Function PutCoordHeader(FileNr, CoHdr As CoordHeader)

  '--- Segment ausgeben ---
  On Local Error Resume Next
  Put #FileNr, 1, CoHdr
  PutCoordHeader = Err
  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function PutSegment(FileNr, RecNr, Segm As Segment)

  '--- Segment ausgeben ---
  On Local Error Resume Next
  Put #FileNr, RecNr, Segm
  PutSegment = Err
  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function PutSegmentHeader(FileNr, SgHdr As SegmentHeader)

  Dim Sg As Segment

  LSet Sg = SgHdr

  PutSegmentHeader = PutSegment(FileNr, 1, Sg)

  '--- Segment ausgeben ---
  'On Local Error Resume Next
  'Put #FileNr, 1, SgHdr
  'PutSegmentHeader = Err
  'If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function StoreSegment(FileNr, Segm As Segment)

  StoreSegment = True

  SgTyp = Segm.SegType

  If CLng(MV.Out.AnzSg) + SgHdrLen > 32767 Then
    'zu viele Segmente (max. 32767)
    Call ShowErrNrFileNr(25010, FileNr)
    Exit Function
  End If

  ActRecNr = MV.Out.AnzSg + SgHdrLen

  If MV.FirstRec(SgTyp) = 0 Then
    'First Record of its type
    MV.FirstRec(SgTyp) = ActRecNr
  Else
    SegmBuf(SgTyp).TypePtr = ActRecNr
    OldRecNr = LastRec(SgTyp)
    ErrNr = PutSegment(FileNr, OldRecNr, SegmBuf(SgTyp))
    If ErrNr Then Exit Function
  End If

  SegmBuf(SgTyp) = Segm
  LastRec(SgTyp) = ActRecNr

  StoreSegment = False

End Function

Function StoreSegmentHeader(FileNr, SgHdr As SegmentHeader)

  Dim Sg As Segment
  Dim SgPtrTbl As SgTable
  Dim SgCntTbl As SgTable

  StoreSegmentHeader = True

  '--- "Normalen" Header speichern ---
  ErrNr = PutSegmentHeader(FileNr, SgHdr)
  If ErrNr Then Exit Function


  For RecNr = 0 To 2
    For i = 0 To 15

      SgTyp = -16 + RecNr * 16 + i

      If LastRec(SgTyp) Then
        '--- Store Last records (if any) ---
        LastRecNr = LastRec(SgTyp)
        SegmBuf(SgTyp).TypePtr = 0
        ErrNr = PutSegment(FileNr, LastRecNr, SegmBuf(SgTyp))
        If ErrNr Then Exit Function
      End If

      '--- Compile First-Pointer and Type-Count Record ---
      SgPtrTbl.Tbl(i) = MV.FirstRec(SgTyp)
      SgCntTbl.Tbl(i) = MV.SgTypCnt(SgTyp)
    Next i

    '--- Pointer und Type-Count Record ausgeben ---
    LSet Sg = SgPtrTbl
    ErrNr = PutSegment(FileNr, RecNr + 2, Sg)
    If ErrNr Then Exit Function

    LSet Sg = SgCntTbl
    ErrNr = PutSegment(FileNr, RecNr + 5, Sg)
    If ErrNr Then Exit Function

  Next RecNr

  StoreSegmentHeader = False

End Function

Function WriteCoord(FileNr, xy As Long)

  If NumPar(6).Actual And 1 Then
    'Grad:Min:Sek
    s$ = dDegCoord2DegStr$(CDbl(xy * cfSec2Deg), 3, 0, 0)
    s$ = LPad$(Unformat$(s$), 10)
  Else
    'Grad
    s$ = dDegCoord2DegStr$(CDbl(xy * cfSec2Deg), 1, 4, 0)
    s$ = LPad$(Unformat$(s$), 9)
  End If

  WriteCoord = WriteString(FileNr, s$)

End Function

Function WriteOutTextFiles(OutFileSpec$)

  WriteOutTextFiles = False

End Function

Function WriteSegment(FileNr, Segm As Segment, Comment$)

  WriteSegment = True

  If IsComment(Segm) Then                      'Kommentarzeile

    '--- Kommentarzeile ausgeben ---
    If Len(Comment$) > 0 Then
      'Leerzeile vor 1. Kommentar
      If MV.CommentCount = 0 Then
        If NumPar(6).Actual And 2 Then
          ErrNr = WriteLine(FileNr, "")
          If ErrNr Then Exit Function
        End If
      End If
      MV.CommentCount = MV.CommentCount + 1
      ErrNr = WriteLine(FileNr, "; " + Comment$)
      If ErrNr Then Exit Function
    End If

  Else                                       'Datenzeile

    '--- Leerzeile vor Segment ausgeben ---
    If MV.CommentCount = 0 Then
      If NumPar(6).Actual And 2 Then
        ErrNr = WriteLine(FileNr, "")
        If ErrNr Then Exit Function
      End If
    End If

    MV.CommentCount = 0


    '--- Koordinaten ausgeben ---
    ErrNr = WriteCoord(FileNr, Segm.y)
    If ErrNr Then Exit Function
    ErrNr = WriteString(FileNr, ", ")
    If ErrNr Then Exit Function
    ErrNr = WriteCoord(FileNr, Segm.x)
    If ErrNr Then Exit Function


    '--- Typ und Rang ausgeben ---
    Select Case Segm.SegType
    Case -4 To -1
      m$ = ", Water," + Str$(-Segm.SegType)
    Case Else
      For i = 0 To AnzDetails - 1
        MinSegId = Details(i).MinSegId
        If Segm.SegType >= MinSegId And Segm.SegType <= Details(i).MaxSegId Then
          m$ = ", " & RTrim$(Details(i).Cmd) & "," & Str$(Segm.SegType - MinSegId + 1)
          SegTypeOk = True
          Exit For
        End If
      Next i
      If Not SegTypeOk Then Stop
    End Select

    ErrNr = WriteString(FileNr, m$)
    If ErrNr Then Exit Function


    '--- Ggf. Segment-Id ausgeben ---
    'If Segm.SegId <> 0 Then
    '  ErrNr = WriteString(FileNr, "," + Lpad$(Str$(Segm.SegId), 7))
    '  If ErrNr Then Exit Function
    'End If


    '--- Kommentar ausgeben ---
    If Len(Comment$) = 0 Then
      m$ = ""
    Else
      m$ = "   ; " + Comment$
    End If

    ErrNr = WriteLine(FileNr, m$)
    If ErrNr Then Exit Function

  End If

  WriteSegment = False

End Function

