Attribute VB_Name = "ModLnk"
'---------------------------- MODLNK.BAS ----------------------------
'Link-Modifikations-Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z




'Wegen VBWIN sind lokale Array-Deklarationen nicht moeglich
Dim NLF$(3 To AnzLnkFields)                         'New Link Field

Function AddLnkIdx(LnkCall() As StationCall, RecNr, Found, Deleted)

  Static HighCall1 As StationCall
  Static HighCall2 As StationCall

  AddLnkIdx = True

  'Aktueller Link ist noch nicht mitgezaehlt
  AnzLnkRec = SV.Out.StnHdr.AnzLnkRec

  '--- Link-Index nicht geladen ---
  If Not SV.LnkIdxLoaded Then
    ErrNr = FindLink(LnkCall(), LnkNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    If Not Found Then
      LnkNr = AnzLnkRec + 1
      RecNr = LnkNr
    End If

    AddLnkIdx = False
    Exit Function
  End If


  '--- Link-Index geladen ---
  '--- 1. Link ---
  If AnzLnkRec = 1 Then
    HighCall1.Call = &H80000000
    HighCall1.SSID = 0
    HighCall2.Call = &H80000000
    HighCall2.SSID = 0
  End If


  Cmp = CmpCalls(LnkCall(1), HighCall1)
  If Cmp = 0 Then Cmp = CmpCalls(LnkCall(2), HighCall2)

  If Cmp = 1 Then

    '--- Wenn richtig sortiert, dann Link hinten anfuegen ---
    LnkNr = AnzLnkRec + 1
    RecNr = LnkNr
    LnkIdxTbl(LnkNr) = RecNr
    HighCall1 = LnkCall(1)
    HighCall2 = LnkCall(2)
    Found = False
    Deleted = False

  Else

    ErrNr = FindLink(LnkCall(), LnkNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    '--- Index aktualisieren ---
    If Not Found Then
      RecNr = AnzLnkRec + 1
      For i = AnzLnkRec To LnkNr Step -1
        LnkIdxTbl(i + 1) = LnkIdxTbl(i)
      Next i
      LnkIdxTbl(LnkNr) = RecNr
    End If

  End If

  AddLnkIdx = False

End Function

Function DeleteLinkRec(LnkRec)

  DeleteLinkRec = True

  Static Lnk As LinkData

  '--- Link laden ---
  ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, Lnk)
  If ErrNr Then Exit Function

  '--- Status = geloescht setzen und Link speichern ---
  '   (falls nicht schon geloescht)
  If Lnk.LnkDate < 32767 Then
    Lnk.LnkDate = 32767

    ErrNr = PutLinkData(SV.Out.BldFile, LnkRec, Lnk)
    If ErrNr Then Exit Function

    SV.Out.StnHdr.AnzLnk = SV.Out.StnHdr.AnzLnk - 1
  End If

  DeleteLinkRec = False

End Function

Function EncodeLink(Lnk As LinkData)

  EncodeLink = True

  'Baud = 999999  -> Link-Typ = WI + Baud = 0
  If (SV.DataFormat And 1) <> 0 And LF$(5) = "999999" Then
      LF$(5) = "0"
      LF$(6) = "WI"
  End If

  'Link-Status = WI  -> Link-Typ = WI + Link-Status = OK
  If (SV.DataFormat And 2) <> 0 And UCase$(LF$(3)) = "WI" Then
      LF$(3) = "OK"
      LF$(6) = "WI"
  End If


  '--- Status ueberpruefen und codieren ---
  If Len(LF$(3)) = 0 Then LF$(3) = "?"
  Stat = FindStnAbv(5, LF$(3))

  If Stat < 0 Then          'unbekannt
    Stat = 0
    If SV.ErrorLevel And 16 Then
      ErrNr = StnLnkError(-1, 31003, LF$(3))
      If ErrNr Then Exit Function
    End If
  End If

  Lnk.StatTyp = (Lnk.StatTyp And &H7F00) Or Stat


  '--- Datum ---
  If Len(LF$(4)) <= 4 Then
    Lnk.LnkDate = Val(LF$(4))
  Else
    ErrNr = StnLnkError(-1, 31004, LF$(4))
    If ErrNr Then Exit Function
  End If


  '--- Baudrate ---
  If Len(LF$(5)) <= 8 Then
    Lnk.Baud = Val(LF$(5))
  Else
    ErrNr = StnLnkError(-1, 31009, LF$(5))
    If ErrNr Then Exit Function
  End If


  '--- Typ ueberpruefen und codieren ---
  If Len(LF$(6)) = 0 Then LF$(6) = "?"
  Typ = FindStnAbv(6, LF$(6))

  If Typ < 0 Then          'unbekannt
    Typ = 0
    If SV.ErrorLevel And 16 Then
      ErrNr = StnLnkError(-1, 31014, LF$(6))
      If ErrNr Then Exit Function
    End If
  End If

  Lnk.StatTyp = (Lnk.StatTyp And &HFF) Or Typ * 256


  EncodeLink = False

End Function

Function FindLink(FindCall() As StationCall, LnkNr, RecNr, Found, Deleted)

  Static Stn As StationData
  Static Lnk As LinkData
  Static MidCall1 As StationCall
  Static MidCall2 As StationCall

  FindLink = True
  Found = False

  AnzLnkRec = SV.Out.StnHdr.AnzLnkRec

  '--- Stations-Index nicht geladen ---
  If SV.LnkIdxLoaded = 0 Then

    '--- erstes Call suchen ---
    ErrNr = FindStation(FindCall(1), StnNr, SrcRec, StnFound, Deleted)
    If ErrNr Then Exit Function

    If (StnFound And Deleted) Or Not StnFound Then
      '--- Call nicht gefunden ---
      RecNr = AnzLnkRec + 1
      LnkNr = RecNr
      FindLink = False
      Exit Function
    End If

    ErrNr = GetStationData(SV.Out.BsdFile, SrcRec, Stn)
    If ErrNr Then Exit Function

    RecNr = Stn.LnkPtr                'erster Link

    Do Until RecNr = 0

      '--- Link ermitteln ---
      ErrNr = GetNextLink(RecNr, NextLink, SrcRec, DstRec, Lnk)
      If ErrNr Then Exit Function

      ErrNr = GetStationCall(DstRec, MidCall2)
      If ErrNr Then Exit Function

      If MidCall2.Call = FindCall(2).Call Then
        If MidCall2.SSID = FindCall(2).SSID Then

          '--- Link gefunden ---
          LnkNr = RecNr
          Found = True
          Deleted = (Lnk.LnkDate = 32767)
          FindLink = False
          Exit Function

        End If
      End If

      RecNr = NextLink
    Loop

    'Link nicht gefunden
    RecNr = AnzLnkRec + 1
    LnkNr = RecNr
    FindLink = False
    Exit Function
  End If


  '--- Link-Index ist geladen -> Binaersuche ---
  Lo = 1                                        'Skip Header = #1
  Hi = AnzLnkRec + 1
  Diff = Hi - Lo

  Do Until Diff = 1
    Mitte = Diff \ 2 + Lo
    RecNr = LnkIdxTbl(Mitte)

    ErrNr = GetLinkCalls(RecNr, MidCall1, MidCall2)
    If ErrNr Then Exit Function

    Cmp = CmpCalls(FindCall(1), MidCall1)
    If Cmp = 0 Then Cmp = CmpCalls(FindCall(2), MidCall2)

    Select Case Cmp
    Case 1
      'FindCall(1) > MidCall1
      Lo = Mitte
    Case 2
      'FindCall(1) < MidCall1
      Hi = Mitte
    Case Else
      '--- Link gefunden ---
      LnkNr = Mitte
      RecNr = LnkIdxTbl(Mitte)

      ErrNr = GetLinkData(SV.Out.BldFile, RecNr, Lnk)
      If ErrNr Then Exit Function
      Deleted = (Lnk.LnkDate = 32767)
      Found = True
      FindLink = False
      Exit Function
    End Select

    Diff = Hi - Lo
  Loop

  '--- Link nicht gefunden ---
  LnkNr = Hi
  RecNr = LnkNr
  FindLink = False

End Function

Function OutputLinkData(FileNr, RecNr, Lnk As LinkData)

  On Local Error Resume Next

  Put #FileNr, RecNr, Lnk

  OutputLinkData = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function OutputLinkHeader(FileNr, LnkHdr As LinkHeader)

  On Local Error Resume Next

  Put #FileNr, 1, LnkHdr

  OutputLinkHeader = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function ProcessLink(Cmnd$)

  'Cmnd$:  AL = Add, ML = Modify, DL = Delete
  'Linkdaten in LF$(1...AnzLnkFields)
  'Rueckkgabewert (ErrNr) wird durch SV.ErrorExit und StnLnkError gesteuert

  Static Stn As StationData
  Static OldLnk As LinkData             'alte Linkdaten

  ProcessLink = True

  'Pruefen, ob gleiche Calls
  If LF$(1) = LF$(2) Then
    ErrNr = StnLnkError(-1, 31046, "")
    If ErrNr Then Exit Function
  End If

  'Ggf. Link-Calls vertauschen, damit Call1 < Call2
  If LF$(1) > LF$(2) Then
    Tmp$ = LF$(1)
    LF$(1) = LF$(2)
    LF$(2) = Tmp$
  End If


  '--- Rufzeichen codieren ---
  For i = 1 To 2
    ErrNr = EncodeCall(-1, LF$(i), "0", ActLnkCall(i))
    If ErrNr Then Exit Function
  Next i


  'void = WriteLog(Cmnd$ + ":" + LF$(1) + "," + LF$(2), 3)'Debug

  Select Case Cmnd$
  Case "AL"                                                'Add

    '--- Wenn zu viele Links -> Abbruch ---
    If SV.Out.StnHdr.AnzLnkRec = SV.MaxAnzLnk Then
      ErrNr = CheckLnkMem()
      If ErrNr Then
        void = ConvertError(Msg$(31038))
        Exit Function
      End If
    End If


    '--- beide Stationen suchen ---
    '  muss wegen evtl. Abbruch vor AddLnkIdx stehen
    For i = 1 To 2
      ErrNr = FindStation(ActLnkCall(i), StnNr, ActLnkData.StnPtr(i), Found, Deleted)
      If ErrNr Then Exit Function

      If (Found And Deleted) Or Not Found Then
        ProcessLink = StnLnkError(-2, 31041, LF$(i))
        Exit Function
      End If

    Next i

    '--- Link codieren ---
    ErrNr = EncodeLink(ActLnkData)
    If ErrNr Then Exit Function


    '-------------------- bis hier nichts geaendert --------------------

    '--- Link suchen und Index aktualisieren ---
    ErrNr = AddLnkIdx(ActLnkCall(), LnkRec, Found, Deleted)
    If ErrNr Then Exit Function

    If Found Then

      If Not Deleted Then
        ProcessLink = StnLnkError(-2, 31042, "")            'schon vorhanden
        Exit Function
      End If


      '------ Geloeschten Link reaktivieren ------

      'Alte Linkdaten laden und Pointer uebernehmen
      ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, OldLnk)
      If ErrNr Then Exit Function

      For i = 1 To 2
        ActLnkData.LnkPtr(i) = OldLnk.LnkPtr(i)
        ActLnkData.StnPtr(i) = OldLnk.StnPtr(i)
      Next i

      SV.Out.StnHdr.AnzLnk = SV.Out.StnHdr.AnzLnk + 1

    Else

      '------ Link neu anlegen ------

      '--- Pointer in Stationsdaten aktualisieren ---
      For i = 1 To 2
        ErrNr = GetStationData(SV.Out.BsdFile, ActLnkData.StnPtr(i), Stn)
        If ErrNr Then Exit Function

        ActLnkData.LnkPtr(i) = Stn.LnkPtr
        Stn.LnkPtr = LnkRec

        ErrNr = PutStationData(SV.Out.BsdFile, ActLnkData.StnPtr(i), Stn)
        If ErrNr Then Exit Function
      Next i


      SV.Out.StnHdr.AnzLnk = SV.Out.StnHdr.AnzLnk + 1
      SV.Out.StnHdr.AnzLnkRec = SV.Out.StnHdr.AnzLnkRec + 1
      LnkRec = SV.Out.StnHdr.AnzLnkRec

    End If


    '--- Link speichern ---
    ErrNr = PutLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
    If ErrNr Then Exit Function


  Case "ML", "UL"                                        'Modify, Update

    ErrNr = FindLink(ActLnkCall(), LnkNr, LnkRec, Found, Deleted)
    If ErrNr Then Exit Function

    If (Found And Deleted) Or Not Found Then
      ProcessLink = StnLnkError(-2, 31044, "")            'nicht gefunden
      Exit Function
    End If

    '--- Alten Link laden ---
    ErrNr = GetLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
    If ErrNr Then Exit Function


    '--- Datum vergleichen ---
    Olddate = ActLnkData.LnkDate
    Newdate = Val(LF$(4))
    If Olddate <> 0 And Newdate <> 0 Then
      If Olddate < 8000 Then Olddate = Olddate + 10000
      If Newdate < 8000 Then Newdate = Newdate + 10000
      If Newdate < Olddate Then
        ErrNr = StnLnkError(-3, 31019, LF$(4))
        If ErrNr Then Exit Function
      End If
    End If


    If Cmnd$ = "ML" Then

      '--- Neue Linkdaten retten ---
      For i = 3 To AnzLnkFields
        NLF$(i) = LF$(i)
      Next i

      '--- Update durchfuehren ---
      ErrNr = DecodeLink(ActLnkData, 0)
      If ErrNr Then Exit Function

      For i = 3 To AnzLnkFields
        If Len(NLF$(i)) > 0 Then LF$(i) = NLF$(i)
      Next i
    End If

    ErrNr = EncodeLink(ActLnkData)
    If ErrNr Then Exit Function


    '-------------------- bis hier nichts geaendert --------------------

    '--- Link speichern ---
    ErrNr = PutLinkData(SV.Out.BldFile, LnkRec, ActLnkData)
    If ErrNr Then Exit Function


  Case "DL"                                                'Delete

    ErrNr = FindLink(ActLnkCall(), LnkNr, LnkRec, Found, Deleted)
    If ErrNr Then Exit Function

    If (Found And Deleted) Or Not Found Then
      ProcessLink = StnLnkError(-2, 31044, "")                 'nicht gefunden
      Exit Function
    End If

    '--- Link loeschen ---
    ErrNr = DeleteLinkRec(LnkRec)
    If ErrNr Then Exit Function

  End Select

  ProcessLink = False

End Function

Function PutLinkData(FileNr, RecNr, Lnk As LinkData)

  PutLinkData = False

  '--- Link-Daten in RAM schreiben ---
  Call StoreLinkData(RecNr, Lnk)

  '--- Link-Daten in Datei schreiben ---
  If FileNr Then PutLinkData = OutputLinkData(FileNr, RecNr, Lnk)

  '--- Puffer in GetLinkData aktualisieren ---
  void = GetLinkData(FileNr, -RecNr, Lnk)

End Function

Function WriteLink(FileNr)

  On Local Error Resume Next

  If SV.TxtFmt = 0 Then
    Print #FileNr, LF$(1); c$; LF$(2); c$; LF$(3); c$; LF$(4); c$; LF$(5);
    'Link-Typ
    If (SV.DataFormat And 32) = 0 Then Print #FileNr, c$; LF$(6);
  Else
    'Feld 4 rechtsbuendig, alle anderen linksbuendig
    Print #FileNr, Rpad$(LF$(1), 9); c$; Rpad$(LF$(2), 9); c$;
    Print #FileNr, Rpad$(LF$(3), 2); c$; LPad$(LF$(4), 4); c$;
    If (SV.TxtFmt And 2) = 0 Then
      Print #FileNr, LPad$(LF$(5), 6);
    Else
      Print #FileNr, LPad$(LF$(5), 8);
    End If
    'Link-Typ
    If (SV.DataFormat And 32) = 0 Then Print #FileNr, c$; Rpad$(LF$(6), 2);
  End If

  Print #FileNr,

  WriteLink = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

