Attribute VB_Name = "MODSTN"
'---------------------------- MODSTN.BAS ----------------------------
'Stations-Modifikations-Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z



'Wegen VBWIN sind lokale Array-Deklarationen nicht moeglich
Dim NSF$(3 To AnzStnFields)                         'New Station Field
Dim QthFld(1 To 6)

Function AddStnIdx(StnCall As StationCall, RecNr, Found, Deleted)

  Static HighCall As StationCall

  AddStnIdx = True

  'Aktuelle Station ist noch nicht mitgezaehlt
  AnzStnRec = SV.Out.StnHdr.AnzStnRec


  '--- Stations-Index nicht geladen ---
  If Not SV.StnIdxLoaded Then
    ErrNr = FindStation(StnCall, StnNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    If Not Found Then
      StnNr = AnzStnRec + 1
      RecNr = StnNr
    End If

    AddStnIdx = False
    Exit Function
  End If


  '--- Stations-Index geladen ---

  '--- 1. Station ---
  If AnzStnRec = 1 Then
    HighCall.Call = &H80000000
    HighCall.SSID = 0
  End If

  If CmpCalls(StnCall, HighCall) = 1 Then

    '--- Wenn richtig sortiert, dann Station hinten anfuegen ---
    '    StnCall > HighCall
    StnNr = AnzStnRec + 1
    RecNr = StnNr
    StnIdxTbl(StnNr) = RecNr
    HighCall = StnCall
    Found = False
    Deleted = False

  Else

    '--- Station zwischendurch einfuegen ---
    ErrNr = FindStation(StnCall, StnNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    '--- Index aktualisieren ---
    If Not Found Then
      RecNr = AnzStnRec + 1
      For i = AnzStnRec To StnNr Step -1
        StnIdxTbl(i + 1) = StnIdxTbl(i)
      Next i
      StnIdxTbl(StnNr) = RecNr
    End If

  End If

  AddStnIdx = False

End Function

Function DeleteStnRec(RecNr, Stn As StationData)

  DeleteStnRec = True

  '--- Stationsdaten laden ---
  ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
  If ErrNr Then Exit Function

  '------ Zeile loeschen (falls nicht schon geloescht) ------
  If Stn.xloc < 32767 Then
    Stn.xloc = 32767
    SV.Out.StnHdr.AnzStn = SV.Out.StnHdr.AnzStn - 1

    '--- Stationsdaten speichern ---
    ErrNr = PutStationData(SV.Out.BsdFile, RecNr, Stn)
    If ErrNr Then Exit Function
  End If

  DeleteStnRec = False

End Function

Function EncodeStation(Stn As StationData)

  EncodeStation = True

  For i = 3 To AnzStnFields

    '--- Ungueltige Felder in Zusatzzeilen ---
    If Val(SF$(2)) <> 0 Then
      If (2 ^ (i - 3) And SV.AddLines) = 0 And Len(SF$(i)) > 0 Then
        If SV.ErrorLevel And 32 Then
          ErrNr = StnLnkError(1, 31045, SF$(i))
          If ErrNr Then Exit Function
        End If
        SF$(i) = ""
      End If
    End If


    '--- '?' entfernen bzw. einsetzen ---
    Select Case i
    Case 3, 5, 6, 7
      '? fuer Codierung noetig
      If Len(SF$(i)) = 0 Then SF$(i) = "?"
    Case Else
      If SF$(i) = "?" Then SF$(i) = ""
    End Select


    '--- Feldlaengen pruefen und Felder codieren ---
    If Len(SF$(i)) > SV.MaxStnLen(i) Then
      ErrNr = StnLnkError(1, 31000 + i, SF$(i))
      If ErrNr Then Exit Function
    Else

      ErrNr = False

      Select Case i
      Case 3
        'Status
        Stn.StnStat = FindStnAbv(1, SF$(3))
        If Stn.StnStat < 0 Then
          Stn.StnStat = 0
          If SV.ErrorLevel And 1 Then ErrNr = True
        End If

      Case 4
        Stn.StnDate = Val(SF$(4))

      Case 5
        'Typ
        Stn.StnTyp = FindStnAbv(2, SF$(5))
        If Stn.StnTyp < 0 Then
          Stn.StnTyp = 0
          If SV.ErrorLevel And 2 Then ErrNr = True
        End If

      Case 6
        'Software
        Stn.Software = FindStnAbv(3, SF$(6))
        If Stn.Software < 0 Then
          Stn.Software = 0
          If SV.ErrorLevel And 4 Then ErrNr = True
        End If

      Case 7
        'Hardware
        Stn.Hardware = FindStnAbv(4, SF$(7))
        If Stn.Hardware < 0 Then
          Stn.Hardware = 0
          If SV.ErrorLevel And 8 Then ErrNr = True
        End If

      Case 8
        'QRG  (uses '.' as decimal separator !)
        On Error Resume Next
        f& = CCur(Val(SF$(8))) * 1000@
        If Err Then f& = 100000000
        On Error GoTo 0
        If f& < 0& And f& <> -1000& Or f& > 99999999 Then ErrNr = True
        Stn.QRG = f&

      Case 9
        Stn.Baud = Val(SF$(9))

      Case 11

        If Val(SF$(2)) <> 0 Then

          '--- Zusatzzeile ---
          'bei neuem Datenformat nicht noetig - Info in Call siehe SF$(2)
          Stn.xloc = 32766
          Stn.yloc = 0

        Else

          Select Case Len(SF$(11))
          Case 0
            Stn.xloc = 0                    'nicht geloescht
            Stn.yloc = 32767                'QTH unbekannt oder Fehler
            ErrNr = False

          Case 6
            ErrNr = Qth2lSecCoord(SF$(11), x&, y&)
            If ErrNr = 0 Then
              Stn.xloc = x& * cfSec2Qth
              Stn.yloc = y& * cfSec2Qth
            Else
              Stn.xloc = 0                  'nicht geloescht
              Stn.yloc = 32767              'QTH unbekannt oder Fehler
            End If

          Case Else
            Stn.xloc = 0                    'nicht geloescht
            Stn.yloc = 32767                'QTH unbekannt oder Fehler
            ErrNr = True

          End Select

        End If

      End Select

      If ErrNr Then
        ErrNr = StnLnkError(1, 31000 + i, SF$(i))
        If ErrNr Then Exit Function
      End If

    End If
  Next i

  ErrNr = PackCall(1, SF$(10), Stn.Sysop)
  If ErrNr Then Exit Function

  EncodeStation = False

End Function

Function OutputStationData(FileNr, RecNr, Stn As StationData)

  On Local Error Resume Next

  Put #FileNr, RecNr, Stn

  OutputStationData = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function OutputStationHeader(FileNr, StnHdr As StationHeader)

  On Local Error Resume Next

  Put #FileNr, 1, StnHdr

  OutputStationHeader = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

Function ProcessStation(Cmnd$, RecNr)

  'Cmnd$:    AS = Add, MS = Modify, DS = Delete
  'Stationsdaten in SF$(1...AnzStnFields)
  'Rueckkgabewert (ErrNr) wird durch SV.ErrorExit und StnLnkError gesteuert

  Static MainStn As StationData                 'Daten der Hauptzeile
  Static AddStn As StationData                  'Daten der Zusatzzeile

  ProcessStation = True                         'Fuer Abbruch bei I/O-Error

  '--- Rufzeichen codieren ---
  ErrNr = EncodeCall(1, SF$(1), SF$(2), ActStnData.StnCall)
  If ErrNr Then Exit Function


  'void = WriteLog(Cmnd$ + ":" + SF$(1) + "," + SF$(2), 3)  'Debug

  Select Case Cmnd$
  Case "AS"                                                'Add

    '--- Wenn zu viele Stationen -> Abbruch ---
    If SV.Out.StnHdr.AnzStnRec = SV.MaxAnzStn Then
      ErrNr = CheckStnMem()
      If ErrNr Then
        void = ConvertError(Msg$(31037))
        Exit Function
      End If
    End If


    '--- Fuer Zusatzzeile -> Hauptzeile suchen ---
    '  muss wegen evtl. Abbruch vor AddStnIdx stehen!
    If SF$(2) > "0" Then
      ErrNr = EncodeCall(1, SF$(1), "0", MainStn.StnCall)
      If ErrNr Then Exit Function
      ErrNr = FindStation(MainStn.StnCall, StnNr, MainRecNr, Found, Deleted)
      If ErrNr Then Exit Function
      If (Found And Deleted) Or Not Found Then
        ProcessStation = StnLnkError(2, 31018, "")
        Exit Function
      End If
    End If


    '--- Station codieren ---
    'muss wegen evtl. Formatfehler vor AddStnIdx stehen
    ErrNr = EncodeStation(ActStnData)
    If ErrNr Then Exit Function


    '-------------------- bis hier nichts geaendert --------------------

    '--- Station suchen und Index aktualisieren ---
    ErrNr = AddStnIdx(ActStnData.StnCall, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    If Found Then

      If Not Deleted Then
        ProcessStation = StnLnkError(2, 31039, "")        'schon vorhanden
        Exit Function
      End If


      '------ geloeschte Station reaktivieren ------

      'Alte Stationsdaten laden und Pointer uebernehmen
      ErrNr = GetStationData(SV.Out.BsdFile, RecNr, MainStn)
      If ErrNr Then Exit Function

      ActStnData.AddLnPtr = MainStn.AddLnPtr
      ActStnData.LnkPtr = MainStn.LnkPtr

      'If SF$(2) > "0" Then ActStnData.xloc = 32766      'Zusatzzeile

      SV.Out.StnHdr.AnzStn = SV.Out.StnHdr.AnzStn + 1

    Else

      '--- Station neu anlegen ---

      ActStnData.LnkPtr = 0                         'noch keine Links

      '--- Pointer auf Zusatzzeilen ---
      If SF$(2) = "0" Then
        '--- Hauptzeile ---
        ActStnData.AddLnPtr = 0
      Else
        '--- Zusatzzeile ---
        'ActStnData.xloc = 32766

        '--- Pointer in Hauptzeile aendern ---
        ErrNr = GetStationData(SV.Out.BsdFile, MainRecNr, MainStn)
        If ErrNr Then Exit Function

        ActStnData.AddLnPtr = MainStn.AddLnPtr
        MainStn.AddLnPtr = RecNr

        ErrNr = PutStationData(SV.Out.BsdFile, MainRecNr, MainStn)
        If ErrNr Then Exit Function
      End If

      '--- Station speichern ---
      SV.Out.StnHdr.AnzStn = SV.Out.StnHdr.AnzStn + 1
      SV.Out.StnHdr.AnzStnRec = SV.Out.StnHdr.AnzStnRec + 1
      RecNr = SV.Out.StnHdr.AnzStnRec

    End If

    ErrNr = PutStationInfo(SV.Out.BstFile, ActStnData, SF$(12), SF$(13))
    If ErrNr Then Exit Function

    ErrNr = PutStationData(SV.Out.BsdFile, RecNr, ActStnData)
    If ErrNr Then Exit Function


  Case "MS", "US"                                       'Modify, Update

    ErrNr = FindStation(ActStnData.StnCall, StnNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    If Found And Deleted Or Not Found Then
      ProcessStation = StnLnkError(2, 31041, "")
      Exit Function
    End If


    '--- Alte Stationsdaten laden ---
    ErrNr = GetStationData(SV.Out.BsdFile, RecNr, ActStnData)
    If ErrNr Then Exit Function

    ErrNr = GetStationInfo(SV.Out.BstFile, ActStnData, ActQTH, ActInfo)
    If ErrNr Then Exit Function

    '--- Datum vergleichen ---
    OldDate = ActStnData.StnDate
    Newdate = Val(SF$(4))
    If OldDate <> 0 And Newdate <> 0 Then
      If OldDate < 8000 Then OldDate = OldDate + 10000
      If Newdate < 8000 Then Newdate = Newdate + 10000
      If Newdate < OldDate Then
        ErrNr = StnLnkError(3, 31019, SF$(4))
        If ErrNr Then Exit Function
      End If
    End If


    If Cmnd$ = "MS" Then

      '--- Neue Stationsdaten retten ---
      For i = 3 To AnzStnFields
        NSF$(i) = SF$(i)
      Next i

      '--- Update durchfuehren ---
      Call DecodeStation(ActStnData, ActQTH, ActInfo, 0)

      For i = 3 To AnzStnFields
        If Len(NSF$(i)) > 0 Then SF$(i) = NSF$(i)
      Next i

    End If

    ErrNr = EncodeStation(ActStnData)
    If ErrNr Then Exit Function

    '-------------------- bis hier nichts geaendert --------------------

    '--- Station speichern ---
    ErrNr = PutStationInfo(SV.Out.BstFile, ActStnData, SF$(12), SF$(13))
    If ErrNr Then Exit Function

    ErrNr = PutStationData(SV.Out.BsdFile, RecNr, ActStnData)
    If ErrNr Then Exit Function


  Case "DS"                                                'Delete

    ErrNr = FindStation(ActStnData.StnCall, StnNr, RecNr, Found, Deleted)
    If ErrNr Then Exit Function

    If Found And Deleted Or Not Found Then
      ProcessStation = StnLnkError(2, 31041, "")
      Exit Function
    End If


    '--- Stationsdaten laden und Station loeschen ---
    ErrNr = DeleteStnRec(RecNr, ActStnData)
    If ErrNr Then Exit Function

    If SF$(2) = "0" Then

      '------ Hauptzeile -> Alle Links loeschen ------
      SrcRec = RecNr
      LnkRec = ActStnData.LnkPtr                'erster Link

      Do Until LnkRec = 0

        '--- Link loeschen ---
        ErrNr = DeleteLinkRec(LnkRec)
        If ErrNr Then Exit Function

        '--- Naechsten Link ermitteln ---
        ErrNr = GetNextLink(LnkRec, NextLink, SrcRec, DstRec, ActLnkData)
        If ErrNr Then Exit Function

        LnkRec = NextLink
      Loop


      '------ Ggf. alle Zusatzzeilen loeschen ------
      AddRecNr = ActStnData.AddLnPtr

      Do Until AddRecNr = 0
        '--- Stationsdaten laden und Station loeschen ---
        ErrNr = DeleteStnRec(AddRecNr, AddStn)
        If ErrNr Then Exit Function

        AddRecNr = AddStn.AddLnPtr
      Loop

    End If

  End Select

  ProcessStation = False

End Function

Function PutStationData(FileNr, RecNr, Stn As StationData)

  PutStationData = False

  '--- Stations-Daten in RAM schreiben ---
  Call StoreStationData(RecNr, Stn)

  '--- Stations-Daten in Datei schreiben ---
  If FileNr Then PutStationData = OutputStationData(FileNr, RecNr, Stn)

  '--- Puffer in GetStationData und GetStationLineData aktualisieren ---
  void = GetStationData(FileNr, -RecNr, Stn)
  void = GetStationLineData(FileNr, -RecNr)

End Function

Function PutStationInfo(FileNr, Stn As StationData, Qth$, Info$)

  PutStationInfo = True

  '--- QTH in Datei schreiben ---
  l = Len(Qth$)
  If l = 0 Then
    Stn.QthPtr = 0
  Else
    Stn.QthPtr = SV.Out.StnHdr.AnzInfo + 1
    ErrNr = PutLenText(FileNr, Stn.QthPtr, Qth$)
    If ErrNr Then Exit Function
    SV.Out.StnHdr.AnzInfo = SV.Out.StnHdr.AnzInfo + l + 2
  End If

  '--- Info in Datei schreiben ---
  l = Len(Info$)
  If l = 0 Then
    Stn.InfoPtr = 0
  Else
    Stn.InfoPtr = SV.Out.StnHdr.AnzInfo + 1
    ErrNr = PutLenText(FileNr, Stn.InfoPtr, Info$)
    If ErrNr Then Exit Function
    SV.Out.StnHdr.AnzInfo = SV.Out.StnHdr.AnzInfo + l + 2
  End If

  PutStationInfo = False

End Function

Function PutStnHeader()

  Dim LnkHdr As LinkHeader

  PutStnHeader = True

  '--- Stations-Daten ---
  SV.Out.StnHdr.FmtTyp = Str2Long("HMSD")
  SV.Out.StnHdr.FmtVer = Str2Int(StnFmtVer$)

  ErrNr = OutputStationHeader(SV.Out.BsdFile, SV.Out.StnHdr)
  If ErrNr Then Exit Function


  '--- Link-Daten ---
  If SV.Out.BldFile Then
    LnkHdr.FmtTyp = Str2Long("HMLD")
    LnkHdr.FmtVer = Str2Int(StnFmtVer$)
    LnkHdr.Upd = SV.Out.StnHdr.Upd
    LnkHdr.AnzLnk = SV.Out.StnHdr.AnzLnk
    LnkHdr.AnzLnkRec = SV.Out.StnHdr.AnzLnkRec

    ErrNr = OutputLinkHeader(SV.Out.BldFile, LnkHdr)
    If ErrNr Then Exit Function
  End If

  PutStnHeader = False

End Function

Function WriteStation(f)

  On Local Error Resume Next

  SF$(12) = RTrim$(SF$(12))
  SF$(13) = RTrim$(SF$(13))

  If SV.TxtFmt = 0 Then
    Print #f, SF$(1); c$; SF$(2); c$; SF$(3); c$; SF$(4); c$; SF$(5);
    Print #f, c$; SF$(6); c$; SF$(7); c$; SF$(8); c$; SF$(9);
    Print #f, c$; SF$(10); c$; SF$(11); c$; SF$(12); c$; SF$(13)
  Else
    'Felder 8 und 9 rechtsbuendig, alle anderen linksbuendig
    Print #f, Rpad$(SF$(1), 9); c$; Rpad$(SF$(2), 1); c$; Rpad$(SF$(3), 2); c$;
    Print #f, LPad$(SF$(4), 4); c$; Rpad$(SF$(5), 2); c$; Rpad$(SF$(6), 2); c$;
    Print #f, Rpad$(SF$(7), 2); c$; LPad$(SF$(8), 9); c$;
    Print #f, LPad$(SF$(9), 6); c$; Rpad$(SF$(10), 6); c$; Rpad$(SF$(11), 6); c$;
    If (SV.TxtFmt And 2) = 0 Then
      Print #f, Rpad$(SF$(12), 8); c$; SF$(13)
    Else
      Print #f, Rpad$(SF$(12), 36); c$; Rpad$(SF$(13), 48)
    End If
  End If

  WriteStation = Err

  If Err Then Call ShowErrNrFileNr(Err, FileNr)

End Function

