Attribute VB_Name = "MsgUpd"
DefInt A-Z
Option Explicit

Type RegType
  ax    As Integer
  bx    As Integer
  cx    As Integer
  dx    As Integer
  bp    As Integer
  si    As Integer
  di    As Integer
  Flags As Integer
End Type


Dim CRLF$

Sub Main()

  Call MsgUpdate

End Sub

Function AppPath$()

  Dim Pt, f$, d$, p$, n$, e$

  'AppPath hat immer "\" am Ende !


  AppPath$ = App.Path


End Function

Function GetMsgLine(FileNr, MsgNr As Long, MsgTxt$, Comment$)

  GetMsgLine = True

  Dim InpLine$, C1$, ErrNr, Section$

  MsgNr = 0
  MsgTxt$ = ""
  Comment$ = ""

  Do
    If EOF(FileNr) Then
      MsgNr = 65535
    Else
      ErrNr = ReadLine(FileNr, InpLine$)
      If ErrNr Then Exit Function

      InpLine$ = LTrim$(InpLine$)
      C1$ = Left$(InpLine$, 1)
      If C1$ = "[" Then Section$ = InpLine$

      If Len(InpLine$) = 0 Then

        'Leerzeile
        If Len(Comment$) = 0 Then
          Comment$ = " "
        Else
          Comment$ = Comment$ + CRLF$
        End If

      ElseIf Section$ = "[BACKUP]" Then

        Comment$ = Comment$ + CRLF$ + InpLine$

      ElseIf C1$ = ";" Or C1$ = "[" Then

        'Kommentarzeile oder Bereich
        If Len(Comment$) = 0 Then
          Comment$ = InpLine$
        Else
          Comment$ = Comment$ + CRLF$ + InpLine$
        End If

      Else
        'Message
        MsgNr = LngVal(Parse$(InpLine$, ","))
        MsgTxt$ = InpLine$
      End If
    End If

  Loop Until MsgNr <> 0

  GetMsgLine = False

End Function

Function LngVal(s$) As Long

  Dim i, n As Long

  'Bei VBDOS anstelle von VAL verwenden, um nicht Floating Point zu laden
  For i = 1 To Len(s$)
    n = 10 * n + (Asc(Mid$(s$, i, 1)) - 48)
  Next i

  LngVal = n

End Function

Sub MsgUpdate()

  'New in V1.1:
  '  Help with MSGUPD /?
  '  Create UPD-Dir (missing in HAMMAP V9.0)
  '  Default path:  path in which MSGUPD.EXE is running
  '  Default files: *.MSG und MSG-ALL.U02

  Dim CmdLine$
  Dim MsgFile$, UpdFile$, f$
  Dim InFileNr, OutFileNr, UpdFileNr
  Dim ErrNr, m$
  Dim fin$, fout$, d$, p$, n$, e$
  Dim dmsg$, pmsg$, nmsg$, emsg$

  CRLF$ = Chr$(13) & Chr$(10)


  CmdLine$ = Command$

  Select Case CmdLine$
  Case "/?"
    m$ = "MSGUPD V1.2" + CRLF$
    m$ = m$ + "Usage: MSGUPD.EXE [MsgFile UpdFile]"
    Call ShowMsg(m$)
    Exit Sub

  Case ""
    pmsg$ = AppPath$()
    If Right$(pmsg$, 1) <> "\" Then pmsg$ = pmsg$ + "\"
    MsgFile$ = pmsg$ + "*.MSG"
    UpdFile$ = pmsg$ + "ALL-MSG.U02"

  Case Else
    MsgFile$ = ParseFileList$(CmdLine$)
    UpdFile$ = ParseFileList$(CmdLine$)

  End Select

  Call ParseFileSpec(MsgFile$, dmsg$, pmsg$, nmsg$, emsg$)

  '--- Create UPD-Dir (if missing - e.g. V9.0) ---
  On Error Resume Next
  MkDir dmsg$ + pmsg$ + "\STN\UPD"
  On Error GoTo 0

  '--- Get MSG-File ---
  f$ = Dir$(MsgFile$)
  If Len(f$) = 0 Then
    Call ShowMsg("Datei nicht gefunden/File not found: '" + MsgFile$ + "'")
    Exit Sub
  End If

  Do Until Len(f$) = 0
    '--- Dateien oeffnen ---
    Call ParseFileSpec(f$, d$, p$, n$, e$)
    fin$ = dmsg$ + pmsg$ + n$ + ".BAK"
    fout$ = dmsg$ + pmsg$ + f$

    UpdFileNr = FreeFile
    On Error Resume Next
    Open UpdFile$ For Input As #UpdFileNr
    ErrNr = Err
    On Error GoTo 0
    If ErrNr Then
      Call ShowMsg("Datei nicht gefunden/File not found: '" + UpdFile$ + "'")
      Exit Sub
    End If

    'Altes BAK-File loeschen, falls vorhanden
    On Error Resume Next
    Kill fin$
    On Error GoTo 0

    'MSG-File in BAK-File umbenennen
    Name fout$ As fin$

    InFileNr = FreeFile
    Open fin$ For Input As #InFileNr

    OutFileNr = FreeFile
    Open fout$ For Output As #OutFileNr

    '--- Update durchfuehren ---
    ErrNr = UpdateMsgFile(InFileNr, OutFileNr, UpdFileNr)
    If ErrNr Then
      Call ShowMsg("Update Error")
      Exit Sub
    End If

    '--- Dateien schliessen ---
    Close #InFileNr
    Close #OutFileNr
    Close #UpdFileNr

    f$ = Dir$
  Loop

End Sub

Function Parse$(Strg$, Sep$)

  Dim Ptr As Long

  Ptr = InStr(Strg$, Sep$)

  If Ptr = 0 Then
      Parse$ = Trim$(Strg$)
    Strg$ = ""
  Else
      Parse$ = Trim$(Left$(Strg$, Ptr - 1))
      Strg$ = Trim$(Mid$(Strg$, Ptr + Len(Sep$)))
  End If

End Function

Function ParseFileList$(l$)

  l$ = Trim$(l$)
  If Left$(l$, 1) = """" Then
    l$ = Mid$(l$, 2)
    ParseFileList$ = Parse$(l$, """")
  Else
    ParseFileList$ = Parse$(l$, " ")
  End If

End Function

Sub ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  'C:\AFU\HAMMAP\HAMMAP.EXE
  ' |           |      |
  ' n1          n2     n3
  'D$    P$       N$    E$

  Dim n1, n2, n3, NewDir, NewName

  '--- Laufwerk (Drive) suchen ---
  n1 = InStr(FileSpec$, ":")

  '--- Directory (Path) suchen (letztes '\') ---
  NewDir = n1
  Do
    n2 = NewDir
    NewDir = InStr(n2 + 1, FileSpec$, "\")
  Loop Until NewDir = 0

  '--- Dateinamen und Erweiterung trennen (letzter '.') ---
  NewName = n2
  Do
    n3 = NewName
    NewName = InStr(n3 + 1, FileSpec$, ".")
  Loop Until NewName = 0

  If n3 = n2 Then n3 = Len(FileSpec$) + 1

  d$ = Left$(FileSpec$, n1)
  p$ = Mid$(FileSpec$, n1 + 1, n2 - n1)
  n$ = Mid$(FileSpec$, n2 + 1, n3 - n2 - 1)
  e$ = "." + Mid$(FileSpec$, n3 + 1)

End Sub

Function ReadLine(FileNr, InpLine$)

  Line Input #FileNr, InpLine$

End Function

Sub ShowMsg(m$)

  MsgBox m$, , "HAMMAP Message Update"

End Sub

Function UpdateMsgFile(InFile, OutFile, UpdFile)

  Dim InpFlag, OutFlag, ErrNr
  Dim InMsgNr As Long, UpdMsgNr As Long
  Dim InMsgTxt$, InComment$, UpdMsgTxt$, UpdComment$

  UpdateMsgFile = True

  InpFlag = 3

  Do

    If InpFlag And 1 Then
      ErrNr = GetMsgLine(InFile, InMsgNr, InMsgTxt$, InComment$)
      If ErrNr Then Exit Function
    End If
    If InpFlag And 2 Then
      ErrNr = GetMsgLine(UpdFile, UpdMsgNr, UpdMsgTxt$, UpdComment$)
      If ErrNr Then Exit Function
    End If


    OutFlag = 0

    If UpdMsgNr = InMsgNr Then

      '--- Gleiche Nummern ---
      If Len(UpdMsgTxt$) = 0 Then
        'Delete - nur ggf.Kommentar ausgeben
        OutFlag = 1
      Else
        'Aenderung
        OutFlag = 5
      End If

      InpFlag = 3

    ElseIf UpdMsgNr > InMsgNr Then

      '--- Im InputFile Einfuegestelle suchen ---
      OutFlag = 3
      InpFlag = 1

    Else

      '--- Aus UpdateFile einfuegen ---
      If Len(UpdMsgTxt$) > 0 Then
        'Delete (UpdMsgTxt$ = "") nicht nochmal ausfuehren
        OutFlag = 4
      End If

      InpFlag = 2
    End If

    '--- Ausgabe ---
    If (OutFlag And 1) <> 0 And Len(InComment$) > 0 Then
      'Kommentar von Input-File
      ErrNr = WriteLine(OutFile, LTrim$(InComment$))
      If ErrNr Then Exit Function
    End If

    If OutFlag And 2 Then
      'Message von Input-File ausgeben
      ErrNr = WriteLine(OutFile, LTrim$(Str$(InMsgNr)) + ", " + InMsgTxt$)
      If ErrNr Then Exit Function
    End If

    If OutFlag And 4 Then
      'Message von Update-File ausgeben
      ErrNr = WriteLine(OutFile, LTrim$(Str$(UpdMsgNr)) + ", " + UpdMsgTxt$)
      If ErrNr Then Exit Function
    End If

  Loop Until InMsgNr = 65535 And UpdMsgNr = 65535

  UpdateMsgFile = False

End Function

Function WriteLine(FileNr, OutLine$)

  Print #FileNr, OutLine$

End Function

