Attribute VB_Name = "MskInp"
'-------------------------- GETMSK.BAS ------------------------

'HAMMAP Input-Masken-Unterprogramm fuer DOS und Windows
'von Gerhard Berg, DJ6FM


DefInt A-Z


Function CheckInputRange()

  CheckInputRange = True

  With InputMask

  For i = 1 To Val(.Tag)

    l$ = .InputLabel(i).Caption
    If Len(MaskData(i, 4)) = 0 Then
      t$ = Unformat$(.InputField(i).text)
    Else
      t$ = Unformat$(.InputAusw(i).text)
    End If

    'Min.Value
    s$ = .InputLabel(i).Tag
    If Len(s$) > 0 Then
      If Val(t$) < Val(s$) Then ErrNr = 25035
    End If

    'Max.Value
    s$ = .InputField(i).Tag
    If Len(s$) > 0 Then
      If Val(t$) > Val(s$) Then ErrNr = 25036
    End If

    If ErrNr Then
      m$ = Msg$(ErrNr) + vbCrLf + LTrim$(l$ & " = '" & t$ & "'")
      MsgBox m$, 0, .Caption
      If Len(MaskData(i, 4)) = 0 Then
        .InputField(i).SetFocus
      Else
        .InputAusw(i).SetFocus
      End If
      Exit Function
    End If

  Next i

  End With

  CheckInputRange = False

End Function

Sub EraseMaskData()

  Erase MaskData

End Sub

Function GetInput(Title$, Prompt$, Default$, InpLine$)

  'Eingabe fuer 1 Feld

  GetInput = True

  ErrNr = InitMaskData(1, Title$, Prompt$)
  If ErrNr Then Exit Function

  MaskData(1, 1) = ""            'Prompt
  MaskData(1, 2) = Default$      'Default

  GetInput = GetMaskInput(0, Change&)

  InpLine$ = GetMaskData(1)

  Call EraseMaskData

End Function

Function GetMaskData(i) As String

  GetMaskData = MaskData(i, 3)

End Function

Function GetMaskInput(Dsbl, Change&)

  Dim MsgNr As Long

  With InputMask

    AnzFields = UBound(MaskData, 1)

    .Tag = Str$(AnzFields)
    .Caption = MaskData(0, 1)                  'Title
    .CommentLabel.Caption = MaskData(0, 2)     'Comment


    '--- Controls laden ---
    For i = 1 To AnzFields
      If i > 1 Then
        Load .InputLabel(i)
        Load .InputField(i)
        Load .InputAusw(i)
        Load .InputList(i)
      End If

      m$ = MaskData(i, 1)    'Prompt
      .InputList(i).Tag = Str$(IsMessageActive(m$))
      .InputLabel(i).Caption = m$      'Prompt
      If Len(m$) > 0 Then PromptFlag = True

      If .InputLabel(i).Width > MaxWidth Then
        MaxWidth = .InputLabel(i).Width
      End If

      .InputLabel(i).Tag = MaskData(i, 5)  'Min.
      .InputField(i).Tag = MaskData(i, 6)  'Max.
    Next i

    .Cmd(0).Caption = Msg$(25050)
    .Cmd(1).Caption = Msg$(25053)

    '.InputField(1).SelStart = 0
    '.InputField(1).SelLength = 32767


    '--- Positionen und Groesse anpassen ---

    yoffs = 0
    h = 285     'Feldhhe
    If AnzFields <= 8 Then
      dy = 2 * h
      ycmd = 0
    ElseIf AnzFields <= 12 Then
      dy = 1.5 * h
      ycmd = 0.2 * dy
    Else
      dy = 1.2 * h
      ycmd = 0.5 * dy
    End If
    yend = 0.5 * dy + ycmd


    .CommentLabel.Visible = Len(MaskData(0, 2))

    dx = .InputLabel(1).Left

    y = .CommentLabel.Top
    If Len(MaskData(0, 2)) Then
      y = 3 * y
      xwc = .CommentLabel.Width + 2 * dx
    End If

    If PromptFlag Then
      x0 = MaxWidth + 2 * dx
    Else
      x0 = dx
    End If

    For i = 1 To AnzFields
      .InputLabel(i).Top = y + yoffs
      CtlVisible = Val(.InputList(i).Tag)

      Ausw$ = MaskData(i, 4)
      lAusw = Len(Ausw$)
      .InputLabel(i).Visible = CtlVisible
      .InputField(i).Visible = CtlVisible And (lAusw = 0)
      .InputAusw(i).Visible = CtlVisible And (lAusw > 0) And Left$(Ausw$, 1) <> "@"
      .InputList(i).Visible = CtlVisible And (lAusw > 0) And Left$(Ausw$, 1) = "@"

      If lAusw = 0 Then
        'Textbox
        With .InputField(i)
          .Left = x0
          .Top = y
          .Height = h
          .TabIndex = i
          .Enabled = (2 ^ (i - 1) And Dsbl) = 0
          .text = MaskData(i, 2)    'Default
        End With

      ElseIf Left$(Ausw$, 1) = "@" Then
        'Combobox/Dropdown-Listbox(Style=2)
        With .InputList(i)
          .Left = x0
          .Top = y + yoffs
          .TabIndex = i
          .Enabled = (2 ^ (i - 1) And Dsbl) = 0
        End With

        MsgNr = Val(Mid$(Ausw$, 2))
        Default = Val(MaskData(i, 2))
        Call AddMsgItems(.InputList(i), MsgNr, Default)

      Else
        'Combobox/Dropdown-Combobox(Style=0)
        With .InputAusw(i)
          .Left = x0
          .Top = y + yoffs
          .TabIndex = i
          .Enabled = (2 ^ (i - 1) And Dsbl) = 0
        End With

        Call AddStrItems(.InputAusw(i), Ausw$, MaskData(i, 2))
      End If

      .InputLabel(i).Enabled = (2 ^ (i - 1) And Dsbl) = 0

      If CtlVisible Then y = y + dy
    Next i

    xb = .Width - .ScaleWidth
    xw = x0 + .InputField(1).Width + dx      'Fensterbreite
    If xwc > xw Then xw = xwc
    .Width = xw + xb


    '--- Kommando-Tasten ---
    xc = .Cmd(0).Width       'Tastenbreite
    dxc = 0.1 * xw                    'Tastenabstand
    x0 = (xw - 2 * xc - dxc) \ 2
    .Cmd(0).Left = x0
    .Cmd(1).Left = x0 + xc + dxc

    .Cmd(0).Top = y + ycmd
    .Cmd(1).Top = y + ycmd


    '--- Fensterhoehe ---
    yb = .Height - .ScaleHeight
    yh = y + .Cmd(0).Height + yend
    .Height = yh + yb

    Call CenterForm(InputMask)


    '--------- Form zeigen und Eingabe machen ----------
    .Show 1

    Cancel = Val(.Tag) <> 0
    GetMaskInput = Cancel
    Change& = 0&

    For i = 1 To AnzFields
      If Cancel Then
        MaskData(i, 3) = MaskData(i, 2)
      Else
        Ausw$ = MaskData(i, 4)
        lAusw = Len(Ausw$)
        If lAusw = 0 Then
          'Textbox
          MaskData(i, 3) = .InputField(i).text
        ElseIf Left$(Ausw$, 1) = "@" Then
          'Combo/Dropdown-Listbox
          MaskData(i, 3) = LTrim$(Str$(.InputList(i).ListIndex))
        Else
          'Combo/Dropdown-Combobox
          MaskData(i, 3) = Parse$((.InputAusw(i).text), "=")
        End If

        'prfen, ob nderungen
        If MaskData(i, 3) <> MaskData(i, 2) Then
          Change& = Change& Or 2 ^ (i - 1)
        End If
      End If
    Next i
  End With

  Unload InputMask
  Set InputMask = Nothing

  void = DoEvents()

End Function

Function InitMaskData(ByVal AnzFields, ByVal Title$, ByVal Comment$)

  On Error Resume Next
  ReDim MaskData(0 To AnzFields, 1 To 6) As String
  ErrNr = Err
  On Error GoTo 0

  If ErrNr Then
    Call ShowErrNr(7)
  Else
    MaskData(0, 1) = Title$
    MaskData(0, 2) = Comment$
  End If

  InitMaskData = ErrNr

End Function

Sub SetMaskData(ByVal i, ByVal Prompt$, ByVal Default$, _
    ByVal Auswahl$, ByVal MinVal$, ByVal MaxVal$)

  MaskData(i, 1) = Prompt$
  MaskData(i, 2) = Default$
 'MaskData(i, 3) = InpLine$
  MaskData(i, 4) = Auswahl$     'XX=Text,... (Separator ',' or '|')
                                'oder @MsgNr
  MaskData(i, 5) = MinVal$
  MaskData(i, 6) = MaxVal$

End Sub

