Attribute VB_Name = "OPNMAP"

'--------------------- OPNMAP.BAS ---------------------------
'Karten-I/O-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z


Function CloseMapBinFiles(FileNr As MapFiles)

  CloseMapBinFiles = True

  '--- Dateien schliessen ---
  If FileNr.BmdFile Then
    ErrNr = CloseFile(FileNr.BmdFile)
    If ErrNr Then Exit Function
  End If

  If FileNr.BmcFile Then
    ErrNr = CloseFile(FileNr.BmcFile)
    If ErrNr Then Exit Function
  End If

  If FileNr.BmtFile Then
    ErrNr = CloseFile(FileNr.BmtFile)
    If ErrNr Then Exit Function
  End If

  CloseMapBinFiles = False

End Function

Function OpenMapInBinFiles(MapFile$, FileNr As MapFiles)

  Dim CoordHdr As CoordHeader

  OpenMapInBinFiles = True

  BinFile$ = UCase$(StripExt$(MapFile$))
  FmtVer = Str2Int(MapFmtVer$)

  '--- Evtl. geoeffnete Dateien schliessen ---
  void = CloseMapBinFiles(FileNr)


  '----- Segment-Datei ---
  ErrNr = OpenFile(BinFile$ + ".BMD", "RI", Len(FileNr.SgHead), FileNr.BmdFile)
  If ErrNr Then Exit Function

  'Header einlesen
  ErrNr = GetSegmentHeader(FileNr.BmdFile, FileNr.SgHead)
  If ErrNr Then Exit Function

  'Dateiformat pruefen
  FmtTyp& = Str2Long("HMMD")
  n& = Len(FileNr.SgHead) * CLng(FileNr.SgHead.AnzSg)

  If FileNr.SgHead.FmtTyp <> FmtTyp& Or FileNr.SgHead.FmtVer <> FmtVer Then
    ErrNr = 25003

  'Auf Konvertierungsfehler pruefen
  ElseIf FileNr.SgHead.AnzKo < 0 Then
    ErrNr = 25017

  'Datei-Laenge pruefen
  ElseIf LOF(FileNr.BmdFile) <> n& Then
    ErrNr = 25015
  End If

  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileNr.BmdFile)
    Exit Function
  End If


  '----- Koordinaten-Datei -----
  ErrNr = OpenFile(BinFile$ + ".BMC", "BI", 0, FileNr.BmcFile)
  If ErrNr Then Exit Function

  'Header einlesen
  ErrNr = GetCoordHeader(FileNr.BmcFile, CoordHdr)
  If ErrNr Then Exit Function

  'Dateiformat pruefen
  FmtTyp& = Str2Long("HMMC")
  FmtVer = Str2Int(MapFmtVer$)
  n& = LOF(FileNr.BmcFile) - 32&

  If CoordHdr.FmtTyp <> FmtTyp& Or CoordHdr.FmtVer <> FmtVer Then
    ErrNr = 25003

  'Laenge pruefen (Overhead = 8 Byte Header + 8 * 4 Byte Trailer)
  ElseIf n& <> CoRecLen * FileNr.SgHead.AnzKo Then
    ErrNr = 25015                               'falsche Laenge
  End If

  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileNr.BmcFile)
    Exit Function
  End If


  '----- Text-Datei -----
  ErrNr = OpenFile(BinFile$ + ".BMT", "BI", 0, FileNr.BmtFile)
  If ErrNr Then Exit Function

  'Header lesen
  ErrNr = GetString(FileNr.BmtFile, 6&, Header$)
  If ErrNr Then Exit Function

  If Header$ <> "HMMT" + MapFmtVer$ Then
    ErrorNr = 25003                             'falsche Version
  ElseIf LOF(FileNr.BmtFile) <> FileNr.SgHead.AnzComment Then
    ErrorNr = 25015                             'falsche Laenge
  End If

  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileNr.BmtFile)
    Exit Function
  End If

  OpenMapInBinFiles = False

End Function

