Attribute VB_Name = "OPNSTN"
'-------------------------- OPNSTN.BAS ------------------------

'HAMMAP Stations-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z


Function CloseStnBinFiles(FileNr As StationFiles)

  ErrNr1 = CloseFile(FileNr.BsdFile)

  ErrNr2 = CloseFile(FileNr.BstFile)

  ErrNr3 = CloseFile(FileNr.BldFile)

  CloseStnBinFiles = ErrNr1 Or ErrNr2 Or ErrNr3

End Function

Sub InitStnData()

  '--- Stationsdaten initialisieren (fuer HAMMAP und STNCVT) ---

  Static Stn As StationData
  Static Lnk As LinkData


  '--- Evtl. geoeffnete Dateien schliessen ---
  void = CloseStnBinFiles(SV.Out)


  '--- Dateierweiterungen der Binaer-Dateien ---
  SV.BinExt(1) = ".BSD"
  SV.BinExt(2) = ".BST"
  SV.BinExt(3) = ".BLD"


  '--- Anzahl Stationen / Links ---
  SV.MaxAnzStn = 0
  SV.MaxAnzLnk = 0

  SV.Out.StnHdr.AnzStn = 0
  SV.Out.StnHdr.AnzStnRec = 1                         '#1 = Header
  SV.Out.StnHdr.AnzInfo = 0
  SV.Out.StnHdr.AnzLnk = 0
  SV.Out.StnHdr.AnzLnkRec = 1                         '#1 = Header
  SV.Out.StnHdr.AnzFmtErr = 0
  SV.Out.StnHdr.AnzRefErr = 0
  SV.Out.StnHdr.Modified = False
  SV.Out.StnHdr.AnzDateErr = 0

  '--- Maximale Feldlaengen setzen ---
  SV.MaxStnLen(1) = 9                                'Call
  SV.MaxStnLen(2) = 1                                'Zeile
  SV.MaxStnLen(3) = 2                                'Status
  SV.MaxStnLen(4) = 4                                'Datum
  SV.MaxStnLen(5) = 2                                'Typ
  SV.MaxStnLen(6) = 2                                'Software
  SV.MaxStnLen(7) = 2                                'Hardware
  SV.MaxStnLen(8) = 9                                'QRG
  SV.MaxStnLen(9) = 6                                'Baud
  SV.MaxStnLen(10) = 6                               'Sysop
  SV.MaxStnLen(11) = 6                               'QTH-Locator
  SV.MaxStnLen(12) = 36                              'Standort
  SV.MaxStnLen(13) = 48                              'Info


  'Evtl. reservierten Speicher freigeben
  On Local Error Resume Next
  Erase StnTbl
  Erase StnIdxTbl
  Erase StnCallTbl
  Erase StnQthTbl

  Erase LnkTbl
  Erase LnkIdxTbl
  Erase LnkStnPtrTbl

  Erase StnFlags
  Erase SaveStnFlags
  On Local Error GoTo 0


  '--- Cache Puffer loeschen ---
  void = GetStationData(0, 0, Stn)
  void = GetLinkData(0, 0, Lnk)

End Sub

Function OpenStnInBinFiles(BinFile$, FileData As StationFiles)

  Dim LnkHdr As LinkHeader

  OpenStnInBinFiles = True


  '------ Stations-Daten-Datei oeffnen ------
  ErrNr = OpenFile(BinFile$ + ".BSD", "RI", Len(FileData.StnHdr), FileData.BsdFile)
  If ErrNr Then Exit Function

  '--- Stations-Header einlesen ---
  ErrNr = InputStationHeader(FileData.BsdFile, FileData.StnHdr)
  If ErrNr Then Exit Function

  '--- Stations-Header pruefen ---
  FmtTyp& = Str2Long("HMSD")
  FmtVer = Str2Int(StnFmtVer$)

  If FileData.StnHdr.FmtTyp <> FmtTyp& Or FileData.StnHdr.FmtVer <> FmtVer Then
    ErrNr = 25003                                       'falsches Dateiformat
  ElseIf LOF(FileData.BsdFile) <> Len(FileData.StnHdr) * CLng(FileData.StnHdr.AnzStnRec) Then
    ErrNr = 25015                                       'falsche Laenge
  ElseIf FileData.StnHdr.AnzFmtErr <> 0 Then
    ErrNr = 25017                                       'Formatfehler/Abbruch
  End If
  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileData.BsdFile)
    Exit Function
  End If


  '--- Stations-Text-Datei oeffnen und pruefen ---
  ErrNr = OpenFile(BinFile$ + ".BST", "BI", 0, FileData.BstFile)
  If ErrNr Then Exit Function

  ErrNr = GetString(FileData.BstFile, 6, m$)
  If ErrNr Then Exit Function

  If m$ <> "HMST" + StnFmtVer$ Then
    ErrNr = 25003                                       'falsches Dateiformat
  ElseIf LOF(FileData.BstFile) <> FileData.StnHdr.AnzInfo Then
    ErrNr = 25015                                       'falsche Laenge
  End If

  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileData.BstFile)
    Exit Function
  End If


  '--- Link-Dateien nur oeffnen, wenn Links vorhanden ---
  If FileData.StnHdr.AnzLnkRec > 1 Then

    '--- Link-Daten-Datei oeffnen ---
    ErrNr = OpenFile(BinFile$ + ".BLD", "RI", Len(LnkHdr), FileData.BldFile)
    If ErrNr Then Exit Function

    ErrNr = InputLinkHeader(FileData.BldFile, LnkHdr)
    If ErrNr Then Exit Function

    FmtTyp& = Str2Long("HMLD")
    FmtVer = Str2Int(StnFmtVer$)
    If LnkHdr.FmtTyp <> FmtTyp& Or LnkHdr.FmtVer <> FmtVer Then
      ErrNr = 25003                                   'falsches Dateiformat
    ElseIf LOF(FileData.BldFile) <> Len(LnkHdr) * CLng(FileData.StnHdr.AnzLnkRec) Then
      ErrNr = 25015                                   'falsche Laenge
    ElseIf FileData.StnHdr.Upd <> LnkHdr.Upd Then
      ErrNr = 25016                                   'falsche Daten-Version
    End If

    If ErrNr Then
      Call ShowErrNrFileNr(ErrNr, FileData.BldFile)
      Exit Function
    End If

  End If

  OpenStnInBinFiles = False

End Function

