Attribute VB_Name = "OPTSUB"
'-------------------------- OPTSUB.BAS ------------------------

'HAMMAP Option-Unterprogramme fuer DOS und Windows
'von Gerhard Berg, DJ6FM


DefInt A-Z



Function AbvAusw$(AbvNr, iMsgBase)

  For i = 0 To AnzStnAbv(AbvNr) - 1
    m$ = m$ + "," + GetStnAbv$(AbvNr, i) + " = " + Msg$(iMsgBase + i)
  Next i

  AbvAusw$ = Mid$(m$, 2)

End Function

Function ConvertError(m$)

  Call FileError(m$, "")

  ConvertError = False

End Function

Function GetStnLineNrs(RecNr, m$)

  GetStnLineNrs = True

  ErrNr = GetStationLineData(SV.Out.BsdFile, RecNr)
  If ErrNr Then Exit Function

  m$ = "0"

  For i = 1 To 9
    If StnLineData(i).xloc < 32767 Then
      m$ = m$ + "," + Str$(i)
    End If
  Next i

  GetStnLineNrs = False

End Function

Function LoadNewMap(Title$, Mode, Change&)

  'Mode=1: GetFileSpec only

  IniDir$ = HomeDir$ + "MAP"

  Filt$ = Msg$(24051) + " (*.BMD)|*.BMD" & "|" & Msg$(24052) + " (*.BMP)|*.BMP" _
  & "|" & Msg$(24053) + " (*.RLE)|*.RLE"

  If HV.MapType >= 2 Then
    Filt$ = "#" & CStr(HV.MapType) & ":" & Filt$
  End If

  FilNam$ = StrPar(3, 6)

  'Flags: Shareware(?) + FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
  Cancel = GetFileSpec(Title$, 1, &H580C&, IniDir$, "BMD", Filt$, FilNam$)

  If Cancel Then

    Change& = False

  Else

    Change& = FilNam$ <> StrPar(3, 6)
    StrPar(3, 6) = FilNam$

    If Mode = 0 Then

      'Karte nicht mehr automatisch whlen
      NumPar(46).Actual = NumPar(46).Actual And Not MF_AutoMap

      'Karte einlesen...
      void = LoadMapFile()

    End If

  End If

  LoadNewMap = Cancel

End Function

Function LoadNewStations(Title$, Change&)

  IniDir$ = HomeDir$ + "STN"
  Filt$ = Msg$(24050) + " (*.BSD)|*.BSD"
  FilNam$ = StrPar(3, 7)

  'Flags: Shareware(?) + FileMustExist + PathMustExist + NoChangeDir + HideReadOnly
  Cancel = GetFileSpec(Title$, 1, &H580C&, IniDir$, "BSD", Filt$, FilNam$)

  If Cancel Then

    Change& = False

  Else

    HV.ForceRecalcRoutes = True
    Change& = True      'Force new map to calculate Station-Flags
    StrPar(3, 7) = FilNam$

    'Stationen einlesen...
    Call LoadStations

  End If

  LoadNewStations = Cancel

End Function

Function StnLnkError(Mode, MsgNr, ErrField$)

  'Mode:  1 = Stations-Format-Fehler
  '      -1 = Stations-Referenz-Fehler
  '       2 = Link-Format-Fehler
  '      -2 = Link-Referenz-Fehler


  Select Case Mode
  Case 1, -1
    '--- Station ---
    If Len(SF$(1)) > 0 Then
      m$ = Rpad$(SF$(1), 9) + ", " + Rpad$(SF$(2), 1) + ": "
    End If
  Case 2, -2
    '--- Link ---
    If Len(LF$(1)) > 0 Then
      m$ = Rpad$(LF$(1), 9) + ", " + Rpad$(LF$(2), 9) + ": "
    End If
  End Select

  m$ = m$ + Msg$(MsgNr)
  If Len(ErrField$) > 0 Then m$ = m$ + Quotes$(ErrField$)

  void = ConvertError(m$)

  StnLnkError = MsgNr

End Function

Function WriteUpdLog(EditCmd$)

  WriteUpdLog = True

  '--- Daten fuer selektierte Station aktualisieren ---
  If HV.SelStnRec > 0 Then
    ErrNr = GetStationData(SV.Out.BsdFile, HV.SelStnRec, SelStnData)
    If ErrNr Then Exit Function
  End If


  '--- Header ausgeben ---
  SV.Out.StnHdr.Modified = True
  ErrNr = PutStnHeader()
  If ErrNr Then Exit Function


  '--- Dateien schliessen und wieder oeffnen ---
  FileSpec$ = StripExt$(UCase$(StrPar(3, 7)))

  ErrNr = CloseStnBinFiles(SV.Out)
  If ErrNr Then Exit Function

  ErrNr = OpenStnInBinFiles(FileSpec$, SV.Out)
  If ErrNr Then Exit Function


  '--- Update-Datei ausgeben ---
  SV.TxtFmt = 1

  ErrNr = OpenFile(FileSpec$ + ".UPD", "A", 0, FileNr)
  If ErrNr Then Exit Function

  ErrNr = WriteString(FileNr, EditCmd$ + ": ")
  If ErrNr Then Exit Function

  If ErrNr Then
    Call ShowErrNrFileNr(ErrNr, FileNr)
    Exit Function
  End If

  Select Case EditCmd$
  Case "AS"
    ErrNr = WriteStation(FileNr)

  Case "US"
    ErrNr = WriteStation(FileNr)

    'Show Changes
    If ErrNr = 0 Then ErrNr = WriteString(FileNr, ";old")
    For i = 1 To 13
      If SF$(i) = OF$(i) Then
        SF$(i) = ""
      Else
        If Len(RTrim$(SF$(i))) <> 0 And Len(RTrim$(OF$(i))) = 0 Then
          SF$(i) = "?"
        Else
          SF$(i) = OF$(i)
        End If
      End If
    Next i
    If ErrNr = 0 Then ErrNr = WriteStation(FileNr)

    'Empty Line
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "")

  Case "DS"
    ErrNr = WriteLine(FileNr, Rpad$(SF$(1), 9) + "," + SF$(2))

  Case "AL"
    ErrNr = WriteLink(FileNr)

  Case "UL"
    ErrNr = WriteLink(FileNr)

    'Show Changes
    If ErrNr = 0 Then ErrNr = WriteString(FileNr, ";old")
    For i = 1 To 6
      If LF$(i) = OF$(i) Then
        LF$(i) = ""
      Else
        If Len(RTrim$(LF$(i))) <> 0 And Len(RTrim$(OF$(i))) = 0 Then
          LF$(i) = "?"
        Else
          LF$(i) = OF$(i)
        End If
      End If
    Next i
    If ErrNr = 0 Then ErrNr = WriteLink(FileNr)

    'Empty Line
    If ErrNr = 0 Then ErrNr = WriteLine(FileNr, "")

  Case "DL"
    ErrNr = WriteLine(FileNr, Rpad$(LF$(1), 9) + "," + LF$(2))
  End Select

  ErrNr = ErrNr Or CloseFile(FileNr)
  If ErrNr Then Exit Function

  WriteUpdLog = False

End Function

