Attribute VB_Name = "ParSub"
'-------------------------- PARSUB.BAS ------------------------
DefInt A-Z
Option Explicit

Sub InitNumPar(ByVal ParNr, ByVal ParLabel$, ByVal DefVal&, ByVal MinVal&, ByVal MaxVal&)

  NumPar(ParNr).Label = ParLabel$
  NumPar(ParNr).Default = DefVal&
  NumPar(ParNr).Min = MinVal&
  NumPar(ParNr).Max = MaxVal&

End Sub

Sub InitStrPar(ByVal ParNr, ByVal ParLabel$, ByVal DefVal$, ByVal MultiLine$)

  StrPar(1, ParNr) = ParLabel$
  StrPar(2, ParNr) = DefVal$
  StrPar(4, ParNr) = MultiLine$

End Sub

Function LoadParameter(InParFile$, SectName$, MustExist, Found)

  Dim i, ErrNr

  '--- Parameter initialisieren ---
  Call InitParameter

  For i = 1 To UBound(NumPar)
    NumPar(i).Actual = NumPar(i).Default
  Next i

  For i = 1 To UBound(StrPar, 2)
    StrPar(3, i) = StrPar(2, i)
  Next i

  '--- Parameter einlesen ---
  ErrNr = ReadParameter(InParFile$, SectName$, MustExist, Found)

  If ErrNr = 0 Then
    Call SetParameter
    GV.ParameterLoaded = True
  End If

  LoadParameter = ErrNr

End Function

Function Params2Str$(ByVal AllPar)

  Dim NewLineFlag
  Dim i, m$, ParStr$


  '--- Numerische Parameter ---
  NewLineFlag = False

  For i = 1 To UBound(NumPar)
    If NumPar(i).Actual <> NumPar(i).Default Or AllPar <> 0 Then
      If Len(RTrim$(NumPar(i).Label)) > 0 Then
        m$ = m$ & RTrim$(NumPar(i).Label) & " = "
        If NumPar(i).Max = 0 And NumPar(i).Actual <> -1 Then
          m$ = m$ & "&H" + Hex$(NumPar(i).Actual) & vbCrLf
        Else
          m$ = m$ & Format$(NumPar(i).Actual) & vbCrLf
        End If
        NewLineFlag = True
      End If
    End If
  Next i

  If NewLineFlag Then m$ = m$ + vbCrLf


  '--- String-Parameter ---
  NewLineFlag = False

  For i = 1 To UBound(StrPar, 2)
    If StrPar(3, i) <> StrPar(2, i) Or AllPar Then
      If Len(StrPar(1, i)) > 0 Then
        If StrPar(4, i) <> "+" Then
          m$ = m$ & StrPar(1, i) & " = "
          m$ = m$ & StrPar(3, i) & vbCrLf
        Else
          ParStr$ = StrPar(3, i)
          m$ = m$ & StrPar(1, i) & " = "
          m$ = m$ & Parse$(ParStr$, ",") & vbCrLf

          Do Until Len(ParStr$) = 0
            m$ = m$ & StrPar(1, i) & " =+ "
            m$ = m$ & Parse$(ParStr$, ",") & vbCrLf
          Loop
        End If
        NewLineFlag = True
      End If
    End If
  Next i

  If NewLineFlag Then m$ = m$ & vbCrLf

  Params2Str$ = m$

End Function

Function ReadParameter(IniFile$, SectName$, MustExist, SectFound)

  Dim ErrNr, Found, i, Num&, AnzDataLines
  Dim SectData$, InpLine$, OrgLine$, CmdLine$, Cmd$

  'Parameter einlesen

  ReadParameter = True

  '----- Initialisierungsdatei einlesen -----
  ErrNr = GetSection(IniFile$, SectName$, MustExist, SectData$, AnzDataLines, SectFound)
  If ErrNr Then Exit Function

  If SectFound Then
    Do Until Len(SectData$) = 0
      InpLine$ = Parse$(SectData$, vbCrLf)
      If UCase$(Left$(InpLine$, 7)) = "LPTCTRL" Then
        OrgLine$ = InpLine$
      Else
        OrgLine$ = Parse$(InpLine$, ";")
      End If
      CmdLine$ = OrgLine$
      Cmd$ = UCase$(Parse$(CmdLine$, "="))

      Found = (Len(OrgLine$) = 0)   'Leere Zeile oder Kommentarzeile

      '--- numerische Parameter ---
      If Not Found Then
        For i = 1 To UBound(NumPar)
          If Cmd$ = UCase$(RTrim$(NumPar(i).Label)) Then
            Num& = Val(CmdLine$)
            NumPar(i).Actual = Num&

            '--- Bereichspruefung ---
            If NumPar(i).Min <> 0& Or NumPar(i).Max <> 0& Then
              If Num& < NumPar(i).Min Or Num& > NumPar(i).Max Then
                Call FileError(Msg$(25031) + " '" + OrgLine$ + "'", InParFile$)
                'Exit Function
              End If
            End If

            Found = True
            Exit For
          End If
        Next i
      End If

      '--- String Parameter ---
      If Not Found Then
        For i = 1 To UBound(StrPar, 2)
          If Cmd$ = UCase$(StrPar(1, i)) Then
            If Left$(CmdLine$, 1) = "+" Then
              StrPar(3, i) = StrPar(3, i) + "," + LTrim$(Mid$(CmdLine$, 2))
            Else
              StrPar(3, i) = CmdLine$
            End If
            Found = True
            Exit For
          End If
        Next i
      End If

      If Not Found Then
        Call FileError(Msg$(25031) + " '" + OrgLine$ + "'", InParFile$)
        'Exit Function
      End If

    Loop

  End If

  ReadParameter = False

End Function

Function WriteParameter(FileSpec$, Section$, d$)

  'FileSpec$ = File Name
  'Section$ = Sector Name
  'd$ = Sector Data

  Dim ErrNr, Found
  Dim BOSN&, BOSD&, EOSD&
  Dim m$, m1$, m2$

  WriteParameter = True

  If Not GV.ParameterLoaded Then Exit Function

  '--- Parameter laden (falls vorhanden) ---
  ErrNr = ExistFile(FileSpec$, False, Found)
  If ErrNr Then Exit Function

  If Found Then

    ErrNr = LoadTextFile(FileSpec$, 32767, m$)
    If ErrNr Then Exit Function

    Found = ExtractSection(m$, Section$, 1&, BOSN&, BOSD&, EOSD&)
    m$ = Left$(m$, BOSN& - 1) + Section$ + vbCrLf + d$ + Mid$(m$, EOSD&)
  Else

    m$ = Section$ & vbCrLf & d$

  End If

  'Parameter ausgeben
  WriteParameter = SaveTextFile(FileSpec$, m$)

End Function

