Attribute VB_Name = "QthSub"
'Unterprogramme fr HAMQTH

DefInt A-Z

Sub CheckKey(InputIndex, KeyAscii)

Exit Sub
  If KeyAscii < 32 Then Exit Sub       'Allow Control-Keys (BS, CTRL+C, CTRL+V)

  c$ = UCase$(Chr$(KeyAscii))
  'Pt = HAMQTH.TxtFld(InputIndex).SelStart

  Select Case InputIndex
  Case 0 To 1       'Geogr. Koord.

    Select Case c$
    Case "-", "N", "S", "O", "E", "W"
    Case ".", ",", "0" To "9", ":", " "
    Case Else
      KeyAscii = 0
    End Select


  Case 2 To 3         'konforme Koord.

    Select Case c$
    'Case "-"
    '  If Pt > 0 Then KeyAscii = 0
    Case ".", ",", "0" To "9"
    Case Else
      KeyAscii = 0
    End Select


  Case 4       'QTH-Locator

    Select Case Pt
    Case 0, 1
      If c$ < "A" Or c$ > "R" Then KeyAscii = 0
    Case 4, 5
      If c$ < "A" Or c$ > "X" Then KeyAscii = 0
    Case 2, 3, 6, 7
      If c$ < "0" Or c$ > "9" Then KeyAscii = 0
    Case Else
      KeyAscii = 0        'Max. 8 Zeichen
    End Select


  Case 5       'MGRS (UTM)
    KeyAscii = 0

  End Select

  If KeyAscii = 0 Then Beep

End Sub

Function GetCoord(InputIndex, Geo1 As dGeoPoint, Geo2 As dGeoPoint)

  Dim InGeo1 As dGeoPoint
  Dim InGeo2 As dGeoPoint

  GetCoord = True

  With HAMQTH

    '--- Koordinaten ermitteln - Output always in WGS84 ---
    Geo1.h = 0#
    Geo2.h = 0#

    InMapDatum = .DatumList(InputIndex).ListIndex
    mb$ = .TxtFldN(InputIndex).text

    Select Case InputIndex
    Case 0 To 3             'Geographische und konforme Koordinaten
      If InputIndex < 2 Then
        'Geogr. Koordinaten
        MapCoSys = 0
      Else
        'Konforme Koordinaten
        MapCoSys = .FmtList(InputIndex).ListIndex + 1
      End If

      ml$ = .TxtFldO(InputIndex).text

      ErrNr = PosStr2dCoord(InMapDatum, MapCoSys, mb$, ml$, Geo1)
      If ErrNr Then Exit Function


    Case 4              'QTH-Locator
      ErrNr = Qth2dDegArea(mb$, InGeo1, InGeo2)
      If ErrNr Then Exit Function

      'Output always in WGS84
      ErrNr = CoordTransf(InMapDatum, InGeo1, 0, Geo1)
      If ErrNr Then Exit Function
      ErrNr = CoordTransf(InMapDatum, InGeo2, 0, Geo2)
      If ErrNr Then Exit Function

    Case 5              'UTM Ref.
      Stop

    Case Else
      Stop
    End Select

  End With

  GetCoord = False

End Function

Sub GetShowCoord(InputIndex)

  Static Busy
  Dim Geo1 As dGeoPoint
  Dim Geo2 As dGeoPoint

  If Busy Or GV.ProgChange Then Exit Sub        'Rekursive Aufrufe vermeiden

  Busy = True

  ErrNr = GetCoord(InputIndex, Geo1, Geo2)

  If ErrNr = 0 Then
    'kein Fehler -> Ergebnisse anzeigen
    Call ShowCoord(InputIndex, Geo1, Geo2)
  Else
    'Fehler -> Felder lschen
    With HAMQTH
      For i = 0 To 5
        If i <> InputIndex Then
          .TxtFldN(i).text = ""
          If i < 4 Then .TxtFldO(i).text = ""
        End If
      Next i
    End With
  End If

  void = DoEvents()

  Busy = False

End Sub

Sub InitHAMQTH()

  Dim Datum As GeoDatum

  'MsgBox Str$(Width / Screen.TwipsPerPixelX) & " * " & Str$(Height / Screen.TwipsPerPixelY)

  ErrNr = InitHmTool("HAMQTH", "DOS,HMSUB,GEO,HAMQTH")
  If ErrNr Then
    Call ExitHMTool
    Exit Sub
  End If

  GV.ProgChange = True
  Call InitMenu

  Call CenterForm(HAMQTH)
  'HAMQTH.Height = 7170

  GV.ProgChange = False

End Sub

Sub InitMenu()

  With HAMQTH

    .Show

    'Main Menu
    .mnuMain(0).Caption = Msg$(45000)

    'File-Menu
    For i = 0 To 1
      'If i > 0 Then Load .pdmnuFile(i)
      Call SetMenuItem(.pdmnuFile(i), Msg$(45010 + i))
    Next i

    'Info-Menu
    For i = 0 To 1
      If i > 0 Then Load .pdmnuInfo(i)
      Call SetMenuItem(.pdmnuInfo(i), Msg$(45020 + i))
    Next i

    .MenuSep.Move 0, 0, .ScaleWidth, 50
    .MenuSep.Visible = True

    'Labels
    For i = 0 To 3
      .Lbl(i).Caption = Msg$(45050 + i)
      .TxtLbl(i).Caption = Msg$(45060 + i)
    Next i

    'Koordinaten-Format
    For i = 0 To 1
      Call AddMsgItems(.FmtList(i), 40040, 0)
      Call AddMsgItems(.FmtList(i + 2), 40051, 0)
    Next i
    Call AddMsgItems(.FmtList(4), 40030, 2)

    'Karten-Datum
    For i = 0 To 5
      Call AddMsgItems(.DatumList(i), 40060, 0)
    Next i

  End With

End Sub

Sub ShowCoord(InputIndex, Geo1 As dGeoPoint, Geo2 As dGeoPoint)

  Dim OutPt As dGeoPoint
  Const dots$ = " ... "

  With HAMQTH

    For OutFldNr = 0 To 5
      If OutFldNr <> InputIndex Then
        OutMapDatum = .DatumList(OutFldNr).ListIndex

        Select Case OutFldNr
        Case 0 To 3       'Geogr. + Konforme Koordinaten

          'Geographische und konforme Koordinaten
          If OutFldNr < 2 Then
            'Geogr. Koordinaten
            MapCoSys = 0
            DegMinSec = .FmtList(OutFldNr).ListIndex
          Else
            'Konforme Koordinaten
            MapCoSys = .FmtList(OutFldNr).ListIndex + 1
          End If

          If InputIndex = 4 Then    'QTH-Locator
            ExtraNulls = lMax(0&, Len(.TxtFldN(4).text) \ 2 - 4)
          Else
            ExtraNulls = 2
          End If

          ErrNr = dCoord2PosStr(OutMapDatum, MapCoSys, DegMinSec, ExtraNulls, Geo1, mb1$, ml1$)
          If ErrNr = 0 And InputIndex = 4 Then
            'Input ist QTH-Locator
            ErrNr = dCoord2PosStr(OutMapDatum, MapCoSys, DegMinSec, ExtraNulls, Geo2, mb2$, ml2$)
            mb1$ = mb1$ & dots$ & mb2$
            ml1$ = ml1$ & dots$ & ml2$
          End If

          If ErrNr Then ml1$ = Msg$(40210)
          .TxtFldO(OutFldNr).text = ml1$

        Case 4      'QTH-Locator
          'Input always in WGS84
          ErrNr = CoordTransf(0, Geo1, OutMapDatum, OutPt)
          If ErrNr = 0 Then ErrNr = dDegCoord2Qth(OutPt, mb1$)
          If ErrNr = 0 Then
            mb1$ = Left$(mb1$, 2 + 2 * .FmtList(4).ListIndex)
          End If

        Case 5      'UTM Referenz
          'Input always in WGS84
          ErrNr = CoordTransf(0, Geo1, OutMapDatum, OutPt)
          If ErrNr = 0 Then ErrNr = dCoord2MGRS(OutMapDatum, OutPt, mb1$)
        End Select

        If ErrNr Then mb1$ = Msg$(40210)
        .TxtFldN(OutFldNr).text = mb1$

      End If

    Next OutFldNr

  End With

End Sub

