Attribute VB_Name = "ROUTER"
'-------------------------- ROUTER.BAS ------------------------

'HAMMAP Router-Unterprogramme
'von Gerhard Berg, DJ6FM

DefInt A-Z


Type RouteType
  AllFrom As Integer
  AllMode As Integer
  Precompile As Integer
End Type

Dim Routes As RouteType

Sub AutoAreaStn(RecNr)

  Dim Stn As StationData

  If (NumPar(46).Actual And MF_AutoArea) = 0 Then Exit Sub
  If RecNr = 0 Then Exit Sub
  If (StnFlags(RecNr) And &H40&) = 0 Then Exit Sub

  ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
  If ErrNr = 0 Then
    Call AutoArea(2, CLng(Stn.xloc) * clQth2Sec, CLng(Stn.yloc) * clQth2Sec)
  End If

End Sub

Function CheckNotVia(ByVal StnList$, RecList$)

  CheckNotVia = True

  RecList$ = ""

  Do Until Len(StnList$) = 0
    StnLine$ = Parse$(StnList$, vbCrLf)
    Do Until Len(StnLine$) = 0
      StnGroup$ = Parse$(StnLine$, ",")
      Do Until Len(StnGroup$) = 0
        Stn$ = Parse$(StnGroup$, " ")
        ErrNr = CheckStation(Stn$, RecNr)
        If ErrNr Then Exit Function
        RecList$ = RecList$ + "," + Str$(RecNr)
      Loop
    Loop
  Loop

  RecList$ = Mid$(RecList$, 2)

  CheckNotVia = False

End Function

Sub EraseRoutes()

  If Routes.Precompile = 0 Then
    HV.ForceRecalcRoutes = True
    On Error Resume Next
    Erase StnRoute
    On Error GoTo 0
  End If

End Sub

Function FindRoute(Fastest, StartRec, EndRec, NotViaList$, RouteFound)

  Static AllRoutesFound, LastNotViaList$

  If NumPar(35).Actual And 32 Then   'Debug
    void = PrepareMapDevices(1)
  End If

  If LastNotViaList$ <> NotViaList$ Then
    'Bei nderung der Not-Via Liste mu Route neu berechnet werden
    LastNotViaList$ = NotViaList$
    HV.ForceRecalcRoutes = True
  End If

  'Bei Suche nach nchster MB, DX, WX usw. (EndRec < 0)
  '   mu Route neu berechnet werden
  Routes.Precompile = (NumPar(42).Actual And 32) <> 0 And EndRec >= 0

  If Routes.Precompile = 0 Then

    'Route jedesmal neu berechnen
    ErrNr = FindRoute1(Fastest, StartRec, EndRec, NotViaList$, RouteFound)
    Call ShowText("", 13, 0)
    Routes.AllFrom = 0

  Else

    If Routes.AllFrom <> StartRec Or Routes.AllMode <> Fastest _
        Or HV.ForceRecalcRoutes Then

      'Calculate all Routes in advance
      HV.ForceRecalcRoutes = False
      ErrNr = FindRoute1(Fastest, StartRec, 0, NotViaList$, RouteFound)
      AllRoutesFound = RouteFound
      If ErrNr = 0 Then
        Routes.AllFrom = StartRec
        Routes.AllMode = Fastest
      End If
      Call ShowText("", 13, 0)
    Else
      RouteFound = AllRoutesFound
    End If

    If EndRec > 0 Then
      If StnRoute(EndRec).Route = 0 Then      'mu neue Zeile sein
        'Keine Route zum Ziel
        RouteFound = False
      End If
    End If

  End If


  If NumPar(35).Actual And 32 Then   'Debug
    void = TerminateAllDevices()
  End If

  FindRoute = ErrNr

End Function

Function FindRoute1(Fastest, StartRec, EndRec, NotViaList$, RouteFound)

  Dim Stn As StationData

  FindRoute1 = True
  RouteFound = False

  Call ShowText("", 13, 0)

  ErrNr = InitRouter()
  If ErrNr Then Exit Function

  'Werte fuer alle Digis initialisieren
  MaxGamma = 32767                          'Max:=9999

  For i = 1 To SV.Out.StnHdr.AnzStnRec      'For i:=1 To AnzDigis Do
    StnRoute(i).Gamma = MaxGamma            'rn[i]:=Max
  Next i

  '--- 'Nicht ueber' setzen
  Do Until Len(NotViaList$) = 0
    RecNr = Val(Parse$(NotViaList$, ","))
    StnRoute(RecNr).Gamma = -1
  Loop


  '--- Anfangswerte setzen ---
  SrcRec = StartRec                         'i:=DigiQuelle
  StnRoute(SrcRec).Gamma = 0                'rn[DigiQuelle]:=0
  StnRoute(SrcRec).Next = -1                'Next[DigiQuell]:=-1

  ShowStep& = InitPercent&(Msg$(24108), 2& * SV.Out.StnHdr.AnzLnkRec, 20)

  '----- Digi-Schleife -----
  Do Until SrcRec = EndRec                'Repeat // Until i = DigiZiel

    '--- Pruefen, ob gewuenschter Stationstyp erreicht ---
    'alle Zeilen pruefen
    If EndRec < 0 Then
      ErrNr = GetStationLineData(SV.Out.BsdFile, SrcRec)
      If ErrNr Then Exit Function

      For i = 0 To 9
        If StnLineData(i).xloc < 32767 Then
          If StnLineData(i).StnTyp = -EndRec Then
            EndRec = SrcRec
            Exit Do
          End If
        End If
      Next i

      Stn = StnLineData(0)
    Else
      'Stationsdaten laden
      ErrNr = GetStationData(SV.Out.BsdFile, SrcRec, Stn)
      If ErrNr Then Exit Function
    End If


    '--- Pruefen auf Status, Typ, Software oder Start ---
    StnOk = False
    If SrcRec = StartRec Then
      StnOk = True
    Else
      If 2& ^ Stn.StnStat And NumPar(30).Actual Then
        If 2& ^ Stn.StnTyp And NumPar(31).Actual Then
          If 2& ^ Stn.Software And NumPar(32).Actual Then
            StnOk = True
          End If
        End If
      End If
    End If

    If StnOk Then

      '----- Alle Links fuer aktuellen Digi pruefen ---
      LnkRec = Stn.LnkPtr            'For k:=ka ...
      Do Until LnkRec = 0                   '... To AnzLinks Do

        If (Tries& Mod ShowStep&) = 0 Then
          ErrNr = ShowPercent(Tries&, "")
          If ErrNr Then Exit Function
        End If
        Tries& = Tries& + 1


        '--- LinkDaten einlesen ---
        ErrNr = GetNextLink(LnkRec, NextLink, SrcRec, DstRec, ActLnkData)
        If ErrNr Then Exit Function


        '--- Pruefen auf Route-Status, Route-Typ und Route-Baud ---
        If CheckLinkFilter(ActLnkData, 1) Then

          '--- Qualitaet berechnen ---
          If Fastest Then
            DstGamma = StnRoute(SrcRec).Gamma + GetGamma()
                'd:=rn[i]+LnkPtr[k].Gamma
          Else
            DstGamma = StnRoute(SrcRec).Gamma + 1
          End If


          'Pruefen, ob Route schneller und Ziel nicht gesperrt
          If DstGamma < StnRoute(DstRec).Gamma Then
              'If (d < rn[j]) Then

            '--- Neuer Link ist schneller ---
            StnRoute(DstRec).Gamma = DstGamma   'rn[j]:=d
            StnRoute(DstRec).Route = SrcRec     'LnkPtr[j]^.Route:=i

            If StnRoute(DstRec).Next = 0 Then   'If (Next[j] = 0) Then
              'Ziel ist bisher noch nicht benutzt worden
              ' -> neu in Liste aufnehmen
              StnRoute(DstRec).Next = StnRoute(StartRec).Next
                  'Next[j]:=Next[DigiQuelle]
              StnRoute(StartRec).Next = DstRec  'Next[DigiQuelle]:=j
              Links = Links + 1
            End If
          End If

          If NumPar(35).Actual And 32 Then   'Debug
            void = DrawOneLink()
            If NumPar(46).Actual And MF_BackGnd Then
              MapForm.Refresh
            End If
          End If
        End If
        LnkRec = NextLink
      Loop

    End If


    '----- Abbruch, wenn keine Route gefunden -----
    If StnRoute(StartRec).Next < 0 Then     'If (Next[DigiQuelle < 0) Then
      FindRoute1 = False
      If EndRec = 0 And Links > 0 Then RouteFound = True
      Exit Function                         'EXIT
    End If


    '--- Aus allen Enden die beste Verbindung suchen ---
    NextDst = StartRec                      'ka:=DigiQuelle
    BestGamma = MaxGamma                    'd:=Max

    Do                                      'Repeat
      SrcRec = StnRoute(NextDst).Next       'i:=Next[ka]
      NewGamma = StnRoute(SrcRec).Gamma     'dd:=rn[i]
      If NewGamma < BestGamma Then          'if (dd < d) then
        DstRec = NextDst                    'j:=ka
        BestGamma = NewGamma                'd:=dd
      End If
      NextDst = SrcRec                      'ka:=i
    Loop Until StnRoute(SrcRec).Next <= 0
        'Until (Next[i] <= 0)

    SrcRec = StnRoute(DstRec).Next          'i:=Next[j]
    StnRoute(DstRec).Next = StnRoute(SrcRec).Next
        'Next[j]:=Next[i]

  Loop

  RouteFound = True
  FindRoute1 = False

End Function

Function GetGamma()

  Dim Baud As Long

  Select Case GetStnAbv$(6, ActLnkData.StatTyp \ 256)
  Case "WI", "BU"
    'Wired or Bus Link
    GetGamma = 1
  Case Else
    'HF-Link
    Baud = ActLnkData.Baud
    If Baud = 0 Then Baud = 1200

    Select Case GetStnAbv$(5, ActLnkData.StatTyp And 255)
    Case "PL", "DF"
      GetGamma = 255
    Case "TE", "IS"
      GetGamma = 6460 * Baud ^ -0.68
      'GetGamma = 6460 * Exp(-.68 * Log(Baud))
    Case Else
      GetGamma = 3230 * Baud ^ -0.68
      'GetGamma = 3230 * Exp(-.68 * Log(Baud))
    End Select
  End Select

End Function

Function GetRouteCalls$(ByVal SrcRec)

  Dim StnCall As StationCall

  m$ = ""

  Do
    ErrNr = GetStationCall(SrcRec, StnCall)
    Call DecodeCall(StnCall, OutCall$, LineNr$)
    m$ = OutCall$ + ", " + m$
    SrcRec = StnRoute(SrcRec).Route
  Loop Until SrcRec = 0

  m$ = Left$(m$, Len(m$) - 2)

  GetRouteCalls$ = m$

End Function

Function InitRouter()

  InitRouter = True

  'Pruefen, ob Links vorhanden
  If SV.Out.StnHdr.AnzLnkRec < 2 Then
    Call ShowErrNr(24216)
    Exit Function
  End If


  '--- Speicher reservieren ---
  On Local Error Resume Next
  ReDim StnRoute(1 To SV.MaxAnzStn) As StationRoute
  If Err Then
    Call ShowErrNr(Err)
    Exit Function
  End If
  On Local Error GoTo 0

  InitRouter = False

End Function

Sub MakeRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)

  '------------------------- Route berechnen -----------------------
  Call ShowFound(0)

  ErrNr = FindRoute(Fastest, StartRec, EndRec, NotViaList$, RouteFound)
  If ErrNr = 0 Then
    If RouteFound Or EndRec = 0 Then
      'Route gefunden oder alle Links
      ErrNr = ShowRoute(Fastest, EndRec)
      If ErrNr = 0 And EndRec > 0 Then
        '--- Route im Zusatzfenster ausgeben ---
        Call ShowFound(2)
        If Mark Then Call DrawFound(2)
      End If
    Else
      Call ShowErrNr(24210)
    End If
  End If

  '--- Speicher freigeben ---
  Call EraseRoutes

End Sub

Function ShowRoute(Fastest, EndRec)

  Static x1 As Long, y1 As Long
  Static x2 As Long, y2 As Long
  Static Stn As StationData

  Dim CrtPen As HMPen
  Dim PrtPen As HMPen

  ShowRoute = True

  If NumPar(46).Actual And MF_AutoArea Then
    '--- Ausschnitt anpassen ---
    Call AutoArea(1, 0&, 0&)              'Init

    If EndRec = 0 Then
      '--- Kein Digi selektiert - alle Wege ---
      Call AutoAreaStn(SrcRec)
      For SrcRec = 2 To SV.Out.StnHdr.AnzStnRec
        DstRec = StnRoute(SrcRec).Route
        If DstRec > 0 Then Call AutoAreaStn(DstRec)
      Next SrcRec
    Else
      '---- Digi selektiert -> eine Route ----
      SrcRec = EndRec
      Do
        Call AutoAreaStn(SrcRec)
        DstRec = StnRoute(SrcRec).Route
        SrcRec = DstRec
      Loop Until DstRec <= 0
    End If

    Call AutoArea(4, 0&, 0&)              'Ausgeben
  End If

  CrtPen.Color = HV.ColVal(13)
  CrtPen.Width = GetLineWidth(0, 10)
  CrtPen.Style = 0

  PrtPen.Color = HV.ColVal(13)
  PrtPen.Width = GetLineWidth(1, 10)
  PrtPen.Style = 0

  ErrNr = PrepareMapDevices(1)

  If EndRec = 0 Then

    'Kein Digi selektiert - alle Wege ausgeben

    For SrcRec = 2 To SV.Out.StnHdr.AnzStnRec

      DstRec = StnRoute(SrcRec).Route

      If DstRec > 0 Then
        ErrNr = DrawLinkLine(SrcRec, DstRec, CrtPen, PrtPen)
        If ErrNr Then Exit For
        TotalFound = TotalFound + 1
      End If

    Next SrcRec

    m$ = LTrim$(Str$(TotalFound)) + " "
    Call ShowText(m$ + Msg$(24111), 13, 0)

  Else

    '---- Route ausgeben ----
    SrcRec = EndRec
    HV.AnzFound = 0
    Qual! = 100

    Do
      DstRec = StnRoute(SrcRec).Route
      If DstRec > 0 Then
        RGBCol& = HV.ColVal(13)

        SrcOk = (StnFlags(SrcRec) And &H70) = &H70
        DstOk = (StnFlags(DstRec) And &H70) = &H70

        If SrcOk Then LastOkSrc = SrcRec

        If SrcOk And DstOk Then
          CrtPen.Style = 0
          PrtPen.Style = 0
          ErrNr = DrawLinkLine(SrcRec, DstRec, CrtPen, PrtPen)
          If ErrNr Then Exit Do
        ElseIf DstOk And LastOkSrc <> 0 Then
          CrtPen.Style = 3
          PrtPen.Style = 3
          ErrNr = DrawLinkLine(LastOkSrc, DstRec, CrtPen, PrtPen)
          If ErrNr Then Exit Do
        End If

        g = StnRoute(SrcRec).Gamma - StnRoute(DstRec).Gamma
        Qual! = Qual! * (255 - g) / 255
        AnzHops = AnzHops + 1
      End If

      If HV.AnzFound < UBound(StnFnd) Then
        ErrNr = AddFoundStn(SrcRec)
        If ErrNr Then Exit Do
      End If

      SrcRec = DstRec
    Loop Until DstRec <= 0

    If Fastest Then
      q$ = " - " + Msg$(31047) + ": " + Format$(Qual!, "0") + " %"
    End If
    Call ShowText(Msg$(31036) + ":" + Str$(AnzHops) + q$, 13, 0)

  End If

  void = TerminateAllDevices()

  ShowRoute = ErrNr

End Function

