Attribute VB_Name = "SETUP"
'---------------------------- SETUP.BAS ----------------------------

'Setup-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z


Sub Main()


  MsgBox "This program is not designed for 32 Bit-Windows."


End Sub

Function CheckExistFile(Src$, Exist, Vers$)

  Static DiskNr

  CheckExistFile = True

  Exist = False

  '--- Pruefen, ob Datei in Shiping List ---
  i1 = InStr(ShipLst$, vbCrLf + Src$)
  i2 = InStr(i1 + 2, ShipLst$, vbCrLf)
  If i1 > 0 And i2 > i1 Then
    Vers$ = Mid$(ShipLst$, i1 + 2, i2 - i1 - 2)
    f$ = Parse$(Vers$, ",")
  End If

  If f$ = Src$ Then
    ErrNr = ExistFile(HomeDir$ + Src$, False, Exist)
    If ErrNr Then Exit Function
    If Not Exist Then

      '--- File ist nicht auf der aktuellen Disk ---
      If DiskNr = 0 Then DiskNr = 1            'mit 2 anfangen
      DiskNr = DiskNr + 1
      Beep

      m$ = Replace$(Msg$(17), "%", LTrim$(Str$(DiskNr)))
      Do
        ErrNr = ExistFile(Src$, False, Exist)
        If ErrNr = 0 And Not Exist Then
          ErrNr = (MsgBoxSim(m$, 1) = 2)   'Cancel
        End If
      Loop Until Exist Or ErrNr

    End If

  End If

  CheckExistFile = ErrNr

End Function

Function CloseFile(FileNr)

  On Local Error Resume Next
  Close #FileNr
  CloseFile = Err
  If Err Then Call FileError(Error$, FileName$(FileNr))

End Function

Function ExistFile(File$, MustExist, Exist)

  On Local Error Resume Next
  f$ = Dir$(File$)
  ErrNr = Err

  If ErrNr Then f$ = ""
  Exist = Len(f$) > 0

  'Pfad nicht gefunden
  If ErrNr = 76 And Not MustExist Then ErrNr = 0
  'Datei nicht gefunden
  If ErrNr = 0 And MustExist And Not Exist Then ErrNr = 53

  If ErrNr Then Call FileError(Msg$(ErrNr), File$)

  ExistFile = ErrNr

End Function

Function ExpandSetupFiles(Src$, Dst$)

  ExpandSetupFiles = True

  '--- Ermittlung der Dateien aus Shiping List---
  SrcList$ = ShipDir$(Src$)
  Call ParseFileSpec(Dst$, d2$, p2$, n2$, E2$)


  '--- Dateien entpacken ---
  Do Until Len(SrcList$) = 0
    f$ = Parse$(SrcList$, vbCrLf)
    Src$ = HomeDir$ + f$

    ErrNr = CheckExistFile(f$, Exist, V$)
    If ErrNr Then Exit Function
    If Exist Then

      c$ = DstPath$ + "LHA\LHA x " + Src$ + " " + Dst$

      ErrNr = WriteSetupLog("  DOS: " + c$)
      If ErrNr Then Exit Function

      ErrNr = DosCommand(c$)
      If ErrNr Then Exit Function


      '--- pruefen, ob alle Files entpackt ------
      ErrNr = LoadSetupFile(DstPath$ + "DIR.LST", LstBuf$)
      If ErrNr Then Exit Function
      Call KillFile(DstPath$ + "DIR.LST")

      Do Until Len(LstBuf$) = 0
        f$ = Parse$(LstBuf$, vbCrLf)
        ErrNr = ExistFile(DstPath$ + f$, True, Exist)
        If ErrNr Then Exit Function
      Loop
    End If
  Loop

  ExpandSetupFiles = False

End Function

Sub FileError(ErrTxt$, File$)

  Beep
  m$ = ErrTxt$
  If Len(File$) > 0 Then m$ = m$ + ": " + UCase$(File$)

  MsgBox m$, 48, ProgName$

  If LogFile Then void = WriteSetupLog(m$)
  If Not MsgLoaded Then End

End Sub

Function FindLanguages()

  FindLanguages = True

  '--- Sprachen bestimmen ---
  f$ = "*.SMS"
  FileList$ = ShipDir$(f$)

  If Len(FileList$) = 0 Then
    Call FileError(Msg$(53), HomeDir$ + f$)
  End If

  Do Until Len(FileList$) = 0
    AnzLng = AnzLng + 1
    LngFile$(AnzLng) = UCase$(Parse$(FileList$, vbCrLf))
  Loop


  '--- Sprachen sortieren (Bubble-Sort) ---
  For i = AnzLng To 2 Step -1
    For j = 2 To i
      If LngFile$(j - 1) > LngFile$(j) Then
        zw$ = LngFile$(j - 1)
        LngFile$(j - 1) = LngFile$(j)
        LngFile$(j) = zw$
      End If
    Next j
  Next i


  '--- Sprachbezeichnung (nur 1. Zeile) einlesen ---
  For i = 1 To AnzLng
    f$ = HomeDir$ + LngFile$(i)
    ErrNr = OpenFile(f$, "I", 0, FileNr)
    If ErrNr Then Exit Function

    On Local Error Resume Next
    Line Input #FileNr, InpLine$
    If Err Then
      Call FileError(Error$, f$)
      Exit Function
    End If
    On Local Error GoTo 0

    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function

    Nr$ = Parse$(InpLine$, ",")
    LngName$(i) = Pc8toAnsi$(InpLine$)
  Next i

  FindLanguages = False

End Function

Sub KillFile(f$)

  On Local Error Resume Next
  Kill f$
  On Local Error GoTo 0

End Sub

Function LoadSetupFile(FileSpec$, text$)

  LoadSetupFile = True

  ErrNr = ExistFile(FileSpec$, True, Exist)
  If ErrNr Then Exit Function

  '--- Datei oeffnen ---
  ErrNr = OpenFile(FileSpec$, "B", 0, FileNr)
  If ErrNr Then Exit Function

  '--- Datei einlesen ---
  On Local Error Resume Next
  text$ = INPUT$(LOF(FileNr), #FileNr)
  If Err Then
    Call FileError(Msg$(Err), FileSpec$)
    Exit Function
  End If
  On Local Error GoTo 0

  '--- Datei schliessen ---
  LoadSetupFile = CloseFile(FileNr)

End Function

Function LoadSetupMsg()

  LoadSetupMsg = True

  f$ = HomeDir$ + Language$ + ".SMS"
  ErrNr = LoadSetupFile(f$, MsgBuf$)
  If ErrNr Then Exit Function

  Do Until Len(MsgBuf$) = 0
    MsgLine$ = Parse$(MsgBuf$, vbCrLf)
    If Len(MsgLine$) > 0 Then
      If Left$(MsgLine$, 1) <> ";" Then
        'VAL nicht verwenden wegen Floating Point
        MsgNr = IntVal(Parse$(MsgLine$, ","))
        'Convert Code and Strip comments
        MsgTxt$(MsgNr) = Pc8toAnsi$(Parse$(MsgLine$, ";"))
      End If
    End If
  Loop

  MsgLoaded = True
  LoadSetupMsg = False

End Function

Function MakePath(NewPath$)

  'Funktion: Pfad anlegen
  'NewPath$ muss "\" am Ende des Pfades haben

  Static LastPath$

  If NewPath$ = LastPath$ Then Exit Function

  MakePath = True

  Call ParseFileSpec(NewPath$, d$, p$, n$, e$)

  LastPath$ = ""

  'Pruefen auf Root Backslash
  If Left$(p$, 1) <> "\" Then Exit Function
  p$ = Mid$(p$, 2)

  'Pruefen auf Leerzeichen
  If InStr(p$, " ") Then Exit Function

  Do Until Len(p$) = 0
    p1$ = Parse$(p$, "\")
    'Pruefen auf leeres Feld('\\')
    If Len(p1$) = 0 Then Exit Function
    Path$ = Path$ + "\" + p1$

    On Local Error Resume Next
    MkDir d$ + Path$
    ErrNr = Err
    If ErrNr = 75 Then ErrNr = 0      'Pfad existiert schon
    If ErrNr Then
      Call FileError(Msg$(ErrNr), d$ + Path$)
      Exit Function
    End If
    On Local Error GoTo 0
  Loop

  LastPath$ = NewPath$
  MakePath = False

End Function

Function Msg$(ByVal MsgNr As Long)

  Select Case MsgNr
  Case 53                           'Datei nicht gefunden
    MsgNr = 22
    If Not MsgLoaded Then
      Msg$ = "Datei nicht gefunden / File not found"
      Exit Function
    End If
  Case 61                           'Disk voll
    MsgNr = 30
  Case 64, 68, 71, 75, 76           'Ungueltiges/r Laufwerk/Pfad
    MsgNr = 7
  End Select

  If MsgLoaded And MsgNr <= UBound(MsgTxt$) Then
    Msg$ = MsgTxt$(MsgNr)
  Else
    Msg$ = Error$
  End If

End Function

Function OpenFile(File$, FileTyp$, RecLen, FileNr)

  On Local Error Resume Next

  FileNr = FreeFile
  ErrNr = Err
  FileName$(FileNr) = File$

  If ErrNr = 0 Then
    Select Case FileTyp$
    Case "I"
      Open File$ For Input As #FileNr
    Case "O"
      Open File$ For Output As #FileNr
    Case "A"
      Open File$ For Append As #FileNr
    Case "B"
      Open File$ For Binary As #FileNr
    End Select
    ErrNr = Err
  End If

  OpenFile = ErrNr

  If ErrNr Then Call FileError(Msg$(ErrNr), File$)

End Function

Function OpenLog()

  OpenLog = True

  If VBDOS Then
    f$ = DstPath$ + "HMDOS.LOG"
    V$ = " - DOS"
  Else
    f$ = DstPath$ + "HMWIN.LOG"
    V$ = " - Windows"
  End If

  ErrNr = OpenFile(f$, "O", 0, LogFile)
  If ErrNr Then Exit Function

  ErrNr = WriteSetupLog("HAMMAP Installation")
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("-------------------")
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Version = " + Version$ + V$)
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Language = " + Language$)
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Date = " + Date$)
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Time = " + Time$)
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Source = " + StripBackSlash$(HomeDir$))
  If ErrNr Then Exit Function
  ErrNr = WriteSetupLog("Destination = " + StripBackSlash$(DstPath$))
  If ErrNr Then Exit Function

  OpenLog = False

End Function

Function PerformSetup()

  PerformSetup = True

  '--- Quelle und Ziel aus Kommandozeile ---
  Options$ = UCase$(Command$)
  DstPath$ = Parse$(Options$, "/")
  HomeDir$ = Parse$(DstPath$, " ")


  '--- Laufwerk bestimmen, von dem SETUP gestartet wird ---
  If Len(HomeDir$) = 0 Then HomeDir$ = AppPath$()
  HomeDir$ = AddBackSlash$(HomeDir$)


  '--- Steuerdatei laden ---
  f$ = HomeDir$ + "SETUPWIN.LST"

  ErrNr = LoadSetupFile(f$, InCmdBuf$)
  If ErrNr Then Exit Function


  '--- Titel setzen ---
  CmdBuf$ = InCmdBuf$

  Do Until Len(CmdBuf$) = 0

    CmdLine$ = UCase$(Parse$(CmdBuf$, vbCrLf))
    Cmd$ = Parse$(CmdLine$, ":")

    Select Case Cmd$
    Case "TITLE"
      Call ShowTitle(CmdLine$)
      Exit Do
    Case Else
    End Select
  Loop


  '--- Shipping List laden ---
  ErrNr = LoadSetupFile(HomeDir$ + "SHIPING.LST", ShipLst$)
  If ErrNr Then Exit Function
  ShipLst$ = UCase$(ShipLst$)

  '--- Sprache bestimmen ---
  If Len(Options$) > 0 And Options$ <> "ALL" Then
    Language$ = Options$
  Else
    ErrNr = FindLanguages()
    If ErrNr Then Exit Function

    If AnzLng = 1 Then
      Language$ = LngFile$(1)
    Else
      Call SelectLanguage
    End If

    Call ParseFileSpec(Language$, d$, p$, n$, e$)
    Language$ = n$
  End If


  '--- Programm-Texte laden ---
  ErrNr = LoadSetupMsg()
  If ErrNr Then Exit Function


  '--- Hinweis: 'Bei Problemen *.TXT lesen' ---
  f$ = HomeDir$ + Language$ + ".TXT"
  ErrNr = ExistFile(f$, False, Exist)
  If ErrNr Then Exit Function
  If Exist Then Call ShowHint


  '--- Ziel-Laufwerk und -Verzeichnis bestimmen ---
  If Len(DstPath$) = 0 Then
    'Default
    DstPath$ = "C:\HAMMAP\"
    ErrNr = SelectDestination()
    If ErrNr Then Exit Function
  Else
    DstPath$ = AddBackSlash$(DstPath$)
    ErrNr = MakePath(DstPath$)
    If ErrNr Then Exit Function
  End If


  '--- Temp-Pfad bestimmen ---
  TmpPath$ = HomeDir$
  p$ = Environ$("TEMP")
  If Len(p$) > 0 Then TmpPath$ = p$
  p$ = Environ$("TMP")
  If Len(p$) > 0 Then TmpPath$ = p$
  TmpPath$ = AddBackSlash$(TmpPath$)


  '--- Log-Datei oeffnen ---
  ErrNr = OpenLog()
  If ErrNr Then Exit Function


  '--- HomeDir$ als aktuelles Verzeichnis setzen ---
  'Dateien ohne Source-Pfad werden von hier gelesen
  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Function


  '--- System-Eigenschaften bestimmen ---
  '    (nach OpenLog und ChangePath)
  ErrNr = AnalyseSystem()
  If ErrNr Then Exit Function


  '--- Sprache ausgeben ---
  ErrNr = OpenFile(DstPath$ + "HM-SPEAK.INI", "O", 0, FileNr)
  If ErrNr Then Exit Function
  ErrNr = WriteLine(FileNr, Language$)
  If ErrNr Then Exit Function
  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Function


  ErrNr = WriteSetupLog("")
  If ErrNr Then Exit Function


  '--- Steuerdatei ausfuehren ---
  CmdBuf$ = InCmdBuf$

  Do Until Len(CmdBuf$) = 0
    ErrNr = CancelSetup()
    If ErrNr Then Exit Do

    CmdLine$ = UCase$(Parse$(CmdBuf$, vbCrLf))
    l$ = Left$(CmdLine$, 1)
    If l$ = ";" Or l$ = "#" Then CmdLine$ = ""

    If Len(CmdLine$) > 0 Then

      '--- Variablen ersetzen ---
      If Options$ = "ALL" Then
        CmdLine$ = Replace$(CmdLine$, "%LANGUAGE%", "*")
      Else
        CmdLine$ = Replace$(CmdLine$, "%LANGUAGE%", Language$)
      End If
      CmdLine$ = Replace$(CmdLine$, "%WINSYS%", StripBackSlash$(WinSysDir$))
      CmdLine$ = Replace$(CmdLine$, "%WIN%", StripBackSlash$(WinDir$))
      CmdLine$ = Replace$(CmdLine$, "%DST%", StripBackSlash$(DstPath$))


      '--- Befehl anzeigen und auf Logdatei schreiben ---
      Call ShowCmd(CmdLine$)
      ErrNr = WriteSetupLog(CmdLine$)
      If ErrNr Then Exit Do


      '--- Befehl zerlegen ---
      Cmd$ = Parse$(CmdLine$, ":")
      Par1$ = Parse$(CmdLine$, ",")
      Par2$ = Parse$(CmdLine$, ",")
      Par3$ = Parse$(CmdLine$, ",")
      Par4$ = CmdLine$
      Src$ = Par1$
      Dst$ = Par2$
      If Mid$(Dst$, 2, 1) = ":" Then
        'Dst is absoulute
        DstSpec$ = Dst$
      Else
        'Dst is relative
        DstSpec$ = DstPath$ + Dst$
      End If


      '--- Befehle ausfuehren ---
      Select Case Cmd$

      Case "TITLE"

      Case "COPY"
        'COPY: [Path]Source, Destination
        ErrNr = MakePath(DstSpec$)
        If ErrNr Then Exit Do
        ErrNr = WildCopySetupFiles(Src$, DstSpec$)


      Case "DCOPY"
        ErrNr = ExistFile(Src$, True, Exist)
        If ErrNr Then Exit Do
        ErrNr = CopyFile(Src$, DstSpec$)
        If ErrNr Then Exit Do
        ErrNr = ExistFile(DstSpec$, True, Exist)


      Case "PATH"
        'PATH: Path
        ErrNr = MakePath(DstPath$ + AddBackSlash$(Par1$))


      Case "REPLACE"
        'REPLACE: File, Search-String, Replace-String
        ErrNr = LoadSetupFile(Par1$, m$)
        If ErrNr = 0 Then
          m$ = Replace$(m$, Par2$, Par3$)
          ErrNr = SaveSetupFile(Par1$, m$)
        End If


      Case "LHA"
        'LHA: Source, Destination[,MsgNr for Query]
        If Len(Par2$) = 0 Then
          ErrNr = ExpandSetupFiles(Src$, DstPath$)
        Else
          Select Case MsgBoxSim(Msg$(IntVal(Par2$)), 3)
          Case 6      'Yes
            ErrNr = ExpandSetupFiles(Src$, DstPath$)
          Case 2      'Cancel
            ErrNr = True
            Exit Do
          End Select
        End If

      Case "VCOPY"
        'VERCOPY: Source, Destination
        ErrNr = CheckExistFile(Src$, Exist, Vers$)
        If ErrNr = 0 And Exist Then
          ErrNr = VerCopyFile(Src$, Dst$, Vers$)
        End If


      Case "PROGMAN"
        'PROGMAN: Command, Parameter
        ErrNr = ProgMan(Par1$, Par2$, Par3$, Par4$)

      Case "QUIT"               'Zum Testen
        ErrNr = 0
        Exit Do


      Case Else
        Call FileError("BadCommand", Cmd$)
        ErrNr = True
      End Select

      If ErrNr Then Exit Do

    End If

  Loop

  PerformSetup = ErrNr

End Function

Function SaveSetupFile(FileSpec$, text$)

  SaveSetupFile = True

  ErrNr = ExistFile(FileSpec$, True, Exist)
  If ErrNr Then Exit Function

  '--- Datei oeffnen ---
  ErrNr = OpenFile(FileSpec$, "O", 0, FileNr)
  If ErrNr Then Exit Function

  '--- Datei ausgeben ---
  On Local Error Resume Next
  Print #FileNr, text$;
  If Err Then
    Call FileError(Msg$(Err), FileSpec$)
    Exit Function
  End If
  On Local Error GoTo 0

  '--- Datei schliessen ---
  SaveSetupFile = CloseFile(FileNr)

End Function

Function ShipDir$(Src$)

  ShipBuf$ = ShipLst$

  'Aus SHIPING.LST alle Files suchen, die der Bedingung in Src$ entsprechen

  Call ParseFileSpec(Src$, d1$, p1$, n1$, e1$)

  Do Until Len(ShipBuf$) = 0
    f$ = Parse$(ShipBuf$, vbCrLf)
    Call ParseFileSpec(f$, d2$, p2$, n2$, E2$)
    cp = p1$ = p2$
    cn = n1$ = "*" Or n1$ = n2$
    ce = e1$ = ".*" Or e1$ = E2$
    If cp And cn And ce Then
      d$ = d$ + p2$ + n2$ + E2$ + vbCrLf
    End If
  Loop

  ShipDir$ = d$

End Function

Function WildCopySetupFiles(Src$, Dst$)

  WildCopySetupFiles = True


  '--- Ermittlung der Dateien aus Shiping List---
  SrcList$ = ShipDir$(Src$)
  Call ParseFileSpec(Dst$, d2$, p2$, n2$, E2$)


  '--- Dateien kopieren ---
  Do Until Len(SrcList$) = 0
    f$ = Parse$(SrcList$, vbCrLf)
    Src$ = HomeDir$ + f$

    ErrNr = CheckExistFile(f$, Exist, V$)
    If ErrNr Then Exit Function
    If Exist Then
      Call ParseFileSpec(f$, d$, p$, n$, e$)
      If n2$ <> "*" Then n$ = n2$
      If E2$ <> ".*" Then e$ = E2$
      Dst$ = d2$ + p2$ + n$ + e$

      ErrNr = CopyFile(Src$, Dst$)
      If ErrNr Then Exit Function

      'Pruefen, ob Datei kopiert ist
      ErrNr = ExistFile(Dst$, True, Exist)
      If ErrNr Then Exit Do
    End If
  Loop

  WildCopySetupFiles = ErrNr

End Function

Function WriteSetupLog(m$)

  WriteSetupLog = WriteLine(LogFile, m$)

End Function

