Attribute VB_Name = "Setup_W"
DefInt A-Z

Public WinDir$
Public WinSysDir$

Public WinVer$
Public AppName$

Type OFStruct
    cBytes As String * 1
    fFixedDisk As String * 1
    nErrCode As Integer
    reserved As String * 4
    szPathName As String * 128
End Type

Declare Function GetWindowsDirectory Lib "Kernel.dll" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

Declare Function VerInstallFile& Lib "ver.dll" (ByVal Flags%, ByVal SrcFile$, ByVal DestFile$, ByVal SrcPath$, ByVal DstPath$, ByVal CurrDir$, ByVal TmpFile$, lpwTmpFileLen%)
Declare Function WinOpenFile Lib "Kernel.dll" Alias "OpenFile" (ByVal lpFileName As String, lpReOpenBuff As OFStruct, ByVal wStyle As Integer) As Integer

Declare Function GetDeviceCaps Lib "GDI.dll" (ByVal hDC As Integer, ByVal nIndex As Integer) As Integer

Function AnalyseSystem()

  AnalyseSystem = True

  '--- Volume-Label bestimmen ---
  Vol$ = Replace$(Dir$(HomeDir$, 8), ".", "")
  ErrNr = WriteSetupLog("Vol = " + Vol$)
  If ErrNr Then Exit Function


  '--- Get Windows and DOS version ---
  TheVerInfo& = GetVersion()
  V& = TheVerInfo& And &HFFFF&
  WinVer$ = Format$(V& Mod 256) + "." + Format$(V& \ 256)
  ErrNr = WriteSetupLog("WinVer = " + WinVer$)
  If ErrNr Then Exit Function
  V& = TheVerInfo& \ &H10000
  DosVer$ = Format$(V& \ 256) + "." + Format$(V& Mod 256)
  ErrNr = WriteSetupLog("DosVer = " + DosVer$)
  If ErrNr Then Exit Function


  '--- Windows Verzeichnis ---
  temp$ = String$(145, 0)                ' Size Buffer
  x = GetWindowsDirectory(temp$, 145)    ' Make API Call
  WinDir$ = AddBackSlash$(UCase$(Left$(temp$, x)))
  ErrNr = WriteSetupLog("WinDir = " + WinDir$)
  If ErrNr Then Exit Function


  '--- Windows\System Verzeichnis ---
  WinSysDir$ = AddBackSlash$(UCase$(GetWinSysDir$()))
  ErrNr = WriteSetupLog("WinSysDir = " + WinSysDir$)
  If ErrNr Then Exit Function


  ' If the Windows \SYSTEM directory is a subdirectory
  ' of the Windows directory, the proper place for
  ' installation of .VBXs and shared .DLLs is the
  ' Windows \SYSTEM directory.
  '
  ' If the Windows \SYSTEM directory is *not* a subdirectory
  ' of the Windows directory, then the user is running a
  ' shared version of Windows, and the proper place for
  ' installation of .VBXs and shared .DLLs is the
  ' Windows directory.

  If InStr(WinSysDir$, WinDir$) = 0 Then
    WinSysDir$ = WinDir$
  End If


  '--- Bildschirm ---
  m1$ = Format$(GetDeviceCaps(SetupForm.hDC, 8))
  m2$ = Format$(GetDeviceCaps(SetupForm.hDC, 10))
  ErrNr = WriteSetupLog("Screen = " & m1$ & " * " & m2$)
  If ErrNr Then Exit Function
  m$ = Format$(GetDeviceCaps(SetupForm.hDC, 24))
  ErrNr = WriteSetupLog("Colors = " & m$)
  If ErrNr Then Exit Function
  m$ = Hex$(GetDeviceCaps(SetupForm.hDC, 38))
  ErrNr = WriteSetupLog("RasterCaps = " & m$)
  If ErrNr Then Exit Function

  AnalyseSystem = False

End Function

Sub CenterControl(Container As Form, Object As Control)

  x = (Container.ScaleWidth - Object.Width) / 2
  y = (Container.ScaleHeight - Object.Height) / 2
  Object.Move x, y

End Sub

Sub CenterForm(x As Form)

  x.Top = (Screen.Height - x.Height) / 2
  x.Left = (Screen.Width - x.Width) / 2

End Sub

Function ProgMan(Cmd$, PrgName$, PrgFile$, Lng$)

  Select Case Cmd$
  Case "DELETE"
    ErrNr = ProgManCmd("DeleteGroup", PrgName$)

  Case "GROUP"
    '--- Create Program Group ---
    AppName$ = PrgName$
    Par$ = PrgName$ & Chr$(44) & PrgFile$
    ErrNr = ProgManCmd("CreateGroup", Par$)

  Case "ITEM"

    If Len(Lng$) = 0 Or UCase$(Lng$) = Language$ Then

      If Left$(PrgName$, 3) = "MSG" Then
        PrgName$ = Msg$(Val(Mid$(PrgName$, 4)))
      End If

      '--- Create Program Item ---
      If Val(WinVer$) >= 3.1 Then
        'Win 3.1 has a ReplaceItem, which will allow us to replace existing icons
        ErrNr = ProgManCmd("ReplaceItem", PrgName$)
      End If

      If ErrNr = 0 Then
        Par$ = PrgFile$ & Chr$(44) & PrgName$ & Chr$(44) & ",,"
        ErrNr = ProgManCmd("AddItem", Par$)
      End If

    End If
  Case Else
    Call FileError("BadCommand", Cmd$)
    ErrNr = True
  End Select

  ProgMan = ErrNr

End Function

Function ProgManCmd(Cmd$, Par$)

  '--- Programm Manager Befehl ausfuehren ---
  On Error Resume Next

  '--- Set LinkTopic to PROGRAM MANAGER ---
  SetupForm.Label1.LinkTopic = "ProgMan|Progman"
  SetupForm.Label1.LinkMode = 2
  SetupForm.Label1.LinkTimeout = 100

  '--- Execute Command ---
  SetupForm.Label1.LinkExecute "[" & Cmd$ & "(" & Par$ & ")]"

  '--- Reset properties ---
  SetupForm.Label1.LinkTimeout = 50
  SetupForm.Label1.LinkMode = 0

  'Unter OS/2 Programm-Manager nicht gestartet
  If Err = 293 Then
    'siehe VBPJ Nov.96
    void& = Shell(WinDir$ & "PROGMAN.EXE", 7)
  End If


  'Wenn Gruppe neu angelegt wird, wird Fehler beim Loeschen ignoriert
  'Kein Fehler bei ShowGroup, wenn falsche Name des Programm-Manager
  If Err = 285 Then
    Select Case UCase$(Cmd$)
    Case "DELETEGROUP", "REPLACEITEM", "SHOWGROUP"
      Err = 0
    End Select
  End If

  ProgManCmd = Err

  If Err Then Call FileError(Error$, "")

End Function

Sub RestoreProgMan()

  '--- Activate Program Manager ---
  On Error Resume Next
    AppActivate Msg$(11)
  If Err Then Exit Sub

  '--- Send Restore keystrokes ---
  SendKeys "%{ }{Enter}", True

  '--- Show HAMMAP Group ---
  void = ProgManCmd("ShowGroup", AppName$ + ", 1")

End Sub

Function SelectDestination()

  SelectDestination = True

  '--- Pfad eingeben ---
  Load PathDlg

  PathDlg.Caption = App.Title
  PathDlg.Label1.Caption = Msg$(26)
  PathDlg.Label2.Caption = Msg$(27)         'Installieren in:

  PathDlg.Text1.text = StripBackSlash$(DstPath$)
  PathDlg.Text1.SelStart = 0
  PathDlg.Text1.SelLength = Len(defaultText$)
  CenterForm PathDlg

  PathDlg.Show 1

  DstPath$ = PathDlg.Text1.Tag
  Cancel = Val(PathDlg.Tag)
  Unload PathDlg

  If Cancel Then Exit Function

  SelectDestination = False

End Function

Sub SelectLanguage()

  y0 = 200
  dy = 350

  SpeakForm.Tag = Str$(AnzLng)

  For i = 1 To AnzLng
    If i > 1 Then Load SpeakForm.Language(i)
    SpeakForm.Language(i).Top = y0 + (i - 1) * dy
    SpeakForm.Language(i).Visible = True
    SpeakForm.Language(i).Caption = LngName$(i)
  Next i

  SpeakForm.OkCmd.Top = 1.5 * y0 + AnzLng * dy
  Frame = SpeakForm.Height - SpeakForm.ScaleHeight
  SpeakForm.Height = Frame + 5 * y0 + AnzLng * dy
  Call CenterForm(SpeakForm)
  SpeakForm.Language(1).Value = 1
  SpeakForm.Show 1

  LngNr = Val(SpeakForm.Tag)
  Language$ = LngFile$(LngNr)
  Unload SpeakForm

End Sub

Sub ShowCmd(Cmd$)

  If Len(Cmd$) = 0 Then
    SetupForm.Label1.Visible = False
  Else
    SetupForm.Label1.Caption = Cmd$
    Call CenterControl(SetupForm, SetupForm.Label1)
    SetupForm.Label1.Visible = True
  End If
  DoEvents

End Sub

Sub ShowHint()

  MsgBox Msg$(40) + vbCrLf + Msg$(41)

End Sub

Sub ShowTitle(t$)

  'For Message-Boxes
  App.Title = "HAMMAP"

  SetupForm.ScaleMode = 2
  SetupForm.FontSize = 24
  SetupForm.FontBold = True
  SetupForm.FontItalic = True

  SetupForm.CurrentY = 10
  SetupForm.CurrentX = 10

  SetupForm.Print t$

  Call CenterForm(SetupForm)
  SetupForm.Show
  SetupForm.Refresh

End Sub

Function VerCopyFile(Src$, Dst$, Vers$)

'---------------------------------------------------------------
' Copies file SrcFile from HomeDir to DestinationPath.
'
' Returns 0 if it could not find the file, or other runtime
' error occurs.  Otherwise, returns true.
'
' If the source file is older, the function returns success (-1)
' even though no file was copied, since no error occurred.
'---------------------------------------------------------------

  ' ----- VerInstallFile() flags -----
  Const VIFF_FORCEINSTALL% = &H1, VIFF_DONTDELETEOLD% = &H2
  Const OF_DELETE% = &H200
  Const VIF_TEMPFILE& = &H1
  Const VIF_MISMATCH& = &H2
  Const VIF_SRCOLD& = &H4

  Const VIF_DIFFLANG& = &H8
  Const VIF_DIFFCODEPG& = &H10
  Const VIF_DIFFTYPE& = &H20
  Const VIF_WRITEPROT& = &H40
  Const VIF_FILEINUSE& = &H80
  Const VIF_OUTOFSPACE& = &H100
  Const VIF_ACCESSVIOLATION& = &H200
  Const VIF_SHARINGVIOLATION = &H400
  Const VIF_CANNOTCREATE = &H800
  Const VIF_CANNOTDELETE = &H1000
  Const VIF_CANNOTRENAME = &H2000
  Const VIF_CANNOTDELETECUR = &H4000
  Const VIF_OUTOFMEMORY = &H8000

  Const VIF_CANNOTREADSRC = &H10000
  Const VIF_CANNOTREADDST = &H20000

  Const VIF_BUFFTOOSMALL = &H40000

  Dim TmpOFStruct As OFStruct


  VerCopyFile = True

  Call ParseFileSpec(Src$, sd$, sp$, sn$, se$)
  Call ParseFileSpec(Dst$, dd$, dp$, dn$, de$)
  SrcDir$ = sd$ & sp$
  If Len(SrcDir$) = 0 Then SrcDir$ = HomeDir$
  SrcFile$ = sn$ & se$
  DstDir$ = dd$ & dp$
  DstFile$ = dn$ & de$


  '--- Message "Version pruefen" ---
  m$ = Msg$(20) + vbCrLf + UCase$(Src$) + vbCrLf
  m$ = m$ + Msg$(21) + vbCrLf + UCase$(Dst$)
  Call ShowCmd(m$)


  '--- Version der Eingabedatei pruefen ---
  InFileVer$ = Parse$(Vers$, ",")
  InFileLng$ = Vers$

  If Len(InFileVer$) = 0 Then InFileVer$ = GetFileVersion(Src$)
  If Len(InFileLng$) = 0 Then InFileLng$ = GetFileLanguage(Src$)

  If Len(InFileVer$) > 0 Then
    ErrNr = WriteSetupLog("  SrcVer = " & InFileVer$)
    If ErrNr Then Exit Function
  End If
  If Len(InFileLng$) > 0 Then
    ErrNr = WriteSetupLog("  SrcLng = " & InFileLng$)
    If ErrNr Then Exit Function
  End If


  '--- Pruefen, ob aeltere Version in C:\WINDOWS ---
  If WinSysDir$ <> WinDir$ Then
    WinDst$ = WinDir$ & DstFile$
    ErrNr = ExistFile(WinDst$, False, Exist)
    If ErrNr Then Exit Function
    If Exist Then
      OutFileVer$ = GetFileVersion(WinDst$)
      OutFileLng$ = GetFileLanguage(WinDst$)
      If InFileVer$ > OutFileVer$ Then
        ErrNr = WriteSetupLog("  WinVer = " & OutFileVer$)
        If ErrNr Then Exit Function
        ErrNr = WriteSetupLog("  WinLng = " & OutFileLng$)
        If ErrNr Then Exit Function
        Screen.MousePointer = 0
        m$ = Replace$(Msg$(29), "%", WinDir$)
        MsgBox Replace$(m$, "#", UCase$(dn$ & de$)), 48
        Screen.MousePointer = 11
      End If
    End If
  End If


  '--- Version der Ausgabedatei pruefen, falls vorhanden ---
  ErrNr = ExistFile(Dst$, False, Exist)
  If ErrNr Then Exit Function
  If Exist Then
    If Len(InFileVer$) > 0 Then
      OutFileVer$ = GetFileVersion(Dst$)
      OutFileLng$ = GetFileLanguage(Dst$)
      If Len(OutFileVer$) > 0 Then
        ErrNr = WriteSetupLog("  DstVer = " & OutFileVer$)
        If ErrNr Then Exit Function
        ErrNr = WriteSetupLog("  DstLng = " & OutFileLng$)
        If ErrNr Then Exit Function

        If InFileVer$ <= OutFileVer$ Then
          ' Don't install older or same version of file
          ErrNr = WriteSetupLog("  not installed")
          If ErrNr Then Exit Function
          VerCopyFile = False
          Exit Function
        End If
      End If
    End If
  End If


  ' VerInstallFile installs the file. We need to initialize
  ' some arguments for the temp file that is created by the call
  CurrDir$ = String$(255, 0)
  TmpFile$ = String$(255, 0)
  lpwTempFileLen% = 255


TryToCopyAgain:

  '--- Message "Kopieren" ---
  m$ = Msg$(14) + vbCrLf + UCase$(Src$) + vbCrLf
  m$ = m$ + Msg$(15) + vbCrLf + UCase$(Dst$)
  Call ShowCmd(m$)


  '--- Kopieren ---
  Result& = VerInstallFile&(0, SrcFile$, DstFile$, SrcDir$, DstDir$, CurrDir$, TmpFile$, lpwTempFileLen%)


  '--------------------------------
  ' There are many return values that you can test for.
  ' The constants are listed above.
  ' The following lines of code return will set the Function to
  ' False if the VerInstallFile call was successful.
  '
  ' If the call was unsuccessful due to a different language on the
  ' users machine, VerInstallFile is called again to force installation.
  ' You can change this to not install if you choose.
  ' Be careful about using FORCEINSTALL.  Other flags could be
  ' set which indicate that this file should not be overridden.
  '
  ' Under any other circumstance, the tempfile created by VerInstallFile
  ' is removed using OpenFile and the VerCopyFile function returns true.
  '--------------------------------------------------------

  If Result& = 0 Or (Result& And VIF_SRCOLD&) = VIF_SRCOLD& Then
    'Das neue File ist lter als das alte File -> ok
    ErrNr = WriteSetupLog("  installed")
    If ErrNr Then Exit Function
    VerCopyFile = False

  ElseIf (Result& And VIF_DIFFLANG&) = VIF_DIFFLANG& Then
    'Files haben verschiedene Sprache
    ErrNr = WriteSetupLog("  different languages")
    If ErrNr Then Exit Function
    If MsgBox(DestFileNam$ & Msg$(25), 4 + 32 + 256) = 6 Then
      'Backup machen
      Backup$ = Left$(Dst$, Len(Dst$) - 4) + ".BAK"
      On Error Resume Next
      FileCopy Dst$, Backup$
      On Error GoTo 0
      'Aenderung wird erzwungen
      Result& = VerInstallFile&(VIFF_FORCEINSTALL%, SrcFile$, DstFile$, HomeDir$, DstDir$, CurrDir$, TmpFile$, lpwTempFileLen%)
      ErrNr = WriteSetupLog("  installed")
      If ErrNr Then Exit Function
    Else
      ErrNr = WriteSetupLog("  not installed")
      If ErrNr Then Exit Function
      Incomplete = True
    End If
    VerCopyFile = False

  ElseIf (Result& And VIF_WRITEPROT&) = VIF_WRITEPROT& Then
    'Destination File is Write-Protected
    ErrNr = WriteSetupLog("  write-protected - not installed")
    If ErrNr Then Exit Function
    MsgBox DstFile$ & " " & Msg$(24), 48
    VerCopyFile = True
    'Result& = VerInstallFile&(VIFF_FORCEINSTALL%, SrcFile$, DstFile$, HomeDir$, WinSysDir$ + "\", CurrDir$, TmpFile$, lpwTempFileLen%)
    'VerCopyFile = False

  'ElseIf (Result& And VIF_CANNOTREADSRC) = VIF_CANNOTREADSRC Then
    ' VerInstallFile does will not handle compressed files that have been split.
    ' Use VB's FileCopy stmt
    'FileCopy Src$, Dst$
    'VerCopyFile = False

  ElseIf (Result& And VIF_FILEINUSE&) = VIF_FILEINUSE& Then

    '--- File is in use ---
    If UCase$(DstFile$) = "DDEML.DLL" Then
      'DDEML is used by SETUP, it cannot be replaced
      MsgBox Replace$(Msg$(28), "%", DstDir$), 48
      ErrNr = WriteSetupLog("  File in use - not installed")
      If ErrNr Then Exit Function

      Incomplete = True
      VerCopyFile = False

    Else

      x% = MsgBox(DstFile$ & " " & Msg$(23), 34)
      If x% = 3 Then          'Abort
        ErrNr = WriteSetupLog("  File in use - not installed/aborted")
        If ErrNr Then Exit Function
        VerCopyFile = True
      ElseIf x% = 4 Then      'Retry
        ErrNr = WriteSetupLog("  File in use - not installed/Retry")
        If ErrNr Then Exit Function
        GoTo TryToCopyAgain
      ElseIf x% = 5 Then      'Ignore
        ErrNr = WriteSetupLog("  File in use - /not installed/ignored")
        If ErrNr Then Exit Function
        Incomplete = True
        VerCopyFile = False
      End If
    End If

  Else

    '--- Datei nicht installiert ---
    MsgBox Msg$(16) + " " + DstFile$
    ErrNr = WriteSetupLog("  not installed")
    If ErrNr Then Exit Function
    VerCopyFile = True

  End If

  If (Result& And VIF_TEMPFILE&) = VIF_TEMPFILE& Then
    copyresult% = WinOpenFile(TmpFile$, TmpOFStruct, OF_DELETE%)
  End If

End Function

