Attribute VB_Name = "StnCvIni"
'--------------------------- STNCVTUP.BAS ------------------------------

'Unterprogramme zum HAMMAP Stations-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function InitConvert(InfoNr)

  InfoNr = 27000

  MsgList$ = "DOS,HMSUB,STNCVT,CONVERT,MAP,STN,GEO"
  InitConvert = InitHmTool("STNCVT", MsgList$)

End Function

Sub InitParameter()

  '--- numerische Parameter setzen ---
  '!!! Achtung: Bei Bit-Parametern (CheckBoxMask) muss NumPar.Max = 0 sein !!!
  '!!! Achtung: Unbenutzte Labels muessen geloescht werden:
  '    NumPar(...).Label = ""

  Dim a As lAreaType

  ReDim NumPar(1 To 8) As NumParType

  Call InitNumPar(1, "LoadMode", 0&, 0&, 0&)
  Call InitNumPar(2, "Filter", 0&, 0&, 0&)
  Call InitNumPar(3, "GeoCoord", 2&, 0&, 2&)    'Grad:Min:Sec
  Call InitNumPar(4, "TextFormat", 1&, 0&, 0&)
  Call InitNumPar(5, "DataFormat", 128&, 0&, 0&)
  Call InitNumPar(6, "AddLines", -1&, 0&, 0&)
  Call InitNumPar(7, "ErrorLevel", 0&, 0&, 0&)

  NumPar(8).Label = ""


  '--- String-Parameter setzen ---
  'Index 1: 1 = Name, 2 = Default, 3 = Actual, 4 = MultiLine
  'Index 2: Anzahl Parameter
  ReDim StrPar(1 To 4, 1 To 9) As String

  'Reihenfolge 1...4 = CvtForm.FileField() !!! (nicht aendern)
  Call InitStrPar(1, "InputFile", "", "+")
  Call InitStrPar(2, "OutBinFile", "", "")
  Call InitStrPar(3, "OutTxtFile", "", "")
  Call InitStrPar(4, "OutLogFile", "", "")

  Call InitStrPar(5, "TempFile", "~HMCVT~~.BSD", "")
  Call InitStrPar(6, "Include", "", "")
  Call InitStrPar(7, "Exclude", "", "")

  Call InitStrPar(8, "Version", "", "")

  Call SetWorldArea(a)
  Call InitStrPar(9, "MapArea", lArea2Str$(a), "")

End Sub

Sub OptionsFunctions(Index)

  Title$ = StdMsg$(27200 + Index)

  Select Case Index
  Case 1, 2             'Standard-Werte
    For i = 1 To UBound(NumPar)
      NumPar(i).Actual = NumPar(i).Default
    Next i

    For i = 1 To UBound(StrPar, 2)
      StrPar(3, i) = StrPar(2, i)
    Next i

    If Index = 2 Then
      'NumPar(5).Actual = 4        'DataFormat
      NumPar(6).Actual = &H7F     'AddLines
      NumPar(7).Actual = &HFBF&   'ErrorLevel
    End If

  Case 4                'Datenformat
    Title$ = Title$ + "  " + Msg$(27219)
    Cancel = CheckBoxMask(Title$, 27220, 0, NumPar(5).Actual, 0&, Change&)

  Case 5                'Textformat
    Cancel = CheckBoxMask(Title$, 27235, 0, NumPar(4).Actual, 0&, Change&)

  Case 6                'Zusatzzeilen
    Cancel = CheckBoxMask(Title$, 27240, 0, NumPar(6).Actual, 0&, Change&)

  Case 7                'Fehlerpruefung
    Cancel = CheckBoxMask(Title$, 27260, 0, NumPar(7).Actual, 0&, Change&)


  Case 8                'Anzeige
    ErrNr = InitMaskData(2, Title$, "")
    If ErrNr Then Exit Sub

    'Grad:Min:Sek
    Call SetMaskData(1, Msg$(40104), CStr(NumPar(3).Actual), "@40040", "", "")      'Geogr.Koordinaten
    'DOS: 3D-Effekt
    Call SetMaskData(2, Msg$(29200), CStr(NumPar(8).Actual), "@29201", "", "")

    Cancel = GetMaskInput(0, Change&)

    If Not Cancel Then
      NumPar(3).Actual = Val(GetMaskData(1))
      NumPar(8).Actual = Val(GetMaskData(2))
    End If

    Call EraseMaskData


  Case 9                'Speicherverwendung
    Cancel = CheckBoxMask(Title$, 27280, 0, NumPar(1).Actual, 0&, Change&)

  Case 10               'Temporaere Dateien
    f$ = GetFileFilter$(1)
    Files$ = StrPar(3, 5)

    'Flags: PathMustExist + NoChangeDir + HideReadOnly
    Cancel = GetFileSpec(Title$, 2, &H80C&, HomeDir$, "BSD", f$, Files$)
    If Cancel Then Exit Sub

    StrPar(3, 5) = Files$


  Case 12               'Filter
    Title$ = Title$ + "  " + Msg$(27219)
    Cancel = CheckBoxMask(Title$, 27290, 0, NumPar(2).Actual, 0&, Change&)

  Case 13               'Include
    Default$ = StrPar(3, 6)
    Cancel = GetInput(Title$, Msg$(31015), Default$, InpLine$)
    If Cancel Then Exit Sub
    StrPar(3, 6) = InpLine$

  Case 14               'Exclude
    Default$ = StrPar(3, 7)
    Cancel = GetInput(Title$, Msg$(31015), Default$, InpLine$)
    If Cancel Then Exit Sub
    StrPar(3, 7) = InpLine$

  Case 15               'Area
    GrdMinSec = NumPar(3).Actual + 1   'Grad:Min:Sek
    Cancel = GetAreaLimits(Title$, SV.lParArea, dummyAreaName$, GrdMinSec, Change&)
    If Cancel Then Exit Sub
    StrPar(3, 9) = lArea2Str$(SV.lParArea)

  End Select

  Call SetParameter

End Sub

Sub SetParameter()

  'NumPar(1) siehe AllocMem()

  SV.TxtFmt = NumPar(4).Actual
  SV.DataFormat = NumPar(5).Actual
  SV.AddLines = NumPar(6).Actual
  SV.ErrorLevel = NumPar(7).Actual

  'Abbruch bei Fehler (0 = Batch-Betrieb)
  SV.ErrorExit = (NumPar(7).Actual And 64) <> 0


  '--- Kartenbereich ---
  ErrNr = Str2lArea(StrPar(3, 9), SV.lParArea)
  If IsNullArea(SV.lParArea) Then Call SetWorldArea(SV.lParArea)
  Call lArea2QthArea(SV.lParArea, SV.iParArea)     '/75


  '--- Anzeige ---


  '--- Liste fuer Include/Exclude definieren ---
  For Pass = 1 To 2
    Inc$ = UCase$(StrPar(3, 6))
    AnzInc = 0
    Do Until Len(Inc$) = 0
      s$ = Parse$(Inc$, ",")
      If Len(s$) > 0 Then
        AnzInc = AnzInc + 1
        If Pass = 2 Then IncList$(AnzInc) = s$
      End If
    Loop

    Exc$ = UCase$(StrPar(3, 7))
    AnzExc = 0
    Do Until Len(Exc$) = 0
      s$ = Parse$(Exc$, ",")
      If Len(s$) > 0 Then
        AnzExc = AnzExc + 1
        If Pass = 2 Then ExcList$(AnzExc) = s$
      End If
    Loop

    If Pass = 1 Then
      If AnzInc > 0 Then ReDim IncList$(1 To AnzInc)
      If AnzExc > 0 Then ReDim ExcList$(1 To AnzExc)
    End If

  Next Pass


  '--- Versionen ---
  If StrPar(3, 8) <> Version$ Then
    If Len(StrPar(3, 8)) = 0 Then
      'alte Version vor V10.2
      NumPar(8).Actual = NumPar(8).Default      'DOS: 3D-Effekt
      NumPar(3).Actual = NumPar(3).Default
    End If

    StrPar(3, 8) = Version$
    m$ = Params2Str$(False)
    void = WriteParameter(InParFile$, "[" + ProgName$ + "]", m$)
  End If

End Sub

