Attribute VB_Name = "STNCVT"
'--------------------------- STNCVT.BAS ------------------------------

'Unterprogramme zum HAMMAP Stations-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM

DefInt A-Z


Function AllocMem()

  '---------- Speicher reservieren ----------

  AllocMem = True

  'Index-Arrays muessen im Speicher sein (wegen Verschiebung)
  'MaxAnz + 1, fuer Header und damit bei MaxAnz = 0 kein Fehler

  SV.StnDataLoaded = (NumPar(1).Actual And 1) <> 0
  SV.StnIdxLoaded = True
  SV.StnCallsLoaded = True
  SV.StnQthLoaded = False
  SV.LnkDataLoaded = (NumPar(1).Actual And 2) <> 0
  SV.LnkIdxLoaded = True
  SV.LnkStnPtrLoaded = Not SV.LnkDataLoaded

  SV.MaxAnzStn = SV.MaxAnzStn + 1
  SV.MaxAnzLnk = SV.MaxAnzLnk + 1

  On Local Error Resume Next

  'Stations-Index
  If SV.StnIdxLoaded Then
    ReDim StnIdxTbl(1 To SV.MaxAnzStn) As Integer
  End If

  'Link-Index
  If SV.LnkIdxLoaded Then
    ReDim LnkIdxTbl(1 To SV.MaxAnzLnk) As Integer
  End If

  ErrNr = Err
  On Local Error GoTo 0

  If ErrNr Then
    Call ShowErrNr(25037)
    Exit Function
  End If


  '--- Stations-Tabelle ---
  If SV.StnDataLoaded Then
    On Local Error Resume Next
    ReDim StnTbl(1 To SV.MaxAnzStn) As StationData
    ErrNr = Err
    On Local Error GoTo 0

    If ErrNr Then
      ErrNr = ConvertError(Msg$(31033))
      If ErrNr Then Exit Function
      SV.StnDataLoaded = 0
    End If
  End If


  '--- Wenn Stationsdaten nicht geladen wurden -> Calls bzw. Qth laden ---
  If SV.StnDataLoaded Then
    SV.StnCallsLoaded = 0
    SV.StnQthLoaded = 0
  Else
    On Local Error Resume Next

    'Stations-Calls
    If SV.StnCallsLoaded Then
      ReDim StnCallTbl(1 To SV.MaxAnzStn) As StationCall
    End If

    'Stations-Qth
    If SV.StnQthLoaded Then
      ReDim StnQthTbl(1 To SV.MaxAnzStn) As Koordinate
    End If

    ErrNr = Err
    On Local Error GoTo 0

    If ErrNr Then
      Call ShowErrNr(25037)
      Exit Function
    End If
  End If


  '--- Link-Tabelle ---
  If SV.LnkDataLoaded Then
    On Local Error Resume Next
    ReDim LnkTbl(1 To SV.MaxAnzLnk) As LinkData
    ErrNr = Err
    On Local Error GoTo 0

    If ErrNr Then
      ErrNr = ConvertError(Msg$(31034))
      If ErrNr Then Exit Function
      SV.LnkDataLoaded = 0
    End If
  End If


  '--- Link-Stations-Pointer ---
  If SV.LnkDataLoaded = 0 Then

    On Local Error Resume Next

    If SV.LnkStnPtrLoaded Then
      ReDim LnkStnPtrTbl(1 To SV.MaxAnzLnk) As StationPointers
    End If

    ErrNr = Err
    On Local Error GoTo 0

    If ErrNr Then
      Call ShowErrNr(25037)
      Exit Function
    End If
  End If

  AllocMem = False

End Function

Function ClearData()

  ClearData = True

  OutLnkFileSpec$ = ""

  '--- Stationsdaten initialisieren ---
  Call InitStnData
  SV.MaxAnzStn = 0
  SV.MaxAnzLnk = 0


  '---------- Daten initialisieren ----------
  ReDim StnAbv(1 To 6) As String
  ReDim AnzStnAbv(1 To 6) As Integer

  '--- Abkuerzungen ---
  For i = 1 To UBound(StnAbv)
    StnAbv(i) = Msg$(31100 + i)
    AnzStnAbv(i) = Len(StnAbv(i)) / 3
  Next i

  ClearData = False

End Function

Function ConvertAllFiles(AnzFiles, InputFile$(), OutputFile$())

  ConvertAllFiles = True

  '--- Maximale Anzahl Stationen / Links bestimmen ---
  For IsFile = 1 To AnzFiles
    Screen.MousePointer = 11
    ErrNr = CalcMaxRec(InputFile$(IsFile))
    Screen.MousePointer = 0
    If ErrNr Then Exit Function
  Next IsFile


  '--- Speicher reservieren ---
  ErrNr = AllocMem()
  If ErrNr Then Exit Function


  '------ Temporaere Binaer-Ausgabedateien oeffnen ---------

    '--- Evtl. geoeffnete Dateien schliessen ---
  void = CloseStnBinFiles(SV.Out)

  If Len(OutputFile$(1)) > 0 Then
    '--- Pfad fuer Temp-File bestimmen ---
    'Wenn Ausgabe-Datei definiert, gleichen Pfad verwenden
    '  fuer spaeteres Rename
    Call ParseFileSpec(OutputFile$(1), d$, p$, f$, e$)
    TmpFile$ = d$ + p$ + "~HMCVT~~"
  Else
    TmpFile$ = StripExt$(StrPar(3, 5))
  End If

  ErrNr = OpenOutBinFiles(TmpFile$)
  If ErrNr Then Exit Function


  '--- Datei(en) konvertieren ---
  For IsFile = 1 To AnzFiles
    Screen.MousePointer = 11
    ErrNr = ConvertFile(InputFile$(IsFile))
    Screen.MousePointer = 0
    If ErrNr Then Exit Function
  Next IsFile


  '--- Text-Dateien ausgeben ---
  If Len(OutputFile$(2)) > 0 Then
    ErrNr = WriteOutTextFiles(OutputFile$(2))
    If ErrNr Then Exit Function
  End If


  '--- Header auf Binaer-Datei ausgeben ---
  ErrNr = PutStnHeader()
  If ErrNr Then Exit Function


  '--- Binaer-Dateien schliessen ---
  'Duerfen erst nach Ausgabe der Text-Dateien geschlossen werden
  ErrNr = CloseStnBinFiles(SV.Out)
  If ErrNr Then Exit Function


  If Len(OutputFile$(1)) = 0 Then

    '--- Keine Binaer-Ausgabe -> Temp-Files loeschen ---
    ErrNr = DeleteStnBinFiles(TmpFile$)
    If ErrNr Then Exit Function

  Else

    OutBinFile$ = StripExt$(OutputFile$(1))

    '--- Evtl. vorhandene alte Dateien loeschen ---
    ErrNr = DeleteStnBinFiles(OutBinFile$)
    If ErrNr Then Exit Function

    '--- Binaer-Ausgabe definiert -> Temp-Dateien umbenennen ---
    For i = 1 To 2
      Ext$ = SV.BinExt(i)
      ErrNr = RenameFile(TmpFile$ + Ext$, OutBinFile$ + Ext$)
      If ErrNr Then Exit Function
    Next i

    If SV.Out.StnHdr.AnzLnkRec = 1 Then
      '--- keine Links vorhanden -> Link-Datei loeschen ---
      ErrNr = DeleteFile(TmpFile$ + ".BLD", Found)
      If ErrNr Then Exit Function
    Else
      ErrNr = RenameFile(TmpFile$ + ".BLD", OutBinFile$ + ".BLD")
      If ErrNr Then Exit Function
    End If
  End If

  ConvertAllFiles = False

End Function

Function ConvertFile(FileSpec$)

  ConvertFile = True

  Call ParseFileSpec(FileSpec$, d$, p$, n$, FileExt$)
  BinFile$ = d$ + p$ + n$

  Select Case FileExt$
  Case ".BSD"

    '-------- Binaer-Dateien konvertieren --------

    '--- Dateien oeffnen ---
    ErrNr = OpenStnInBinFiles(BinFile$, SV.In)
    If ErrNr Then Exit Function

    '--- Dateinamen auf Logfile ausgeben ---
    ErrNr = WriteLog(vbCrLf + Msg$(27001), 3)
    If ErrNr Then Exit Function

    For i = 1 To 2
      ErrNr = WriteLog("    " + BinFile$ + SV.BinExt(i), 3)
      If ErrNr Then Exit Function
    Next i

    If SV.In.BldFile Then
      ErrNr = WriteLog("    " + BinFile$ + ".BLD", 3)
      If ErrNr Then Exit Function
    End If

    '--- Datei konvertieren ---
    ErrNr = ConvertStnBinFile()
    If ErrNr Then Exit Function

    '--- Datei schliessen ---
    ErrNr = CloseStnBinFiles(SV.In)
    If ErrNr Then Exit Function


  Case ".STN", ".UPD", ".PRL"

    '-------- Text-Datei konvertieren --------

    '--- Dateinamen auf Logfile ausgeben ---
    Select Case FileExt$
    Case ".STN"
      MsgNr = 27002
    Case ".UPD"
      MsgNr = 27004
    Case ".PRL"
      MsgNr = 27007
    End Select

    ErrNr = WriteLog(vbCrLf + Msg$(MsgNr), 3)
    If ErrNr Then Exit Function
    ErrNr = WriteLog("    " + FileSpec$, 3)
    If ErrNr Then Exit Function

    '--- Datei oeffnen ---
    ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
    If ErrNr Then Exit Function

    '--- Datei konvertieren ---
    ErrNr = ConvertStnTextFile(FileNr, FileExt$)
    If ErrNr Then Exit Function

    '--- Datei schliessen ---
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function


    '-------- Ggf. Link-Text-Datei konvertieren --------

    If FileExt$ = ".STN" Then

      FileSpec$ = d$ + p$ + n$ + ".LNK"
      ErrNr = ExistFile(FileSpec$, False, Exist)
      If ErrNr Then Exit Function

      If Exist Then

        '--- Dateinamen auf Logfile ausgeben ---
        ErrNr = WriteLog(vbCrLf + Msg$(27003), 3)
        If ErrNr Then Exit Function
        ErrNr = WriteLog("    " + FileSpec$, 3)
        If ErrNr Then Exit Function

        '--- Datei oeffnen ---
        ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
        If ErrNr Then Exit Function

        '--- Datei konvertieren ---
        ErrNr = ConvertStnTextFile(FileNr, ".LNK")
        If ErrNr Then Exit Function

        '--- Datei schliessen ---
        ErrNr = CloseFile(FileNr)
        If ErrNr Then Exit Function

      End If
    End If

  End Select

  ConvertFile = False

End Function

Function ConvertStnBinFile()

  Static Stn As StationData
  Static Lnk As LinkData

  ConvertStnBinFile = True

  'Hinweis, wenn Daten modifiziert
  If SV.In.StnHdr.Modified Then
    Answer = MsgBox(Msg$(27012), 1)
    If Answer = 2 Then Exit Function
  End If

  If SV.Out.StnHdr.AnzStnRec = 1 Then

    '-------------- Erste Datei uebernehmen --------------

    '--- Stations-Daten einlesen und auf Temp-Datei ausgeben ---
    ShowStep = SV.In.StnHdr.AnzStnRec \ 50
    If ShowStep = 0 Then ShowStep = 1
    void = ShowComplete(0&, CLng(ShowStep * 50), SV.In.BsdFile, 29103)

    SV.Out.StnHdr.AnzStnRec = 1

    For RecNr = 2 To SV.In.StnHdr.AnzStnRec

      '--- Daten von Disk einlesen ---
      ErrNr = InputStationData(SV.In.BsdFile, RecNr, Stn)
      If ErrNr Then Exit For

      '--- Daten in RAM und auf Disk ausgeben ---
      ErrNr = PutStationData(SV.Out.BsdFile, RecNr, Stn)
      If ErrNr Then Exit For

      '--- Index aktualisieren ---
      If SV.StnIdxLoaded Then
        ErrNr = AddStnIdx(Stn.StnCall, IdxRecNr, Found, Deleted)
        If ErrNr Then Exit For
      End If

      SV.Out.StnHdr.AnzStnRec = SV.Out.StnHdr.AnzStnRec + 1

      If RecNr Mod ShowStep = 0 Then
        ErrNr = ShowComplete(CLng(RecNr), 0&, 0, 0)
        If ErrNr Then Exit For
      End If
    Next RecNr

    void = ShowComplete(-1&, 0&, 0, 0)
    If ErrNr Then Exit Function


    '-------- Falls vorhanden, Linkdaten kopieren --------
    If SV.In.BldFile > 0 Then

      ShowStep = SV.In.StnHdr.AnzLnkRec \ 50
      If ShowStep = 0 Then ShowStep = 1
      void = ShowComplete(0&, CLng(ShowStep * 50), SV.In.BldFile, 29103)

      SV.Out.StnHdr.AnzLnkRec = 1

      For RecNr = 2 To SV.In.StnHdr.AnzLnkRec

        '--- Daten von Disk einlesen ---
        ErrNr = InputLinkData(SV.In.BldFile, RecNr, Lnk)
        If ErrNr Then Exit For

        '--- Daten in RAM und auf Disk ausgeben ---
        ErrNr = PutLinkData(SV.Out.BldFile, RecNr, Lnk)
        If ErrNr Then Exit For

        '--- Index aktualisieren ---
        If SV.LnkIdxLoaded Then
          ErrNr = GetLinkCalls(RecNr, ActLnkCall(1), ActLnkCall(2))
          If ErrNr Then Exit For

          ErrNr = AddLnkIdx(ActLnkCall(), IdxRecNr, Found, Deleted)
          If ErrNr Then Exit Function
        End If

        SV.Out.StnHdr.AnzLnkRec = SV.Out.StnHdr.AnzLnkRec + 1

        If RecNr Mod ShowStep = 0 Then
          ErrNr = ShowComplete(CLng(RecNr), 0&, 0, 0)
          If ErrNr Then Exit For
        End If
      Next RecNr

      void = ShowComplete(-1&, 0&, 0, 0)
      If ErrNr Then Exit Function

    End If


    '--- Stations-Texte kopieren (ShowComplete in CopyFileSection) ---
    ErrNr = CopyFileSection(SV.In.BstFile, SV.Out.BstFile, LOF(SV.In.BstFile) - 6)
    If ErrNr Then Exit Function


    '--- Header kopieren ---
    SV.Out.StnHdr = SV.In.StnHdr
    ' SV.Out.StnHdr.AnzRefErr = 0

  Else

    ErrNr = WriteLog(vbCrLf + Msg$(27006), 3)
    Exit Function                                'noch nicht implementiert

  End If

  ConvertStnBinFile = False

End Function

Function ConvertStnTextFile(FileNr, FileExt$)

  ErrNr = 0

  ShowStep& = LOF(FileNr) \ 50
  NextShow& = ShowStep&
  void = ShowComplete(0&, ShowStep& * 50, FileNr, 29104)

  Do

    '--- Zeile einlesen ---
    Do
      'Dateiende
      EndOfFile = EOF(FileNr)
      If EndOfFile Then Exit Do

      ErrNr = ReadLine(FileNr, InpLine$)
      If ErrNr Then Exit Do

      Actual& = Actual& + Len(InpLine$) + 2

      l$ = Left$(InpLine$, 1)
      If l$ = ";" Or l$ = "#" Then
        If Mid$(InpLine$, 2, 1) = "$" Then
          'Update-Info aus Hot Comment:
          '  #$ Update = nn, jjmm
          InpLine$ = UCase$(Mid$(InpLine$, 3))
          ErrNr = WriteLog(InpLine$, 3)
          If ErrNr Then Exit Do
          Updat$ = Parse$(InpLine$, ",")
          SV.Out.StnHdr.Date = Str2Long(InpLine$)
          InpLine$ = Parse$(Updat$, "=")
          SV.Out.StnHdr.Upd = Val(Updat$)
        End If
        InpLine$ = ""
      End If

    Loop While Len(InpLine$) = 0

    If EndOfFile Or ErrNr <> 0 Then Exit Do

'void = Writelog(InpLine$, 3)           'Debug

    '--- TAB's in Leerzeichen umwandeln ---
    InpLine$ = Replace$(InpLine$, Chr$(9), " ")


    '--- Befehl festlegen ---
    Select Case FileExt$
    Case ".STN"                                       'Stations-Datei
      Cmd$ = "AS"
    Case ".LNK"                                       'Link-Datei
      Cmd$ = "AL"
    Case ".UPD"                                       'Update-Datei
      Cmd$ = UCase$(Parse$(InpLine$, ":"))
    Case ".PRL"                                       'PrListe-Datei
      Cmd$ = "AS"
      InpLine$ = Prl2Hm$(InpLine$)                    'Zeile konvertieren
    Case Else
      Stop
    End Select


    '--- Zeile in Felder zerlegen ---
    Select Case Cmd$
    Case "AS", "MS", "US"
      ErrNr = ParseLine(1, InpLine$, SF$(), AnzStnFields, AnzStnFields)
    Case "DS"                                     'Delete Station
      If InStr(InpLine$, ",") = 0 Then
        InpLine$ = InpLine$ + ",0"
      End If
      ErrNr = ParseLine(1, InpLine$, SF$(), 2, 3)
    Case "AL", "ML", "UL"
      ErrNr = ParseLine(-1, InpLine$, LF$(), AnzLnkFields, AnzLnkFields)
    Case "DL"                                     'Delete Link
      ErrNr = ParseLine(-1, InpLine$, LF$(), 2, 3)
    Case Else
      ErrNr = WriteLog(Msg$(27010) + ": '" + Cmd$ + "'", 3)
    End Select

    If ErrNr Then Exit Do


    '--- Zeile verarbeiten ---
    Select Case Cmd$
    Case "AS", "MS", "DS", "US"
      If CheckIncStn(UCase$(SF$(1))) Then
        ErrNr = ProcessStation(Cmd$, void)
      End If

    Case "AL", "ML", "DL", "UL"
      If CheckIncStn(UCase$(LF$(1))) Then
        If CheckIncStn(UCase$(LF$(2))) Then
          ErrNr = ProcessLink(Cmd$)
        End If
      End If
    Case Else
      ErrNr = SV.ErrorExit
    End Select

    If ErrNr Then Exit Do


    '--- % fertig anzeigen ---
    If Actual& >= NextShow& Then
      ErrNr = ShowComplete(NextShow&, 0&, 0, 0)
      If ErrNr Then Exit Do
      NextShow& = NextShow& + ShowStep&
    End If

  Loop

  void = ShowComplete(-1&, 0&, 0, 0)

  ConvertStnTextFile = ErrNr

End Function

Function ParseLine(Mode, InpLine$, Field$(), MinFields, MaxFields)

  '--- Eingabezeile in Felder zerlegen ---

  'Rueckkgabewert (ErrNr) wird durch SV.ErrorExit und StnLnkError gesteuert

  ParseLine = True

  Start = 1
  LineLength = Len(InpLine$)


  '--- Zeile in Felder zerlegen ---
  Do
    Comma = InStr(Start, InpLine$, ",")
    If Comma = 0 Then Comma = LineLength + 1
    AnzFields = AnzFields + 1
    If AnzFields <= MaxFields Then
      Field$(AnzFields) = LTrim$(RTrim$(Mid$(InpLine$, Start, Comma - Start)))
    End If
    If Comma > LineLength Then Exit Do        'Letztes Feld
    Start = Comma + 1
  Loop

  '--- Fehlende Felder loeschen ---
  For i = AnzFields + 1 To MaxFields
    Field$(i) = ""
  Next i

  '--- Fehler, wenn zu wenig oder zu viel Felder ---
  If AnzFields < MinFields Or AnzFields > MaxFields Then
    If AnzFields = 14 And MaxFields = 13 And (NumPar(5).Actual And 1024) <> 0 Then
      'Im Info-Feld ',' durch ';' ersetzen
      m$ = Rpad$(SF$(1), 9) + ", " + Rpad$(SF$(2), 1) + ": "
      m$ = m$ & Msg$(27017) & Quotes$(Field$(13) & "," & Mid$(InpLine$, Start))
      m$ = m$ & " - " & Msg$(27016)
      ErrNr = WriteLog(m$, 3)
      Field$(13) = Field$(13) & ";" & Mid$(InpLine$, Start)
    Else
      ErrNr = StnLnkError(Mode, 27011, "")
    End If
    If ErrNr Then Exit Function
  End If

  ParseLine = False

End Function

Function StnLnkError(Mode, MsgNr, ErrField$)

  'Mode:           Station    Link
  'Format-Fehler       1       -1
  'Referenz-Fehler     2       -2
  'Datums-Fehler       3       -3

  If Mode > 0 Then
    If Len(SF$(1)) > 0 Then
      If Len(SF$(1)) > 9 Then SF$(1) = Left$(SF$(1), 9)
      m$ = Rpad$(SF$(1), 9) + ", " + Rpad$(SF$(2), 1) + ": "
    End If
  Else
    If Len(LF$(1)) > 0 Then
      m$ = Rpad$(LF$(1), 9) + ", " + Rpad$(LF$(2), 9) + ": "
    End If
  End If

  m$ = m$ + Msg$(MsgNr)
  If Len(ErrField$) > 0 Then m$ = m$ + Quotes$(ErrField$)

  ErrNr = ConvertError(m$)


  Select Case Abs(Mode)
  Case 1
    '--- Format-Fehler ---
    SV.Out.StnHdr.AnzFmtErr = SV.Out.StnHdr.AnzFmtErr + 1
  Case 2
    '--- Referenz-Fehler ---
    If SV.ErrorLevel And 128 Then
      SV.Out.StnHdr.AnzFmtErr = SV.Out.StnHdr.AnzFmtErr + 1
    Else
      MsgNr = 0
    End If
    SV.Out.StnHdr.AnzRefErr = SV.Out.StnHdr.AnzRefErr + 1
  Case 3
    '--- Datums-Fehler ---
    If SV.ErrorLevel And 256 Then
      SV.Out.StnHdr.AnzFmtErr = SV.Out.StnHdr.AnzFmtErr + 1
    Else
      MsgNr = 0
    End If
    SV.Out.StnHdr.AnzDateErr = SV.Out.StnHdr.AnzDateErr + 1
  End Select

  If ErrNr = 0 And SV.ErrorExit Then
    StnLnkError = MsgNr
  Else
    StnLnkError = ErrNr
  End If

End Function

Sub UpdateFunctions(Index)

  '--- Home-Directory wieder herstellen ---
  ErrNr = ChangePath(HomeDir$)
  If ErrNr Then Exit Sub

  Select Case Index
  Case 1
    Call UpdateCommand
  Case 2
    Call RestoreCommand
  Case 3
    Call DeleteUpdateCommand

  End Select

End Sub

