Attribute VB_Name = "StnCvtUp"
'--------------------------- STNCVTUP.BAS ------------------------------

'Unterprogramme zum HAMMAP Stations-Konvertierungs-Programm
'von Gerhard Berg, DJ6FM

DefInt A-Z

Function CalcMaxRec(FileSpec$)

  Dim StnHdr As StationHeader                       'Stations-Header

  CalcMaxRec = True

  Call ParseFileSpec(FileSpec$, d$, p$, n$, FileExt$)

  Select Case FileExt$
  Case ".BSD"

    '--- Binaer-Datei oeffnen und Header lesen ---
    ErrNr = OpenFile(FileSpec$, "RI", Len(StnHdr), FileNr)
    If ErrNr Then Exit Function
    ErrNr = InputStationHeader(FileNr, StnHdr)
    If ErrNr Then Exit Function

    '--- Anzahl Stationen / Links ---
    SV.MaxAnzStn = SV.MaxAnzStn + StnHdr.AnzStnRec
    SV.MaxAnzLnk = SV.MaxAnzLnk + StnHdr.AnzLnkRec

    '--- Datei schliessen ---
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function


  Case ".STN", ".PRL"

    '-------- Stations-Datei --------
    ErrNr = FileLines(FileSpec$, 1, AnzLines)
    If ErrNr Then Exit Function
    SV.MaxAnzStn = SV.MaxAnzStn + AnzLines

    '-------- Ggf. Anzahl Links bestimmen --------
    LnkFileSpec$ = d$ + p$ + n$ + ".LNK"
    ErrNr = ExistFile(LnkFileSpec$, False, Exist)
    If ErrNr Then Exit Function

    If Exist Then
      ErrNr = FileLines(LnkFileSpec$, 2, AnzLines)
      If ErrNr Then Exit Function
      SV.MaxAnzLnk = SV.MaxAnzLnk + AnzLines
    End If


  Case ".UPD"

    '-------- Update-Datei --------

    '--- Datei oeffnen ---
    ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
    If ErrNr Then Exit Function

    '--- Neue Stationen / Links zaehlen ---
    Do Until EOF(FileNr)
      ErrNr = ReadDataLine(FileNr, InpLine$, EndOfFile)
      If ErrNr Then Exit Function
      If EndOfFile Then Exit Do

      Select Case UCase$(Left$(InpLine$, 3))
      Case "AS:"
        SV.MaxAnzStn = SV.MaxAnzStn + 1
      Case "AL:"
        SV.MaxAnzLnk = SV.MaxAnzLnk + 1
      End Select
    Loop

    '--- Datei schliessen ---
    ErrNr = CloseFile(FileNr)
    If ErrNr Then Exit Function

  Case Else
    Stop
  End Select

  CalcMaxRec = False

End Function

Sub CheckFieldLength()

  'QTH-Lnge prfen und ggf. krzen
  If Len(SF$(12)) > 36 Then
    If NumPar(7).Actual And 1024 Then
      m$ = CStr(Len(SF$(12))) & " Bytes"
      If NumPar(5).Actual And 256 Then m$ = m$ & " - " & Msg$(27016)
      void = StnLnkError(1, 27014, m$)
    End If
    If NumPar(5).Actual And 256 Then
      SF$(12) = RTrim$(Left$(SF$(12), 36))
    End If
  End If

  'Info-Lnge prfen und ggf. krzen
  If Len(SF$(13)) > 48 Then
    If NumPar(7).Actual And 2048 Then
      m$ = CStr(Len(SF$(13))) & " Bytes"
      If NumPar(5).Actual And 512 Then m$ = m$ & " - " & Msg$(27016)
      void = StnLnkError(1, 27015, m$)
    End If
    If NumPar(5).Actual And 512 Then
      SF$(13) = RTrim$(Left$(SF$(13), 48))
    End If
  End If

End Sub

Function CheckIncStn(Ca$)

  CheckIncStn = False

  '--- Include-Liste pruefen ---
  If AnzInc > 0 Then
    Ok = False
    For i = 1 To AnzInc
      ic$ = IncList$(i)
      If Left$(Ca$, Len(ic$)) = ic$ Then
        Ok = True
        Exit For
      End If
    Next i
    If Not Ok Then Exit Function
  End If

  '--- Exclude-Liste pruefen ---
  If AnzExc > 0 Then
    For i = 1 To AnzExc
      ec$ = ExcList$(i)
      If Left$(Ca$, Len(ec$)) = ec$ Then Exit Function
    Next i
  End If

  CheckIncStn = True

End Function

Function CheckInExt(Ext$)

  Select Case UCase$(Ext$)
  Case ".BSD"
    CheckInExt = 1                     'Bin
  Case ".STN", ".UPD", ".PRL"
    CheckInExt = 2                     'Text
  Case Else
    CheckInExt = 0
  End Select

End Function

Function CheckLnkMem()

  CheckLnkMem = True

End Function

Function CheckOutExt(Ext$)

  Select Case UCase$(Ext$)
  Case ".BSD": CheckOutExt = 1                    'Bin-Out
  Case ".STN": CheckOutExt = 2                    'Text-Out
  Case ".LOG": CheckOutExt = 3                  'Log
  Case Else: CheckOutExt = 0
  End Select

End Function


Function CheckStnMem()

  CheckStnMem = True

End Function

Function CloseOutBinFiles()

  '--- Binaer-Dateien im Fall von Abbruch schliessen ---
  CloseOutBinFiles = CloseStnBinFiles(SV.Out)

End Function

Function CloseOutTextFiles()

  '--- Text-Dateien im Fall von Abbruch schliessen ---
  CloseOutTextFiles = True

  '--- Stations-Textdatei schliessen ---
  ErrNr = CloseFile(SV.Out.StnFile)
  If ErrNr Then Exit Function

  '--- Ggf. Link-Textdatei schliessen ---
  If SV.Out.LnkFile > 0 Then
    ErrNr = CloseFile(SV.Out.LnkFile)
    If ErrNr Then Exit Function
  End If

  CloseOutTextFiles = False

End Function

Function ConvertError(ErrTxt$)

  ConvertError = WriteLog(ErrTxt$, 3)

End Function

Function CopyFileSection(SrcFile, DstFile, AnzBytes&)

  ErrNr = 0

  BufSiz& = 1000&
  Rest& = AnzBytes&

  void = ShowComplete(0&, AnzBytes&, SrcFile, 29103)

  Do While Rest& > 0&

    If Rest& < BufSiz& Then
      Block& = Rest&
    Else
      Block& = BufSiz&
    End If

    ErrNr = GetString(SrcFile, Block&, Buffer$)
    If ErrNr Then Exit Do

    ErrNr = PutString(DstFile, Buffer$)
    If ErrNr Then Exit Do

    Rest& = Rest& - Block&

    ErrNr = ShowComplete(AnzBytes& - Rest&, 0&, 0, 0)
    If ErrNr Then Exit Do

  Loop

  Buffer$ = ""

  void = ShowComplete(-1&, 0&, 0, 0)

  CopyFileSection = ErrNr

End Function

Function DeleteStnBinFiles(BinFile$)

  DeleteStnBinFiles = True

  For i = 1 To UBound(SV.BinExt)
    ErrNr = DeleteFile(BinFile$ + SV.BinExt(i), Found)
    If ErrNr Then Exit Function
  Next i

  DeleteStnBinFiles = False

End Function

Function FileLines(FileSpec$, Mode, AnzLines)

  FileLines = True
  AnzLines = 0

  '--- Datei oeffnen ---
  ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
  If ErrNr Then Exit Function


  '--- Zeilen zaehlen ---
  Do Until EOF(FileNr)
    ErrNr = ReadLine(FileNr, f$)
    If ErrNr Then Exit Function
    Incr = 1
    If AnzInc + AnzExc > 0 Then
      For i = 1 To Mode
        Ca$ = UCase$(Parse$(f$, ","))
        If CheckIncStn(Ca$) = 0 Then Incr = 0
      Next i
    End If
    AnzLines = AnzLines + Incr
  Loop

  '--- Datei schliessen ---
  ErrNr = CloseFile(FileNr)
  If ErrNr Then Exit Function

  FileLines = False

End Function

Function GetAlphaCall(RecNr, AlphaCall$)

  Static StnCall As StationCall
  Static cs As String * 6

  GetAlphaCall = True

  ErrNr = GetStationCall(RecNr, StnCall)
  If ErrNr Then Exit Function

  cs = UnPackCall$(StnCall.Call)

  SSID$ = Format$(StnCall.SSID \ 256)
  LineNr$ = Format$(StnCall.SSID And 255)

  AlphaCall$ = cs + Left$(SSID$ + " ", 2) + LineNr$

  GetAlphaCall = False

End Function

Function GetDefExt$(FileTyp)

  Select Case FileTyp
  Case 0: GetDefExt$ = ""                             'Input
  Case 1: GetDefExt$ = "BSD"                          'Bin-Out
  Case 2: GetDefExt$ = "STN"                          'Text-Out
  Case 3: GetDefExt$ = "LOG"                          'Log
  Case Else: Stop
  End Select

End Function

Function GetFileFilter$(Index)

  fl$ = Msg$(29015) + " (*.LOG)|*.LOG"
  fb$ = Msg$(29016) + " (*.BSD)|*.BSD"
  ft$ = Msg$(29017) + " (*.STN)|*.STN"
  fu$ = Msg$(29018) + " (*.UPD)|*.UPD"
  fp$ = Msg$(29019) + " (*.PRL)|*.PRL"

  Select Case Index
  Case 0                                    'Eingabedatei
    GetFileFilter$ = fb$ + "|" + fu$ + "|" + ft$ + "|" + fp$
  Case 1                                    'Binaer-Ausgabedatei
    GetFileFilter$ = fb$
  Case 2                                    'Text-Ausgabedatei
    GetFileFilter$ = ft$
  Case 3                                    'Logdatei
    GetFileFilter$ = fl$
  End Select

End Function

Sub HelpFunctions(Index)

  Select Case Index
  Case 1
    s$ = "CONVERT-File"
  Case 2
    s$ = "CONVERT-Convert"
  Case 3
    s$ = "STNCVT-Update"
  Case 4
    s$ = "STNCVT-Options"
  Case 5
    s$ = "HAMMAP-Help"
  End Select

  void = ShowHelp(s$)

End Sub

Function OpenOutBinFiles(OutBinFile$)

  Static StnHdr As StationHeader                       'Stations-Header
  Static LnkHdr As LinkHeader                          'Link-Header

  OpenOutBinFiles = True

  '--- Ggf. alte Dateien loeschen ---
  ErrNr = DeleteStnBinFiles(OutBinFile$)
  If ErrNr Then Exit Function


  '--- Stations-Daten-Datei oeffnen ---
  ErrNr = OpenFile(OutBinFile$ + ".BSD", "R", Len(StnHdr), SV.Out.BsdFile)
  If ErrNr Then Exit Function

  '--- Stations-Text-Datei oeffnen ---
  ErrNr = OpenFile(OutBinFile$ + ".BST", "B", 0, SV.Out.BstFile)
  If ErrNr Then Exit Function

  '--- Link-Daten-Datei oeffnen ---
  ErrNr = OpenFile(OutBinFile$ + ".BLD", "R", Len(LnkHdr), SV.Out.BldFile)
  If ErrNr Then Exit Function


  '--- Vorlaeufige Header ausgeben ---
  SV.Out.StnHdr.AnzFmtErr = -1                          'Abbruch-Flag

  ErrNr = PutStnHeader()
  If ErrNr Then Exit Function

  SV.Out.StnHdr.AnzFmtErr = 0


  '--- Header fuer Stations-Texte ---
  ErrNr = PutString(SV.Out.BstFile, "HMST" + StnFmtVer$)
  If ErrNr Then Exit Function

  SV.Out.StnHdr.AnzInfo = 6

  OpenOutBinFiles = False

End Function

Function Prl2Hm$(ByVal l As String)

  'Parameter must be passed byval - actual parameter is changed

  Static pf$(1 To 13)                             'PR-Liste Field

  '--- Call ---
  pf$(1) = UCase$(Left$(Left$(l, 7) + "      ", 6))
  pf$(2) = "0"                         'Zeile

  '--- Status ---
  pf$(3) = "OK"

  '--- Datum ---
  pf$(4) = Right$(Date$, 2) + Left$(Date$, 2)

  '--- Typ ---
  pf$(5) = "UN"

  '--- Software ---
  'pf$(6) = ""

  '--- Hardware ---
  'pf$(7) = "PC"

  '--- QRG ---
  'pf$(8) = ""

  '--- Baudrate ---
  'pf$(9) = "1200"

  '--- Sysop ---
  'pf$(10) = pf$(1)

  '--- Locator ---
  pf$(11) = UCase$(Mid$(l, 45, 6))
  If InStr(pf$(11), " ") Or InStr(pf$(11), "?") Then
    pf$(11) = "      "
  End If

  '--- QTH ---
  pf$(12) = RTrim$(Mid$(l, 27, 18))
  Dok$ = LTrim$(RTrim$(Mid$(l$, 22, 5)))                 'DOK
  If Dok$ <> "-" Then pf$(12) = pf$(12) + " (" + Dok$ + ")"
  If Len(pf$(12)) > 36 Then pf$(12) = Left$(pf$(12), 36)


  '--- Info ---
  pf$(13) = RTrim$(Mid$(l$, 8, 14))                        'Name

  'Dok$ = LTrim$(Rtrim$(Mid$(l$, 22, 5)))                 'DOK
  'If Dok$ <> "-" Then pf$(13) = pf$(13) + ";DOK:" + Dok$

  Tel$ = RTrim$(Mid$(l$, 52, 16))                        'Telefon
  Do
    Pt = InStr(Tel$, " ")
    If Pt = 0 Then Exit Do
    Tel$ = Left$(Tel$, Pt - 1) + Mid$(m$, Pt + 1)
  Loop
  If Tel$ <> "-" Then pf$(13) = pf$(13) + ";Tel:" + Tel$

  Box$ = RTrim$(Mid$(l$, 68))                            'Box
  If Len(Box$) > 0 Then pf$(13) = pf$(13) + ";@" + Box$

  If Len(pf$(13)) > 48 Then pf$(13) = Left$(pf$(13), 48)


  '--- Zeile im STN-Format bilden ---
  For i = 1 To 13
    m$ = m$ + "," + pf$(i)
  Next i
  Prl2Hm$ = Mid$(m$, 2)

End Function

Function SortLinks()

  '--- Links nach SSID alphabetisch sortieren ---
  'Methode: Bubble-Sort (da nicht viele Verschiebungen)

  AnzLnkRec = SV.Out.StnHdr.AnzLnkRec

  void = ShowComplete(0&, 100&, SV.Out.LnkFile, 29105)

  Compl& = 0&

  Do
    Moved = 0

    ErrNr = GetLnkStnPtrs(LnkIdxTbl(2), SrcRec, DstRec)
    If ErrNr Then Exit Do
    ErrNr = GetAlphaCall(SrcRec, Src1$)
    If ErrNr Then Exit Do
    ErrNr = GetAlphaCall(DstRec, Dst1$)
    If ErrNr Then Exit Do

    For LnkNr = 2 To AnzLnkRec - 1
      ErrNr = GetLnkStnPtrs(LnkIdxTbl(LnkNr + 1), SrcRec, DstRec)
      If ErrNr Then Exit Do
      ErrNr = GetAlphaCall(SrcRec, Src2$)
      If ErrNr Then Exit Do
      ErrNr = GetAlphaCall(DstRec, Dst2$)
      If ErrNr Then Exit Do

      If Src1$ > Src2$ Or (Src1$ = Src2$ And Dst1$ > Dst2$) Then
        Moved = Moved + 1

        'Pointer vertauschen
        LnkIdx = LnkIdxTbl(LnkNr + 1)
        LnkIdxTbl(LnkNr + 1) = LnkIdxTbl(LnkNr)
        LnkIdxTbl(LnkNr) = LnkIdx

      Else
        Src1$ = Src2$
        Dst1$ = Dst2$
      End If
    Next LnkNr

    Compl& = Compl& + 2
    If Compl& = 100& Then Compl& = 0&
    ErrNr = ShowComplete(Compl&, 0&, 0, 0)
    If ErrNr Then Exit Do

  Loop Until Moved = 0

  void = ShowComplete(-1&, 0&, 0, 0)

  SortLinks = ErrNr

End Function

Function SortStations()

  '--- Stationen nach SSID alphabetisch sortieren ---
  'Methode: Bubble-Sort (da nicht viel Verschiebungen)
  'nach Visual Basic Programmer's Jounal May 1995 S. 38

  Lo = 2
  Hi = SV.Out.StnHdr.AnzStnRec

  If Hi = 1 Then Exit Function   'Keine Stationen

  void = ShowComplete(0&, 100&, SV.Out.StnFile, 29105)

  Compl& = 0

  j = Lo

  Do While j < Hi

    K = Hi

    ErrNr = GetAlphaCall(StnIdxTbl(K), vk$)
    If ErrNr Then Exit Do

    Moved = 0

    Do While K > j
      ErrNr = GetAlphaCall(StnIdxTbl(K - 1), vk1$)
      If ErrNr Then Exit Do

      If vk$ < vk1$ Then
        'Pointer vertauschen
        Tmp = StnIdxTbl(K)
        StnIdxTbl(K) = StnIdxTbl(K - 1)
        StnIdxTbl(K - 1) = Tmp
        Moved = Moved + 1
      Else
        vk$ = vk1$
      End If

      K = K - 1
    Loop

    Compl& = Compl& + 2
    If Compl& = 100& Then Compl& = 0&
    ErrNr = ShowComplete(Compl&, 0&, 0, 0)
    If ErrNr Then Exit Do

    j = j + 1
    If Moved = 0 Then Exit Do
  Loop

  void = ShowComplete(-1&, 0&, 0, 0)

  SortStations = ErrNr

End Function

Function WriteAllLinks()

  ErrNr = 0

  C1 = True
  c2 = True
  c3 = True
  C4 = True


  IsWholeMap = IsNullArea(SV.lParArea) Or IsWorldArea(SV.lParArea)
  LoadQthData = (NumPar(2).Actual And 2) <> 0 Or IsWholeMap = 0

  ShowStep = SV.Out.StnHdr.AnzLnkRec \ 50
  If ShowStep = 0 Then ShowStep = 1
  void = ShowComplete(0&, CLng(ShowStep * 50), SV.Out.LnkFile, 29102)

  For i = 2 To SV.Out.StnHdr.AnzLnkRec

    If SV.LnkIdxLoaded Then
      RecNr = LnkIdxTbl(i)
    Else
      RecNr = i
    End If

    '--- Stations-Record aus Speicher bzw. von Disk holen ---
    ErrNr = GetLinkData(SV.Out.BldFile, RecNr, ActLnkData)
    If ErrNr Then Exit For

    '--- Falls Link nicht geloescht, Link decodieren und ausgeben ---
    If ActLnkData.LnkDate < 32767 Then
      ErrNr = DecodeLink(ActLnkData, 0)
      If ErrNr Then Exit For

      If LoadQthData Then
        ErrNr = GetStationQth(ActLnkData.StnPtr(1), x1, y1)
        If ErrNr Then Exit For
        ErrNr = GetStationQth(ActLnkData.StnPtr(2), x2, y2)
        If ErrNr Then Exit For
      End If

      'Ggf. Link nicht ausgeben, wenn kein QTH
      If NumPar(2).Actual And 2 Then
        C1 = y1 < 32767 And y2 < 32767
      End If

      'Ggf. Link nicht ausgeben, wenn QTH ausserhalb
      If IsWholeMap = 0 Then
        c2 = y1 < 32767 And PointInIArea(x1, y1, SV.iParArea)
        c3 = y2 < 32767 And PointInIArea(x2, y2, SV.iParArea)
      End If

      'Calls auf Include / Exclude pruefen
      If AnzInc + AnzExc > 0 Then
        C4 = CheckIncStn(LF$(1)) And CheckIncStn(LF$(2))
      End If

      If C1 And c2 And c3 And C4 Then
        ErrNr = WriteLink(SV.Out.LnkFile)
        If ErrNr Then Exit For
      Else
        SV.Out.StnHdr.AnzLnk = SV.Out.StnHdr.AnzLnk - 1
      End If
    End If

    If i Mod ShowStep = 0 Then
      ErrNr = ShowComplete(CLng(i), 0&, 0, 0)
      If ErrNr Then Exit For
    End If

  Next i

  void = ShowComplete(-1&, 0&, 0, 0)

  WriteAllLinks = ErrNr

End Function

Function WriteAllStations()

  Static MSF$(3 To AnzStnFields)                  'Main Line Station Field

  ErrNr = 0

  C1 = True
  c2 = True
  c3 = True
  C4 = True

  IsWholeMap = IsNullArea(SV.lParArea) Or IsWorldArea(SV.lParArea)

  ShowStep = SV.Out.StnHdr.AnzStnRec \ 50
  If ShowStep = 0 Then ShowStep = 1
  void = ShowComplete(0&, CLng(ShowStep * 50), SV.Out.StnFile, 29102)

  With ActStnData

    For i = 2 To SV.Out.StnHdr.AnzStnRec

      '--- Stations-Record aus Speicher bzw. von Disk holen ---
      RecNr = GetStnIdx(i)

      ErrNr = GetStationData(SV.Out.BsdFile, RecNr, ActStnData)
      If ErrNr Then Exit For
      ErrNr = GetStationInfo(SV.Out.BstFile, ActStnData, ActQTH, ActInfo)
      If ErrNr Then Exit For


      '--- Falls Station nicht geloescht, Station decodieren und ausgeben ---
      If .xloc < 32767 Then

        Call DecodeStation(ActStnData, ActQTH, ActInfo, 0)

        '--- Filter fr Hauptzeile pruefen -> gilt dann auch fr Zusatzzeilen ---
        If SF$(2) = "0" Then

          'Hauptzeile
          MainCall$ = SF$(1)
          If .xloc = 32766 Then Stop  'Zusatzzeile

          'Ggf. Station nicht ausgeben, falls keine Links
          If NumPar(2).Actual And 1 Then
            C1 = .LnkPtr > 0
          End If

          'Ggf. Station nicht ausgeben, falls kein QTH
          If NumPar(2).Actual And 2 Then
            c2 = .yloc < 32767
          End If

          'Ggf. Station nicht ausgeben, falls ausserhalb Bereich
          If Not IsWholeMap Then
            c3 = .yloc < 32767 And PointInIArea(.xloc, .yloc, SV.iParArea)
          End If

          'Call Auf Include/Exclude pruefen
          If AnzInc + AnzExc > 0 Then
            C4 = CheckIncStn(SF$(1))
          End If

          WriteOk = C1 And c2 And c3 And C4

        Else

          'Zusatzzeilen -> mssen direkt nach Hauptzeilen folgen
          If SF$(1) <> MainCall$ Then Stop
          If .xloc <> 32766 Then Stop  'keine Zusatzzeile

        End If


        If WriteOk Then

          '--- Wenn Typ, Software und Hardware in Zusatzzeile gleich Hauptzeile,...
          '... dann Inhalt in Zusatzzeile loeschen ---
          If SF$(2) = "0" Then
            'Hauptzeile
            For f = 5 To 7
              MSF$(f) = SF$(f)
            Next f
          Else
            'Zusatzzeilen
            For f = 5 To 7
              If SF$(f) = MSF$(f) Then SF$(f) = ""
            Next f
          End If

          'Prfen, ob Felder ',' enthalten und ggf. ersetzen
          If (NumPar(7).Actual And 512) <> 0 Or (NumPar(5).Actual And 128) <> 0 Then
            For n = 1 To 13
              If InStr(SF$(n), ",") Then
                If NumPar(7).Actual And 512 Then
                  'Fehlerprfung
                  ErrNr = StnLnkError(1, 27013, SF$(n))
                ElseIf NumPar(5).Actual And 128 Then
                  'Ersetzen
                  m$ = Rpad$(SF$(1), 9) + ", " + Rpad$(SF$(2), 1) + ": "
                  m$ = m$ & Msg$(27013) & Quotes$(SF$(n)) & " - " & Msg$(27016)
                  ErrNr = WriteLog(m$, 3)
                  SF$(n) = Replace$(SF$(n), ",", ";")
                End If
                If ErrNr Then Exit For
              End If
            Next n
            If ErrNr Then Exit For
          End If


          Call CheckFieldLength

          ErrNr = WriteStation(SV.Out.StnFile)
          If ErrNr Then Exit For
        Else
          SV.Out.StnHdr.AnzStn = SV.Out.StnHdr.AnzStn - 1
        End If
      End If

      If i Mod ShowStep = 0 Then
        ErrNr = ShowComplete(CLng(i), 0&, 0, 0)
        If ErrNr Then Exit For
      End If

    Next i

  End With

  void = ShowComplete(-1&, 0&, 0, 0)

  WriteAllStations = ErrNr

End Function

Function WriteOutTextFiles(OutFileSpec$)

  WriteOutTextFiles = True

  OutTextFile$ = StripExt$(OutFileSpec$)


  '--- Ausgabe auf Log-Datei ---
  ErrNr = WriteLog(vbCrLf + Msg$(29013) + ":", 3)
  If ErrNr Then Exit Function
  ErrNr = WriteLog("    " + OutTextFile$ + ".STN", 3)
  If ErrNr Then Exit Function


  '--- Stations-Text-Ausgabedatei oeffnen ---
  ErrNr = OpenFile(OutTextFile$ + ".STN", "O", 0, SV.Out.StnFile)
  If ErrNr Then Exit Function


  '--- Ggf. SSID's alphabetisch sortieren ---
  If SV.DataFormat And 4 Then
    ErrNr = SortStations()
    If ErrNr Then Exit Function
  End If

  '--- Stations-Textdatei ausgeben ---
  ErrNr = WriteAllStations()
  If ErrNr Then Exit Function

  '--- Stations-Textdatei schliessen ---
  ErrNr = CloseFile(SV.Out.StnFile)
  If ErrNr Then Exit Function


  '--- Ggf. Link-Textdatei oeffnen und ausgeben ---
  If SV.Out.StnHdr.AnzLnkRec > 1 Then

    ErrNr = WriteLog("    " + OutTextFile$ + ".LNK", 3)
    If ErrNr Then Exit Function

    ErrNr = OpenFile(OutTextFile$ + ".LNK", "O", 0, SV.Out.LnkFile)
    If ErrNr Then Exit Function

    If SV.DataFormat And 4 Then
      ErrNr = SortLinks()
      If ErrNr Then Exit Function
    End If

    ErrNr = WriteAllLinks()
    If ErrNr Then Exit Function

    '--- Ggf. Link-Textdatei schliessen ---
    ErrNr = CloseFile(SV.Out.LnkFile)
    If ErrNr Then Exit Function

  End If

  WriteOutTextFiles = False

End Function

Function WriteStatistics(OutLogFile$)

  WriteStatistics = True

  '--- Statistik ausgeben (ohne Header-Records) ---
  m$ = LPad$(Format$(SV.Out.StnHdr.AnzStn), 4)
  If SV.Out.StnHdr.AnzStn <> SV.Out.StnHdr.AnzStnRec - 1 Then
    m$ = m$ + " (" + Format$(SV.Out.StnHdr.AnzStnRec - 1) + ")"
  End If
  ErrNr = WriteLog(vbCrLf + m$ + " " + Msg$(31035), 3)
  If ErrNr Then Exit Function

  m$ = LPad$(Format$(SV.Out.StnHdr.AnzLnk), 4)
  If SV.Out.StnHdr.AnzLnk <> SV.Out.StnHdr.AnzLnkRec - 1 Then
    m$ = m$ + " (" + Format$(SV.Out.StnHdr.AnzLnkRec - 1) + ")"
  End If
  ErrNr = WriteLog(m$ + " " + Msg$(31036), 3)
  If ErrNr Then Exit Function

  '--- Anzahl Fehler (Referenzfehler) ---
  m$ = LPad$(Format$(SV.Out.StnHdr.AnzFmtErr), 4) + " " + Msg$(29026)
  If SV.Out.StnHdr.AnzRefErr + SV.Out.StnHdr.AnzDateErr > 0 Then
    m$ = m$ + " ("
    m$ = m$ + Format$(SV.Out.StnHdr.AnzRefErr) + " " + Msg$(29028) + " - "
    m$ = m$ + Format$(SV.Out.StnHdr.AnzDateErr) + " " + Msg$(31020)
    m$ = m$ + ")"
  End If
  ErrNr = WriteLog(m$, 3)
  If ErrNr Then Exit Function

  If SV.Out.StnHdr.AnzFmtErr + SV.Out.StnHdr.AnzRefErr + SV.Out.StnHdr.AnzDateErr > 0 Then
    If Len(OutLogFile$) > 0 Then
      m$ = "       " + Msg$(29027) + Quotes$(OutLogFile$)
      ErrNr = WriteLog(m$, 1)
      If ErrNr Then Exit Function
    End If
  End If


  'n = (SV.StnDataLoaded <> 0) And 1 Or (SV.StnIdxLoaded <> 0) And 2
  'n = n Or (SV.StnCallsLoaded <> 0) And 4 Or (SV.StnQthLoaded <> 0) And 8
  'n = n Or (SV.LnkDataLoaded <> 0) And 16 Or (SV.LnkIdxLoaded <> 0) And 32
  'n = n Or (SV.LnkStnPtrLoaded <> 0) And 64
  'ErrNr = WriteLog("Arrays = &H" + Hex$(n), 3)
  'If ErrNr Then Exit Function

  WriteStatistics = SV.Out.StnHdr.AnzFmtErr

End Function

