Attribute VB_Name = "STNSUB"
'-------------------------- STNSUB.BAS ------------------------

'HAMMAP Stations-Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z


Function AddFoundStn(RecNr)

  Dim Stn As StationData

  AddFoundStn = True

  If HV.AnzFound >= UBound(StnFnd) Then

    Call ShowErrNr(31037)

  Else

    HV.AnzFound = HV.AnzFound + 1

    ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
    If ErrNr Then Exit Function

    StnFnd(HV.AnzFound).StnRec = RecNr
    StnFnd(HV.AnzFound).Status = Stn.StnStat
    StnFnd(HV.AnzFound).LnkRec = Stn.LnkPtr
    StnFnd(HV.AnzFound).StnCall = Stn.StnCall

    AddFoundStn = False

  End If

End Function

Function AddFoundTip(TipMode, RecNr)

  Dim TipStn As StationData
  Dim OutCall$, LineNr$
  Dim m$, ti$
  Dim i, ErrNr

  AddFoundTip = True

  ErrNr = GetStationLineData(SV.Out.BsdFile, RecNr)
  If ErrNr Then Exit Function

  Call DecodeCall(StnLineData(0).StnCall, OutCall$, LineNr$)

  gblTipInfo$ = gblTipInfo$ & vbCrLf & OutCall$

  m$ = ""

  If TipMode > 1 Then
    For i = 0 To 9
      TipStn = StnLineData(i)
      ti$ = ""
      If TipStn.xloc < 32767 Then

        ' bei weiteren Tips siehe DecodeStation
        Select Case TipMode
        Case 1          'nur Call

        Case 2          'Typ
          If TipStn.StnTyp > 0 Then
            ti$ = Msg$(24310 + TipStn.StnTyp)   'lang
            'ti$ = GetStnAbv$(2, TipStn.StnTyp)  'kurz
          End If

        Case 3          'Hard-/Software
          If TipStn.Hardware > 0 Then
            ti$ = Msg$(24370 + TipStn.Hardware)
            If TipStn.Software > 0 Then ti$ = ti$ & "/"
          End If
          If TipStn.Software > 0 Then
            ti$ = ti$ & Msg$(24340 + TipStn.Software)
          End If

        Case 4          'QRG
          If TipStn.QRG > 0 Then
            ti$ = Format$(CCur(TipStn.QRG) / 1000@, "#,##0.000")
          End If

        Case 5          'Baud
          If TipStn.Baud > 0 Then
            ti$ = Format$(TipStn.Baud, "#")
          End If

        Case 6          'QTH
          If TipStn.QthPtr > 0 Then
            ErrNr = GetLenText(SV.Out.BstFile, TipStn.QthPtr, ti$)
            If ErrNr Then Exit Function
            ti$ = Pc8toAnsi$(ti$)
          End If
        End Select

        If Len(ti$) > 0 Then
          If InStr(m$ & "+", "+" & ti$ & "+") = 0 Then
            m$ = m$ & "+" & ti$
          End If
        End If
      End If
    Next i
  End If

  If Len(m$) > 0 Then
    gblTipInfo$ = gblTipInfo$ & ": " & Mid$(m$, 2)
  End If

  AddFoundTip = False

End Function

Function CheckStation(ByVal Stn$, RecNr)

  Static FindCall As StationCall

  CheckStation = True

  SF$(1) = ""         'see StnLnkError
  ErrNr = EncodeCall(1, Stn$, "0", FindCall)

  ErrNr = FindStation(FindCall, StnNr, RecNr, Found, Deleted)
  If ErrNr Then Exit Function

  If Not Found Or Deleted Then           'Nicht gefunden
    Call FileError(Msg$(24202) + ": '" + Stn$ + "'", "")
    Exit Function
  End If

  CheckStation = False

End Function

Sub DeselectStation()

  'auch wenn keine Station selektiert ist ntig,
  '  um ggf. Auswahl usw. zu lschen

  'ggf. letztes Blinken aufheben
  MapForm.BlinkTimer.Enabled = False
  Call DrawSelectedStation(-1)

  void = SelectLink(0)

  HV.AnzFound = 0
  Call ShowFound(0)

  HV.SelStnRec = 0
  SelStnCall$ = ""
  Call ShowSelectedStn
  Call ShowText("", 13, 0)

  HV.NewTip = True

End Sub

Function FindAllStations(Eingabe$)

  Static Stn As StationData
  Static MidCall As StationCall
  Static FindCall As StationCall

  FindAllStations = True
  Found = False

  If InStr(Eingabe$, "-") Then
    'DB0CPU-0
    WildCard = 0
  ElseIf Right$(Eingabe$, 1) <> "*" Then
    'DB0CPU
    WildCard = 1
  Else
    'DB0CP*
    WildCard = 2
    CmpLen = Len(Eingabe$) - 1
    Eingabe$ = Left$(Eingabe$, CmpLen)
  End If


  SF$(1) = ""         'see StnLnkError

  ErrNr = EncodeCall(1, Eingabe$, "0", FindCall)
  If ErrNr Then Exit Function

  AnzStnRec = SV.Out.StnHdr.AnzStnRec

  '--- Stations-Index nicht geladen -> sequentiell suchen ---
  If SV.StnIdxLoaded = 0 Then
    For RecNr = 2 To AnzStnRec

      ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
      If ErrNr Then Exit Function

      If (StnFlags(RecNr) And &H30) = &H30 Then
        'Not deleted and main line
        Select Case WildCard
        Case 0
          If Stn.StnCall.Call = FindCall.Call Then
            If Stn.StnCall.SSID = FindCall.SSID Then
              void = AddFoundStn(RecNr)
              FindAllStations = False
              Exit Function
            End If
          End If

        Case 1
          If Stn.StnCall.Call = FindCall.Call Then
            ErrNr = AddFoundStn(RecNr)
            If ErrNr Then Exit For
          End If

        Case 2
          Call DecodeCall(Stn.StnCall, sc$, LineNr$)
          If Left$(sc$, CmpLen) = Eingabe$ Then
            ErrNr = AddFoundStn(RecNr)
            If ErrNr Then Exit For
          End If
        End Select
      End If
    Next RecNr

    FindAllStations = False
    Exit Function
  End If


  '--- Stations-Index ist geladen -> Binaersuche ---
  Lo = 1                                        'Skip Header = #1
  Hi = AnzStnRec + 1
  Diff = Hi - Lo

  '--- Station suchen ---
  Do Until Diff = 1
    Mitte = Diff \ 2 + Lo
    RecNr = StnIdxTbl(Mitte)

    ErrNr = GetStationCall(RecNr, MidCall)
    If ErrNr Then Exit Function

    Select Case CmpCalls(FindCall, MidCall)
    Case 1
      'FindCall > MidCall
      Lo = Mitte
    Case 2
      'FindCall < MidCall
      Hi = Mitte
    Case Else
      '--- Station gefunden ---
      StnNr = Mitte
      Found = True
      Exit Do
    End Select

    Diff = Hi - Lo
  Loop

  If Diff = 1 Then StnNr = Hi

  Do
    RecNr = StnIdxTbl(StnNr)
    ErrNr = GetStationData(SV.Out.BsdFile, RecNr, Stn)
    If ErrNr Then Exit Function
    Deleted = (Stn.xloc = 32767)

    Select Case WildCard
    Case 0
      If Found Then
        If (StnFlags(RecNr) And &H30) = &H30 Then
          void = AddFoundStn(RecNr)
        End If
      End If
      Exit Do

    Case 1
      If Stn.StnCall.Call <> FindCall.Call Then Exit Do
      If (StnFlags(RecNr) And &H30) = &H30 Then
        ErrNr = AddFoundStn(RecNr)
        If ErrNr Then Exit Do
      End If

    Case 2
      Call DecodeCall(Stn.StnCall, sc$, LineNr$)
      If Left$(sc$, CmpLen) <> Eingabe$ Then Exit Do
      If (StnFlags(RecNr) And &H30) = &H30 Then
        ErrNr = AddFoundStn(RecNr)
        If ErrNr Then Exit Do
      End If

    End Select

    StnNr = StnNr + 1
  Loop Until StnNr > AnzStnRec

  FindAllStations = False

End Function

Function FindStnByKoord(secP As lPoint, TipMode)

  'Digi finden nach geogr. Koord. mx, my

  Dim mx As Long, my As Long
  Dim dx As Long, dy As Long
  Dim mindx As Long, mindy As Long

  SelectStnByKoord = True

  mx = secP.x / cfQth2Sec
  my = secP.y / cfQth2Sec

  mindx = 5! * HMCrt.SecPerPixelX / cfQth2Sec
  mindy = 5! * HMCrt.SecPerPixelY / cfQth2Sec

  If TipMode = 0 Then
    HV.AnzFound = 0
  Else
    gblTipInfo$ = ""
  End If

  olddist& = 36000 * 36000

  Mask = &H7F00   'mit Filter (nur angezeigte Stationen)
  'Mask = 0       'alle Stationen

  For StnRec = 2 To SV.Out.StnHdr.AnzStnRec

    If (StnFlags(StnRec) And &HF0) = &HF0 Then
      'Gltige Hauptzeile, QTH bekannt und im Ausschnitt
      ErrNr = GetStationQth(StnRec, actx, acty)
      If ErrNr Then Exit Function
      dx = actx - mx
      dy = acty - my
      If Abs(dx) <= mindx And Abs(dy) <= mindy Then
        Dist& = dx * dx + dy * dy

        '--- naeher ---
        If Dist& < olddist& Then
          'Filter prfen
          If (StnFlags(StnRec) And Mask) = Mask Then
            olddist& = Dist&
            xfound = actx
            yfound = acty

            Select Case TipMode
            Case 0
              HV.AnzFound = 0
              ErrNr = AddFoundStn(StnRec)
              If ErrNr Then Exit Function
            Case -1
              gblTipInfo$ = Str$(StnRec)
            Case Else
              gblTipInfo$ = ""
              ErrNr = AddFoundTip(TipMode, StnRec)
              If ErrNr Then Exit Function
            End Select
          End If

        '--- gleich weit und gleiches QTH ---
        ElseIf Dist& = olddist& Then
          If actx = xfound And acty = yfound Then
            If HV.AnzFound < UBound(StnFnd) Then
              'Filter prfen
              If (StnFlags(StnRec) And Mask) = Mask Then
                Select Case TipMode
                Case 0
                  ErrNr = AddFoundStn(StnRec)
                  If ErrNr Then Exit Function
                Case -1
                Case Else
                  ErrNr = AddFoundTip(TipMode, StnRec)
                  If ErrNr Then Exit Function
                End Select
              End If
            End If
          End If
        End If

      End If
    End If
  Next StnRec

  SelectStnByKoord = False

End Function

Sub MouseClickStation(secP As lPoint)

  'Digi mit Maus anclicken

  Call DeselectStation

  ErrNr = FindStnByKoord(secP, 0)          'Digi(s) finden
  If ErrNr Then Exit Sub

  If HV.AnzFound = 0 Then
    Call ShowText("", 13, 0)
    Beep
    Call ApiSleep(200)
    Call ShowText(Msg$(24209), 13, 0)
  Else
    Call ShowFoundStn(False)
  End If

End Sub

Function SelectStation(ByVal NewStn, EnblAutoArea)

  'NewStn must be passed by value - may change actual parameter

  'Station already selected/deselected - no change
  If NewStn = HV.SelStnRec Then Exit Function

  If NewStn = 0 Then     'kein Digi
    Call DeselectStation
    Exit Function
  End If

  SelectStation = True

  'letztes Blinken ggf. aufheben
  Call DrawSelectedStation(-1)

  ErrNr = SelectLink(0)
  If ErrNr Then Exit Function

  If (NumPar(46).Actual And MF_AutoArea) <> 0 And EnblAutoArea Then
    If StnFlags(NewStn) And &H40 Then
      'Ausschnitt verschieben, falls Station nicht im Ausschnitt und QTH bekannt
      Call AutoArea(1, 0&, 0&)     'Init
      Call AutoAreaStn(NewStn)
      Call AutoArea(4, 0&, 0&)     'NewMap
    End If
  End If


  '--- pruefen, ob QTH bekannt und im Ausschnitt ---
  If (NumPar(41).Actual And 1) = 0 Then

    If (StnFlags(NewStn) And &H40) = 0 Then     'QTH unbekannt
      Call ShowErrNr(24206)
      Exit Function
    ElseIf (StnFlags(NewStn) And &H80) = 0 Then   'QTH nicht im Ausschnitt
      Call ShowErrNr(24204)
      Exit Function
    End If

  End If

  '--- Daten der selektierten Station laden ---
  ErrNr = GetStationData(SV.Out.BsdFile, NewStn, ActStnData)
  If ErrNr Then Exit Function

  ErrNr = GetStationInfo(SV.Out.BstFile, ActStnData, ActQTH, ActInfo)
  If ErrNr Then Exit Function

  SelStnData = ActStnData
  Call DecodeCall(SelStnData.StnCall, SelStnCall$, dummy$)
  SelQTH = ActQTH
  SelInfo = ActInfo

  '--- Information ausgeben ---
  HV.SelStnRec = NewStn                      'Digi ist selektiert
  Call ShowSelectedStn
  Call ShowStationInfo(1, HV.SelStnRec)

  If HV.PrtEnbl And 1 Then
    DrawOk = (NumPar(42).Actual And 8) <> 0
    Call DrawSelStnLinks(DrawOk)
  End If

  '--- Station ausgeben (auch falls kein blinken) ---
  Call DrawSelectedStation(-1)

  '--- Route im voraus berechnen ---
  If NumPar(42).Actual And 32 Then
    Select Case NumPar(47).Actual
    Case 13 To 15     'TipInfo = Route    (ok v11)
      Fastest = (NumPar(42).Actual And 16) <> 0
      void = FindRoute(Fastest, HV.SelStnRec, 0, "", RouteFound)
    End Select
  End If

  HV.NewTip = True

  SelectStation = False

End Function

Function ShowCall$(FoundNr)

  i = FoundNr
  If HV.FoundMode = 2 Then
    'Route rueckwaerts
    i = HV.AnzShow - i + 1
  End If
  RecNr = StnFnd(i).StnRec

  Call DecodeCall(StnFnd(i).StnCall, OutCall$, LineNr$)

  Select Case HV.FoundMode
  Case 1                'Stationen

    '--- Stations-Status pruefen, ob Station defekt / geplant ---
    If StnFnd(i).Status >= 4 Then
      OutCall$ = LCase$(OutCall$)
    End If

  Case 2, 3             'Route, Links

    '--- Link-Status Pruefen, ob Link defekt / geplant ---
    If StnFnd(i).Status >= 4 Then
      OutCall$ = LCase$(OutCall$)
    End If

    If (StnFlags(RecNr) And &H40) = 0 Then
      'Partner-QTH unbekannt -> '?' ausgeben
      OutCall$ = OutCall$ + " ?"
    ElseIf (StnFlags(RecNr) And &H80) = 0 Then
      'Partner-QTH nicht im Ausschnitt -> '>' ausgeben
      OutCall$ = OutCall$ + " >"
    End If

  End Select

  ShowCall$ = OutCall$

End Function

Sub ShowFound(FoundMode)

  'FoundMode: 0=nur loeschen, 1=Digis, 2=Route, 3=Links

  HV.FoundMode = FoundMode

  If HV.AnzFound <= HV.MaxFound Then
    HV.AnzShow = HV.AnzFound
  Else
    HV.AnzShow = HV.MaxFound                        '1...AnzShow
  End If



  '--- Ausgabebereich loeschen ---
  AuxForm.AuxList.Clear
  AuxForm.AuxList.Refresh

  If FoundMode = 0 Then
    AuxForm.ListLabel.Caption = ""
    AuxForm.ListLabel.Refresh
  Else
    '--- Titel je nach Found-Mode ausgeben ---
    AuxForm.ListLabel.Caption = Msg$(24600 + FoundMode)
    If FoundMode <> 2 Then Call SortFound

    If HV.FoundMode = 3 And HV.AnzFound = 0 Then
      '--- keine Links ---
      AuxForm.AuxList.AddItem Msg$(24604)
    Else
      '--- Stationen, Route, Links anzeigen ---
      For i = 1 To HV.AnzShow
        AuxForm.AuxList.AddItem ShowCall$(i)
      Next i
    End If
  End If

  Call ToolbarShowFound(FoundMode)


End Sub

Sub ShowFoundStn(EnblAutoArea)

  Select Case HV.AnzFound
  Case 0
    Stop

  Case 1
    'Nur 1 Station gefunden -> sofort selektieren
    void = SelectStation(StnFnd(1).StnRec, EnblAutoArea)


  Case Else
    '--- Auswahl ausgeben ---
    Call ShowText(LTrim$(Str$(HV.AnzFound)) + " " + Msg$(24107), 13, 0)
    Call ShowFound(1)

  End Select

End Sub

Sub SortFound()

  Static TmpFnd As FoundType

  '--- gefundene Stationen sortieren ---
  For i = HV.AnzFound To 2 Step -1
    For j = 2 To i
      If StnFnd(j - 1).StnCall.Call > StnFnd(j).StnCall.Call Then
        DoSwap = True
      ElseIf StnFnd(j - 1).StnCall.Call = StnFnd(j).StnCall.Call Then
        DoSwap = StnFnd(j - 1).StnCall.SSID > StnFnd(j).StnCall.SSID
      Else
        DoSwap = False
      End If
      If DoSwap Then
        TmpFnd = StnFnd(j - 1)
        StnFnd(j - 1) = StnFnd(j)
        StnFnd(j) = TmpFnd
      End If
    Next j
  Next i

End Sub

Function StnColor(Software)

  If NumPar(41).Actual And 2 Then
    '--- Stationen farbig ---
    Select Case GetStnAbv$(3, Software)
    Case "TH", "TN", "TO"
      StnColor = 1
    Case "G8"
      StnColor = 2
    Case "FB"
      StnColor = 4
    Case "FN"
      StnColor = 5
    Case "DB"
      StnColor = 6
    Case "BC", "BM"
      StnColor = 3
    Case Else
      StnColor = 14
    End Select
  Else
    '--- Stationen nicht farbig ---
    StnColor = 14
  End If

End Function

