Attribute VB_Name = "STRLIB"
DefInt A-Z
Option Explicit


'VarPtr(a&) returns address of a&
'VarPtr(Byval a&) returns value of a&
'VarPtr(a$) returns address of string descriptor
'VarPtr(Byval a$) = StrPtr(a$) returns address of string space

'for Strings see: VBPJ April 1998, page 109 ff
'for Arrays  see: VBPJ July 1997, page 44 ff


  Declare Function AnsiToOem Lib "user32.dll" Alias "CharToOemA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
  Declare Function OemToAnsi Lib "user32.dll" Alias "OemToCharA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long

  Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, Source As Any, ByVal numBytes As Long)
  Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (dest As Any, ByVal numBytes As Long)

Function AddBackSlash$(ByVal p$)

  If Right$(p$, 1) = "\" Then
    AddBackSlash$ = p$
  Else
    AddBackSlash$ = p$ + "\"
  End If

End Function

Function AddRight$(s$, a$)

  If Right$(s$, Len(a$)) <> a$ Then
    AddRight$ = s$ & a$
  Else
    AddRight$ = s$
  End If

End Function

Function AnsiToPc8$(ByVal Ansi$)


  Dim Pc8$
  Dim void

  Pc8$ = Space$(Len(Ansi$))
  void = AnsiToOem(Ansi$, Pc8$)
  AnsiToPc8$ = Pc8$


End Function

Sub AppendStr(StrIn$, MaxLen As Long)

  Static s$, ls As Long, Pt As Long
  Dim lin

  If MaxLen = -1 Then
    'Retrieve and delete string
    StrIn$ = Left$(s$, Pt - 1)
    s$ = ""
  Else
    If MaxLen > 0 Then
      'Initialize string and pointer
      s$ = String$(MaxLen, " ")
      ls = MaxLen
      Pt = 1
    End If

    lin = Len(StrIn$)
    If lin > 0 Then
      If Pt + lin > ls Then
        s$ = s$ + String$(1000, lin)
        ls = ls + lin
      End If

      Mid$(s$, Pt) = StrIn$
      Pt = Pt + lin
    End If
  End If

End Sub

Function DecFmt$(ByVal AnzNulls)

  If AnzNulls = 0 Then
    DecFmt$ = "#,##0"
  Else
    DecFmt$ = "#,##0." & String$(AnzNulls, "0")
  End If

End Function

Function DelRight$(s$, d$)

  Dim ld

  ld = Len(d$)

  If Right$(s$, ld) = d$ Then
    DelRight$ = Left$(s$, Len(s$) - ld)
  Else
    DelRight$ = s$
  End If

End Function

Function DropDblQuotes$(ByVal f$)

  'Remove leading and trailing "
  f$ = LTrim$(RTrim$(f$))

  If Len(f$) > 2 Then
    If Left$(f$, 1) = """" And Right$(f$, 1) = """" Then
      f$ = Mid$(f$, 2, Len(f$) - 2)
    End If
  End If

  DropDblQuotes$ = f$

End Function

Function Extract$(ExtrCmd, ByVal NewStr$, ByVal Sep$, EOS)

  'ExtrCmd: 0=extract only, 1=set+extract, 2=insert+extract
  '        -1=set only, -2=insert only

  Static s$
  Static ls As Long, lsep
  Static Pt1 As Long, Pt2 As Long

  lsep = Len(Sep$)

  Select Case Abs(ExtrCmd)
  Case 1      'set
    s$ = NewStr$
    ls = Len(s$)
    Pt1 = 1
  Case 2      'insert
    s$ = Left$(s$, Pt1 - 1) & NewStr$ & Mid$(s$, Pt1)
    ls = ls + Len(NewStr$)
  End Select

  If ExtrCmd < 0 Then Exit Function

  If ls = 0 Or Pt1 > ls Then
    Extract$ = ""
    s$ = ""           'Release string space
    ls = 0
    EOS = True
  Else
    If lsep = 0 Then
      'No separator -> get remainder of string
      Pt2 = ls + 1
    Else
      Pt2 = InStr(Pt1, s$, Sep$)
      If Pt2 = 0 Then Pt2 = ls + 1
    End If
    Extract$ = Mid$(s$, Pt1, Pt2 - Pt1)
    Pt1 = Pt2 + lsep
    EOS = False
  End If

End Function

Function IntVal(s$) As Long

  Dim i, n As Long


  IntVal = Val(s$)


End Function

Function LPad$(s$, Length)

  Dim l As Long

  l = Length - Len(s$)
  If l > 0 Then
    LPad$ = Space$(l) + s$
  Else
    LPad$ = s$
  End If

End Function

Function Parse$(Strg$, Sep$)

  Dim Ptr As Long

  Ptr = InStr(Strg$, Sep$)

  If Ptr = 0 Then
      Parse$ = Trim$(Strg$)
    Strg$ = ""
  Else
      Parse$ = Trim$(Left$(Strg$, Ptr - 1))
      Strg$ = Trim$(Mid$(Strg$, Ptr + Len(Sep$)))
  End If

End Function

Function ParseFileList$(l$)

  l$ = Trim$(l$)
  If Left$(l$, 1) = """" Then
    l$ = Mid$(l$, 2)
    ParseFileList$ = Parse$(l$, """")
  Else
    ParseFileList$ = Parse$(l$, " ")
  End If

End Function

Sub ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  'C:\AFU\HAMMAP\HAMMAP.EXE
  ' |           |      |
  ' n1          n2     n3
  'D$    P$       N$    E$

  Dim n1, n2, n3, NewDir, NewName

  '--- Laufwerk (Drive) suchen ---
  n1 = InStr(FileSpec$, ":")

  '--- Directory (Path) suchen (letztes '\') ---
  NewDir = n1
  Do
    n2 = NewDir
    NewDir = InStr(n2 + 1, FileSpec$, "\")
  Loop Until NewDir = 0

  '--- Dateinamen und Erweiterung trennen (letzter '.') ---
  NewName = n2
  Do
    n3 = NewName
    NewName = InStr(n3 + 1, FileSpec$, ".")
  Loop Until NewName = 0

  If n3 = n2 Then n3 = Len(FileSpec$) + 1

  d$ = Left$(FileSpec$, n1)
  p$ = Mid$(FileSpec$, n1 + 1, n2 - n1)
  n$ = Mid$(FileSpec$, n2 + 1, n3 - n2 - 1)
  e$ = "." + Mid$(FileSpec$, n3 + 1)

End Sub

Function Pc8toAnsi$(Pc8$)


  Dim Ansi$
  Dim void

  Ansi$ = Space$(Len(Pc8$))
  void = OemToAnsi(Pc8$, Ansi$)
  Pc8toAnsi$ = Ansi$


End Function

Function Quotes$(Txt$)

  Quotes$ = " '" + Txt$ + "'"

End Function

Function Replace$(ByVal Source$, ByVal Search$, ByVal Repl$)

  Dim Pt As Long
  Dim ls, lr
  Dim m$

  m$ = Source$
  ls = Len(Search$)
  lr = Len(Repl$)
  Pt = 1

  Do
'    Pt = InStr(Pt, UCase$(m$), UCase$(Search$))
    Pt = InStr(Pt, m$, Search$)
    If Pt = 0 Then Exit Do
    m$ = Left$(m$, Pt - 1) + Repl$ + Mid$(m$, Pt + ls)
    Pt = Pt + lr
  Loop

  Replace$ = m$

End Function

Function Rpad$(s$, Length)

  Dim l As Long

  l = Length - Len(s$)
  If l > 0 Then
    Rpad$ = s$ & Space$(l)
  Else
    Rpad$ = s$
  End If

End Function

Function sCtlVal(Ctl As Control) As Single

  sCtlVal = Val(Unformat$(Ctl.text))

End Function

Function StripBackSlash$(p$)

  If Right$(p$, 1) = "\" And p$ <> "\" Then
    StripBackSlash$ = Left$(p$, Len(p$) - 1)
  Else
    StripBackSlash$ = p$
  End If

End Function

Function SwapStr(s1$, s2$)

  '4 Byte String Descriptor = Address of String
  Dim SaveAddr As Long

  SaveAddr = StrPtr(s1$)
  CopyMemory ByVal VarPtr(s1$), ByVal VarPtr(s2$), 4
  CopyMemory ByVal VarPtr(s2$), SaveAddr, 4

End Function

Function Ucase16$(ByVal s$)

  Ucase16$ = s$

End Function

Function Unformat$(ByVal Txt$)

  Dim i, s$, t$

  If Len(Txt$) = 0 Then

    Unformat$ = "0"

  Else

    '1000-separator
    s$ = Mid$(Format$(1234, "0,000"), 2, 1)
    t$ = Replace$(Txt$, s$, "")

    'Decimal separator
    s$ = Mid$(Format$(0, "0.0"), 2, 1)
    i = InStr(t$, s$)
    If i > 0 Then Mid$(t$, i, 1) = "."

    Unformat$ = t$

  End If

End Function

