Attribute VB_Name = "ServerSub"
DefInt A-Z

'Deklarationen fr OLE
Public gClientNr As Integer
Public gcolClients As Collection

Sub ApiNotify(Mode, ByVal s$)


  Static Flag

  Dim Client As HAMMAP
  Dim iNotifyMask As Integer

  Dim iMask As Integer

  HV.FriendOLE = True

  iMask = 2 ^ (Mode - 1)
  s$ = Trim$(s$)

  If Not gcolClients Is Nothing Then
    For Each Client In gcolClients
      With Client
        iNotifyMask = .CallbackMask
        If iNotifyMask And iMask Then
          On Error Resume Next
          If .CallbackObject Is Nothing Then
            '--- Notify client using Events ---
            HV.FriendOLE = False
            .NotifyEvent Mode, s$
            HV.FriendOLE = True
          Else
            '--- Notify client using Callback Objects ---
            HV.FriendOLE = False
            .CallbackObject.Notify Mode, s$
            HV.FriendOLE = True
          End If
          If Err Then MsgBox Error$
          On Error GoTo 0
        End If
      End With
    Next Client
  End If

  HV.FriendOLE = False


  With DdeSource
    Select Case Mode
    Case 1
      .Station.Caption = s$
    Case 2
      .Ready.Caption = s$
    Case 3
      .Area.Caption = s$
    Case 4
      'Force Change
      If Flag Then s$ = s$ & " "
      .NewMap.Caption = s$
      Flag = Not Flag
    End Select
  End With

  DoEvents


End Sub

Sub CloseClients()

  '--- Stop all clients ---
  Dim Client As HAMMAP

  For Each Client In gcolClients
    With Client
      'On Error Resume Next
      HV.FriendOLE = True
      If .CallbackObject Is Nothing Then
        '--- Notify client using Events ---
        HV.FriendOLE = False
        .TerminateEvent
      Else
        '--- Notify client using Callback Objects ---
        HV.FriendOLE = False
        .CallbackObject.Terminate
      End If
      'On Error GoTo 0
      DoEvents
    End With
  Next Client

  For i& = gcolClients.Count To 1 Step -1
    gcolClients.Remove i&
  Next i&

  Set gcolClients = Nothing

  DdeSource.LinkMode = 0      'Cause DDE LinkClose Event
  DoEvents


End Sub

Sub InitShowOle()

  Dim NewShow
  Static OldShow

  NewShow = GV.DesignMode And (NumPar(35).Actual And 4096) <> 0

  If NewShow <> OldShow Then
    If NewShow Then
      Call InitTextForm("HAMMAP - API-Commands", "", True)
    End If
    Call ShowTextForm(NewShow, False)

    OldShow = NewShow
  End If

End Sub

Function OverlayFunction(CmdStr$, ClientName$, IsCmd, OverlayMode)

  m$ = ClientName$ & " Overlay-Transfer"

  ErrNr = 0
  IsCmd = False

  Cmd$ = CmdStr$

  If UCase$(Parse$(Cmd$, ":")) = "OVERLAY" Then
    OverlayMode = Val(Parse$(Cmd$, ","))

    Select Case OverlayMode
    Case -1     'Clear Foreground Overlay
      ForeOverlay$ = ""
      OverlayInfo$ = ""
      OverlayMode = 0
      HV.OvlErrFlag = False

    Case -2     'Clear Background Overlay
      BackOverlay$ = ""
      OverlayInfo$ = ""
      OverlayMode = 0
      HV.OvlErrFlag = False

    Case 0      'End Overlay Transfer
      Call ShowText("", 7, 0)

    Case 1, 2   'Begin Overlay Transfer
      Call ShowText(m$, 7, 0)
      If Len(Cmd$) = 0 Then
        If Len(OverlayInfo$) = 0 Then
          'Info von vorhergehenden Befehl nicht berschreiben
          OverlayInfo$ = ClientName$ & " Overlay"
        End If
      Else
        OverlayInfo$ = Cmd$
      End If


    Case Else   'Error
      ErrNr = 3  'bad parameter
    End Select

  Else

    Select Case OverlayMode
    Case 0
      IsCmd = True

    Case 1
      On Error Resume Next
      ForeOverlay$ = ForeOverlay$ & CmdStr$ & vbCrLf
      PrgErr = Err
      On Error GoTo 0
      Call ShowText(m$, 7, 0)

    Case 2
      On Error Resume Next
      BackOverlay$ = BackOverlay$ & CmdStr$ & vbCrLf
      PrgErr = Err
      On Error GoTo 0
      Call ShowText(m$, 7, 0)

    End Select

    If PrgErr Then ErrNr = -5

  End If

  OverlayFunction = ErrNr

End Function

Function ServerCommand(Remote, CmdStr$, ClientName$, Result$)

  Dim ErrNr
  Dim IsCmd
  Static OverlayMode

  ErrNr = OverlayFunction(CmdStr$, ClientName$, IsCmd, OverlayMode)
  If ErrNr Then
    Result$ = CStr(ErrNr)
  Else
    If IsCmd Then
      'Executable Command - no Overlay Function
      If HV.HMDisabled Then
        If Remote Then
          'Busy
          ErrNr = -1
          Result$ = "-1"
        Else
          'Overlay laden
          ErrNr = ApiCommandList(False, CmdStr$, Result$)
        End If
      Else
        Call PrepareFunction(True, 0)
        ErrNr = ApiCommandList(False, CmdStr$, Result$)
        Call TerminateFunction(0, 0&)
      End If
    Else
      Result$ = ""
    End If
  End If

  ServerCommand = ErrNr

End Function

Function ServerDdeCommand(CmdStr$)

  Static Result$
  Static OverlayMode

  If Len(CmdStr$) > 0 Then
    ClientName$ = DdeSource.ClientName.Caption
    If Len(ClientName$) = 0 Then ClientName$ = "DDE"
    ErrNr = ServerCommand(True, CmdStr$, ClientName$, Result$)
  Else
    ErrNr = 0
  End If

  ServerDdeCommand = (ErrNr <> 0)

  'DDE Transmits a maximum of 1024 Bytes
  If Len(Result$) <= 1024 Then
    DdeSource.Result.Caption = Result$
    Result$ = ""
  Else
    DdeSource.Result.Caption = Left$(Result$, 1024)
    Result$ = Mid$(Result$, 1025)
  End If

  If (NumPar(35).Actual And 128) = 0 Then DoEvents

End Function

Sub ShowOleClients()


  Dim Client As HAMMAP
  Dim Item As Variant

  If gcolClients.Count = 0 Then
    MsgBox "No OLE-Clients"
  Else

    HV.FriendOLE = True

    For Each Client In gcolClients
      With Client
        m$ = m$ & vbCrLf & "#" & Str$(.ClientNr) & " = " & .ClientName _
           & ", Mask = " & Hex$(.CallbackMask)
        If Not .CallbackObject Is Nothing Then
          m$ = m$ & ", Callback"
        End If
      End With
    Next Client

    MsgBox Mid$(m$, 3)

    HV.FriendOLE = False
  End If

End Sub

