Attribute VB_Name = "TipSub"
DefInt A-Z
Option Explicit

Function DrawGreatCircle(Dev As HMDevice, secP1in As lPoint, secP2in As lPoint)

  Dim NewPen As HMPen

  Dim secP1 As lPoint
  Dim secP2 As lPoint
  Dim degP1 As dGeoPoint
  Dim degP2 As dGeoPoint

  Dim secP As lPoint      'aktueller Punkt
  Dim devP As PointApi
  Dim olddevP As PointApi

  Dim tanB As Double, angle1rad As Double
  Dim l1rad As Double, b1rad As Double
  Dim dlrad As Double
  Dim dx As Long, oldsecx As Long

  Dim ErrNr, LastErr, Ok, c1, c2

  Const sec180 = 180# * cfDeg2Sec

  DrawGreatCircle = True

  ErrNr = PrepareMapDevices(1)
  If ErrNr Then Exit Function

  NewPen.Color = HV.ColVal(13)
  NewPen.Width = GetLineWidth(0, 11)
  NewPen.Style = 0

  ErrNr = SetPen(Dev, NewPen)
  If ErrNr Then Exit Function

  'Ausgabe soll immer von links nach rechts sein
  c1 = secP1in.x <= secP2in.x
  c2 = Abs(secP1in.x - secP2in.x) < sec180

  If c1 = c2 Then
    secP1 = secP1in
    secP2 = secP2in
  Else
    'P1 und P2 vertauschen
    secP1 = secP2in
    secP2 = secP1in
  End If

  degP1.l = secP1.x * cfSec2Deg
  degP1.b = secP1.y * cfSec2Deg
  degP2.l = secP2.x * cfSec2Deg
  degP2.b = secP2.y * cfSec2Deg


  If degP1.l = degP2.l Then

    'gleiche Lnge -> senkrechte Linie
    ErrNr = DrawLineGeo(Dev, secP1, secP2, NewPen)

  ElseIf Abs(degP1.l - degP2.l) = 180# Then

    'auf Erdkugel entgegengesetzt
    If degP1.b + degP2.b > 0 Then
      'Weg ber Nordpol
      secP.y = 90 * cfDeg2Sec
    Else
      'Weg ber Sdpol
      secP.y = -90 * cfDeg2Sec
    End If

    secP.x = secP1.x
    ErrNr = DrawLineGeo(Dev, secP1, secP, NewPen)   'P1-N/S
    secP.x = secP2.x
    ErrNr = DrawLineGeo(Dev, secP, secP2, NewPen)   'N/S-P2

  ElseIf Abs(degP1.b) = 90# Then

    'senkrechte Linie von P1 zum Nord-/Sdpol
    secP1.x = secP2.x
    ErrNr = DrawLineGeo(Dev, secP1, secP2, NewPen)

  ElseIf Abs(degP2.b) = 90# Then

    'senkrechte Linie von P2 zum Nord-/Sdpol
    secP2.x = secP1.x
    ErrNr = DrawLineGeo(Dev, secP1, secP2, NewPen)

  Else

    angle1rad = QthAngle(degP1, degP2) * deg2rad
    If angle1rad = 0# Then Exit Function  'Error

    l1rad = degP1.l * deg2rad
    b1rad = degP1.b * deg2rad


    'Schrittweite
    dx = 1 / Dev.PixelPerSecX

    'Anfangspunkt
    secP = secP1
    oldsecx = secP1.x
    ErrNr = secPoint2devPoint(HMCrt, secP, olddevP)
    LastErr = ErrNr

    Do
      secP.x = secP.x + dx
      If secP.x > sec180 Then secP.x = sec180   'avoid overflow

      If oldsecx <= secP2.x And secP.x >= secP2.x Then Exit Do
      oldsecx = secP.x

      '--- Breite berechnen ---
      dlrad = secP.x * cfSec2Rad - l1rad

      On Error Resume Next
      'Lsung nach Bronstein - Taschenbuch der Mathematik, 7. Auflage - 1967, S. 164 (5)
      'N=Nordpol, L=Lnge, B=Breite
      'c=Strecke(N:P1)=Pi/2-B1; A=Winkel(N:P1,N:P)=L-L1; B=Winkel(P1:N,P1:P)=Angle1
      'gesucht: b=Strecke(N:P)=Pi/2-Phi
      'Sin(A) * Ctg(B) = Ctg(b) * Sin(c) - Cos(A) * Cos(c)
      'Ctg(b) = (Sin(A) * Ctg(B) + Cos(A) * Cos(c)) / Sin(c)
      'Ctg(Pi/2-B) = (Sin(L-L1) * Ctg(Angle1) + Cos(L-L1) * Cos(Pi/2-B1)) / Sin(Pi/2-B1)
      'mit ctg(Pi/2-x)=tan(x); ctg(x)=1/tan(x); cos(HalfPi-x)=sin(x); sin(HalfPi-x)=cos(x)
      tanB = (Sin(dlrad) / Tan(angle1rad) + Cos(dlrad) * Sin(b1rad)) / Cos(b1rad)
      If Err = 0 Then secP.y = Atn(tanB) * rad2deg * cfDeg2Sec
      ErrNr = Err
      On Error GoTo 0

      If ErrNr = 0 Then ErrNr = secPoint2devPoint(HMCrt, secP, devP)

      If ErrNr = 0 And LastErr = 0 Then
        Ok = DrawLineDev(Dev, olddevP, devP, Dev.ActPen.Color)
      End If

      olddevP = devP

      If secP.x = sec180 Then
        'Wrap around
        secP.x = -sec180
        If ErrNr = 0 Then ErrNr = secPoint2devPoint(HMCrt, secP, olddevP)
      End If

      LastErr = ErrNr
    Loop

    'Verbindung zum Endpunkt
    ErrNr = secPoint2devPoint(HMCrt, secP2, devP)
    If ErrNr = 0 And LastErr = 0 Then
      Ok = DrawLineDev(Dev, olddevP, devP, Dev.ActPen.Color)
    End If

  End If

  ErrNr = TerminateAllDevices()

  DrawGreatCircle = False

End Function

Function GetDistrict$(Qth$)

  Dim SQL$, m$, void

  SQL$ = "Select Distinct Distrikt from tblLocator "
  SQL$ = SQL$ & "Where Locator = '" & Qth$ & "'"

  m$ = GetDBInfo$(SQL$, void)
  'If Len(m$) = 0 Then m$ = Msg$(19663)
  GetDistrict$ = Replace$(m$, vbCrLf, ", ")

End Function

Function GetGeoInfo$(Qth$)

  Dim SQL$, m$, void

  SQL$ = "Select Stadt from tblLocator "
  SQL$ = SQL$ & "Where Locator like '" & Qth$ & "*' Order by Stadt"

  m$ = GetDBInfo$(SQL$, void)
  If Len(m$) = 0 Then
    GetGeoInfo$ = Qth$ & ":" & vbCrLf & Msg$(19664)
  Else
    GetGeoInfo$ = Qth$ & ":" & vbCrLf & m$
  End If

End Function

Sub InitTip()

  With MapForm.Tip
    .FontSize = NumPar(50).Actual
    .FontBold = False    'fr Win16
    If NumPar(50).Actual >= 8 Then
      .FontName = "Arial"
    Else
      .FontName = "Small Fonts"
    End If
  End With

End Sub

Function MapTipInfo$(InfoNr As Long, pabs As PointApi)

  Static m$, LastQth$
  Dim Qth$, ErrNr, TipMode, ExtraNulls
  Dim pSec As lPoint      'Position in Sekunden
  Dim psel As lPoint
  Dim pDeg As dGeoPoint   'Position in Grad
  Dim MapDatum, MapCoSys, DegMinSec, mb$, ml$

  MapTipInfo$ = ""

  Call devPoint2degPoint(HMCrt, pabs, pDeg)
  If InfoNr > 1 Then
    pSec.y = Int(pDeg.b * cfDeg2Sec)
    pSec.x = Int(pDeg.l * cfDeg2Sec)
  End If

  '!!! bei zustzlichen Tips NumPar(47).Max erhhen !!!
  Select Case InfoNr
  Case 1      'Koordinaten
    'Ausgabe: erst Breite, dann Lnge
    MapDatum = NumPar(61).Actual
    MapCoSys = NumPar(60).Actual
    DegMinSec = NumPar(59).Actual
    ExtraNulls = -Int(Log(HMCrt.SecPerPixelX) / Log(10))
    If ExtraNulls < 0 Then ExtraNulls = 0

    ErrNr = dCoord2PosStr(MapDatum, MapCoSys, DegMinSec, ExtraNulls, pDeg, mb$, ml$)
    If ErrNr = 0 Then
      m$ = mb$ & vbCrLf & ml$
    Else
      m$ = Msg$(40210)
    End If

  Case 2      'Locator
    m$ = GetMouseInfo$(pDeg, 2)

  Case 3      'Entfernung und Richtung
    If HV.SelStnRec > 0 Then
      m$ = GetMouseInfo$(pDeg, 6)
    Else
      m$ = MapTipStn$(pSec)
    End If

  Case 4      'Grokreis
    If HV.SelStnRec > 0 Then
      'Restore Map - keep new Selection, keep Found
      ErrNr = RestoreMap(2, 1)
      'DoEvents
      psel.x = SelStnData.xloc * clQth2Sec
      psel.y = SelStnData.yloc * clQth2Sec

      MapForm.Tip.Visible = False
      ErrNr = DrawGreatCircle(HMCrt, psel, pSec)
      MapForm.Tip.Visible = True

      m$ = GetMouseInfo$(pDeg, 6)
      m$ = Replace$(m$, vbCrLf, " ")
      Call ShowText(m$, 7, 0)
      m$ = ""
    Else
      m$ = MapTipStn$(pSec)
    End If

  Case 5, 6
    'Tips aus Locator-Datenbank
    ErrNr = dDegCoord2Qth(pDeg, Qth$)
    If ErrNr Then Exit Function
    Qth$ = Left$(Qth$, 6)

    If Qth$ <> LastQth$ Then
      LastQth$ = Qth$
      Select Case NumPar(47).Actual   'ok v11
      Case 5      'District
        m$ = GetDistrict(Qth$)
      Case 6      'Geogr. Informationen
        m$ = GetGeoInfo$(Qth$)
      End Select
    End If

  Case 7 To 12     'Stationen
    TipMode = NumPar(47).Actual - 6
    ErrNr = FindStnByKoord(pSec, TipMode)
    If ErrNr Then Exit Function
    m$ = Mid$(gblTipInfo$, 3)

  Case 13 To 15     'Route
    TipMode = NumPar(47).Actual - 13
    m$ = MapTipRoute$(pSec, TipMode)

  Case Else
    m$ = "Illegal Tip-Mode"
  End Select

  MapTipInfo$ = m$

End Function

Function MapTipRoute$(secP As lPoint, TipMode)

  Static RouteShown, LastStart, LastEnd
  Dim m$, RouteOk, ErrNr
  Dim StartRec, EndRec, RouteFound
  Dim LnkRec, AnzLnk, NextLink
  Dim SrcRec, DstRec, Fastest
  Dim DstCall$, LineNr$
  Dim StnCall As StationCall


  If SV.Out.StnHdr.AnzLnkRec < 2 Then

    'keine Link-Daten geladen
    m$ = Msg$(24216)

  ElseIf HV.SelStnRec = 0 Then

    'keine Station selektiert
    m$ = MapTipStn$(secP)

  Else

    'Get Destination Station
    ErrNr = FindStnByKoord(secP, -1)
    If ErrNr Then
      m$ = "Error"
    ElseIf Len(gblTipInfo$) = 0 Then
      'keine Zielstation
      m$ = Msg$(24223)
    Else
      'Start- + End-Station
      StartRec = HV.SelStnRec
      EndRec = Val(gblTipInfo$)

      ErrNr = GetStationCall(EndRec, StnCall)
      Call DecodeCall(StnCall, DstCall$, LineNr$)

      Fastest = (NumPar(42).Actual And 16) <> 0
      ErrNr = FindRoute(Fastest, StartRec, EndRec, "", RouteFound)
      If ErrNr Then
        m$ = "Error"
      ElseIf RouteFound = 0 Then
        'keine Route
        If StartRec = EndRec Then
          m$ = DstCall$
        Else
          m$ = DstCall$ & " - " & Msg$(24221)
        End If
        If TipMode > 0 Then Call ShowFound(0)
      Else
        RouteOk = True
        RouteShown = True

        If TipMode = 0 Then
          m$ = GetRouteCalls$(EndRec)
          m$ = Replace$(m$, ", ", vbCrLf)
        Else
          m$ = ""
          If StartRec <> LastStart Or EndRec <> LastEnd Then
            LastStart = StartRec
            LastEnd = EndRec
            MapForm.Tip.Visible = False

            'Restore Map - keep new Selection
            ErrNr = RestoreMap(2, 0)
            'DoEvents
            ErrNr = ShowRoute(True, EndRec)
            If ErrNr = 0 Then
              Call ShowFound(2)
              If TipMode > 0 Then
                Call DrawFound(TipMode)
              End If
            End If
          End If
        End If
      End If

      '--- Speicher freigeben ---
      Call EraseRoutes

    End If
  End If

  If RouteOk = False And TipMode > 0 Then
    If RouteShown Then
      RouteShown = False
      'Restore Map - keep new Selection
      ErrNr = RestoreMap(2, 0)
      Call ShowFound(0)
      LastStart = 0
      LastEnd = 0
    End If
  End If

  MapTipRoute$ = m$

End Function

Sub MapTipShow(Pnt As PointApi, ByVal m$)


  With MapForm.Tip

    '--- Tip Position ---
    If Len(m$) = 0 Then

      'DoEvents
      .Visible = False
      .Refresh

    Else

      .Visible = True
      .Caption = m$

      If Pnt.x + HV.CursorWidth + .Width < HMCrt.MapRect.Right - 1 Then
        Pnt.x = Pnt.x + HV.CursorWidth
      Else
        Pnt.x = Pnt.x - .Width - HV.CursorWidth / 4
      End If

      If Pnt.y + .Height >= HMCrt.MapRect.Bottom Then
        Pnt.y = Pnt.y - .Height
      End If

      .Move Pnt.x, Pnt.y

      'MapForm.Refresh
      'DoEvents

    End If
  End With


End Sub

Function MapTipStn$(secP As lPoint)

  Dim ErrNr

  ErrNr = FindStnByKoord(secP, 1)
  If ErrNr Then
    MapTipStn$ = "Error"
  ElseIf Len(gblTipInfo$) = 0 Then
    'keine Station angewhlt
    MapTipStn$ = Msg$(24211)
  Else
    'Nicht ausgewhlt...
    MapTipStn$ = Msg$(24222) & ":" & vbCrLf & Mid$(gblTipInfo$, 3)
  End If

End Function

Sub TipTimerEvent()

  Static Busy, TipShown
  Static LastX As Long, LastY As Long
  Dim Pnt As PointApi
  Dim WinHnd As Long, MouseInMap As Integer
  Dim m$, p&, ErrNr

  'Prevent recursive calls
  If Busy Then Exit Sub

  Busy = True

  '--- Prfen, ob Maus im Client-Bereich der Karte ---
  With MapForm
    MouseInMap = False
    Call GetCursorPos(Pnt)        'Maus-Koordinaten
    WinHnd = WindowFromPoint&(Pnt.x, Pnt.y)
    If WinHnd = .hWnd Then
      Call ScreenToClient(.hWnd, Pnt)
      If PointInRect(Pnt, HMCrt.MapRect) Then MouseInMap = True
    End If

    If Not MouseInMap Then
      If TipShown Then
        'Restore Map - keep new Selection
        Select Case NumPar(47).Actual   'ok v11
        Case 4
          ErrNr = RestoreMap(2, 1)    'Grokreis lschen
        Case 14 To 15
          ErrNr = RestoreMap(2, 2)    'Route lschen
        End Select
        Call MapTipShow(Pnt, "")
        TipShown = False
      End If
    Else
      'Prfen, ob sich Position verndert hat oder neue Information
      If Pnt.x <> LastX Or Pnt.y <> LastY Or HV.NewTip Then
        LastX = Pnt.x
        LastY = Pnt.y
        HV.NewTip = False

        m$ = MapTipInfo$(NumPar(47).Actual, Pnt)
        Call MapTipShow(Pnt, m$)
        TipShown = True
      End If
    End If

  End With

  Busy = False

End Sub

