Attribute VB_Name = "ToolBarSub"
DefInt A-Z


Const AnzToolbars = 4

Dim RightClickToolBarNr
Dim StnRecNr()
Dim LnkRecNr()

Sub CheckToolbarText()

  If NumPar(53).Actual And 4 Then

    With HmForm.StnList
      If Len(.text) = 0 Then
        .text = .Tag
      End If
    End With

    With HmForm.LnkList
      If Len(.text) = 0 Then
        .text = .Tag
      End If
    End With

  End If

End Sub

Sub InitPlaceHolder()

  'Station-Label
  With HmForm.HMToolbar(2).Buttons("StnLabel")
    HmForm.StnLabel.Move .Left + 20, .Top + 50, .Width - 50
  End With

  'Station-List
  With HmForm.HMToolbar(2).Buttons("StnList")
    HmForm.StnList.Move .Left + 20, .Top, .Width - 50
  End With

  'Link-Label
  With HmForm.HMToolbar(2).Buttons("LnkLabel")
    HmForm.LnkLabel.Move .Left + 100, .Top + 50, .Width - 120
  End With

  'Link-List
  With HmForm.HMToolbar(2).Buttons("LnkList")
    HmForm.LnkList.Move .Left + 20, .Top, .Width - 50
  End With

End Sub

Sub InitToolbars()

  '--- One-time Toolbar initialization ---

  'Dim btn As ComctlLib.Button
  Dim btn As Button

  With HmForm
    'Popup-Menu
    Call SetMsgMode(1)
    i = 1
    Do
      m$ = Parse$(Msg$(28300 + i), "(")
      If Len(m$) = 0 Then Exit Do
      On Error Resume Next
      Load .pumnuToolbar(i)
      On Error GoTo 0
      Call SetMenuItem(.pumnuToolbar(i), m$)
      Select Case i
      Case 3 To 7
        .pumnuToolbar(i).Visible = False
      End Select
      i = i + 1
    Loop
    Call SetMsgMode(0)


    '--- Set Tooltiptext ---
    For i = 0 To AnzToolbars - 1
      For Each btn In .HMToolbar(i).Buttons
        Select Case btn.Style
        Case tbrDefault, tbrCheck, tbrButtonGroup
          If i = 3 Then
            m$ = StdMsg$(24700 + btn.Index - 1)
          Else
            m$ = StdMsg$(28000 + i * 30 + btn.Index)
          End If
          btn.Description = m$
          btn.ToolTipText = m$
        End Select
      Next btn

      .HMToolbar(i).AllowCustomize = False

    Next i

    '--- Placeholder ---
    .StnLabel.ZOrder 0
    .StnLabel.text = " " & Msg$(28061)
    void = SetReadOnly(.StnLabel, True)

    .StnList.ZOrder 0
    .StnList.ToolTipText = Msg$(28063)

    .LnkLabel.ZOrder 0
    .LnkLabel.text = Msg$(28066)
    void = SetReadOnly(.LnkLabel, True)

    .LnkList.ZOrder 0
    .LnkList.ToolTipText = Msg$(28068)

    .HMToolbar(3).Buttons("District").Visible = HasDBModule
    .HMToolbar(3).Buttons("GeoInfo").Visible = HasDBModule

    .HMToolbar(0).Buttons("SelStn").Value = tbrPressed
  End With

  Set btn = Nothing

  Call RestoreToolbars

End Sub

Sub MainToolbarFunctions(ByVal Button As ComctlLib.Button)

  With MapForm
    BtnIdx = Button.Index
    Select Case BtnIdx
    Case 2 To AnzToolbars
      OldPar& = NumPar(53).Actual
      If OldPar& And 32 Then
        NumPar(53).Actual = OldPar& Xor 2 ^ (BtnIdx - 1)
      Else
        NumPar(53).Actual = (OldPar& And Not 14&) Or 2 ^ (BtnIdx - 1)
      End If
      Call SetToolbars
      ResizeHMForm = True
    End Select

    Select Case Button.Key
    Case "ScrollBar"
      'Scrollbar-Anzeige wurde gendert
      ResizeMapForm = True
      NumPar(53).Actual = NumPar(53).Actual Xor 128
      Call ScrollBarEnbl

    Case "StnWindow"
      'Stations-Fenster-Anzeige wurde gendert
      ResizeHMForm = True
      NumPar(53).Actual = NumPar(53).Actual Xor 256
      Call AuxFormEnbl

    Case "SelStn"
      HV.MouseFunctionMode = 0
      Call MapTipEnbl(True, False)

    Case "Enlarge"
      HV.MouseFunctionMode = 1
      Call MapTipEnbl(False, True)

    Case "Reduce"
      HV.MouseFunctionMode = 2
      Call MapTipEnbl(False, True)

    Case "FillWater"
      HV.MouseFunctionMode = 3
      Call MapTipEnbl(False, True)
    End Select

    Call SetMouseIcon

  End With

  If ResizeHMForm Then
    Call HMFormResize
  ElseIf ResizeMapForm Then
    Call MapFormResize
  End If

End Sub

Sub MapToolbarFunctions(ByVal Button As ComctlLib.Button)

  If Button.Key <> "Zoom" Then
    Call PrepareFunction(True, 0)
  End If

  With HmForm.HMToolbar(1)

    Select Case Button.Key
    Case "ZoomIn"
      Call CmdZoomInOut(0.5)

    Case "ZoomOut"
      Call CmdZoomInOut(2)

    Case "Zoom"
      Call InitializeZoom

    Case "NewMap"
      Call ClearMap

    Case "PrintMap"
      If IsPrinterInstalled() Then
        Call PrintCmd(2)        'direkt drucken
      End If

    Case "MoveLeft"
      Call CmdZoomMove("L", 0.25)

    Case "MoveRight"
      Call CmdZoomMove("R", 0.25)

    Case "MoveUp"
      Call CmdZoomMove("U", 0.25)

    Case "MoveDown"
      Call CmdZoomMove("D", 0.25)

    Case "ShowStn"
      If Button.Value Then
        NumPar(9).Actual = NumPar(9).Actual Or ME_Stn
      Else
        NumPar(9).Actual = NumPar(9).Actual And Not (ME_Stn Or ME_StnCalls)
        .Buttons("MarkStn").Value = tbrUnpressed
      End If
      Call NewMap

    Case "MarkStn"
      If Button.Value Then
        NumPar(9).Actual = NumPar(9).Actual Or (ME_Stn Or ME_StnCalls)
        .Buttons("ShowStn").Value = tbrPressed
      Else
        NumPar(9).Actual = NumPar(9).Actual And Not ME_StnCalls
      End If
      Call NewMap

    Case "ShowLinks"
      If Button.Value Then
        NumPar(9).Actual = NumPar(9).Actual Or ME_Links
      Else
        NumPar(9).Actual = NumPar(9).Actual And Not ME_Links
      End If
      Call NewMap

    Case "ShowGrid"
      If Button.Value = tbrPressed Then
        'Gitter ohne Beschriftung ausgeben
        NumPar(9).Actual = NumPar(9).Actual Or ME_Grid
      Else
        'Gitter garnicht mehr ausgeben
        .Buttons("ShowLocator").Value = tbrUnpressed
        NumPar(9).Actual = NumPar(9).Actual And Not (ME_Grid Or ME_GridNames)
      End If
      Call NewMap

    Case "ShowLocator"
      If Button.Value = tbrPressed Then
        'Gitter mit Beschriftung ausgeben
        .Buttons("ShowGrid").Value = tbrPressed
        NumPar(9).Actual = NumPar(9).Actual Or (ME_Grid Or ME_GridNames)
      Else
        'Locator-Beschriftung nicht mehr ausgeben
        NumPar(9).Actual = NumPar(9).Actual And Not ME_GridNames
      End If
      Call NewMap

    Case "ShowTowns"
      If Button.Value = tbrPressed Then
        'Stdte ohne Beschriftung ausgeben
        NumPar(9).Actual = NumPar(9).Actual Or ME_Towns
      Else
        'Stdte garnicht mehr ausgeben
        .Buttons("ShowTownNames").Value = tbrUnpressed
        NumPar(9).Actual = NumPar(9).Actual And Not (ME_Towns Or ME_TownNames)
      End If
      Call NewMap


    Case "ShowTownNames"
      If Button.Value = tbrPressed Then
        'Stdte mit Beschriftung ausgeben
        .Buttons("ShowTowns").Value = tbrPressed
        NumPar(9).Actual = NumPar(9).Actual Or (ME_Towns Or ME_TownNames)
      Else
        'Stdte-Beschriftung nicht mehr ausgeben
        NumPar(9).Actual = NumPar(9).Actual And Not ME_TownNames
      End If
      Call NewMap


    Case "ShowRivers"
      If Button.Value = tbrPressed Then
        NumPar(9).Actual = NumPar(9).Actual Or (ME_Rivers Or ME_Canals)
      Else
        NumPar(9).Actual = NumPar(9).Actual And Not (ME_Rivers Or ME_Canals)
      End If
      Call NewMap


    Case "ShowCoast"      'Inseln, Seen
      If Button.Value = tbrPressed Then
        NumPar(9).Actual = NumPar(9).Actual Or ME_Lakes
      Else
        NumPar(9).Actual = NumPar(9).Actual And Not ME_Lakes
      End If
      Call NewMap


    Case "ShowMountains"
      If Button.Value = tbrPressed Then
        'Berge ohne Beschriftung ausgeben
        NumPar(9).Actual = NumPar(9).Actual Or ME_Mountains
      Else
        'Berge garnicht mehr ausgeben
        .Buttons("ShowMountainNames").Value = tbrUnpressed
        NumPar(9).Actual = NumPar(9).Actual And Not (ME_Mountains Or ME_MtnNames)
      End If
      Call NewMap


    Case "ShowMountainNames"
      If Button.Value = tbrPressed Then
        'Berge mit Beschriftung ausgeben
        .Buttons("ShowMountains").Value = tbrPressed
        NumPar(9).Actual = NumPar(9).Actual Or (ME_Mountains Or ME_MtnNames)
      Else
        'Berg-Beschriftung nicht mehr ausgeben
        NumPar(9).Actual = NumPar(9).Actual And Not ME_MtnNames
      End If
      Call NewMap


    Case Else
      Stop
    End Select

  End With

  If Button.Key <> "Zoom" Then
    Call TerminateFunction(0, 0&)
  End If

End Sub

Sub MouseToolbarFunctions(ByVal Button As ComctlLib.Button)

  Call MapTipEnbl(False, True)


  NumPar(47).Actual = Button.Index - 1


  Call MapTipEnbl(True, False)

End Sub

Sub RestoreToolbars()


End Sub

Sub SaveToolbars()


End Sub

Sub SetMainToolBar()

  HmForm.HMToolbar(0).Buttons(HV.MouseFunctionMode + 9).Value = tbrPressed

End Sub

Sub SetMapToolbar()

  With HmForm.HMToolbar(1)

    '--- Karten-Inhalt ---
    .Buttons("ShowCoast").Value = Sgn(NumPar(9).Actual And ME_Lakes)
    .Buttons("ShowRivers").Value = Sgn(NumPar(9).Actual And (ME_Rivers Or ME_Canals))

    .Buttons("ShowTowns").Value = Sgn(NumPar(9).Actual And (ME_Towns Or ME_TownNames))
    .Buttons("ShowTownNames").Value = Sgn(NumPar(9).Actual And ME_TownNames)

    .Buttons("ShowMountains").Value = Sgn(NumPar(9).Actual And (ME_Mountains Or ME_MtnNames))
    .Buttons("ShowMountainNames").Value = Sgn(NumPar(9).Actual And ME_MtnNames)

    .Buttons("ShowGrid").Value = Sgn(NumPar(9).Actual And (ME_Grid Or ME_GridNames))
    .Buttons("ShowLocator").Value = Sgn(NumPar(9).Actual And ME_GridNames)

    .Buttons("ShowStn").Value = Sgn(NumPar(9).Actual And ME_Stn)
    .Buttons("MarkStn").Value = Sgn(NumPar(9).Actual And ME_StnCalls)
    .Buttons("ShowLinks").Value = Sgn(NumPar(9).Actual And ME_Links)


    'Disable Buttons for Bitmap map
    Enbl = HV.MapType < 2
    .Buttons("ShowCoast").Visible = Enbl
    .Buttons("ShowRivers").Visible = Enbl
    .Buttons("ShowTowns").Visible = Enbl
    .Buttons("ShowTownNames").Visible = Enbl
  End With

End Sub

Sub SetMouseIcon()

  With MapForm

    If HV.MouseFunctionMode = 0 Then
      .MousePointer = 0
      .MouseIcon = LoadPicture("")
      .MapHScroll.MousePointer = 0
      .MapVScroll.MousePointer = 0
    Else
      .MouseIcon = LoadResPicture(100 + HV.MouseFunctionMode, 2)
      .MousePointer = 99
      .MapHScroll.MousePointer = 1      'Arrow
      .MapVScroll.MousePointer = 1
    End If

  End With

  DoEvents

End Sub

Sub SetMouseToolbar()


  HmForm.HMToolbar(3).Buttons(NumPar(47).Actual + 1).Value = tbrPressed


End Sub

Sub SetPlaceholderWidth(NewWidth)

  Dim btn As Button

  For Each btn In HmForm.HMToolbar(2).Buttons
    If btn.Style = tbrPlaceholder Then
      btn.Width = NewWidth
    End If
  Next btn

  HmForm.HMToolbar(2).Refresh

End Sub

Sub SetToolbars()

  'Dim btn As ComctlLib.Button
  Dim btn As Button

  With HmForm
    With .HMToolbar(0)

      '--- Vertical Toolbar: Button Style and Value ---

      If (NumPar(53).Actual And 32) = 0 Then
        'Verify single Symbolbar selection
        If NumPar(53).Actual And 2 Then
          NumPar(53).Actual = NumPar(53).Actual And Not 12&
        ElseIf NumPar(53).Actual And 4 Then
          NumPar(53).Actual = NumPar(53).Actual And Not 8&
        End If
      End If

      For i = 2 To AnzToolbars
        Set btn = .Buttons(i)
        If NumPar(53).Actual And 32 Then
          btn.Style = tbrCheck
        Else
          btn.Style = tbrButtonGroup
        End If
      Next i

      Mask = 2
      For i = 2 To AnzToolbars
        Set btn = .Buttons(i)
        If NumPar(53).Actual And Mask Then
          btn.Value = tbrPressed
        Else
          btn.Value = tbrUnpressed
        End If
        Mask = Mask * 2
      Next i

      With .Buttons("ScrollBar")
        If NumPar(53).Actual And 128 Then
          .Value = tbrPressed
        Else
          .Value = tbrUnpressed
        End If
      End With

      With .Buttons("StnWindow")
        If NumPar(53).Actual And 256 Then
          .Value = tbrPressed
        Else
          .Value = tbrUnpressed
        End If
      End With
    End With

    Mask = 1
    For i = 0 To AnzToolbars - 1
      With .HMToolbar(i)
        '--- Show Toolbars ---
        .Visible = (Mask And NumPar(53).Actual) <> 0
        Mask = Mask * 2

        '--- Set Images ---
        If NumPar(53).Actual And 64 Then
          .ImageList = ImageForm.BigImages
        Else
          .ImageList = ImageForm.SmallImages
        End If

        'On Error Resume Next
        For Each btn In .Buttons
          Select Case btn.Style
          Case tbrDefault, tbrCheck, tbrButtonGroup
            If Len(btn.Key) = 0 Then
              Stop
            Else
              'Use button key also as image key
              btn.Image = btn.Key
            End If
          End Select
        Next btn
        'On Error GoTo 0

        If i = 0 Then
          .Width = .ButtonWidth
        Else
          .Height = .ButtonHeight
        End If
        .Refresh
      End With
    Next i

    'Symbole in senkrechtem Toolbar immer an der gleichen Stelle
    '  (Werte durch probieren ermittelt)
    With .HMToolbar(0)
      .Buttons(1).Width = (2000 - 1.5 * .Top)
    End With
  End With

  'Watchdog for updating StnList and LnkList in Station-Toolbar
  HV.MapFormProgResize = True
  MapForm.Watchdog.Enabled = (NumPar(53).Actual And 4) <> 0
  HV.MapFormProgResize = False

  Call InitPlaceHolder

  Set btn = Nothing

End Sub

Sub StnToolbarFunctions(ByVal Button As ComctlLib.Button)

  With HmForm.HMToolbar(1)

    Select Case Button.Key
    Case "FindStn"
      Call SelectStnByCall

    Case "StnInfo"
      If HV.SelStnRec <> 0 Then
        ErrNr = GetLongStationInfo(HV.SelStnRec, m$)
        If ErrNr = 0 Then MsgBox m$, 8
      End If

    Case "FindRoute"
      Cancel = SelectRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)
      If Cancel Then Exit Sub
      Call MakeRoute(StartRec, EndRec, NotViaList$, Fastest, Mark)

    Case "LnkInfo"
      If HV.SelStnRec And HV.SelLnkRec <> 0 Then
        ErrNr = GetLinkInfo(HV.SelStnRec, HV.SelLnkRec, m$)
        If ErrNr = 0 Then MsgBox m$, 8
      End If

    End Select

  End With

End Sub

Sub ToolbarFunctions(Index As Integer, ByVal Button As ComctlLib.Button)

  Select Case Index
  Case 0
    Call MainToolbarFunctions(Button)

  Case 1
    Call MapToolbarFunctions(Button)

  Case 2
    Call StnToolbarFunctions(Button)

  Case 3
    Call MouseToolbarFunctions(Button)

  Case Else
    Stop
  End Select

End Sub

Sub ToolbarMenuFunctions(Index)

  With HmForm

    Select Case Index
    Case 1        'Groe Symbole
      NumPar(53).Actual = NumPar(53).Actual Xor 64
      Call SetToolbars
      DoEvents
      'Call SaveToolbars
      Call HMFormResize

    Case 2        'Mehrere Symbolleisten
      NumPar(53).Actual = NumPar(53).Actual Xor 32
      Call SetToolbars
      DoEvents
      Call HMFormResize

    Case 8      '-
    Case 9      'Hilfe
      void = ShowHelp("HAMMAP-Toolbars")

    End Select

  End With

End Sub

Sub ToolbarRightClick(Index)

  RightClickToolBarNr = Index

  With HmForm
    .pumnuToolbar(1).Checked = (NumPar(53).Actual And 64) <> 0
    .pumnuToolbar(2).Checked = (NumPar(53).Actual And 32) <> 0


    .PopupMenu HmForm.mnuToolBar, 2
  End With

End Sub

Sub ToolbarSelectLink()

  Call PrepareFunction(True, 0)

  With HmForm.LnkList
    Item = .ListIndex + 1
    If Item > 0 Then
      void = SelectLink(LnkRecNr(Item))
    Else
      .text = .Tag
    End If
  End With

  Call TerminateFunction(0, 0&)

End Sub

Sub ToolbarSelectStn()

  Call PrepareFunction(True, 0)

  With HmForm.StnList
    Item = .ListIndex + 1
    If Item > 0 Then
      void = SelectStation(StnRecNr(Item), True)
    Else
      .text = .Tag
    End If

  End With

  Call TerminateFunction(0, 0&)

End Sub

Sub ToolbarShowFound(FoundMode)

  'FoundMode: 0=nur loeschen, 1=Digis, 2=Route, 3=Links

  If HV.AnzFound <= HV.MaxFound Then
    AnzShow = HV.AnzFound
  Else
    AnzShow = HV.MaxFound                        '1...AnzShow
  End If

  '--- Ausgabebereich loeschen ---
    '.Refresh

    Select Case FoundMode
    Case 0           'nur lschen
      With HmForm.StnList
        If .ListCount > 0 Then
          .Clear
        End If
        '.Text = Msg$(28200)
        '.Tag = .Text
      End With

      With HmForm.LnkList
        If .ListCount > 0 Then .Clear
        .text = Msg$(28200)
        '.text = ""
        .Tag = .text
      End With

      'HmForm.LnkLabel.text = ""


    Case 1           'Digis
      With HmForm.StnList
        If .ListCount > 0 Then .Clear
        .text = Msg$(28201)
        .Tag = .text
        ReDim StnRecNr(1 To AnzShow)

        For i = 1 To AnzShow
          .AddItem ShowCall$(i)
          StnRecNr(i) = StnFnd(i).StnRec
        Next i
      End With

    Case 2, 3          'Route, Links
      '--- Titel je nach Found-Mode ausgeben ---
      'AuxForm.ListLabel.Caption = Msg$(24600 + FoundMode)
      HmForm.LnkLabel.text = Msg$(24600 + FoundMode)

      With HmForm.LnkList
        If .ListCount > 0 Then .Clear

        Select Case HV.AnzFound
        Case 0
          .text = Msg$(28200)
        Case 1
          .text = ShowCall(1)
          void = SelectLink(StnFnd(1).LnkRec)
        Case Else
          .text = Msg$(28200 + FoundMode)
          ReDim LnkRecNr(1 To AnzShow)
          For i = 1 To AnzShow
            .AddItem ShowCall$(i)
            If FoundMode = 2 Then
              LnkRecNr(i) = StnFnd(AnzShow - i + 1).LnkRec
            Else
              LnkRecNr(i) = StnFnd(i).LnkRec
            End If
          Next i
        End Select
        .Tag = .text
      End With
    End Select

End Sub

Sub ToolbarShowSelectedLink()

  If HV.SelLnkRec = 0 Then
    s$ = Msg$(28200)
    With HmForm.LnkList
      .Clear
      .text = s$
      .Tag = s$
      .Refresh
    End With
  Else
    s$ = SelDstCall$
  End If

  With HmForm
    .HMToolbar(2).Buttons("LnkInfo").Enabled = _
      (HV.SelLnkRec <> 0) And HV.FoundMode = 3
  End With

End Sub

Sub ToolbarShowSelectedStn()

  If HV.SelStnRec = 0 Then
    s$ = Msg$(28200)
  Else
    s$ = SelStnCall$
  End If

  With HmForm
    With .StnList
      .text = s$
      .Tag = s$
    End With

    .HMToolbar(2).Buttons("StnInfo").Enabled = (HV.SelStnRec <> 0)
  End With

End Sub

