Attribute VB_Name = "TxtDsp"
'---------------------------- TXTFRM.BAS ----------------------------

'Textform-Ausgabe Unterprogramme
'von Gerhard Berg, DJ6FM


DefInt A-Z

Sub AppendTextForm(m$)

  With TextForm.TextField
    .SelStart = Len(.text)
    .SelLength = 0
    .SelText = m$
  End With

End Sub

Sub InitTextForm(Title$, text$, MnuEnbl)

  Load TextForm

  With TextForm
    .Caption = Title$
    .mnuClose.Caption = Msg$(25070)
    .mnuFont.Caption = Msg$(25071)
    .mnuPrint.Caption = Msg$(25072)

    .mnuClose.Visible = MnuEnbl
    .mnuPrint.Visible = MnuEnbl

    If Len(text$) <= 30000 Then
      .TextField.text = text$
    Else
      .TextField.text = Right$(text$, 30000)
    End If

    .FontName = .TextField.FontName
    .FontSize = .TextField.FontSize
    .FontBold = .TextField.FontBold

    .WindowState = 0
    MaxWidth = 85 * .TextWidth("X")
    .Width = lMin(MaxWidth, 0.9 * Screen.Width)
    .Height = 0.8 * Screen.Height
    Call CenterForm(TextForm)

  End With

End Sub

Sub PrintText(ByVal Title$, ByVal Txt$)


  With Printer

    TopMargin! = 1.5
    LeftMargin! = 2.5

    .FontName = TextForm.TextField.FontName
    .FontSize = 9
    .FontItalic = False

    .ScaleMode = 7       'cm
    .ScaleTop = -TopMargin!
    .ScaleLeft = -LeftMargin!

    .CurrentX = 0
    .CurrentY = 0

    .FontBold = True
    Printer.Print Title$
    .FontBold = False
    Printer.Print

    Do Until Len(Txt$) = 0
      If .CurrentY >= .ScaleHeight - 2 * TopMargin! Then
        .NewPage
        .CurrentX = 0
        .CurrentY = 0
      End If

      'Parse geht nicht, da fhrende Leerzeichen gedruckt werden mssen
      Ptr = InStr(Txt$, vbCrLf)

      If Ptr = 0 Then
        l$ = Txt$
        Txt$ = ""
      Else
        l$ = Left$(Txt$, Ptr - 1)
        Txt$ = Mid$(Txt$, Ptr + 2)
      End If

      Printer.Print l$
    Loop

    .EndDoc
  End With


End Sub

Function ShowHelp(Section$)

  ShowHelp = ShowSection(HlpFile$, Section$, 0)

End Function

Function ShowSection(FileName$, SectName$, Mode)

  ShowSection = True

  '----- Bereich einlesen ------
  Screen.MousePointer = 11
  ErrNr = GetSection(FileName$, SectName$, True, SectData$, AnzDataLines, Found)
  Screen.MousePointer = 0
  If ErrNr Then Exit Function

  '----- Titel und Font ------
  Title$ = Parse$(SectData$, vbCrLf)

  Cmd$ = UCase$(Title$)
  If Parse$(Cmd$, "=") = "$FONT" Then
    n$ = Parse$(Cmd$, ",")
    s! = Val(Parse$(Cmd$, ","))
    b% = Cmd$ = "BOLD"

    Title$ = Parse$(SectData$, vbCrLf)
  Else
    n$ = "Courier New"
    s! = 8.25
    b% = True
  End If

  With TextForm.TextField
    On Error Resume Next
    .FontName = n$
    .FontSize = s!
    .FontBold = b%
    On Error GoTo 0
  End With

  Title$ = Pc8toAnsi$(Title$)
  SectData$ = Pc8toAnsi$(SectData$)

  '--- Text ausgeben ---
  Call InitTextForm(Title$, SectData$, True)
  Call ShowTextForm(True, Mode)

  ShowSection = False

End Function

Sub ShowTextForm(Display, Mode)

  If Display Then
    TextForm.TextField.SelStart = 0

    On Error Resume Next
    TextForm.Show Mode
    ErrNr = Err
    On Error GoTo 0
    'If modeless is not possible, then show modal
    If ErrNr Then TextForm.Show 1

    'Paint-Event zulassen (modeless)
    void = DoEvents()
  Else
    TextForm.Hide
  End If

  If Mode = 1 Or Display = 0 Then
    If GV.TopForm = 1 Then GV.TopForm = 0
    Unload TextForm
    Set TextForm = Nothing
  End If

End Sub

