Attribute VB_Name = "TYPEDEF"
'--------------------------- TYPDEF_I.BAS ------------------------------

'Globale HAMMAP Definitionen
'von Gerhard Berg, DJ6FM


'--------------------- Kartendaten --------------------

Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Type PointApi
  x As Long
  y As Long
End Type

Type SizeApi
  x As Long
  y As Long
End Type


Type lPoint
  x As Long
  y As Long
End Type

Type dGeoPoint
  l As Double     'Lnge
  b As Double     'Breite
  h As Double       'Hoehe
  hNN As Double     'Hoehe ueber NN
End Type

Type degAreaType
  bmin As Double                'min. Breite in Grad
  bmax As Double                'max. Breite
  lMin As Double                'min. Lnge
  lMax As Double                'max. Lnge
End Type

Type lAreaType    'in Sekunden
  lxmin As Long                'min. x-Koordinate
  lxmax As Long                'max. x-Koordinate
  lymin As Long                'min. y-Koordinate
  lymax As Long                'max. y-Koordinate
End Type

Type lMsecAreaType    'in Milli-Sekunden (1 msec = 1/1000 sec)
  lxmin As Long                'min. x-Koordinate
  lxmax As Long                'max. x-Koordinate
  lymin As Long                'min. y-Koordinate
  lymax As Long                'max. y-Koordinate
End Type

Type iAreaType
  ixmin As Integer             'min. x-Koordinate
  ixmax As Integer             'max. x-Koordinate
  iymin As Integer             'min. y-Koordinate
  iymax As Integer             'max. y-Koordinate
End Type


Type lAreaLimits
  lArea As lAreaType           'min./max. Koordinaten
  Label As String * 20         'Bezeichnung
End Type


Type CoordHeader              'Header:  (8 Bytes)
  FmtTyp As Long              '00   Format-Typ
  FmtVer As Integer           '04   Format-Version
  dummy As Integer            '06   fill
End Type


Type Koordinate               'Karten-Koordinaten
  x As Integer                'x-Schrittweite
  y As Integer                'y-Schrittweite
End Type


Type CoordCluster
  xy(1 To 8) As Koordinate
End Type


Type Segment                '     Karten-Segment:
  'SegId As Long            '00   Segment-Identifier
  TypePtr As Long           '00   Ptr. zum naechsten Segment
                                  'vom gleichen Typ
  SegType As Integer        '04   Segment-Typen
  KoCnt As Integer          '06   Koordinaten-Anzahl
  KoBeg As Long             '08   Koordinaten-Anfang
  Comment As Long           '0C   Kommentar-Anfang
  x As Long                 '10   x Anfangswert
  y As Long                 '14   y Anfangswert
  iArea As iAreaType        '18   Segment-Bereich
End Type

Type SegmentHeader          '     Header:
  FmtTyp As Long            '00   Format-Typ
  FmtVer As Integer         '04   Format-Version
  AnzSg As Integer          '06   Anzahl Segmente
  AnzKo As Long             '08   Anzahl Koordinaten
                            '     -1 = Fehler
  AnzComment As Long        '0C   Gesamtlaenge Kommentare
  SegMask As Long           '10   Segment-Type Mask
  LengRes As Integer        '14   Length Resolution (in meter)
  AnglRes As Integer        '16   Angle Resolution
  iArea As iAreaType        '18   Kartenbereich
End Type

Type SgTable
  Tbl(0 To 15) As Integer
End Type


Type MapFiles
  SgHead As SegmentHeader                       'Segment-Header

  BmdFile As Integer                            'Binary-Map-Data-File
  BmcFile As Integer                            'Binary-Map-Coordinate-File
  BmtFile As Integer                            'Binary-Map-Text-File

  TxtFile As Integer                            'ASCII-Text-File

  SegMask As Long
  AnzSg As Integer                              'Anzahl Segmente
  AnzKo As Long                                 'Anzahl Koordinaten
  TxtLen As Long                                'Text-Laenge (BmtFile)
  FmtErr As Integer                             'Anzahl Format-Fehler
End Type


Type MapVar                                     '--- Karten Variablen ---
  BinExt(1 To 3) As String * 4                  'Erweiterungen fuer Binaerdateien
  Out As MapFiles                               'Variablen fuer Ausgabedateien
  In As MapFiles                                'Variablen fuer Eingabedateien

  Sg As Segment                                 'Aktuelles Segment
  co As Koordinate                              'Aktuelle Koordinate

  FirstRec(-16 To 31) As Integer
  SgTypCnt(-16 To 31) As Integer

  iMapArea As iAreaType                     'Aktueller Kartenbereich
  ActMapArea As lAreaType                   '... in Sekunden
  degActMapArea As degAreaType              '... in Grad
  SelMapArea As lAreaType

  iStnArea As iAreaType                     'Bereich fr Stationsausgabe (QTH-Units)

  lParArea As lAreaType                     'Parameter-Kartenbereich

  lSgArea As lAreaType                      'Aktueller Segment-Bereich

  MaxVectorArea As lAreaType                'Max. Ausschnitt-Groesse aller Vektor-Dateien
  MaxBmpArea As lAreaType                   'Max. aktuelle Ausschnitt-Gre (je nach Einstellungen)
  MaxMapArea As lAreaType                   'Max. Ausschnitt-Groesse aller Dateien
  FileMapArea As lAreaType                  'Max. Ausschnitt der aktuellen Datei
  degFileMapArea As degAreaType             '... in Grad
  LoadMode As Integer                       'Lade-Modus
  OutSegmFlag As Integer                    'Segment Ausgabe Flag
  CommentCount As Integer                   'Kommentar-Zaehler

  Border As RECT                            'BMP-Map Border
  BmpDisp As RECT                           'Source Rect for Display

End Type


'--- CBD File-Header ---
Type CbdHead
  MagicNum As Long       '&H20770002
  DictAddr As Long       'Offset segment dictionary
  SegCount As Long       'Anzahl Segmente im File
  SegSize As Long        'Groesse segment dictionary
  SegMax As Long         'max. Anzahl strokes
  Fill As String * 20
End Type


'--- CBD Segment Dictionary ---
Type SegmentDict
  SegId As Long          'Segment-ID
  lymax As Long         'Bereich Breite
  lymin As Long
  lxmax As Long        'Bereich Laenge
  lxmin As Long
  AbsAdr As Long         'Absolute Address
  nbytes As Integer
  Rank As Integer
End Type


'--- Segment ---
Type CbdSegment
  OrgX As Long
  OrgY As Long
  Id As Long
  AnzKoord As Integer
  dummy As Integer
End Type

Type KonfCoord
  Right As Double
  Up As Double
  h As Double       'Hhe ber Ellipsoid
  hNN As Double     'Hhe ber NN
  Zone As Integer   'Ost/West
  South As Integer  'Nord=0, Sd=1
End Type

Type MapProjection
  e0 As Double      'False Easting
  b0 As Double      'Bezugsbreite
  m As Double       'Mastab am Bezugsmeridian
End Type

Type GeoDatum
  a As Double       'Groe Halbachse
  b As Double       'Kleine Halbachse
  c As Double       'Polkrmmungshalbmesser
  f As Double       'geometrische Abplattung
  e1 As Double      '1. numerische Exzentrizitt
  e1sq As Double    'Quadrat der 1. numerischen Exzentrizitt
  E2 As Double      '2. numerische Exzentrizitt
  e2sq As Double    'Quadrat der 2. numerischen Exzentrizitt

  dx As Double      'Shift
  dy As Double
  dZ As Double

  rX As Double      'Rotation
  rY As Double
  rZ As Double
End Type


'--------------------- Stationsdaten --------------------

Type StationCall
  Call As Long                    'Call (packed)
  SSID As Integer                 'SSID (hi) and Line-Nr (low)
End Type


Type StationData                  'gesamt: 44 Byte
  StnCall As StationCall          '00  Rufzeichen
  StnTyp As Integer               '06  Typ
  Software As Integer             '08  Software
  Hardware As Integer             '0A  Hardware

  AddLnPtr As Integer             '0C  Pointer zu Zusatzzeilen
  LnkPtr As Integer               '0E  Link-Pointer (0=Ende)
  xloc As Integer                 '10  x-Koordinate (1/48 = 1.25' = 75")
                                  '    32767 = Station geloescht
                                  '    32766 = Zusatzzeile
  yloc As Integer                 '12  y-Koordinate (1/48 = 1.25' = 75")
                                  '    32767 = QTH ungueltig oder unbekannt
  StnDate As Integer              '14  Datum
  StnStat As Integer              '16  Status: 0=unbek.,1=OK,2=IS,3=TE,4=DF,
                                  '            5=PL,(6=WI)
  Sysop As Long                   '18  Sysop-Rufzeichen

  QRG As Long                     '1C  QRG in kHz
  Baud As Long                    '20  Baud-Rate
  QthPtr As Long                  '24  QTH-Pointer  (0 = kein QTH)
  InfoPtr As Long                 '28  Info-Pointer (0 = keine Info)
End Type

Type StationHeader
  FmtTyp As Long                  '00 Formattyp: HMSD
  FmtVer As Integer               '04 Format-Version
  Upd As Integer                  '06 Update-Version
  Date As Long                    '08 Update-Datum (war String * 8)

  AnzStn As Integer               '0C Anzahl Stationen
  AnzStnRec As Integer            '0E Anzahl Stations-Records
  AnzInfo As Long                 '10 Anzahl Informationen
  AnzLnk As Integer               '14 Anzahl Links
  AnzLnkRec As Integer            '16 Anzahl Link-Records
  AnzFmtErr As Integer            '18 Anzahl Format-Fehler (-1 = Abbruch)
  AnzRefErr As Integer            '1A Anzahl Daten-Referenz-Fehler

  Modified As Integer             '1C Flag: vom Benutzer geaendert

  AnzDateErr As Integer           '1E Anzahl Datums-Fehler (ab V9.0b)

  dummy(1 To 6) As Integer        '20    zum Auffuellen
End Type


Type LinkData                     'gesamt: 16 Byte
  StnPtr(1 To 2)  As Integer      '00  Pointer zu Calls
  LnkPtr(1 To 2) As Integer       '04  Link Pointer (next Link)
  StatTyp As Integer              '08  Low-Byte = Status, HighByte = Typ
                                  '    Status: 0=unbek.,1=OK,2=IS,3=TE,4=DF,
                                  '            5=PL,(6=WI)
  LnkDate As Integer              '0A  Datum
                                  '    32767 = Link geloescht
  Baud As Long                    '0C  Baud-Rate
End Type

Type LinkHeader
  FmtTyp As Long                  '00  Formattyp: HMLD
  FmtVer As Integer               '04  Format-Version
  Upd As Integer                  '06  Update Version
  AnzLnk As Integer               '08  Anzahl Links
  AnzLnkRec As Integer            '0A  Anzahl Link Records
  dummy(1 To 2) As Integer        '0C  zum Auffuellen
End Type

Type StationPointers
  StnPtr(1 To 2)  As Integer
End Type


Type StationFiles
  StnFile As Integer                'Text-Stations-Datei
  LnkFile As Integer                'Text-Link-Datei

  BsdFile As Integer                'Binaer-Stations-Daten
  BstFile As Integer                'Binaer-Stations-Texte
  BldFile As Integer                'Binaer-Link-Daten

  StnHdr As StationHeader
End Type

Type QRGTable
  QRGLow As Long    'QRG in 100 Hz
  QRGHigh As Long
  Shift As Long
  Raster As Long

  Prefix As String * 2
  ChLow As Integer
  ChIncr As Integer
  Postfix As String * 2
  ChLen As Integer

  Description As String * 40
End Type

Type StnVar                         '--- Stations Variablen ---

                                    'HAMMAP     STNCVT          HMINFO
  StnDataLoaded As Integer          'Optional   Optional        False
  StnIdxLoaded As Integer           'True ?     True            False
  StnCallsLoaded As Integer         'False      True            False
  StnQthLoaded As Integer           'True       False           False

  LnkDataLoaded As Integer          'Optional   Optional        False
  LnkIdxLoaded As Integer           'False ?    True            False
  LnkStnPtrLoaded As Integer        'False ?    True            False

  MaxAnzStn As Integer              'Maximale Anzahl Stationen
  MaxAnzLnk As Integer              'Maximale Anzahl Links

  MaxStnLen(13) As Integer          'Max. Laenge der Stations-Felder

  ErrorExit As Integer              'Abbruch bei Konvertierungsfehler
  TxtFmt As Integer                 'Text-Ausgabeformat
  DataFormat As Integer             'Data Format Variations
  AddLines As Integer               'Maske, welche Felder in Zusatzzeilen gltig
  ErrorLevel As Integer             'Fehler-Ueberpruefung

  BinExt(1 To 3) As String * 4

  Out As StationFiles
  In As StationFiles

  lParArea As lAreaType             'Parameter-Kartenbereich
  iParArea As iAreaType
End Type


Type FoundType
  StnRec As Integer
  Status As Integer
  LnkRec As Integer
  StnCall As StationCall
End Type

Type NumParType                         'numerische Parameter
  Label As String * 20
  Default As Long
  Min As Long
  Max As Long
  Actual As Long
End Type

Type BinParType                         'Binaer-Parameter (True / False)
  Label As String * 20
  Default As Integer
  Actual As Integer
End Type

Type StationSymbol
  Default As Integer
  Actual As Integer
End Type

Type StationRoute                           'Route
  Route As Integer
  Gamma As Integer
  Next As Integer
End Type


'---------------- Mausdaten -------------
Type Region                         'Bereich fuer Maus, abs. Koordinaten
    xlo As Integer                  'x links oben
    ylo As Integer                  'y links oben
    xru As Integer                  'x rechts unten
    yru As Integer                  'y rechts unten
End Type


'Werte der Maus
Type MouseValues
    p As PointApi                   'aktuelle position
    b As Integer                    'Maustaste
End Type



'----------- HAMMAP-Variablen HV (DOS + WINDOWS) -----------
Type HammapVar
  CursorWidth As Long               'Cursor-Breite (Pixel)

  MapType As Integer                '0=none, 1=Vector, 2=BMP, 3=RLE
  MapElem As Long                   'Map-Elements

  MapWidthGeo As Long               'MapWidth (in Seconds)
  MapHeightGeo As Long

  MapColNr As Integer
  MapColor As Integer
  MapAttrib As Integer

  CoLoadMode As Integer             'Koordinaten Lade-Modus
  FastLoad As Integer

  ValidStnFlags As Integer
  ValidSaveStnFlags As Integer

  SelStnRec As Integer              'Selektierte Station (Record-Nr.)
  SaveSelStnRec As Integer              'same for StoreMap
  SelLnkRec As Integer              'Selektierter Link (Record-Nr.)
  MaxFound As Integer               'maximal anzeigbar
  AnzFound As Integer               'Anzahl gefundene Digis/Links
  AnzShow As Integer                'davon angezeigt
  FoundMode As Integer

  AnzVectorFiles As Integer
  AnzBitmapFiles As Integer

  AnzArea As Integer                'Anzahl Kartenbereiche
  MapDim As Integer                 'Dimension Karten-Array
  AreaListModified As Integer       'Auschnitt-Liste ist modifiziert

  ZoomStartPoint As PointApi
  ZoomStartRect As RECT
  MaxMove As RECT
  MinMove As RECT
  ZoomRect As RECT
  ZoomOffset As Integer
  ZoomMode As Integer            'Flag: Zoom-Frame wird angezeigt
  ZoomPointer As Integer
  ScreenAspect As Single

  HScrollScale As Long
  VScrollScale As Long
  ScrollUserChange As Integer
  ScrollPrgChange As Integer
  Scrolling As Integer

  DefCol(0 To 15) As Long           'Default Colors
  ColVal(0 To 15) As Long           'Farbwerte
  ForeCol As Long                   'Vordergrund (Win:schwarz,DOS:wei)
  BackCol As Long                   'Hintergrund (Win:wei,DOS:schwarz)

  PrtEnbl As Integer                'Print Enable
                                      '1=Screen
                                      '2=Printer, 4=Simulation, 8=buffered,
                                      '  16=Windows Metafile, 32=Enhanced Metafile
                                      '256=Screendump
  PrtSim As Integer                 'Printer Simulation
  BlinkFlag As Integer

  ShowStep As Integer
  ShowCnt As Integer
  ShowMax As Long

  NewTip As Integer
  ForceRecalcRoutes As Integer
  MouseFunctionMode As Long
  StartupComplete As Integer

  FunctionPrepared As Integer
  HMDisabled As Integer
  StartTime As Long

  HMFormProgResize As Integer
  MapFormProgResize As Integer
  AuxFormProgResize As Integer
  AutoArrangeBusy As Integer
  DisableNewMap As Integer

  PrtSetupProgChange As Integer

  hMetaDC As Long         'Device Context for Metafile

  ScrollMapArea As lAreaType
  HScrollEnbl As Integer
  VScrollEnbl As Integer

  FriendOLE As Integer
  NewMapFlag As Integer
  ExecOverlay As Integer

  OvlErrFlag As Integer
End Type


'------ Variablen fuer alle Programme ------
Type GlobalVar
  DesignMode As Integer             '/D
  ExpertMode As Integer             '/X
  HammapMode As Integer             '/H - don't Enable HAMMAP
  AnzCmdFiles As Integer            'Anzahl Files in Command Line
  ProgChange As Integer             'Event caused by program
  ProgUnload As Integer             'Unload Forms by program
  NoShowError As Integer            'Error Msg. fuer DDE unterdruecken
  TopForm As Integer                '1=TXTFRM
  ParameterLoaded As Integer
  HammapConnected As Integer

End Type



'----------------- GDI-Structures -----------------
Type HMPen
  Color As Long
  Width As Long
  Style As Long
End Type


Type HMFont
  Name As String * 32
  Size As Single
  Angle As Integer        'Drehwinkel in Grad
  Attr As Integer         '1 = Bold, 2 = Italic
End Type

Type HMFontInfo
  TrueType As Integer
  CellHeight As Integer
  MaxCharWidth As Integer
End Type


Type HMDevice
  Id As Integer              '0 = CRT, 1 = Printer
  SymbolSize As Integer      'Symbol Size in Pixel
  Options As Long
  RasterCaps As Long

  MonoChrome As Integer
  BackCol As Long
  WinWaterCol As Long
  WinBorderCol As Long
  FloodFillErr As Integer

  hDev As Long            'handle of Device
  VbDev As Long
  VbFont As Long
  VbPen As Long
  VbBrush As Long

  ActPen As HMPen

  BrushColor As Long
  BrushStyle As Integer

  ParamFont As HMFont         'Font as defined by Parameter
  NameFont As HMFont          'Font used for Names (Stations and Towns)
  ActFont As HMFont           'Actual Font asked for
  PhysFont As HMFontInfo      'Physical Font selected

  TextColor As Long           'Actual Text Color
  RotateText As Integer       'Senkrechten Text drehen

  MapWidth As Long            'MapSize in Pixel
  MapHeight As Long
  MapRect As RECT

  FrameWidth As Long          'Rahmen um Karte (1 Pixel grer)
  FrameHeight As Long
  FrameRect As RECT

  DrawWidth As Long           'Zeichenbereich
  DrawHeight As Long
  DrawRect As RECT

  PrintRect As RECT           'Druckbereich

  SecPerPixelX As Double      'Umrechnungsfaktoren Geo <--> Pixel
  SecPerPixelY As Double
  PixelPerSecX As Double
  PixelPerSecY As Double

  mPerPixel As Long           'Auflsung in Meter pro Pixel

  DpiX As Integer             'Pixel (Dots) per Inch
  DpiY As Integer
  PixelAspect As Single

  BlinkEnbl As Integer
  TipEnbl As Integer

End Type

'#If DOS Then
Type ScrollBarType
  Visible As Integer
  Height As Integer
  Width As Integer
  Value As Integer
End Type

Type TimerType
  Enabled As Integer
  Interval As Long
  Start As Long
End Type

Type LabelType
  Visible As Integer
End Type

Type MapFormType
  'Properties
  hWnd As Integer
  hDC As Integer
  ScaleMode As Integer
  ScaleHeight As Single
  ScaleWidth As Single
  MousePointer As Integer
  'Controls
  Tip As LabelType
  TipTimer As TimerType
  BlinkTimer As TimerType
  MapHScroll As ScrollBarType
  MapVScroll As ScrollBarType
End Type

Type DosWindow
  r As RECT
End Type
'#End If


Public Const LF_FACESIZE& = 32

Public Type LOGBRUSH
  lbStyle As Long
  lbColor As Long
  lbHatch As Long
End Type

Public Type LOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  lfItalic As Byte
  lfUnderline As Byte
  lfStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
  lfFaceName(LF_FACESIZE - 1) As Byte
End Type

Public Type ABC
  abcA As Long
  abcB As Long
  abcC As Long
End Type

Public Type TEXTMETRIC
  tmHeight As Long
  tmAscent As Long
  tmDescent As Long
  tmInternalLeading As Long
  tmExternalLeading As Long
  tmAveCharWidth As Long
  tmMaxCharWidth As Long
  tmWeight As Long
  tmOverhang As Long
  tmDigitizedAspectX As Long
  tmDigitizedAspectY As Long
  tmFirstChar As Byte
  tmLastChar As Byte
  tmDefaultChar As Byte
  tmBreakChar As Byte
  tmItalic As Byte
  tmUnderlined As Byte
  tmStruckOut As Byte
  tmPitchAndFamily As Byte
  tmCharSet As Byte
End Type

