Attribute VB_Name = "UPDATE"
'--------------------------- UPDATE.BAS ------------------------------

'HAMMAP Update Routinen
'von Gerhard Berg, DJ6FM


DefInt A-Z
Option Explicit




Dim UpdNr$                            'Update Nr
Dim Modified                          'STN\*.* modified

Function CheckVersion(CmdLine$)

  Dim FileNr, ErrNr, InputLine$, m$
  Dim PrgVer, OldVer, NewVer, DskVer, Ver$, void

  CheckVersion = True

  PrgVer = Val(Parse$(CmdLine$, ","))
  OldVer = Val(Parse$(CmdLine$, ","))
  NewVer = Val(CmdLine$)


  '--- Programm-Version pruefen ---
  If PrgVer > 1 Then
    m$ = "WIN"
    m$ = Msg$(27104) + " SC" + m$ + ".EXE."
    void = TxtMsgBox(m$, 0, ProgName$)
    Exit Function
  End If


  '--- Alte Version ueberpruefen ---
  DskVer = GetStnVer()

  'Neue Version bereits installiert
  If NewVer = DskVer Then
    m$ = Msg$(27107) + " # " + Format$(NewVer)
    void = TxtMsgBox(m$, 0, ProgName$)
    Exit Function
  End If

  'Benoetigte Version ist nicht vorhanden
  If OldVer <> 0 And OldVer <> DskVer Then
    m$ = Msg$(27105) + ": #" + Format$(OldVer) + vbCrLf
    m$ = m$ + Msg$(27106) + ": #" + Format$(DskVer)
    void = TxtMsgBox(m$, 48, ProgName$)
    Exit Function
  End If


  '--- Neue Version ausgeben ---
  Modified = True
  Ver$ = Format$(NewVer) + vbCrLf
  ErrNr = SaveTextFile(HomeDir$ + "STN\STNVER.BAT", Ver$)
  If ErrNr Then Exit Function

  CheckVersion = False

End Function

Sub DeleteUpdateCommand()

  '--- Update- und Sicherungsdateien loeschen ---

  Dim void, ErrNr, f$, Exist

  void = DoEvents()

  '--- Aktualisierungsdateien loeschen ---
  If TxtMsgBox(Msg$(27111), 4 + 32, ProgName$) = 6 Then
    f$ = HomeDir$ + "STN\UPD\*.*"
    ErrNr = ExistFile(f$, True, Exist)
    If ErrNr = 0 Then
      void = WildDeleteFiles(f$)
    End If
  End If

  '--- Sicherungsdateien loeschen ---
  If TxtMsgBox(Msg$(27112), 4 + 32, ProgName$) = 6 Then
    f$ = HomeDir$ + "STN\BACKUP\*.*"
    ErrNr = ExistFile(f$, True, Exist)
    If ErrNr = 0 Then
      void = WildDeleteFiles(f$)
    End If
  End If

End Sub

Function DosCommand(DosCmd$)


  Dim Handle, ErrNr, ErrTxt$

  DosCommand = True

  ErrNr = ChangePath(HomeDir$ + "STN\UPD\")
  If ErrNr Then Exit Function

  ErrNr = ShellAndWait("..\..\" & DosCmd$, 3, ErrTxt$)
  If ErrNr Then
    MsgBox ErrTxt$
    Exit Function
  End If

  DosCommand = ChangePath(HomeDir$)


End Function

Function ExpandFiles(FileSpec$)

  Dim ErrNr, ErrMsg$, ErrNr1
  Dim Exist, Exist7PL, ExistP01, UpdFile$
  Dim d$, p$, n$, e$, n1$

  ExpandFiles = True

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  UpdFile$ = HomeDir$ + "STN\UPD\" + n$


  '--- Final File (see Filespec) ---
  ErrNr = ExistFile(UpdFile$ + e$, False, Exist)
  If ErrNr Then Exit Function
  If Not Exist Then

    '--- LZH-File ---
    ErrNr = ExistFile(UpdFile$ + ".LZH", False, Exist)
    If ErrNr Then Exit Function
    If Not Exist Then

      '--- 7PLUS-File ---
      ErrNr = ExistFile(UpdFile$ + ".7PL", False, Exist7PL)
      If ErrNr Then Exit Function
      ErrNr = ExistFile(UpdFile$ + ".P01", False, ExistP01)
      If ErrNr Then Exit Function
      If Not Exist7PL And Not ExistP01 Then

        '--- BBS-File (muss mindestens existieren) ---
        ErrNr = ExistFile(UpdFile$ + ".BBS", True, Exist)
        If ErrNr Or Not Exist Then Exit Function


        '--- BBS-File fraktionieren ---
        ErrNr = DosCommand("7plus\7plus " + n$ + ".BBS -x " + n$)
        If ErrNr Then Exit Function
        If UCase$(Left$(n$, 4)) <> "DIGI" Then
          'Fuer HM5x-Unn.BBS auch DIGInn.Pnn fraktionieren
          n1$ = "DIGI" + Right$(n$, 2)
          ErrNr = DosCommand("7plus\7plus " + n$ + ".BBS -x " + n1$)
          If ErrNr Then Exit Function
        End If

        ErrNr = ExistFile(UpdFile$ + ".7PL", False, Exist7PL)
        If ErrNr Then Exit Function
        ErrNr = ExistFile(UpdFile$ + ".P01", False, ExistP01)
        If ErrNr Then Exit Function
        If Not Exist7PL And Not ExistP01 Then
          Call ShowErrNrFileTxt(53, UpdFile$ + ".P01 / .7PL")
        End If

      End If

      '--- 7PLUS decodieren ---
      ErrNr = DosCommand("7plus\7plus " + n$)
      If ErrNr Then Exit Function

      ErrNr = ExistFile(UpdFile$ + ".LZH", False, Exist)
      If ErrNr Then Exit Function
      If Not Exist Then
        ErrNr = 53
        ErrMsg$ = UpdFile$ + ".LZH"
      End If

      If ErrNr Then
        ErrNr1 = ExistFile(UpdFile$ + ".ERR", False, Exist)
        If ErrNr1 Then Exit Function
        If Exist Then
          Call ShowErrNr(27113)
        Else
          Call ShowErrNrFileTxt(ErrNr, ErrMsg$)
        End If
        Exit Function
      End If
    End If

    '--- LZH entpacken ---
    ErrNr = DosCommand("lha\lha e " + n$)
    If ErrNr Then Exit Function

    ErrNr = ExistFile(UpdFile$ + e$, True, Exist)
    If ErrNr Then Exit Function

  End If

  ExpandFiles = False

End Function

Function PerformUpdate(Ver)

  Dim MakFile$, RstFile$, RestoreFile
  Dim ErrNr, ErrCl

  PerformUpdate = True

  Modified = False

  UpdNr$ = Format$(Ver)
  If Len(UpdNr$) = 1 Then UpdNr$ = "0" + UpdNr$

  MakFile$ = HomeDir$ + "STN\UPD\HM50-U" + UpdNr$ + ".MAK"

  ErrNr = ExpandFiles(MakFile$)
  If ErrNr Then Exit Function

  'Backup-Verzeichnis einrichten, falls nicht vorhanden
  RstFile$ = HomeDir$ + "STN\BACKUP\RESTORE.MAK"
  ErrNr = MakePath(RstFile$)
  If ErrNr Then Exit Function

  'MAK-File fuer Restore oeffnen
  ErrNr = OpenFile(RstFile$, "O", 0, RestoreFile)
  If ErrNr Then Exit Function

  'Update durchfuehren
  ErrNr = ProcessMakFile(MakFile$, RestoreFile)

  'MAK-File fuer Restore schliessen
  ErrCl = CloseFile(RestoreFile)
  PerformUpdate = ErrNr Or ErrCl

End Function

Function ProcessMakCommand(OrgLine$, RestoreFile)

  Dim InpLine$, Cmd$, Src$, Dst$, DD$, f$
  Dim void, ErrNr, m$
  Dim d$, p$, n$, e$

  ProcessMakCommand = True
  InpLine$ = OrgLine$

  Cmd$ = UCase$(Parse$(InpLine$, ":"))

  Select Case Cmd$
  Case "MESSAGE"
    void = TxtMsgBox(InpLine$, 0, ProgName$)

  Case "VERSION"
    ErrNr = CheckVersion(InpLine$)
    If ErrNr Then Exit Function

  Case "EXPAND"
    ErrNr = ExpandFiles(InpLine$)
    If ErrNr Then Exit Function

  Case "CONVERT"
    ErrNr = BatchConvert(UCase$(InpLine$))
    If ErrNr Then Exit Function

  Case "COPY"
    Src$ = HomeDir$ + Parse$(InpLine$, ",")
    Dst$ = HomeDir$ + InpLine$

    'Unter DOS muss Windows-Verzeichnis nicht existieren und umgekehrt
    DD$ = UCase$(Left$(InpLine$, 4))
    If DD$ = "DOS\" Then
      'Pruefen, ob Zielverzeichnis existiert
      On Error Resume Next
      f$ = Dir$(Dst$)
      If Err = 76 Then
        ProcessMakCommand = False
        Exit Function
      End If
      On Error GoTo 0
    End If

    'Kopieren
    ErrNr = WildCopyFiles(Src$, Dst$)
    If ErrNr Then Exit Function


  Case "BACKUP"
    If RestoreFile Then
      Call ParseFileSpec(InpLine$, d$, p$, n$, e$)
      Cmd$ = "Copy: STN\BACKUP\" + n$ + e$ + ", " + InpLine$
      ErrNr = WriteLine(RestoreFile, Cmd$)
      If ErrNr Then Exit Function

      'Log-File loeschen
      If e$ = ".*" Then
        Cmd$ = "Delete: STN\UPD\" + n$ + "*.LOG"
        ErrNr = WriteLine(RestoreFile, Cmd$)
        If ErrNr Then Exit Function
      End If
    End If
    ErrNr = WildCopyFiles(InpLine$, "STN\BACKUP\*.*")
    If ErrNr Then Exit Function

  Case "DELETE"
    Src$ = HomeDir$ + Parse$(InpLine$, ",")
    ErrNr = WildDeleteFiles(Src$)
    If ErrNr Then Exit Function

  Case "DELETE-QUERY"
    m$ = Msg$(27103) + vbCrLf + InpLine$
    If TxtMsgBox(m$, 4 + 32, ProgName$) = 6 Then
      Src$ = HomeDir$ + Parse$(InpLine$, ",")
      ErrNr = WildDeleteFiles(Src$)
      If ErrNr Then Exit Function
    End If

  Case Else
    void = TxtMsgBox(Msg$(27010) + ":" + vbCrLf + OrgLine$, 0, ProgName$)
    Exit Function
  End Select

  ProcessMakCommand = False

End Function

Function ProcessMakFile(FileSpec$, RestoreFile)

  Dim FileNr, ErrNr, ErrCl, void, EndOfFile
  Dim InpLine$

  ProcessMakFile = True

  ErrNr = OpenFile(FileSpec$, "I", 0, FileNr)
  If ErrNr Then Exit Function

  Do Until EOF(FileNr)
    ErrNr = ReadDataLine(FileNr, InpLine$, EndOfFile)
    If ErrNr Or EndOfFile Then Exit Do

    ErrNr = ProcessMakCommand(InpLine$, RestoreFile)
    If ErrNr Then Exit Do
  Loop

  ErrCl = CloseFile(FileNr)
  ProcessMakFile = ErrNr Or ErrCl

End Function

Sub RestoreCommand()

  '--- Restore Files ---

  Dim void, ErrNr, f$, Exist

  void = DoEvents()

  void = ProcessMakFile(HomeDir$ + "STN\BACKUP\RESTORE.MAK", 0)

End Sub

Sub UpdateCommand()

  Dim FileSpec$, f$, n$, Ver, void, ErrNr

  void = DoEvents()

  FileSpec$ = HomeDir$ + "STN\UPD\HM50-U*.*"
  ErrNr = GetDir(FileSpec$, f$)
  If ErrNr Then Exit Sub

  '--- keine Update-Datei gefunden ---
  If Len(f$) = 0 Then
    Call ShowErrNrFileTxt(53, FileSpec$)
    Exit Sub
  End If

  '--- neuesten Update finden ---
  Do Until Len(f$) = 0
    n$ = Mid$(Parse$(f$, "."), 7)
    If Val(n$) > Ver Then Ver = Val(n$)
    f$ = Dir$
  Loop

  ErrNr = PerformUpdate(Ver)

  If ErrNr = 0 Then
    'Update erfolgreich
    Call ShowErrNr(27101)
  Else
    '--- Alle evtl. offenen Dateien schliessen ---
    void = CloseFile(-1)

    'Bei Fehler, Restore durchfuehren, falls Daten modifiziert
    If Modified Then
      void = ProcessMakFile(HomeDir$ + "STN\BACKUP\RESTORE.MAK", 0)

      'alle alten Log-Files loeschen
      'ErrNr = WildDeleteFiles(HomeDir$ + "STN\UPD\*.LOG")
      'If ErrNr Then Exit Sub

    End If
    void = WriteLog(vbCrLf + Msg$(27102), 1)   'nur Schirm
    Call ShowErrNr(27102)
  End If

End Sub

Function WildCopyFiles(SourceFileSpec$, DestFileSpec$)


  Dim f$, m$, ErrNr, Exist
  Dim d$, p$, n$, e$
  Dim d1$, P1$, n1$, e1$
  Dim d2$, P2$, n2$, E2$
  Dim Src$, Dst$, FileList$

  ErrNr = ExistFile(SourceFileSpec$, False, Exist)
  WildCopyFiles = ErrNr
  If ErrNr Or Not Exist Then Exit Function

  Call ParseFileSpec(SourceFileSpec$, d1$, P1$, n1$, e1$)
  Call ParseFileSpec(DestFileSpec$, d2$, P2$, n2$, E2$)

  f$ = Dir$(SourceFileSpec$)

  Do Until Len(f$) = 0

    Call ParseFileSpec(f$, d$, p$, n$, e$)
    If n2$ <> "*" Then n$ = n2$
    If E2$ <> ".*" Then e$ = E2$

    Src$ = d1$ + P1$ + f$
    Dst$ = d2$ + P2$ + n$ + e$

    Screen.MousePointer = 11
    On Error Resume Next
    FileCopy Src$, Dst$
    ErrNr = Err
    On Error GoTo 0
    Screen.MousePointer = 0

    If ErrNr Then
      m$ = Src$ + " -> " + Dst$
      Call ShowErrNrFileTxt(ErrNr, m$)
      Exit Do
    End If

    FileList$ = FileList$ + Dst$ + ","

    f$ = Dir$
  Loop

  'Pruefen, ob Dateien kopiert sind
  '  (darf nicht in Kopierschleife stehen, da beide Dir$ benutzen)
  Do Until Len(FileList$) = 0
    Dst$ = Parse$(FileList$, ",")
    ErrNr = ExistFile(Dst$, True, Exist)
    If ErrNr Then Exit Do
  Loop

  WildCopyFiles = ErrNr


End Function

Function WildDeleteFiles(FileSpec$)

  Dim d$, p$, n$, e$
  Dim Found, ErrNr, f$

  WildDeleteFiles = True

  Call ParseFileSpec(FileSpec$, d$, p$, n$, e$)

  ErrNr = GetDir(FileSpec$, f$)
  If ErrNr Then Exit Function

  Screen.MousePointer = 11

  Do Until Len(f$) = 0
    ErrNr = DeleteFile(d$ + p$ + f$, Found)
    If ErrNr Then Exit Do
    If Not Found Then Stop
    f$ = Dir$
  Loop

  Screen.MousePointer = 0

  WildDeleteFiles = ErrNr

End Function

