Attribute VB_Name = "ZoomSub"
DefInt A-Z
'
'Unverzerrte Anzeige:
'
'  Hhe in Karte     Hhe auf Bildschirm
' --------------- = ---------------------
' Breite in Karte   Breite auf Bildschirm
'
'         wgeo             wabs*TwipsPerPixelY   wabs
' ---------------------- = ------------------- = ---- * PixelAspect
' wgeo*cos(ym*cfSec2Rad)   wabs*TwipsPerPixelX   wabs
'

Function AdjustArea(a As lAreaType, Mode)

  AdjustArea = True

  '--- Adjust Area for undisturbed Map Display ---
  Call GetAreaSize(a, wold&, hold&)
  Call GetAreaCenter(a, xm&, ym&)
  f! = HV.ScreenAspect * Cos(ym& * cfSec2Rad)      'f!=dygeo/dxgeo
  wnew& = hold& / f!      'neue Breite
  hnew& = wold& * f!      'neue Hhe
  'Max. Fehler 1/2 Pixel
  Limit& = 0.5 * wold& / (HMCrt.FrameWidth - 2)

  Select Case Mode
  Case 1      'links
    a.lxmin = a.lxmax - wnew&

  Case 2      'rechts
    a.lxmax = a.lxmin + wnew&

  Case 3      'links und rechts
    a.lxmin = xm& - wnew& / 2
    a.lxmax = xm& + wnew& / 2

  Case 4      'unten
    ymax& = a.lymax
    ymin& = MV.MaxMapArea.lymin
    wmax& = 0                         'Breite fr y = ymax
    wmin& = PropWidth(ymax&, ymin&)   'Breite fr y = ymin

    If wmin& < wold& Then Exit Function               'Fehler (keine Lsung)

    'Debug.Print
    'Debug.Print "ymax&", "ymin&", "a.lymin", "wnew&", "wold&", "d&"

    Do
      'Nherungswert durch lineare Interpolation bestimmen
      a.lymin = ymin& + CSng(wmin& - wold&) * (ymax& - ymin&) / (wmin& - wmax&)
      wnew& = PropWidth(a.lymax, a.lymin)
      d& = wnew& - wold&
      'Debug.Print ymax&, ymin&, a.lymin, wnew&, wold&, d&
      If Abs(d&) <= Limit& Then Exit Do
      If d& > 0 Then
        ymin& = a.lymin
        wmin& = wnew&
      Else
        ymax& = a.lymin
        wmax& = wnew&
      End If
      If d& = dold& Then Exit Do          'keine nderung -> Notausgang
      dold& = d&
    Loop

  Case 8      'oben
    ymax& = MV.MaxMapArea.lymax
    ymin& = a.lymin
    wmax& = PropWidth(ymax&, ymin&)
    wmin& = 0
    If wmax& > wold& Then Exit Function               'Fehler (keine Lsung)
    'Debug.Print
    'Debug.Print "ymax&", "ymin&", "a.lymin", "wnew&", "wold&", "d&"

    Do
      'Nherungswert durch lineare Interpolation bestimmen
      a.lymax = ymin& + CSng(wmin& - wold&) * (ymax& - ymin&) / (wmin& - wmax&)
      wnew& = PropWidth(a.lymax, a.lymin)
      d& = wnew& - wold&
      'Debug.Print ymax&, ymin&, a.lymin, wnew&, wold&, d&
      If Abs(d&) <= Limit& Then Exit Do
      If d& > 0 Then
        ymin& = a.lymax
        wmin& = wnew&
      Else
        ymax& = a.lymax
        wmax& = wnew&
      End If
      If d& = dold& Then Stop     'keine nderung
      dold& = d&
    Loop

  Case 12     'unten und oben
    a.lymin = ym& - hnew& / 2
    a.lymax = ym& + hnew& / 2

  Case 15     'alle
    Sq! = CSng(wold&) * CSng(hold&)
    Call SetArea(xm&, ym&, Sqr(Sq! / f!), Sqr(Sq! * f!), a)
  End Select

  AdjustArea = Not AreaInArea(0, a, MV.MaxMapArea)

End Function

Function AdjustRect(r As RECT, Mode)

  '--- Adjust RECT for undisturbed Map Display ---
  Dim a As lAreaType

  Call Rect2lArea(HMCrt, r, HV.ZoomOffset, a)
  AdjustRect = AdjustArea(a, Mode)
  Call larea2Rect(HMCrt, a, HV.ZoomOffset, r)

End Function

Sub AutoArea(ByVal Mode, ByVal x As Long, ByVal y As Long)

  Static AnzCoord
  Static NewArea
  Static a As lAreaType

  If (NumPar(46).Actual And MF_AutoArea) = 0 Then Exit Sub

  If Mode And 1 Then
    'Initialisieren
    AnzCoord = 0
    NewArea = 0
    a = MV.ActMapArea
  End If


  If Mode And 2 Then
    '--- Koordinate bearbeiten ---
    If AnzCoord = 0 And (NumPar(46).Actual And MF_IncrArea) = 0 Then

      NewArea = 15
      a.lxmin = x
      a.lxmax = x
      a.lymin = y
      a.lymax = y

    Else

      'Ausschnitt erweitern
      If x < a.lxmin Then
        a.lxmin = x
        NewArea = NewArea Or 1
      End If

      If x > a.lxmax Then
        a.lxmax = x
        NewArea = NewArea Or 2
      End If

      If y < a.lymin Then
        a.lymin = y
        NewArea = NewArea Or 4
      End If

      If y > a.lymax Then
        a.lymax = y
        NewArea = NewArea Or 8
      End If

    End If

    AnzCoord = AnzCoord + 1
  End If


  If (Mode And 4) > 0 And AnzCoord > 0 Then
    'Ggf. Karte verschieben

    If Not AreaInArea(0, a, MV.ActMapArea) Then
      'Neuer Ausschnitt pat nicht komplett in alten Ausschnitt

      Call GetAreaSize(a, w&, h&)
      Call GetAreaSize(MV.ActMapArea, wold&, hold&)
      hborder& = 0.1 * lMax(w&, wold&)
      vBorder& = 0.1 * lMax(h&, hold&)

      'Rnder berechnen
      If NewArea And 1 Then a.lxmin = a.lxmin - hborder&
      If NewArea And 2 Then a.lxmax = a.lxmax + hborder&
      If NewArea And 4 Then a.lymin = a.lymin - vBorder&
      If NewArea And 8 Then a.lymax = a.lymax + vBorder&


      If (NumPar(46).Actual And MF_IncrArea) = 0 Then
        'Ausschnitt mindestens so gro wie vorher
        Call GetAreaSize(a, w&, h&)
        Call GetAreaCenter(a, xm&, ym&)
        Call SetArea(xm&, ym&, lMax(w&, wold&), lMax(h&, hold&), a)
      End If


      Call SelectMapArea(a, "")

    End If

  End If

End Sub

Sub CheckZoomArea(pabs As PointApi)

  x1 = HV.ZoomRect.Left
  y1 = HV.ZoomRect.Top
  x2 = HV.ZoomRect.Right - 1
  y2 = HV.ZoomRect.Bottom - 1

  dx = 10
  dy = 10

  With MapForm

    'pruefen, ob Maus im aeusseren Rahmen (fester Toleranzbereich dx und dy)
    If pabs.x >= x1 - dx And pabs.x < x2 + dx And _
       pabs.y >= y1 - dy And pabs.y < y2 + dy Then

      'Rahmen innen teilen
      'wenn dx zu gro, dann Toleranzbereich = 1/3 von Breite bzw. Hoehe
      If dx > (x2 - x1) / 3 Then dx = (x2 - x1) / 3
      If dy > (y2 - y1) / 3 Then dy = (y2 - y1) / 3

      '--- linke Spalte ---
      If pabs.x < x1 + dx Then

        If pabs.y < y1 + dy Then       'links oben
          HV.ZoomPointer = 9
          .MousePointer = 8

        ElseIf pabs.y > y2 - dy Then   'links unten
          HV.ZoomPointer = 5
          .MousePointer = 6

        Else                           'links Mitte
          HV.ZoomPointer = 1
          .MousePointer = 9
        End If


      '--- rechte Spalte ---
      ElseIf pabs.x > x2 - dx Then

        If pabs.y < y1 + dy Then       'rechts oben
          HV.ZoomPointer = 10
          .MousePointer = 6

        ElseIf pabs.y > y2 - dy Then   'rechts unten
          HV.ZoomPointer = 6
          .MousePointer = 8

        Else                           'rechts Mitte
          HV.ZoomPointer = 2
          .MousePointer = 9
        End If

      '--- Mittlere Spalte ---
      Else

        If pabs.y < y1 + dy Then       'Mitte oben
          HV.ZoomPointer = 8
          .MousePointer = 7

        ElseIf pabs.y > y2 - dy Then   'Mitte unten
          HV.ZoomPointer = 4
          .MousePointer = 7

        Else                           'Mitte Mitte
          HV.ZoomPointer = 15
          .MousePointer = 5
        End If

      End If

    Else

      HV.ZoomPointer = 0
      .MousePointer = 0

    End If

    Select Case HV.ZoomPointer
    Case 5, 6, 9, 10
      If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
        'Proportionaler Ausschnitt: ziehen in Ecken nicht moeglich
        HV.ZoomPointer = 0
        .MousePointer = 0
      End If
    End Select

  End With

End Sub

Sub CmdZoomCenter(xm&, ym&, ZoomScale!)

  Dim lNewArea As lAreaType

  Call GetAreaSize(MV.ActMapArea, w&, h&)

  Call SetArea(xm&, ym&, w& * ZoomScale!, h& * ZoomScale!, lNewArea)

  If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
    void = AdjustArea(lNewArea, 15)
  End If

  Call SelectMapArea(lNewArea, "")

  If HV.MouseFunctionMode > 0 Then
    Call SetCursorGeo(xm&, ym&)
  End If

End Sub

Sub CmdZoomInOut(ZoomScale!)

  Dim xm As Long, ym As Long

  If HV.SelStnRec > 0 And SelStnData.yloc < 32767 Then
    xm& = CLng(SelStnData.xloc) * clQth2Sec
    ym& = CLng(SelStnData.yloc) * clQth2Sec
  Else
    Call GetAreaCenter(MV.ActMapArea, xm&, ym&)
  End If

  Call CmdZoomCenter(xm&, ym&, ZoomScale!)

End Sub

Sub CmdZoomMove(Mode$, Dist!)

  Dim lNewArea As lAreaType

  Call GetAreaSize(MV.ActMapArea, w&, h&)

  Select Case Mode$
  Case "R"
    dx& = w& * Dist!
  Case "L"
    dx& = -w& * Dist!
  Case "U"
    dy& = h& * Dist!
  Case "D"
    dy& = -h& * Dist!
  End Select

  'Vers
  dx& = lMin(dx&, MV.MaxMapArea.lxmax - MV.ActMapArea.lxmax)
  dx& = lMax(dx&, MV.MaxMapArea.lxmin - MV.ActMapArea.lxmin)
  dy& = lMin(dy&, MV.MaxMapArea.lymax - MV.ActMapArea.lymax)
  dy& = lMax(dy&, MV.MaxMapArea.lymin - MV.ActMapArea.lymin)

  lNewArea.lxmin = MV.ActMapArea.lxmin + dx&
  lNewArea.lxmax = MV.ActMapArea.lxmax + dx&
  lNewArea.lymin = MV.ActMapArea.lymin + dy&
  lNewArea.lymax = MV.ActMapArea.lymax + dy&

  If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
    void = AdjustArea(lNewArea, 15)
  End If
  Call SelectMapArea(lNewArea, "")

End Sub

Sub CmdZoomScroll(Mode, Scrolling)

  'Mode: 0 = Horizontal, 1 = Vertical

  Dim lNewArea As lAreaType
  Dim r As RECT

  If HV.MapType < 2 Or Not Scrolling Then

    '--- Vector-Map ---
    lNewArea = MV.ActMapArea

    Call GetAreaSize(MV.ActMapArea, w&, h&)

    If Mode = 0 Then
      lNewArea.lxmin = MapForm.MapHScroll.Value * HV.HScrollScale + HV.ScrollMapArea.lxmin
      lNewArea.lxmax = lNewArea.lxmin + w&
    Else
      lNewArea.lymin = MapForm.MapVScroll.Value * HV.VScrollScale + HV.ScrollMapArea.lymin
      lNewArea.lymax = lNewArea.lymin + h&
    End If

    'Avoid programmatic change of the Value property
    HV.ScrollUserChange = True

    If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
      void& = AdjustArea(lNewArea, 15)
    End If

    'Call SelectMapArea(lNewArea, "")

    MV.SelMapArea = lNewArea
    StrPar(3, 10) = ""

    If Scrolling Then
      HV.Scrolling = True
      SavePar& = NumPar(46).Actual
      'Ausgabe beim Scrolling immer im Hintergrund (Update erst am Ende)
      NumPar(46).Actual = NumPar(46).Actual Or MF_BackGnd

      Call NewScrollingMap

      'Vordergrund aktualisieren
      MapForm.Refresh
      NumPar(46).Actual = SavePar&
      HV.Scrolling = False
    Else
      Call NewMap
    End If

    'DoEvents
    HV.ScrollUserChange = False

  Else

    r = MV.BmpDisp      'Set Horizontal range

    If Mode = 0 Then
      w& = r.Right - r.Left
      With MapForm.MapHScroll
        fy! = (MV.Border.Right - MV.Border.Left - w&) / (.Max - .Min)
        r.Left = MV.Border.Left + fy! * (.Value - .Min)
      End With
      r.Right = r.Left + w&
    Else
      h& = r.Bottom - r.Top
      With MapForm.MapVScroll
        fy! = (MV.Border.Bottom - MV.Border.Top - h&) / (.Max - .Min)
        r.Top = MV.Border.Top + fy! * (.Value - .Min)
      End With
      r.Bottom = r.Top + h&
    End If

    If NumPar(46).Actual And MF_BackGnd Then
      'Ausgabe im Hintergrund
      void& = CopyBitMap&(MapForm.hDC, HMCrt.MapRect, MapForm.BitMap.hDC, r)
      MapForm.Refresh
      'DoEvents
    Else
      'Ausgabe im Vordergrund
      MapForm.AutoRedraw = False
      void& = CopyBitMap&(MapForm.hDC, HMCrt.MapRect, MapForm.BitMap.hDC, r)
      MapForm.AutoRedraw = True
    End If

  End If

End Sub

Sub DragZoom(pabs As PointApi)

  Call ForcePointIntoRect(pabs, HV.MaxMove)

  HV.ZoomRect.Left = HV.ZoomStartPoint.x
  HV.ZoomRect.Top = HV.ZoomStartPoint.y
  HV.ZoomRect.Right = pabs.x + 1
  HV.ZoomRect.Bottom = pabs.y + 1

  If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
    '--- Proportional Zoom ---
    'use given Bottom to calculate Right value
    void = AdjustRect(HV.ZoomRect, 2)

    If HV.ZoomRect.Right < pabs.x + 1 Then
      'determine bottom so that right value is equal to given point
      HV.ZoomRect.Right = pabs.x + 1
      ErrNr = AdjustRect(HV.ZoomRect, 4)
      If ErrNr Then
        HV.ZoomRect.Bottom = HMCrt.FrameRect.Bottom
        void = AdjustRect(HV.ZoomRect, 2)
      End If
    End If
  End If

  Call ShowZoomFrame(True)

End Sub

Sub InitializeZoom()

  'Call DeselectStation

  If HV.ZoomMode > 0 Then Exit Sub
  If HV.MouseFunctionMode > 0 Then Exit Sub

  '0: ZoomArea including frame border, 1: excluding frame border
  HV.ZoomOffset = 1
  HV.ZoomMode = 1
  MapForm.MousePointer = 2

  If NumPar(12).Actual And 4 Then
    Call ShowText(Msg$(24900), 15, -1)
  End If

End Sub

Sub MoveZoomFrame(pabs As PointApi)

  Dim MoveRect As RECT

  If HV.ZoomPointer = 0 Then Stop

  dx = pabs.x - HV.ZoomStartPoint.x
  dy = pabs.y - HV.ZoomStartPoint.y

  If HV.ZoomPointer = 15 Then

    '--- ganzen Rahmen verschieben ---
    If dx > HV.MaxMove.Right Then dx = HV.MaxMove.Right
    If dx < HV.MaxMove.Left Then dx = HV.MaxMove.Left
    If dy > HV.MaxMove.Bottom Then dy = HV.MaxMove.Bottom
    If dy < HV.MaxMove.Top Then dy = HV.MaxMove.Top

    MoveRect.Left = dx
    MoveRect.Right = dx
    MoveRect.Top = dy
    MoveRect.Bottom = dy

  Else

    '--- Rahmengre verndern ---
    'mehrere IF's knnen gleichzeitig erfllt sein
    If HV.ZoomPointer And 1 Then        'linke Kante
      If dx < HV.MaxMove.Left Then dx = HV.MaxMove.Left
      If dx > HV.MinMove.Left Then dx = HV.MinMove.Left
      MoveRect.Left = dx
    End If

    If HV.ZoomPointer And 2 Then        'rechte Kante
      If dx > HV.MaxMove.Right Then dx = HV.MaxMove.Right
      If dx < HV.MinMove.Right Then dx = HV.MinMove.Right
      MoveRect.Right = dx
    End If

    If HV.ZoomPointer And 4 Then        'Unterkante
      If dy > HV.MaxMove.Bottom Then dy = HV.MaxMove.Bottom
      If dy < HV.MinMove.Bottom Then dy = HV.MinMove.Bottom
      MoveRect.Bottom = dy
    End If

    If HV.ZoomPointer And 8 Then        'Oberkante
      If dy < HV.MaxMove.Top Then dy = HV.MaxMove.Top
      If dy > HV.MinMove.Top Then dy = HV.MinMove.Top
      MoveRect.Top = dy
    End If

  End If

  Call AddRect(HV.ZoomStartRect, MoveRect, HV.ZoomRect)

  If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
    Call ProportionalZoom(dx, dy)
  End If

End Sub

Sub ProportionalZoom(dx, dy)

  Dim FrameArea As lAreaType

  Call Rect2lArea(HMCrt, HV.ZoomRect, HV.ZoomOffset, FrameArea)

  Select Case HV.ZoomPointer
  Case 1, 2   'links, rechts -> Hhe anpassen
    void = AdjustArea(FrameArea, 12)
  Case 4, 8   'unten, oben -> Breite anpassen
    void = AdjustArea(FrameArea, 3)
  Case 15   'verschieben -> Hhe und Breite anpassen
    void = AdjustArea(FrameArea, 15)
  End Select

  Call larea2Rect(HMCrt, FrameArea, HV.ZoomOffset, HV.ZoomRect)

  If HV.ZoomPointer = 15 Then
    'Nach Verndern der Gre -> max Verschiebung neu berechnen
    HV.ZoomStartPoint.x = HV.ZoomStartPoint.x + dx   'Anfangspunkt
    HV.ZoomStartPoint.y = HV.ZoomStartPoint.y + dy
    HV.ZoomStartRect = HV.ZoomRect
    Call SubRect(HMCrt.FrameRect, HV.ZoomStartRect, HV.MaxMove)
  End If

End Sub

Sub SetCursorGeo(xgeo As Long, ygeo As Long)

  Dim p As PointApi

  p.x = SecGeo2AbsX(HMCrt, xgeo)
  p.y = SecGeo2AbsY(HMCrt, ygeo)

  Call ClientToScreen(MapForm.hWnd, p)

  Call SetCursorPos(p.x, p.y)

End Sub

Sub ShowZoomFrame(State)

  Static LastState
  Dim ZoomArea As lAreaType
  Dim r As RECT

  If State = 0 And LastState = 0 Then Exit Sub
  If HV.ZoomMode < 2 Then Exit Sub

  'Sicherstellen, da Zoom-Rahmen nicht ber Kartenrahmen hinausgeht
  Call ForceRectIntoRect(HV.ZoomRect, HMCrt.FrameRect)


  MapForm.ZoomFrame.Visible = State
  DoEvents



  If State Then
    '--- Zoomframe zeigen ---
    r = HV.ZoomRect
    MapForm.ZoomFrame.Move r.Left, r.Top, r.Right - r.Left, r.Bottom - r.Top

    If NumPar(35).Actual And 8 Then
      'Debug -> show absolute Zoomframe position
      m$ = "L:" & Str$(r.Left) & Str$(HMCrt.FrameRect.Left)
      m$ = m$ & " - R:" & Str$(r.Right) & Str$(HMCrt.FrameRect.Right)
      m$ = m$ & " - T:" & Str$(r.Top) & Str$(HMCrt.FrameRect.Top)
      m$ = m$ & " - B:" & Str$(r.Bottom) & Str$(HMCrt.FrameRect.Bottom)
      Call ShowText(m$, 13, 0)
    ElseIf (NumPar(12).Actual And 4) = 0 Then
      'keine Tipps -> Zoom-Koordinaten anzeigen
      Call Rect2lArea(HMCrt, HV.ZoomRect, HV.ZoomOffset, ZoomArea)
      AnzFields = NumPar(59).Actual + 1
      Call ShowText(lArea2Msg$(ZoomArea, AnzFields), 7, 0)
    End If

  Else

    '--- Zoomframe abschalten ---
    Call ShowText("", 13, 0)

  End If

  LastState = State

End Sub

Sub StartZoomMove(pabs As PointApi)

  'Called, when mouse button is pressed
  Dim pgeo As lPoint
  Dim r As RECT
  Dim FrameArea As lAreaType

  HV.ZoomStartPoint = pabs     'Anfangspunkt

  Select Case HV.ZoomMode
  Case 1
    '------- Rahmen aufziehen -------
    HV.ZoomPointer = True
    HV.ZoomMode = 2

    'Maximaler Rahmen fr Cursor-Position
    HV.MaxMove = HMCrt.FrameRect
    HV.MaxMove.Left = pabs.x + 2
    HV.MaxMove.Top = pabs.y + 2

    If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
      '--- Proportional ---
      'Maximalwerte fr rechte untere Ecke bestimmen
      r.Left = pabs.x
      r.Top = pabs.y

      '.Bottom ist vorgegeben -> .Right bestimmen (zuerst ohne Iteration)
      r.Bottom = HMCrt.FrameRect.Bottom
      void = AdjustRect(r, 2)
      If r.Right < HV.MaxMove.Right Then
        HV.MaxMove.Right = r.Right
      Else
        '.Right ist vorgegeben -> .Bottom bestimmen
        r.Right = HMCrt.FrameRect.Right
        void = AdjustRect(r, 4)
        If r.Bottom < HV.MaxMove.Bottom Then
          HV.MaxMove.Bottom = r.Bottom
        End If
      End If
    End If

    If NumPar(12).Actual And 4 Then
      Call ShowText(Msg$(24901), 15, -1)
    End If

  Case 3
    '------- Kanten/Rahmen verschieben -------
    If HV.ZoomPointer Then
      HV.ZoomStartRect = HV.ZoomRect
      HV.ZoomMode = 4

      'Maximale Verschiebung nach auen
      Call SubRect(HMCrt.FrameRect, HV.ZoomStartRect, HV.MaxMove)

      If NumPar(46).Actual And (MF_CrtProp Or MF_PrtProp) Then
        '--- Proportional ---
        Call Rect2lArea(HMCrt, HV.ZoomStartRect, 0, FrameArea)
        Call GetAreaCenter(FrameArea, xm&, ym&)
        f! = HV.ScreenAspect * Cos(ym& * cfSec2Rad)      'f!=dygeo/dxgeo

        Select Case HV.ZoomPointer
        Case 1, 2   'links, rechts -> Hhe begrenzen
          dxgeo& = lMin(MV.ActMapArea.lymax - ym&, ym& - MV.ActMapArea.lymin) / f!
          dxabs& = SecGeo2AbsX(HMCrt, xm& + dxgeo&) + 1 + _
              HV.ZoomOffset - HV.ZoomStartRect.Right
          'dxabs& * 2, da sich rechte Kante doppelt so weit wie Mittelpunkt bewegt
          HV.MaxMove.Right = lMin(dxabs& * 2, HV.MaxMove.Right)
          HV.MaxMove.Left = lMax(-dxabs& * 2, HV.MaxMove.Left)

        Case 4, 8   'unten, oben -> Breite begrenzen
          dygeo& = lMin(MV.ActMapArea.lxmax - xm&, xm& - MV.ActMapArea.lxmin) * f!
          dyabs& = HV.ZoomStartRect.Top - SecGeo2AbsY(HMCrt, ym& + dygeo&) - _
              HV.ZoomOffset
          'dyabs& * 2, da sich rechte Kante doppelt so weit wie Mittelpunkt bewegt
          HV.MaxMove.Bottom = lMin(dyabs& * 2, HV.MaxMove.Bottom)
          HV.MaxMove.Top = lMax(-dyabs& * 2, HV.MaxMove.Top)

        Case 15   'verschieben -> Hhe und Breite anpassen

        End Select
      End If

      'Maximale Verschiebung nach innen
      HV.MinMove.Left = HV.ZoomStartRect.Right - HV.ZoomStartRect.Left - 3
      HV.MinMove.Top = HV.ZoomStartRect.Bottom - HV.ZoomStartRect.Top - 3
      HV.MinMove.Right = -HV.MinMove.Left
      HV.MinMove.Bottom = -HV.MinMove.Top
    End If

  End Select

End Sub

Sub StopZoom()

  If HV.ZoomMode = 0 Then Exit Sub

  If NumPar(12).Actual And 4 Then
    Call ShowText("", 15, -1)
  End If

   'Zoom-Frame ausschalten
  Call ShowZoomFrame(False)

  HV.ZoomMode = 0
  HV.ZoomPointer = 0
  MapForm.MousePointer = 0

End Sub

Sub TerminateZoom(pabs As PointApi)

  Select Case HV.ZoomMode
  Case 2
    If NumPar(46).Actual And MF_ZoomCorr Then
      'Rahmen stehen lassen zum verndern
      HV.ZoomMode = 3

      If NumPar(12).Actual And 4 Then
        Call ShowText(Msg$(24902), 15, -1)
      End If

    Else
      'Vergrern
      Call ZoomMouseMove(pabs)
      Call Zoom
    End If

  Case 3
    'Statischen Rahmen vergrern
    Call Zoom

  Case 4
    Call ZoomMouseMove(pabs)
    HV.ZoomMode = 3
  End Select

End Sub

Sub Zoom()

  Dim lNewArea As lAreaType

  Call StopZoom

  'Sicherstellen, da Zoom-Rahmen nicht ber Kartenrahmen hinausgeht
  Call ForceRectIntoRect(HV.ZoomRect, HMCrt.FrameRect)

  Call Rect2lArea(HMCrt, HV.ZoomRect, HV.ZoomOffset, lNewArea)

  Call SelectMapArea(lNewArea, "")

End Sub

Sub ZoomMouseMove(pabs As PointApi)

  'pabs in Pixel (Client coordinates)
  Static Busy
  Static p As PointApi

  If pabs.x = p.x And pabs.y = p.y Then Exit Sub

  If Busy Then Exit Sub
  Busy = True

  p = pabs

  Select Case HV.ZoomMode
  Case 2
    Call DragZoom(p)

  Case 3
    Call CheckZoomArea(p)

  Case 4
    Call MoveZoomFrame(p)
    Call ShowZoomFrame(True)
  End Select

  Busy = False

End Sub

